/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern5 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_SFmode:
      if (!register_operand (operands[1], E_SFmode))
        return -1;
      return 0;

    case E_DFmode:
      if (!register_operand (operands[1], E_DFmode))
        return -1;
      return 1;

    case E_HFmode:
      if (!register_operand (operands[1], E_HFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern16 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_RVVM8DImode)
      || GET_MODE (x1) != E_RVVM8DImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_RVVM8DFmode:
      if (!register_operand (operands[1], E_RVVM8DFmode))
        return -1;
      return 0;

    case E_RVVM4SFmode:
      if (!register_operand (operands[1], E_RVVM4SFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern19 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_RVVM1DImode)
      || GET_MODE (x1) != E_RVVM1DImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_RVVM1DFmode:
      if (!register_operand (operands[1], E_RVVM1DFmode))
        return -1;
      return 0;

    case E_RVVMF2SFmode:
      if (!register_operand (operands[1], E_RVVMF2SFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern26 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V64HImode)
      || GET_MODE (x1) != E_V64HImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V64HFmode:
      if (!register_operand (operands[1], E_V64HFmode))
        return -1;
      return 0;

    case E_V64SFmode:
      if (!register_operand (operands[1], E_V64SFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern33 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V4SImode)
      || GET_MODE (x1) != E_V4SImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V4SFmode:
      if (!register_operand (operands[1], E_V4SFmode))
        return -1;
      return 0;

    case E_V4HFmode:
      if (!register_operand (operands[1], E_V4HFmode))
        return -1;
      return 1;

    case E_V4DFmode:
      if (!register_operand (operands[1], E_V4DFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern40 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V512SImode)
      || GET_MODE (x1) != E_V512SImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V512SFmode:
      if (!register_operand (operands[1], E_V512SFmode))
        return -1;
      return 0;

    case E_V512HFmode:
      if (!register_operand (operands[1], E_V512HFmode))
        return -1;
      return 1;

    case E_V512DFmode:
      if (!register_operand (operands[1], E_V512DFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern51 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V512DImode)
      || GET_MODE (x1) != E_V512DImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V512DFmode:
      if (!register_operand (operands[1], E_V512DFmode))
        return -1;
      return 0;

    case E_V512SFmode:
      if (!register_operand (operands[1], E_V512SFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern58 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_RVVMF4HFmode)
      || GET_MODE (x1) != E_RVVMF4HFmode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_RVVMF4HImode:
      if (!register_operand (operands[1], E_RVVMF4HImode))
        return -1;
      return 0;

    case E_RVVMF8QImode:
      if (!register_operand (operands[1], E_RVVMF8QImode))
        return -1;
      return 1;

    case E_RVVMF2SImode:
      if (!register_operand (operands[1], E_RVVMF2SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern64 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_RVVM8DFmode)
      || GET_MODE (x1) != E_RVVM8DFmode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_RVVM8DImode:
      if (!register_operand (operands[1], E_RVVM8DImode))
        return -1;
      return 0;

    case E_RVVM4SImode:
      if (!register_operand (operands[1], E_RVVM4SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern66 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_RVVM2DFmode)
      || GET_MODE (x1) != E_RVVM2DFmode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_RVVM2DImode:
      if (!register_operand (operands[1], E_RVVM2DImode))
        return -1;
      return 0;

    case E_RVVM1SImode:
      if (!register_operand (operands[1], E_RVVM1SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern72 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V16HFmode)
      || GET_MODE (x1) != E_V16HFmode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V16HImode:
      if (!register_operand (operands[1], E_V16HImode))
        return -1;
      return 0;

    case E_V16QImode:
      if (!register_operand (operands[1], E_V16QImode))
        return -1;
      return 1;

    case E_V16SImode:
      if (!register_operand (operands[1], E_V16SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern78 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V1024HFmode)
      || GET_MODE (x1) != E_V1024HFmode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V1024HImode:
      if (!register_operand (operands[1], E_V1024HImode))
        return -1;
      return 0;

    case E_V1024QImode:
      if (!register_operand (operands[1], E_V1024QImode))
        return -1;
      return 1;

    case E_V1024SImode:
      if (!register_operand (operands[1], E_V1024SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern85 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V32SFmode)
      || GET_MODE (x1) != E_V32SFmode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V32SImode:
      if (!register_operand (operands[1], E_V32SImode))
        return -1;
      return 0;

    case E_V32HImode:
      if (!register_operand (operands[1], E_V32HImode))
        return -1;
      return 1;

    case E_V32DImode:
      if (!register_operand (operands[1], E_V32DImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern92 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V2DFmode)
      || GET_MODE (x1) != E_V2DFmode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V2DImode:
      if (!register_operand (operands[1], E_V2DImode))
        return -1;
      return 0;

    case E_V2SImode:
      if (!register_operand (operands[1], E_V2SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern99 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V256DFmode)
      || GET_MODE (x1) != E_V256DFmode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V256DImode:
      if (!register_operand (operands[1], E_V256DImode))
        return -1;
      return 0;

    case E_V256SImode:
      if (!register_operand (operands[1], E_V256SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern106 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + i1])
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  x5 = XEXP (x2, 0);
  operands[1] = x5;
  return pattern105 (x2); /* [-1, 2] */
}

int
pattern108 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !register_operand (operands[2], i2))
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  if (GET_MODE (x3) != i1
      || !vector_mask_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern111 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode
          || !register_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (pattern3 (x3) != 0)
        return -1;
      return 1;

    case E_RVVM8QImode:
      if (pattern0 (x3, 
E_RVVM8QImode) != 0)
        return -1;
      return 2;

    case E_RVVM4QImode:
      if (pattern0 (x3, 
E_RVVM4QImode) != 0)
        return -1;
      return 3;

    case E_RVVM2QImode:
      if (pattern0 (x3, 
E_RVVM2QImode) != 0)
        return -1;
      return 4;

    case E_RVVM1QImode:
      if (pattern0 (x3, 
E_RVVM1QImode) != 0)
        return -1;
      return 5;

    case E_RVVM8HImode:
      if (pattern0 (x3, 
E_RVVM8HImode) != 0)
        return -1;
      return 6;

    case E_RVVM4HImode:
      if (pattern0 (x3, 
E_RVVM4HImode) != 0)
        return -1;
      return 7;

    case E_RVVM2HImode:
      if (pattern0 (x3, 
E_RVVM2HImode) != 0)
        return -1;
      return 8;

    case E_RVVM1HImode:
      if (pattern0 (x3, 
E_RVVM1HImode) != 0)
        return -1;
      return 9;

    case E_RVVM8SImode:
      if (pattern0 (x3, 
E_RVVM8SImode) != 0)
        return -1;
      return 10;

    case E_RVVM4SImode:
      if (pattern0 (x3, 
E_RVVM4SImode) != 0)
        return -1;
      return 11;

    case E_RVVM2SImode:
      if (pattern0 (x3, 
E_RVVM2SImode) != 0)
        return -1;
      return 12;

    case E_RVVM1SImode:
      if (pattern0 (x3, 
E_RVVM1SImode) != 0)
        return -1;
      return 13;

    case E_RVVM8DImode:
      if (pattern0 (x3, 
E_RVVM8DImode) != 0)
        return -1;
      return 14;

    case E_RVVM4DImode:
      if (pattern0 (x3, 
E_RVVM4DImode) != 0)
        return -1;
      return 15;

    case E_RVVM2DImode:
      if (pattern0 (x3, 
E_RVVM2DImode) != 0)
        return -1;
      return 16;

    case E_RVVM1DImode:
      if (pattern0 (x3, 
E_RVVM1DImode) != 0)
        return -1;
      return 17;

    case E_RVVMF2QImode:
      if (pattern0 (x3, 
E_RVVMF2QImode) != 0)
        return -1;
      return 18;

    case E_RVVMF4QImode:
      if (pattern0 (x3, 
E_RVVMF4QImode) != 0)
        return -1;
      return 19;

    case E_RVVMF8QImode:
      if (pattern0 (x3, 
E_RVVMF8QImode) != 0)
        return -1;
      return 20;

    case E_RVVMF2HImode:
      if (pattern0 (x3, 
E_RVVMF2HImode) != 0)
        return -1;
      return 21;

    case E_RVVMF4HImode:
      if (pattern0 (x3, 
E_RVVMF4HImode) != 0)
        return -1;
      return 22;

    case E_RVVMF2SImode:
      if (pattern0 (x3, 
E_RVVMF2SImode) != 0)
        return -1;
      return 23;

    case E_V1QImode:
      if (pattern0 (x3, 
E_V1QImode) != 0)
        return -1;
      return 24;

    case E_V2QImode:
      if (pattern0 (x3, 
E_V2QImode) != 0)
        return -1;
      return 25;

    case E_V4QImode:
      if (pattern0 (x3, 
E_V4QImode) != 0)
        return -1;
      return 26;

    case E_V8QImode:
      if (pattern0 (x3, 
E_V8QImode) != 0)
        return -1;
      return 27;

    case E_V16QImode:
      if (pattern0 (x3, 
E_V16QImode) != 0)
        return -1;
      return 28;

    case E_V32QImode:
      if (pattern0 (x3, 
E_V32QImode) != 0)
        return -1;
      return 29;

    case E_V64QImode:
      if (pattern0 (x3, 
E_V64QImode) != 0)
        return -1;
      return 30;

    case E_V128QImode:
      if (pattern0 (x3, 
E_V128QImode) != 0)
        return -1;
      return 31;

    case E_V256QImode:
      if (pattern0 (x3, 
E_V256QImode) != 0)
        return -1;
      return 32;

    case E_V512QImode:
      if (pattern0 (x3, 
E_V512QImode) != 0)
        return -1;
      return 33;

    case E_V1024QImode:
      if (pattern0 (x3, 
E_V1024QImode) != 0)
        return -1;
      return 34;

    case E_V2048QImode:
      if (pattern0 (x3, 
E_V2048QImode) != 0)
        return -1;
      return 35;

    case E_V4096QImode:
      if (pattern0 (x3, 
E_V4096QImode) != 0)
        return -1;
      return 36;

    case E_V1HImode:
      if (pattern0 (x3, 
E_V1HImode) != 0)
        return -1;
      return 37;

    case E_V2HImode:
      if (pattern0 (x3, 
E_V2HImode) != 0)
        return -1;
      return 38;

    case E_V4HImode:
      if (pattern0 (x3, 
E_V4HImode) != 0)
        return -1;
      return 39;

    case E_V8HImode:
      if (pattern0 (x3, 
E_V8HImode) != 0)
        return -1;
      return 40;

    case E_V16HImode:
      if (pattern0 (x3, 
E_V16HImode) != 0)
        return -1;
      return 41;

    case E_V32HImode:
      if (pattern0 (x3, 
E_V32HImode) != 0)
        return -1;
      return 42;

    case E_V64HImode:
      if (pattern0 (x3, 
E_V64HImode) != 0)
        return -1;
      return 43;

    case E_V128HImode:
      if (pattern0 (x3, 
E_V128HImode) != 0)
        return -1;
      return 44;

    case E_V256HImode:
      if (pattern0 (x3, 
E_V256HImode) != 0)
        return -1;
      return 45;

    case E_V512HImode:
      if (pattern0 (x3, 
E_V512HImode) != 0)
        return -1;
      return 46;

    case E_V1024HImode:
      if (pattern0 (x3, 
E_V1024HImode) != 0)
        return -1;
      return 47;

    case E_V2048HImode:
      if (pattern0 (x3, 
E_V2048HImode) != 0)
        return -1;
      return 48;

    case E_V1SImode:
      if (pattern0 (x3, 
E_V1SImode) != 0)
        return -1;
      return 49;

    case E_V2SImode:
      if (pattern0 (x3, 
E_V2SImode) != 0)
        return -1;
      return 50;

    case E_V4SImode:
      if (pattern0 (x3, 
E_V4SImode) != 0)
        return -1;
      return 51;

    case E_V8SImode:
      if (pattern0 (x3, 
E_V8SImode) != 0)
        return -1;
      return 52;

    case E_V16SImode:
      if (pattern0 (x3, 
E_V16SImode) != 0)
        return -1;
      return 53;

    case E_V32SImode:
      if (pattern0 (x3, 
E_V32SImode) != 0)
        return -1;
      return 54;

    case E_V64SImode:
      if (pattern0 (x3, 
E_V64SImode) != 0)
        return -1;
      return 55;

    case E_V128SImode:
      if (pattern0 (x3, 
E_V128SImode) != 0)
        return -1;
      return 56;

    case E_V256SImode:
      if (pattern0 (x3, 
E_V256SImode) != 0)
        return -1;
      return 57;

    case E_V512SImode:
      if (pattern0 (x3, 
E_V512SImode) != 0)
        return -1;
      return 58;

    case E_V1024SImode:
      if (pattern0 (x3, 
E_V1024SImode) != 0)
        return -1;
      return 59;

    case E_V1DImode:
      if (pattern0 (x3, 
E_V1DImode) != 0)
        return -1;
      return 60;

    case E_V2DImode:
      if (pattern0 (x3, 
E_V2DImode) != 0)
        return -1;
      return 61;

    case E_V4DImode:
      if (pattern0 (x3, 
E_V4DImode) != 0)
        return -1;
      return 62;

    case E_V8DImode:
      if (pattern0 (x3, 
E_V8DImode) != 0)
        return -1;
      return 63;

    case E_V16DImode:
      if (pattern0 (x3, 
E_V16DImode) != 0)
        return -1;
      return 64;

    case E_V32DImode:
      if (pattern0 (x3, 
E_V32DImode) != 0)
        return -1;
      return 65;

    case E_V64DImode:
      if (pattern0 (x3, 
E_V64DImode) != 0)
        return -1;
      return 66;

    case E_V128DImode:
      if (pattern0 (x3, 
E_V128DImode) != 0)
        return -1;
      return 67;

    case E_V256DImode:
      if (pattern0 (x3, 
E_V256DImode) != 0)
        return -1;
      return 68;

    case E_V512DImode:
      if (pattern0 (x3, 
E_V512DImode) != 0)
        return -1;
      return 69;

    default:
      return -1;
    }
}

int
pattern128 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern129 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x1, 1);
  x5 = XEXP (x4, 0);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8SFmode:
      return pattern128 (x1, 
E_RVVM4HFmode, 
E_RVVM8SFmode); /* [-1, 0] */

    case E_RVVM4SFmode:
      if (pattern128 (x1, 
E_RVVM2HFmode, 
E_RVVM4SFmode) != 0)
        return -1;
      return 1;

    case E_RVVM2SFmode:
      if (pattern128 (x1, 
E_RVVM1HFmode, 
E_RVVM2SFmode) != 0)
        return -1;
      return 2;

    case E_RVVM1SFmode:
      if (pattern128 (x1, 
E_RVVMF2HFmode, 
E_RVVM1SFmode) != 0)
        return -1;
      return 3;

    case E_RVVMF2SFmode:
      if (pattern128 (x1, 
E_RVVMF4HFmode, 
E_RVVMF2SFmode) != 0)
        return -1;
      return 4;

    case E_RVVM8DFmode:
      if (pattern128 (x1, 
E_RVVM4SFmode, 
E_RVVM8DFmode) != 0)
        return -1;
      return 5;

    case E_RVVM4DFmode:
      if (pattern128 (x1, 
E_RVVM2SFmode, 
E_RVVM4DFmode) != 0)
        return -1;
      return 6;

    case E_RVVM2DFmode:
      if (pattern128 (x1, 
E_RVVM1SFmode, 
E_RVVM2DFmode) != 0)
        return -1;
      return 7;

    case E_RVVM1DFmode:
      if (pattern128 (x1, 
E_RVVMF2SFmode, 
E_RVVM1DFmode) != 0)
        return -1;
      return 8;

    case E_V1SFmode:
      if (pattern128 (x1, 
E_V1HFmode, 
E_V1SFmode) != 0)
        return -1;
      return 9;

    case E_V2SFmode:
      if (pattern128 (x1, 
E_V2HFmode, 
E_V2SFmode) != 0)
        return -1;
      return 10;

    case E_V4SFmode:
      if (pattern128 (x1, 
E_V4HFmode, 
E_V4SFmode) != 0)
        return -1;
      return 11;

    case E_V8SFmode:
      if (pattern128 (x1, 
E_V8HFmode, 
E_V8SFmode) != 0)
        return -1;
      return 12;

    case E_V16SFmode:
      if (pattern128 (x1, 
E_V16HFmode, 
E_V16SFmode) != 0)
        return -1;
      return 13;

    case E_V32SFmode:
      if (pattern128 (x1, 
E_V32HFmode, 
E_V32SFmode) != 0)
        return -1;
      return 14;

    case E_V64SFmode:
      if (pattern128 (x1, 
E_V64HFmode, 
E_V64SFmode) != 0)
        return -1;
      return 15;

    case E_V128SFmode:
      if (pattern128 (x1, 
E_V128HFmode, 
E_V128SFmode) != 0)
        return -1;
      return 16;

    case E_V256SFmode:
      if (pattern128 (x1, 
E_V256HFmode, 
E_V256SFmode) != 0)
        return -1;
      return 17;

    case E_V512SFmode:
      if (pattern128 (x1, 
E_V512HFmode, 
E_V512SFmode) != 0)
        return -1;
      return 18;

    case E_V1024SFmode:
      if (pattern128 (x1, 
E_V1024HFmode, 
E_V1024SFmode) != 0)
        return -1;
      return 19;

    case E_V1DFmode:
      if (pattern128 (x1, 
E_V1SFmode, 
E_V1DFmode) != 0)
        return -1;
      return 20;

    case E_V2DFmode:
      if (pattern128 (x1, 
E_V2SFmode, 
E_V2DFmode) != 0)
        return -1;
      return 21;

    case E_V4DFmode:
      if (pattern128 (x1, 
E_V4SFmode, 
E_V4DFmode) != 0)
        return -1;
      return 22;

    case E_V8DFmode:
      if (pattern128 (x1, 
E_V8SFmode, 
E_V8DFmode) != 0)
        return -1;
      return 23;

    case E_V16DFmode:
      if (pattern128 (x1, 
E_V16SFmode, 
E_V16DFmode) != 0)
        return -1;
      return 24;

    case E_V32DFmode:
      if (pattern128 (x1, 
E_V32SFmode, 
E_V32DFmode) != 0)
        return -1;
      return 25;

    case E_V64DFmode:
      if (pattern128 (x1, 
E_V64SFmode, 
E_V64DFmode) != 0)
        return -1;
      return 26;

    case E_V128DFmode:
      if (pattern128 (x1, 
E_V128SFmode, 
E_V128DFmode) != 0)
        return -1;
      return 27;

    case E_V256DFmode:
      if (pattern128 (x1, 
E_V256SFmode, 
E_V256DFmode) != 0)
        return -1;
      return 28;

    case E_V512DFmode:
      if (pattern128 (x1, 
E_V512SFmode, 
E_V512DFmode) != 0)
        return -1;
      return 29;

    default:
      return -1;
    }
}

int
pattern142 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
      operands[1] = x3;
      x4 = XEXP (x2, 1);
      operands[2] = x4;
      x5 = XEXP (x1, 1);
      operands[3] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_RVVM8HFmode:
          return pattern136 (x1, 
E_RVVM8HFmode); /* [-1, 0] */

        case E_RVVM4HFmode:
          if (pattern136 (x1, 
E_RVVM4HFmode) != 0)
            return -1;
          return 1;

        case E_RVVM2HFmode:
          if (pattern136 (x1, 
E_RVVM2HFmode) != 0)
            return -1;
          return 2;

        case E_RVVM1HFmode:
          if (pattern136 (x1, 
E_RVVM1HFmode) != 0)
            return -1;
          return 3;

        case E_RVVMF2HFmode:
          if (pattern136 (x1, 
E_RVVMF2HFmode) != 0)
            return -1;
          return 4;

        case E_RVVMF4HFmode:
          if (pattern136 (x1, 
E_RVVMF4HFmode) != 0)
            return -1;
          return 5;

        case E_RVVM8SFmode:
          if (pattern136 (x1, 
E_RVVM8SFmode) != 0)
            return -1;
          return 6;

        case E_RVVM4SFmode:
          if (pattern136 (x1, 
E_RVVM4SFmode) != 0)
            return -1;
          return 7;

        case E_RVVM2SFmode:
          if (pattern136 (x1, 
E_RVVM2SFmode) != 0)
            return -1;
          return 8;

        case E_RVVM1SFmode:
          if (pattern136 (x1, 
E_RVVM1SFmode) != 0)
            return -1;
          return 9;

        case E_RVVMF2SFmode:
          if (pattern136 (x1, 
E_RVVMF2SFmode) != 0)
            return -1;
          return 10;

        case E_RVVM8DFmode:
          if (pattern136 (x1, 
E_RVVM8DFmode) != 0)
            return -1;
          return 11;

        case E_RVVM4DFmode:
          if (pattern136 (x1, 
E_RVVM4DFmode) != 0)
            return -1;
          return 12;

        case E_RVVM2DFmode:
          if (pattern136 (x1, 
E_RVVM2DFmode) != 0)
            return -1;
          return 13;

        case E_RVVM1DFmode:
          if (pattern136 (x1, 
E_RVVM1DFmode) != 0)
            return -1;
          return 14;

        case E_V1HFmode:
          if (pattern136 (x1, 
E_V1HFmode) != 0)
            return -1;
          return 15;

        case E_V2HFmode:
          if (pattern136 (x1, 
E_V2HFmode) != 0)
            return -1;
          return 16;

        case E_V4HFmode:
          if (pattern136 (x1, 
E_V4HFmode) != 0)
            return -1;
          return 17;

        case E_V8HFmode:
          if (pattern136 (x1, 
E_V8HFmode) != 0)
            return -1;
          return 18;

        case E_V16HFmode:
          if (pattern136 (x1, 
E_V16HFmode) != 0)
            return -1;
          return 19;

        case E_V32HFmode:
          if (pattern136 (x1, 
E_V32HFmode) != 0)
            return -1;
          return 20;

        case E_V64HFmode:
          if (pattern136 (x1, 
E_V64HFmode) != 0)
            return -1;
          return 21;

        case E_V128HFmode:
          if (pattern136 (x1, 
E_V128HFmode) != 0)
            return -1;
          return 22;

        case E_V256HFmode:
          if (pattern136 (x1, 
E_V256HFmode) != 0)
            return -1;
          return 23;

        case E_V512HFmode:
          if (pattern136 (x1, 
E_V512HFmode) != 0)
            return -1;
          return 24;

        case E_V1024HFmode:
          if (pattern136 (x1, 
E_V1024HFmode) != 0)
            return -1;
          return 25;

        case E_V2048HFmode:
          if (pattern136 (x1, 
E_V2048HFmode) != 0)
            return -1;
          return 26;

        case E_V1SFmode:
          if (pattern136 (x1, 
E_V1SFmode) != 0)
            return -1;
          return 27;

        case E_V2SFmode:
          if (pattern136 (x1, 
E_V2SFmode) != 0)
            return -1;
          return 28;

        case E_V4SFmode:
          if (pattern136 (x1, 
E_V4SFmode) != 0)
            return -1;
          return 29;

        case E_V8SFmode:
          if (pattern136 (x1, 
E_V8SFmode) != 0)
            return -1;
          return 30;

        case E_V16SFmode:
          if (pattern136 (x1, 
E_V16SFmode) != 0)
            return -1;
          return 31;

        case E_V32SFmode:
          if (pattern136 (x1, 
E_V32SFmode) != 0)
            return -1;
          return 32;

        case E_V64SFmode:
          if (pattern136 (x1, 
E_V64SFmode) != 0)
            return -1;
          return 33;

        case E_V128SFmode:
          if (pattern136 (x1, 
E_V128SFmode) != 0)
            return -1;
          return 34;

        case E_V256SFmode:
          if (pattern136 (x1, 
E_V256SFmode) != 0)
            return -1;
          return 35;

        case E_V512SFmode:
          if (pattern136 (x1, 
E_V512SFmode) != 0)
            return -1;
          return 36;

        case E_V1024SFmode:
          if (pattern136 (x1, 
E_V1024SFmode) != 0)
            return -1;
          return 37;

        case E_V1DFmode:
          if (pattern136 (x1, 
E_V1DFmode) != 0)
            return -1;
          return 38;

        case E_V2DFmode:
          if (pattern136 (x1, 
E_V2DFmode) != 0)
            return -1;
          return 39;

        case E_V4DFmode:
          if (pattern136 (x1, 
E_V4DFmode) != 0)
            return -1;
          return 40;

        case E_V8DFmode:
          if (pattern136 (x1, 
E_V8DFmode) != 0)
            return -1;
          return 41;

        case E_V16DFmode:
          if (pattern136 (x1, 
E_V16DFmode) != 0)
            return -1;
          return 42;

        case E_V32DFmode:
          if (pattern136 (x1, 
E_V32DFmode) != 0)
            return -1;
          return 43;

        case E_V64DFmode:
          if (pattern136 (x1, 
E_V64DFmode) != 0)
            return -1;
          return 44;

        case E_V128DFmode:
          if (pattern136 (x1, 
E_V128DFmode) != 0)
            return -1;
          return 45;

        case E_V256DFmode:
          if (pattern136 (x1, 
E_V256DFmode) != 0)
            return -1;
          return 46;

        case E_V512DFmode:
          if (pattern136 (x1, 
E_V512DFmode) != 0)
            return -1;
          return 47;

        default:
          return -1;
        }

    case FLOAT_EXTEND:
      res = pattern139 (x1);
      if (res >= 0)
        return res + 48; /* [48, 107] */
      return -1;

    case NEG:
      x4 = XEXP (x2, 1);
      if (GET_CODE (x4) != FLOAT_EXTEND)
        return -1;
      x5 = XEXP (x1, 1);
      operands[1] = x5;
      x6 = XEXP (x3, 0);
      switch (GET_CODE (x6))
        {
        case FLOAT_EXTEND:
          x7 = XEXP (x6, 0);
          operands[2] = x7;
          x8 = XEXP (x4, 0);
          operands[3] = x8;
          switch (GET_MODE (operands[0]))
            {
            case E_RVVM8SFmode:
              if (pattern140 (x1, 
E_RVVM8SFmode, 
E_RVVM4HFmode) != 0)
                return -1;
              return 108;

            case E_RVVM4SFmode:
              if (pattern140 (x1, 
E_RVVM4SFmode, 
E_RVVM2HFmode) != 0)
                return -1;
              return 109;

            case E_RVVM2SFmode:
              if (pattern140 (x1, 
E_RVVM2SFmode, 
E_RVVM1HFmode) != 0)
                return -1;
              return 110;

            case E_RVVM1SFmode:
              if (pattern140 (x1, 
E_RVVM1SFmode, 
E_RVVMF2HFmode) != 0)
                return -1;
              return 111;

            case E_RVVMF2SFmode:
              if (pattern140 (x1, 
E_RVVMF2SFmode, 
E_RVVMF4HFmode) != 0)
                return -1;
              return 112;

            case E_RVVM8DFmode:
              if (pattern140 (x1, 
E_RVVM8DFmode, 
E_RVVM4SFmode) != 0)
                return -1;
              return 113;

            case E_RVVM4DFmode:
              if (pattern140 (x1, 
E_RVVM4DFmode, 
E_RVVM2SFmode) != 0)
                return -1;
              return 114;

            case E_RVVM2DFmode:
              if (pattern140 (x1, 
E_RVVM2DFmode, 
E_RVVM1SFmode) != 0)
                return -1;
              return 115;

            case E_RVVM1DFmode:
              if (pattern140 (x1, 
E_RVVM1DFmode, 
E_RVVMF2SFmode) != 0)
                return -1;
              return 116;

            case E_V1SFmode:
              if (pattern140 (x1, 
E_V1SFmode, 
E_V1HFmode) != 0)
                return -1;
              return 117;

            case E_V2SFmode:
              if (pattern140 (x1, 
E_V2SFmode, 
E_V2HFmode) != 0)
                return -1;
              return 118;

            case E_V4SFmode:
              if (pattern140 (x1, 
E_V4SFmode, 
E_V4HFmode) != 0)
                return -1;
              return 119;

            case E_V8SFmode:
              if (pattern140 (x1, 
E_V8SFmode, 
E_V8HFmode) != 0)
                return -1;
              return 120;

            case E_V16SFmode:
              if (pattern140 (x1, 
E_V16SFmode, 
E_V16HFmode) != 0)
                return -1;
              return 121;

            case E_V32SFmode:
              if (pattern140 (x1, 
E_V32SFmode, 
E_V32HFmode) != 0)
                return -1;
              return 122;

            case E_V64SFmode:
              if (pattern140 (x1, 
E_V64SFmode, 
E_V64HFmode) != 0)
                return -1;
              return 123;

            case E_V128SFmode:
              if (pattern140 (x1, 
E_V128SFmode, 
E_V128HFmode) != 0)
                return -1;
              return 124;

            case E_V256SFmode:
              if (pattern140 (x1, 
E_V256SFmode, 
E_V256HFmode) != 0)
                return -1;
              return 125;

            case E_V512SFmode:
              if (pattern140 (x1, 
E_V512SFmode, 
E_V512HFmode) != 0)
                return -1;
              return 126;

            case E_V1024SFmode:
              if (pattern140 (x1, 
E_V1024SFmode, 
E_V1024HFmode) != 0)
                return -1;
              return 127;

            case E_V1DFmode:
              if (pattern140 (x1, 
E_V1DFmode, 
E_V1SFmode) != 0)
                return -1;
              return 128;

            case E_V2DFmode:
              if (pattern140 (x1, 
E_V2DFmode, 
E_V2SFmode) != 0)
                return -1;
              return 129;

            case E_V4DFmode:
              if (pattern140 (x1, 
E_V4DFmode, 
E_V4SFmode) != 0)
                return -1;
              return 130;

            case E_V8DFmode:
              if (pattern140 (x1, 
E_V8DFmode, 
E_V8SFmode) != 0)
                return -1;
              return 131;

            case E_V16DFmode:
              if (pattern140 (x1, 
E_V16DFmode, 
E_V16SFmode) != 0)
                return -1;
              return 132;

            case E_V32DFmode:
              if (pattern140 (x1, 
E_V32DFmode, 
E_V32SFmode) != 0)
                return -1;
              return 133;

            case E_V64DFmode:
              if (pattern140 (x1, 
E_V64DFmode, 
E_V64SFmode) != 0)
                return -1;
              return 134;

            case E_V128DFmode:
              if (pattern140 (x1, 
E_V128DFmode, 
E_V128SFmode) != 0)
                return -1;
              return 135;

            case E_V256DFmode:
              if (pattern140 (x1, 
E_V256DFmode, 
E_V256SFmode) != 0)
                return -1;
              return 136;

            case E_V512DFmode:
              if (pattern140 (x1, 
E_V512DFmode, 
E_V512SFmode) != 0)
                return -1;
              return 137;

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          operands[3] = x6;
          x8 = XEXP (x4, 0);
          operands[2] = x8;
          switch (GET_MODE (operands[0]))
            {
            case E_RVVM8SFmode:
              if (pattern141 (x1, 
E_RVVM8SFmode, 
E_RVVM4HFmode) != 0)
                return -1;
              return 138;

            case E_RVVM4SFmode:
              if (pattern141 (x1, 
E_RVVM4SFmode, 
E_RVVM2HFmode) != 0)
                return -1;
              return 139;

            case E_RVVM2SFmode:
              if (pattern141 (x1, 
E_RVVM2SFmode, 
E_RVVM1HFmode) != 0)
                return -1;
              return 140;

            case E_RVVM1SFmode:
              if (pattern141 (x1, 
E_RVVM1SFmode, 
E_RVVMF2HFmode) != 0)
                return -1;
              return 141;

            case E_RVVMF2SFmode:
              if (pattern141 (x1, 
E_RVVMF2SFmode, 
E_RVVMF4HFmode) != 0)
                return -1;
              return 142;

            case E_RVVM8DFmode:
              if (pattern141 (x1, 
E_RVVM8DFmode, 
E_RVVM4SFmode) != 0)
                return -1;
              return 143;

            case E_RVVM4DFmode:
              if (pattern141 (x1, 
E_RVVM4DFmode, 
E_RVVM2SFmode) != 0)
                return -1;
              return 144;

            case E_RVVM2DFmode:
              if (pattern141 (x1, 
E_RVVM2DFmode, 
E_RVVM1SFmode) != 0)
                return -1;
              return 145;

            case E_RVVM1DFmode:
              if (pattern141 (x1, 
E_RVVM1DFmode, 
E_RVVMF2SFmode) != 0)
                return -1;
              return 146;

            case E_V1SFmode:
              if (pattern141 (x1, 
E_V1SFmode, 
E_V1HFmode) != 0)
                return -1;
              return 147;

            case E_V2SFmode:
              if (pattern141 (x1, 
E_V2SFmode, 
E_V2HFmode) != 0)
                return -1;
              return 148;

            case E_V4SFmode:
              if (pattern141 (x1, 
E_V4SFmode, 
E_V4HFmode) != 0)
                return -1;
              return 149;

            case E_V8SFmode:
              if (pattern141 (x1, 
E_V8SFmode, 
E_V8HFmode) != 0)
                return -1;
              return 150;

            case E_V16SFmode:
              if (pattern141 (x1, 
E_V16SFmode, 
E_V16HFmode) != 0)
                return -1;
              return 151;

            case E_V32SFmode:
              if (pattern141 (x1, 
E_V32SFmode, 
E_V32HFmode) != 0)
                return -1;
              return 152;

            case E_V64SFmode:
              if (pattern141 (x1, 
E_V64SFmode, 
E_V64HFmode) != 0)
                return -1;
              return 153;

            case E_V128SFmode:
              if (pattern141 (x1, 
E_V128SFmode, 
E_V128HFmode) != 0)
                return -1;
              return 154;

            case E_V256SFmode:
              if (pattern141 (x1, 
E_V256SFmode, 
E_V256HFmode) != 0)
                return -1;
              return 155;

            case E_V512SFmode:
              if (pattern141 (x1, 
E_V512SFmode, 
E_V512HFmode) != 0)
                return -1;
              return 156;

            case E_V1024SFmode:
              if (pattern141 (x1, 
E_V1024SFmode, 
E_V1024HFmode) != 0)
                return -1;
              return 157;

            case E_V1DFmode:
              if (pattern141 (x1, 
E_V1DFmode, 
E_V1SFmode) != 0)
                return -1;
              return 158;

            case E_V2DFmode:
              if (pattern141 (x1, 
E_V2DFmode, 
E_V2SFmode) != 0)
                return -1;
              return 159;

            case E_V4DFmode:
              if (pattern141 (x1, 
E_V4DFmode, 
E_V4SFmode) != 0)
                return -1;
              return 160;

            case E_V8DFmode:
              if (pattern141 (x1, 
E_V8DFmode, 
E_V8SFmode) != 0)
                return -1;
              return 161;

            case E_V16DFmode:
              if (pattern141 (x1, 
E_V16DFmode, 
E_V16SFmode) != 0)
                return -1;
              return 162;

            case E_V32DFmode:
              if (pattern141 (x1, 
E_V32DFmode, 
E_V32SFmode) != 0)
                return -1;
              return 163;

            case E_V64DFmode:
              if (pattern141 (x1, 
E_V64DFmode, 
E_V64SFmode) != 0)
                return -1;
              return 164;

            case E_V128DFmode:
              if (pattern141 (x1, 
E_V128DFmode, 
E_V128SFmode) != 0)
                return -1;
              return 165;

            case E_V256DFmode:
              if (pattern141 (x1, 
E_V256DFmode, 
E_V256SFmode) != 0)
                return -1;
              return 166;

            case E_V512DFmode:
              if (pattern141 (x1, 
E_V512DFmode, 
E_V512SFmode) != 0)
                return -1;
              return 167;

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern191 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i2
      || !vector_mask_operand (operands[1], i2)
      || !vector_merge_operand (operands[2], i1)
      || !register_operand (operands[3], i1)
      || !register_operand (operands[4], i3))
    return -1;
  return 0;
}

int
pattern194 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != ASHIFT
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_CODE (x5) != SUBREG
      || maybe_ne (SUBREG_BYTE (x5), 0)
      || GET_MODE (x5) != E_QImode)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != AND
      || GET_MODE (x6) != E_DImode
      || !register_operand (operands[0], E_DImode)
      || GET_MODE (x1) != E_DImode)
    return -1;
  x7 = XEXP (x6, 1);
  operands[2] = x7;
  if (!const_int_operand (operands[2], E_VOIDmode))
    return -1;
  x8 = XEXP (x1, 1);
  operands[3] = x8;
  if (!register_operand (operands[3], E_DImode))
    return -1;
  x9 = XEXP (x6, 0);
  switch (GET_CODE (x9))
    {
    case NOT:
      if (GET_MODE (x9) != E_DImode)
        return -1;
      x10 = XEXP (x9, 0);
      operands[1] = x10;
      if (!register_operand (operands[1], E_DImode))
        return -1;
      return 0;

    case REG:
    case SUBREG:
      operands[1] = x9;
      if (!register_operand (operands[1], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern201 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[3], i2)
      || !nonmemory_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern204 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i3))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i2)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern208 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3, machine_mode i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i3))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[2], i2)
      || !csr_operand (operands[3], i4)
      || !register_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern211 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[2] = x4;
  x5 = XEXP (x1, 2);
  operands[3] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8HFmode:
      if (!register_operand (operands[0], E_RVVM8HFmode)
          || GET_MODE (x1) != E_RVVM8HFmode
          || !register_operand (operands[1], E_RVVMF2BImode)
          || GET_MODE (x3) != E_RVVM8HFmode
          || !register_operand (operands[3], E_RVVM8HFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_RVVM8HImode:
          if (!register_operand (operands[2], E_RVVM8HImode))
            return -1;
          return 0;

        case E_RVVM4QImode:
          if (!register_operand (operands[2], E_RVVM4QImode))
            return -1;
          return 1;

        default:
          return -1;
        }

    case E_RVVM4HFmode:
      if (!register_operand (operands[0], E_RVVM4HFmode)
          || GET_MODE (x1) != E_RVVM4HFmode
          || !register_operand (operands[1], E_RVVMF4BImode)
          || GET_MODE (x3) != E_RVVM4HFmode
          || !register_operand (operands[3], E_RVVM4HFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_RVVM4HImode:
          if (!register_operand (operands[2], E_RVVM4HImode))
            return -1;
          return 2;

        case E_RVVM2QImode:
          if (!register_operand (operands[2], E_RVVM2QImode))
            return -1;
          return 3;

        case E_RVVM8SImode:
          if (!register_operand (operands[2], E_RVVM8SImode))
            return -1;
          return 4;

        default:
          return -1;
        }

    case E_RVVM2HFmode:
      if (!register_operand (operands[0], E_RVVM2HFmode)
          || GET_MODE (x1) != E_RVVM2HFmode
          || !register_operand (operands[1], E_RVVMF8BImode)
          || GET_MODE (x3) != E_RVVM2HFmode
          || !register_operand (operands[3], E_RVVM2HFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_RVVM2HImode:
          if (!register_operand (operands[2], E_RVVM2HImode))
            return -1;
          return 5;

        case E_RVVM1QImode:
          if (!register_operand (operands[2], E_RVVM1QImode))
            return -1;
          return 6;

        case E_RVVM4SImode:
          if (!register_operand (operands[2], E_RVVM4SImode))
            return -1;
          return 7;

        default:
          return -1;
        }

    case E_RVVM1HFmode:
      if (!register_operand (operands[0], E_RVVM1HFmode)
          || GET_MODE (x1) != E_RVVM1HFmode
          || !register_operand (operands[1], E_RVVMF16BImode)
          || GET_MODE (x3) != E_RVVM1HFmode
          || !register_operand (operands[3], E_RVVM1HFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_RVVM1HImode:
          if (!register_operand (operands[2], E_RVVM1HImode))
            return -1;
          return 8;

        case E_RVVMF2QImode:
          if (!register_operand (operands[2], E_RVVMF2QImode))
            return -1;
          return 9;

        case E_RVVM2SImode:
          if (!register_operand (operands[2], E_RVVM2SImode))
            return -1;
          return 10;

        default:
          return -1;
        }

    case E_RVVMF2HFmode:
      if (!register_operand (operands[0], E_RVVMF2HFmode)
          || GET_MODE (x1) != E_RVVMF2HFmode
          || !register_operand (operands[1], E_RVVMF32BImode)
          || GET_MODE (x3) != E_RVVMF2HFmode
          || !register_operand (operands[3], E_RVVMF2HFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_RVVMF2HImode:
          if (!register_operand (operands[2], E_RVVMF2HImode))
            return -1;
          return 11;

        case E_RVVMF4QImode:
          if (!register_operand (operands[2], E_RVVMF4QImode))
            return -1;
          return 12;

        case E_RVVM1SImode:
          if (!register_operand (operands[2], E_RVVM1SImode))
            return -1;
          return 13;

        default:
          return -1;
        }

    case E_RVVMF4HFmode:
      if (!register_operand (operands[0], E_RVVMF4HFmode)
          || GET_MODE (x1) != E_RVVMF4HFmode
          || !register_operand (operands[1], E_RVVMF64BImode)
          || GET_MODE (x3) != E_RVVMF4HFmode
          || !register_operand (operands[3], E_RVVMF4HFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_RVVMF4HImode:
          if (!register_operand (operands[2], E_RVVMF4HImode))
            return -1;
          return 14;

        case E_RVVMF8QImode:
          if (!register_operand (operands[2], E_RVVMF8QImode))
            return -1;
          return 15;

        case E_RVVMF2SImode:
          if (!register_operand (operands[2], E_RVVMF2SImode))
            return -1;
          return 16;

        default:
          return -1;
        }

    case E_RVVM8SFmode:
      if (!register_operand (operands[0], E_RVVM8SFmode)
          || GET_MODE (x1) != E_RVVM8SFmode
          || !register_operand (operands[1], E_RVVMF4BImode)
          || GET_MODE (x3) != E_RVVM8SFmode
          || !register_operand (operands[3], E_RVVM8SFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_RVVM8SImode:
          if (!register_operand (operands[2], E_RVVM8SImode))
            return -1;
          return 17;

        case E_RVVM4HImode:
          if (!register_operand (operands[2], E_RVVM4HImode))
            return -1;
          return 18;

        default:
          return -1;
        }

    case E_RVVM4SFmode:
      if (!register_operand (operands[0], E_RVVM4SFmode)
          || GET_MODE (x1) != E_RVVM4SFmode
          || !register_operand (operands[1], E_RVVMF8BImode)
          || GET_MODE (x3) != E_RVVM4SFmode
          || !register_operand (operands[3], E_RVVM4SFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_RVVM4SImode:
          if (!register_operand (operands[2], E_RVVM4SImode))
            return -1;
          return 19;

        case E_RVVM2HImode:
          if (!register_operand (operands[2], E_RVVM2HImode))
            return -1;
          return 20;

        case E_RVVM8DImode:
          if (!register_operand (operands[2], E_RVVM8DImode))
            return -1;
          return 21;

        default:
          return -1;
        }

    case E_RVVM2SFmode:
      if (!register_operand (operands[0], E_RVVM2SFmode)
          || GET_MODE (x1) != E_RVVM2SFmode
          || !register_operand (operands[1], E_RVVMF16BImode)
          || GET_MODE (x3) != E_RVVM2SFmode
          || !register_operand (operands[3], E_RVVM2SFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_RVVM2SImode:
          if (!register_operand (operands[2], E_RVVM2SImode))
            return -1;
          return 22;

        case E_RVVM1HImode:
          if (!register_operand (operands[2], E_RVVM1HImode))
            return -1;
          return 23;

        case E_RVVM4DImode:
          if (!register_operand (operands[2], E_RVVM4DImode))
            return -1;
          return 24;

        default:
          return -1;
        }

    case E_RVVM1SFmode:
      if (!register_operand (operands[0], E_RVVM1SFmode)
          || GET_MODE (x1) != E_RVVM1SFmode
          || !register_operand (operands[1], E_RVVMF32BImode)
          || GET_MODE (x3) != E_RVVM1SFmode
          || !register_operand (operands[3], E_RVVM1SFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_RVVM1SImode:
          if (!register_operand (operands[2], E_RVVM1SImode))
            return -1;
          return 25;

        case E_RVVMF2HImode:
          if (!register_operand (operands[2], E_RVVMF2HImode))
            return -1;
          return 26;

        case E_RVVM2DImode:
          if (!register_operand (operands[2], E_RVVM2DImode))
            return -1;
          return 27;

        default:
          return -1;
        }

    case E_RVVMF2SFmode:
      if (!register_operand (operands[0], E_RVVMF2SFmode)
          || GET_MODE (x1) != E_RVVMF2SFmode
          || !register_operand (operands[1], E_RVVMF64BImode)
          || GET_MODE (x3) != E_RVVMF2SFmode
          || !register_operand (operands[3], E_RVVMF2SFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_RVVMF2SImode:
          if (!register_operand (operands[2], E_RVVMF2SImode))
            return -1;
          return 28;

        case E_RVVMF4HImode:
          if (!register_operand (operands[2], E_RVVMF4HImode))
            return -1;
          return 29;

        case E_RVVM1DImode:
          if (!register_operand (operands[2], E_RVVM1DImode))
            return -1;
          return 30;

        default:
          return -1;
        }

    case E_RVVM8DFmode:
      if (!register_operand (operands[0], E_RVVM8DFmode)
          || GET_MODE (x1) != E_RVVM8DFmode
          || !register_operand (operands[1], E_RVVMF8BImode)
          || GET_MODE (x3) != E_RVVM8DFmode
          || !register_operand (operands[3], E_RVVM8DFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_RVVM8DImode:
          if (!register_operand (operands[2], E_RVVM8DImode))
            return -1;
          return 31;

        case E_RVVM4SImode:
          if (!register_operand (operands[2], E_RVVM4SImode))
            return -1;
          return 32;

        default:
          return -1;
        }

    case E_RVVM4DFmode:
      if (!register_operand (operands[0], E_RVVM4DFmode)
          || GET_MODE (x1) != E_RVVM4DFmode
          || !register_operand (operands[1], E_RVVMF16BImode)
          || GET_MODE (x3) != E_RVVM4DFmode
          || !register_operand (operands[3], E_RVVM4DFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_RVVM4DImode:
          if (!register_operand (operands[2], E_RVVM4DImode))
            return -1;
          return 33;

        case E_RVVM2SImode:
          if (!register_operand (operands[2], E_RVVM2SImode))
            return -1;
          return 34;

        default:
          return -1;
        }

    case E_RVVM2DFmode:
      if (!register_operand (operands[0], E_RVVM2DFmode)
          || GET_MODE (x1) != E_RVVM2DFmode
          || !register_operand (operands[1], E_RVVMF32BImode)
          || GET_MODE (x3) != E_RVVM2DFmode
          || !register_operand (operands[3], E_RVVM2DFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_RVVM2DImode:
          if (!register_operand (operands[2], E_RVVM2DImode))
            return -1;
          return 35;

        case E_RVVM1SImode:
          if (!register_operand (operands[2], E_RVVM1SImode))
            return -1;
          return 36;

        default:
          return -1;
        }

    case E_RVVM1DFmode:
      if (!register_operand (operands[0], E_RVVM1DFmode)
          || GET_MODE (x1) != E_RVVM1DFmode
          || !register_operand (operands[1], E_RVVMF64BImode)
          || GET_MODE (x3) != E_RVVM1DFmode
          || !register_operand (operands[3], E_RVVM1DFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_RVVM1DImode:
          if (!register_operand (operands[2], E_RVVM1DImode))
            return -1;
          return 37;

        case E_RVVMF2SImode:
          if (!register_operand (operands[2], E_RVVMF2SImode))
            return -1;
          return 38;

        default:
          return -1;
        }

    case E_V1HFmode:
      if (!register_operand (operands[0], E_V1HFmode)
          || GET_MODE (x1) != E_V1HFmode
          || !register_operand (operands[1], E_V1BImode)
          || GET_MODE (x3) != E_V1HFmode
          || !register_operand (operands[3], E_V1HFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V1HImode:
          if (!register_operand (operands[2], E_V1HImode))
            return -1;
          return 39;

        case E_V1QImode:
          if (!register_operand (operands[2], E_V1QImode))
            return -1;
          return 40;

        case E_V1SImode:
          if (!register_operand (operands[2], E_V1SImode))
            return -1;
          return 41;

        default:
          return -1;
        }

    case E_V2HFmode:
      if (!register_operand (operands[0], E_V2HFmode)
          || GET_MODE (x1) != E_V2HFmode
          || !register_operand (operands[1], E_V2BImode)
          || GET_MODE (x3) != E_V2HFmode
          || !register_operand (operands[3], E_V2HFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V2HImode:
          if (!register_operand (operands[2], E_V2HImode))
            return -1;
          return 42;

        case E_V2QImode:
          if (!register_operand (operands[2], E_V2QImode))
            return -1;
          return 43;

        case E_V2SImode:
          if (!register_operand (operands[2], E_V2SImode))
            return -1;
          return 44;

        default:
          return -1;
        }

    case E_V4HFmode:
      if (!register_operand (operands[0], E_V4HFmode)
          || GET_MODE (x1) != E_V4HFmode
          || !register_operand (operands[1], E_V4BImode)
          || GET_MODE (x3) != E_V4HFmode
          || !register_operand (operands[3], E_V4HFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V4HImode:
          if (!register_operand (operands[2], E_V4HImode))
            return -1;
          return 45;

        case E_V4QImode:
          if (!register_operand (operands[2], E_V4QImode))
            return -1;
          return 46;

        case E_V4SImode:
          if (!register_operand (operands[2], E_V4SImode))
            return -1;
          return 47;

        default:
          return -1;
        }

    case E_V8HFmode:
      if (!register_operand (operands[0], E_V8HFmode)
          || GET_MODE (x1) != E_V8HFmode
          || !register_operand (operands[1], E_V8BImode)
          || GET_MODE (x3) != E_V8HFmode
          || !register_operand (operands[3], E_V8HFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V8HImode:
          if (!register_operand (operands[2], E_V8HImode))
            return -1;
          return 48;

        case E_V8QImode:
          if (!register_operand (operands[2], E_V8QImode))
            return -1;
          return 49;

        case E_V8SImode:
          if (!register_operand (operands[2], E_V8SImode))
            return -1;
          return 50;

        default:
          return -1;
        }

    case E_V16HFmode:
      if (!register_operand (operands[0], E_V16HFmode)
          || GET_MODE (x1) != E_V16HFmode
          || !register_operand (operands[1], E_V16BImode)
          || GET_MODE (x3) != E_V16HFmode
          || !register_operand (operands[3], E_V16HFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V16HImode:
          if (!register_operand (operands[2], E_V16HImode))
            return -1;
          return 51;

        case E_V16QImode:
          if (!register_operand (operands[2], E_V16QImode))
            return -1;
          return 52;

        case E_V16SImode:
          if (!register_operand (operands[2], E_V16SImode))
            return -1;
          return 53;

        default:
          return -1;
        }

    case E_V32HFmode:
      if (!register_operand (operands[0], E_V32HFmode)
          || GET_MODE (x1) != E_V32HFmode
          || !register_operand (operands[1], E_V32BImode)
          || GET_MODE (x3) != E_V32HFmode
          || !register_operand (operands[3], E_V32HFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V32HImode:
          if (!register_operand (operands[2], E_V32HImode))
            return -1;
          return 54;

        case E_V32QImode:
          if (!register_operand (operands[2], E_V32QImode))
            return -1;
          return 55;

        case E_V32SImode:
          if (!register_operand (operands[2], E_V32SImode))
            return -1;
          return 56;

        default:
          return -1;
        }

    case E_V64HFmode:
      if (!register_operand (operands[0], E_V64HFmode)
          || GET_MODE (x1) != E_V64HFmode
          || !register_operand (operands[1], E_V64BImode)
          || GET_MODE (x3) != E_V64HFmode
          || !register_operand (operands[3], E_V64HFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V64HImode:
          if (!register_operand (operands[2], E_V64HImode))
            return -1;
          return 57;

        case E_V64QImode:
          if (!register_operand (operands[2], E_V64QImode))
            return -1;
          return 58;

        case E_V64SImode:
          if (!register_operand (operands[2], E_V64SImode))
            return -1;
          return 59;

        default:
          return -1;
        }

    case E_V128HFmode:
      if (!register_operand (operands[0], E_V128HFmode)
          || GET_MODE (x1) != E_V128HFmode
          || !register_operand (operands[1], E_V128BImode)
          || GET_MODE (x3) != E_V128HFmode
          || !register_operand (operands[3], E_V128HFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V128HImode:
          if (!register_operand (operands[2], E_V128HImode))
            return -1;
          return 60;

        case E_V128QImode:
          if (!register_operand (operands[2], E_V128QImode))
            return -1;
          return 61;

        case E_V128SImode:
          if (!register_operand (operands[2], E_V128SImode))
            return -1;
          return 62;

        default:
          return -1;
        }

    case E_V256HFmode:
      if (!register_operand (operands[0], E_V256HFmode)
          || GET_MODE (x1) != E_V256HFmode
          || !register_operand (operands[1], E_V256BImode)
          || GET_MODE (x3) != E_V256HFmode
          || !register_operand (operands[3], E_V256HFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V256HImode:
          if (!register_operand (operands[2], E_V256HImode))
            return -1;
          return 63;

        case E_V256QImode:
          if (!register_operand (operands[2], E_V256QImode))
            return -1;
          return 64;

        case E_V256SImode:
          if (!register_operand (operands[2], E_V256SImode))
            return -1;
          return 65;

        default:
          return -1;
        }

    case E_V512HFmode:
      if (!register_operand (operands[0], E_V512HFmode)
          || GET_MODE (x1) != E_V512HFmode
          || !register_operand (operands[1], E_V512BImode)
          || GET_MODE (x3) != E_V512HFmode
          || !register_operand (operands[3], E_V512HFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V512HImode:
          if (!register_operand (operands[2], E_V512HImode))
            return -1;
          return 66;

        case E_V512QImode:
          if (!register_operand (operands[2], E_V512QImode))
            return -1;
          return 67;

        case E_V512SImode:
          if (!register_operand (operands[2], E_V512SImode))
            return -1;
          return 68;

        default:
          return -1;
        }

    case E_V1024HFmode:
      if (!register_operand (operands[0], E_V1024HFmode)
          || GET_MODE (x1) != E_V1024HFmode
          || !register_operand (operands[1], E_V1024BImode)
          || GET_MODE (x3) != E_V1024HFmode
          || !register_operand (operands[3], E_V1024HFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V1024HImode:
          if (!register_operand (operands[2], E_V1024HImode))
            return -1;
          return 69;

        case E_V1024QImode:
          if (!register_operand (operands[2], E_V1024QImode))
            return -1;
          return 70;

        case E_V1024SImode:
          if (!register_operand (operands[2], E_V1024SImode))
            return -1;
          return 71;

        default:
          return -1;
        }

    case E_V2048HFmode:
      if (!register_operand (operands[0], E_V2048HFmode)
          || GET_MODE (x1) != E_V2048HFmode
          || !register_operand (operands[1], E_V2048BImode)
          || GET_MODE (x3) != E_V2048HFmode
          || !register_operand (operands[3], E_V2048HFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V2048HImode:
          if (!register_operand (operands[2], E_V2048HImode))
            return -1;
          return 72;

        case E_V2048QImode:
          if (!register_operand (operands[2], E_V2048QImode))
            return -1;
          return 73;

        default:
          return -1;
        }

    case E_V1SFmode:
      if (!register_operand (operands[0], E_V1SFmode)
          || GET_MODE (x1) != E_V1SFmode
          || !register_operand (operands[1], E_V1BImode)
          || GET_MODE (x3) != E_V1SFmode
          || !register_operand (operands[3], E_V1SFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V1SImode:
          if (!register_operand (operands[2], E_V1SImode))
            return -1;
          return 74;

        case E_V1HImode:
          if (!register_operand (operands[2], E_V1HImode))
            return -1;
          return 75;

        case E_V1DImode:
          if (!register_operand (operands[2], E_V1DImode))
            return -1;
          return 76;

        default:
          return -1;
        }

    case E_V2SFmode:
      if (!register_operand (operands[0], E_V2SFmode)
          || GET_MODE (x1) != E_V2SFmode
          || !register_operand (operands[1], E_V2BImode)
          || GET_MODE (x3) != E_V2SFmode
          || !register_operand (operands[3], E_V2SFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V2SImode:
          if (!register_operand (operands[2], E_V2SImode))
            return -1;
          return 77;

        case E_V2HImode:
          if (!register_operand (operands[2], E_V2HImode))
            return -1;
          return 78;

        case E_V2DImode:
          if (!register_operand (operands[2], E_V2DImode))
            return -1;
          return 79;

        default:
          return -1;
        }

    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x1) != E_V4SFmode
          || !register_operand (operands[1], E_V4BImode)
          || GET_MODE (x3) != E_V4SFmode
          || !register_operand (operands[3], E_V4SFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V4SImode:
          if (!register_operand (operands[2], E_V4SImode))
            return -1;
          return 80;

        case E_V4HImode:
          if (!register_operand (operands[2], E_V4HImode))
            return -1;
          return 81;

        case E_V4DImode:
          if (!register_operand (operands[2], E_V4DImode))
            return -1;
          return 82;

        default:
          return -1;
        }

    case E_V8SFmode:
      if (!register_operand (operands[0], E_V8SFmode)
          || GET_MODE (x1) != E_V8SFmode
          || !register_operand (operands[1], E_V8BImode)
          || GET_MODE (x3) != E_V8SFmode
          || !register_operand (operands[3], E_V8SFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V8SImode:
          if (!register_operand (operands[2], E_V8SImode))
            return -1;
          return 83;

        case E_V8HImode:
          if (!register_operand (operands[2], E_V8HImode))
            return -1;
          return 84;

        case E_V8DImode:
          if (!register_operand (operands[2], E_V8DImode))
            return -1;
          return 85;

        default:
          return -1;
        }

    case E_V16SFmode:
      if (!register_operand (operands[0], E_V16SFmode)
          || GET_MODE (x1) != E_V16SFmode
          || !register_operand (operands[1], E_V16BImode)
          || GET_MODE (x3) != E_V16SFmode
          || !register_operand (operands[3], E_V16SFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V16SImode:
          if (!register_operand (operands[2], E_V16SImode))
            return -1;
          return 86;

        case E_V16HImode:
          if (!register_operand (operands[2], E_V16HImode))
            return -1;
          return 87;

        case E_V16DImode:
          if (!register_operand (operands[2], E_V16DImode))
            return -1;
          return 88;

        default:
          return -1;
        }

    case E_V32SFmode:
      if (!register_operand (operands[0], E_V32SFmode)
          || GET_MODE (x1) != E_V32SFmode
          || !register_operand (operands[1], E_V32BImode)
          || GET_MODE (x3) != E_V32SFmode
          || !register_operand (operands[3], E_V32SFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V32SImode:
          if (!register_operand (operands[2], E_V32SImode))
            return -1;
          return 89;

        case E_V32HImode:
          if (!register_operand (operands[2], E_V32HImode))
            return -1;
          return 90;

        case E_V32DImode:
          if (!register_operand (operands[2], E_V32DImode))
            return -1;
          return 91;

        default:
          return -1;
        }

    case E_V64SFmode:
      if (!register_operand (operands[0], E_V64SFmode)
          || GET_MODE (x1) != E_V64SFmode
          || !register_operand (operands[1], E_V64BImode)
          || GET_MODE (x3) != E_V64SFmode
          || !register_operand (operands[3], E_V64SFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V64SImode:
          if (!register_operand (operands[2], E_V64SImode))
            return -1;
          return 92;

        case E_V64HImode:
          if (!register_operand (operands[2], E_V64HImode))
            return -1;
          return 93;

        case E_V64DImode:
          if (!register_operand (operands[2], E_V64DImode))
            return -1;
          return 94;

        default:
          return -1;
        }

    case E_V128SFmode:
      if (!register_operand (operands[0], E_V128SFmode)
          || GET_MODE (x1) != E_V128SFmode
          || !register_operand (operands[1], E_V128BImode)
          || GET_MODE (x3) != E_V128SFmode
          || !register_operand (operands[3], E_V128SFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V128SImode:
          if (!register_operand (operands[2], E_V128SImode))
            return -1;
          return 95;

        case E_V128HImode:
          if (!register_operand (operands[2], E_V128HImode))
            return -1;
          return 96;

        case E_V128DImode:
          if (!register_operand (operands[2], E_V128DImode))
            return -1;
          return 97;

        default:
          return -1;
        }

    case E_V256SFmode:
      if (!register_operand (operands[0], E_V256SFmode)
          || GET_MODE (x1) != E_V256SFmode
          || !register_operand (operands[1], E_V256BImode)
          || GET_MODE (x3) != E_V256SFmode
          || !register_operand (operands[3], E_V256SFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V256SImode:
          if (!register_operand (operands[2], E_V256SImode))
            return -1;
          return 98;

        case E_V256HImode:
          if (!register_operand (operands[2], E_V256HImode))
            return -1;
          return 99;

        case E_V256DImode:
          if (!register_operand (operands[2], E_V256DImode))
            return -1;
          return 100;

        default:
          return -1;
        }

    case E_V512SFmode:
      if (!register_operand (operands[0], E_V512SFmode)
          || GET_MODE (x1) != E_V512SFmode
          || !register_operand (operands[1], E_V512BImode)
          || GET_MODE (x3) != E_V512SFmode
          || !register_operand (operands[3], E_V512SFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V512SImode:
          if (!register_operand (operands[2], E_V512SImode))
            return -1;
          return 101;

        case E_V512HImode:
          if (!register_operand (operands[2], E_V512HImode))
            return -1;
          return 102;

        case E_V512DImode:
          if (!register_operand (operands[2], E_V512DImode))
            return -1;
          return 103;

        default:
          return -1;
        }

    case E_V1024SFmode:
      if (!register_operand (operands[0], E_V1024SFmode)
          || GET_MODE (x1) != E_V1024SFmode
          || !register_operand (operands[1], E_V1024BImode)
          || GET_MODE (x3) != E_V1024SFmode
          || !register_operand (operands[3], E_V1024SFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V1024SImode:
          if (!register_operand (operands[2], E_V1024SImode))
            return -1;
          return 104;

        case E_V1024HImode:
          if (!register_operand (operands[2], E_V1024HImode))
            return -1;
          return 105;

        default:
          return -1;
        }

    case E_V1DFmode:
      if (!register_operand (operands[0], E_V1DFmode)
          || GET_MODE (x1) != E_V1DFmode
          || !register_operand (operands[1], E_V1BImode)
          || GET_MODE (x3) != E_V1DFmode
          || !register_operand (operands[3], E_V1DFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V1DImode:
          if (!register_operand (operands[2], E_V1DImode))
            return -1;
          return 106;

        case E_V1SImode:
          if (!register_operand (operands[2], E_V1SImode))
            return -1;
          return 107;

        default:
          return -1;
        }

    case E_V2DFmode:
      if (!register_operand (operands[0], E_V2DFmode)
          || GET_MODE (x1) != E_V2DFmode
          || !register_operand (operands[1], E_V2BImode)
          || GET_MODE (x3) != E_V2DFmode
          || !register_operand (operands[3], E_V2DFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V2DImode:
          if (!register_operand (operands[2], E_V2DImode))
            return -1;
          return 108;

        case E_V2SImode:
          if (!register_operand (operands[2], E_V2SImode))
            return -1;
          return 109;

        default:
          return -1;
        }

    case E_V4DFmode:
      if (!register_operand (operands[0], E_V4DFmode)
          || GET_MODE (x1) != E_V4DFmode
          || !register_operand (operands[1], E_V4BImode)
          || GET_MODE (x3) != E_V4DFmode
          || !register_operand (operands[3], E_V4DFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V4DImode:
          if (!register_operand (operands[2], E_V4DImode))
            return -1;
          return 110;

        case E_V4SImode:
          if (!register_operand (operands[2], E_V4SImode))
            return -1;
          return 111;

        default:
          return -1;
        }

    case E_V8DFmode:
      if (!register_operand (operands[0], E_V8DFmode)
          || GET_MODE (x1) != E_V8DFmode
          || !register_operand (operands[1], E_V8BImode)
          || GET_MODE (x3) != E_V8DFmode
          || !register_operand (operands[3], E_V8DFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V8DImode:
          if (!register_operand (operands[2], E_V8DImode))
            return -1;
          return 112;

        case E_V8SImode:
          if (!register_operand (operands[2], E_V8SImode))
            return -1;
          return 113;

        default:
          return -1;
        }

    case E_V16DFmode:
      if (!register_operand (operands[0], E_V16DFmode)
          || GET_MODE (x1) != E_V16DFmode
          || !register_operand (operands[1], E_V16BImode)
          || GET_MODE (x3) != E_V16DFmode
          || !register_operand (operands[3], E_V16DFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V16DImode:
          if (!register_operand (operands[2], E_V16DImode))
            return -1;
          return 114;

        case E_V16SImode:
          if (!register_operand (operands[2], E_V16SImode))
            return -1;
          return 115;

        default:
          return -1;
        }

    case E_V32DFmode:
      if (!register_operand (operands[0], E_V32DFmode)
          || GET_MODE (x1) != E_V32DFmode
          || !register_operand (operands[1], E_V32BImode)
          || GET_MODE (x3) != E_V32DFmode
          || !register_operand (operands[3], E_V32DFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V32DImode:
          if (!register_operand (operands[2], E_V32DImode))
            return -1;
          return 116;

        case E_V32SImode:
          if (!register_operand (operands[2], E_V32SImode))
            return -1;
          return 117;

        default:
          return -1;
        }

    case E_V64DFmode:
      if (!register_operand (operands[0], E_V64DFmode)
          || GET_MODE (x1) != E_V64DFmode
          || !register_operand (operands[1], E_V64BImode)
          || GET_MODE (x3) != E_V64DFmode
          || !register_operand (operands[3], E_V64DFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V64DImode:
          if (!register_operand (operands[2], E_V64DImode))
            return -1;
          return 118;

        case E_V64SImode:
          if (!register_operand (operands[2], E_V64SImode))
            return -1;
          return 119;

        default:
          return -1;
        }

    case E_V128DFmode:
      if (!register_operand (operands[0], E_V128DFmode)
          || GET_MODE (x1) != E_V128DFmode
          || !register_operand (operands[1], E_V128BImode)
          || GET_MODE (x3) != E_V128DFmode
          || !register_operand (operands[3], E_V128DFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V128DImode:
          if (!register_operand (operands[2], E_V128DImode))
            return -1;
          return 120;

        case E_V128SImode:
          if (!register_operand (operands[2], E_V128SImode))
            return -1;
          return 121;

        default:
          return -1;
        }

    case E_V256DFmode:
      if (!register_operand (operands[0], E_V256DFmode)
          || GET_MODE (x1) != E_V256DFmode
          || !register_operand (operands[1], E_V256BImode)
          || GET_MODE (x3) != E_V256DFmode
          || !register_operand (operands[3], E_V256DFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V256DImode:
          if (!register_operand (operands[2], E_V256DImode))
            return -1;
          return 122;

        case E_V256SImode:
          if (!register_operand (operands[2], E_V256SImode))
            return -1;
          return 123;

        default:
          return -1;
        }

    case E_V512DFmode:
      if (!register_operand (operands[0], E_V512DFmode)
          || GET_MODE (x1) != E_V512DFmode
          || !register_operand (operands[1], E_V512BImode)
          || GET_MODE (x3) != E_V512DFmode
          || !register_operand (operands[3], E_V512DFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_V512DImode:
          if (!register_operand (operands[2], E_V512DImode))
            return -1;
          return 124;

        case E_V512SImode:
          if (!register_operand (operands[2], E_V512SImode))
            return -1;
          return 125;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern287 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[2], E_QImode))
    return -1;
  x2 = XEXP (x1, 1);
  operands[1] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern286 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern286 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern291 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_RVVM8SImode)
      || GET_MODE (x1) != E_RVVM8SImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_RVVM4HImode:
      if (!register_operand (operands[1], E_RVVM4HImode))
        return -1;
      return 0;

    case E_RVVM2QImode:
      if (!register_operand (operands[1], E_RVVM2QImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern295 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_RVVMF2SImode)
      || GET_MODE (x1) != E_RVVMF2SImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_RVVMF4HImode:
      if (!register_operand (operands[1], E_RVVMF4HImode))
        return -1;
      return 0;

    case E_RVVMF8QImode:
      if (!register_operand (operands[1], E_RVVMF8QImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern300 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V1SImode)
      || GET_MODE (x1) != E_V1SImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V1HImode:
      if (!register_operand (operands[1], E_V1HImode))
        return -1;
      return 0;

    case E_V1QImode:
      if (!register_operand (operands[1], E_V1QImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern305 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V32SImode)
      || GET_MODE (x1) != E_V32SImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V32HImode:
      if (!register_operand (operands[1], E_V32HImode))
        return -1;
      return 0;

    case E_V32QImode:
      if (!register_operand (operands[1], E_V32QImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern310 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V1024SImode)
      || GET_MODE (x1) != E_V1024SImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V1024HImode:
      if (!register_operand (operands[1], E_V1024HImode))
        return -1;
      return 0;

    case E_V1024QImode:
      if (!register_operand (operands[1], E_V1024QImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern315 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V16DImode)
      || GET_MODE (x1) != E_V16DImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V16SImode:
      if (!register_operand (operands[1], E_V16SImode))
        return -1;
      return 0;

    case E_V16HImode:
      if (!register_operand (operands[1], E_V16HImode))
        return -1;
      return 1;

    case E_V16QImode:
      if (!register_operand (operands[1], E_V16QImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern321 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !symbolic_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern324 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != 66
      || GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 67
      || GET_MODE (x3) != E_SImode)
    return -1;
  return 0;
}

int
pattern329 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_SImode:
      if (!register_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[1], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern333 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode)
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern335 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_DImode
      || !register_operand (operands[0], E_DImode)
      || GET_MODE (x3) != E_DImode)
    return -1;
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  if (!register_operand (operands[1], E_DImode))
    return -1;
  x6 = XEXP (x4, 1);
  operands[2] = x6;
  if (!immediate_operand (operands[2], E_QImode))
    return -1;
  x7 = XEXP (x3, 1);
  operands[3] = x7;
  if (!immediate_operand (operands[3], E_VOIDmode))
    return -1;
  x8 = XVECEXP (x1, 0, 1);
  x9 = XEXP (x8, 0);
  operands[4] = x9;
  if (!scratch_operand (operands[4], E_DImode))
    return -1;
  return 0;
}

int
pattern339 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !scratch_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern342 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  operands[2] = x1;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVMF2QImode:
      return pattern341 (
E_RVVMF2QImode); /* [-1, 1] */

    case E_RVVMF4QImode:
      res = pattern341 (
E_RVVMF4QImode);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    case E_RVVMF8QImode:
      res = pattern341 (
E_RVVMF8QImode);
      if (res >= 0)
        return res + 4; /* [4, 5] */
      return -1;

    case E_RVVMF2HImode:
      res = pattern341 (
E_RVVMF2HImode);
      if (res >= 0)
        return res + 6; /* [6, 7] */
      return -1;

    case E_RVVMF4HImode:
      res = pattern341 (
E_RVVMF4HImode);
      if (res >= 0)
        return res + 8; /* [8, 9] */
      return -1;

    case E_RVVMF2BFmode:
      res = pattern341 (
E_RVVMF2BFmode);
      if (res >= 0)
        return res + 10; /* [10, 11] */
      return -1;

    case E_RVVMF4BFmode:
      res = pattern341 (
E_RVVMF4BFmode);
      if (res >= 0)
        return res + 12; /* [12, 13] */
      return -1;

    case E_RVVMF2HFmode:
      res = pattern341 (
E_RVVMF2HFmode);
      if (res >= 0)
        return res + 14; /* [14, 15] */
      return -1;

    case E_RVVMF4HFmode:
      res = pattern341 (
E_RVVMF4HFmode);
      if (res >= 0)
        return res + 16; /* [16, 17] */
      return -1;

    case E_RVVMF2SImode:
      res = pattern341 (
E_RVVMF2SImode);
      if (res >= 0)
        return res + 18; /* [18, 19] */
      return -1;

    case E_RVVMF2SFmode:
      res = pattern341 (
E_RVVMF2SFmode);
      if (res >= 0)
        return res + 20; /* [20, 21] */
      return -1;

    case E_RVVMF64BImode:
      res = pattern341 (
E_RVVMF64BImode);
      if (res >= 0)
        return res + 22; /* [22, 23] */
      return -1;

    case E_RVVMF32BImode:
      res = pattern341 (
E_RVVMF32BImode);
      if (res >= 0)
        return res + 24; /* [24, 25] */
      return -1;

    case E_RVVMF16BImode:
      res = pattern341 (
E_RVVMF16BImode);
      if (res >= 0)
        return res + 26; /* [26, 27] */
      return -1;

    case E_RVVMF8BImode:
      res = pattern341 (
E_RVVMF8BImode);
      if (res >= 0)
        return res + 28; /* [28, 29] */
      return -1;

    case E_RVVMF4BImode:
      res = pattern341 (
E_RVVMF4BImode);
      if (res >= 0)
        return res + 30; /* [30, 31] */
      return -1;

    case E_RVVMF2BImode:
      res = pattern341 (
E_RVVMF2BImode);
      if (res >= 0)
        return res + 32; /* [32, 33] */
      return -1;

    case E_RVVM1BImode:
      res = pattern341 (
E_RVVM1BImode);
      if (res >= 0)
        return res + 34; /* [34, 35] */
      return -1;

    case E_V32QImode:
      res = pattern341 (
E_V32QImode);
      if (res >= 0)
        return res + 36; /* [36, 37] */
      return -1;

    case E_V64QImode:
      res = pattern341 (
E_V64QImode);
      if (res >= 0)
        return res + 38; /* [38, 39] */
      return -1;

    case E_V128QImode:
      res = pattern341 (
E_V128QImode);
      if (res >= 0)
        return res + 40; /* [40, 41] */
      return -1;

    case E_V256QImode:
      res = pattern341 (
E_V256QImode);
      if (res >= 0)
        return res + 42; /* [42, 43] */
      return -1;

    case E_V512QImode:
      res = pattern341 (
E_V512QImode);
      if (res >= 0)
        return res + 44; /* [44, 45] */
      return -1;

    case E_V1024QImode:
      res = pattern341 (
E_V1024QImode);
      if (res >= 0)
        return res + 46; /* [46, 47] */
      return -1;

    case E_V2048QImode:
      res = pattern341 (
E_V2048QImode);
      if (res >= 0)
        return res + 48; /* [48, 49] */
      return -1;

    case E_V4096QImode:
      res = pattern341 (
E_V4096QImode);
      if (res >= 0)
        return res + 50; /* [50, 51] */
      return -1;

    case E_V32HImode:
      res = pattern341 (
E_V32HImode);
      if (res >= 0)
        return res + 52; /* [52, 53] */
      return -1;

    case E_V64HImode:
      res = pattern341 (
E_V64HImode);
      if (res >= 0)
        return res + 54; /* [54, 55] */
      return -1;

    case E_V128HImode:
      res = pattern341 (
E_V128HImode);
      if (res >= 0)
        return res + 56; /* [56, 57] */
      return -1;

    case E_V256HImode:
      res = pattern341 (
E_V256HImode);
      if (res >= 0)
        return res + 58; /* [58, 59] */
      return -1;

    case E_V512HImode:
      res = pattern341 (
E_V512HImode);
      if (res >= 0)
        return res + 60; /* [60, 61] */
      return -1;

    case E_V1024HImode:
      res = pattern341 (
E_V1024HImode);
      if (res >= 0)
        return res + 62; /* [62, 63] */
      return -1;

    case E_V2048HImode:
      res = pattern341 (
E_V2048HImode);
      if (res >= 0)
        return res + 64; /* [64, 65] */
      return -1;

    case E_V32SImode:
      res = pattern341 (
E_V32SImode);
      if (res >= 0)
        return res + 66; /* [66, 67] */
      return -1;

    case E_V64SImode:
      res = pattern341 (
E_V64SImode);
      if (res >= 0)
        return res + 68; /* [68, 69] */
      return -1;

    case E_V128SImode:
      res = pattern341 (
E_V128SImode);
      if (res >= 0)
        return res + 70; /* [70, 71] */
      return -1;

    case E_V256SImode:
      res = pattern341 (
E_V256SImode);
      if (res >= 0)
        return res + 72; /* [72, 73] */
      return -1;

    case E_V512SImode:
      res = pattern341 (
E_V512SImode);
      if (res >= 0)
        return res + 74; /* [74, 75] */
      return -1;

    case E_V1024SImode:
      res = pattern341 (
E_V1024SImode);
      if (res >= 0)
        return res + 76; /* [76, 77] */
      return -1;

    case E_V32DImode:
      res = pattern341 (
E_V32DImode);
      if (res >= 0)
        return res + 78; /* [78, 79] */
      return -1;

    case E_V64DImode:
      res = pattern341 (
E_V64DImode);
      if (res >= 0)
        return res + 80; /* [80, 81] */
      return -1;

    case E_V128DImode:
      res = pattern341 (
E_V128DImode);
      if (res >= 0)
        return res + 82; /* [82, 83] */
      return -1;

    case E_V256DImode:
      res = pattern341 (
E_V256DImode);
      if (res >= 0)
        return res + 84; /* [84, 85] */
      return -1;

    case E_V512DImode:
      res = pattern341 (
E_V512DImode);
      if (res >= 0)
        return res + 86; /* [86, 87] */
      return -1;

    case E_V32HFmode:
      res = pattern341 (
E_V32HFmode);
      if (res >= 0)
        return res + 88; /* [88, 89] */
      return -1;

    case E_V64HFmode:
      res = pattern341 (
E_V64HFmode);
      if (res >= 0)
        return res + 90; /* [90, 91] */
      return -1;

    case E_V128HFmode:
      res = pattern341 (
E_V128HFmode);
      if (res >= 0)
        return res + 92; /* [92, 93] */
      return -1;

    case E_V256HFmode:
      res = pattern341 (
E_V256HFmode);
      if (res >= 0)
        return res + 94; /* [94, 95] */
      return -1;

    case E_V512HFmode:
      res = pattern341 (
E_V512HFmode);
      if (res >= 0)
        return res + 96; /* [96, 97] */
      return -1;

    case E_V1024HFmode:
      res = pattern341 (
E_V1024HFmode);
      if (res >= 0)
        return res + 98; /* [98, 99] */
      return -1;

    case E_V2048HFmode:
      res = pattern341 (
E_V2048HFmode);
      if (res >= 0)
        return res + 100; /* [100, 101] */
      return -1;

    case E_V32SFmode:
      res = pattern341 (
E_V32SFmode);
      if (res >= 0)
        return res + 102; /* [102, 103] */
      return -1;

    case E_V64SFmode:
      res = pattern341 (
E_V64SFmode);
      if (res >= 0)
        return res + 104; /* [104, 105] */
      return -1;

    case E_V128SFmode:
      res = pattern341 (
E_V128SFmode);
      if (res >= 0)
        return res + 106; /* [106, 107] */
      return -1;

    case E_V256SFmode:
      res = pattern341 (
E_V256SFmode);
      if (res >= 0)
        return res + 108; /* [108, 109] */
      return -1;

    case E_V512SFmode:
      res = pattern341 (
E_V512SFmode);
      if (res >= 0)
        return res + 110; /* [110, 111] */
      return -1;

    case E_V1024SFmode:
      res = pattern341 (
E_V1024SFmode);
      if (res >= 0)
        return res + 112; /* [112, 113] */
      return -1;

    case E_V32DFmode:
      res = pattern341 (
E_V32DFmode);
      if (res >= 0)
        return res + 114; /* [114, 115] */
      return -1;

    case E_V64DFmode:
      res = pattern341 (
E_V64DFmode);
      if (res >= 0)
        return res + 116; /* [116, 117] */
      return -1;

    case E_V128DFmode:
      res = pattern341 (
E_V128DFmode);
      if (res >= 0)
        return res + 118; /* [118, 119] */
      return -1;

    case E_V256DFmode:
      res = pattern341 (
E_V256DFmode);
      if (res >= 0)
        return res + 120; /* [120, 121] */
      return -1;

    case E_V512DFmode:
      res = pattern341 (
E_V512DFmode);
      if (res >= 0)
        return res + 122; /* [122, 123] */
      return -1;

    case E_V32BImode:
      res = pattern341 (
E_V32BImode);
      if (res >= 0)
        return res + 124; /* [124, 125] */
      return -1;

    case E_V64BImode:
      res = pattern341 (
E_V64BImode);
      if (res >= 0)
        return res + 126; /* [126, 127] */
      return -1;

    case E_V128BImode:
      res = pattern341 (
E_V128BImode);
      if (res >= 0)
        return res + 128; /* [128, 129] */
      return -1;

    case E_V256BImode:
      res = pattern341 (
E_V256BImode);
      if (res >= 0)
        return res + 130; /* [130, 131] */
      return -1;

    case E_V512BImode:
      res = pattern341 (
E_V512BImode);
      if (res >= 0)
        return res + 132; /* [132, 133] */
      return -1;

    case E_V1024BImode:
      res = pattern341 (
E_V1024BImode);
      if (res >= 0)
        return res + 134; /* [134, 135] */
      return -1;

    case E_V2048BImode:
      res = pattern341 (
E_V2048BImode);
      if (res >= 0)
        return res + 136; /* [136, 137] */
      return -1;

    case E_V4096BImode:
      res = pattern341 (
E_V4096BImode);
      if (res >= 0)
        return res + 138; /* [138, 139] */
      return -1;

    default:
      return -1;
    }
}

int
pattern407 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || !memory_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !memory_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern411 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!memory_operand (operands[0], i1)
      || !register_operand (operands[1], i1)
      || !memory_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern415 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != AND
      || GET_MODE (x1) != E_DImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != ASHIFT
      || GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!register_operand (operands[1], E_DImode))
    return -1;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  return 0;
}

int
pattern420 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], i1))
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_SImode:
      if (!scratch_operand (operands[2], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!scratch_operand (operands[2], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern427 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34, x35, x36, x37, x38, x39, x40, x41;
  rtx x42, x43, x44, x45, x46, x47;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 2)
    return -1;
  x5 = XEXP (x2, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 2)
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 1);
  if (GET_CODE (x7) != MEM)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_CODE (x8) != PLUS)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_CODE (x9) != REG
      || REGNO (x9) != 2)
    return -1;
  x10 = XEXP (x8, 1);
  if (GET_CODE (x10) != CONST_INT)
    return -1;
  x11 = XEXP (x6, 0);
  if (GET_CODE (x11) != REG)
    return -1;
  x12 = XVECEXP (x1, 0, 2);
  x13 = XEXP (x12, 1);
  if (GET_CODE (x13) != MEM)
    return -1;
  x14 = XEXP (x13, 0);
  if (GET_CODE (x14) != PLUS)
    return -1;
  x15 = XEXP (x14, 0);
  if (GET_CODE (x15) != REG
      || REGNO (x15) != 2)
    return -1;
  x16 = XEXP (x14, 1);
  if (GET_CODE (x16) != CONST_INT)
    return -1;
  x17 = XEXP (x12, 0);
  if (GET_CODE (x17) != REG)
    return -1;
  x18 = XVECEXP (x1, 0, 3);
  x19 = XEXP (x18, 1);
  if (GET_CODE (x19) != MEM)
    return -1;
  x20 = XEXP (x19, 0);
  if (GET_CODE (x20) != PLUS)
    return -1;
  x21 = XEXP (x20, 0);
  if (GET_CODE (x21) != REG
      || REGNO (x21) != 2)
    return -1;
  x22 = XEXP (x20, 1);
  if (GET_CODE (x22) != CONST_INT)
    return -1;
  x23 = XEXP (x18, 0);
  if (GET_CODE (x23) != REG)
    return -1;
  x24 = XVECEXP (x1, 0, 4);
  x25 = XEXP (x24, 1);
  if (GET_CODE (x25) != MEM)
    return -1;
  x26 = XEXP (x25, 0);
  if (GET_CODE (x26) != PLUS)
    return -1;
  x27 = XEXP (x26, 0);
  if (GET_CODE (x27) != REG
      || REGNO (x27) != 2)
    return -1;
  x28 = XEXP (x26, 1);
  if (GET_CODE (x28) != CONST_INT)
    return -1;
  x29 = XEXP (x24, 0);
  if (GET_CODE (x29) != REG)
    return -1;
  x30 = XVECEXP (x1, 0, 5);
  x31 = XEXP (x30, 1);
  if (GET_CODE (x31) != MEM)
    return -1;
  x32 = XEXP (x31, 0);
  if (GET_CODE (x32) != PLUS)
    return -1;
  x33 = XEXP (x32, 0);
  if (GET_CODE (x33) != REG
      || REGNO (x33) != 2)
    return -1;
  x34 = XEXP (x32, 1);
  if (GET_CODE (x34) != CONST_INT)
    return -1;
  x35 = XEXP (x30, 0);
  if (GET_CODE (x35) != REG)
    return -1;
  x36 = XVECEXP (x1, 0, 6);
  x37 = XEXP (x36, 1);
  if (GET_CODE (x37) != MEM)
    return -1;
  x38 = XEXP (x37, 0);
  if (GET_CODE (x38) != PLUS)
    return -1;
  x39 = XEXP (x38, 0);
  if (GET_CODE (x39) != REG
      || REGNO (x39) != 2)
    return -1;
  x40 = XEXP (x38, 1);
  if (GET_CODE (x40) != CONST_INT)
    return -1;
  x41 = XEXP (x36, 0);
  if (GET_CODE (x41) != REG)
    return -1;
  x42 = XVECEXP (x1, 0, 7);
  x43 = XEXP (x42, 1);
  if (GET_CODE (x43) != MEM)
    return -1;
  x44 = XEXP (x43, 0);
  if (GET_CODE (x44) != PLUS)
    return -1;
  x45 = XEXP (x44, 0);
  if (GET_CODE (x45) != REG
      || REGNO (x45) != 2)
    return -1;
  x46 = XEXP (x44, 1);
  if (GET_CODE (x46) != CONST_INT)
    return -1;
  x47 = XEXP (x42, 0);
  if (GET_CODE (x47) != REG)
    return -1;
  return 0;
}

int
pattern447 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x1, 0);
  x5 = XEXP (x4, 0);
  switch (GET_MODE (x5))
    {
    case E_QImode:
      if (!register_operand (operands[2], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!register_operand (operands[2], E_HImode))
        return -1;
      return 1;

    case E_SImode:
      if (!register_operand (operands[2], E_SImode))
        return -1;
      return 2;

    case E_DImode:
      if (!register_operand (operands[2], E_DImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern456 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  operands[2] = x3;
  x4 = XEXP (x2, 0);
  if (!rtx_equal_p (x4, operands[1]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern455 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern455 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern462 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != ASHIFT
      || GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_CODE (x3) != SUBREG
      || maybe_ne (SUBREG_BYTE (x3), 0)
      || GET_MODE (x3) != E_QImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != AND
      || GET_MODE (x4) != E_DImode)
    return -1;
  x5 = XEXP (x4, 1);
  operands[2] = x5;
  if (!const_int_operand (operands[2], E_VOIDmode))
    return -1;
  x6 = XEXP (x4, 0);
  return pattern373 (x6); /* [-1, 1] */
}

int
pattern467 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 0);
  operands[4] = x3;
  x4 = XVECEXP (x2, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x2, 0, 2);
  operands[6] = x5;
  x6 = XEXP (x1, 1);
  x7 = XEXP (x6, 0);
  x8 = XEXP (x7, 0);
  operands[2] = x8;
  x9 = XEXP (x6, 1);
  operands[1] = x9;
  x10 = XEXP (x6, 2);
  operands[3] = x10;
  x11 = XEXP (x1, 2);
  if (!rtx_equal_p (x11, operands[1]))
    return -1;
  return pattern466 (x1); /* [-1, 91] */
}

int
pattern473 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != UNSPEC
      || XVECLEN (x2, 0) != 3
      || XINT (x2, 1) != i1)
    return -1;
  x3 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x3) != MEM
      || GET_MODE (x3) != E_BLKmode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != SCRATCH)
    return -1;
  x5 = XEXP (x1, 0);
  x6 = XVECEXP (x5, 0, 1);
  operands[5] = x6;
  x7 = XVECEXP (x5, 0, 2);
  operands[6] = x7;
  x8 = XVECEXP (x5, 0, 3);
  operands[7] = x8;
  x9 = XVECEXP (x5, 0, 4);
  operands[8] = x9;
  x10 = XVECEXP (x2, 0, 0);
  operands[3] = x10;
  if (!pmode_reg_or_0_operand (operands[3], E_VOIDmode))
    return -1;
  x11 = XVECEXP (x2, 0, 2);
  operands[4] = x11;
  x12 = XEXP (x1, 2);
  operands[2] = x12;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8QImode:
      return pattern472 (x1, 
E_RVVM8QImode, 
E_RVVM1BImode); /* [-1, 0] */

    case E_RVVM4QImode:
      if (pattern472 (x1, 
E_RVVM4QImode, 
E_RVVMF2BImode) != 0)
        return -1;
      return 1;

    case E_RVVM2QImode:
      if (pattern472 (x1, 
E_RVVM2QImode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 2;

    case E_RVVM1QImode:
      if (pattern472 (x1, 
E_RVVM1QImode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 3;

    case E_RVVM8HImode:
      if (pattern472 (x1, 
E_RVVM8HImode, 
E_RVVMF2BImode) != 0)
        return -1;
      return 4;

    case E_RVVM4HImode:
      if (pattern472 (x1, 
E_RVVM4HImode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 5;

    case E_RVVM2HImode:
      if (pattern472 (x1, 
E_RVVM2HImode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 6;

    case E_RVVM1HImode:
      if (pattern472 (x1, 
E_RVVM1HImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 7;

    case E_RVVM8SImode:
      if (pattern472 (x1, 
E_RVVM8SImode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 8;

    case E_RVVM4SImode:
      if (pattern472 (x1, 
E_RVVM4SImode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 9;

    case E_RVVM2SImode:
      if (pattern472 (x1, 
E_RVVM2SImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 10;

    case E_RVVM1SImode:
      if (pattern472 (x1, 
E_RVVM1SImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 11;

    case E_RVVM8DImode:
      if (pattern472 (x1, 
E_RVVM8DImode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 12;

    case E_RVVM4DImode:
      if (pattern472 (x1, 
E_RVVM4DImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 13;

    case E_RVVM2DImode:
      if (pattern472 (x1, 
E_RVVM2DImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 14;

    case E_RVVM1DImode:
      if (pattern472 (x1, 
E_RVVM1DImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 15;

    case E_RVVMF8QImode:
      if (pattern472 (x1, 
E_RVVMF8QImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 16;

    case E_RVVMF4HImode:
      if (pattern472 (x1, 
E_RVVMF4HImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 17;

    case E_RVVMF2SImode:
      if (pattern472 (x1, 
E_RVVMF2SImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 18;

    default:
      return -1;
    }
}

int
pattern485 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !vector_mask_operand (operands[1], i2))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[3], i1)
      || !vector_merge_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern487 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  operands[5] = x3;
  x4 = XVECEXP (x2, 0, 2);
  operands[6] = x4;
  x5 = XVECEXP (x2, 0, 3);
  operands[7] = x5;
  x6 = XVECEXP (x2, 0, 4);
  operands[8] = x6;
  x7 = XEXP (x1, 2);
  operands[2] = x7;
  x8 = XEXP (x1, 1);
  x9 = XEXP (x8, 0);
  switch (GET_CODE (x9))
    {
    case REG:
    case SUBREG:
      operands[3] = x9;
      return pattern482 (x1); /* [-1, 67] */

    case VEC_DUPLICATE:
      x10 = XEXP (x8, 1);
      operands[3] = x10;
      x11 = XEXP (x9, 0);
      switch (GET_CODE (x11))
        {
        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case REG:
        case SUBREG:
          res = pattern484 (x1);
          if (res >= 0)
            return res + 68; /* [68, 135] */
          return -1;

        case SIGN_EXTEND:
          res = pattern486 (x1);
          if (res >= 0)
            return res + 136; /* [136, 149] */
          return -1;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern491 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i3
      || !vector_mask_operand (operands[1], i3))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[4], i2)
      || !register_operand (operands[3], i1)
      || !vector_merge_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern494 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  operands[5] = x3;
  x4 = XVECEXP (x2, 0, 2);
  operands[6] = x4;
  x5 = XVECEXP (x2, 0, 3);
  operands[7] = x5;
  x6 = XVECEXP (x2, 0, 4);
  operands[8] = x6;
  x7 = XEXP (x1, 2);
  operands[2] = x7;
  x8 = XEXP (x1, 1);
  x9 = XEXP (x8, 0);
  switch (GET_CODE (x9))
    {
    case REG:
    case SUBREG:
      operands[3] = x9;
      return pattern493 (x1); /* [-1, 67] */

    case VEC_DUPLICATE:
      x10 = XEXP (x8, 1);
      operands[3] = x10;
      x11 = XEXP (x9, 0);
      switch (GET_CODE (x11))
        {
        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case REG:
        case SUBREG:
          res = pattern484 (x1);
          if (res >= 0)
            return res + 68; /* [68, 135] */
          return -1;

        case SIGN_EXTEND:
          res = pattern486 (x1);
          if (res >= 0)
            return res + 136; /* [136, 149] */
          return -1;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern495 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !vector_mask_operand (operands[1], i2))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[3], i1))
    return -1;
  x4 = XEXP (x3, 1);
  if (GET_MODE (x4) != i1
      || !reg_or_0_operand (operands[4], i3)
      || !vector_merge_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern496 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[4] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8QImode:
      return pattern495 (x1, 
E_RVVM8QImode, 
E_RVVM1BImode, 
E_QImode); /* [-1, 0] */

    case E_RVVM4QImode:
      if (pattern495 (x1, 
E_RVVM4QImode, 
E_RVVMF2BImode, 
E_QImode) != 0)
        return -1;
      return 1;

    case E_RVVM2QImode:
      if (pattern495 (x1, 
E_RVVM2QImode, 
E_RVVMF4BImode, 
E_QImode) != 0)
        return -1;
      return 2;

    case E_RVVM1QImode:
      if (pattern495 (x1, 
E_RVVM1QImode, 
E_RVVMF8BImode, 
E_QImode) != 0)
        return -1;
      return 3;

    case E_RVVMF2QImode:
      if (pattern495 (x1, 
E_RVVMF2QImode, 
E_RVVMF16BImode, 
E_QImode) != 0)
        return -1;
      return 4;

    case E_RVVMF4QImode:
      if (pattern495 (x1, 
E_RVVMF4QImode, 
E_RVVMF32BImode, 
E_QImode) != 0)
        return -1;
      return 5;

    case E_RVVMF8QImode:
      if (pattern495 (x1, 
E_RVVMF8QImode, 
E_RVVMF64BImode, 
E_QImode) != 0)
        return -1;
      return 6;

    case E_RVVM8HImode:
      if (pattern495 (x1, 
E_RVVM8HImode, 
E_RVVMF2BImode, 
E_HImode) != 0)
        return -1;
      return 7;

    case E_RVVM4HImode:
      if (pattern495 (x1, 
E_RVVM4HImode, 
E_RVVMF4BImode, 
E_HImode) != 0)
        return -1;
      return 8;

    case E_RVVM2HImode:
      if (pattern495 (x1, 
E_RVVM2HImode, 
E_RVVMF8BImode, 
E_HImode) != 0)
        return -1;
      return 9;

    case E_RVVM1HImode:
      if (pattern495 (x1, 
E_RVVM1HImode, 
E_RVVMF16BImode, 
E_HImode) != 0)
        return -1;
      return 10;

    case E_RVVMF2HImode:
      if (pattern495 (x1, 
E_RVVMF2HImode, 
E_RVVMF32BImode, 
E_HImode) != 0)
        return -1;
      return 11;

    case E_RVVMF4HImode:
      if (pattern495 (x1, 
E_RVVMF4HImode, 
E_RVVMF64BImode, 
E_HImode) != 0)
        return -1;
      return 12;

    case E_RVVM8SImode:
      if (pattern495 (x1, 
E_RVVM8SImode, 
E_RVVMF4BImode, 
E_SImode) != 0)
        return -1;
      return 13;

    case E_RVVM4SImode:
      if (pattern495 (x1, 
E_RVVM4SImode, 
E_RVVMF8BImode, 
E_SImode) != 0)
        return -1;
      return 14;

    case E_RVVM2SImode:
      if (pattern495 (x1, 
E_RVVM2SImode, 
E_RVVMF16BImode, 
E_SImode) != 0)
        return -1;
      return 15;

    case E_RVVM1SImode:
      if (pattern495 (x1, 
E_RVVM1SImode, 
E_RVVMF32BImode, 
E_SImode) != 0)
        return -1;
      return 16;

    case E_RVVMF2SImode:
      if (pattern495 (x1, 
E_RVVMF2SImode, 
E_RVVMF64BImode, 
E_SImode) != 0)
        return -1;
      return 17;

    case E_V1QImode:
      if (pattern495 (x1, 
E_V1QImode, 
E_V1BImode, 
E_QImode) != 0)
        return -1;
      return 18;

    case E_V2QImode:
      if (pattern495 (x1, 
E_V2QImode, 
E_V2BImode, 
E_QImode) != 0)
        return -1;
      return 19;

    case E_V4QImode:
      if (pattern495 (x1, 
E_V4QImode, 
E_V4BImode, 
E_QImode) != 0)
        return -1;
      return 20;

    case E_V8QImode:
      if (pattern495 (x1, 
E_V8QImode, 
E_V8BImode, 
E_QImode) != 0)
        return -1;
      return 21;

    case E_V16QImode:
      if (pattern495 (x1, 
E_V16QImode, 
E_V16BImode, 
E_QImode) != 0)
        return -1;
      return 22;

    case E_V32QImode:
      if (pattern495 (x1, 
E_V32QImode, 
E_V32BImode, 
E_QImode) != 0)
        return -1;
      return 23;

    case E_V64QImode:
      if (pattern495 (x1, 
E_V64QImode, 
E_V64BImode, 
E_QImode) != 0)
        return -1;
      return 24;

    case E_V128QImode:
      if (pattern495 (x1, 
E_V128QImode, 
E_V128BImode, 
E_QImode) != 0)
        return -1;
      return 25;

    case E_V256QImode:
      if (pattern495 (x1, 
E_V256QImode, 
E_V256BImode, 
E_QImode) != 0)
        return -1;
      return 26;

    case E_V512QImode:
      if (pattern495 (x1, 
E_V512QImode, 
E_V512BImode, 
E_QImode) != 0)
        return -1;
      return 27;

    case E_V1024QImode:
      if (pattern495 (x1, 
E_V1024QImode, 
E_V1024BImode, 
E_QImode) != 0)
        return -1;
      return 28;

    case E_V2048QImode:
      if (pattern495 (x1, 
E_V2048QImode, 
E_V2048BImode, 
E_QImode) != 0)
        return -1;
      return 29;

    case E_V4096QImode:
      if (pattern495 (x1, 
E_V4096QImode, 
E_V4096BImode, 
E_QImode) != 0)
        return -1;
      return 30;

    case E_V1HImode:
      if (pattern495 (x1, 
E_V1HImode, 
E_V1BImode, 
E_HImode) != 0)
        return -1;
      return 31;

    case E_V2HImode:
      if (pattern495 (x1, 
E_V2HImode, 
E_V2BImode, 
E_HImode) != 0)
        return -1;
      return 32;

    case E_V4HImode:
      if (pattern495 (x1, 
E_V4HImode, 
E_V4BImode, 
E_HImode) != 0)
        return -1;
      return 33;

    case E_V8HImode:
      if (pattern495 (x1, 
E_V8HImode, 
E_V8BImode, 
E_HImode) != 0)
        return -1;
      return 34;

    case E_V16HImode:
      if (pattern495 (x1, 
E_V16HImode, 
E_V16BImode, 
E_HImode) != 0)
        return -1;
      return 35;

    case E_V32HImode:
      if (pattern495 (x1, 
E_V32HImode, 
E_V32BImode, 
E_HImode) != 0)
        return -1;
      return 36;

    case E_V64HImode:
      if (pattern495 (x1, 
E_V64HImode, 
E_V64BImode, 
E_HImode) != 0)
        return -1;
      return 37;

    case E_V128HImode:
      if (pattern495 (x1, 
E_V128HImode, 
E_V128BImode, 
E_HImode) != 0)
        return -1;
      return 38;

    case E_V256HImode:
      if (pattern495 (x1, 
E_V256HImode, 
E_V256BImode, 
E_HImode) != 0)
        return -1;
      return 39;

    case E_V512HImode:
      if (pattern495 (x1, 
E_V512HImode, 
E_V512BImode, 
E_HImode) != 0)
        return -1;
      return 40;

    case E_V1024HImode:
      if (pattern495 (x1, 
E_V1024HImode, 
E_V1024BImode, 
E_HImode) != 0)
        return -1;
      return 41;

    case E_V2048HImode:
      if (pattern495 (x1, 
E_V2048HImode, 
E_V2048BImode, 
E_HImode) != 0)
        return -1;
      return 42;

    case E_V1SImode:
      if (pattern495 (x1, 
E_V1SImode, 
E_V1BImode, 
E_SImode) != 0)
        return -1;
      return 43;

    case E_V2SImode:
      if (pattern495 (x1, 
E_V2SImode, 
E_V2BImode, 
E_SImode) != 0)
        return -1;
      return 44;

    case E_V4SImode:
      if (pattern495 (x1, 
E_V4SImode, 
E_V4BImode, 
E_SImode) != 0)
        return -1;
      return 45;

    case E_V8SImode:
      if (pattern495 (x1, 
E_V8SImode, 
E_V8BImode, 
E_SImode) != 0)
        return -1;
      return 46;

    case E_V16SImode:
      if (pattern495 (x1, 
E_V16SImode, 
E_V16BImode, 
E_SImode) != 0)
        return -1;
      return 47;

    case E_V32SImode:
      if (pattern495 (x1, 
E_V32SImode, 
E_V32BImode, 
E_SImode) != 0)
        return -1;
      return 48;

    case E_V64SImode:
      if (pattern495 (x1, 
E_V64SImode, 
E_V64BImode, 
E_SImode) != 0)
        return -1;
      return 49;

    case E_V128SImode:
      if (pattern495 (x1, 
E_V128SImode, 
E_V128BImode, 
E_SImode) != 0)
        return -1;
      return 50;

    case E_V256SImode:
      if (pattern495 (x1, 
E_V256SImode, 
E_V256BImode, 
E_SImode) != 0)
        return -1;
      return 51;

    case E_V512SImode:
      if (pattern495 (x1, 
E_V512SImode, 
E_V512BImode, 
E_SImode) != 0)
        return -1;
      return 52;

    case E_V1024SImode:
      if (pattern495 (x1, 
E_V1024SImode, 
E_V1024BImode, 
E_SImode) != 0)
        return -1;
      return 53;

    case E_RVVM8DImode:
      if (pattern495 (x1, 
E_RVVM8DImode, 
E_RVVMF8BImode, 
E_DImode) != 0)
        return -1;
      return 54;

    case E_RVVM4DImode:
      if (pattern495 (x1, 
E_RVVM4DImode, 
E_RVVMF16BImode, 
E_DImode) != 0)
        return -1;
      return 55;

    case E_RVVM2DImode:
      if (pattern495 (x1, 
E_RVVM2DImode, 
E_RVVMF32BImode, 
E_DImode) != 0)
        return -1;
      return 56;

    case E_RVVM1DImode:
      if (pattern495 (x1, 
E_RVVM1DImode, 
E_RVVMF64BImode, 
E_DImode) != 0)
        return -1;
      return 57;

    case E_V1DImode:
      if (pattern495 (x1, 
E_V1DImode, 
E_V1BImode, 
E_DImode) != 0)
        return -1;
      return 58;

    case E_V2DImode:
      if (pattern495 (x1, 
E_V2DImode, 
E_V2BImode, 
E_DImode) != 0)
        return -1;
      return 59;

    case E_V4DImode:
      if (pattern495 (x1, 
E_V4DImode, 
E_V4BImode, 
E_DImode) != 0)
        return -1;
      return 60;

    case E_V8DImode:
      if (pattern495 (x1, 
E_V8DImode, 
E_V8BImode, 
E_DImode) != 0)
        return -1;
      return 61;

    case E_V16DImode:
      if (pattern495 (x1, 
E_V16DImode, 
E_V16BImode, 
E_DImode) != 0)
        return -1;
      return 62;

    case E_V32DImode:
      if (pattern495 (x1, 
E_V32DImode, 
E_V32BImode, 
E_DImode) != 0)
        return -1;
      return 63;

    case E_V64DImode:
      if (pattern495 (x1, 
E_V64DImode, 
E_V64BImode, 
E_DImode) != 0)
        return -1;
      return 64;

    case E_V128DImode:
      if (pattern495 (x1, 
E_V128DImode, 
E_V128BImode, 
E_DImode) != 0)
        return -1;
      return 65;

    case E_V256DImode:
      if (pattern495 (x1, 
E_V256DImode, 
E_V256BImode, 
E_DImode) != 0)
        return -1;
      return 66;

    case E_V512DImode:
      if (pattern495 (x1, 
E_V512DImode, 
E_V512BImode, 
E_DImode) != 0)
        return -1;
      return 67;

    default:
      return -1;
    }
}

int
pattern510 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (x1))
    {
    case E_RVVMF4QImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_RVVMF4QImode
          || !reg_or_0_operand (operands[2], E_QImode)
          || !register_operand (operands[1], E_RVVMF4QImode))
        return -1;
      return 0;

    case E_RVVMF2HImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_RVVMF2HImode
          || !reg_or_0_operand (operands[2], E_HImode)
          || !register_operand (operands[1], E_RVVMF2HImode))
        return -1;
      return 1;

    case E_RVVM1SImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_RVVM1SImode
          || !reg_or_0_operand (operands[2], E_SImode)
          || !register_operand (operands[1], E_RVVM1SImode))
        return -1;
      return 2;

    case E_RVVM2DImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_RVVM2DImode
          || !reg_or_0_operand (operands[2], E_DImode)
          || !register_operand (operands[1], E_RVVM2DImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern513 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (x1))
    {
    case E_V2QImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V2QImode
          || !reg_or_0_operand (operands[2], E_QImode)
          || !register_operand (operands[1], E_V2QImode))
        return -1;
      return 0;

    case E_V2HImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V2HImode
          || !reg_or_0_operand (operands[2], E_HImode)
          || !register_operand (operands[1], E_V2HImode))
        return -1;
      return 1;

    case E_V2SImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V2SImode
          || !reg_or_0_operand (operands[2], E_SImode)
          || !register_operand (operands[1], E_V2SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern516 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (x1))
    {
    case E_V16QImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V16QImode
          || !reg_or_0_operand (operands[2], E_QImode)
          || !register_operand (operands[1], E_V16QImode))
        return -1;
      return 0;

    case E_V16HImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V16HImode
          || !reg_or_0_operand (operands[2], E_HImode)
          || !register_operand (operands[1], E_V16HImode))
        return -1;
      return 1;

    case E_V16SImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V16SImode
          || !reg_or_0_operand (operands[2], E_SImode)
          || !register_operand (operands[1], E_V16SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern519 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (x1))
    {
    case E_V128QImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V128QImode
          || !reg_or_0_operand (operands[2], E_QImode)
          || !register_operand (operands[1], E_V128QImode))
        return -1;
      return 0;

    case E_V128HImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V128HImode
          || !reg_or_0_operand (operands[2], E_HImode)
          || !register_operand (operands[1], E_V128HImode))
        return -1;
      return 1;

    case E_V128SImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V128SImode
          || !reg_or_0_operand (operands[2], E_SImode)
          || !register_operand (operands[1], E_V128SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern522 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (x1))
    {
    case E_V1024QImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V1024QImode
          || !reg_or_0_operand (operands[2], E_QImode)
          || !register_operand (operands[1], E_V1024QImode))
        return -1;
      return 0;

    case E_V1024HImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V1024HImode
          || !reg_or_0_operand (operands[2], E_HImode)
          || !register_operand (operands[1], E_V1024HImode))
        return -1;
      return 1;

    case E_V1024SImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V1024SImode
          || !reg_or_0_operand (operands[2], E_SImode)
          || !register_operand (operands[1], E_V1024SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern528 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3, machine_mode i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i3
      || !vector_mask_operand (operands[1], i3))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[3], i2))
    return -1;
  x5 = XEXP (x3, 1);
  return pattern527 (x5, 
i1, 
i2, 
i4); /* [-1, 0] */
}

int
pattern531 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x1, 1);
  if (!comparison_except_ltge_operator (x3, i1))
    return -1;
  return 0;
}

int
pattern532 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x1, 1);
  if (!ltge_operator (x3, i1))
    return -1;
  return 0;
}

int
pattern534 (rtx x1, machine_mode i1, int i2, int i3, int i4, int i5)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 0);
  if (GET_MODE (x7) != i1)
    return -1;
  x8 = XEXP (x6, 1);
  if (GET_MODE (x8) != i1)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_MODE (x9) != i1)
    return -1;
  x10 = XEXP (x9, 0);
  if (GET_MODE (x10) != i1)
    return -1;
  x11 = XVECEXP (x1, 0, 2);
  x12 = XEXP (x11, 0);
  if (GET_MODE (x12) != i1)
    return -1;
  switch (REGNO (x7))
    {
    case 19:
      x13 = XEXP (x11, 1);
      if (GET_CODE (x13) != MEM
          || GET_MODE (x13) != i1)
        return -1;
      x14 = XEXP (x13, 0);
      if (GET_CODE (x14) != PLUS
          || GET_MODE (x14) != i1)
        return -1;
      x15 = XEXP (x14, 0);
      if (GET_CODE (x15) != REG
          || REGNO (x15) != 2
          || GET_MODE (x15) != i1)
        return -1;
      x16 = XEXP (x14, 1);
      if (x16 != const_int_rtx[MAX_SAVED_CONST_INT + i5]
          || REGNO (x12) != 18)
        return -1;
      x17 = XVECEXP (x1, 0, 3);
      if (GET_CODE (x17) != SET)
        return -1;
      x18 = XEXP (x17, 1);
      if (GET_CODE (x18) != MEM
          || GET_MODE (x18) != i1)
        return -1;
      x19 = XEXP (x18, 0);
      if (GET_CODE (x19) != PLUS
          || GET_MODE (x19) != i1)
        return -1;
      x20 = XEXP (x19, 0);
      if (GET_CODE (x20) != REG
          || REGNO (x20) != 2
          || GET_MODE (x20) != i1)
        return -1;
      x21 = XEXP (x19, 1);
      if (x21 != const_int_rtx[MAX_SAVED_CONST_INT + i4])
        return -1;
      x22 = XEXP (x17, 0);
      if (GET_CODE (x22) != REG
          || REGNO (x22) != 9
          || GET_MODE (x22) != i1)
        return -1;
      x23 = XVECEXP (x1, 0, 4);
      if (GET_CODE (x23) != SET)
        return -1;
      x24 = XEXP (x23, 1);
      if (GET_CODE (x24) != MEM
          || GET_MODE (x24) != i1)
        return -1;
      x25 = XEXP (x24, 0);
      if (GET_CODE (x25) != PLUS
          || GET_MODE (x25) != i1)
        return -1;
      x26 = XEXP (x25, 0);
      if (GET_CODE (x26) != REG
          || REGNO (x26) != 2
          || GET_MODE (x26) != i1)
        return -1;
      x27 = XEXP (x25, 1);
      if (x27 != const_int_rtx[MAX_SAVED_CONST_INT + i3])
        return -1;
      x28 = XEXP (x23, 0);
      if (GET_CODE (x28) != REG
          || REGNO (x28) != 8
          || GET_MODE (x28) != i1)
        return -1;
      x29 = XVECEXP (x1, 0, 5);
      if (GET_CODE (x29) != SET)
        return -1;
      x30 = XEXP (x29, 1);
      if (GET_CODE (x30) != MEM
          || GET_MODE (x30) != i1)
        return -1;
      x31 = XEXP (x30, 0);
      if (GET_CODE (x31) != PLUS
          || GET_MODE (x31) != i1)
        return -1;
      x32 = XEXP (x31, 0);
      if (GET_CODE (x32) != REG
          || REGNO (x32) != 2
          || GET_MODE (x32) != i1)
        return -1;
      x33 = XEXP (x31, 1);
      if (x33 != const_int_rtx[MAX_SAVED_CONST_INT + i2])
        return -1;
      x34 = XEXP (x29, 0);
      if (GET_CODE (x34) != REG
          || REGNO (x34) != 1
          || GET_MODE (x34) != i1
          || !stack_pop_up_to_s3_operand (operands[0], E_VOIDmode))
        return -1;
      return 0;

    case 9:
      x13 = XEXP (x11, 1);
      if (GET_CODE (x13) != MEM
          || GET_MODE (x13) != i1)
        return -1;
      x14 = XEXP (x13, 0);
      if (GET_CODE (x14) != PLUS
          || GET_MODE (x14) != i1)
        return -1;
      x15 = XEXP (x14, 0);
      if (GET_CODE (x15) != REG
          || REGNO (x15) != 2
          || GET_MODE (x15) != i1)
        return -1;
      x16 = XEXP (x14, 1);
      if (x16 != const_int_rtx[MAX_SAVED_CONST_INT + i5]
          || REGNO (x12) != 8)
        return -1;
      x17 = XVECEXP (x1, 0, 3);
      if (GET_CODE (x17) != SET)
        return -1;
      x18 = XEXP (x17, 1);
      if (GET_CODE (x18) != MEM
          || GET_MODE (x18) != i1)
        return -1;
      x19 = XEXP (x18, 0);
      if (GET_CODE (x19) != PLUS
          || GET_MODE (x19) != i1)
        return -1;
      x20 = XEXP (x19, 0);
      if (GET_CODE (x20) != REG
          || REGNO (x20) != 2
          || GET_MODE (x20) != i1)
        return -1;
      x21 = XEXP (x19, 1);
      if (x21 != const_int_rtx[MAX_SAVED_CONST_INT + i4])
        return -1;
      x22 = XEXP (x17, 0);
      if (GET_CODE (x22) != REG
          || REGNO (x22) != 1
          || GET_MODE (x22) != i1)
        return -1;
      x23 = XVECEXP (x1, 0, 4);
      if (GET_CODE (x23) != RETURN)
        return -1;
      x29 = XVECEXP (x1, 0, 5);
      if (GET_CODE (x29) != USE)
        return -1;
      x34 = XEXP (x29, 0);
      if (GET_CODE (x34) != REG
          || REGNO (x34) != 1
          || GET_MODE (x34) != E_SImode
          || !stack_pop_up_to_s1_operand (operands[0], E_VOIDmode))
        return -1;
      return 1;

    case 1:
      x13 = XEXP (x11, 1);
      if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || REGNO (x12) != 10)
        return -1;
      x17 = XVECEXP (x1, 0, 3);
      if (GET_CODE (x17) != USE)
        return -1;
      x22 = XEXP (x17, 0);
      if (GET_CODE (x22) != REG
          || REGNO (x22) != 10
          || GET_MODE (x22) != i1)
        return -1;
      x23 = XVECEXP (x1, 0, 4);
      if (GET_CODE (x23) != RETURN)
        return -1;
      x29 = XVECEXP (x1, 0, 5);
      if (GET_CODE (x29) != USE)
        return -1;
      x34 = XEXP (x29, 0);
      if (GET_CODE (x34) != REG
          || REGNO (x34) != 1
          || GET_MODE (x34) != E_SImode
          || !stack_pop_up_to_ra_operand (operands[0], E_VOIDmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern541 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i3
      || !vector_mask_operand (operands[1], i3))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i2
      || !register_operand (operands[3], i2)
      || !vector_merge_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern543 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x1, 1);
  if (!signed_order_operator (x3, i1))
    return -1;
  return 0;
}

int
pattern544 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  switch (GET_MODE (x2))
    {
    case E_RVVMF64BImode:
      x3 = XVECEXP (x2, 0, 0);
      if (GET_MODE (x3) != E_RVVMF64BImode
          || !vector_mask_operand (operands[1], E_RVVMF64BImode)
          || !register_operand (operands[2], E_RVVMF64BImode))
        return -1;
      return 0;

    case E_RVVMF32BImode:
      x3 = XVECEXP (x2, 0, 0);
      if (GET_MODE (x3) != E_RVVMF32BImode
          || !vector_mask_operand (operands[1], E_RVVMF32BImode)
          || !register_operand (operands[2], E_RVVMF32BImode))
        return -1;
      return 1;

    case E_RVVMF16BImode:
      x3 = XVECEXP (x2, 0, 0);
      if (GET_MODE (x3) != E_RVVMF16BImode
          || !vector_mask_operand (operands[1], E_RVVMF16BImode)
          || !register_operand (operands[2], E_RVVMF16BImode))
        return -1;
      return 2;

    case E_RVVMF8BImode:
      x3 = XVECEXP (x2, 0, 0);
      if (GET_MODE (x3) != E_RVVMF8BImode
          || !vector_mask_operand (operands[1], E_RVVMF8BImode)
          || !register_operand (operands[2], E_RVVMF8BImode))
        return -1;
      return 3;

    case E_RVVMF4BImode:
      x3 = XVECEXP (x2, 0, 0);
      if (GET_MODE (x3) != E_RVVMF4BImode
          || !vector_mask_operand (operands[1], E_RVVMF4BImode)
          || !register_operand (operands[2], E_RVVMF4BImode))
        return -1;
      return 4;

    case E_RVVMF2BImode:
      x3 = XVECEXP (x2, 0, 0);
      if (GET_MODE (x3) != E_RVVMF2BImode
          || !vector_mask_operand (operands[1], E_RVVMF2BImode)
          || !register_operand (operands[2], E_RVVMF2BImode))
        return -1;
      return 5;

    case E_RVVM1BImode:
      x3 = XVECEXP (x2, 0, 0);
      if (GET_MODE (x3) != E_RVVM1BImode
          || !vector_mask_operand (operands[1], E_RVVM1BImode)
          || !register_operand (operands[2], E_RVVM1BImode))
        return -1;
      return 6;

    case E_V1BImode:
      x3 = XVECEXP (x2, 0, 0);
      if (GET_MODE (x3) != E_V1BImode
          || !vector_mask_operand (operands[1], E_V1BImode)
          || !register_operand (operands[2], E_V1BImode))
        return -1;
      return 7;

    case E_V2BImode:
      x3 = XVECEXP (x2, 0, 0);
      if (GET_MODE (x3) != E_V2BImode
          || !vector_mask_operand (operands[1], E_V2BImode)
          || !register_operand (operands[2], E_V2BImode))
        return -1;
      return 8;

    case E_V4BImode:
      x3 = XVECEXP (x2, 0, 0);
      if (GET_MODE (x3) != E_V4BImode
          || !vector_mask_operand (operands[1], E_V4BImode)
          || !register_operand (operands[2], E_V4BImode))
        return -1;
      return 9;

    case E_V8BImode:
      x3 = XVECEXP (x2, 0, 0);
      if (GET_MODE (x3) != E_V8BImode
          || !vector_mask_operand (operands[1], E_V8BImode)
          || !register_operand (operands[2], E_V8BImode))
        return -1;
      return 10;

    case E_V16BImode:
      x3 = XVECEXP (x2, 0, 0);
      if (GET_MODE (x3) != E_V16BImode
          || !vector_mask_operand (operands[1], E_V16BImode)
          || !register_operand (operands[2], E_V16BImode))
        return -1;
      return 11;

    case E_V32BImode:
      x3 = XVECEXP (x2, 0, 0);
      if (GET_MODE (x3) != E_V32BImode
          || !vector_mask_operand (operands[1], E_V32BImode)
          || !register_operand (operands[2], E_V32BImode))
        return -1;
      return 12;

    case E_V64BImode:
      x3 = XVECEXP (x2, 0, 0);
      if (GET_MODE (x3) != E_V64BImode
          || !vector_mask_operand (operands[1], E_V64BImode)
          || !register_operand (operands[2], E_V64BImode))
        return -1;
      return 13;

    case E_V128BImode:
      x3 = XVECEXP (x2, 0, 0);
      if (GET_MODE (x3) != E_V128BImode
          || !vector_mask_operand (operands[1], E_V128BImode)
          || !register_operand (operands[2], E_V128BImode))
        return -1;
      return 14;

    case E_V256BImode:
      x3 = XVECEXP (x2, 0, 0);
      if (GET_MODE (x3) != E_V256BImode
          || !vector_mask_operand (operands[1], E_V256BImode)
          || !register_operand (operands[2], E_V256BImode))
        return -1;
      return 15;

    case E_V512BImode:
      x3 = XVECEXP (x2, 0, 0);
      if (GET_MODE (x3) != E_V512BImode
          || !vector_mask_operand (operands[1], E_V512BImode)
          || !register_operand (operands[2], E_V512BImode))
        return -1;
      return 16;

    case E_V1024BImode:
      x3 = XVECEXP (x2, 0, 0);
      if (GET_MODE (x3) != E_V1024BImode
          || !vector_mask_operand (operands[1], E_V1024BImode)
          || !register_operand (operands[2], E_V1024BImode))
        return -1;
      return 17;

    case E_V2048BImode:
      x3 = XVECEXP (x2, 0, 0);
      if (GET_MODE (x3) != E_V2048BImode
          || !vector_mask_operand (operands[1], E_V2048BImode)
          || !register_operand (operands[2], E_V2048BImode))
        return -1;
      return 18;

    case E_V4096BImode:
      x3 = XVECEXP (x2, 0, 0);
      if (GET_MODE (x3) != E_V4096BImode
          || !vector_mask_operand (operands[1], E_V4096BImode)
          || !register_operand (operands[2], E_V4096BImode))
        return -1;
      return 19;

    default:
      return -1;
    }
}

int
pattern556 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  operands[5] = x3;
  x4 = XVECEXP (x2, 0, 2);
  operands[6] = x4;
  x5 = XVECEXP (x2, 0, 3);
  operands[7] = x5;
  x6 = XVECEXP (x2, 0, 4);
  operands[8] = x6;
  x7 = XEXP (x1, 1);
  x8 = XVECEXP (x7, 0, 0);
  operands[3] = x8;
  x9 = XVECEXP (x7, 0, 1);
  switch (GET_CODE (x9))
    {
    case REG:
    case SUBREG:
      return pattern554 (x1); /* [-1, 47] */

    case VEC_DUPLICATE:
      x10 = XEXP (x9, 0);
      operands[4] = x10;
      switch (GET_MODE (operands[0]))
        {
        case E_RVVM8HFmode:
          if (pattern555 (x1, 
E_RVVM8HFmode, 
E_RVVMF2BImode, 
E_HFmode) != 0)
            return -1;
          return 48;

        case E_RVVM4HFmode:
          if (pattern555 (x1, 
E_RVVM4HFmode, 
E_RVVMF4BImode, 
E_HFmode) != 0)
            return -1;
          return 49;

        case E_RVVM2HFmode:
          if (pattern555 (x1, 
E_RVVM2HFmode, 
E_RVVMF8BImode, 
E_HFmode) != 0)
            return -1;
          return 50;

        case E_RVVM1HFmode:
          if (pattern555 (x1, 
E_RVVM1HFmode, 
E_RVVMF16BImode, 
E_HFmode) != 0)
            return -1;
          return 51;

        case E_RVVMF2HFmode:
          if (pattern555 (x1, 
E_RVVMF2HFmode, 
E_RVVMF32BImode, 
E_HFmode) != 0)
            return -1;
          return 52;

        case E_RVVMF4HFmode:
          if (pattern555 (x1, 
E_RVVMF4HFmode, 
E_RVVMF64BImode, 
E_HFmode) != 0)
            return -1;
          return 53;

        case E_RVVM8SFmode:
          if (pattern555 (x1, 
E_RVVM8SFmode, 
E_RVVMF4BImode, 
E_SFmode) != 0)
            return -1;
          return 54;

        case E_RVVM4SFmode:
          if (pattern555 (x1, 
E_RVVM4SFmode, 
E_RVVMF8BImode, 
E_SFmode) != 0)
            return -1;
          return 55;

        case E_RVVM2SFmode:
          if (pattern555 (x1, 
E_RVVM2SFmode, 
E_RVVMF16BImode, 
E_SFmode) != 0)
            return -1;
          return 56;

        case E_RVVM1SFmode:
          if (pattern555 (x1, 
E_RVVM1SFmode, 
E_RVVMF32BImode, 
E_SFmode) != 0)
            return -1;
          return 57;

        case E_RVVMF2SFmode:
          if (pattern555 (x1, 
E_RVVMF2SFmode, 
E_RVVMF64BImode, 
E_SFmode) != 0)
            return -1;
          return 58;

        case E_RVVM8DFmode:
          if (pattern555 (x1, 
E_RVVM8DFmode, 
E_RVVMF8BImode, 
E_DFmode) != 0)
            return -1;
          return 59;

        case E_RVVM4DFmode:
          if (pattern555 (x1, 
E_RVVM4DFmode, 
E_RVVMF16BImode, 
E_DFmode) != 0)
            return -1;
          return 60;

        case E_RVVM2DFmode:
          if (pattern555 (x1, 
E_RVVM2DFmode, 
E_RVVMF32BImode, 
E_DFmode) != 0)
            return -1;
          return 61;

        case E_RVVM1DFmode:
          if (pattern555 (x1, 
E_RVVM1DFmode, 
E_RVVMF64BImode, 
E_DFmode) != 0)
            return -1;
          return 62;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern564 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 0)
    return -1;
  x5 = XEXP (x1, 0);
  x6 = XVECEXP (x5, 0, 1);
  operands[4] = x6;
  x7 = XVECEXP (x5, 0, 2);
  operands[5] = x7;
  x8 = XVECEXP (x5, 0, 3);
  operands[6] = x8;
  x9 = XVECEXP (x5, 0, 4);
  operands[7] = x9;
  x10 = XEXP (x2, 0);
  x11 = XEXP (x10, 0);
  operands[3] = x11;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8HImode:
      return pattern563 (x1, 
E_RVVM8HImode, 
E_RVVM4QImode, 
E_RVVMF2BImode, 
E_HImode); /* [-1, 0] */

    case E_RVVM4HImode:
      if (pattern563 (x1, 
E_RVVM4HImode, 
E_RVVM2QImode, 
E_RVVMF4BImode, 
E_HImode) != 0)
        return -1;
      return 1;

    case E_RVVM2HImode:
      if (pattern563 (x1, 
E_RVVM2HImode, 
E_RVVM1QImode, 
E_RVVMF8BImode, 
E_HImode) != 0)
        return -1;
      return 2;

    case E_RVVM1HImode:
      if (pattern563 (x1, 
E_RVVM1HImode, 
E_RVVMF2QImode, 
E_RVVMF16BImode, 
E_HImode) != 0)
        return -1;
      return 3;

    case E_RVVMF2HImode:
      if (pattern563 (x1, 
E_RVVMF2HImode, 
E_RVVMF4QImode, 
E_RVVMF32BImode, 
E_HImode) != 0)
        return -1;
      return 4;

    case E_RVVMF4HImode:
      if (pattern563 (x1, 
E_RVVMF4HImode, 
E_RVVMF8QImode, 
E_RVVMF64BImode, 
E_HImode) != 0)
        return -1;
      return 5;

    case E_RVVM8SImode:
      if (pattern563 (x1, 
E_RVVM8SImode, 
E_RVVM4HImode, 
E_RVVMF4BImode, 
E_SImode) != 0)
        return -1;
      return 6;

    case E_RVVM4SImode:
      if (pattern563 (x1, 
E_RVVM4SImode, 
E_RVVM2HImode, 
E_RVVMF8BImode, 
E_SImode) != 0)
        return -1;
      return 7;

    case E_RVVM2SImode:
      if (pattern563 (x1, 
E_RVVM2SImode, 
E_RVVM1HImode, 
E_RVVMF16BImode, 
E_SImode) != 0)
        return -1;
      return 8;

    case E_RVVM1SImode:
      if (pattern563 (x1, 
E_RVVM1SImode, 
E_RVVMF2HImode, 
E_RVVMF32BImode, 
E_SImode) != 0)
        return -1;
      return 9;

    case E_RVVMF2SImode:
      if (pattern563 (x1, 
E_RVVMF2SImode, 
E_RVVMF4HImode, 
E_RVVMF64BImode, 
E_SImode) != 0)
        return -1;
      return 10;

    case E_RVVM8DImode:
      if (pattern563 (x1, 
E_RVVM8DImode, 
E_RVVM4SImode, 
E_RVVMF8BImode, 
E_DImode) != 0)
        return -1;
      return 11;

    case E_RVVM4DImode:
      if (pattern563 (x1, 
E_RVVM4DImode, 
E_RVVM2SImode, 
E_RVVMF16BImode, 
E_DImode) != 0)
        return -1;
      return 12;

    case E_RVVM2DImode:
      if (pattern563 (x1, 
E_RVVM2DImode, 
E_RVVM1SImode, 
E_RVVMF32BImode, 
E_DImode) != 0)
        return -1;
      return 13;

    case E_RVVM1DImode:
      if (pattern563 (x1, 
E_RVVM1DImode, 
E_RVVMF2SImode, 
E_RVVMF64BImode, 
E_DImode) != 0)
        return -1;
      return 14;

    case E_V1HImode:
      if (pattern563 (x1, 
E_V1HImode, 
E_V1QImode, 
E_V1BImode, 
E_HImode) != 0)
        return -1;
      return 15;

    case E_V2HImode:
      if (pattern563 (x1, 
E_V2HImode, 
E_V2QImode, 
E_V2BImode, 
E_HImode) != 0)
        return -1;
      return 16;

    case E_V4HImode:
      if (pattern563 (x1, 
E_V4HImode, 
E_V4QImode, 
E_V4BImode, 
E_HImode) != 0)
        return -1;
      return 17;

    case E_V8HImode:
      if (pattern563 (x1, 
E_V8HImode, 
E_V8QImode, 
E_V8BImode, 
E_HImode) != 0)
        return -1;
      return 18;

    case E_V16HImode:
      if (pattern563 (x1, 
E_V16HImode, 
E_V16QImode, 
E_V16BImode, 
E_HImode) != 0)
        return -1;
      return 19;

    case E_V32HImode:
      if (pattern563 (x1, 
E_V32HImode, 
E_V32QImode, 
E_V32BImode, 
E_HImode) != 0)
        return -1;
      return 20;

    case E_V64HImode:
      if (pattern563 (x1, 
E_V64HImode, 
E_V64QImode, 
E_V64BImode, 
E_HImode) != 0)
        return -1;
      return 21;

    case E_V128HImode:
      if (pattern563 (x1, 
E_V128HImode, 
E_V128QImode, 
E_V128BImode, 
E_HImode) != 0)
        return -1;
      return 22;

    case E_V256HImode:
      if (pattern563 (x1, 
E_V256HImode, 
E_V256QImode, 
E_V256BImode, 
E_HImode) != 0)
        return -1;
      return 23;

    case E_V512HImode:
      if (pattern563 (x1, 
E_V512HImode, 
E_V512QImode, 
E_V512BImode, 
E_HImode) != 0)
        return -1;
      return 24;

    case E_V1024HImode:
      if (pattern563 (x1, 
E_V1024HImode, 
E_V1024QImode, 
E_V1024BImode, 
E_HImode) != 0)
        return -1;
      return 25;

    case E_V2048HImode:
      if (pattern563 (x1, 
E_V2048HImode, 
E_V2048QImode, 
E_V2048BImode, 
E_HImode) != 0)
        return -1;
      return 26;

    case E_V1SImode:
      if (pattern563 (x1, 
E_V1SImode, 
E_V1HImode, 
E_V1BImode, 
E_SImode) != 0)
        return -1;
      return 27;

    case E_V2SImode:
      if (pattern563 (x1, 
E_V2SImode, 
E_V2HImode, 
E_V2BImode, 
E_SImode) != 0)
        return -1;
      return 28;

    case E_V4SImode:
      if (pattern563 (x1, 
E_V4SImode, 
E_V4HImode, 
E_V4BImode, 
E_SImode) != 0)
        return -1;
      return 29;

    case E_V8SImode:
      if (pattern563 (x1, 
E_V8SImode, 
E_V8HImode, 
E_V8BImode, 
E_SImode) != 0)
        return -1;
      return 30;

    case E_V16SImode:
      if (pattern563 (x1, 
E_V16SImode, 
E_V16HImode, 
E_V16BImode, 
E_SImode) != 0)
        return -1;
      return 31;

    case E_V32SImode:
      if (pattern563 (x1, 
E_V32SImode, 
E_V32HImode, 
E_V32BImode, 
E_SImode) != 0)
        return -1;
      return 32;

    case E_V64SImode:
      if (pattern563 (x1, 
E_V64SImode, 
E_V64HImode, 
E_V64BImode, 
E_SImode) != 0)
        return -1;
      return 33;

    case E_V128SImode:
      if (pattern563 (x1, 
E_V128SImode, 
E_V128HImode, 
E_V128BImode, 
E_SImode) != 0)
        return -1;
      return 34;

    case E_V256SImode:
      if (pattern563 (x1, 
E_V256SImode, 
E_V256HImode, 
E_V256BImode, 
E_SImode) != 0)
        return -1;
      return 35;

    case E_V512SImode:
      if (pattern563 (x1, 
E_V512SImode, 
E_V512HImode, 
E_V512BImode, 
E_SImode) != 0)
        return -1;
      return 36;

    case E_V1024SImode:
      if (pattern563 (x1, 
E_V1024SImode, 
E_V1024HImode, 
E_V1024BImode, 
E_SImode) != 0)
        return -1;
      return 37;

    case E_V1DImode:
      if (pattern563 (x1, 
E_V1DImode, 
E_V1SImode, 
E_V1BImode, 
E_DImode) != 0)
        return -1;
      return 38;

    case E_V2DImode:
      if (pattern563 (x1, 
E_V2DImode, 
E_V2SImode, 
E_V2BImode, 
E_DImode) != 0)
        return -1;
      return 39;

    case E_V4DImode:
      if (pattern563 (x1, 
E_V4DImode, 
E_V4SImode, 
E_V4BImode, 
E_DImode) != 0)
        return -1;
      return 40;

    case E_V8DImode:
      if (pattern563 (x1, 
E_V8DImode, 
E_V8SImode, 
E_V8BImode, 
E_DImode) != 0)
        return -1;
      return 41;

    case E_V16DImode:
      if (pattern563 (x1, 
E_V16DImode, 
E_V16SImode, 
E_V16BImode, 
E_DImode) != 0)
        return -1;
      return 42;

    case E_V32DImode:
      if (pattern563 (x1, 
E_V32DImode, 
E_V32SImode, 
E_V32BImode, 
E_DImode) != 0)
        return -1;
      return 43;

    case E_V64DImode:
      if (pattern563 (x1, 
E_V64DImode, 
E_V64SImode, 
E_V64BImode, 
E_DImode) != 0)
        return -1;
      return 44;

    case E_V128DImode:
      if (pattern563 (x1, 
E_V128DImode, 
E_V128SImode, 
E_V128BImode, 
E_DImode) != 0)
        return -1;
      return 45;

    case E_V256DImode:
      if (pattern563 (x1, 
E_V256DImode, 
E_V256SImode, 
E_V256BImode, 
E_DImode) != 0)
        return -1;
      return 46;

    case E_V512DImode:
      if (pattern563 (x1, 
E_V512DImode, 
E_V512SImode, 
E_V512BImode, 
E_DImode) != 0)
        return -1;
      return 47;

    default:
      return -1;
    }
}

int
pattern588 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], i2))
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  operands[5] = x3;
  x4 = XVECEXP (x2, 0, 2);
  operands[6] = x4;
  x5 = XVECEXP (x2, 0, 3);
  operands[7] = x5;
  x6 = XEXP (x1, 1);
  x7 = XEXP (x6, 0);
  operands[3] = x7;
  if (!register_operand (operands[3], i1))
    return -1;
  x8 = XEXP (x6, 1);
  operands[4] = x8;
  if (!vector_neg_arith_operand (operands[4], i1))
    return -1;
  x9 = XEXP (x1, 2);
  if (!rtx_equal_p (x9, operands[1]))
    return -1;
  return 0;
}

int
pattern591 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[2], E_QImode)
      || !register_operand (operands[1], i2)
      || !register_operand (operands[3], i1))
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (GET_MODE (x4) != i1)
    return -1;
  return 0;
}

int
pattern595 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!const_int_operand (operands[3], E_VOIDmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8SImode:
      return pattern475 (x1, 
E_RVVM8SImode, 
E_RVVMF4BImode); /* [-1, 0] */

    case E_RVVM4SImode:
      if (pattern475 (x1, 
E_RVVM4SImode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 1;

    case E_RVVM2SImode:
      if (pattern475 (x1, 
E_RVVM2SImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 2;

    case E_RVVM1SImode:
      if (pattern475 (x1, 
E_RVVM1SImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 3;

    case E_RVVMF2SImode:
      if (pattern475 (x1, 
E_RVVMF2SImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 4;

    default:
      return -1;
    }
}

int
pattern602 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  if (!vector_mask_operand (operands[1], i1))
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  operands[6] = x3;
  x4 = XVECEXP (x2, 0, 2);
  operands[7] = x4;
  x5 = XVECEXP (x2, 0, 3);
  operands[8] = x5;
  x6 = XEXP (x1, 1);
  x7 = XEXP (x6, 0);
  operands[4] = x7;
  if (!register_operand (operands[4], i2))
    return -1;
  x8 = XEXP (x6, 1);
  operands[5] = x8;
  if (!register_operand (operands[5], i2))
    return -1;
  x9 = XEXP (x1, 2);
  operands[2] = x9;
  if (!vector_merge_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern604 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  if (!vector_mask_operand (operands[1], E_RVVMF4BImode))
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  operands[6] = x3;
  x4 = XVECEXP (x2, 0, 2);
  operands[7] = x4;
  x5 = XVECEXP (x2, 0, 3);
  operands[8] = x5;
  x6 = XEXP (x1, 1);
  x7 = XEXP (x6, 0);
  operands[4] = x7;
  x8 = XEXP (x6, 1);
  operands[5] = x8;
  x9 = XEXP (x1, 2);
  operands[2] = x9;
  if (!vector_merge_operand (operands[2], E_RVVMF4BImode))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_RVVM4HFmode:
      if (!register_operand (operands[4], E_RVVM4HFmode)
          || !register_operand (operands[5], E_RVVM4HFmode))
        return -1;
      return 0;

    case E_RVVM8SFmode:
      if (!register_operand (operands[4], E_RVVM8SFmode)
          || !register_operand (operands[5], E_RVVM8SFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern606 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  if (!vector_mask_operand (operands[1], E_RVVMF16BImode))
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  operands[6] = x3;
  x4 = XVECEXP (x2, 0, 2);
  operands[7] = x4;
  x5 = XVECEXP (x2, 0, 3);
  operands[8] = x5;
  x6 = XEXP (x1, 1);
  x7 = XEXP (x6, 0);
  operands[4] = x7;
  x8 = XEXP (x6, 1);
  operands[5] = x8;
  x9 = XEXP (x1, 2);
  operands[2] = x9;
  if (!vector_merge_operand (operands[2], E_RVVMF16BImode))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_RVVM1HFmode:
      if (!register_operand (operands[4], E_RVVM1HFmode)
          || !register_operand (operands[5], E_RVVM1HFmode))
        return -1;
      return 0;

    case E_RVVM2SFmode:
      if (!register_operand (operands[4], E_RVVM2SFmode)
          || !register_operand (operands[5], E_RVVM2SFmode))
        return -1;
      return 1;

    case E_RVVM4DFmode:
      if (!register_operand (operands[4], E_RVVM4DFmode)
          || !register_operand (operands[5], E_RVVM4DFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern609 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  if (!vector_mask_operand (operands[1], E_V1BImode))
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  operands[6] = x3;
  x4 = XVECEXP (x2, 0, 2);
  operands[7] = x4;
  x5 = XVECEXP (x2, 0, 3);
  operands[8] = x5;
  x6 = XEXP (x1, 1);
  x7 = XEXP (x6, 0);
  operands[4] = x7;
  x8 = XEXP (x6, 1);
  operands[5] = x8;
  x9 = XEXP (x1, 2);
  operands[2] = x9;
  if (!vector_merge_operand (operands[2], E_V1BImode))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_V1HFmode:
      if (!register_operand (operands[4], E_V1HFmode)
          || !register_operand (operands[5], E_V1HFmode))
        return -1;
      return 0;

    case E_V1SFmode:
      if (!register_operand (operands[4], E_V1SFmode)
          || !register_operand (operands[5], E_V1SFmode))
        return -1;
      return 1;

    case E_V1DFmode:
      if (!register_operand (operands[4], E_V1DFmode)
          || !register_operand (operands[5], E_V1DFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern612 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  if (!vector_mask_operand (operands[1], E_V8BImode))
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  operands[6] = x3;
  x4 = XVECEXP (x2, 0, 2);
  operands[7] = x4;
  x5 = XVECEXP (x2, 0, 3);
  operands[8] = x5;
  x6 = XEXP (x1, 1);
  x7 = XEXP (x6, 0);
  operands[4] = x7;
  x8 = XEXP (x6, 1);
  operands[5] = x8;
  x9 = XEXP (x1, 2);
  operands[2] = x9;
  if (!vector_merge_operand (operands[2], E_V8BImode))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_V8HFmode:
      if (!register_operand (operands[4], E_V8HFmode)
          || !register_operand (operands[5], E_V8HFmode))
        return -1;
      return 0;

    case E_V8SFmode:
      if (!register_operand (operands[4], E_V8SFmode)
          || !register_operand (operands[5], E_V8SFmode))
        return -1;
      return 1;

    case E_V8DFmode:
      if (!register_operand (operands[4], E_V8DFmode)
          || !register_operand (operands[5], E_V8DFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern615 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  if (!vector_mask_operand (operands[1], E_V64BImode))
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  operands[6] = x3;
  x4 = XVECEXP (x2, 0, 2);
  operands[7] = x4;
  x5 = XVECEXP (x2, 0, 3);
  operands[8] = x5;
  x6 = XEXP (x1, 1);
  x7 = XEXP (x6, 0);
  operands[4] = x7;
  x8 = XEXP (x6, 1);
  operands[5] = x8;
  x9 = XEXP (x1, 2);
  operands[2] = x9;
  if (!vector_merge_operand (operands[2], E_V64BImode))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_V64HFmode:
      if (!register_operand (operands[4], E_V64HFmode)
          || !register_operand (operands[5], E_V64HFmode))
        return -1;
      return 0;

    case E_V64SFmode:
      if (!register_operand (operands[4], E_V64SFmode)
          || !register_operand (operands[5], E_V64SFmode))
        return -1;
      return 1;

    case E_V64DFmode:
      if (!register_operand (operands[4], E_V64DFmode)
          || !register_operand (operands[5], E_V64DFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern619 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  if (!vector_mask_operand (operands[1], E_V1024BImode))
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  operands[6] = x3;
  x4 = XVECEXP (x2, 0, 2);
  operands[7] = x4;
  x5 = XVECEXP (x2, 0, 3);
  operands[8] = x5;
  x6 = XEXP (x1, 1);
  x7 = XEXP (x6, 0);
  operands[4] = x7;
  x8 = XEXP (x6, 1);
  operands[5] = x8;
  x9 = XEXP (x1, 2);
  operands[2] = x9;
  if (!vector_merge_operand (operands[2], E_V1024BImode))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_V1024HFmode:
      if (!register_operand (operands[4], E_V1024HFmode)
          || !register_operand (operands[5], E_V1024HFmode))
        return -1;
      return 0;

    case E_V1024SFmode:
      if (!register_operand (operands[4], E_V1024SFmode)
          || !register_operand (operands[5], E_V1024SFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern623 (rtx x1, machine_mode i1, int i2, int i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 0);
  if (GET_MODE (x7) != i1)
    return -1;
  x8 = XEXP (x6, 1);
  if (GET_MODE (x8) != i1)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_MODE (x9) != i1)
    return -1;
  x10 = XEXP (x9, 0);
  if (GET_MODE (x10) != i1)
    return -1;
  x11 = XVECEXP (x1, 0, 2);
  x12 = XEXP (x11, 0);
  if (GET_MODE (x12) != i1)
    return -1;
  x13 = XEXP (x11, 1);
  if (GET_MODE (x13) != i1)
    return -1;
  x14 = XEXP (x13, 0);
  if (GET_MODE (x14) != i1)
    return -1;
  x15 = XEXP (x14, 0);
  if (GET_MODE (x15) != i1)
    return -1;
  switch (REGNO (x7))
    {
    case 18:
      if (REGNO (x12) != 9)
        return -1;
      x16 = XVECEXP (x1, 0, 3);
      if (GET_CODE (x16) != SET)
        return -1;
      x17 = XEXP (x16, 1);
      if (GET_CODE (x17) != MEM
          || GET_MODE (x17) != i1)
        return -1;
      x18 = XEXP (x17, 0);
      if (GET_CODE (x18) != PLUS
          || GET_MODE (x18) != i1)
        return -1;
      x19 = XEXP (x18, 0);
      if (GET_CODE (x19) != REG
          || REGNO (x19) != 2
          || GET_MODE (x19) != i1)
        return -1;
      x20 = XEXP (x18, 1);
      if (x20 != const_int_rtx[MAX_SAVED_CONST_INT + i3])
        return -1;
      x21 = XEXP (x16, 0);
      if (GET_CODE (x21) != REG
          || REGNO (x21) != 8
          || GET_MODE (x21) != i1)
        return -1;
      x22 = XVECEXP (x1, 0, 4);
      if (GET_CODE (x22) != SET)
        return -1;
      x23 = XEXP (x22, 1);
      if (GET_CODE (x23) != MEM
          || GET_MODE (x23) != i1)
        return -1;
      x24 = XEXP (x23, 0);
      if (GET_CODE (x24) != PLUS
          || GET_MODE (x24) != i1)
        return -1;
      x25 = XEXP (x24, 0);
      if (GET_CODE (x25) != REG
          || REGNO (x25) != 2
          || GET_MODE (x25) != i1)
        return -1;
      x26 = XEXP (x24, 1);
      if (x26 != const_int_rtx[MAX_SAVED_CONST_INT + i2])
        return -1;
      x27 = XEXP (x22, 0);
      if (GET_CODE (x27) != REG
          || REGNO (x27) != 1
          || GET_MODE (x27) != i1
          || !stack_pop_up_to_s2_operand (operands[0], E_VOIDmode))
        return -1;
      return 0;

    case 8:
      if (REGNO (x12) != 1)
        return -1;
      x16 = XVECEXP (x1, 0, 3);
      if (GET_CODE (x16) != RETURN)
        return -1;
      x22 = XVECEXP (x1, 0, 4);
      if (GET_CODE (x22) != USE)
        return -1;
      x27 = XEXP (x22, 0);
      if (GET_CODE (x27) != REG
          || REGNO (x27) != 1
          || GET_MODE (x27) != E_SImode
          || !stack_pop_up_to_s0_operand (operands[0], E_VOIDmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern644 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_RVVMF8BImode
      || !vector_mask_operand (operands[1], E_RVVMF8BImode))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !vector_merge_operand (operands[2], i1))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_RVVM1QImode:
      if (!register_operand (operands[4], E_RVVM1QImode))
        return -1;
      return 0;

    case E_RVVM2HImode:
      if (!register_operand (operands[4], E_RVVM2HImode))
        return -1;
      return 1;

    case E_RVVM4SImode:
      if (!register_operand (operands[4], E_RVVM4SImode))
        return -1;
      return 2;

    case E_RVVM8DImode:
      if (!register_operand (operands[4], E_RVVM8DImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern650 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_RVVMF8BImode
      || !vector_mask_operand (operands[1], E_RVVMF8BImode))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !vector_merge_operand (operands[2], i1))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_RVVM2HImode:
      if (!register_operand (operands[4], E_RVVM2HImode))
        return -1;
      return 0;

    case E_RVVM1QImode:
      if (!register_operand (operands[4], E_RVVM1QImode))
        return -1;
      return 1;

    case E_RVVM4SImode:
      if (!register_operand (operands[4], E_RVVM4SImode))
        return -1;
      return 2;

    case E_RVVM8DImode:
      if (!register_operand (operands[4], E_RVVM8DImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern656 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_RVVMF16BImode
      || !vector_mask_operand (operands[1], E_RVVMF16BImode))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !vector_merge_operand (operands[2], i1))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_RVVM2SImode:
      if (!register_operand (operands[4], E_RVVM2SImode))
        return -1;
      return 0;

    case E_RVVM1HImode:
      if (!register_operand (operands[4], E_RVVM1HImode))
        return -1;
      return 1;

    case E_RVVMF2QImode:
      if (!register_operand (operands[4], E_RVVMF2QImode))
        return -1;
      return 2;

    case E_RVVM4DImode:
      if (!register_operand (operands[4], E_RVVM4DImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern662 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_RVVMF64BImode
      || !vector_mask_operand (operands[1], E_RVVMF64BImode))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !vector_merge_operand (operands[2], i1))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_RVVM1DImode:
      if (!register_operand (operands[4], E_RVVM1DImode))
        return -1;
      return 0;

    case E_RVVMF2SImode:
      if (!register_operand (operands[4], E_RVVMF2SImode))
        return -1;
      return 1;

    case E_RVVMF4HImode:
      if (!register_operand (operands[4], E_RVVMF4HImode))
        return -1;
      return 2;

    case E_RVVMF8QImode:
      if (!register_operand (operands[4], E_RVVMF8QImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern673 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[4], i1)
      || !vector_merge_operand (operands[2], i1))
    return -1;
  x3 = XVECEXP (x1, 0, 0);
  switch (GET_MODE (x3))
    {
    case E_RVVMF2BImode:
      if (!vector_mask_operand (operands[1], E_RVVMF2BImode)
          || !register_operand (operands[3], E_RVVM8HImode))
        return -1;
      return 0;

    case E_RVVMF4BImode:
      if (!vector_mask_operand (operands[1], E_RVVMF4BImode)
          || !register_operand (operands[3], E_RVVM4HImode))
        return -1;
      return 1;

    case E_RVVMF8BImode:
      if (!vector_mask_operand (operands[1], E_RVVMF8BImode)
          || !register_operand (operands[3], E_RVVM2HImode))
        return -1;
      return 2;

    case E_RVVMF16BImode:
      if (!vector_mask_operand (operands[1], E_RVVMF16BImode)
          || !register_operand (operands[3], E_RVVM1HImode))
        return -1;
      return 3;

    case E_RVVMF32BImode:
      if (!vector_mask_operand (operands[1], E_RVVMF32BImode)
          || !register_operand (operands[3], E_RVVMF2HImode))
        return -1;
      return 4;

    case E_RVVMF64BImode:
      if (!vector_mask_operand (operands[1], E_RVVMF64BImode)
          || !register_operand (operands[3], E_RVVMF4HImode))
        return -1;
      return 5;

    case E_V1BImode:
      if (!vector_mask_operand (operands[1], E_V1BImode)
          || !register_operand (operands[3], E_V1HImode))
        return -1;
      return 6;

    case E_V2BImode:
      if (!vector_mask_operand (operands[1], E_V2BImode)
          || !register_operand (operands[3], E_V2HImode))
        return -1;
      return 7;

    case E_V4BImode:
      if (!vector_mask_operand (operands[1], E_V4BImode)
          || !register_operand (operands[3], E_V4HImode))
        return -1;
      return 8;

    case E_V8BImode:
      if (!vector_mask_operand (operands[1], E_V8BImode)
          || !register_operand (operands[3], E_V8HImode))
        return -1;
      return 9;

    case E_V16BImode:
      if (!vector_mask_operand (operands[1], E_V16BImode)
          || !register_operand (operands[3], E_V16HImode))
        return -1;
      return 10;

    case E_V32BImode:
      if (!vector_mask_operand (operands[1], E_V32BImode)
          || !register_operand (operands[3], E_V32HImode))
        return -1;
      return 11;

    case E_V64BImode:
      if (!vector_mask_operand (operands[1], E_V64BImode)
          || !register_operand (operands[3], E_V64HImode))
        return -1;
      return 12;

    case E_V128BImode:
      if (!vector_mask_operand (operands[1], E_V128BImode)
          || !register_operand (operands[3], E_V128HImode))
        return -1;
      return 13;

    case E_V256BImode:
      if (!vector_mask_operand (operands[1], E_V256BImode)
          || !register_operand (operands[3], E_V256HImode))
        return -1;
      return 14;

    case E_V512BImode:
      if (!vector_mask_operand (operands[1], E_V512BImode)
          || !register_operand (operands[3], E_V512HImode))
        return -1;
      return 15;

    case E_V1024BImode:
      if (!vector_mask_operand (operands[1], E_V1024BImode)
          || !register_operand (operands[3], E_V1024HImode))
        return -1;
      return 16;

    case E_V2048BImode:
      if (!vector_mask_operand (operands[1], E_V2048BImode)
          || !register_operand (operands[3], E_V2048HImode))
        return -1;
      return 17;

    default:
      return -1;
    }
}

int
pattern681 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1)
      || !register_operand (operands[4], i2)
      || !vector_merge_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern688 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], i2))
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  operands[5] = x3;
  x4 = XVECEXP (x2, 0, 2);
  operands[6] = x4;
  x5 = XVECEXP (x2, 0, 3);
  operands[7] = x5;
  x6 = XEXP (x1, 1);
  x7 = XEXP (x6, 0);
  operands[3] = x7;
  if (!register_operand (operands[3], i1))
    return -1;
  x8 = XEXP (x6, 1);
  if (GET_MODE (x8) != i1)
    return -1;
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 0);
  operands[4] = x10;
  x11 = XEXP (x1, 2);
  if (!rtx_equal_p (x11, operands[1]))
    return -1;
  return 0;
}

int
pattern695 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!pmode_reg_or_0_operand (operands[3], E_VOIDmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVMF8x2QImode:
      return pattern601 (x1, 
E_RVVMF8x2QImode, 
E_RVVMF64BImode); /* [-1, 0] */

    case E_RVVMF8x3QImode:
      if (pattern601 (x1, 
E_RVVMF8x3QImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 1;

    case E_RVVMF8x4QImode:
      if (pattern601 (x1, 
E_RVVMF8x4QImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 2;

    case E_RVVMF8x5QImode:
      if (pattern601 (x1, 
E_RVVMF8x5QImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 3;

    case E_RVVMF8x6QImode:
      if (pattern601 (x1, 
E_RVVMF8x6QImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 4;

    case E_RVVMF8x7QImode:
      if (pattern601 (x1, 
E_RVVMF8x7QImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 5;

    case E_RVVMF8x8QImode:
      if (pattern601 (x1, 
E_RVVMF8x8QImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 6;

    case E_RVVMF4x2HImode:
      if (pattern601 (x1, 
E_RVVMF4x2HImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 7;

    case E_RVVMF4x3HImode:
      if (pattern601 (x1, 
E_RVVMF4x3HImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 8;

    case E_RVVMF4x4HImode:
      if (pattern601 (x1, 
E_RVVMF4x4HImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 9;

    case E_RVVMF4x5HImode:
      if (pattern601 (x1, 
E_RVVMF4x5HImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 10;

    case E_RVVMF4x6HImode:
      if (pattern601 (x1, 
E_RVVMF4x6HImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 11;

    case E_RVVMF4x7HImode:
      if (pattern601 (x1, 
E_RVVMF4x7HImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 12;

    case E_RVVMF4x8HImode:
      if (pattern601 (x1, 
E_RVVMF4x8HImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 13;

    case E_RVVMF2x2SImode:
      if (pattern601 (x1, 
E_RVVMF2x2SImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 14;

    case E_RVVMF2x3SImode:
      if (pattern601 (x1, 
E_RVVMF2x3SImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 15;

    case E_RVVMF2x4SImode:
      if (pattern601 (x1, 
E_RVVMF2x4SImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 16;

    case E_RVVMF2x5SImode:
      if (pattern601 (x1, 
E_RVVMF2x5SImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 17;

    case E_RVVMF2x6SImode:
      if (pattern601 (x1, 
E_RVVMF2x6SImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 18;

    case E_RVVMF2x7SImode:
      if (pattern601 (x1, 
E_RVVMF2x7SImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 19;

    case E_RVVMF2x8SImode:
      if (pattern601 (x1, 
E_RVVMF2x8SImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 20;

    case E_RVVM1x2DImode:
      if (pattern601 (x1, 
E_RVVM1x2DImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 21;

    case E_RVVM1x3DImode:
      if (pattern601 (x1, 
E_RVVM1x3DImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 22;

    case E_RVVM1x4DImode:
      if (pattern601 (x1, 
E_RVVM1x4DImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 23;

    case E_RVVM1x5DImode:
      if (pattern601 (x1, 
E_RVVM1x5DImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 24;

    case E_RVVM1x6DImode:
      if (pattern601 (x1, 
E_RVVM1x6DImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 25;

    case E_RVVM1x7DImode:
      if (pattern601 (x1, 
E_RVVM1x7DImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 26;

    case E_RVVM1x8DImode:
      if (pattern601 (x1, 
E_RVVM1x8DImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 27;

    case E_RVVMF4x2BFmode:
      if (pattern601 (x1, 
E_RVVMF4x2BFmode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 28;

    case E_RVVMF4x3BFmode:
      if (pattern601 (x1, 
E_RVVMF4x3BFmode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 29;

    case E_RVVMF4x4BFmode:
      if (pattern601 (x1, 
E_RVVMF4x4BFmode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 30;

    case E_RVVMF4x5BFmode:
      if (pattern601 (x1, 
E_RVVMF4x5BFmode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 31;

    case E_RVVMF4x6BFmode:
      if (pattern601 (x1, 
E_RVVMF4x6BFmode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 32;

    case E_RVVMF4x7BFmode:
      if (pattern601 (x1, 
E_RVVMF4x7BFmode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 33;

    case E_RVVMF4x8BFmode:
      if (pattern601 (x1, 
E_RVVMF4x8BFmode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 34;

    case E_RVVMF4x2HFmode:
      if (pattern601 (x1, 
E_RVVMF4x2HFmode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 35;

    case E_RVVMF4x3HFmode:
      if (pattern601 (x1, 
E_RVVMF4x3HFmode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 36;

    case E_RVVMF4x4HFmode:
      if (pattern601 (x1, 
E_RVVMF4x4HFmode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 37;

    case E_RVVMF4x5HFmode:
      if (pattern601 (x1, 
E_RVVMF4x5HFmode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 38;

    case E_RVVMF4x6HFmode:
      if (pattern601 (x1, 
E_RVVMF4x6HFmode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 39;

    case E_RVVMF4x7HFmode:
      if (pattern601 (x1, 
E_RVVMF4x7HFmode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 40;

    case E_RVVMF4x8HFmode:
      if (pattern601 (x1, 
E_RVVMF4x8HFmode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 41;

    case E_RVVMF2x2SFmode:
      if (pattern601 (x1, 
E_RVVMF2x2SFmode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 42;

    case E_RVVMF2x3SFmode:
      if (pattern601 (x1, 
E_RVVMF2x3SFmode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 43;

    case E_RVVMF2x4SFmode:
      if (pattern601 (x1, 
E_RVVMF2x4SFmode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 44;

    case E_RVVMF2x5SFmode:
      if (pattern601 (x1, 
E_RVVMF2x5SFmode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 45;

    case E_RVVMF2x6SFmode:
      if (pattern601 (x1, 
E_RVVMF2x6SFmode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 46;

    case E_RVVMF2x7SFmode:
      if (pattern601 (x1, 
E_RVVMF2x7SFmode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 47;

    case E_RVVMF2x8SFmode:
      if (pattern601 (x1, 
E_RVVMF2x8SFmode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 48;

    case E_RVVM1x2DFmode:
      if (pattern601 (x1, 
E_RVVM1x2DFmode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 49;

    case E_RVVM1x3DFmode:
      if (pattern601 (x1, 
E_RVVM1x3DFmode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 50;

    case E_RVVM1x4DFmode:
      if (pattern601 (x1, 
E_RVVM1x4DFmode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 51;

    case E_RVVM1x5DFmode:
      if (pattern601 (x1, 
E_RVVM1x5DFmode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 52;

    case E_RVVM1x6DFmode:
      if (pattern601 (x1, 
E_RVVM1x6DFmode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 53;

    case E_RVVM1x7DFmode:
      if (pattern601 (x1, 
E_RVVM1x7DFmode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 54;

    case E_RVVM1x8DFmode:
      if (pattern601 (x1, 
E_RVVM1x8DFmode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 55;

    case E_RVVMF4x2QImode:
      if (pattern601 (x1, 
E_RVVMF4x2QImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 56;

    case E_RVVMF4x3QImode:
      if (pattern601 (x1, 
E_RVVMF4x3QImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 57;

    case E_RVVMF4x4QImode:
      if (pattern601 (x1, 
E_RVVMF4x4QImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 58;

    case E_RVVMF4x5QImode:
      if (pattern601 (x1, 
E_RVVMF4x5QImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 59;

    case E_RVVMF4x6QImode:
      if (pattern601 (x1, 
E_RVVMF4x6QImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 60;

    case E_RVVMF4x7QImode:
      if (pattern601 (x1, 
E_RVVMF4x7QImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 61;

    case E_RVVMF4x8QImode:
      if (pattern601 (x1, 
E_RVVMF4x8QImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 62;

    case E_RVVMF2x2HImode:
      if (pattern601 (x1, 
E_RVVMF2x2HImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 63;

    case E_RVVMF2x3HImode:
      if (pattern601 (x1, 
E_RVVMF2x3HImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 64;

    case E_RVVMF2x4HImode:
      if (pattern601 (x1, 
E_RVVMF2x4HImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 65;

    case E_RVVMF2x5HImode:
      if (pattern601 (x1, 
E_RVVMF2x5HImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 66;

    case E_RVVMF2x6HImode:
      if (pattern601 (x1, 
E_RVVMF2x6HImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 67;

    case E_RVVMF2x7HImode:
      if (pattern601 (x1, 
E_RVVMF2x7HImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 68;

    case E_RVVMF2x8HImode:
      if (pattern601 (x1, 
E_RVVMF2x8HImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 69;

    case E_RVVM1x2SImode:
      if (pattern601 (x1, 
E_RVVM1x2SImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 70;

    case E_RVVM1x3SImode:
      if (pattern601 (x1, 
E_RVVM1x3SImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 71;

    case E_RVVM1x4SImode:
      if (pattern601 (x1, 
E_RVVM1x4SImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 72;

    case E_RVVM1x5SImode:
      if (pattern601 (x1, 
E_RVVM1x5SImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 73;

    case E_RVVM1x6SImode:
      if (pattern601 (x1, 
E_RVVM1x6SImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 74;

    case E_RVVM1x7SImode:
      if (pattern601 (x1, 
E_RVVM1x7SImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 75;

    case E_RVVM1x8SImode:
      if (pattern601 (x1, 
E_RVVM1x8SImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 76;

    case E_RVVM2x2DImode:
      if (pattern601 (x1, 
E_RVVM2x2DImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 77;

    case E_RVVM2x3DImode:
      if (pattern601 (x1, 
E_RVVM2x3DImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 78;

    case E_RVVM2x4DImode:
      if (pattern601 (x1, 
E_RVVM2x4DImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 79;

    case E_RVVMF2x2BFmode:
      if (pattern601 (x1, 
E_RVVMF2x2BFmode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 80;

    case E_RVVMF2x3BFmode:
      if (pattern601 (x1, 
E_RVVMF2x3BFmode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 81;

    case E_RVVMF2x4BFmode:
      if (pattern601 (x1, 
E_RVVMF2x4BFmode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 82;

    case E_RVVMF2x5BFmode:
      if (pattern601 (x1, 
E_RVVMF2x5BFmode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 83;

    case E_RVVMF2x6BFmode:
      if (pattern601 (x1, 
E_RVVMF2x6BFmode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 84;

    case E_RVVMF2x7BFmode:
      if (pattern601 (x1, 
E_RVVMF2x7BFmode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 85;

    case E_RVVMF2x8BFmode:
      if (pattern601 (x1, 
E_RVVMF2x8BFmode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 86;

    case E_RVVMF2x2HFmode:
      if (pattern601 (x1, 
E_RVVMF2x2HFmode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 87;

    case E_RVVMF2x3HFmode:
      if (pattern601 (x1, 
E_RVVMF2x3HFmode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 88;

    case E_RVVMF2x4HFmode:
      if (pattern601 (x1, 
E_RVVMF2x4HFmode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 89;

    case E_RVVMF2x5HFmode:
      if (pattern601 (x1, 
E_RVVMF2x5HFmode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 90;

    case E_RVVMF2x6HFmode:
      if (pattern601 (x1, 
E_RVVMF2x6HFmode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 91;

    case E_RVVMF2x7HFmode:
      if (pattern601 (x1, 
E_RVVMF2x7HFmode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 92;

    case E_RVVMF2x8HFmode:
      if (pattern601 (x1, 
E_RVVMF2x8HFmode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 93;

    case E_RVVM1x2SFmode:
      if (pattern601 (x1, 
E_RVVM1x2SFmode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 94;

    case E_RVVM1x3SFmode:
      if (pattern601 (x1, 
E_RVVM1x3SFmode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 95;

    case E_RVVM1x4SFmode:
      if (pattern601 (x1, 
E_RVVM1x4SFmode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 96;

    case E_RVVM1x5SFmode:
      if (pattern601 (x1, 
E_RVVM1x5SFmode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 97;

    case E_RVVM1x6SFmode:
      if (pattern601 (x1, 
E_RVVM1x6SFmode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 98;

    case E_RVVM1x7SFmode:
      if (pattern601 (x1, 
E_RVVM1x7SFmode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 99;

    case E_RVVM1x8SFmode:
      if (pattern601 (x1, 
E_RVVM1x8SFmode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 100;

    case E_RVVM2x2DFmode:
      if (pattern601 (x1, 
E_RVVM2x2DFmode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 101;

    case E_RVVM2x3DFmode:
      if (pattern601 (x1, 
E_RVVM2x3DFmode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 102;

    case E_RVVM2x4DFmode:
      if (pattern601 (x1, 
E_RVVM2x4DFmode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 103;

    case E_RVVMF2x2QImode:
      if (pattern601 (x1, 
E_RVVMF2x2QImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 104;

    case E_RVVMF2x3QImode:
      if (pattern601 (x1, 
E_RVVMF2x3QImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 105;

    case E_RVVMF2x4QImode:
      if (pattern601 (x1, 
E_RVVMF2x4QImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 106;

    case E_RVVMF2x5QImode:
      if (pattern601 (x1, 
E_RVVMF2x5QImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 107;

    case E_RVVMF2x6QImode:
      if (pattern601 (x1, 
E_RVVMF2x6QImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 108;

    case E_RVVMF2x7QImode:
      if (pattern601 (x1, 
E_RVVMF2x7QImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 109;

    case E_RVVMF2x8QImode:
      if (pattern601 (x1, 
E_RVVMF2x8QImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 110;

    case E_RVVM1x2HImode:
      if (pattern601 (x1, 
E_RVVM1x2HImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 111;

    case E_RVVM1x3HImode:
      if (pattern601 (x1, 
E_RVVM1x3HImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 112;

    case E_RVVM1x4HImode:
      if (pattern601 (x1, 
E_RVVM1x4HImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 113;

    case E_RVVM1x5HImode:
      if (pattern601 (x1, 
E_RVVM1x5HImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 114;

    case E_RVVM1x6HImode:
      if (pattern601 (x1, 
E_RVVM1x6HImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 115;

    case E_RVVM1x7HImode:
      if (pattern601 (x1, 
E_RVVM1x7HImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 116;

    case E_RVVM1x8HImode:
      if (pattern601 (x1, 
E_RVVM1x8HImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 117;

    case E_RVVM2x2SImode:
      if (pattern601 (x1, 
E_RVVM2x2SImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 118;

    case E_RVVM2x3SImode:
      if (pattern601 (x1, 
E_RVVM2x3SImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 119;

    case E_RVVM2x4SImode:
      if (pattern601 (x1, 
E_RVVM2x4SImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 120;

    case E_RVVM4x2DImode:
      if (pattern601 (x1, 
E_RVVM4x2DImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 121;

    case E_RVVM1x2BFmode:
      if (pattern601 (x1, 
E_RVVM1x2BFmode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 122;

    case E_RVVM1x3BFmode:
      if (pattern601 (x1, 
E_RVVM1x3BFmode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 123;

    case E_RVVM1x4BFmode:
      if (pattern601 (x1, 
E_RVVM1x4BFmode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 124;

    case E_RVVM1x5BFmode:
      if (pattern601 (x1, 
E_RVVM1x5BFmode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 125;

    case E_RVVM1x6BFmode:
      if (pattern601 (x1, 
E_RVVM1x6BFmode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 126;

    case E_RVVM1x7BFmode:
      if (pattern601 (x1, 
E_RVVM1x7BFmode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 127;

    case E_RVVM1x8BFmode:
      if (pattern601 (x1, 
E_RVVM1x8BFmode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 128;

    case E_RVVM1x2HFmode:
      if (pattern601 (x1, 
E_RVVM1x2HFmode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 129;

    case E_RVVM1x3HFmode:
      if (pattern601 (x1, 
E_RVVM1x3HFmode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 130;

    case E_RVVM1x4HFmode:
      if (pattern601 (x1, 
E_RVVM1x4HFmode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 131;

    case E_RVVM1x5HFmode:
      if (pattern601 (x1, 
E_RVVM1x5HFmode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 132;

    case E_RVVM1x6HFmode:
      if (pattern601 (x1, 
E_RVVM1x6HFmode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 133;

    case E_RVVM1x7HFmode:
      if (pattern601 (x1, 
E_RVVM1x7HFmode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 134;

    case E_RVVM1x8HFmode:
      if (pattern601 (x1, 
E_RVVM1x8HFmode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 135;

    case E_RVVM2x2SFmode:
      if (pattern601 (x1, 
E_RVVM2x2SFmode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 136;

    case E_RVVM2x3SFmode:
      if (pattern601 (x1, 
E_RVVM2x3SFmode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 137;

    case E_RVVM2x4SFmode:
      if (pattern601 (x1, 
E_RVVM2x4SFmode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 138;

    case E_RVVM4x2DFmode:
      if (pattern601 (x1, 
E_RVVM4x2DFmode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 139;

    case E_RVVM1x2QImode:
      if (pattern601 (x1, 
E_RVVM1x2QImode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 140;

    case E_RVVM1x3QImode:
      if (pattern601 (x1, 
E_RVVM1x3QImode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 141;

    case E_RVVM1x4QImode:
      if (pattern601 (x1, 
E_RVVM1x4QImode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 142;

    case E_RVVM1x5QImode:
      if (pattern601 (x1, 
E_RVVM1x5QImode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 143;

    case E_RVVM1x6QImode:
      if (pattern601 (x1, 
E_RVVM1x6QImode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 144;

    case E_RVVM1x7QImode:
      if (pattern601 (x1, 
E_RVVM1x7QImode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 145;

    case E_RVVM1x8QImode:
      if (pattern601 (x1, 
E_RVVM1x8QImode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 146;

    case E_RVVM2x2HImode:
      if (pattern601 (x1, 
E_RVVM2x2HImode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 147;

    case E_RVVM2x3HImode:
      if (pattern601 (x1, 
E_RVVM2x3HImode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 148;

    case E_RVVM2x4HImode:
      if (pattern601 (x1, 
E_RVVM2x4HImode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 149;

    case E_RVVM4x2SImode:
      if (pattern601 (x1, 
E_RVVM4x2SImode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 150;

    case E_RVVM2x2BFmode:
      if (pattern601 (x1, 
E_RVVM2x2BFmode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 151;

    case E_RVVM2x3BFmode:
      if (pattern601 (x1, 
E_RVVM2x3BFmode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 152;

    case E_RVVM2x4BFmode:
      if (pattern601 (x1, 
E_RVVM2x4BFmode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 153;

    case E_RVVM2x2HFmode:
      if (pattern601 (x1, 
E_RVVM2x2HFmode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 154;

    case E_RVVM2x3HFmode:
      if (pattern601 (x1, 
E_RVVM2x3HFmode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 155;

    case E_RVVM2x4HFmode:
      if (pattern601 (x1, 
E_RVVM2x4HFmode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 156;

    case E_RVVM4x2SFmode:
      if (pattern601 (x1, 
E_RVVM4x2SFmode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 157;

    case E_RVVM2x2QImode:
      if (pattern601 (x1, 
E_RVVM2x2QImode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 158;

    case E_RVVM2x3QImode:
      if (pattern601 (x1, 
E_RVVM2x3QImode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 159;

    case E_RVVM2x4QImode:
      if (pattern601 (x1, 
E_RVVM2x4QImode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 160;

    case E_RVVM4x2HImode:
      if (pattern601 (x1, 
E_RVVM4x2HImode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 161;

    case E_RVVM4x2BFmode:
      if (pattern601 (x1, 
E_RVVM4x2BFmode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 162;

    case E_RVVM4x2HFmode:
      if (pattern601 (x1, 
E_RVVM4x2HFmode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 163;

    case E_RVVM4x2QImode:
      if (pattern601 (x1, 
E_RVVM4x2QImode, 
E_RVVMF2BImode) != 0)
        return -1;
      return 164;

    default:
      return -1;
    }
}

int
pattern767 (rtx x1, unsigned int i1, unsigned int i2, unsigned int i3, unsigned int i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  x3 = XEXP (x2, 0);
  if (REGNO (x3) != i4)
    return -1;
  x4 = XVECEXP (x1, 0, 3);
  x5 = XEXP (x4, 0);
  if (REGNO (x5) != i3)
    return -1;
  x6 = XVECEXP (x1, 0, 4);
  x7 = XEXP (x6, 0);
  if (REGNO (x7) != i2)
    return -1;
  x8 = XVECEXP (x1, 0, 5);
  x9 = XEXP (x8, 0);
  if (REGNO (x9) != i1)
    return -1;
  return 0;
}

int
pattern770 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34, x35, x36, x37, x38, x39, x40, x41;
  rtx x42, x43, x44, x45;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 1);
  switch (XWINT (x5, 0))
    {
    case -4L:
      x6 = XVECEXP (x1, 0, 2);
      x7 = XEXP (x6, 1);
      x8 = XEXP (x7, 0);
      x9 = XEXP (x8, 1);
      if (XWINT (x9, 0) != -8L)
        return -1;
      x10 = XVECEXP (x1, 0, 3);
      x11 = XEXP (x10, 1);
      x12 = XEXP (x11, 0);
      x13 = XEXP (x12, 1);
      if (XWINT (x13, 0) != -12L)
        return -1;
      x14 = XVECEXP (x1, 0, 4);
      x15 = XEXP (x14, 1);
      x16 = XEXP (x15, 0);
      x17 = XEXP (x16, 1);
      if (XWINT (x17, 0) != -16L)
        return -1;
      x18 = XVECEXP (x1, 0, 5);
      x19 = XEXP (x18, 1);
      x20 = XEXP (x19, 0);
      x21 = XEXP (x20, 1);
      if (XWINT (x21, 0) != -20L)
        return -1;
      x22 = XVECEXP (x1, 0, 6);
      x23 = XEXP (x22, 1);
      x24 = XEXP (x23, 0);
      x25 = XEXP (x24, 1);
      if (XWINT (x25, 0) != -24L)
        return -1;
      x26 = XVECEXP (x1, 0, 7);
      x27 = XEXP (x26, 1);
      x28 = XEXP (x27, 0);
      x29 = XEXP (x28, 1);
      if (XWINT (x29, 0) != -28L)
        return -1;
      x30 = XVECEXP (x1, 0, 8);
      x31 = XEXP (x30, 1);
      x32 = XEXP (x31, 0);
      x33 = XEXP (x32, 1);
      if (XWINT (x33, 0) != -32L)
        return -1;
      x34 = XVECEXP (x1, 0, 9);
      x35 = XEXP (x34, 1);
      x36 = XEXP (x35, 0);
      x37 = XEXP (x36, 1);
      if (XWINT (x37, 0) != -36L)
        return -1;
      x38 = XVECEXP (x1, 0, 10);
      x39 = XEXP (x38, 1);
      x40 = XEXP (x39, 0);
      x41 = XEXP (x40, 1);
      if (XWINT (x41, 0) != -40L)
        return -1;
      x42 = XVECEXP (x1, 0, 11);
      x43 = XEXP (x42, 1);
      x44 = XEXP (x43, 0);
      x45 = XEXP (x44, 1);
      if (XWINT (x45, 0) != -44L)
        return -1;
      return 0;

    case -8L:
      x6 = XVECEXP (x1, 0, 2);
      x7 = XEXP (x6, 1);
      x8 = XEXP (x7, 0);
      x9 = XEXP (x8, 1);
      if (XWINT (x9, 0) != -16L)
        return -1;
      x10 = XVECEXP (x1, 0, 3);
      x11 = XEXP (x10, 1);
      x12 = XEXP (x11, 0);
      x13 = XEXP (x12, 1);
      if (XWINT (x13, 0) != -24L)
        return -1;
      x14 = XVECEXP (x1, 0, 4);
      x15 = XEXP (x14, 1);
      x16 = XEXP (x15, 0);
      x17 = XEXP (x16, 1);
      if (XWINT (x17, 0) != -32L)
        return -1;
      x18 = XVECEXP (x1, 0, 5);
      x19 = XEXP (x18, 1);
      x20 = XEXP (x19, 0);
      x21 = XEXP (x20, 1);
      if (XWINT (x21, 0) != -40L)
        return -1;
      x22 = XVECEXP (x1, 0, 6);
      x23 = XEXP (x22, 1);
      x24 = XEXP (x23, 0);
      x25 = XEXP (x24, 1);
      if (XWINT (x25, 0) != -48L)
        return -1;
      x26 = XVECEXP (x1, 0, 7);
      x27 = XEXP (x26, 1);
      x28 = XEXP (x27, 0);
      x29 = XEXP (x28, 1);
      if (XWINT (x29, 0) != -56L)
        return -1;
      x30 = XVECEXP (x1, 0, 8);
      x31 = XEXP (x30, 1);
      x32 = XEXP (x31, 0);
      x33 = XEXP (x32, 1);
      if (XWINT (x33, 0) != -64L)
        return -1;
      x34 = XVECEXP (x1, 0, 9);
      x35 = XEXP (x34, 1);
      x36 = XEXP (x35, 0);
      x37 = XEXP (x36, 1);
      if (XWINT (x37, 0) != -72L)
        return -1;
      x38 = XVECEXP (x1, 0, 10);
      x39 = XEXP (x38, 1);
      x40 = XEXP (x39, 0);
      x41 = XEXP (x40, 1);
      if (XWINT (x41, 0) != -80L)
        return -1;
      x42 = XVECEXP (x1, 0, 11);
      x43 = XEXP (x42, 1);
      x44 = XEXP (x43, 0);
      x45 = XEXP (x44, 1);
      if (XWINT (x45, 0) != -88L)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern784 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 9);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 1
      || GET_MODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x1, 0, 10);
  if (GET_CODE (x4) != RETURN)
    return -1;
  x5 = XVECEXP (x1, 0, 11);
  if (GET_CODE (x5) != USE)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 1
      || GET_MODE (x6) != E_SImode
      || !stack_pop_up_to_s7_operand (operands[0], E_VOIDmode))
    return -1;
  return 0;
}

int
pattern790 (rtx x1, unsigned int i1, unsigned int i2, unsigned int i3, unsigned int i4, unsigned int i5)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 6);
  x3 = XEXP (x2, 0);
  if (REGNO (x3) != i5)
    return -1;
  x4 = XVECEXP (x1, 0, 7);
  x5 = XEXP (x4, 0);
  if (REGNO (x5) != i4)
    return -1;
  x6 = XVECEXP (x1, 0, 8);
  x7 = XEXP (x6, 0);
  if (REGNO (x7) != i3)
    return -1;
  x8 = XVECEXP (x1, 0, 9);
  x9 = XEXP (x8, 0);
  if (REGNO (x9) != i2)
    return -1;
  x10 = XVECEXP (x1, 0, 10);
  x11 = XEXP (x10, 1);
  if (GET_CODE (x11) != MEM
      || GET_MODE (x11) != E_SImode)
    return -1;
  x12 = XEXP (x11, 0);
  if (GET_CODE (x12) != PLUS
      || GET_MODE (x12) != E_SImode)
    return -1;
  x13 = XEXP (x12, 0);
  if (GET_CODE (x13) != REG
      || REGNO (x13) != 2
      || GET_MODE (x13) != E_SImode)
    return -1;
  x14 = XEXP (x12, 1);
  if (x14 != const_int_rtx[MAX_SAVED_CONST_INT + -40])
    return -1;
  x15 = XEXP (x10, 0);
  if (REGNO (x15) != i1)
    return -1;
  x16 = XVECEXP (x1, 0, 11);
  return pattern789 (x16); /* [-1, 0] */
}

int
pattern795 (rtx x1, machine_mode i1, rtx_code i2, unsigned int i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 11);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != i3
      || GET_MODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x1, 0, 12);
  if (GET_CODE (x4) != i2)
    return -1;
  return 0;
}

int
pattern798 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != MEM
      || GET_MODE (x1) != E_DImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != PLUS
      || GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 2
      || GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_CODE (x4) != CONST_INT
      || XWINT (x4, 0) != -96L)
    return -1;
  return 0;
}

 int
recog_2 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode
      || !register_operand (operands[1], E_SImode))
    return -1;
  if (arith_operand (operands[2], E_SImode))
    return 4; /* *addsi3 */
  if (!const_two_s12 (operands[2], E_SImode)
      || !(
#line 747 "../../../gcc/config/riscv/riscv.md"
(!riscv_reg_frame_related (operands[0])) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)))
    return -1;
  return 6; /* *addsi3_const_sum_of_two_s12 */
}

 int
recog_7 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern231 (x2))
    {
    case 0:
      if (!
#line 907 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 31185; /* *dual_widen_fmaurvvm8hi */

    case 1:
      if (!
#line 907 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 31187; /* *dual_widen_fmaurvvm4hi */

    case 2:
      if (!
#line 907 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 31189; /* *dual_widen_fmaurvvm2hi */

    case 3:
      if (!
#line 907 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 31191; /* *dual_widen_fmaurvvm1hi */

    case 4:
      if (!
#line 907 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 31193; /* *dual_widen_fmaurvvmf2hi */

    case 5:
      if (!(
#line 907 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 31195; /* *dual_widen_fmaurvvmf4hi */

    case 6:
      if (!
#line 907 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 31197; /* *dual_widen_fmaurvvm8si */

    case 7:
      if (!
#line 907 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 31199; /* *dual_widen_fmaurvvm4si */

    case 8:
      if (!
#line 907 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 31201; /* *dual_widen_fmaurvvm2si */

    case 9:
      if (!
#line 907 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 31203; /* *dual_widen_fmaurvvm1si */

    case 10:
      if (!(
#line 907 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 31205; /* *dual_widen_fmaurvvmf2si */

    case 11:
      if (!(
#line 907 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 31207; /* *dual_widen_fmaurvvm8di */

    case 12:
      if (!(
#line 907 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 31209; /* *dual_widen_fmaurvvm4di */

    case 13:
      if (!(
#line 907 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 31211; /* *dual_widen_fmaurvvm2di */

    case 14:
      if (!(
#line 907 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 31213; /* *dual_widen_fmaurvvm1di */

    case 15:
      if (!(
#line 907 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 31215; /* *dual_widen_fmauv1hi */

    case 16:
      if (!(
#line 907 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 31217; /* *dual_widen_fmauv2hi */

    case 17:
      if (!(
#line 907 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 31219; /* *dual_widen_fmauv4hi */

    case 18:
      if (!(
#line 907 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 31221; /* *dual_widen_fmauv8hi */

    case 19:
      if (!(
#line 907 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 31223; /* *dual_widen_fmauv16hi */

    case 20:
      if (!(
#line 907 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 31225; /* *dual_widen_fmauv32hi */

    case 21:
      if (!(
#line 907 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 31227; /* *dual_widen_fmauv64hi */

    case 22:
      if (!(
#line 907 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 31229; /* *dual_widen_fmauv128hi */

    case 23:
      if (!(
#line 907 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 31231; /* *dual_widen_fmauv256hi */

    case 24:
      if (!(
#line 907 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 31233; /* *dual_widen_fmauv512hi */

    case 25:
      if (!(
#line 907 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 31235; /* *dual_widen_fmauv1024hi */

    case 26:
      if (!(
#line 907 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 31237; /* *dual_widen_fmauv2048hi */

    case 27:
      if (!(
#line 907 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 31239; /* *dual_widen_fmauv1si */

    case 28:
      if (!(
#line 907 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 31241; /* *dual_widen_fmauv2si */

    case 29:
      if (!(
#line 907 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 31243; /* *dual_widen_fmauv4si */

    case 30:
      if (!(
#line 907 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 31245; /* *dual_widen_fmauv8si */

    case 31:
      if (!(
#line 907 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 31247; /* *dual_widen_fmauv16si */

    case 32:
      if (!(
#line 907 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 31249; /* *dual_widen_fmauv32si */

    case 33:
      if (!(
#line 907 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 31251; /* *dual_widen_fmauv64si */

    case 34:
      if (!(
#line 907 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 972 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 31253; /* *dual_widen_fmauv128si */

    case 35:
      if (!(
#line 907 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 973 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 31255; /* *dual_widen_fmauv256si */

    case 36:
      if (!(
#line 907 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 974 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 31257; /* *dual_widen_fmauv512si */

    case 37:
      if (!(
#line 907 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 975 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 31259; /* *dual_widen_fmauv1024si */

    case 38:
      if (!(
#line 907 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 976 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 31261; /* *dual_widen_fmauv1di */

    case 39:
      if (!(
#line 907 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 977 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 31263; /* *dual_widen_fmauv2di */

    case 40:
      if (!(
#line 907 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 978 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 31265; /* *dual_widen_fmauv4di */

    case 41:
      if (!(
#line 907 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 979 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 31267; /* *dual_widen_fmauv8di */

    case 42:
      if (!(
#line 907 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 980 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 31269; /* *dual_widen_fmauv16di */

    case 43:
      if (!(
#line 907 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 981 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 31271; /* *dual_widen_fmauv32di */

    case 44:
      if (!(
#line 907 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 982 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 31273; /* *dual_widen_fmauv64di */

    case 45:
      if (!(
#line 907 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 983 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 31275; /* *dual_widen_fmauv128di */

    case 46:
      if (!(
#line 907 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 984 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 31277; /* *dual_widen_fmauv256di */

    case 47:
      if (!(
#line 907 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 985 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 31279; /* *dual_widen_fmauv512di */

    case 48:
      if (!
#line 951 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 31328; /* *dual_widen_fmausrvvm8hi */

    case 49:
      if (!
#line 951 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 31329; /* *dual_widen_fmausrvvm4hi */

    case 50:
      if (!
#line 951 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 31330; /* *dual_widen_fmausrvvm2hi */

    case 51:
      if (!
#line 951 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 31331; /* *dual_widen_fmausrvvm1hi */

    case 52:
      if (!
#line 951 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 31332; /* *dual_widen_fmausrvvmf2hi */

    case 53:
      if (!(
#line 951 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 31333; /* *dual_widen_fmausrvvmf4hi */

    case 54:
      if (!
#line 951 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 31334; /* *dual_widen_fmausrvvm8si */

    case 55:
      if (!
#line 951 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 31335; /* *dual_widen_fmausrvvm4si */

    case 56:
      if (!
#line 951 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 31336; /* *dual_widen_fmausrvvm2si */

    case 57:
      if (!
#line 951 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 31337; /* *dual_widen_fmausrvvm1si */

    case 58:
      if (!(
#line 951 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 31338; /* *dual_widen_fmausrvvmf2si */

    case 59:
      if (!(
#line 951 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 31339; /* *dual_widen_fmausrvvm8di */

    case 60:
      if (!(
#line 951 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 31340; /* *dual_widen_fmausrvvm4di */

    case 61:
      if (!(
#line 951 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 31341; /* *dual_widen_fmausrvvm2di */

    case 62:
      if (!(
#line 951 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 31342; /* *dual_widen_fmausrvvm1di */

    case 63:
      if (!(
#line 951 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 31343; /* *dual_widen_fmausv1hi */

    case 64:
      if (!(
#line 951 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 31344; /* *dual_widen_fmausv2hi */

    case 65:
      if (!(
#line 951 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 31345; /* *dual_widen_fmausv4hi */

    case 66:
      if (!(
#line 951 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 31346; /* *dual_widen_fmausv8hi */

    case 67:
      if (!(
#line 951 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 31347; /* *dual_widen_fmausv16hi */

    case 68:
      if (!(
#line 951 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 31348; /* *dual_widen_fmausv32hi */

    case 69:
      if (!(
#line 951 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 31349; /* *dual_widen_fmausv64hi */

    case 70:
      if (!(
#line 951 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 31350; /* *dual_widen_fmausv128hi */

    case 71:
      if (!(
#line 951 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 31351; /* *dual_widen_fmausv256hi */

    case 72:
      if (!(
#line 951 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 31352; /* *dual_widen_fmausv512hi */

    case 73:
      if (!(
#line 951 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 31353; /* *dual_widen_fmausv1024hi */

    case 74:
      if (!(
#line 951 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 31354; /* *dual_widen_fmausv2048hi */

    case 75:
      if (!(
#line 951 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 31355; /* *dual_widen_fmausv1si */

    case 76:
      if (!(
#line 951 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 31356; /* *dual_widen_fmausv2si */

    case 77:
      if (!(
#line 951 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 31357; /* *dual_widen_fmausv4si */

    case 78:
      if (!(
#line 951 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 31358; /* *dual_widen_fmausv8si */

    case 79:
      if (!(
#line 951 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 31359; /* *dual_widen_fmausv16si */

    case 80:
      if (!(
#line 951 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 31360; /* *dual_widen_fmausv32si */

    case 81:
      if (!(
#line 951 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 31361; /* *dual_widen_fmausv64si */

    case 82:
      if (!(
#line 951 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 972 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 31362; /* *dual_widen_fmausv128si */

    case 83:
      if (!(
#line 951 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 973 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 31363; /* *dual_widen_fmausv256si */

    case 84:
      if (!(
#line 951 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 974 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 31364; /* *dual_widen_fmausv512si */

    case 85:
      if (!(
#line 951 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 975 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 31365; /* *dual_widen_fmausv1024si */

    case 86:
      if (!(
#line 951 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 976 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 31366; /* *dual_widen_fmausv1di */

    case 87:
      if (!(
#line 951 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 977 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 31367; /* *dual_widen_fmausv2di */

    case 88:
      if (!(
#line 951 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 978 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 31368; /* *dual_widen_fmausv4di */

    case 89:
      if (!(
#line 951 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 979 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 31369; /* *dual_widen_fmausv8di */

    case 90:
      if (!(
#line 951 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 980 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 31370; /* *dual_widen_fmausv16di */

    case 91:
      if (!(
#line 951 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 981 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 31371; /* *dual_widen_fmausv32di */

    case 92:
      if (!(
#line 951 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 982 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 31372; /* *dual_widen_fmausv64di */

    case 93:
      if (!(
#line 951 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 983 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 31373; /* *dual_widen_fmausv128di */

    case 94:
      if (!(
#line 951 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 984 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 31374; /* *dual_widen_fmausv256di */

    case 95:
      if (!(
#line 951 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 985 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 31375; /* *dual_widen_fmausv512di */

    case 96:
      if (!
#line 975 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 31377; /* *single_widen_fmaurvvm8hi */

    case 97:
      if (!
#line 975 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 31379; /* *single_widen_fmaurvvm4hi */

    case 98:
      if (!
#line 975 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 31381; /* *single_widen_fmaurvvm2hi */

    case 99:
      if (!
#line 975 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 31383; /* *single_widen_fmaurvvm1hi */

    case 100:
      if (!
#line 975 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 31385; /* *single_widen_fmaurvvmf2hi */

    case 101:
      if (!(
#line 975 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 31387; /* *single_widen_fmaurvvmf4hi */

    case 102:
      if (!
#line 975 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 31389; /* *single_widen_fmaurvvm8si */

    case 103:
      if (!
#line 975 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 31391; /* *single_widen_fmaurvvm4si */

    case 104:
      if (!
#line 975 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 31393; /* *single_widen_fmaurvvm2si */

    case 105:
      if (!
#line 975 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 31395; /* *single_widen_fmaurvvm1si */

    case 106:
      if (!(
#line 975 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 31397; /* *single_widen_fmaurvvmf2si */

    case 107:
      if (!(
#line 975 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 31399; /* *single_widen_fmaurvvm8di */

    case 108:
      if (!(
#line 975 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 31401; /* *single_widen_fmaurvvm4di */

    case 109:
      if (!(
#line 975 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 31403; /* *single_widen_fmaurvvm2di */

    case 110:
      if (!(
#line 975 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 31405; /* *single_widen_fmaurvvm1di */

    case 111:
      if (!(
#line 975 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 31407; /* *single_widen_fmauv1hi */

    case 112:
      if (!(
#line 975 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 31409; /* *single_widen_fmauv2hi */

    case 113:
      if (!(
#line 975 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 31411; /* *single_widen_fmauv4hi */

    case 114:
      if (!(
#line 975 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 31413; /* *single_widen_fmauv8hi */

    case 115:
      if (!(
#line 975 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 31415; /* *single_widen_fmauv16hi */

    case 116:
      if (!(
#line 975 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 31417; /* *single_widen_fmauv32hi */

    case 117:
      if (!(
#line 975 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 31419; /* *single_widen_fmauv64hi */

    case 118:
      if (!(
#line 975 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 31421; /* *single_widen_fmauv128hi */

    case 119:
      if (!(
#line 975 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 31423; /* *single_widen_fmauv256hi */

    case 120:
      if (!(
#line 975 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 31425; /* *single_widen_fmauv512hi */

    case 121:
      if (!(
#line 975 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 31427; /* *single_widen_fmauv1024hi */

    case 122:
      if (!(
#line 975 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 31429; /* *single_widen_fmauv2048hi */

    case 123:
      if (!(
#line 975 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 31431; /* *single_widen_fmauv1si */

    case 124:
      if (!(
#line 975 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 31433; /* *single_widen_fmauv2si */

    case 125:
      if (!(
#line 975 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 31435; /* *single_widen_fmauv4si */

    case 126:
      if (!(
#line 975 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 31437; /* *single_widen_fmauv8si */

    case 127:
      if (!(
#line 975 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 31439; /* *single_widen_fmauv16si */

    case 128:
      if (!(
#line 975 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 31441; /* *single_widen_fmauv32si */

    case 129:
      if (!(
#line 975 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 31443; /* *single_widen_fmauv64si */

    case 130:
      if (!(
#line 975 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 972 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 31445; /* *single_widen_fmauv128si */

    case 131:
      if (!(
#line 975 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 973 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 31447; /* *single_widen_fmauv256si */

    case 132:
      if (!(
#line 975 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 974 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 31449; /* *single_widen_fmauv512si */

    case 133:
      if (!(
#line 975 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 975 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 31451; /* *single_widen_fmauv1024si */

    case 134:
      if (!(
#line 975 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 976 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 31453; /* *single_widen_fmauv1di */

    case 135:
      if (!(
#line 975 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 977 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 31455; /* *single_widen_fmauv2di */

    case 136:
      if (!(
#line 975 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 978 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 31457; /* *single_widen_fmauv4di */

    case 137:
      if (!(
#line 975 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 979 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 31459; /* *single_widen_fmauv8di */

    case 138:
      if (!(
#line 975 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 980 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 31461; /* *single_widen_fmauv16di */

    case 139:
      if (!(
#line 975 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 981 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 31463; /* *single_widen_fmauv32di */

    case 140:
      if (!(
#line 975 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 982 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 31465; /* *single_widen_fmauv64di */

    case 141:
      if (!(
#line 975 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 983 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 31467; /* *single_widen_fmauv128di */

    case 142:
      if (!(
#line 975 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 984 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 31469; /* *single_widen_fmauv256di */

    case 143:
      if (!(
#line 975 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 985 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 31471; /* *single_widen_fmauv512di */

    default:
      return -1;
    }
}

 int
recog_23 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_SFmode) != 0
          || !(
#line 1119 "../../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT  || TARGET_ZFINX) && 
#line 105 "../../../gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX)))
        return -1;
      return 23; /* mulsf3 */

    case E_DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_DFmode) != 0
          || !(
#line 1119 "../../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT  || TARGET_ZFINX) && 
#line 106 "../../../gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX)))
        return -1;
      return 24; /* muldf3 */

    case E_HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_HFmode) != 0
          || !(
#line 1119 "../../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT  || TARGET_ZFINX) && 
#line 107 "../../../gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX)))
        return -1;
      return 25; /* mulhf3 */

    case E_SImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_SImode) != 0
          || !
#line 1128 "../../../gcc/config/riscv/riscv.md"
(TARGET_ZMMUL || TARGET_MUL))
        return -1;
      return 26; /* *mulsi3 */

    case E_DImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_DImode) != 0
          || !
#line 1155 "../../../gcc/config/riscv/riscv.md"
((TARGET_ZMMUL || TARGET_MUL) && TARGET_64BIT))
        return -1;
      return 27; /* muldi3 */

    case E_RVVM8QImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM8QImode) != 0
          || !
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24550; /* mulrvvm8qi3 */

    case E_RVVM4QImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM4QImode) != 0
          || !
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24564; /* mulrvvm4qi3 */

    case E_RVVM2QImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM2QImode) != 0
          || !
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24578; /* mulrvvm2qi3 */

    case E_RVVM1QImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM1QImode) != 0
          || !
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24592; /* mulrvvm1qi3 */

    case E_RVVM8HImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM8HImode) != 0
          || !
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24606; /* mulrvvm8hi3 */

    case E_RVVM4HImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM4HImode) != 0
          || !
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24620; /* mulrvvm4hi3 */

    case E_RVVM2HImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM2HImode) != 0
          || !
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24634; /* mulrvvm2hi3 */

    case E_RVVM1HImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM1HImode) != 0
          || !
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24648; /* mulrvvm1hi3 */

    case E_RVVM8SImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM8SImode) != 0
          || !
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24662; /* mulrvvm8si3 */

    case E_RVVM4SImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM4SImode) != 0
          || !
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24676; /* mulrvvm4si3 */

    case E_RVVM2SImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM2SImode) != 0
          || !
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24690; /* mulrvvm2si3 */

    case E_RVVM1SImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM1SImode) != 0
          || !
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24704; /* mulrvvm1si3 */

    case E_RVVM8DImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM8DImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 24718; /* mulrvvm8di3 */

    case E_RVVM4DImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM4DImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 24732; /* mulrvvm4di3 */

    case E_RVVM2DImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM2DImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 24746; /* mulrvvm2di3 */

    case E_RVVM1DImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM1DImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 24760; /* mulrvvm1di3 */

    case E_RVVMF2QImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVMF2QImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 24774; /* mulrvvmf2qi3 */

    case E_RVVMF4QImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVMF4QImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 24788; /* mulrvvmf4qi3 */

    case E_RVVMF8QImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVMF8QImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 24802; /* mulrvvmf8qi3 */

    case E_RVVMF2HImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVMF2HImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 24816; /* mulrvvmf2hi3 */

    case E_RVVMF4HImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVMF4HImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 132 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 24830; /* mulrvvmf4hi3 */

    case E_RVVMF2SImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVMF2SImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 133 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 24844; /* mulrvvmf2si3 */

    case E_V1QImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V1QImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 188 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 24858; /* mulv1qi3 */

    case E_V2QImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V2QImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 189 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 24872; /* mulv2qi3 */

    case E_V4QImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V4QImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 190 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 24886; /* mulv4qi3 */

    case E_V8QImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V8QImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 191 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 24900; /* mulv8qi3 */

    case E_V16QImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V16QImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 192 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 24914; /* mulv16qi3 */

    case E_V32QImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V32QImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 193 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 24928; /* mulv32qi3 */

    case E_V64QImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V64QImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 194 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 24942; /* mulv64qi3 */

    case E_V128QImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V128QImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 195 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 24956; /* mulv128qi3 */

    case E_V256QImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V256QImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 196 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 24970; /* mulv256qi3 */

    case E_V512QImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V512QImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 197 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 24984; /* mulv512qi3 */

    case E_V1024QImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V1024QImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 198 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 24998; /* mulv1024qi3 */

    case E_V2048QImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V2048QImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 199 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 25012; /* mulv2048qi3 */

    case E_V4096QImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V4096QImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 200 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 25026; /* mulv4096qi3 */

    case E_V1HImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V1HImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 201 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 25040; /* mulv1hi3 */

    case E_V2HImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V2HImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 202 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 25054; /* mulv2hi3 */

    case E_V4HImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V4HImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 203 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 25068; /* mulv4hi3 */

    case E_V8HImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V8HImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 204 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 25082; /* mulv8hi3 */

    case E_V16HImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V16HImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 205 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 25096; /* mulv16hi3 */

    case E_V32HImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V32HImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 206 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 25110; /* mulv32hi3 */

    case E_V64HImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V64HImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 207 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 25124; /* mulv64hi3 */

    case E_V128HImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V128HImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 208 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 25138; /* mulv128hi3 */

    case E_V256HImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V256HImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 209 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 25152; /* mulv256hi3 */

    case E_V512HImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V512HImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 210 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 25166; /* mulv512hi3 */

    case E_V1024HImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V1024HImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 211 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 25180; /* mulv1024hi3 */

    case E_V2048HImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V2048HImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 212 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 25194; /* mulv2048hi3 */

    case E_V1SImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V1SImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 213 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 25208; /* mulv1si3 */

    case E_V2SImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V2SImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 214 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 25222; /* mulv2si3 */

    case E_V4SImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V4SImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 215 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 25236; /* mulv4si3 */

    case E_V8SImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V8SImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 216 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 25250; /* mulv8si3 */

    case E_V16SImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V16SImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 217 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 25264; /* mulv16si3 */

    case E_V32SImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V32SImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 218 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 25278; /* mulv32si3 */

    case E_V64SImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V64SImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 219 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 25292; /* mulv64si3 */

    case E_V128SImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V128SImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 220 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 25306; /* mulv128si3 */

    case E_V256SImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V256SImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 221 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 25320; /* mulv256si3 */

    case E_V512SImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V512SImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 222 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 25334; /* mulv512si3 */

    case E_V1024SImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V1024SImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 223 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 25348; /* mulv1024si3 */

    case E_V1DImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V1DImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 224 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 25362; /* mulv1di3 */

    case E_V2DImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V2DImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 225 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 25376; /* mulv2di3 */

    case E_V4DImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V4DImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 226 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 25390; /* mulv4di3 */

    case E_V8DImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V8DImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 227 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 25404; /* mulv8di3 */

    case E_V16DImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V16DImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 228 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 25418; /* mulv16di3 */

    case E_V32DImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V32DImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 229 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 25432; /* mulv32di3 */

    case E_V64DImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V64DImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 230 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 25446; /* mulv64di3 */

    case E_V128DImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V128DImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 231 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 25460; /* mulv128di3 */

    case E_V256DImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V256DImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 232 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 25474; /* mulv256di3 */

    case E_V512DImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V512DImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 233 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 25488; /* mulv512di3 */

    case E_RVVM8HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM8HFmode) != 0
          || !(
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 27508; /* mulrvvm8hf3 */

    case E_RVVM4HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM4HFmode) != 0
          || !(
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 27512; /* mulrvvm4hf3 */

    case E_RVVM2HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM2HFmode) != 0
          || !(
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 27516; /* mulrvvm2hf3 */

    case E_RVVM1HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM1HFmode) != 0
          || !(
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 27520; /* mulrvvm1hf3 */

    case E_RVVMF2HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVMF2HFmode) != 0
          || !(
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 27524; /* mulrvvmf2hf3 */

    case E_RVVMF4HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVMF4HFmode) != 0
          || !(
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 157 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
        return -1;
      return 27528; /* mulrvvmf4hf3 */

    case E_RVVM8SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM8SFmode) != 0
          || !(
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27532; /* mulrvvm8sf3 */

    case E_RVVM4SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM4SFmode) != 0
          || !(
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27536; /* mulrvvm4sf3 */

    case E_RVVM2SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM2SFmode) != 0
          || !(
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27540; /* mulrvvm2sf3 */

    case E_RVVM1SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM1SFmode) != 0
          || !(
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27544; /* mulrvvm1sf3 */

    case E_RVVMF2SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVMF2SFmode) != 0
          || !(
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 27548; /* mulrvvmf2sf3 */

    case E_RVVM8DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM8DFmode) != 0
          || !(
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27552; /* mulrvvm8df3 */

    case E_RVVM4DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM4DFmode) != 0
          || !(
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27556; /* mulrvvm4df3 */

    case E_RVVM2DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM2DFmode) != 0
          || !(
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27560; /* mulrvvm2df3 */

    case E_RVVM1DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM1DFmode) != 0
          || !(
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27564; /* mulrvvm1df3 */

    case E_V1HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V1HFmode) != 0
          || !(
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 236 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
        return -1;
      return 27568; /* mulv1hf3 */

    case E_V2HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V2HFmode) != 0
          || !(
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 237 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
        return -1;
      return 27572; /* mulv2hf3 */

    case E_V4HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V4HFmode) != 0
          || !(
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 238 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
        return -1;
      return 27576; /* mulv4hf3 */

    case E_V8HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V8HFmode) != 0
          || !(
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 239 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
        return -1;
      return 27580; /* mulv8hf3 */

    case E_V16HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V16HFmode) != 0
          || !(
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 240 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
        return -1;
      return 27584; /* mulv16hf3 */

    case E_V32HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V32HFmode) != 0
          || !(
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 241 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 27588; /* mulv32hf3 */

    case E_V64HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V64HFmode) != 0
          || !(
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 242 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 27592; /* mulv64hf3 */

    case E_V128HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V128HFmode) != 0
          || !(
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 243 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 27596; /* mulv128hf3 */

    case E_V256HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V256HFmode) != 0
          || !(
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 244 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 27600; /* mulv256hf3 */

    case E_V512HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V512HFmode) != 0
          || !(
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 245 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 27604; /* mulv512hf3 */

    case E_V1024HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V1024HFmode) != 0
          || !(
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 246 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 27608; /* mulv1024hf3 */

    case E_V2048HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V2048HFmode) != 0
          || !(
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 247 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 27612; /* mulv2048hf3 */

    case E_V1SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V1SFmode) != 0
          || !(
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 248 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27616; /* mulv1sf3 */

    case E_V2SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V2SFmode) != 0
          || !(
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 249 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27620; /* mulv2sf3 */

    case E_V4SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V4SFmode) != 0
          || !(
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 250 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27624; /* mulv4sf3 */

    case E_V8SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V8SFmode) != 0
          || !(
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 251 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27628; /* mulv8sf3 */

    case E_V16SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V16SFmode) != 0
          || !(
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 252 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 27632; /* mulv16sf3 */

    case E_V32SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V32SFmode) != 0
          || !(
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 253 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 27636; /* mulv32sf3 */

    case E_V64SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V64SFmode) != 0
          || !(
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 254 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 27640; /* mulv64sf3 */

    case E_V128SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V128SFmode) != 0
          || !(
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 255 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 27644; /* mulv128sf3 */

    case E_V256SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V256SFmode) != 0
          || !(
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 256 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 27648; /* mulv256sf3 */

    case E_V512SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V512SFmode) != 0
          || !(
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 257 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 27652; /* mulv512sf3 */

    case E_V1024SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V1024SFmode) != 0
          || !(
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 258 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 27656; /* mulv1024sf3 */

    case E_V1DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V1DFmode) != 0
          || !(
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 259 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27660; /* mulv1df3 */

    case E_V2DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V2DFmode) != 0
          || !(
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 260 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27664; /* mulv2df3 */

    case E_V4DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V4DFmode) != 0
          || !(
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 261 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27668; /* mulv4df3 */

    case E_V8DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V8DFmode) != 0
          || !(
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 262 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 27672; /* mulv8df3 */

    case E_V16DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V16DFmode) != 0
          || !(
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 263 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 27676; /* mulv16df3 */

    case E_V32DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V32DFmode) != 0
          || !(
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 264 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 27680; /* mulv32df3 */

    case E_V64DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V64DFmode) != 0
          || !(
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 265 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 27684; /* mulv64df3 */

    case E_V128DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V128DFmode) != 0
          || !(
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 266 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 27688; /* mulv128df3 */

    case E_V256DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V256DFmode) != 0
          || !(
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 267 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 27692; /* mulv256df3 */

    case E_V512DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V512DFmode) != 0
          || !(
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 268 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 27696; /* mulv512df3 */

    default:
      return -1;
    }
}

 int
recog_33 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != VEC_SELECT)
    return -1;
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != PARALLEL
      || XVECLEN (x4, 0) != 1)
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 67
      || GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XEXP (x1, 0);
  operands[0] = x6;
  x7 = XEXP (x3, 0);
  operands[1] = x7;
  x8 = XVECEXP (x4, 0, 0);
  switch (GET_CODE (x8))
    {
    case REG:
    case SUBREG:
      operands[2] = x8;
      if (!register_operand (operands[2], E_DImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_QImode:
          if (!register_operand (operands[0], E_QImode)
              || GET_MODE (x2) != E_QImode
              || GET_MODE (x3) != E_QImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_RVVM8QImode:
              if (!register_operand (operands[1], E_RVVM8QImode)
                  || !
#line 349 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                return -1;
              return 2439; /* *pred_th_extractrvvm8qi */

            case E_RVVM4QImode:
              if (!register_operand (operands[1], E_RVVM4QImode)
                  || !
#line 349 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                return -1;
              return 2440; /* *pred_th_extractrvvm4qi */

            case E_RVVM2QImode:
              if (!register_operand (operands[1], E_RVVM2QImode)
                  || !
#line 349 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                return -1;
              return 2441; /* *pred_th_extractrvvm2qi */

            case E_RVVM1QImode:
              if (!register_operand (operands[1], E_RVVM1QImode)
                  || !
#line 349 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                return -1;
              return 2442; /* *pred_th_extractrvvm1qi */

            case E_RVVMF8QImode:
              if (!register_operand (operands[1], E_RVVMF8QImode)
                  || !(
#line 349 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
                return -1;
              return 2455; /* *pred_th_extractrvvmf8qi */

            case E_V1QImode:
              if (!register_operand (operands[1], E_V1QImode)
                  || !(
#line 349 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 188 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
                return -1;
              return 2458; /* *pred_th_extractv1qi */

            case E_V2QImode:
              if (!register_operand (operands[1], E_V2QImode)
                  || !(
#line 349 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 189 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
                return -1;
              return 2459; /* *pred_th_extractv2qi */

            case E_V4QImode:
              if (!register_operand (operands[1], E_V4QImode)
                  || !(
#line 349 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 190 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
                return -1;
              return 2460; /* *pred_th_extractv4qi */

            case E_V8QImode:
              if (!register_operand (operands[1], E_V8QImode)
                  || !(
#line 349 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 191 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
                return -1;
              return 2461; /* *pred_th_extractv8qi */

            case E_V16QImode:
              if (!register_operand (operands[1], E_V16QImode)
                  || !(
#line 349 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 192 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
                return -1;
              return 2462; /* *pred_th_extractv16qi */

            case E_V32QImode:
              if (!register_operand (operands[1], E_V32QImode)
                  || !(
#line 349 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 193 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
                return -1;
              return 2463; /* *pred_th_extractv32qi */

            case E_V64QImode:
              if (!register_operand (operands[1], E_V64QImode)
                  || !(
#line 349 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 194 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 2464; /* *pred_th_extractv64qi */

            case E_V128QImode:
              if (!register_operand (operands[1], E_V128QImode)
                  || !(
#line 349 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 195 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 2465; /* *pred_th_extractv128qi */

            case E_V256QImode:
              if (!register_operand (operands[1], E_V256QImode)
                  || !(
#line 349 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 196 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 2466; /* *pred_th_extractv256qi */

            case E_V512QImode:
              if (!register_operand (operands[1], E_V512QImode)
                  || !(
#line 349 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 197 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 2467; /* *pred_th_extractv512qi */

            case E_V1024QImode:
              if (!register_operand (operands[1], E_V1024QImode)
                  || !(
#line 349 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 198 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 2468; /* *pred_th_extractv1024qi */

            case E_V2048QImode:
              if (!register_operand (operands[1], E_V2048QImode)
                  || !(
#line 349 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 199 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 2469; /* *pred_th_extractv2048qi */

            case E_V4096QImode:
              if (!register_operand (operands[1], E_V4096QImode)
                  || !(
#line 349 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 200 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 2470; /* *pred_th_extractv4096qi */

            default:
              return -1;
            }

        case E_HImode:
          if (!register_operand (operands[0], E_HImode)
              || GET_MODE (x2) != E_HImode
              || GET_MODE (x3) != E_HImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_RVVM8HImode:
              if (!register_operand (operands[1], E_RVVM8HImode)
                  || !
#line 349 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                return -1;
              return 2443; /* *pred_th_extractrvvm8hi */

            case E_RVVM4HImode:
              if (!register_operand (operands[1], E_RVVM4HImode)
                  || !
#line 349 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                return -1;
              return 2444; /* *pred_th_extractrvvm4hi */

            case E_RVVM2HImode:
              if (!register_operand (operands[1], E_RVVM2HImode)
                  || !
#line 349 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                return -1;
              return 2445; /* *pred_th_extractrvvm2hi */

            case E_RVVM1HImode:
              if (!register_operand (operands[1], E_RVVM1HImode)
                  || !
#line 349 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                return -1;
              return 2446; /* *pred_th_extractrvvm1hi */

            case E_RVVMF4HImode:
              if (!register_operand (operands[1], E_RVVMF4HImode)
                  || !(
#line 349 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 132 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
                return -1;
              return 2456; /* *pred_th_extractrvvmf4hi */

            case E_V1HImode:
              if (!register_operand (operands[1], E_V1HImode)
                  || !(
#line 349 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 201 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
                return -1;
              return 2471; /* *pred_th_extractv1hi */

            case E_V2HImode:
              if (!register_operand (operands[1], E_V2HImode)
                  || !(
#line 349 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 202 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
                return -1;
              return 2472; /* *pred_th_extractv2hi */

            case E_V4HImode:
              if (!register_operand (operands[1], E_V4HImode)
                  || !(
#line 349 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 203 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
                return -1;
              return 2473; /* *pred_th_extractv4hi */

            case E_V8HImode:
              if (!register_operand (operands[1], E_V8HImode)
                  || !(
#line 349 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 204 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
                return -1;
              return 2474; /* *pred_th_extractv8hi */

            case E_V16HImode:
              if (!register_operand (operands[1], E_V16HImode)
                  || !(
#line 349 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 205 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
                return -1;
              return 2475; /* *pred_th_extractv16hi */

            case E_V32HImode:
              if (!register_operand (operands[1], E_V32HImode)
                  || !(
#line 349 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 206 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 2476; /* *pred_th_extractv32hi */

            case E_V64HImode:
              if (!register_operand (operands[1], E_V64HImode)
                  || !(
#line 349 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 207 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 2477; /* *pred_th_extractv64hi */

            case E_V128HImode:
              if (!register_operand (operands[1], E_V128HImode)
                  || !(
#line 349 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 208 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 2478; /* *pred_th_extractv128hi */

            case E_V256HImode:
              if (!register_operand (operands[1], E_V256HImode)
                  || !(
#line 349 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 209 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 2479; /* *pred_th_extractv256hi */

            case E_V512HImode:
              if (!register_operand (operands[1], E_V512HImode)
                  || !(
#line 349 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 210 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 2480; /* *pred_th_extractv512hi */

            case E_V1024HImode:
              if (!register_operand (operands[1], E_V1024HImode)
                  || !(
#line 349 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 211 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 2481; /* *pred_th_extractv1024hi */

            case E_V2048HImode:
              if (!register_operand (operands[1], E_V2048HImode)
                  || !(
#line 349 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 212 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 2482; /* *pred_th_extractv2048hi */

            default:
              return -1;
            }

        case E_SImode:
          switch (pattern441 (x2))
            {
            case 0:
              if (!
#line 349 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                return -1;
              return 2447; /* *pred_th_extractrvvm8si */

            case 1:
              if (!
#line 349 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                return -1;
              return 2448; /* *pred_th_extractrvvm4si */

            case 2:
              if (!
#line 349 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                return -1;
              return 2449; /* *pred_th_extractrvvm2si */

            case 3:
              if (!
#line 349 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                return -1;
              return 2450; /* *pred_th_extractrvvm1si */

            case 4:
              if (!(
#line 349 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 133 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
                return -1;
              return 2457; /* *pred_th_extractrvvmf2si */

            case 5:
              if (!(
#line 349 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 213 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
                return -1;
              return 2483; /* *pred_th_extractv1si */

            case 6:
              if (!(
#line 349 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 214 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
                return -1;
              return 2484; /* *pred_th_extractv2si */

            case 7:
              if (!(
#line 349 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 215 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
                return -1;
              return 2485; /* *pred_th_extractv4si */

            case 8:
              if (!(
#line 349 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 216 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
                return -1;
              return 2486; /* *pred_th_extractv8si */

            case 9:
              if (!(
#line 349 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 217 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 2487; /* *pred_th_extractv16si */

            case 10:
              if (!(
#line 349 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 218 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 2488; /* *pred_th_extractv32si */

            case 11:
              if (!(
#line 349 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 219 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 2489; /* *pred_th_extractv64si */

            case 12:
              if (!(
#line 349 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 220 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 2490; /* *pred_th_extractv128si */

            case 13:
              if (!(
#line 349 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 221 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 2491; /* *pred_th_extractv256si */

            case 14:
              if (!(
#line 349 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 222 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 2492; /* *pred_th_extractv512si */

            case 15:
              if (!(
#line 349 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 223 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 2493; /* *pred_th_extractv1024si */

            default:
              return -1;
            }

        case E_DImode:
          switch (pattern442 (x2))
            {
            case 0:
              if (!(
#line 349 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 2451; /* *pred_th_extractrvvm8di */

            case 1:
              if (!(
#line 349 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 2452; /* *pred_th_extractrvvm4di */

            case 2:
              if (!(
#line 349 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 2453; /* *pred_th_extractrvvm2di */

            case 3:
              if (!(
#line 349 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 2454; /* *pred_th_extractrvvm1di */

            case 4:
              if (!(
#line 349 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 224 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
                return -1;
              return 2494; /* *pred_th_extractv1di */

            case 5:
              if (!(
#line 349 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 225 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
                return -1;
              return 2495; /* *pred_th_extractv2di */

            case 6:
              if (!(
#line 349 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 226 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
                return -1;
              return 2496; /* *pred_th_extractv4di */

            case 7:
              if (!(
#line 349 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 227 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 2497; /* *pred_th_extractv8di */

            case 8:
              if (!(
#line 349 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 228 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 2498; /* *pred_th_extractv16di */

            case 9:
              if (!(
#line 349 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 229 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 2499; /* *pred_th_extractv32di */

            case 10:
              if (!(
#line 349 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 230 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 2500; /* *pred_th_extractv64di */

            case 11:
              if (!(
#line 349 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 231 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 2501; /* *pred_th_extractv128di */

            case 12:
              if (!(
#line 349 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 232 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 2502; /* *pred_th_extractv256di */

            case 13:
              if (!(
#line 349 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 233 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 2503; /* *pred_th_extractv512di */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case CONST_INT:
      return recog_30 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 int
recog_52 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode))
        return -1;
      switch (pattern171 ())
        {
        case 0:
          if (!(
#line 3585 "../../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT) && (
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT) && 
#line 105 "../../../gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX))))
            return -1;
          return 405; /* fclasssfsi */

        case 1:
          if (!(
#line 3585 "../../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT) && (
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT) && 
#line 106 "../../../gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX))))
            return -1;
          return 407; /* fclassdfsi */

        case 2:
          if (!(
#line 3585 "../../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT) && (
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT) && 
#line 107 "../../../gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX))))
            return -1;
          return 409; /* fclasshfsi */

        default:
          return -1;
        }

    case E_DImode:
      if (!register_operand (operands[0], E_DImode))
        return -1;
      switch (pattern171 ())
        {
        case 0:
          if (!(
#line 3585 "../../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT) && (
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT) && 
#line 105 "../../../gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX))))
            return -1;
          return 406; /* fclasssfdi */

        case 1:
          if (!(
#line 3585 "../../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT) && (
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT) && 
#line 106 "../../../gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX))))
            return -1;
          return 408; /* fclassdfdi */

        case 2:
          if (!(
#line 3585 "../../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT) && (
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT) && 
#line 107 "../../../gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX))))
            return -1;
          return 410; /* fclasshfdi */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_57 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern584 (x2, 
E_RVVMF16BImode) != 0)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  switch (GET_MODE (x3))
    {
    case E_RVVMF2QImode:
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_RVVMF2QImode
          || !register_operand (operands[2], E_QImode)
          || !register_operand (operands[1], E_RVVMF2QImode)
          || !
#line 3496 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8693; /* pred_madcrvvmf2qi_scalar */

    case E_RVVM1HImode:
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_RVVM1HImode
          || !register_operand (operands[2], E_HImode)
          || !register_operand (operands[1], E_RVVM1HImode)
          || !
#line 3496 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8699; /* pred_madcrvvm1hi_scalar */

    case E_RVVM2SImode:
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_RVVM2SImode
          || !register_operand (operands[2], E_SImode)
          || !register_operand (operands[1], E_RVVM2SImode)
          || !
#line 3496 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8704; /* pred_madcrvvm2si_scalar */

    case E_RVVM4DImode:
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_RVVM4DImode
          || !reg_or_0_operand (operands[2], E_DImode)
          || !register_operand (operands[1], E_RVVM4DImode)
          || !(
#line 3567 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 769 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 8798; /* *pred_madcrvvm4di_scalar */

    default:
      return -1;
    }
}

 int
recog_61 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM1QImode:
      x2 = XEXP (x1, 1);
      switch (pattern672 (x2, 
E_RVVM1QImode))
        {
        case 0:
          if (!
#line 7793 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18673; /* pred_redmin_vl0srvvm8qi */

        case 1:
          if (!
#line 7793 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18681; /* pred_redmin_vl0srvvm4qi */

        case 2:
          if (!
#line 7793 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18689; /* pred_redmin_vl0srvvm2qi */

        case 3:
          if (!
#line 7793 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18697; /* pred_redmin_vl0srvvm1qi */

        case 4:
          if (!(
#line 7793 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 18801; /* pred_redmin_vl0srvvmf2qi */

        case 5:
          if (!(
#line 7793 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 18809; /* pred_redmin_vl0srvvmf4qi */

        case 6:
          if (!(
#line 7793 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 18817; /* pred_redmin_vl0srvvmf8qi */

        case 7:
          if (!(
#line 7793 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 188 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
            return -1;
          return 18849; /* pred_redmin_vl0sv1qi */

        case 8:
          if (!(
#line 7793 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 189 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
            return -1;
          return 18857; /* pred_redmin_vl0sv2qi */

        case 9:
          if (!(
#line 7793 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 190 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
            return -1;
          return 18865; /* pred_redmin_vl0sv4qi */

        case 10:
          if (!(
#line 7793 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 191 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
            return -1;
          return 18873; /* pred_redmin_vl0sv8qi */

        case 11:
          if (!(
#line 7793 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 192 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
            return -1;
          return 18881; /* pred_redmin_vl0sv16qi */

        case 12:
          if (!(
#line 7793 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 193 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
            return -1;
          return 18889; /* pred_redmin_vl0sv32qi */

        case 13:
          if (!(
#line 7793 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 194 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 18897; /* pred_redmin_vl0sv64qi */

        case 14:
          if (!(
#line 7793 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 195 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 18905; /* pred_redmin_vl0sv128qi */

        case 15:
          if (!(
#line 7793 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 196 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 18913; /* pred_redmin_vl0sv256qi */

        case 16:
          if (!(
#line 7793 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 197 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 18921; /* pred_redmin_vl0sv512qi */

        case 17:
          if (!(
#line 7793 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 198 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 18929; /* pred_redmin_vl0sv1024qi */

        case 18:
          if (!(
#line 7793 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 199 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 18937; /* pred_redmin_vl0sv2048qi */

        case 19:
          if (!(
#line 7793 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 200 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 18945; /* pred_redmin_vl0sv4096qi */

        default:
          return -1;
        }

    case E_RVVM1HImode:
      x2 = XEXP (x1, 1);
      switch (pattern673 (x2, 
E_RVVM1HImode))
        {
        case 0:
          if (!
#line 7793 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18705; /* pred_redmin_vl0srvvm8hi */

        case 1:
          if (!
#line 7793 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18713; /* pred_redmin_vl0srvvm4hi */

        case 2:
          if (!
#line 7793 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18721; /* pred_redmin_vl0srvvm2hi */

        case 3:
          if (!
#line 7793 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18729; /* pred_redmin_vl0srvvm1hi */

        case 4:
          if (!(
#line 7793 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 18825; /* pred_redmin_vl0srvvmf2hi */

        case 5:
          if (!(
#line 7793 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 132 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 18833; /* pred_redmin_vl0srvvmf4hi */

        case 6:
          if (!(
#line 7793 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 201 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
            return -1;
          return 18953; /* pred_redmin_vl0sv1hi */

        case 7:
          if (!(
#line 7793 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 202 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
            return -1;
          return 18961; /* pred_redmin_vl0sv2hi */

        case 8:
          if (!(
#line 7793 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 203 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
            return -1;
          return 18969; /* pred_redmin_vl0sv4hi */

        case 9:
          if (!(
#line 7793 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 204 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
            return -1;
          return 18977; /* pred_redmin_vl0sv8hi */

        case 10:
          if (!(
#line 7793 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 205 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
            return -1;
          return 18985; /* pred_redmin_vl0sv16hi */

        case 11:
          if (!(
#line 7793 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 206 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 18993; /* pred_redmin_vl0sv32hi */

        case 12:
          if (!(
#line 7793 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 207 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 19001; /* pred_redmin_vl0sv64hi */

        case 13:
          if (!(
#line 7793 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 208 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 19009; /* pred_redmin_vl0sv128hi */

        case 14:
          if (!(
#line 7793 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 209 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 19017; /* pred_redmin_vl0sv256hi */

        case 15:
          if (!(
#line 7793 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 210 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 19025; /* pred_redmin_vl0sv512hi */

        case 16:
          if (!(
#line 7793 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 211 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 19033; /* pred_redmin_vl0sv1024hi */

        case 17:
          if (!(
#line 7793 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 212 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 19041; /* pred_redmin_vl0sv2048hi */

        default:
          return -1;
        }

    case E_RVVM1SImode:
      x2 = XEXP (x1, 1);
      switch (pattern674 (x2, 
E_RVVM1SImode))
        {
        case 0:
          if (!
#line 7793 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18737; /* pred_redmin_vl0srvvm8si */

        case 1:
          if (!
#line 7793 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18745; /* pred_redmin_vl0srvvm4si */

        case 2:
          if (!
#line 7793 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18753; /* pred_redmin_vl0srvvm2si */

        case 3:
          if (!
#line 7793 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18761; /* pred_redmin_vl0srvvm1si */

        case 4:
          if (!(
#line 7793 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 133 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 18841; /* pred_redmin_vl0srvvmf2si */

        case 5:
          if (!(
#line 7793 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 213 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return -1;
          return 19049; /* pred_redmin_vl0sv1si */

        case 6:
          if (!(
#line 7793 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 214 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return -1;
          return 19057; /* pred_redmin_vl0sv2si */

        case 7:
          if (!(
#line 7793 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 215 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
            return -1;
          return 19065; /* pred_redmin_vl0sv4si */

        case 8:
          if (!(
#line 7793 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 216 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
            return -1;
          return 19073; /* pred_redmin_vl0sv8si */

        case 9:
          if (!(
#line 7793 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 217 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 19081; /* pred_redmin_vl0sv16si */

        case 10:
          if (!(
#line 7793 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 218 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 19089; /* pred_redmin_vl0sv32si */

        case 11:
          if (!(
#line 7793 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 219 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 19097; /* pred_redmin_vl0sv64si */

        case 12:
          if (!(
#line 7793 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 220 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 19105; /* pred_redmin_vl0sv128si */

        case 13:
          if (!(
#line 7793 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 221 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 19113; /* pred_redmin_vl0sv256si */

        case 14:
          if (!(
#line 7793 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 222 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 19121; /* pred_redmin_vl0sv512si */

        case 15:
          if (!(
#line 7793 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 223 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 19129; /* pred_redmin_vl0sv1024si */

        default:
          return -1;
        }

    case E_RVVM1DImode:
      x2 = XEXP (x1, 1);
      switch (pattern675 (x2))
        {
        case 0:
          if (!(
#line 7793 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18769; /* pred_redmin_vl0srvvm8di */

        case 1:
          if (!(
#line 7793 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18777; /* pred_redmin_vl0srvvm4di */

        case 2:
          if (!(
#line 7793 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18785; /* pred_redmin_vl0srvvm2di */

        case 3:
          if (!(
#line 7793 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18793; /* pred_redmin_vl0srvvm1di */

        case 4:
          if (!(
#line 7793 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 224 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 19137; /* pred_redmin_vl0sv1di */

        case 5:
          if (!(
#line 7793 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 225 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 19145; /* pred_redmin_vl0sv2di */

        case 6:
          if (!(
#line 7793 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 226 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 19153; /* pred_redmin_vl0sv4di */

        case 7:
          if (!(
#line 7793 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 227 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 19161; /* pred_redmin_vl0sv8di */

        case 8:
          if (!(
#line 7793 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 228 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 19169; /* pred_redmin_vl0sv16di */

        case 9:
          if (!(
#line 7793 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 229 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 19177; /* pred_redmin_vl0sv32di */

        case 10:
          if (!(
#line 7793 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 230 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 19185; /* pred_redmin_vl0sv64di */

        case 11:
          if (!(
#line 7793 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 231 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 19193; /* pred_redmin_vl0sv128di */

        case 12:
          if (!(
#line 7793 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 232 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 19201; /* pred_redmin_vl0sv256di */

        case 13:
          if (!(
#line 7793 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 233 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 19209; /* pred_redmin_vl0sv512di */

        default:
          return -1;
        }

    case E_RVVM1HFmode:
      x2 = XEXP (x1, 1);
      switch (pattern676 (x2, 
E_RVVM1HFmode))
        {
        case 0:
          if (!(
#line 7879 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 19526; /* pred_redmin_vl0srvvm8hf */

        case 1:
          if (!(
#line 7879 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 19528; /* pred_redmin_vl0srvvm4hf */

        case 2:
          if (!(
#line 7879 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 19530; /* pred_redmin_vl0srvvm2hf */

        case 3:
          if (!(
#line 7879 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 19532; /* pred_redmin_vl0srvvm1hf */

        case 4:
          if (!(
#line 7879 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 19534; /* pred_redmin_vl0srvvmf2hf */

        case 5:
          if (!(
#line 7879 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 157 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
            return -1;
          return 19536; /* pred_redmin_vl0srvvmf4hf */

        case 6:
          if (!(
#line 7879 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 236 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
            return -1;
          return 19556; /* pred_redmin_vl0sv1hf */

        case 7:
          if (!(
#line 7879 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 237 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
            return -1;
          return 19558; /* pred_redmin_vl0sv2hf */

        case 8:
          if (!(
#line 7879 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 238 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
            return -1;
          return 19560; /* pred_redmin_vl0sv4hf */

        case 9:
          if (!(
#line 7879 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 239 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
            return -1;
          return 19562; /* pred_redmin_vl0sv8hf */

        case 10:
          if (!(
#line 7879 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 240 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
            return -1;
          return 19564; /* pred_redmin_vl0sv16hf */

        case 11:
          if (!(
#line 7879 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 241 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 19566; /* pred_redmin_vl0sv32hf */

        case 12:
          if (!(
#line 7879 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 242 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 19568; /* pred_redmin_vl0sv64hf */

        case 13:
          if (!(
#line 7879 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 243 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 19570; /* pred_redmin_vl0sv128hf */

        case 14:
          if (!(
#line 7879 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 244 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 19572; /* pred_redmin_vl0sv256hf */

        case 15:
          if (!(
#line 7879 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 245 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 19574; /* pred_redmin_vl0sv512hf */

        case 16:
          if (!(
#line 7879 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 246 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 19576; /* pred_redmin_vl0sv1024hf */

        case 17:
          if (!(
#line 7879 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 247 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 19578; /* pred_redmin_vl0sv2048hf */

        default:
          return -1;
        }

    case E_RVVM1SFmode:
      x2 = XEXP (x1, 1);
      switch (pattern677 (x2, 
E_RVVM1SFmode))
        {
        case 0:
          if (!(
#line 7879 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 19538; /* pred_redmin_vl0srvvm8sf */

        case 1:
          if (!(
#line 7879 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 19540; /* pred_redmin_vl0srvvm4sf */

        case 2:
          if (!(
#line 7879 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 19542; /* pred_redmin_vl0srvvm2sf */

        case 3:
          if (!(
#line 7879 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 19544; /* pred_redmin_vl0srvvm1sf */

        case 4:
          if (!(
#line 7879 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
            return -1;
          return 19546; /* pred_redmin_vl0srvvmf2sf */

        case 5:
          if (!(
#line 7879 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 248 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 19580; /* pred_redmin_vl0sv1sf */

        case 6:
          if (!(
#line 7879 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 249 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 19582; /* pred_redmin_vl0sv2sf */

        case 7:
          if (!(
#line 7879 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 250 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 19584; /* pred_redmin_vl0sv4sf */

        case 8:
          if (!(
#line 7879 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 251 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 19586; /* pred_redmin_vl0sv8sf */

        case 9:
          if (!(
#line 7879 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 252 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 19588; /* pred_redmin_vl0sv16sf */

        case 10:
          if (!(
#line 7879 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 253 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 19590; /* pred_redmin_vl0sv32sf */

        case 11:
          if (!(
#line 7879 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 254 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 19592; /* pred_redmin_vl0sv64sf */

        case 12:
          if (!(
#line 7879 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 255 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 19594; /* pred_redmin_vl0sv128sf */

        case 13:
          if (!(
#line 7879 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 256 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 19596; /* pred_redmin_vl0sv256sf */

        case 14:
          if (!(
#line 7879 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 257 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 19598; /* pred_redmin_vl0sv512sf */

        case 15:
          if (!(
#line 7879 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 258 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 19600; /* pred_redmin_vl0sv1024sf */

        default:
          return -1;
        }

    case E_RVVM1DFmode:
      x2 = XEXP (x1, 1);
      switch (pattern678 (x2))
        {
        case 0:
          if (!(
#line 7879 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 19548; /* pred_redmin_vl0srvvm8df */

        case 1:
          if (!(
#line 7879 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 19550; /* pred_redmin_vl0srvvm4df */

        case 2:
          if (!(
#line 7879 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 19552; /* pred_redmin_vl0srvvm2df */

        case 3:
          if (!(
#line 7879 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 19554; /* pred_redmin_vl0srvvm1df */

        case 4:
          if (!(
#line 7879 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 259 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 19602; /* pred_redmin_vl0sv1df */

        case 5:
          if (!(
#line 7879 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 260 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 19604; /* pred_redmin_vl0sv2df */

        case 6:
          if (!(
#line 7879 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 261 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 19606; /* pred_redmin_vl0sv4df */

        case 7:
          if (!(
#line 7879 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 262 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 19608; /* pred_redmin_vl0sv8df */

        case 8:
          if (!(
#line 7879 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 263 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 19610; /* pred_redmin_vl0sv16df */

        case 9:
          if (!(
#line 7879 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 264 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 19612; /* pred_redmin_vl0sv32df */

        case 10:
          if (!(
#line 7879 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 265 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 19614; /* pred_redmin_vl0sv64df */

        case 11:
          if (!(
#line 7879 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 266 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 19616; /* pred_redmin_vl0sv128df */

        case 12:
          if (!(
#line 7879 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 267 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 19618; /* pred_redmin_vl0sv256df */

        case 13:
          if (!(
#line 7879 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 268 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 19620; /* pred_redmin_vl0sv512df */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_72 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM1QImode:
      x2 = XEXP (x1, 1);
      switch (pattern672 (x2, 
E_RVVM1QImode))
        {
        case 0:
          if (!
#line 7771 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18131; /* pred_redorrvvm8qi */

        case 1:
          if (!
#line 7771 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18139; /* pred_redorrvvm4qi */

        case 2:
          if (!
#line 7771 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18147; /* pred_redorrvvm2qi */

        case 3:
          if (!
#line 7771 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18155; /* pred_redorrvvm1qi */

        case 4:
          if (!(
#line 7771 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 18259; /* pred_redorrvvmf2qi */

        case 5:
          if (!(
#line 7771 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 18267; /* pred_redorrvvmf4qi */

        case 6:
          if (!(
#line 7771 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 18275; /* pred_redorrvvmf8qi */

        case 7:
          if (!(
#line 7771 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 188 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
            return -1;
          return 18307; /* pred_redorv1qi */

        case 8:
          if (!(
#line 7771 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 189 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
            return -1;
          return 18315; /* pred_redorv2qi */

        case 9:
          if (!(
#line 7771 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 190 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
            return -1;
          return 18323; /* pred_redorv4qi */

        case 10:
          if (!(
#line 7771 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 191 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
            return -1;
          return 18331; /* pred_redorv8qi */

        case 11:
          if (!(
#line 7771 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 192 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
            return -1;
          return 18339; /* pred_redorv16qi */

        case 12:
          if (!(
#line 7771 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 193 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
            return -1;
          return 18347; /* pred_redorv32qi */

        case 13:
          if (!(
#line 7771 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 194 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 18355; /* pred_redorv64qi */

        case 14:
          if (!(
#line 7771 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 195 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 18363; /* pred_redorv128qi */

        case 15:
          if (!(
#line 7771 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 196 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 18371; /* pred_redorv256qi */

        case 16:
          if (!(
#line 7771 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 197 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 18379; /* pred_redorv512qi */

        case 17:
          if (!(
#line 7771 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 198 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 18387; /* pred_redorv1024qi */

        case 18:
          if (!(
#line 7771 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 199 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 18395; /* pred_redorv2048qi */

        case 19:
          if (!(
#line 7771 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 200 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 18403; /* pred_redorv4096qi */

        default:
          return -1;
        }

    case E_RVVM1HImode:
      x2 = XEXP (x1, 1);
      switch (pattern673 (x2, 
E_RVVM1HImode))
        {
        case 0:
          if (!
#line 7771 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18163; /* pred_redorrvvm8hi */

        case 1:
          if (!
#line 7771 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18171; /* pred_redorrvvm4hi */

        case 2:
          if (!
#line 7771 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18179; /* pred_redorrvvm2hi */

        case 3:
          if (!
#line 7771 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18187; /* pred_redorrvvm1hi */

        case 4:
          if (!(
#line 7771 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 18283; /* pred_redorrvvmf2hi */

        case 5:
          if (!(
#line 7771 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 132 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 18291; /* pred_redorrvvmf4hi */

        case 6:
          if (!(
#line 7771 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 201 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
            return -1;
          return 18411; /* pred_redorv1hi */

        case 7:
          if (!(
#line 7771 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 202 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
            return -1;
          return 18419; /* pred_redorv2hi */

        case 8:
          if (!(
#line 7771 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 203 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
            return -1;
          return 18427; /* pred_redorv4hi */

        case 9:
          if (!(
#line 7771 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 204 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
            return -1;
          return 18435; /* pred_redorv8hi */

        case 10:
          if (!(
#line 7771 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 205 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
            return -1;
          return 18443; /* pred_redorv16hi */

        case 11:
          if (!(
#line 7771 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 206 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 18451; /* pred_redorv32hi */

        case 12:
          if (!(
#line 7771 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 207 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 18459; /* pred_redorv64hi */

        case 13:
          if (!(
#line 7771 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 208 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 18467; /* pred_redorv128hi */

        case 14:
          if (!(
#line 7771 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 209 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 18475; /* pred_redorv256hi */

        case 15:
          if (!(
#line 7771 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 210 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 18483; /* pred_redorv512hi */

        case 16:
          if (!(
#line 7771 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 211 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 18491; /* pred_redorv1024hi */

        case 17:
          if (!(
#line 7771 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 212 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 18499; /* pred_redorv2048hi */

        default:
          return -1;
        }

    case E_RVVM1SImode:
      x2 = XEXP (x1, 1);
      switch (pattern674 (x2, 
E_RVVM1SImode))
        {
        case 0:
          if (!
#line 7771 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18195; /* pred_redorrvvm8si */

        case 1:
          if (!
#line 7771 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18203; /* pred_redorrvvm4si */

        case 2:
          if (!
#line 7771 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18211; /* pred_redorrvvm2si */

        case 3:
          if (!
#line 7771 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18219; /* pred_redorrvvm1si */

        case 4:
          if (!(
#line 7771 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 133 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 18299; /* pred_redorrvvmf2si */

        case 5:
          if (!(
#line 7771 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 213 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return -1;
          return 18507; /* pred_redorv1si */

        case 6:
          if (!(
#line 7771 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 214 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return -1;
          return 18515; /* pred_redorv2si */

        case 7:
          if (!(
#line 7771 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 215 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
            return -1;
          return 18523; /* pred_redorv4si */

        case 8:
          if (!(
#line 7771 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 216 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
            return -1;
          return 18531; /* pred_redorv8si */

        case 9:
          if (!(
#line 7771 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 217 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 18539; /* pred_redorv16si */

        case 10:
          if (!(
#line 7771 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 218 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 18547; /* pred_redorv32si */

        case 11:
          if (!(
#line 7771 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 219 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 18555; /* pred_redorv64si */

        case 12:
          if (!(
#line 7771 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 220 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 18563; /* pred_redorv128si */

        case 13:
          if (!(
#line 7771 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 221 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 18571; /* pred_redorv256si */

        case 14:
          if (!(
#line 7771 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 222 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 18579; /* pred_redorv512si */

        case 15:
          if (!(
#line 7771 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 223 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 18587; /* pred_redorv1024si */

        default:
          return -1;
        }

    case E_RVVM1DImode:
      x2 = XEXP (x1, 1);
      switch (pattern675 (x2))
        {
        case 0:
          if (!(
#line 7771 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18227; /* pred_redorrvvm8di */

        case 1:
          if (!(
#line 7771 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18235; /* pred_redorrvvm4di */

        case 2:
          if (!(
#line 7771 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18243; /* pred_redorrvvm2di */

        case 3:
          if (!(
#line 7771 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18251; /* pred_redorrvvm1di */

        case 4:
          if (!(
#line 7771 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 224 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18595; /* pred_redorv1di */

        case 5:
          if (!(
#line 7771 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 225 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18603; /* pred_redorv2di */

        case 6:
          if (!(
#line 7771 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 226 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18611; /* pred_redorv4di */

        case 7:
          if (!(
#line 7771 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 227 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 18619; /* pred_redorv8di */

        case 8:
          if (!(
#line 7771 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 228 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 18627; /* pred_redorv16di */

        case 9:
          if (!(
#line 7771 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 229 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 18635; /* pred_redorv32di */

        case 10:
          if (!(
#line 7771 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 230 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 18643; /* pred_redorv64di */

        case 11:
          if (!(
#line 7771 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 231 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 18651; /* pred_redorv128di */

        case 12:
          if (!(
#line 7771 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 232 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 18659; /* pred_redorv256di */

        case 13:
          if (!(
#line 7771 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 233 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 18667; /* pred_redorv512di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_80 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM1HFmode:
      x2 = XEXP (x1, 1);
      switch (pattern676 (x2, 
E_RVVM1HFmode))
        {
        case 0:
          if (!(
#line 7902 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 19622; /* pred_redusumrvvm8hf */

        case 1:
          if (!(
#line 7902 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 19624; /* pred_redusumrvvm4hf */

        case 2:
          if (!(
#line 7902 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 19626; /* pred_redusumrvvm2hf */

        case 3:
          if (!(
#line 7902 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 19628; /* pred_redusumrvvm1hf */

        case 4:
          if (!(
#line 7902 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 19630; /* pred_redusumrvvmf2hf */

        case 5:
          if (!(
#line 7902 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 157 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
            return -1;
          return 19632; /* pred_redusumrvvmf4hf */

        case 6:
          if (!(
#line 7902 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 236 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
            return -1;
          return 19652; /* pred_redusumv1hf */

        case 7:
          if (!(
#line 7902 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 237 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
            return -1;
          return 19654; /* pred_redusumv2hf */

        case 8:
          if (!(
#line 7902 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 238 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
            return -1;
          return 19656; /* pred_redusumv4hf */

        case 9:
          if (!(
#line 7902 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 239 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
            return -1;
          return 19658; /* pred_redusumv8hf */

        case 10:
          if (!(
#line 7902 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 240 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
            return -1;
          return 19660; /* pred_redusumv16hf */

        case 11:
          if (!(
#line 7902 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 241 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 19662; /* pred_redusumv32hf */

        case 12:
          if (!(
#line 7902 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 242 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 19664; /* pred_redusumv64hf */

        case 13:
          if (!(
#line 7902 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 243 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 19666; /* pred_redusumv128hf */

        case 14:
          if (!(
#line 7902 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 244 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 19668; /* pred_redusumv256hf */

        case 15:
          if (!(
#line 7902 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 245 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 19670; /* pred_redusumv512hf */

        case 16:
          if (!(
#line 7902 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 246 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 19672; /* pred_redusumv1024hf */

        case 17:
          if (!(
#line 7902 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 247 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 19674; /* pred_redusumv2048hf */

        default:
          return -1;
        }

    case E_RVVM1SFmode:
      x2 = XEXP (x1, 1);
      switch (pattern677 (x2, 
E_RVVM1SFmode))
        {
        case 0:
          if (!(
#line 7902 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 19634; /* pred_redusumrvvm8sf */

        case 1:
          if (!(
#line 7902 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 19636; /* pred_redusumrvvm4sf */

        case 2:
          if (!(
#line 7902 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 19638; /* pred_redusumrvvm2sf */

        case 3:
          if (!(
#line 7902 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 19640; /* pred_redusumrvvm1sf */

        case 4:
          if (!(
#line 7902 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
            return -1;
          return 19642; /* pred_redusumrvvmf2sf */

        case 5:
          if (!(
#line 7902 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 248 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 19676; /* pred_redusumv1sf */

        case 6:
          if (!(
#line 7902 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 249 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 19678; /* pred_redusumv2sf */

        case 7:
          if (!(
#line 7902 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 250 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 19680; /* pred_redusumv4sf */

        case 8:
          if (!(
#line 7902 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 251 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 19682; /* pred_redusumv8sf */

        case 9:
          if (!(
#line 7902 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 252 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 19684; /* pred_redusumv16sf */

        case 10:
          if (!(
#line 7902 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 253 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 19686; /* pred_redusumv32sf */

        case 11:
          if (!(
#line 7902 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 254 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 19688; /* pred_redusumv64sf */

        case 12:
          if (!(
#line 7902 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 255 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 19690; /* pred_redusumv128sf */

        case 13:
          if (!(
#line 7902 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 256 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 19692; /* pred_redusumv256sf */

        case 14:
          if (!(
#line 7902 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 257 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 19694; /* pred_redusumv512sf */

        case 15:
          if (!(
#line 7902 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 258 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 19696; /* pred_redusumv1024sf */

        default:
          return -1;
        }

    case E_RVVM1DFmode:
      x2 = XEXP (x1, 1);
      switch (pattern678 (x2))
        {
        case 0:
          if (!(
#line 7902 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 19644; /* pred_redusumrvvm8df */

        case 1:
          if (!(
#line 7902 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 19646; /* pred_redusumrvvm4df */

        case 2:
          if (!(
#line 7902 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 19648; /* pred_redusumrvvm2df */

        case 3:
          if (!(
#line 7902 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 19650; /* pred_redusumrvvm1df */

        case 4:
          if (!(
#line 7902 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 259 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 19698; /* pred_redusumv1df */

        case 5:
          if (!(
#line 7902 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 260 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 19700; /* pred_redusumv2df */

        case 6:
          if (!(
#line 7902 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 261 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 19702; /* pred_redusumv4df */

        case 7:
          if (!(
#line 7902 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 262 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 19704; /* pred_redusumv8df */

        case 8:
          if (!(
#line 7902 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 263 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 19706; /* pred_redusumv16df */

        case 9:
          if (!(
#line 7902 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 264 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 19708; /* pred_redusumv32df */

        case 10:
          if (!(
#line 7902 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 265 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 19710; /* pred_redusumv64df */

        case 11:
          if (!(
#line 7902 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 266 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 19712; /* pred_redusumv128df */

        case 12:
          if (!(
#line 7902 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 267 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 19714; /* pred_redusumv256df */

        case 13:
          if (!(
#line 7902 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 268 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 19716; /* pred_redusumv512df */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_87 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern446 (x2))
    {
    case 0:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 940; /* pred_th_whole_movrvvm8qi */

    case 1:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 941; /* pred_th_whole_movrvvm4qi */

    case 2:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 942; /* pred_th_whole_movrvvm2qi */

    case 3:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 943; /* pred_th_whole_movrvvm1qi */

    case 4:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 944; /* pred_th_whole_movrvvm8hi */

    case 5:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 945; /* pred_th_whole_movrvvm4hi */

    case 6:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 946; /* pred_th_whole_movrvvm2hi */

    case 7:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 947; /* pred_th_whole_movrvvm1hi */

    case 8:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 948; /* pred_th_whole_movrvvm8si */

    case 9:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 949; /* pred_th_whole_movrvvm4si */

    case 10:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 950; /* pred_th_whole_movrvvm2si */

    case 11:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 951; /* pred_th_whole_movrvvm1si */

    case 12:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 952; /* pred_th_whole_movrvvm8di */

    case 13:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 953; /* pred_th_whole_movrvvm4di */

    case 14:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 954; /* pred_th_whole_movrvvm2di */

    case 15:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 955; /* pred_th_whole_movrvvm1di */

    case 16:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 956; /* pred_th_whole_movrvvmf8qi */

    case 17:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 132 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 957; /* pred_th_whole_movrvvmf4hi */

    case 18:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 133 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 958; /* pred_th_whole_movrvvmf2si */

    case 19:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 167 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 959; /* pred_th_whole_movrvvm8bf */

    case 20:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 168 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 960; /* pred_th_whole_movrvvm4bf */

    case 21:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 169 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 961; /* pred_th_whole_movrvvm2bf */

    case 22:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 170 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 962; /* pred_th_whole_movrvvm1bf */

    case 23:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 171 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 963; /* pred_th_whole_movrvvmf2bf */

    case 24:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 172 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 964; /* pred_th_whole_movrvvmf4bf */

    case 25:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 176 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 965; /* pred_th_whole_movrvvm8hf */

    case 26:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 176 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 966; /* pred_th_whole_movrvvm4hf */

    case 27:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 176 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 967; /* pred_th_whole_movrvvm2hf */

    case 28:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 177 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 968; /* pred_th_whole_movrvvm1hf */

    case 29:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 177 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 969; /* pred_th_whole_movrvvmf2hf */

    case 30:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 178 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 970; /* pred_th_whole_movrvvmf4hf */

    case 31:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 180 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 971; /* pred_th_whole_movrvvm8sf */

    case 32:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 180 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 972; /* pred_th_whole_movrvvm4sf */

    case 33:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 180 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 973; /* pred_th_whole_movrvvm2sf */

    case 34:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 181 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 974; /* pred_th_whole_movrvvm1sf */

    case 35:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 181 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 975; /* pred_th_whole_movrvvmf2sf */

    case 36:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 183 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 976; /* pred_th_whole_movrvvm8df */

    case 37:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 183 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 977; /* pred_th_whole_movrvvm4df */

    case 38:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 184 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 978; /* pred_th_whole_movrvvm2df */

    case 39:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 184 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 979; /* pred_th_whole_movrvvm1df */

    case 40:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 188 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 980; /* pred_th_whole_movv1qi */

    case 41:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 189 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 981; /* pred_th_whole_movv2qi */

    case 42:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 190 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 982; /* pred_th_whole_movv4qi */

    case 43:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 191 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 983; /* pred_th_whole_movv8qi */

    case 44:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 192 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 984; /* pred_th_whole_movv16qi */

    case 45:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 193 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 985; /* pred_th_whole_movv32qi */

    case 46:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 194 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 986; /* pred_th_whole_movv64qi */

    case 47:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 195 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 987; /* pred_th_whole_movv128qi */

    case 48:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 196 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 988; /* pred_th_whole_movv256qi */

    case 49:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 197 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 989; /* pred_th_whole_movv512qi */

    case 50:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 198 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 990; /* pred_th_whole_movv1024qi */

    case 51:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 199 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 991; /* pred_th_whole_movv2048qi */

    case 52:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 200 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 992; /* pred_th_whole_movv4096qi */

    case 53:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 201 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 993; /* pred_th_whole_movv1hi */

    case 54:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 202 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 994; /* pred_th_whole_movv2hi */

    case 55:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 203 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 995; /* pred_th_whole_movv4hi */

    case 56:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 204 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 996; /* pred_th_whole_movv8hi */

    case 57:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 205 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 997; /* pred_th_whole_movv16hi */

    case 58:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 206 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 998; /* pred_th_whole_movv32hi */

    case 59:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 207 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 999; /* pred_th_whole_movv64hi */

    case 60:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 208 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 1000; /* pred_th_whole_movv128hi */

    case 61:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 209 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 1001; /* pred_th_whole_movv256hi */

    case 62:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 210 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 1002; /* pred_th_whole_movv512hi */

    case 63:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 211 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 1003; /* pred_th_whole_movv1024hi */

    case 64:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 212 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 1004; /* pred_th_whole_movv2048hi */

    case 65:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 213 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 1005; /* pred_th_whole_movv1si */

    case 66:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 214 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 1006; /* pred_th_whole_movv2si */

    case 67:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 215 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 1007; /* pred_th_whole_movv4si */

    case 68:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 216 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 1008; /* pred_th_whole_movv8si */

    case 69:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 217 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 1009; /* pred_th_whole_movv16si */

    case 70:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 218 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 1010; /* pred_th_whole_movv32si */

    case 71:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 219 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 1011; /* pred_th_whole_movv64si */

    case 72:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 220 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 1012; /* pred_th_whole_movv128si */

    case 73:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 221 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 1013; /* pred_th_whole_movv256si */

    case 74:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 222 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 1014; /* pred_th_whole_movv512si */

    case 75:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 223 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 1015; /* pred_th_whole_movv1024si */

    case 76:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 224 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1016; /* pred_th_whole_movv1di */

    case 77:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 225 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1017; /* pred_th_whole_movv2di */

    case 78:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 226 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1018; /* pred_th_whole_movv4di */

    case 79:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 227 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 1019; /* pred_th_whole_movv8di */

    case 80:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 228 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 1020; /* pred_th_whole_movv16di */

    case 81:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 229 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 1021; /* pred_th_whole_movv32di */

    case 82:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 230 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 1022; /* pred_th_whole_movv64di */

    case 83:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 231 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 1023; /* pred_th_whole_movv128di */

    case 84:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 232 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 1024; /* pred_th_whole_movv256di */

    case 85:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 233 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 1025; /* pred_th_whole_movv512di */

    case 86:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 272 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1026; /* pred_th_whole_movv1hf */

    case 87:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 273 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1027; /* pred_th_whole_movv2hf */

    case 88:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 274 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1028; /* pred_th_whole_movv4hf */

    case 89:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 275 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1029; /* pred_th_whole_movv8hf */

    case 90:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 276 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1030; /* pred_th_whole_movv16hf */

    case 91:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 277 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 1031; /* pred_th_whole_movv32hf */

    case 92:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 278 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 1032; /* pred_th_whole_movv64hf */

    case 93:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 279 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 1033; /* pred_th_whole_movv128hf */

    case 94:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 280 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 1034; /* pred_th_whole_movv256hf */

    case 95:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 281 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 1035; /* pred_th_whole_movv512hf */

    case 96:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 282 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 1036; /* pred_th_whole_movv1024hf */

    case 97:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 283 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 1037; /* pred_th_whole_movv2048hf */

    case 98:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 284 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1038; /* pred_th_whole_movv1sf */

    case 99:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 285 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1039; /* pred_th_whole_movv2sf */

    case 100:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 286 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1040; /* pred_th_whole_movv4sf */

    case 101:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 287 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1041; /* pred_th_whole_movv8sf */

    case 102:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 288 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 1042; /* pred_th_whole_movv16sf */

    case 103:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 289 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 1043; /* pred_th_whole_movv32sf */

    case 104:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 290 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 1044; /* pred_th_whole_movv64sf */

    case 105:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 291 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 1045; /* pred_th_whole_movv128sf */

    case 106:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 292 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 1046; /* pred_th_whole_movv256sf */

    case 107:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 293 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 1047; /* pred_th_whole_movv512sf */

    case 108:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 294 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 1048; /* pred_th_whole_movv1024sf */

    case 109:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 295 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 1049; /* pred_th_whole_movv1df */

    case 110:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 296 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 1050; /* pred_th_whole_movv2df */

    case 111:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 297 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 1051; /* pred_th_whole_movv4df */

    case 112:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 298 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 1052; /* pred_th_whole_movv8df */

    case 113:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 299 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 1053; /* pred_th_whole_movv16df */

    case 114:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 300 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 1054; /* pred_th_whole_movv32df */

    case 115:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 301 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 1055; /* pred_th_whole_movv64df */

    case 116:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 302 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 1056; /* pred_th_whole_movv128df */

    case 117:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 303 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 1057; /* pred_th_whole_movv256df */

    case 118:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 304 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 1058; /* pred_th_whole_movv512df */

    case 119:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1167 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 1059; /* pred_th_whole_movrvvmf8x2qi */

    case 120:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1168 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 1060; /* pred_th_whole_movrvvmf8x3qi */

    case 121:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1169 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 1061; /* pred_th_whole_movrvvmf8x4qi */

    case 122:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1170 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 1062; /* pred_th_whole_movrvvmf8x5qi */

    case 123:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1171 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 1063; /* pred_th_whole_movrvvmf8x6qi */

    case 124:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1172 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 1064; /* pred_th_whole_movrvvmf8x7qi */

    case 125:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1173 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 1065; /* pred_th_whole_movrvvmf8x8qi */

    case 126:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1174 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 1066; /* pred_th_whole_movrvvmf4x2hi */

    case 127:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1175 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 1067; /* pred_th_whole_movrvvmf4x3hi */

    case 128:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1176 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 1068; /* pred_th_whole_movrvvmf4x4hi */

    case 129:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1177 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 1069; /* pred_th_whole_movrvvmf4x5hi */

    case 130:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1178 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 1070; /* pred_th_whole_movrvvmf4x6hi */

    case 131:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1179 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 1071; /* pred_th_whole_movrvvmf4x7hi */

    case 132:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1180 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 1072; /* pred_th_whole_movrvvmf4x8hi */

    case 133:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1181 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 1073; /* pred_th_whole_movrvvmf2x2si */

    case 134:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1182 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 1074; /* pred_th_whole_movrvvmf2x3si */

    case 135:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1183 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 1075; /* pred_th_whole_movrvvmf2x4si */

    case 136:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1184 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 1076; /* pred_th_whole_movrvvmf2x5si */

    case 137:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1185 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 1077; /* pred_th_whole_movrvvmf2x6si */

    case 138:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1186 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 1078; /* pred_th_whole_movrvvmf2x7si */

    case 139:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1187 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 1079; /* pred_th_whole_movrvvmf2x8si */

    case 140:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1188 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1080; /* pred_th_whole_movrvvm1x2di */

    case 141:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1189 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1081; /* pred_th_whole_movrvvm1x3di */

    case 142:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1190 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1082; /* pred_th_whole_movrvvm1x4di */

    case 143:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1191 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1083; /* pred_th_whole_movrvvm1x5di */

    case 144:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1192 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1084; /* pred_th_whole_movrvvm1x6di */

    case 145:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1193 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1085; /* pred_th_whole_movrvvm1x7di */

    case 146:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1194 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1086; /* pred_th_whole_movrvvm1x8di */

    case 147:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1195 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 1087; /* pred_th_whole_movrvvmf4x2bf */

    case 148:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1196 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 1088; /* pred_th_whole_movrvvmf4x3bf */

    case 149:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1197 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 1089; /* pred_th_whole_movrvvmf4x4bf */

    case 150:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1198 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 1090; /* pred_th_whole_movrvvmf4x5bf */

    case 151:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1199 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 1091; /* pred_th_whole_movrvvmf4x6bf */

    case 152:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1200 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 1092; /* pred_th_whole_movrvvmf4x7bf */

    case 153:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1201 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 1093; /* pred_th_whole_movrvvmf4x8bf */

    case 154:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1202 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1094; /* pred_th_whole_movrvvmf4x2hf */

    case 155:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1203 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1095; /* pred_th_whole_movrvvmf4x3hf */

    case 156:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1204 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1096; /* pred_th_whole_movrvvmf4x4hf */

    case 157:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1205 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1097; /* pred_th_whole_movrvvmf4x5hf */

    case 158:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1206 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1098; /* pred_th_whole_movrvvmf4x6hf */

    case 159:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1207 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1099; /* pred_th_whole_movrvvmf4x7hf */

    case 160:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1208 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1100; /* pred_th_whole_movrvvmf4x8hf */

    case 161:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1209 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1101; /* pred_th_whole_movrvvmf2x2sf */

    case 162:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1210 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1102; /* pred_th_whole_movrvvmf2x3sf */

    case 163:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1211 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1103; /* pred_th_whole_movrvvmf2x4sf */

    case 164:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1212 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1104; /* pred_th_whole_movrvvmf2x5sf */

    case 165:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1213 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1105; /* pred_th_whole_movrvvmf2x6sf */

    case 166:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1214 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1106; /* pred_th_whole_movrvvmf2x7sf */

    case 167:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1215 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1107; /* pred_th_whole_movrvvmf2x8sf */

    case 168:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1216 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 1108; /* pred_th_whole_movrvvm1x2df */

    case 169:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1217 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 1109; /* pred_th_whole_movrvvm1x3df */

    case 170:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1218 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 1110; /* pred_th_whole_movrvvm1x4df */

    case 171:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1219 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 1111; /* pred_th_whole_movrvvm1x5df */

    case 172:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1220 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 1112; /* pred_th_whole_movrvvm1x6df */

    case 173:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1221 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 1113; /* pred_th_whole_movrvvm1x7df */

    case 174:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1222 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 1114; /* pred_th_whole_movrvvm1x8df */

    case 175:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1115; /* pred_th_whole_movrvvmf4x2qi */

    case 176:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1116; /* pred_th_whole_movrvvmf4x3qi */

    case 177:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1117; /* pred_th_whole_movrvvmf4x4qi */

    case 178:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1118; /* pred_th_whole_movrvvmf4x5qi */

    case 179:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1119; /* pred_th_whole_movrvvmf4x6qi */

    case 180:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1120; /* pred_th_whole_movrvvmf4x7qi */

    case 181:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1121; /* pred_th_whole_movrvvmf4x8qi */

    case 182:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1122; /* pred_th_whole_movrvvmf2x2hi */

    case 183:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1123; /* pred_th_whole_movrvvmf2x3hi */

    case 184:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1124; /* pred_th_whole_movrvvmf2x4hi */

    case 185:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1125; /* pred_th_whole_movrvvmf2x5hi */

    case 186:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1126; /* pred_th_whole_movrvvmf2x6hi */

    case 187:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1127; /* pred_th_whole_movrvvmf2x7hi */

    case 188:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1128; /* pred_th_whole_movrvvmf2x8hi */

    case 189:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1129; /* pred_th_whole_movrvvm1x2si */

    case 190:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1130; /* pred_th_whole_movrvvm1x3si */

    case 191:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1131; /* pred_th_whole_movrvvm1x4si */

    case 192:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1132; /* pred_th_whole_movrvvm1x5si */

    case 193:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1133; /* pred_th_whole_movrvvm1x6si */

    case 194:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1134; /* pred_th_whole_movrvvm1x7si */

    case 195:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1135; /* pred_th_whole_movrvvm1x8si */

    case 196:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1247 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1136; /* pred_th_whole_movrvvm2x2di */

    case 197:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1248 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1137; /* pred_th_whole_movrvvm2x3di */

    case 198:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1249 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1138; /* pred_th_whole_movrvvm2x4di */

    case 199:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1250 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 1139; /* pred_th_whole_movrvvmf2x2bf */

    case 200:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1251 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 1140; /* pred_th_whole_movrvvmf2x3bf */

    case 201:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1252 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 1141; /* pred_th_whole_movrvvmf2x4bf */

    case 202:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1253 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 1142; /* pred_th_whole_movrvvmf2x5bf */

    case 203:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1254 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 1143; /* pred_th_whole_movrvvmf2x6bf */

    case 204:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1255 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 1144; /* pred_th_whole_movrvvmf2x7bf */

    case 205:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1256 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 1145; /* pred_th_whole_movrvvmf2x8bf */

    case 206:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1257 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1146; /* pred_th_whole_movrvvmf2x2hf */

    case 207:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1258 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1147; /* pred_th_whole_movrvvmf2x3hf */

    case 208:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1259 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1148; /* pred_th_whole_movrvvmf2x4hf */

    case 209:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1260 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1149; /* pred_th_whole_movrvvmf2x5hf */

    case 210:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1261 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1150; /* pred_th_whole_movrvvmf2x6hf */

    case 211:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1262 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1151; /* pred_th_whole_movrvvmf2x7hf */

    case 212:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1263 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1152; /* pred_th_whole_movrvvmf2x8hf */

    case 213:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1264 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1153; /* pred_th_whole_movrvvm1x2sf */

    case 214:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1265 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1154; /* pred_th_whole_movrvvm1x3sf */

    case 215:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1266 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1155; /* pred_th_whole_movrvvm1x4sf */

    case 216:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1267 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1156; /* pred_th_whole_movrvvm1x5sf */

    case 217:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1268 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1157; /* pred_th_whole_movrvvm1x6sf */

    case 218:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1269 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1158; /* pred_th_whole_movrvvm1x7sf */

    case 219:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1270 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1159; /* pred_th_whole_movrvvm1x8sf */

    case 220:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1271 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 1160; /* pred_th_whole_movrvvm2x2df */

    case 221:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1272 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 1161; /* pred_th_whole_movrvvm2x3df */

    case 222:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1273 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 1162; /* pred_th_whole_movrvvm2x4df */

    case 223:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1163; /* pred_th_whole_movrvvmf2x2qi */

    case 224:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1164; /* pred_th_whole_movrvvmf2x3qi */

    case 225:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1165; /* pred_th_whole_movrvvmf2x4qi */

    case 226:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1166; /* pred_th_whole_movrvvmf2x5qi */

    case 227:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1167; /* pred_th_whole_movrvvmf2x6qi */

    case 228:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1168; /* pred_th_whole_movrvvmf2x7qi */

    case 229:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1169; /* pred_th_whole_movrvvmf2x8qi */

    case 230:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1170; /* pred_th_whole_movrvvm1x2hi */

    case 231:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1171; /* pred_th_whole_movrvvm1x3hi */

    case 232:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1172; /* pred_th_whole_movrvvm1x4hi */

    case 233:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1173; /* pred_th_whole_movrvvm1x5hi */

    case 234:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1174; /* pred_th_whole_movrvvm1x6hi */

    case 235:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1175; /* pred_th_whole_movrvvm1x7hi */

    case 236:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1176; /* pred_th_whole_movrvvm1x8hi */

    case 237:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1177; /* pred_th_whole_movrvvm2x2si */

    case 238:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1178; /* pred_th_whole_movrvvm2x3si */

    case 239:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1179; /* pred_th_whole_movrvvm2x4si */

    case 240:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1294 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1180; /* pred_th_whole_movrvvm4x2di */

    case 241:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1295 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 1181; /* pred_th_whole_movrvvm1x2bf */

    case 242:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1296 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 1182; /* pred_th_whole_movrvvm1x3bf */

    case 243:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1297 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 1183; /* pred_th_whole_movrvvm1x4bf */

    case 244:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1298 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 1184; /* pred_th_whole_movrvvm1x5bf */

    case 245:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1299 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 1185; /* pred_th_whole_movrvvm1x6bf */

    case 246:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1300 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 1186; /* pred_th_whole_movrvvm1x7bf */

    case 247:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1301 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 1187; /* pred_th_whole_movrvvm1x8bf */

    case 248:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1302 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1188; /* pred_th_whole_movrvvm1x2hf */

    case 249:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1303 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1189; /* pred_th_whole_movrvvm1x3hf */

    case 250:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1304 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1190; /* pred_th_whole_movrvvm1x4hf */

    case 251:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1305 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1191; /* pred_th_whole_movrvvm1x5hf */

    case 252:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1306 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1192; /* pred_th_whole_movrvvm1x6hf */

    case 253:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1307 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1193; /* pred_th_whole_movrvvm1x7hf */

    case 254:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1308 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1194; /* pred_th_whole_movrvvm1x8hf */

    case 255:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1309 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1195; /* pred_th_whole_movrvvm2x2sf */

    case 256:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1310 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1196; /* pred_th_whole_movrvvm2x3sf */

    case 257:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1311 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1197; /* pred_th_whole_movrvvm2x4sf */

    case 258:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1312 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 1198; /* pred_th_whole_movrvvm4x2df */

    case 259:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1199; /* pred_th_whole_movrvvm1x2qi */

    case 260:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1200; /* pred_th_whole_movrvvm1x3qi */

    case 261:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1201; /* pred_th_whole_movrvvm1x4qi */

    case 262:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1202; /* pred_th_whole_movrvvm1x5qi */

    case 263:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1203; /* pred_th_whole_movrvvm1x6qi */

    case 264:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1204; /* pred_th_whole_movrvvm1x7qi */

    case 265:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1205; /* pred_th_whole_movrvvm1x8qi */

    case 266:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1206; /* pred_th_whole_movrvvm2x2hi */

    case 267:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1207; /* pred_th_whole_movrvvm2x3hi */

    case 268:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1208; /* pred_th_whole_movrvvm2x4hi */

    case 269:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1209; /* pred_th_whole_movrvvm4x2si */

    case 270:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1327 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 1210; /* pred_th_whole_movrvvm2x2bf */

    case 271:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1328 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 1211; /* pred_th_whole_movrvvm2x3bf */

    case 272:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1329 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 1212; /* pred_th_whole_movrvvm2x4bf */

    case 273:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1330 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1213; /* pred_th_whole_movrvvm2x2hf */

    case 274:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1331 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1214; /* pred_th_whole_movrvvm2x3hf */

    case 275:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1332 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1215; /* pred_th_whole_movrvvm2x4hf */

    case 276:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1333 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1216; /* pred_th_whole_movrvvm4x2sf */

    case 277:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1217; /* pred_th_whole_movrvvm2x2qi */

    case 278:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1218; /* pred_th_whole_movrvvm2x3qi */

    case 279:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1219; /* pred_th_whole_movrvvm2x4qi */

    case 280:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1220; /* pred_th_whole_movrvvm4x2hi */

    case 281:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1341 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 1221; /* pred_th_whole_movrvvm4x2bf */

    case 282:
      if (!(
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1342 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1222; /* pred_th_whole_movrvvm4x2hf */

    case 283:
      if (!
#line 116 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1223; /* pred_th_whole_movrvvm4x2qi */

    case 284:
      if (!(
#line 141 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1533 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 1224; /* pred_th_whole_movrvvmf64bi */

    case 285:
      if (!
#line 141 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1225; /* pred_th_whole_movrvvmf32bi */

    case 286:
      if (!
#line 141 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1226; /* pred_th_whole_movrvvmf16bi */

    case 287:
      if (!
#line 141 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1227; /* pred_th_whole_movrvvmf8bi */

    case 288:
      if (!
#line 141 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1228; /* pred_th_whole_movrvvmf4bi */

    case 289:
      if (!
#line 141 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1229; /* pred_th_whole_movrvvmf2bi */

    case 290:
      if (!
#line 141 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1230; /* pred_th_whole_movrvvm1bi */

    default:
      return -1;
    }
}

 int
recog_109 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode
      || !register_operand (operands[1], E_SImode))
    return -1;
  if (
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT))
    return 114; /* one_cmplsi2 */
  if (!
#line 1787 "../../../gcc/config/riscv/riscv.md"
(TARGET_64BIT))
    return -1;
  return 116; /* *one_cmplsi2_internal */
}

 int
recog_110 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return recog_109 (x1, insn, pnum_clobbers);

    case E_DImode:
      if (!register_operand (operands[0], E_DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_DImode
          || !register_operand (operands[1], E_DImode)
          || !
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT))
        return -1;
      return 115; /* one_cmpldi2 */

    case E_RVVMF64BImode:
      if (!register_operand (operands[0], E_RVVMF64BImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF64BImode
          || !register_operand (operands[1], E_RVVMF64BImode)
          || !(
#line 560 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1533 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 25961; /* one_cmplrvvmf64bi2 */

    case E_RVVMF32BImode:
      if (!register_operand (operands[0], E_RVVMF32BImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF32BImode
          || !register_operand (operands[1], E_RVVMF32BImode)
          || !
#line 560 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25962; /* one_cmplrvvmf32bi2 */

    case E_RVVMF16BImode:
      if (!register_operand (operands[0], E_RVVMF16BImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF16BImode
          || !register_operand (operands[1], E_RVVMF16BImode)
          || !
#line 560 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25963; /* one_cmplrvvmf16bi2 */

    case E_RVVMF8BImode:
      if (!register_operand (operands[0], E_RVVMF8BImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF8BImode
          || !register_operand (operands[1], E_RVVMF8BImode)
          || !
#line 560 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25964; /* one_cmplrvvmf8bi2 */

    case E_RVVMF4BImode:
      if (!register_operand (operands[0], E_RVVMF4BImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF4BImode
          || !register_operand (operands[1], E_RVVMF4BImode)
          || !
#line 560 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25965; /* one_cmplrvvmf4bi2 */

    case E_RVVMF2BImode:
      if (!register_operand (operands[0], E_RVVMF2BImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF2BImode
          || !register_operand (operands[1], E_RVVMF2BImode)
          || !
#line 560 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25966; /* one_cmplrvvmf2bi2 */

    case E_RVVM1BImode:
      if (!register_operand (operands[0], E_RVVM1BImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1BImode
          || !register_operand (operands[1], E_RVVM1BImode)
          || !
#line 560 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25967; /* one_cmplrvvm1bi2 */

    case E_V1BImode:
      if (!register_operand (operands[0], E_V1BImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V1BImode
          || !register_operand (operands[1], E_V1BImode)
          || !(
#line 560 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1518 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode))))
        return -1;
      return 25968; /* one_cmplv1bi2 */

    case E_V2BImode:
      if (!register_operand (operands[0], E_V2BImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2BImode
          || !register_operand (operands[1], E_V2BImode)
          || !(
#line 560 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1519 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode))))
        return -1;
      return 25969; /* one_cmplv2bi2 */

    case E_V4BImode:
      if (!register_operand (operands[0], E_V4BImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4BImode
          || !register_operand (operands[1], E_V4BImode)
          || !(
#line 560 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1520 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode))))
        return -1;
      return 25970; /* one_cmplv4bi2 */

    case E_V8BImode:
      if (!register_operand (operands[0], E_V8BImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V8BImode
          || !register_operand (operands[1], E_V8BImode)
          || !(
#line 560 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1521 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode))))
        return -1;
      return 25971; /* one_cmplv8bi2 */

    case E_V16BImode:
      if (!register_operand (operands[0], E_V16BImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V16BImode
          || !register_operand (operands[1], E_V16BImode)
          || !(
#line 560 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1522 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode))))
        return -1;
      return 25972; /* one_cmplv16bi2 */

    case E_V32BImode:
      if (!register_operand (operands[0], E_V32BImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V32BImode
          || !register_operand (operands[1], E_V32BImode)
          || !(
#line 560 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1523 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode))))
        return -1;
      return 25973; /* one_cmplv32bi2 */

    case E_V64BImode:
      if (!register_operand (operands[0], E_V64BImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V64BImode
          || !register_operand (operands[1], E_V64BImode)
          || !(
#line 560 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1524 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 25974; /* one_cmplv64bi2 */

    case E_V128BImode:
      if (!register_operand (operands[0], E_V128BImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V128BImode
          || !register_operand (operands[1], E_V128BImode)
          || !(
#line 560 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1525 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 25975; /* one_cmplv128bi2 */

    case E_V256BImode:
      if (!register_operand (operands[0], E_V256BImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V256BImode
          || !register_operand (operands[1], E_V256BImode)
          || !(
#line 560 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1526 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 25976; /* one_cmplv256bi2 */

    case E_V512BImode:
      if (!register_operand (operands[0], E_V512BImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V512BImode
          || !register_operand (operands[1], E_V512BImode)
          || !(
#line 560 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1527 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 25977; /* one_cmplv512bi2 */

    case E_V1024BImode:
      if (!register_operand (operands[0], E_V1024BImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V1024BImode
          || !register_operand (operands[1], E_V1024BImode)
          || !(
#line 560 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1528 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 25978; /* one_cmplv1024bi2 */

    case E_V2048BImode:
      if (!register_operand (operands[0], E_V2048BImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2048BImode
          || !register_operand (operands[1], E_V2048BImode)
          || !(
#line 560 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1529 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 25979; /* one_cmplv2048bi2 */

    case E_V4096BImode:
      if (!register_operand (operands[0], E_V4096BImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4096BImode
          || !register_operand (operands[1], E_V4096BImode)
          || !(
#line 560 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1530 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 25980; /* one_cmplv4096bi2 */

    case E_RVVM8QImode:
      if (!register_operand (operands[0], E_RVVM8QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM8QImode
          || !register_operand (operands[1], E_RVVM8QImode)
          || !
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 26900; /* one_cmplrvvm8qi2 */

    case E_RVVM4QImode:
      if (!register_operand (operands[0], E_RVVM4QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM4QImode
          || !register_operand (operands[1], E_RVVM4QImode)
          || !
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 26902; /* one_cmplrvvm4qi2 */

    case E_RVVM2QImode:
      if (!register_operand (operands[0], E_RVVM2QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM2QImode
          || !register_operand (operands[1], E_RVVM2QImode)
          || !
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 26904; /* one_cmplrvvm2qi2 */

    case E_RVVM1QImode:
      if (!register_operand (operands[0], E_RVVM1QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1QImode
          || !register_operand (operands[1], E_RVVM1QImode)
          || !
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 26906; /* one_cmplrvvm1qi2 */

    case E_RVVM8HImode:
      if (!register_operand (operands[0], E_RVVM8HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM8HImode
          || !register_operand (operands[1], E_RVVM8HImode)
          || !
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 26908; /* one_cmplrvvm8hi2 */

    case E_RVVM4HImode:
      if (!register_operand (operands[0], E_RVVM4HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM4HImode
          || !register_operand (operands[1], E_RVVM4HImode)
          || !
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 26910; /* one_cmplrvvm4hi2 */

    case E_RVVM2HImode:
      if (!register_operand (operands[0], E_RVVM2HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM2HImode
          || !register_operand (operands[1], E_RVVM2HImode)
          || !
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 26912; /* one_cmplrvvm2hi2 */

    case E_RVVM1HImode:
      if (!register_operand (operands[0], E_RVVM1HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1HImode
          || !register_operand (operands[1], E_RVVM1HImode)
          || !
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 26914; /* one_cmplrvvm1hi2 */

    case E_RVVM8SImode:
      if (!register_operand (operands[0], E_RVVM8SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM8SImode
          || !register_operand (operands[1], E_RVVM8SImode)
          || !
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 26916; /* one_cmplrvvm8si2 */

    case E_RVVM4SImode:
      if (!register_operand (operands[0], E_RVVM4SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM4SImode
          || !register_operand (operands[1], E_RVVM4SImode)
          || !
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 26918; /* one_cmplrvvm4si2 */

    case E_RVVM2SImode:
      if (!register_operand (operands[0], E_RVVM2SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM2SImode
          || !register_operand (operands[1], E_RVVM2SImode)
          || !
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 26920; /* one_cmplrvvm2si2 */

    case E_RVVM1SImode:
      if (!register_operand (operands[0], E_RVVM1SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1SImode
          || !register_operand (operands[1], E_RVVM1SImode)
          || !
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 26922; /* one_cmplrvvm1si2 */

    case E_RVVM8DImode:
      if (!register_operand (operands[0], E_RVVM8DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM8DImode
          || !register_operand (operands[1], E_RVVM8DImode)
          || !(
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 26924; /* one_cmplrvvm8di2 */

    case E_RVVM4DImode:
      if (!register_operand (operands[0], E_RVVM4DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM4DImode
          || !register_operand (operands[1], E_RVVM4DImode)
          || !(
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 26926; /* one_cmplrvvm4di2 */

    case E_RVVM2DImode:
      if (!register_operand (operands[0], E_RVVM2DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM2DImode
          || !register_operand (operands[1], E_RVVM2DImode)
          || !(
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 26928; /* one_cmplrvvm2di2 */

    case E_RVVM1DImode:
      if (!register_operand (operands[0], E_RVVM1DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1DImode
          || !register_operand (operands[1], E_RVVM1DImode)
          || !(
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 26930; /* one_cmplrvvm1di2 */

    case E_RVVMF2QImode:
      if (!register_operand (operands[0], E_RVVMF2QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF2QImode
          || !register_operand (operands[1], E_RVVMF2QImode)
          || !(
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 26932; /* one_cmplrvvmf2qi2 */

    case E_RVVMF4QImode:
      if (!register_operand (operands[0], E_RVVMF4QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF4QImode
          || !register_operand (operands[1], E_RVVMF4QImode)
          || !(
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 26934; /* one_cmplrvvmf4qi2 */

    case E_RVVMF8QImode:
      if (!register_operand (operands[0], E_RVVMF8QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF8QImode
          || !register_operand (operands[1], E_RVVMF8QImode)
          || !(
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 26936; /* one_cmplrvvmf8qi2 */

    case E_RVVMF2HImode:
      if (!register_operand (operands[0], E_RVVMF2HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF2HImode
          || !register_operand (operands[1], E_RVVMF2HImode)
          || !(
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 26938; /* one_cmplrvvmf2hi2 */

    case E_RVVMF4HImode:
      if (!register_operand (operands[0], E_RVVMF4HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF4HImode
          || !register_operand (operands[1], E_RVVMF4HImode)
          || !(
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 132 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 26940; /* one_cmplrvvmf4hi2 */

    case E_RVVMF2SImode:
      if (!register_operand (operands[0], E_RVVMF2SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF2SImode
          || !register_operand (operands[1], E_RVVMF2SImode)
          || !(
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 133 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 26942; /* one_cmplrvvmf2si2 */

    case E_V1QImode:
      if (!register_operand (operands[0], E_V1QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V1QImode
          || !register_operand (operands[1], E_V1QImode)
          || !(
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 188 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 26944; /* one_cmplv1qi2 */

    case E_V2QImode:
      if (!register_operand (operands[0], E_V2QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2QImode
          || !register_operand (operands[1], E_V2QImode)
          || !(
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 189 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 26946; /* one_cmplv2qi2 */

    case E_V4QImode:
      if (!register_operand (operands[0], E_V4QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4QImode
          || !register_operand (operands[1], E_V4QImode)
          || !(
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 190 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 26948; /* one_cmplv4qi2 */

    case E_V8QImode:
      if (!register_operand (operands[0], E_V8QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V8QImode
          || !register_operand (operands[1], E_V8QImode)
          || !(
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 191 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 26950; /* one_cmplv8qi2 */

    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V16QImode
          || !register_operand (operands[1], E_V16QImode)
          || !(
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 192 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 26952; /* one_cmplv16qi2 */

    case E_V32QImode:
      if (!register_operand (operands[0], E_V32QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V32QImode
          || !register_operand (operands[1], E_V32QImode)
          || !(
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 193 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 26954; /* one_cmplv32qi2 */

    case E_V64QImode:
      if (!register_operand (operands[0], E_V64QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V64QImode
          || !register_operand (operands[1], E_V64QImode)
          || !(
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 194 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 26956; /* one_cmplv64qi2 */

    case E_V128QImode:
      if (!register_operand (operands[0], E_V128QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V128QImode
          || !register_operand (operands[1], E_V128QImode)
          || !(
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 195 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 26958; /* one_cmplv128qi2 */

    case E_V256QImode:
      if (!register_operand (operands[0], E_V256QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V256QImode
          || !register_operand (operands[1], E_V256QImode)
          || !(
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 196 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 26960; /* one_cmplv256qi2 */

    case E_V512QImode:
      if (!register_operand (operands[0], E_V512QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V512QImode
          || !register_operand (operands[1], E_V512QImode)
          || !(
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 197 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 26962; /* one_cmplv512qi2 */

    case E_V1024QImode:
      if (!register_operand (operands[0], E_V1024QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V1024QImode
          || !register_operand (operands[1], E_V1024QImode)
          || !(
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 198 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 26964; /* one_cmplv1024qi2 */

    case E_V2048QImode:
      if (!register_operand (operands[0], E_V2048QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2048QImode
          || !register_operand (operands[1], E_V2048QImode)
          || !(
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 199 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 26966; /* one_cmplv2048qi2 */

    case E_V4096QImode:
      if (!register_operand (operands[0], E_V4096QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4096QImode
          || !register_operand (operands[1], E_V4096QImode)
          || !(
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 200 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 26968; /* one_cmplv4096qi2 */

    case E_V1HImode:
      if (!register_operand (operands[0], E_V1HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V1HImode
          || !register_operand (operands[1], E_V1HImode)
          || !(
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 201 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 26970; /* one_cmplv1hi2 */

    case E_V2HImode:
      if (!register_operand (operands[0], E_V2HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2HImode
          || !register_operand (operands[1], E_V2HImode)
          || !(
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 202 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 26972; /* one_cmplv2hi2 */

    case E_V4HImode:
      if (!register_operand (operands[0], E_V4HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4HImode
          || !register_operand (operands[1], E_V4HImode)
          || !(
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 203 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 26974; /* one_cmplv4hi2 */

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V8HImode
          || !register_operand (operands[1], E_V8HImode)
          || !(
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 204 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 26976; /* one_cmplv8hi2 */

    case E_V16HImode:
      if (!register_operand (operands[0], E_V16HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V16HImode
          || !register_operand (operands[1], E_V16HImode)
          || !(
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 205 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 26978; /* one_cmplv16hi2 */

    case E_V32HImode:
      if (!register_operand (operands[0], E_V32HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V32HImode
          || !register_operand (operands[1], E_V32HImode)
          || !(
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 206 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 26980; /* one_cmplv32hi2 */

    case E_V64HImode:
      if (!register_operand (operands[0], E_V64HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V64HImode
          || !register_operand (operands[1], E_V64HImode)
          || !(
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 207 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 26982; /* one_cmplv64hi2 */

    case E_V128HImode:
      if (!register_operand (operands[0], E_V128HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V128HImode
          || !register_operand (operands[1], E_V128HImode)
          || !(
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 208 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 26984; /* one_cmplv128hi2 */

    case E_V256HImode:
      if (!register_operand (operands[0], E_V256HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V256HImode
          || !register_operand (operands[1], E_V256HImode)
          || !(
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 209 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 26986; /* one_cmplv256hi2 */

    case E_V512HImode:
      if (!register_operand (operands[0], E_V512HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V512HImode
          || !register_operand (operands[1], E_V512HImode)
          || !(
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 210 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 26988; /* one_cmplv512hi2 */

    case E_V1024HImode:
      if (!register_operand (operands[0], E_V1024HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V1024HImode
          || !register_operand (operands[1], E_V1024HImode)
          || !(
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 211 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 26990; /* one_cmplv1024hi2 */

    case E_V2048HImode:
      if (!register_operand (operands[0], E_V2048HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2048HImode
          || !register_operand (operands[1], E_V2048HImode)
          || !(
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 212 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 26992; /* one_cmplv2048hi2 */

    case E_V1SImode:
      if (!register_operand (operands[0], E_V1SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V1SImode
          || !register_operand (operands[1], E_V1SImode)
          || !(
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 213 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 26994; /* one_cmplv1si2 */

    case E_V2SImode:
      if (!register_operand (operands[0], E_V2SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2SImode
          || !register_operand (operands[1], E_V2SImode)
          || !(
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 214 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 26996; /* one_cmplv2si2 */

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4SImode
          || !register_operand (operands[1], E_V4SImode)
          || !(
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 215 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 26998; /* one_cmplv4si2 */

    case E_V8SImode:
      if (!register_operand (operands[0], E_V8SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V8SImode
          || !register_operand (operands[1], E_V8SImode)
          || !(
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 216 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 27000; /* one_cmplv8si2 */

    case E_V16SImode:
      if (!register_operand (operands[0], E_V16SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V16SImode
          || !register_operand (operands[1], E_V16SImode)
          || !(
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 217 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 27002; /* one_cmplv16si2 */

    case E_V32SImode:
      if (!register_operand (operands[0], E_V32SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V32SImode
          || !register_operand (operands[1], E_V32SImode)
          || !(
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 218 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 27004; /* one_cmplv32si2 */

    case E_V64SImode:
      if (!register_operand (operands[0], E_V64SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V64SImode
          || !register_operand (operands[1], E_V64SImode)
          || !(
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 219 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 27006; /* one_cmplv64si2 */

    case E_V128SImode:
      if (!register_operand (operands[0], E_V128SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V128SImode
          || !register_operand (operands[1], E_V128SImode)
          || !(
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 220 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 27008; /* one_cmplv128si2 */

    case E_V256SImode:
      if (!register_operand (operands[0], E_V256SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V256SImode
          || !register_operand (operands[1], E_V256SImode)
          || !(
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 221 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 27010; /* one_cmplv256si2 */

    case E_V512SImode:
      if (!register_operand (operands[0], E_V512SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V512SImode
          || !register_operand (operands[1], E_V512SImode)
          || !(
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 222 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 27012; /* one_cmplv512si2 */

    case E_V1024SImode:
      if (!register_operand (operands[0], E_V1024SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V1024SImode
          || !register_operand (operands[1], E_V1024SImode)
          || !(
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 223 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 27014; /* one_cmplv1024si2 */

    case E_V1DImode:
      if (!register_operand (operands[0], E_V1DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V1DImode
          || !register_operand (operands[1], E_V1DImode)
          || !(
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 224 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 27016; /* one_cmplv1di2 */

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2DImode
          || !register_operand (operands[1], E_V2DImode)
          || !(
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 225 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 27018; /* one_cmplv2di2 */

    case E_V4DImode:
      if (!register_operand (operands[0], E_V4DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4DImode
          || !register_operand (operands[1], E_V4DImode)
          || !(
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 226 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 27020; /* one_cmplv4di2 */

    case E_V8DImode:
      if (!register_operand (operands[0], E_V8DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V8DImode
          || !register_operand (operands[1], E_V8DImode)
          || !(
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 227 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 27022; /* one_cmplv8di2 */

    case E_V16DImode:
      if (!register_operand (operands[0], E_V16DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V16DImode
          || !register_operand (operands[1], E_V16DImode)
          || !(
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 228 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 27024; /* one_cmplv16di2 */

    case E_V32DImode:
      if (!register_operand (operands[0], E_V32DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V32DImode
          || !register_operand (operands[1], E_V32DImode)
          || !(
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 229 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 27026; /* one_cmplv32di2 */

    case E_V64DImode:
      if (!register_operand (operands[0], E_V64DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V64DImode
          || !register_operand (operands[1], E_V64DImode)
          || !(
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 230 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 27028; /* one_cmplv64di2 */

    case E_V128DImode:
      if (!register_operand (operands[0], E_V128DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V128DImode
          || !register_operand (operands[1], E_V128DImode)
          || !(
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 231 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 27030; /* one_cmplv128di2 */

    case E_V256DImode:
      if (!register_operand (operands[0], E_V256DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V256DImode
          || !register_operand (operands[1], E_V256DImode)
          || !(
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 232 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 27032; /* one_cmplv256di2 */

    case E_V512DImode:
      if (!register_operand (operands[0], E_V512DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V512DImode
          || !register_operand (operands[1], E_V512DImode)
          || !(
#line 1073 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 233 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 27034; /* one_cmplv512di2 */

    default:
      return -1;
    }
}

 int
recog_216 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V4HImode)
      && reg_or_mem_operand (operands[1], E_V4HImode)
      && (
#line 1434 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V4HImode)
       || register_operand (operands[1], V4HImode))) && 
#line 4311 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
    return 3199; /* *movv4hi */
  if (!register_operand (operands[0], E_V4HImode)
      || !register_operand (operands[1], E_V4HImode)
      || !(
#line 1509 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 203 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
    return -1;
  return 3351; /* *movv4hi_vls */
}

 int
recog_223 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V1QImode)
      && reg_or_mem_operand (operands[1], E_V1QImode)
      && (
#line 1434 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V1QImode)
       || register_operand (operands[1], V1QImode))) && 
#line 4304 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
    return 3192; /* *movv1qi */
  if (!register_operand (operands[0], E_V1QImode)
      || !register_operand (operands[1], E_V1QImode)
      || !(
#line 1509 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 188 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
    return -1;
  return 3336; /* *movv1qi_vls */
}

 int
recog_230 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM2x3QImode)
      || !reg_or_mem_operand (operands[1], E_RVVM2x3QImode))
    return -1;
  if ((
#line 1405 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)))
    {
      *pnum_clobbers = 3;
      return 3180; /* *movrvvm2x3qi_si */
    }
  if (!(
#line 1405 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)))
    return -1;
  *pnum_clobbers = 3;
  return 3181; /* *movrvvm2x3qi_di */
}

 int
recog_235 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM2x2HFmode)
      || !reg_or_mem_operand (operands[1], E_RVVM2x2HFmode))
    return -1;
  if ((
#line 1405 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1330 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 3170; /* *movrvvm2x2hf_si */
    }
  if (!(
#line 1405 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1330 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 3171; /* *movrvvm2x2hf_di */
}

 int
recog_242 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM2x2HImode)
      || !reg_or_mem_operand (operands[1], E_RVVM2x2HImode))
    return -1;
  if ((
#line 1405 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)))
    {
      *pnum_clobbers = 3;
      return 3156; /* *movrvvm2x2hi_si */
    }
  if (!(
#line 1405 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)))
    return -1;
  *pnum_clobbers = 3;
  return 3157; /* *movrvvm2x2hi_di */
}

 int
recog_249 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM1x2QImode)
      || !reg_or_mem_operand (operands[1], E_RVVM1x2QImode))
    return -1;
  if ((
#line 1405 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)))
    {
      *pnum_clobbers = 3;
      return 3142; /* *movrvvm1x2qi_si */
    }
  if (!(
#line 1405 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)))
    return -1;
  *pnum_clobbers = 3;
  return 3143; /* *movrvvm1x2qi_di */
}

 int
recog_256 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM1x6HFmode)
      || !reg_or_mem_operand (operands[1], E_RVVM1x6HFmode))
    return -1;
  if ((
#line 1405 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1306 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 3128; /* *movrvvm1x6hf_si */
    }
  if (!(
#line 1405 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1306 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 3129; /* *movrvvm1x6hf_di */
}

 int
recog_264 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM1x5BFmode)
      || !reg_or_mem_operand (operands[1], E_RVVM1x5BFmode))
    return -1;
  if ((
#line 1405 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1298 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 3112; /* *movrvvm1x5bf_si */
    }
  if (!(
#line 1405 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1298 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 3113; /* *movrvvm1x5bf_di */
}

 int
recog_272 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM1x8HImode)
      || !reg_or_mem_operand (operands[1], E_RVVM1x8HImode))
    return -1;
  if ((
#line 1405 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)))
    {
      *pnum_clobbers = 3;
      return 3096; /* *movrvvm1x8hi_si */
    }
  if (!(
#line 1405 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)))
    return -1;
  *pnum_clobbers = 3;
  return 3097; /* *movrvvm1x8hi_di */
}

 int
recog_279 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF2x8QImode)
      || !reg_or_mem_operand (operands[1], E_RVVMF2x8QImode))
    return -1;
  if ((
#line 1405 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)))
    {
      *pnum_clobbers = 3;
      return 3082; /* *movrvvmf2x8qi_si */
    }
  if (!(
#line 1405 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)))
    return -1;
  *pnum_clobbers = 3;
  return 3083; /* *movrvvmf2x8qi_di */
}

 int
recog_287 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM2x3DFmode)
      || !reg_or_mem_operand (operands[1], E_RVVM2x3DFmode))
    return -1;
  if ((
#line 1405 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1272 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 3066; /* *movrvvm2x3df_si */
    }
  if (!(
#line 1405 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1272 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 3067; /* *movrvvm2x3df_di */
}

 int
recog_295 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM1x2SFmode)
      || !reg_or_mem_operand (operands[1], E_RVVM1x2SFmode))
    return -1;
  if ((
#line 1405 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1264 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 3050; /* *movrvvm1x2sf_si */
    }
  if (!(
#line 1405 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1264 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 3051; /* *movrvvm1x2sf_di */
}

 int
recog_303 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF2x8BFmode)
      || !reg_or_mem_operand (operands[1], E_RVVMF2x8BFmode))
    return -1;
  if ((
#line 1405 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1256 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 3034; /* *movrvvmf2x8bf_si */
    }
  if (!(
#line 1405 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1256 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 3035; /* *movrvvmf2x8bf_di */
}

 int
recog_311 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM2x3DImode)
      || !reg_or_mem_operand (operands[1], E_RVVM2x3DImode))
    return -1;
  if ((
#line 1405 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1248 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 3018; /* *movrvvm2x3di_si */
    }
  if (!(
#line 1405 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1248 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 3019; /* *movrvvm2x3di_di */
}

 int
recog_319 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM1x2SImode)
      || !reg_or_mem_operand (operands[1], E_RVVM1x2SImode))
    return -1;
  if ((
#line 1405 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)))
    {
      *pnum_clobbers = 3;
      return 3002; /* *movrvvm1x2si_si */
    }
  if (!(
#line 1405 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)))
    return -1;
  *pnum_clobbers = 3;
  return 3003; /* *movrvvm1x2si_di */
}

 int
recog_327 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF4x8QImode)
      || !reg_or_mem_operand (operands[1], E_RVVMF4x8QImode))
    return -1;
  if ((
#line 1405 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)))
    {
      *pnum_clobbers = 3;
      return 2986; /* *movrvvmf4x8qi_si */
    }
  if (!(
#line 1405 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)))
    return -1;
  *pnum_clobbers = 3;
  return 2987; /* *movrvvmf4x8qi_di */
}

 int
recog_335 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM1x7DFmode)
      || !reg_or_mem_operand (operands[1], E_RVVM1x7DFmode))
    return -1;
  if ((
#line 1405 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1221 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 2970; /* *movrvvm1x7df_si */
    }
  if (!(
#line 1405 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1221 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 2971; /* *movrvvm1x7df_di */
}

 int
recog_343 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF2x6SFmode)
      || !reg_or_mem_operand (operands[1], E_RVVMF2x6SFmode))
    return -1;
  if ((
#line 1405 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1213 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 2954; /* *movrvvmf2x6sf_si */
    }
  if (!(
#line 1405 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1213 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_32) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 2955; /* *movrvvmf2x6sf_di */
}

 int
recog_351 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF4x5HFmode)
      || !reg_or_mem_operand (operands[1], E_RVVMF4x5HFmode))
    return -1;
  if ((
#line 1405 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1205 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 2938; /* *movrvvmf4x5hf_si */
    }
  if (!(
#line 1405 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1205 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 2939; /* *movrvvmf4x5hf_di */
}

 int
recog_359 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF4x4BFmode)
      || !reg_or_mem_operand (operands[1], E_RVVMF4x4BFmode))
    return -1;
  if ((
#line 1405 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1197 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 2922; /* *movrvvmf4x4bf_si */
    }
  if (!(
#line 1405 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1197 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32 && TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 2923; /* *movrvvmf4x4bf_di */
}

 int
recog_367 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM1x3DImode)
      || !reg_or_mem_operand (operands[1], E_RVVM1x3DImode))
    return -1;
  if ((
#line 1405 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1189 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 2906; /* *movrvvm1x3di_si */
    }
  if (!(
#line 1405 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1189 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 2907; /* *movrvvm1x3di_di */
}

 int
recog_375 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  res = recog_374 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  switch (GET_CODE (x2))
    {
    case MEM:
      if (pnum_clobbers == NULL)
        return -1;
      x3 = XEXP (x2, 0);
      operands[0] = x3;
      if (!absolute_symbolic_operand (operands[0], E_VOIDmode))
        return -1;
      x4 = XEXP (x1, 1);
      operands[1] = x4;
      switch (GET_MODE (x2))
        {
        case E_QImode:
          if (!reg_or_0_operand (operands[1], E_QImode))
            return -1;
          if ((
#line 93 "../../../gcc/config/riscv/pic.md"
(USE_LOAD_ADDRESS_MACRO (operands[0])) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)))
            {
              *pnum_clobbers = 1;
              return 842; /* *local_pic_storeqi */
            }
          if (!(
#line 93 "../../../gcc/config/riscv/pic.md"
(USE_LOAD_ADDRESS_MACRO (operands[0])) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)))
            return -1;
          *pnum_clobbers = 1;
          return 846; /* *local_pic_storeqi */

        case E_HImode:
          if (!reg_or_0_operand (operands[1], E_HImode))
            return -1;
          if ((
#line 93 "../../../gcc/config/riscv/pic.md"
(USE_LOAD_ADDRESS_MACRO (operands[0])) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)))
            {
              *pnum_clobbers = 1;
              return 843; /* *local_pic_storehi */
            }
          if (!(
#line 93 "../../../gcc/config/riscv/pic.md"
(USE_LOAD_ADDRESS_MACRO (operands[0])) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)))
            return -1;
          *pnum_clobbers = 1;
          return 847; /* *local_pic_storehi */

        case E_SImode:
          if (!reg_or_0_operand (operands[1], E_SImode))
            return -1;
          if ((
#line 93 "../../../gcc/config/riscv/pic.md"
(USE_LOAD_ADDRESS_MACRO (operands[0])) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)))
            {
              *pnum_clobbers = 1;
              return 844; /* *local_pic_storesi */
            }
          if (!(
#line 93 "../../../gcc/config/riscv/pic.md"
(USE_LOAD_ADDRESS_MACRO (operands[0])) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)))
            return -1;
          *pnum_clobbers = 1;
          return 848; /* *local_pic_storesi */

        case E_DImode:
          if (!reg_or_0_operand (operands[1], E_DImode))
            return -1;
          if ((
#line 93 "../../../gcc/config/riscv/pic.md"
(USE_LOAD_ADDRESS_MACRO (operands[0])) && (
#line 69 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
            {
              *pnum_clobbers = 1;
              return 845; /* *local_pic_storedi */
            }
          if (!(
#line 93 "../../../gcc/config/riscv/pic.md"
(USE_LOAD_ADDRESS_MACRO (operands[0])) && (
#line 69 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
            return -1;
          *pnum_clobbers = 1;
          return 849; /* *local_pic_storedi */

        case E_SFmode:
          if (!register_operand (operands[1], E_SFmode))
            return -1;
          if ((
#line 102 "../../../gcc/config/riscv/pic.md"
(TARGET_HARD_FLOAT && USE_LOAD_ADDRESS_MACRO (operands[0])
   && (!TARGET_DOUBLE_FLOAT || TARGET_64BIT)) && (
#line 110 "../../../gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
            {
              *pnum_clobbers = 1;
              return 850; /* *local_pic_storesf */
            }
          if ((
#line 102 "../../../gcc/config/riscv/pic.md"
(TARGET_HARD_FLOAT && USE_LOAD_ADDRESS_MACRO (operands[0])
   && (!TARGET_DOUBLE_FLOAT || TARGET_64BIT)) && (
#line 110 "../../../gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
            {
              *pnum_clobbers = 1;
              return 853; /* *local_pic_storesf */
            }
          if ((
#line 128 "../../../gcc/config/riscv/pic.md"
(!TARGET_HARD_FLOAT && USE_LOAD_ADDRESS_MACRO (operands[0])) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)))
            {
              *pnum_clobbers = 1;
              return 862; /* *local_pic_store_sfsf */
            }
          if (!(
#line 128 "../../../gcc/config/riscv/pic.md"
(!TARGET_HARD_FLOAT && USE_LOAD_ADDRESS_MACRO (operands[0])) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)))
            return -1;
          *pnum_clobbers = 1;
          return 865; /* *local_pic_store_sfsf */

        case E_DFmode:
          if (!register_operand (operands[1], E_DFmode))
            return -1;
          if ((
#line 102 "../../../gcc/config/riscv/pic.md"
(TARGET_HARD_FLOAT && USE_LOAD_ADDRESS_MACRO (operands[0])
   && (!TARGET_DOUBLE_FLOAT || TARGET_64BIT)) && (
#line 111 "../../../gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
            {
              *pnum_clobbers = 1;
              return 851; /* *local_pic_storedf */
            }
          if ((
#line 102 "../../../gcc/config/riscv/pic.md"
(TARGET_HARD_FLOAT && USE_LOAD_ADDRESS_MACRO (operands[0])
   && (!TARGET_DOUBLE_FLOAT || TARGET_64BIT)) && (
#line 111 "../../../gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
            {
              *pnum_clobbers = 1;
              return 854; /* *local_pic_storedf */
            }
          if ((
#line 128 "../../../gcc/config/riscv/pic.md"
(!TARGET_HARD_FLOAT && USE_LOAD_ADDRESS_MACRO (operands[0])) && (
#line 115 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
            {
              *pnum_clobbers = 1;
              return 863; /* *local_pic_store_sfdf */
            }
          if (!(
#line 128 "../../../gcc/config/riscv/pic.md"
(!TARGET_HARD_FLOAT && USE_LOAD_ADDRESS_MACRO (operands[0])) && (
#line 115 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
            return -1;
          *pnum_clobbers = 1;
          return 866; /* *local_pic_store_sfdf */

        case E_HFmode:
          if (!register_operand (operands[1], E_HFmode))
            return -1;
          if ((
#line 102 "../../../gcc/config/riscv/pic.md"
(TARGET_HARD_FLOAT && USE_LOAD_ADDRESS_MACRO (operands[0])
   && (!TARGET_DOUBLE_FLOAT || TARGET_64BIT)) && (
#line 112 "../../../gcc/config/riscv/iterators.md"
(TARGET_ZFHMIN || TARGET_ZHINXMIN) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
            {
              *pnum_clobbers = 1;
              return 852; /* *local_pic_storehf */
            }
          if ((
#line 102 "../../../gcc/config/riscv/pic.md"
(TARGET_HARD_FLOAT && USE_LOAD_ADDRESS_MACRO (operands[0])
   && (!TARGET_DOUBLE_FLOAT || TARGET_64BIT)) && (
#line 112 "../../../gcc/config/riscv/iterators.md"
(TARGET_ZFHMIN || TARGET_ZHINXMIN) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
            {
              *pnum_clobbers = 1;
              return 855; /* *local_pic_storehf */
            }
          if ((
#line 128 "../../../gcc/config/riscv/pic.md"
(!TARGET_HARD_FLOAT && USE_LOAD_ADDRESS_MACRO (operands[0])) && (
#line 115 "../../../gcc/config/riscv/iterators.md"
(TARGET_ZFHMIN) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
            {
              *pnum_clobbers = 1;
              return 864; /* *local_pic_store_sfhf */
            }
          if (!(
#line 128 "../../../gcc/config/riscv/pic.md"
(!TARGET_HARD_FLOAT && USE_LOAD_ADDRESS_MACRO (operands[0])) && (
#line 115 "../../../gcc/config/riscv/iterators.md"
(TARGET_ZFHMIN) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
            return -1;
          *pnum_clobbers = 1;
          return 867; /* *local_pic_store_sfhf */

        default:
          return -1;
        }

    case REG:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x4 = XEXP (x1, 1);
      operands[0] = x4;
      switch (REGNO (x2))
        {
        case 68:
          if (!const_int_operand (operands[0], E_SImode)
              || !
#line 1089 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 2721; /* vxrmsi */

        case 69:
          if (!reg_or_int_operand (operands[0], E_SImode)
              || !
#line 1111 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 2723; /* fsrmsi_restore */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_386 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != AND)
    return -1;
  x5 = XEXP (x2, 1);
  if (GET_CODE (x5) != LABEL_REF)
    return -1;
  x6 = XEXP (x2, 2);
  if (GET_CODE (x6) != PC)
    return -1;
  x7 = XEXP (x1, 0);
  if (GET_CODE (x7) != PC)
    return -1;
  x8 = XEXP (x4, 0);
  operands[1] = x8;
  res = recog_385 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  if (!equality_operator (x3, E_VOIDmode))
    return -1;
  operands[1] = x3;
  x9 = XEXP (x3, 1);
  if (GET_CODE (x9) != CONST_INT)
    return -1;
  operands[2] = x8;
  x10 = XEXP (x4, 1);
  operands[3] = x10;
  if (consecutive_bits_operand (operands[3], E_VOIDmode)
      && XWINT (x9, 0) == 0L)
    {
      switch (pattern447 (x2))
        {
        case 0:
          if ((
#line 3225 "../../../gcc/config/riscv/riscv.md"
((INTVAL (operands[3]) >= 0 || !partial_subreg_p (operands[2]))
    && popcount_hwi (INTVAL (operands[3])) > 1
    && !SMALL_OPERAND (INTVAL (operands[3]))) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            {
              *pnum_clobbers = 1;
              return 361; /* *branchqi_shiftedmask_equals_zero */
            }
          if ((
#line 3225 "../../../gcc/config/riscv/riscv.md"
((INTVAL (operands[3]) >= 0 || !partial_subreg_p (operands[2]))
    && popcount_hwi (INTVAL (operands[3])) > 1
    && !SMALL_OPERAND (INTVAL (operands[3]))) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            {
              *pnum_clobbers = 1;
              return 365; /* *branchqi_shiftedmask_equals_zero */
            }
          break;

        case 1:
          if ((
#line 3225 "../../../gcc/config/riscv/riscv.md"
((INTVAL (operands[3]) >= 0 || !partial_subreg_p (operands[2]))
    && popcount_hwi (INTVAL (operands[3])) > 1
    && !SMALL_OPERAND (INTVAL (operands[3]))) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            {
              *pnum_clobbers = 1;
              return 362; /* *branchhi_shiftedmask_equals_zero */
            }
          if ((
#line 3225 "../../../gcc/config/riscv/riscv.md"
((INTVAL (operands[3]) >= 0 || !partial_subreg_p (operands[2]))
    && popcount_hwi (INTVAL (operands[3])) > 1
    && !SMALL_OPERAND (INTVAL (operands[3]))) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            {
              *pnum_clobbers = 1;
              return 366; /* *branchhi_shiftedmask_equals_zero */
            }
          break;

        case 2:
          if ((
#line 3225 "../../../gcc/config/riscv/riscv.md"
((INTVAL (operands[3]) >= 0 || !partial_subreg_p (operands[2]))
    && popcount_hwi (INTVAL (operands[3])) > 1
    && !SMALL_OPERAND (INTVAL (operands[3]))) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            {
              *pnum_clobbers = 1;
              return 363; /* *branchsi_shiftedmask_equals_zero */
            }
          if ((
#line 3225 "../../../gcc/config/riscv/riscv.md"
((INTVAL (operands[3]) >= 0 || !partial_subreg_p (operands[2]))
    && popcount_hwi (INTVAL (operands[3])) > 1
    && !SMALL_OPERAND (INTVAL (operands[3]))) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            {
              *pnum_clobbers = 1;
              return 367; /* *branchsi_shiftedmask_equals_zero */
            }
          break;

        case 3:
          if ((
#line 3225 "../../../gcc/config/riscv/riscv.md"
((INTVAL (operands[3]) >= 0 || !partial_subreg_p (operands[2]))
    && popcount_hwi (INTVAL (operands[3])) > 1
    && !SMALL_OPERAND (INTVAL (operands[3]))) && ((((
#line 69 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT))))
            {
              *pnum_clobbers = 1;
              return 364; /* *branchdi_shiftedmask_equals_zero */
            }
          if ((
#line 3225 "../../../gcc/config/riscv/riscv.md"
((INTVAL (operands[3]) >= 0 || !partial_subreg_p (operands[2]))
    && popcount_hwi (INTVAL (operands[3])) > 1
    && !SMALL_OPERAND (INTVAL (operands[3]))) && 
#line 69 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            {
              *pnum_clobbers = 1;
              return 368; /* *branchdi_shiftedmask_equals_zero */
            }
          break;

        default:
          break;
        }
    }
  operands[4] = x9;
  x11 = XEXP (x5, 0);
  operands[0] = x11;
  switch (GET_MODE (x4))
    {
    case E_SImode:
      if (!register_operand (operands[2], E_SImode)
          || !const_twobits_not_arith_operand (operands[3], E_SImode)
          || !single_bit_mask_operand (operands[4], E_SImode)
          || !(
#line 1099 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBS && TARGET_ZBB) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
        return -1;
      *pnum_clobbers = 2;
      return 651; /* *branchsi_mask_twobits_equals_singlebit */

    case E_DImode:
      if (!register_operand (operands[2], E_DImode)
          || !const_twobits_not_arith_operand (operands[3], E_DImode)
          || !single_bit_mask_operand (operands[4], E_DImode)
          || !(
#line 1099 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBS && TARGET_ZBB) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
        return -1;
      *pnum_clobbers = 2;
      return 652; /* *branchdi_mask_twobits_equals_singlebit */

    default:
      return -1;
    }
}

 int
recog_390 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[4] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[5] = x5;
  x6 = XEXP (x2, 1);
  operands[3] = x6;
  if (!vector_move_operand (operands[3], E_RVVMF16BImode))
    return -1;
  x7 = XEXP (x2, 2);
  operands[2] = x7;
  if (!vector_undef_operand (operands[2], E_RVVMF16BImode))
    return -1;
  if (
#line 170 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
    return 1233; /* *pred_th_movrvvmf16bi */
  if (!
#line 1964 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
    return -1;
  return 3818; /* pred_movrvvmf16bi */
}

 int
recog_392 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[4] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[5] = x5;
  x6 = XEXP (x2, 1);
  operands[3] = x6;
  if (!vector_move_operand (operands[3], E_RVVMF4BImode))
    return -1;
  x7 = XEXP (x2, 2);
  operands[2] = x7;
  if (!vector_undef_operand (operands[2], E_RVVMF4BImode))
    return -1;
  if (
#line 170 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
    return 1235; /* *pred_th_movrvvmf4bi */
  if (!
#line 1964 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
    return -1;
  return 3820; /* pred_movrvvmf4bi */
}

 int
recog_394 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[4] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[5] = x5;
  x6 = XEXP (x2, 1);
  operands[3] = x6;
  if (!vector_move_operand (operands[3], E_RVVM1BImode))
    return -1;
  x7 = XEXP (x2, 2);
  operands[2] = x7;
  if (!vector_undef_operand (operands[2], E_RVVM1BImode))
    return -1;
  if (
#line 170 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
    return 1237; /* *pred_th_movrvvm1bi */
  if (!
#line 1964 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
    return -1;
  return 3822; /* pred_movrvvm1bi */
}

 int
recog_397 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern467 (x2))
    {
    case 0:
      if (!
#line 212 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR))
        return -1;
      return 28609; /* *cond_len_zero_extendrvvm4qirvvm8hi */

    case 1:
      if (!
#line 212 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR))
        return -1;
      return 28611; /* *cond_len_zero_extendrvvm2qirvvm4hi */

    case 2:
      if (!
#line 212 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR))
        return -1;
      return 28613; /* *cond_len_zero_extendrvvm1qirvvm2hi */

    case 3:
      if (!
#line 212 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR))
        return -1;
      return 28615; /* *cond_len_zero_extendrvvmf2qirvvm1hi */

    case 4:
      if (!
#line 212 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR))
        return -1;
      return 28617; /* *cond_len_zero_extendrvvmf4qirvvmf2hi */

    case 5:
      if (!(
#line 212 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 946 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 28619; /* *cond_len_zero_extendrvvmf8qirvvmf4hi */

    case 6:
      if (!
#line 212 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR))
        return -1;
      return 28621; /* *cond_len_zero_extendrvvm4hirvvm8si */

    case 7:
      if (!
#line 238 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR))
        return -1;
      return 28705; /* *cond_len_zero_extendrvvm2qirvvm8si */

    case 8:
      if (!
#line 212 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR))
        return -1;
      return 28623; /* *cond_len_zero_extendrvvm2hirvvm4si */

    case 9:
      if (!
#line 238 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR))
        return -1;
      return 28707; /* *cond_len_zero_extendrvvm1qirvvm4si */

    case 10:
      if (!
#line 212 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR))
        return -1;
      return 28625; /* *cond_len_zero_extendrvvm1hirvvm2si */

    case 11:
      if (!
#line 238 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR))
        return -1;
      return 28709; /* *cond_len_zero_extendrvvmf2qirvvm2si */

    case 12:
      if (!
#line 212 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR))
        return -1;
      return 28627; /* *cond_len_zero_extendrvvmf2hirvvm1si */

    case 13:
      if (!
#line 238 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR))
        return -1;
      return 28711; /* *cond_len_zero_extendrvvmf4qirvvm1si */

    case 14:
      if (!(
#line 212 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 948 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 28629; /* *cond_len_zero_extendrvvmf4hirvvmf2si */

    case 15:
      if (!(
#line 238 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1106 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 28713; /* *cond_len_zero_extendrvvmf8qirvvmf2si */

    case 16:
      if (!(
#line 212 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 950 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28631; /* *cond_len_zero_extendrvvm4sirvvm8di */

    case 17:
      if (!(
#line 238 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1108 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28715; /* *cond_len_zero_extendrvvm2hirvvm8di */

    case 18:
      if (!(
#line 264 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1151 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28765; /* *cond_len_zero_extendrvvm1qirvvm8di */

    case 19:
      if (!(
#line 212 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 950 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28633; /* *cond_len_zero_extendrvvm2sirvvm4di */

    case 20:
      if (!(
#line 238 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1108 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28717; /* *cond_len_zero_extendrvvm1hirvvm4di */

    case 21:
      if (!(
#line 264 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1151 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28767; /* *cond_len_zero_extendrvvmf2qirvvm4di */

    case 22:
      if (!(
#line 212 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 951 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28635; /* *cond_len_zero_extendrvvm1sirvvm2di */

    case 23:
      if (!(
#line 238 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1109 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28719; /* *cond_len_zero_extendrvvmf2hirvvm2di */

    case 24:
      if (!(
#line 264 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1152 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28769; /* *cond_len_zero_extendrvvmf4qirvvm2di */

    case 25:
      if (!(
#line 212 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 951 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28637; /* *cond_len_zero_extendrvvmf2sirvvm1di */

    case 26:
      if (!(
#line 238 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1109 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28721; /* *cond_len_zero_extendrvvmf4hirvvm1di */

    case 27:
      if (!(
#line 264 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1152 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28771; /* *cond_len_zero_extendrvvmf8qirvvm1di */

    case 28:
      if (!(
#line 212 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 953 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 28639; /* *cond_len_zero_extendv1qiv1hi */

    case 29:
      if (!(
#line 212 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 954 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 28641; /* *cond_len_zero_extendv2qiv2hi */

    case 30:
      if (!(
#line 212 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 955 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 28643; /* *cond_len_zero_extendv4qiv4hi */

    case 31:
      if (!(
#line 212 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 956 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 28645; /* *cond_len_zero_extendv8qiv8hi */

    case 32:
      if (!(
#line 212 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 957 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 28647; /* *cond_len_zero_extendv16qiv16hi */

    case 33:
      if (!(
#line 212 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 958 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28649; /* *cond_len_zero_extendv32qiv32hi */

    case 34:
      if (!(
#line 212 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 959 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28651; /* *cond_len_zero_extendv64qiv64hi */

    case 35:
      if (!(
#line 212 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 960 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28653; /* *cond_len_zero_extendv128qiv128hi */

    case 36:
      if (!(
#line 212 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 961 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28655; /* *cond_len_zero_extendv256qiv256hi */

    case 37:
      if (!(
#line 212 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 962 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28657; /* *cond_len_zero_extendv512qiv512hi */

    case 38:
      if (!(
#line 212 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 963 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28659; /* *cond_len_zero_extendv1024qiv1024hi */

    case 39:
      if (!(
#line 212 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 964 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28661; /* *cond_len_zero_extendv2048qiv2048hi */

    case 40:
      if (!(
#line 212 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 965 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 28663; /* *cond_len_zero_extendv1hiv1si */

    case 41:
      if (!(
#line 238 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1111 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 28723; /* *cond_len_zero_extendv1qiv1si */

    case 42:
      if (!(
#line 212 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 966 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 28665; /* *cond_len_zero_extendv2hiv2si */

    case 43:
      if (!(
#line 238 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1112 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 28725; /* *cond_len_zero_extendv2qiv2si */

    case 44:
      if (!(
#line 212 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 967 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 28667; /* *cond_len_zero_extendv4hiv4si */

    case 45:
      if (!(
#line 238 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1113 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 28727; /* *cond_len_zero_extendv4qiv4si */

    case 46:
      if (!(
#line 212 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 968 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 28669; /* *cond_len_zero_extendv8hiv8si */

    case 47:
      if (!(
#line 238 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1114 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 28729; /* *cond_len_zero_extendv8qiv8si */

    case 48:
      if (!(
#line 212 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 969 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28671; /* *cond_len_zero_extendv16hiv16si */

    case 49:
      if (!(
#line 238 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1115 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28731; /* *cond_len_zero_extendv16qiv16si */

    case 50:
      if (!(
#line 212 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 970 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28673; /* *cond_len_zero_extendv32hiv32si */

    case 51:
      if (!(
#line 238 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1116 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28733; /* *cond_len_zero_extendv32qiv32si */

    case 52:
      if (!(
#line 212 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 971 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28675; /* *cond_len_zero_extendv64hiv64si */

    case 53:
      if (!(
#line 238 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1117 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28735; /* *cond_len_zero_extendv64qiv64si */

    case 54:
      if (!(
#line 212 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 972 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28677; /* *cond_len_zero_extendv128hiv128si */

    case 55:
      if (!(
#line 238 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1118 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28737; /* *cond_len_zero_extendv128qiv128si */

    case 56:
      if (!(
#line 212 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 973 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28679; /* *cond_len_zero_extendv256hiv256si */

    case 57:
      if (!(
#line 238 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1119 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28739; /* *cond_len_zero_extendv256qiv256si */

    case 58:
      if (!(
#line 212 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 974 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28681; /* *cond_len_zero_extendv512hiv512si */

    case 59:
      if (!(
#line 238 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1120 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28741; /* *cond_len_zero_extendv512qiv512si */

    case 60:
      if (!(
#line 212 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 975 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28683; /* *cond_len_zero_extendv1024hiv1024si */

    case 61:
      if (!(
#line 238 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1121 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28743; /* *cond_len_zero_extendv1024qiv1024si */

    case 62:
      if (!(
#line 212 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 976 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28685; /* *cond_len_zero_extendv1siv1di */

    case 63:
      if (!(
#line 238 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1122 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28745; /* *cond_len_zero_extendv1hiv1di */

    case 64:
      if (!(
#line 264 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1154 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28773; /* *cond_len_zero_extendv1qiv1di */

    case 65:
      if (!(
#line 212 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 977 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28687; /* *cond_len_zero_extendv2siv2di */

    case 66:
      if (!(
#line 238 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1123 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28747; /* *cond_len_zero_extendv2hiv2di */

    case 67:
      if (!(
#line 264 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1155 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28775; /* *cond_len_zero_extendv2qiv2di */

    case 68:
      if (!(
#line 212 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 978 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28689; /* *cond_len_zero_extendv4siv4di */

    case 69:
      if (!(
#line 238 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1124 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28749; /* *cond_len_zero_extendv4hiv4di */

    case 70:
      if (!(
#line 264 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1156 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28777; /* *cond_len_zero_extendv4qiv4di */

    case 71:
      if (!(
#line 212 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 979 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28691; /* *cond_len_zero_extendv8siv8di */

    case 72:
      if (!(
#line 238 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1125 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28751; /* *cond_len_zero_extendv8hiv8di */

    case 73:
      if (!(
#line 264 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1157 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28779; /* *cond_len_zero_extendv8qiv8di */

    case 74:
      if (!(
#line 212 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 980 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28693; /* *cond_len_zero_extendv16siv16di */

    case 75:
      if (!(
#line 238 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1126 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28753; /* *cond_len_zero_extendv16hiv16di */

    case 76:
      if (!(
#line 264 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1158 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28781; /* *cond_len_zero_extendv16qiv16di */

    case 77:
      if (!(
#line 212 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 981 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28695; /* *cond_len_zero_extendv32siv32di */

    case 78:
      if (!(
#line 238 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1127 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28755; /* *cond_len_zero_extendv32hiv32di */

    case 79:
      if (!(
#line 264 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1159 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28783; /* *cond_len_zero_extendv32qiv32di */

    case 80:
      if (!(
#line 212 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 982 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28697; /* *cond_len_zero_extendv64siv64di */

    case 81:
      if (!(
#line 238 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1128 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28757; /* *cond_len_zero_extendv64hiv64di */

    case 82:
      if (!(
#line 264 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1160 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28785; /* *cond_len_zero_extendv64qiv64di */

    case 83:
      if (!(
#line 212 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 983 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28699; /* *cond_len_zero_extendv128siv128di */

    case 84:
      if (!(
#line 238 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1129 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28759; /* *cond_len_zero_extendv128hiv128di */

    case 85:
      if (!(
#line 264 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1161 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28787; /* *cond_len_zero_extendv128qiv128di */

    case 86:
      if (!(
#line 212 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 984 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28701; /* *cond_len_zero_extendv256siv256di */

    case 87:
      if (!(
#line 238 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1130 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28761; /* *cond_len_zero_extendv256hiv256di */

    case 88:
      if (!(
#line 264 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1162 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28789; /* *cond_len_zero_extendv256qiv256di */

    case 89:
      if (!(
#line 212 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 985 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28703; /* *cond_len_zero_extendv512siv512di */

    case 90:
      if (!(
#line 238 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1131 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28763; /* *cond_len_zero_extendv512hiv512di */

    case 91:
      if (!(
#line 264 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1163 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28791; /* *cond_len_zero_extendv512qiv512di */

    default:
      return -1;
    }
}

 int
recog_398 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 0);
  if (GET_CODE (x4) != MINUS)
    return -1;
  x5 = XEXP (x2, 0);
  x6 = XVECEXP (x5, 0, 0);
  operands[5] = x6;
  x7 = XVECEXP (x5, 0, 1);
  operands[6] = x7;
  x8 = XVECEXP (x5, 0, 2);
  operands[7] = x8;
  x9 = XEXP (x4, 0);
  operands[2] = x9;
  x10 = XVECEXP (x3, 0, 1);
  operands[4] = x10;
  x11 = XEXP (x2, 2);
  operands[1] = x11;
  x12 = XEXP (x4, 1);
  switch (GET_CODE (x12))
    {
    case REG:
    case SUBREG:
      operands[3] = x12;
      switch (GET_MODE (operands[0]))
        {
        case E_RVVM8QImode:
          if (pattern681 (x2, 
E_RVVM8QImode, 
E_RVVM1BImode) != 0
              || !
#line 3216 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 8499; /* pred_sbcrvvm8qi */

        case E_RVVM4QImode:
          if (pattern681 (x2, 
E_RVVM4QImode, 
E_RVVMF2BImode) != 0
              || !
#line 3216 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 8500; /* pred_sbcrvvm4qi */

        case E_RVVM2QImode:
          if (pattern681 (x2, 
E_RVVM2QImode, 
E_RVVMF4BImode) != 0
              || !
#line 3216 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 8501; /* pred_sbcrvvm2qi */

        case E_RVVM1QImode:
          if (pattern681 (x2, 
E_RVVM1QImode, 
E_RVVMF8BImode) != 0
              || !
#line 3216 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 8502; /* pred_sbcrvvm1qi */

        case E_RVVM8HImode:
          if (pattern681 (x2, 
E_RVVM8HImode, 
E_RVVMF2BImode) != 0
              || !
#line 3216 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 8503; /* pred_sbcrvvm8hi */

        case E_RVVM4HImode:
          if (pattern681 (x2, 
E_RVVM4HImode, 
E_RVVMF4BImode) != 0
              || !
#line 3216 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 8504; /* pred_sbcrvvm4hi */

        case E_RVVM2HImode:
          if (pattern681 (x2, 
E_RVVM2HImode, 
E_RVVMF8BImode) != 0
              || !
#line 3216 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 8505; /* pred_sbcrvvm2hi */

        case E_RVVM1HImode:
          if (pattern681 (x2, 
E_RVVM1HImode, 
E_RVVMF16BImode) != 0
              || !
#line 3216 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 8506; /* pred_sbcrvvm1hi */

        case E_RVVM8SImode:
          if (pattern681 (x2, 
E_RVVM8SImode, 
E_RVVMF4BImode) != 0
              || !
#line 3216 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 8507; /* pred_sbcrvvm8si */

        case E_RVVM4SImode:
          if (pattern681 (x2, 
E_RVVM4SImode, 
E_RVVMF8BImode) != 0
              || !
#line 3216 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 8508; /* pred_sbcrvvm4si */

        case E_RVVM2SImode:
          if (pattern681 (x2, 
E_RVVM2SImode, 
E_RVVMF16BImode) != 0
              || !
#line 3216 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 8509; /* pred_sbcrvvm2si */

        case E_RVVM1SImode:
          if (pattern681 (x2, 
E_RVVM1SImode, 
E_RVVMF32BImode) != 0
              || !
#line 3216 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 8510; /* pred_sbcrvvm1si */

        case E_RVVM8DImode:
          if (pattern681 (x2, 
E_RVVM8DImode, 
E_RVVMF8BImode) != 0
              || !(
#line 3216 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 8511; /* pred_sbcrvvm8di */

        case E_RVVM4DImode:
          if (pattern681 (x2, 
E_RVVM4DImode, 
E_RVVMF16BImode) != 0
              || !(
#line 3216 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 8512; /* pred_sbcrvvm4di */

        case E_RVVM2DImode:
          if (pattern681 (x2, 
E_RVVM2DImode, 
E_RVVMF32BImode) != 0
              || !(
#line 3216 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 8513; /* pred_sbcrvvm2di */

        case E_RVVM1DImode:
          if (pattern681 (x2, 
E_RVVM1DImode, 
E_RVVMF64BImode) != 0
              || !(
#line 3216 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 8514; /* pred_sbcrvvm1di */

        case E_RVVMF2QImode:
          if (pattern681 (x2, 
E_RVVMF2QImode, 
E_RVVMF16BImode) != 0
              || !(
#line 3216 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 8515; /* pred_sbcrvvmf2qi */

        case E_RVVMF4QImode:
          if (pattern681 (x2, 
E_RVVMF4QImode, 
E_RVVMF32BImode) != 0
              || !(
#line 3216 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 8516; /* pred_sbcrvvmf4qi */

        case E_RVVMF8QImode:
          if (pattern681 (x2, 
E_RVVMF8QImode, 
E_RVVMF64BImode) != 0
              || !(
#line 3216 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 8517; /* pred_sbcrvvmf8qi */

        case E_RVVMF2HImode:
          if (pattern681 (x2, 
E_RVVMF2HImode, 
E_RVVMF32BImode) != 0
              || !(
#line 3216 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 8518; /* pred_sbcrvvmf2hi */

        case E_RVVMF4HImode:
          if (pattern681 (x2, 
E_RVVMF4HImode, 
E_RVVMF64BImode) != 0
              || !(
#line 3216 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 132 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 8519; /* pred_sbcrvvmf4hi */

        case E_RVVMF2SImode:
          if (pattern681 (x2, 
E_RVVMF2SImode, 
E_RVVMF64BImode) != 0
              || !(
#line 3216 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 133 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 8520; /* pred_sbcrvvmf2si */

        default:
          return -1;
        }

    case VEC_DUPLICATE:
      x13 = XEXP (x12, 0);
      switch (GET_CODE (x13))
        {
        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case REG:
        case SUBREG:
          operands[3] = x13;
          switch (GET_MODE (operands[0]))
            {
            case E_RVVM8QImode:
              if (pattern694 (x2, 
E_RVVM8QImode, 
E_RVVM1BImode, 
E_QImode) != 0
                  || !
#line 3266 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 8575; /* pred_sbcrvvm8qi_scalar */

            case E_RVVM4QImode:
              if (pattern694 (x2, 
E_RVVM4QImode, 
E_RVVMF2BImode, 
E_QImode) != 0
                  || !
#line 3266 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 8576; /* pred_sbcrvvm4qi_scalar */

            case E_RVVM2QImode:
              if (pattern694 (x2, 
E_RVVM2QImode, 
E_RVVMF4BImode, 
E_QImode) != 0
                  || !
#line 3266 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 8577; /* pred_sbcrvvm2qi_scalar */

            case E_RVVM1QImode:
              if (pattern694 (x2, 
E_RVVM1QImode, 
E_RVVMF8BImode, 
E_QImode) != 0
                  || !
#line 3266 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 8578; /* pred_sbcrvvm1qi_scalar */

            case E_RVVMF2QImode:
              if (pattern694 (x2, 
E_RVVMF2QImode, 
E_RVVMF16BImode, 
E_QImode) != 0
                  || !
#line 3266 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 8579; /* pred_sbcrvvmf2qi_scalar */

            case E_RVVMF4QImode:
              if (pattern694 (x2, 
E_RVVMF4QImode, 
E_RVVMF32BImode, 
E_QImode) != 0
                  || !
#line 3266 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 8580; /* pred_sbcrvvmf4qi_scalar */

            case E_RVVMF8QImode:
              if (pattern694 (x2, 
E_RVVMF8QImode, 
E_RVVMF64BImode, 
E_QImode) != 0
                  || !(
#line 3266 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 565 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
                return -1;
              return 8581; /* pred_sbcrvvmf8qi_scalar */

            case E_RVVM8HImode:
              if (pattern694 (x2, 
E_RVVM8HImode, 
E_RVVMF2BImode, 
E_HImode) != 0
                  || !
#line 3266 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 8582; /* pred_sbcrvvm8hi_scalar */

            case E_RVVM4HImode:
              if (pattern694 (x2, 
E_RVVM4HImode, 
E_RVVMF4BImode, 
E_HImode) != 0
                  || !
#line 3266 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 8583; /* pred_sbcrvvm4hi_scalar */

            case E_RVVM2HImode:
              if (pattern694 (x2, 
E_RVVM2HImode, 
E_RVVMF8BImode, 
E_HImode) != 0
                  || !
#line 3266 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 8584; /* pred_sbcrvvm2hi_scalar */

            case E_RVVM1HImode:
              if (pattern694 (x2, 
E_RVVM1HImode, 
E_RVVMF16BImode, 
E_HImode) != 0
                  || !
#line 3266 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 8585; /* pred_sbcrvvm1hi_scalar */

            case E_RVVMF2HImode:
              if (pattern694 (x2, 
E_RVVMF2HImode, 
E_RVVMF32BImode, 
E_HImode) != 0
                  || !
#line 3266 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 8586; /* pred_sbcrvvmf2hi_scalar */

            case E_RVVMF4HImode:
              if (pattern694 (x2, 
E_RVVMF4HImode, 
E_RVVMF64BImode, 
E_HImode) != 0
                  || !(
#line 3266 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 567 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
                return -1;
              return 8587; /* pred_sbcrvvmf4hi_scalar */

            case E_RVVM8SImode:
              if (pattern694 (x2, 
E_RVVM8SImode, 
E_RVVMF4BImode, 
E_SImode) != 0
                  || !
#line 3266 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 8588; /* pred_sbcrvvm8si_scalar */

            case E_RVVM4SImode:
              if (pattern694 (x2, 
E_RVVM4SImode, 
E_RVVMF8BImode, 
E_SImode) != 0
                  || !
#line 3266 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 8589; /* pred_sbcrvvm4si_scalar */

            case E_RVVM2SImode:
              if (pattern694 (x2, 
E_RVVM2SImode, 
E_RVVMF16BImode, 
E_SImode) != 0
                  || !
#line 3266 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 8590; /* pred_sbcrvvm2si_scalar */

            case E_RVVM1SImode:
              if (pattern694 (x2, 
E_RVVM1SImode, 
E_RVVMF32BImode, 
E_SImode) != 0
                  || !
#line 3266 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 8591; /* pred_sbcrvvm1si_scalar */

            case E_RVVMF2SImode:
              if (pattern694 (x2, 
E_RVVMF2SImode, 
E_RVVMF64BImode, 
E_SImode) != 0
                  || !(
#line 3266 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 569 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
                return -1;
              return 8592; /* pred_sbcrvvmf2si_scalar */

            case E_V1QImode:
              if (pattern694 (x2, 
E_V1QImode, 
E_V1BImode, 
E_QImode) != 0
                  || !(
#line 3266 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 571 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
                return -1;
              return 8593; /* pred_sbcv1qi_scalar */

            case E_V2QImode:
              if (pattern694 (x2, 
E_V2QImode, 
E_V2BImode, 
E_QImode) != 0
                  || !(
#line 3266 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 572 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
                return -1;
              return 8594; /* pred_sbcv2qi_scalar */

            case E_V4QImode:
              if (pattern694 (x2, 
E_V4QImode, 
E_V4BImode, 
E_QImode) != 0
                  || !(
#line 3266 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 573 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
                return -1;
              return 8595; /* pred_sbcv4qi_scalar */

            case E_V8QImode:
              if (pattern694 (x2, 
E_V8QImode, 
E_V8BImode, 
E_QImode) != 0
                  || !(
#line 3266 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 574 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
                return -1;
              return 8596; /* pred_sbcv8qi_scalar */

            case E_V16QImode:
              if (pattern694 (x2, 
E_V16QImode, 
E_V16BImode, 
E_QImode) != 0
                  || !(
#line 3266 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 575 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
                return -1;
              return 8597; /* pred_sbcv16qi_scalar */

            case E_V32QImode:
              if (pattern694 (x2, 
E_V32QImode, 
E_V32BImode, 
E_QImode) != 0
                  || !(
#line 3266 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 576 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
                return -1;
              return 8598; /* pred_sbcv32qi_scalar */

            case E_V64QImode:
              if (pattern694 (x2, 
E_V64QImode, 
E_V64BImode, 
E_QImode) != 0
                  || !(
#line 3266 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 577 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 8599; /* pred_sbcv64qi_scalar */

            case E_V128QImode:
              if (pattern694 (x2, 
E_V128QImode, 
E_V128BImode, 
E_QImode) != 0
                  || !(
#line 3266 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 578 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 8600; /* pred_sbcv128qi_scalar */

            case E_V256QImode:
              if (pattern694 (x2, 
E_V256QImode, 
E_V256BImode, 
E_QImode) != 0
                  || !(
#line 3266 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 579 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 8601; /* pred_sbcv256qi_scalar */

            case E_V512QImode:
              if (pattern694 (x2, 
E_V512QImode, 
E_V512BImode, 
E_QImode) != 0
                  || !(
#line 3266 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 580 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 8602; /* pred_sbcv512qi_scalar */

            case E_V1024QImode:
              if (pattern694 (x2, 
E_V1024QImode, 
E_V1024BImode, 
E_QImode) != 0
                  || !(
#line 3266 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 581 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 8603; /* pred_sbcv1024qi_scalar */

            case E_V2048QImode:
              if (pattern694 (x2, 
E_V2048QImode, 
E_V2048BImode, 
E_QImode) != 0
                  || !(
#line 3266 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 582 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 8604; /* pred_sbcv2048qi_scalar */

            case E_V4096QImode:
              if (pattern694 (x2, 
E_V4096QImode, 
E_V4096BImode, 
E_QImode) != 0
                  || !(
#line 3266 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 583 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 8605; /* pred_sbcv4096qi_scalar */

            case E_V1HImode:
              if (pattern694 (x2, 
E_V1HImode, 
E_V1BImode, 
E_HImode) != 0
                  || !(
#line 3266 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 584 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
                return -1;
              return 8606; /* pred_sbcv1hi_scalar */

            case E_V2HImode:
              if (pattern694 (x2, 
E_V2HImode, 
E_V2BImode, 
E_HImode) != 0
                  || !(
#line 3266 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 585 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
                return -1;
              return 8607; /* pred_sbcv2hi_scalar */

            case E_V4HImode:
              if (pattern694 (x2, 
E_V4HImode, 
E_V4BImode, 
E_HImode) != 0
                  || !(
#line 3266 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 586 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
                return -1;
              return 8608; /* pred_sbcv4hi_scalar */

            case E_V8HImode:
              if (pattern694 (x2, 
E_V8HImode, 
E_V8BImode, 
E_HImode) != 0
                  || !(
#line 3266 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 587 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
                return -1;
              return 8609; /* pred_sbcv8hi_scalar */

            case E_V16HImode:
              if (pattern694 (x2, 
E_V16HImode, 
E_V16BImode, 
E_HImode) != 0
                  || !(
#line 3266 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 588 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
                return -1;
              return 8610; /* pred_sbcv16hi_scalar */

            case E_V32HImode:
              if (pattern694 (x2, 
E_V32HImode, 
E_V32BImode, 
E_HImode) != 0
                  || !(
#line 3266 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 589 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 8611; /* pred_sbcv32hi_scalar */

            case E_V64HImode:
              if (pattern694 (x2, 
E_V64HImode, 
E_V64BImode, 
E_HImode) != 0
                  || !(
#line 3266 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 590 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 8612; /* pred_sbcv64hi_scalar */

            case E_V128HImode:
              if (pattern694 (x2, 
E_V128HImode, 
E_V128BImode, 
E_HImode) != 0
                  || !(
#line 3266 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 591 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 8613; /* pred_sbcv128hi_scalar */

            case E_V256HImode:
              if (pattern694 (x2, 
E_V256HImode, 
E_V256BImode, 
E_HImode) != 0
                  || !(
#line 3266 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 592 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 8614; /* pred_sbcv256hi_scalar */

            case E_V512HImode:
              if (pattern694 (x2, 
E_V512HImode, 
E_V512BImode, 
E_HImode) != 0
                  || !(
#line 3266 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 593 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 8615; /* pred_sbcv512hi_scalar */

            case E_V1024HImode:
              if (pattern694 (x2, 
E_V1024HImode, 
E_V1024BImode, 
E_HImode) != 0
                  || !(
#line 3266 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 594 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 8616; /* pred_sbcv1024hi_scalar */

            case E_V2048HImode:
              if (pattern694 (x2, 
E_V2048HImode, 
E_V2048BImode, 
E_HImode) != 0
                  || !(
#line 3266 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 595 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 8617; /* pred_sbcv2048hi_scalar */

            case E_V1SImode:
              if (pattern694 (x2, 
E_V1SImode, 
E_V1BImode, 
E_SImode) != 0
                  || !(
#line 3266 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 596 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
                return -1;
              return 8618; /* pred_sbcv1si_scalar */

            case E_V2SImode:
              if (pattern694 (x2, 
E_V2SImode, 
E_V2BImode, 
E_SImode) != 0
                  || !(
#line 3266 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 597 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
                return -1;
              return 8619; /* pred_sbcv2si_scalar */

            case E_V4SImode:
              if (pattern694 (x2, 
E_V4SImode, 
E_V4BImode, 
E_SImode) != 0
                  || !(
#line 3266 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 598 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
                return -1;
              return 8620; /* pred_sbcv4si_scalar */

            case E_V8SImode:
              if (pattern694 (x2, 
E_V8SImode, 
E_V8BImode, 
E_SImode) != 0
                  || !(
#line 3266 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 599 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
                return -1;
              return 8621; /* pred_sbcv8si_scalar */

            case E_V16SImode:
              if (pattern694 (x2, 
E_V16SImode, 
E_V16BImode, 
E_SImode) != 0
                  || !(
#line 3266 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 600 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 8622; /* pred_sbcv16si_scalar */

            case E_V32SImode:
              if (pattern694 (x2, 
E_V32SImode, 
E_V32BImode, 
E_SImode) != 0
                  || !(
#line 3266 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 601 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 8623; /* pred_sbcv32si_scalar */

            case E_V64SImode:
              if (pattern694 (x2, 
E_V64SImode, 
E_V64BImode, 
E_SImode) != 0
                  || !(
#line 3266 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 602 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 8624; /* pred_sbcv64si_scalar */

            case E_V128SImode:
              if (pattern694 (x2, 
E_V128SImode, 
E_V128BImode, 
E_SImode) != 0
                  || !(
#line 3266 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 603 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 8625; /* pred_sbcv128si_scalar */

            case E_V256SImode:
              if (pattern694 (x2, 
E_V256SImode, 
E_V256BImode, 
E_SImode) != 0
                  || !(
#line 3266 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 604 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 8626; /* pred_sbcv256si_scalar */

            case E_V512SImode:
              if (pattern694 (x2, 
E_V512SImode, 
E_V512BImode, 
E_SImode) != 0
                  || !(
#line 3266 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 605 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 8627; /* pred_sbcv512si_scalar */

            case E_V1024SImode:
              if (pattern694 (x2, 
E_V1024SImode, 
E_V1024BImode, 
E_SImode) != 0
                  || !(
#line 3266 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 606 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 8628; /* pred_sbcv1024si_scalar */

            case E_RVVM8DImode:
              if (pattern694 (x2, 
E_RVVM8DImode, 
E_RVVMF8BImode, 
E_DImode) != 0
                  || !(
#line 3408 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 769 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 8637; /* *pred_sbcrvvm8di_scalar */

            case E_RVVM4DImode:
              if (pattern694 (x2, 
E_RVVM4DImode, 
E_RVVMF16BImode, 
E_DImode) != 0
                  || !(
#line 3408 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 769 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 8638; /* *pred_sbcrvvm4di_scalar */

            case E_RVVM2DImode:
              if (pattern694 (x2, 
E_RVVM2DImode, 
E_RVVMF32BImode, 
E_DImode) != 0
                  || !(
#line 3408 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 770 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 8639; /* *pred_sbcrvvm2di_scalar */

            case E_RVVM1DImode:
              if (pattern694 (x2, 
E_RVVM1DImode, 
E_RVVMF64BImode, 
E_DImode) != 0
                  || !(
#line 3408 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 770 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 8640; /* *pred_sbcrvvm1di_scalar */

            default:
              return -1;
            }

        case SIGN_EXTEND:
          if (GET_MODE (x13) != E_DImode)
            return -1;
          x14 = XEXP (x13, 0);
          operands[3] = x14;
          if (!reg_or_0_operand (operands[3], E_SImode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_RVVM8DImode:
              if (pattern710 (x2, 
E_RVVM8DImode, 
E_RVVMF8BImode) != 0
                  || !(
#line 3434 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 769 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 8641; /* *pred_sbcrvvm8di_extended_scalar */

            case E_RVVM4DImode:
              if (pattern710 (x2, 
E_RVVM4DImode, 
E_RVVMF16BImode) != 0
                  || !(
#line 3434 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 769 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 8642; /* *pred_sbcrvvm4di_extended_scalar */

            case E_RVVM2DImode:
              if (pattern710 (x2, 
E_RVVM2DImode, 
E_RVVMF32BImode) != 0
                  || !(
#line 3434 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 770 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 8643; /* *pred_sbcrvvm2di_extended_scalar */

            case E_RVVM1DImode:
              if (pattern710 (x2, 
E_RVVM1DImode, 
E_RVVMF64BImode) != 0
                  || !(
#line 3434 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 770 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 8644; /* *pred_sbcrvvm1di_extended_scalar */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_411 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8QImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVM8QImode, 
E_RVVM1BImode) != 0
          || !
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVM8QImode)
        || register_operand (operands[3], RVVM8QImode)))))
        return -1;
      return 3651; /* *pred_movrvvm8qi */

    case E_RVVM4QImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVM4QImode, 
E_RVVMF2BImode) != 0
          || !
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVM4QImode)
        || register_operand (operands[3], RVVM4QImode)))))
        return -1;
      return 3652; /* *pred_movrvvm4qi */

    case E_RVVM2QImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVM2QImode, 
E_RVVMF4BImode) != 0
          || !
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVM2QImode)
        || register_operand (operands[3], RVVM2QImode)))))
        return -1;
      return 3653; /* *pred_movrvvm2qi */

    case E_RVVM1QImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVM1QImode, 
E_RVVMF8BImode) != 0
          || !
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVM1QImode)
        || register_operand (operands[3], RVVM1QImode)))))
        return -1;
      return 3654; /* *pred_movrvvm1qi */

    case E_RVVM8HImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVM8HImode, 
E_RVVMF2BImode) != 0
          || !
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVM8HImode)
        || register_operand (operands[3], RVVM8HImode)))))
        return -1;
      return 3655; /* *pred_movrvvm8hi */

    case E_RVVM4HImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVM4HImode, 
E_RVVMF4BImode) != 0
          || !
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVM4HImode)
        || register_operand (operands[3], RVVM4HImode)))))
        return -1;
      return 3656; /* *pred_movrvvm4hi */

    case E_RVVM2HImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVM2HImode, 
E_RVVMF8BImode) != 0
          || !
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVM2HImode)
        || register_operand (operands[3], RVVM2HImode)))))
        return -1;
      return 3657; /* *pred_movrvvm2hi */

    case E_RVVM1HImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVM1HImode, 
E_RVVMF16BImode) != 0
          || !
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVM1HImode)
        || register_operand (operands[3], RVVM1HImode)))))
        return -1;
      return 3658; /* *pred_movrvvm1hi */

    case E_RVVM8SImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVM8SImode, 
E_RVVMF4BImode) != 0
          || !
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVM8SImode)
        || register_operand (operands[3], RVVM8SImode)))))
        return -1;
      return 3659; /* *pred_movrvvm8si */

    case E_RVVM4SImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVM4SImode, 
E_RVVMF8BImode) != 0
          || !
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVM4SImode)
        || register_operand (operands[3], RVVM4SImode)))))
        return -1;
      return 3660; /* *pred_movrvvm4si */

    case E_RVVM2SImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVM2SImode, 
E_RVVMF16BImode) != 0
          || !
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVM2SImode)
        || register_operand (operands[3], RVVM2SImode)))))
        return -1;
      return 3661; /* *pred_movrvvm2si */

    case E_RVVM1SImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVM1SImode, 
E_RVVMF32BImode) != 0
          || !
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVM1SImode)
        || register_operand (operands[3], RVVM1SImode)))))
        return -1;
      return 3662; /* *pred_movrvvm1si */

    case E_RVVM8DImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVM8DImode, 
E_RVVMF8BImode) != 0
          || !(
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVM8DImode)
        || register_operand (operands[3], RVVM8DImode)))) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 3663; /* *pred_movrvvm8di */

    case E_RVVM4DImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVM4DImode, 
E_RVVMF16BImode) != 0
          || !(
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVM4DImode)
        || register_operand (operands[3], RVVM4DImode)))) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 3664; /* *pred_movrvvm4di */

    case E_RVVM2DImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVM2DImode, 
E_RVVMF32BImode) != 0
          || !(
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVM2DImode)
        || register_operand (operands[3], RVVM2DImode)))) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 3665; /* *pred_movrvvm2di */

    case E_RVVM1DImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVM1DImode, 
E_RVVMF64BImode) != 0
          || !(
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVM1DImode)
        || register_operand (operands[3], RVVM1DImode)))) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 3666; /* *pred_movrvvm1di */

    case E_RVVMF2QImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVMF2QImode, 
E_RVVMF16BImode) != 0
          || !(
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVMF2QImode)
        || register_operand (operands[3], RVVMF2QImode)))) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 3667; /* *pred_movrvvmf2qi */

    case E_RVVMF4QImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVMF4QImode, 
E_RVVMF32BImode) != 0
          || !(
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVMF4QImode)
        || register_operand (operands[3], RVVMF4QImode)))) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 3668; /* *pred_movrvvmf4qi */

    case E_RVVMF8QImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVMF8QImode, 
E_RVVMF64BImode) != 0
          || !(
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVMF8QImode)
        || register_operand (operands[3], RVVMF8QImode)))) && (
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 3669; /* *pred_movrvvmf8qi */

    case E_RVVMF2HImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVMF2HImode, 
E_RVVMF32BImode) != 0
          || !(
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVMF2HImode)
        || register_operand (operands[3], RVVMF2HImode)))) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 3670; /* *pred_movrvvmf2hi */

    case E_RVVMF4HImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVMF4HImode, 
E_RVVMF64BImode) != 0
          || !(
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVMF4HImode)
        || register_operand (operands[3], RVVMF4HImode)))) && (
#line 132 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 3671; /* *pred_movrvvmf4hi */

    case E_RVVMF2SImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVMF2SImode, 
E_RVVMF64BImode) != 0
          || !(
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVMF2SImode)
        || register_operand (operands[3], RVVMF2SImode)))) && (
#line 133 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 3672; /* *pred_movrvvmf2si */

    case E_RVVM8BFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVM8BFmode, 
E_RVVMF2BImode) != 0
          || !(
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVM8BFmode)
        || register_operand (operands[3], RVVM8BFmode)))) && 
#line 167 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 3673; /* *pred_movrvvm8bf */

    case E_RVVM4BFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVM4BFmode, 
E_RVVMF4BImode) != 0
          || !(
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVM4BFmode)
        || register_operand (operands[3], RVVM4BFmode)))) && 
#line 168 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 3674; /* *pred_movrvvm4bf */

    case E_RVVM2BFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVM2BFmode, 
E_RVVMF8BImode) != 0
          || !(
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVM2BFmode)
        || register_operand (operands[3], RVVM2BFmode)))) && 
#line 169 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 3675; /* *pred_movrvvm2bf */

    case E_RVVM1BFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVM1BFmode, 
E_RVVMF16BImode) != 0
          || !(
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVM1BFmode)
        || register_operand (operands[3], RVVM1BFmode)))) && 
#line 170 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 3676; /* *pred_movrvvm1bf */

    case E_RVVMF2BFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVMF2BFmode, 
E_RVVMF32BImode) != 0
          || !(
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVMF2BFmode)
        || register_operand (operands[3], RVVMF2BFmode)))) && 
#line 171 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 3677; /* *pred_movrvvmf2bf */

    case E_RVVMF4BFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVMF4BFmode, 
E_RVVMF64BImode) != 0
          || !(
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVMF4BFmode)
        || register_operand (operands[3], RVVMF4BFmode)))) && 
#line 172 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 3678; /* *pred_movrvvmf4bf */

    case E_RVVM8HFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVM8HFmode, 
E_RVVMF2BImode) != 0
          || !(
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVM8HFmode)
        || register_operand (operands[3], RVVM8HFmode)))) && 
#line 176 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 3679; /* *pred_movrvvm8hf */

    case E_RVVM4HFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVM4HFmode, 
E_RVVMF4BImode) != 0
          || !(
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVM4HFmode)
        || register_operand (operands[3], RVVM4HFmode)))) && 
#line 176 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 3680; /* *pred_movrvvm4hf */

    case E_RVVM2HFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVM2HFmode, 
E_RVVMF8BImode) != 0
          || !(
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVM2HFmode)
        || register_operand (operands[3], RVVM2HFmode)))) && 
#line 176 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 3681; /* *pred_movrvvm2hf */

    case E_RVVM1HFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVM1HFmode, 
E_RVVMF16BImode) != 0
          || !(
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVM1HFmode)
        || register_operand (operands[3], RVVM1HFmode)))) && 
#line 177 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 3682; /* *pred_movrvvm1hf */

    case E_RVVMF2HFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVMF2HFmode, 
E_RVVMF32BImode) != 0
          || !(
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVMF2HFmode)
        || register_operand (operands[3], RVVMF2HFmode)))) && 
#line 177 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 3683; /* *pred_movrvvmf2hf */

    case E_RVVMF4HFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVMF4HFmode, 
E_RVVMF64BImode) != 0
          || !(
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVMF4HFmode)
        || register_operand (operands[3], RVVMF4HFmode)))) && 
#line 178 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 3684; /* *pred_movrvvmf4hf */

    case E_RVVM8SFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVM8SFmode, 
E_RVVMF4BImode) != 0
          || !(
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVM8SFmode)
        || register_operand (operands[3], RVVM8SFmode)))) && 
#line 180 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 3685; /* *pred_movrvvm8sf */

    case E_RVVM4SFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVM4SFmode, 
E_RVVMF8BImode) != 0
          || !(
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVM4SFmode)
        || register_operand (operands[3], RVVM4SFmode)))) && 
#line 180 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 3686; /* *pred_movrvvm4sf */

    case E_RVVM2SFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVM2SFmode, 
E_RVVMF16BImode) != 0
          || !(
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVM2SFmode)
        || register_operand (operands[3], RVVM2SFmode)))) && 
#line 180 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 3687; /* *pred_movrvvm2sf */

    case E_RVVM1SFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVM1SFmode, 
E_RVVMF32BImode) != 0
          || !(
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVM1SFmode)
        || register_operand (operands[3], RVVM1SFmode)))) && 
#line 181 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 3688; /* *pred_movrvvm1sf */

    case E_RVVMF2SFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVMF2SFmode, 
E_RVVMF64BImode) != 0
          || !(
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVMF2SFmode)
        || register_operand (operands[3], RVVMF2SFmode)))) && 
#line 181 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 3689; /* *pred_movrvvmf2sf */

    case E_RVVM8DFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVM8DFmode, 
E_RVVMF8BImode) != 0
          || !(
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVM8DFmode)
        || register_operand (operands[3], RVVM8DFmode)))) && 
#line 183 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 3690; /* *pred_movrvvm8df */

    case E_RVVM4DFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVM4DFmode, 
E_RVVMF16BImode) != 0
          || !(
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVM4DFmode)
        || register_operand (operands[3], RVVM4DFmode)))) && 
#line 183 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 3691; /* *pred_movrvvm4df */

    case E_RVVM2DFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVM2DFmode, 
E_RVVMF32BImode) != 0
          || !(
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVM2DFmode)
        || register_operand (operands[3], RVVM2DFmode)))) && 
#line 184 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 3692; /* *pred_movrvvm2df */

    case E_RVVM1DFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVM1DFmode, 
E_RVVMF64BImode) != 0
          || !(
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVM1DFmode)
        || register_operand (operands[3], RVVM1DFmode)))) && 
#line 184 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 3693; /* *pred_movrvvm1df */

    case E_V1QImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V1QImode, 
E_V1BImode) != 0
          || !(
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V1QImode)
        || register_operand (operands[3], V1QImode)))) && 
#line 188 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 3694; /* *pred_movv1qi */

    case E_V2QImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V2QImode, 
E_V2BImode) != 0
          || !(
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V2QImode)
        || register_operand (operands[3], V2QImode)))) && 
#line 189 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 3695; /* *pred_movv2qi */

    case E_V4QImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V4QImode, 
E_V4BImode) != 0
          || !(
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V4QImode)
        || register_operand (operands[3], V4QImode)))) && 
#line 190 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 3696; /* *pred_movv4qi */

    case E_V8QImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V8QImode, 
E_V8BImode) != 0
          || !(
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V8QImode)
        || register_operand (operands[3], V8QImode)))) && 
#line 191 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 3697; /* *pred_movv8qi */

    case E_V16QImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V16QImode, 
E_V16BImode) != 0
          || !(
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V16QImode)
        || register_operand (operands[3], V16QImode)))) && 
#line 192 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 3698; /* *pred_movv16qi */

    case E_V32QImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V32QImode, 
E_V32BImode) != 0
          || !(
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V32QImode)
        || register_operand (operands[3], V32QImode)))) && 
#line 193 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 3699; /* *pred_movv32qi */

    case E_V64QImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V64QImode, 
E_V64BImode) != 0
          || !(
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V64QImode)
        || register_operand (operands[3], V64QImode)))) && 
#line 194 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 3700; /* *pred_movv64qi */

    case E_V128QImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V128QImode, 
E_V128BImode) != 0
          || !(
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V128QImode)
        || register_operand (operands[3], V128QImode)))) && 
#line 195 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 3701; /* *pred_movv128qi */

    case E_V256QImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V256QImode, 
E_V256BImode) != 0
          || !(
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V256QImode)
        || register_operand (operands[3], V256QImode)))) && 
#line 196 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 3702; /* *pred_movv256qi */

    case E_V512QImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V512QImode, 
E_V512BImode) != 0
          || !(
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V512QImode)
        || register_operand (operands[3], V512QImode)))) && 
#line 197 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 3703; /* *pred_movv512qi */

    case E_V1024QImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V1024QImode, 
E_V1024BImode) != 0
          || !(
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V1024QImode)
        || register_operand (operands[3], V1024QImode)))) && 
#line 198 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 3704; /* *pred_movv1024qi */

    case E_V2048QImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V2048QImode, 
E_V2048BImode) != 0
          || !(
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V2048QImode)
        || register_operand (operands[3], V2048QImode)))) && 
#line 199 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 3705; /* *pred_movv2048qi */

    case E_V4096QImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V4096QImode, 
E_V4096BImode) != 0
          || !(
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V4096QImode)
        || register_operand (operands[3], V4096QImode)))) && 
#line 200 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 3706; /* *pred_movv4096qi */

    case E_V1HImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V1HImode, 
E_V1BImode) != 0
          || !(
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V1HImode)
        || register_operand (operands[3], V1HImode)))) && 
#line 201 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 3707; /* *pred_movv1hi */

    case E_V2HImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V2HImode, 
E_V2BImode) != 0
          || !(
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V2HImode)
        || register_operand (operands[3], V2HImode)))) && 
#line 202 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 3708; /* *pred_movv2hi */

    case E_V4HImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V4HImode, 
E_V4BImode) != 0
          || !(
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V4HImode)
        || register_operand (operands[3], V4HImode)))) && 
#line 203 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 3709; /* *pred_movv4hi */

    case E_V8HImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V8HImode, 
E_V8BImode) != 0
          || !(
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V8HImode)
        || register_operand (operands[3], V8HImode)))) && 
#line 204 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 3710; /* *pred_movv8hi */

    case E_V16HImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V16HImode, 
E_V16BImode) != 0
          || !(
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V16HImode)
        || register_operand (operands[3], V16HImode)))) && 
#line 205 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 3711; /* *pred_movv16hi */

    case E_V32HImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V32HImode, 
E_V32BImode) != 0
          || !(
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V32HImode)
        || register_operand (operands[3], V32HImode)))) && 
#line 206 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 3712; /* *pred_movv32hi */

    case E_V64HImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V64HImode, 
E_V64BImode) != 0
          || !(
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V64HImode)
        || register_operand (operands[3], V64HImode)))) && 
#line 207 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 3713; /* *pred_movv64hi */

    case E_V128HImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V128HImode, 
E_V128BImode) != 0
          || !(
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V128HImode)
        || register_operand (operands[3], V128HImode)))) && 
#line 208 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 3714; /* *pred_movv128hi */

    case E_V256HImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V256HImode, 
E_V256BImode) != 0
          || !(
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V256HImode)
        || register_operand (operands[3], V256HImode)))) && 
#line 209 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 3715; /* *pred_movv256hi */

    case E_V512HImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V512HImode, 
E_V512BImode) != 0
          || !(
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V512HImode)
        || register_operand (operands[3], V512HImode)))) && 
#line 210 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 3716; /* *pred_movv512hi */

    case E_V1024HImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V1024HImode, 
E_V1024BImode) != 0
          || !(
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V1024HImode)
        || register_operand (operands[3], V1024HImode)))) && 
#line 211 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 3717; /* *pred_movv1024hi */

    case E_V2048HImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V2048HImode, 
E_V2048BImode) != 0
          || !(
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V2048HImode)
        || register_operand (operands[3], V2048HImode)))) && 
#line 212 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 3718; /* *pred_movv2048hi */

    case E_V1SImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V1SImode, 
E_V1BImode) != 0
          || !(
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V1SImode)
        || register_operand (operands[3], V1SImode)))) && 
#line 213 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 3719; /* *pred_movv1si */

    case E_V2SImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V2SImode, 
E_V2BImode) != 0
          || !(
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V2SImode)
        || register_operand (operands[3], V2SImode)))) && 
#line 214 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 3720; /* *pred_movv2si */

    case E_V4SImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V4SImode, 
E_V4BImode) != 0
          || !(
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V4SImode)
        || register_operand (operands[3], V4SImode)))) && 
#line 215 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 3721; /* *pred_movv4si */

    case E_V8SImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V8SImode, 
E_V8BImode) != 0
          || !(
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V8SImode)
        || register_operand (operands[3], V8SImode)))) && 
#line 216 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 3722; /* *pred_movv8si */

    case E_V16SImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V16SImode, 
E_V16BImode) != 0
          || !(
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V16SImode)
        || register_operand (operands[3], V16SImode)))) && 
#line 217 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 3723; /* *pred_movv16si */

    case E_V32SImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V32SImode, 
E_V32BImode) != 0
          || !(
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V32SImode)
        || register_operand (operands[3], V32SImode)))) && 
#line 218 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 3724; /* *pred_movv32si */

    case E_V64SImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V64SImode, 
E_V64BImode) != 0
          || !(
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V64SImode)
        || register_operand (operands[3], V64SImode)))) && 
#line 219 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 3725; /* *pred_movv64si */

    case E_V128SImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V128SImode, 
E_V128BImode) != 0
          || !(
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V128SImode)
        || register_operand (operands[3], V128SImode)))) && 
#line 220 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 3726; /* *pred_movv128si */

    case E_V256SImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V256SImode, 
E_V256BImode) != 0
          || !(
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V256SImode)
        || register_operand (operands[3], V256SImode)))) && 
#line 221 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 3727; /* *pred_movv256si */

    case E_V512SImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V512SImode, 
E_V512BImode) != 0
          || !(
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V512SImode)
        || register_operand (operands[3], V512SImode)))) && 
#line 222 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 3728; /* *pred_movv512si */

    case E_V1024SImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V1024SImode, 
E_V1024BImode) != 0
          || !(
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V1024SImode)
        || register_operand (operands[3], V1024SImode)))) && 
#line 223 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 3729; /* *pred_movv1024si */

    case E_V1DImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V1DImode, 
E_V1BImode) != 0
          || !(
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V1DImode)
        || register_operand (operands[3], V1DImode)))) && 
#line 224 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 3730; /* *pred_movv1di */

    case E_V2DImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V2DImode, 
E_V2BImode) != 0
          || !(
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V2DImode)
        || register_operand (operands[3], V2DImode)))) && 
#line 225 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 3731; /* *pred_movv2di */

    case E_V4DImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V4DImode, 
E_V4BImode) != 0
          || !(
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V4DImode)
        || register_operand (operands[3], V4DImode)))) && 
#line 226 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 3732; /* *pred_movv4di */

    case E_V8DImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V8DImode, 
E_V8BImode) != 0
          || !(
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V8DImode)
        || register_operand (operands[3], V8DImode)))) && 
#line 227 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 3733; /* *pred_movv8di */

    case E_V16DImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V16DImode, 
E_V16BImode) != 0
          || !(
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V16DImode)
        || register_operand (operands[3], V16DImode)))) && 
#line 228 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 3734; /* *pred_movv16di */

    case E_V32DImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V32DImode, 
E_V32BImode) != 0
          || !(
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V32DImode)
        || register_operand (operands[3], V32DImode)))) && 
#line 229 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 3735; /* *pred_movv32di */

    case E_V64DImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V64DImode, 
E_V64BImode) != 0
          || !(
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V64DImode)
        || register_operand (operands[3], V64DImode)))) && 
#line 230 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 3736; /* *pred_movv64di */

    case E_V128DImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V128DImode, 
E_V128BImode) != 0
          || !(
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V128DImode)
        || register_operand (operands[3], V128DImode)))) && 
#line 231 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 3737; /* *pred_movv128di */

    case E_V256DImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V256DImode, 
E_V256BImode) != 0
          || !(
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V256DImode)
        || register_operand (operands[3], V256DImode)))) && 
#line 232 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 3738; /* *pred_movv256di */

    case E_V512DImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V512DImode, 
E_V512BImode) != 0
          || !(
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V512DImode)
        || register_operand (operands[3], V512DImode)))) && 
#line 233 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 3739; /* *pred_movv512di */

    case E_V1HFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V1HFmode, 
E_V1BImode) != 0
          || !(
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V1HFmode)
        || register_operand (operands[3], V1HFmode)))) && 
#line 272 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 3740; /* *pred_movv1hf */

    case E_V2HFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V2HFmode, 
E_V2BImode) != 0
          || !(
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V2HFmode)
        || register_operand (operands[3], V2HFmode)))) && 
#line 273 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 3741; /* *pred_movv2hf */

    case E_V4HFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V4HFmode, 
E_V4BImode) != 0
          || !(
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V4HFmode)
        || register_operand (operands[3], V4HFmode)))) && 
#line 274 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 3742; /* *pred_movv4hf */

    case E_V8HFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V8HFmode, 
E_V8BImode) != 0
          || !(
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V8HFmode)
        || register_operand (operands[3], V8HFmode)))) && 
#line 275 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 3743; /* *pred_movv8hf */

    case E_V16HFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V16HFmode, 
E_V16BImode) != 0
          || !(
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V16HFmode)
        || register_operand (operands[3], V16HFmode)))) && 
#line 276 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 3744; /* *pred_movv16hf */

    case E_V32HFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V32HFmode, 
E_V32BImode) != 0
          || !(
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V32HFmode)
        || register_operand (operands[3], V32HFmode)))) && 
#line 277 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 3745; /* *pred_movv32hf */

    case E_V64HFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V64HFmode, 
E_V64BImode) != 0
          || !(
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V64HFmode)
        || register_operand (operands[3], V64HFmode)))) && 
#line 278 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 3746; /* *pred_movv64hf */

    case E_V128HFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V128HFmode, 
E_V128BImode) != 0
          || !(
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V128HFmode)
        || register_operand (operands[3], V128HFmode)))) && 
#line 279 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 3747; /* *pred_movv128hf */

    case E_V256HFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V256HFmode, 
E_V256BImode) != 0
          || !(
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V256HFmode)
        || register_operand (operands[3], V256HFmode)))) && 
#line 280 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 3748; /* *pred_movv256hf */

    case E_V512HFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V512HFmode, 
E_V512BImode) != 0
          || !(
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V512HFmode)
        || register_operand (operands[3], V512HFmode)))) && 
#line 281 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 3749; /* *pred_movv512hf */

    case E_V1024HFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V1024HFmode, 
E_V1024BImode) != 0
          || !(
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V1024HFmode)
        || register_operand (operands[3], V1024HFmode)))) && 
#line 282 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 3750; /* *pred_movv1024hf */

    case E_V2048HFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V2048HFmode, 
E_V2048BImode) != 0
          || !(
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V2048HFmode)
        || register_operand (operands[3], V2048HFmode)))) && 
#line 283 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 3751; /* *pred_movv2048hf */

    case E_V1SFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V1SFmode, 
E_V1BImode) != 0
          || !(
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V1SFmode)
        || register_operand (operands[3], V1SFmode)))) && 
#line 284 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 3752; /* *pred_movv1sf */

    case E_V2SFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V2SFmode, 
E_V2BImode) != 0
          || !(
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V2SFmode)
        || register_operand (operands[3], V2SFmode)))) && 
#line 285 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 3753; /* *pred_movv2sf */

    case E_V4SFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V4SFmode, 
E_V4BImode) != 0
          || !(
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V4SFmode)
        || register_operand (operands[3], V4SFmode)))) && 
#line 286 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 3754; /* *pred_movv4sf */

    case E_V8SFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V8SFmode, 
E_V8BImode) != 0
          || !(
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V8SFmode)
        || register_operand (operands[3], V8SFmode)))) && 
#line 287 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 3755; /* *pred_movv8sf */

    case E_V16SFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V16SFmode, 
E_V16BImode) != 0
          || !(
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V16SFmode)
        || register_operand (operands[3], V16SFmode)))) && 
#line 288 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 3756; /* *pred_movv16sf */

    case E_V32SFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V32SFmode, 
E_V32BImode) != 0
          || !(
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V32SFmode)
        || register_operand (operands[3], V32SFmode)))) && 
#line 289 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 3757; /* *pred_movv32sf */

    case E_V64SFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V64SFmode, 
E_V64BImode) != 0
          || !(
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V64SFmode)
        || register_operand (operands[3], V64SFmode)))) && 
#line 290 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 3758; /* *pred_movv64sf */

    case E_V128SFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V128SFmode, 
E_V128BImode) != 0
          || !(
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V128SFmode)
        || register_operand (operands[3], V128SFmode)))) && 
#line 291 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 3759; /* *pred_movv128sf */

    case E_V256SFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V256SFmode, 
E_V256BImode) != 0
          || !(
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V256SFmode)
        || register_operand (operands[3], V256SFmode)))) && 
#line 292 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 3760; /* *pred_movv256sf */

    case E_V512SFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V512SFmode, 
E_V512BImode) != 0
          || !(
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V512SFmode)
        || register_operand (operands[3], V512SFmode)))) && 
#line 293 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 3761; /* *pred_movv512sf */

    case E_V1024SFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V1024SFmode, 
E_V1024BImode) != 0
          || !(
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V1024SFmode)
        || register_operand (operands[3], V1024SFmode)))) && 
#line 294 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 3762; /* *pred_movv1024sf */

    case E_V1DFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V1DFmode, 
E_V1BImode) != 0
          || !(
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V1DFmode)
        || register_operand (operands[3], V1DFmode)))) && 
#line 295 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 3763; /* *pred_movv1df */

    case E_V2DFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V2DFmode, 
E_V2BImode) != 0
          || !(
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V2DFmode)
        || register_operand (operands[3], V2DFmode)))) && 
#line 296 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 3764; /* *pred_movv2df */

    case E_V4DFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V4DFmode, 
E_V4BImode) != 0
          || !(
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V4DFmode)
        || register_operand (operands[3], V4DFmode)))) && 
#line 297 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 3765; /* *pred_movv4df */

    case E_V8DFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V8DFmode, 
E_V8BImode) != 0
          || !(
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V8DFmode)
        || register_operand (operands[3], V8DFmode)))) && 
#line 298 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 3766; /* *pred_movv8df */

    case E_V16DFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V16DFmode, 
E_V16BImode) != 0
          || !(
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V16DFmode)
        || register_operand (operands[3], V16DFmode)))) && 
#line 299 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 3767; /* *pred_movv16df */

    case E_V32DFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V32DFmode, 
E_V32BImode) != 0
          || !(
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V32DFmode)
        || register_operand (operands[3], V32DFmode)))) && 
#line 300 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 3768; /* *pred_movv32df */

    case E_V64DFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V64DFmode, 
E_V64BImode) != 0
          || !(
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V64DFmode)
        || register_operand (operands[3], V64DFmode)))) && 
#line 301 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 3769; /* *pred_movv64df */

    case E_V128DFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V128DFmode, 
E_V128BImode) != 0
          || !(
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V128DFmode)
        || register_operand (operands[3], V128DFmode)))) && 
#line 302 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 3770; /* *pred_movv128df */

    case E_V256DFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V256DFmode, 
E_V256BImode) != 0
          || !(
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V256DFmode)
        || register_operand (operands[3], V256DFmode)))) && 
#line 303 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 3771; /* *pred_movv256df */

    case E_V512DFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V512DFmode, 
E_V512BImode) != 0
          || !(
#line 1912 "../../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V512DFmode)
        || register_operand (operands[3], V512DFmode)))) && 
#line 304 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 3772; /* *pred_movv512df */

    default:
      return -1;
    }
}

 int
recog_599 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern557 (x2))
    {
    case 0:
      if (!(
#line 6373 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 15033; /* pred_xorsignrvvm8hf */

    case 1:
      if (!(
#line 6373 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 15035; /* pred_xorsignrvvm4hf */

    case 2:
      if (!(
#line 6373 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 15037; /* pred_xorsignrvvm2hf */

    case 3:
      if (!(
#line 6373 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 15039; /* pred_xorsignrvvm1hf */

    case 4:
      if (!(
#line 6373 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 15041; /* pred_xorsignrvvmf2hf */

    case 5:
      if (!(
#line 6373 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 157 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
        return -1;
      return 15043; /* pred_xorsignrvvmf4hf */

    case 6:
      if (!(
#line 6373 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 15045; /* pred_xorsignrvvm8sf */

    case 7:
      if (!(
#line 6373 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 15047; /* pred_xorsignrvvm4sf */

    case 8:
      if (!(
#line 6373 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 15049; /* pred_xorsignrvvm2sf */

    case 9:
      if (!(
#line 6373 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 15051; /* pred_xorsignrvvm1sf */

    case 10:
      if (!(
#line 6373 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 15053; /* pred_xorsignrvvmf2sf */

    case 11:
      if (!(
#line 6373 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 15055; /* pred_xorsignrvvm8df */

    case 12:
      if (!(
#line 6373 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 15057; /* pred_xorsignrvvm4df */

    case 13:
      if (!(
#line 6373 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 15059; /* pred_xorsignrvvm2df */

    case 14:
      if (!(
#line 6373 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 15061; /* pred_xorsignrvvm1df */

    case 15:
      if (!(
#line 6373 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 236 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
        return -1;
      return 15063; /* pred_xorsignv1hf */

    case 16:
      if (!(
#line 6373 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 237 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
        return -1;
      return 15065; /* pred_xorsignv2hf */

    case 17:
      if (!(
#line 6373 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 238 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
        return -1;
      return 15067; /* pred_xorsignv4hf */

    case 18:
      if (!(
#line 6373 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 239 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
        return -1;
      return 15069; /* pred_xorsignv8hf */

    case 19:
      if (!(
#line 6373 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 240 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
        return -1;
      return 15071; /* pred_xorsignv16hf */

    case 20:
      if (!(
#line 6373 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 241 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 15073; /* pred_xorsignv32hf */

    case 21:
      if (!(
#line 6373 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 242 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 15075; /* pred_xorsignv64hf */

    case 22:
      if (!(
#line 6373 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 243 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 15077; /* pred_xorsignv128hf */

    case 23:
      if (!(
#line 6373 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 244 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 15079; /* pred_xorsignv256hf */

    case 24:
      if (!(
#line 6373 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 245 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 15081; /* pred_xorsignv512hf */

    case 25:
      if (!(
#line 6373 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 246 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 15083; /* pred_xorsignv1024hf */

    case 26:
      if (!(
#line 6373 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 247 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 15085; /* pred_xorsignv2048hf */

    case 27:
      if (!(
#line 6373 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 248 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 15087; /* pred_xorsignv1sf */

    case 28:
      if (!(
#line 6373 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 249 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 15089; /* pred_xorsignv2sf */

    case 29:
      if (!(
#line 6373 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 250 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 15091; /* pred_xorsignv4sf */

    case 30:
      if (!(
#line 6373 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 251 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 15093; /* pred_xorsignv8sf */

    case 31:
      if (!(
#line 6373 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 252 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 15095; /* pred_xorsignv16sf */

    case 32:
      if (!(
#line 6373 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 253 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 15097; /* pred_xorsignv32sf */

    case 33:
      if (!(
#line 6373 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 254 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 15099; /* pred_xorsignv64sf */

    case 34:
      if (!(
#line 6373 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 255 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 15101; /* pred_xorsignv128sf */

    case 35:
      if (!(
#line 6373 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 256 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 15103; /* pred_xorsignv256sf */

    case 36:
      if (!(
#line 6373 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 257 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 15105; /* pred_xorsignv512sf */

    case 37:
      if (!(
#line 6373 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 258 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 15107; /* pred_xorsignv1024sf */

    case 38:
      if (!(
#line 6373 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 259 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 15109; /* pred_xorsignv1df */

    case 39:
      if (!(
#line 6373 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 260 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 15111; /* pred_xorsignv2df */

    case 40:
      if (!(
#line 6373 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 261 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 15113; /* pred_xorsignv4df */

    case 41:
      if (!(
#line 6373 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 262 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 15115; /* pred_xorsignv8df */

    case 42:
      if (!(
#line 6373 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 263 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 15117; /* pred_xorsignv16df */

    case 43:
      if (!(
#line 6373 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 264 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 15119; /* pred_xorsignv32df */

    case 44:
      if (!(
#line 6373 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 265 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 15121; /* pred_xorsignv64df */

    case 45:
      if (!(
#line 6373 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 266 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 15123; /* pred_xorsignv128df */

    case 46:
      if (!(
#line 6373 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 267 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 15125; /* pred_xorsignv256df */

    case 47:
      if (!(
#line 6373 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 268 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 15127; /* pred_xorsignv512df */

    case 48:
      if (!(
#line 6415 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 15144; /* pred_xorsignrvvm8hf_scalar */

    case 49:
      if (!(
#line 6415 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 15146; /* pred_xorsignrvvm4hf_scalar */

    case 50:
      if (!(
#line 6415 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 15148; /* pred_xorsignrvvm2hf_scalar */

    case 51:
      if (!(
#line 6415 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 15150; /* pred_xorsignrvvm1hf_scalar */

    case 52:
      if (!(
#line 6415 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 15152; /* pred_xorsignrvvmf2hf_scalar */

    case 53:
      if (!(
#line 6415 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 157 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
        return -1;
      return 15154; /* pred_xorsignrvvmf4hf_scalar */

    case 54:
      if (!(
#line 6415 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 15156; /* pred_xorsignrvvm8sf_scalar */

    case 55:
      if (!(
#line 6415 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 15158; /* pred_xorsignrvvm4sf_scalar */

    case 56:
      if (!(
#line 6415 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 15160; /* pred_xorsignrvvm2sf_scalar */

    case 57:
      if (!(
#line 6415 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 15162; /* pred_xorsignrvvm1sf_scalar */

    case 58:
      if (!(
#line 6415 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 15164; /* pred_xorsignrvvmf2sf_scalar */

    case 59:
      if (!(
#line 6415 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 15166; /* pred_xorsignrvvm8df_scalar */

    case 60:
      if (!(
#line 6415 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 15168; /* pred_xorsignrvvm4df_scalar */

    case 61:
      if (!(
#line 6415 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 15170; /* pred_xorsignrvvm2df_scalar */

    case 62:
      if (!(
#line 6415 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 15172; /* pred_xorsignrvvm1df_scalar */

    case 63:
      if (!(
#line 6415 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 236 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
        return -1;
      return 15174; /* pred_xorsignv1hf_scalar */

    case 64:
      if (!(
#line 6415 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 237 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
        return -1;
      return 15176; /* pred_xorsignv2hf_scalar */

    case 65:
      if (!(
#line 6415 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 238 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
        return -1;
      return 15178; /* pred_xorsignv4hf_scalar */

    case 66:
      if (!(
#line 6415 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 239 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
        return -1;
      return 15180; /* pred_xorsignv8hf_scalar */

    case 67:
      if (!(
#line 6415 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 240 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
        return -1;
      return 15182; /* pred_xorsignv16hf_scalar */

    case 68:
      if (!(
#line 6415 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 241 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 15184; /* pred_xorsignv32hf_scalar */

    case 69:
      if (!(
#line 6415 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 242 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 15186; /* pred_xorsignv64hf_scalar */

    case 70:
      if (!(
#line 6415 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 243 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 15188; /* pred_xorsignv128hf_scalar */

    case 71:
      if (!(
#line 6415 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 244 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 15190; /* pred_xorsignv256hf_scalar */

    case 72:
      if (!(
#line 6415 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 245 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 15192; /* pred_xorsignv512hf_scalar */

    case 73:
      if (!(
#line 6415 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 246 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 15194; /* pred_xorsignv1024hf_scalar */

    case 74:
      if (!(
#line 6415 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 247 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 15196; /* pred_xorsignv2048hf_scalar */

    case 75:
      if (!(
#line 6415 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 248 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 15198; /* pred_xorsignv1sf_scalar */

    case 76:
      if (!(
#line 6415 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 249 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 15200; /* pred_xorsignv2sf_scalar */

    case 77:
      if (!(
#line 6415 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 250 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 15202; /* pred_xorsignv4sf_scalar */

    case 78:
      if (!(
#line 6415 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 251 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 15204; /* pred_xorsignv8sf_scalar */

    case 79:
      if (!(
#line 6415 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 252 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 15206; /* pred_xorsignv16sf_scalar */

    case 80:
      if (!(
#line 6415 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 253 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 15208; /* pred_xorsignv32sf_scalar */

    case 81:
      if (!(
#line 6415 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 254 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 15210; /* pred_xorsignv64sf_scalar */

    case 82:
      if (!(
#line 6415 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 255 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 15212; /* pred_xorsignv128sf_scalar */

    case 83:
      if (!(
#line 6415 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 256 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 15214; /* pred_xorsignv256sf_scalar */

    case 84:
      if (!(
#line 6415 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 257 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 15216; /* pred_xorsignv512sf_scalar */

    case 85:
      if (!(
#line 6415 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 258 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 15218; /* pred_xorsignv1024sf_scalar */

    case 86:
      if (!(
#line 6415 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 259 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 15220; /* pred_xorsignv1df_scalar */

    case 87:
      if (!(
#line 6415 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 260 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 15222; /* pred_xorsignv2df_scalar */

    case 88:
      if (!(
#line 6415 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 261 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 15224; /* pred_xorsignv4df_scalar */

    case 89:
      if (!(
#line 6415 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 262 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 15226; /* pred_xorsignv8df_scalar */

    case 90:
      if (!(
#line 6415 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 263 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 15228; /* pred_xorsignv16df_scalar */

    case 91:
      if (!(
#line 6415 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 264 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 15230; /* pred_xorsignv32df_scalar */

    case 92:
      if (!(
#line 6415 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 265 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 15232; /* pred_xorsignv64df_scalar */

    case 93:
      if (!(
#line 6415 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 266 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 15234; /* pred_xorsignv128df_scalar */

    case 94:
      if (!(
#line 6415 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 267 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 15236; /* pred_xorsignv256df_scalar */

    case 95:
      if (!(
#line 6415 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 268 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 15238; /* pred_xorsignv512df_scalar */

    default:
      return -1;
    }
}

 int
recog_605 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[4] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[5] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[6] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[7] = x7;
  x8 = XEXP (x2, 1);
  switch (XINT (x8, 1))
    {
    case 117:
      x9 = XVECEXP (x8, 0, 0);
      operands[3] = x9;
      switch (GET_MODE (operands[0]))
        {
        case E_RVVM8QImode:
          if (pattern665 (x2, 
E_RVVM8QImode, 
E_RVVM1BImode) != 0
              || !
#line 6142 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14408; /* pred_iotarvvm8qi */

        case E_RVVM4QImode:
          if (pattern665 (x2, 
E_RVVM4QImode, 
E_RVVMF2BImode) != 0
              || !
#line 6142 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14409; /* pred_iotarvvm4qi */

        case E_RVVM2QImode:
          if (pattern665 (x2, 
E_RVVM2QImode, 
E_RVVMF4BImode) != 0
              || !
#line 6142 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14410; /* pred_iotarvvm2qi */

        case E_RVVM1QImode:
          if (pattern665 (x2, 
E_RVVM1QImode, 
E_RVVMF8BImode) != 0
              || !
#line 6142 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14411; /* pred_iotarvvm1qi */

        case E_RVVM8HImode:
          if (pattern665 (x2, 
E_RVVM8HImode, 
E_RVVMF2BImode) != 0
              || !
#line 6142 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14412; /* pred_iotarvvm8hi */

        case E_RVVM4HImode:
          if (pattern665 (x2, 
E_RVVM4HImode, 
E_RVVMF4BImode) != 0
              || !
#line 6142 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14413; /* pred_iotarvvm4hi */

        case E_RVVM2HImode:
          if (pattern665 (x2, 
E_RVVM2HImode, 
E_RVVMF8BImode) != 0
              || !
#line 6142 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14414; /* pred_iotarvvm2hi */

        case E_RVVM1HImode:
          if (pattern665 (x2, 
E_RVVM1HImode, 
E_RVVMF16BImode) != 0
              || !
#line 6142 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14415; /* pred_iotarvvm1hi */

        case E_RVVM8SImode:
          if (pattern665 (x2, 
E_RVVM8SImode, 
E_RVVMF4BImode) != 0
              || !
#line 6142 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14416; /* pred_iotarvvm8si */

        case E_RVVM4SImode:
          if (pattern665 (x2, 
E_RVVM4SImode, 
E_RVVMF8BImode) != 0
              || !
#line 6142 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14417; /* pred_iotarvvm4si */

        case E_RVVM2SImode:
          if (pattern665 (x2, 
E_RVVM2SImode, 
E_RVVMF16BImode) != 0
              || !
#line 6142 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14418; /* pred_iotarvvm2si */

        case E_RVVM1SImode:
          if (pattern665 (x2, 
E_RVVM1SImode, 
E_RVVMF32BImode) != 0
              || !
#line 6142 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14419; /* pred_iotarvvm1si */

        case E_RVVM8DImode:
          if (pattern665 (x2, 
E_RVVM8DImode, 
E_RVVMF8BImode) != 0
              || !(
#line 6142 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 14420; /* pred_iotarvvm8di */

        case E_RVVM4DImode:
          if (pattern665 (x2, 
E_RVVM4DImode, 
E_RVVMF16BImode) != 0
              || !(
#line 6142 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 14421; /* pred_iotarvvm4di */

        case E_RVVM2DImode:
          if (pattern665 (x2, 
E_RVVM2DImode, 
E_RVVMF32BImode) != 0
              || !(
#line 6142 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 14422; /* pred_iotarvvm2di */

        case E_RVVM1DImode:
          if (pattern665 (x2, 
E_RVVM1DImode, 
E_RVVMF64BImode) != 0
              || !(
#line 6142 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 14423; /* pred_iotarvvm1di */

        case E_RVVMF2QImode:
          if (pattern665 (x2, 
E_RVVMF2QImode, 
E_RVVMF16BImode) != 0
              || !(
#line 6142 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 14424; /* pred_iotarvvmf2qi */

        case E_RVVMF4QImode:
          if (pattern665 (x2, 
E_RVVMF4QImode, 
E_RVVMF32BImode) != 0
              || !(
#line 6142 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 14425; /* pred_iotarvvmf4qi */

        case E_RVVMF8QImode:
          if (pattern665 (x2, 
E_RVVMF8QImode, 
E_RVVMF64BImode) != 0
              || !(
#line 6142 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 14426; /* pred_iotarvvmf8qi */

        case E_RVVMF2HImode:
          if (pattern665 (x2, 
E_RVVMF2HImode, 
E_RVVMF32BImode) != 0
              || !(
#line 6142 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 14427; /* pred_iotarvvmf2hi */

        case E_RVVMF4HImode:
          if (pattern665 (x2, 
E_RVVMF4HImode, 
E_RVVMF64BImode) != 0
              || !(
#line 6142 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 132 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 14428; /* pred_iotarvvmf4hi */

        case E_RVVMF2SImode:
          if (pattern665 (x2, 
E_RVVMF2SImode, 
E_RVVMF64BImode) != 0
              || !(
#line 6142 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 133 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 14429; /* pred_iotarvvmf2si */

        default:
          return -1;
        }

    case 118:
      x9 = XVECEXP (x8, 0, 0);
      operands[3] = x9;
      switch (GET_MODE (operands[0]))
        {
        case E_RVVM8HFmode:
          if (pattern598 (x2, 
E_RVVM8HFmode, 
E_RVVMF2BImode) != 0
              || !(
#line 6953 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 16358; /* pred_rsqrt7rvvm8hf */

        case E_RVVM4HFmode:
          if (pattern598 (x2, 
E_RVVM4HFmode, 
E_RVVMF4BImode) != 0
              || !(
#line 6953 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 16359; /* pred_rsqrt7rvvm4hf */

        case E_RVVM2HFmode:
          if (pattern598 (x2, 
E_RVVM2HFmode, 
E_RVVMF8BImode) != 0
              || !(
#line 6953 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 16360; /* pred_rsqrt7rvvm2hf */

        case E_RVVM1HFmode:
          if (pattern598 (x2, 
E_RVVM1HFmode, 
E_RVVMF16BImode) != 0
              || !(
#line 6953 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 16361; /* pred_rsqrt7rvvm1hf */

        case E_RVVMF2HFmode:
          if (pattern598 (x2, 
E_RVVMF2HFmode, 
E_RVVMF32BImode) != 0
              || !(
#line 6953 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 16362; /* pred_rsqrt7rvvmf2hf */

        case E_RVVMF4HFmode:
          if (pattern598 (x2, 
E_RVVMF4HFmode, 
E_RVVMF64BImode) != 0
              || !(
#line 6953 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 157 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
            return -1;
          return 16363; /* pred_rsqrt7rvvmf4hf */

        case E_RVVM8SFmode:
          if (pattern598 (x2, 
E_RVVM8SFmode, 
E_RVVMF4BImode) != 0
              || !(
#line 6953 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 16364; /* pred_rsqrt7rvvm8sf */

        case E_RVVM4SFmode:
          if (pattern598 (x2, 
E_RVVM4SFmode, 
E_RVVMF8BImode) != 0
              || !(
#line 6953 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 16365; /* pred_rsqrt7rvvm4sf */

        case E_RVVM2SFmode:
          if (pattern598 (x2, 
E_RVVM2SFmode, 
E_RVVMF16BImode) != 0
              || !(
#line 6953 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 16366; /* pred_rsqrt7rvvm2sf */

        case E_RVVM1SFmode:
          if (pattern598 (x2, 
E_RVVM1SFmode, 
E_RVVMF32BImode) != 0
              || !(
#line 6953 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 16367; /* pred_rsqrt7rvvm1sf */

        case E_RVVMF2SFmode:
          if (pattern598 (x2, 
E_RVVMF2SFmode, 
E_RVVMF64BImode) != 0
              || !(
#line 6953 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
            return -1;
          return 16368; /* pred_rsqrt7rvvmf2sf */

        case E_RVVM8DFmode:
          if (pattern598 (x2, 
E_RVVM8DFmode, 
E_RVVMF8BImode) != 0
              || !(
#line 6953 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 16369; /* pred_rsqrt7rvvm8df */

        case E_RVVM4DFmode:
          if (pattern598 (x2, 
E_RVVM4DFmode, 
E_RVVMF16BImode) != 0
              || !(
#line 6953 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 16370; /* pred_rsqrt7rvvm4df */

        case E_RVVM2DFmode:
          if (pattern598 (x2, 
E_RVVM2DFmode, 
E_RVVMF32BImode) != 0
              || !(
#line 6953 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 16371; /* pred_rsqrt7rvvm2df */

        case E_RVVM1DFmode:
          if (pattern598 (x2, 
E_RVVM1DFmode, 
E_RVVMF64BImode) != 0
              || !(
#line 6953 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 16372; /* pred_rsqrt7rvvm1df */

        default:
          return -1;
        }

    case 120:
      x9 = XVECEXP (x8, 0, 0);
      operands[3] = x9;
      switch (GET_MODE (operands[0]))
        {
        case E_RVVM8HImode:
          if (pattern666 (x2, 
E_RVVM8HImode, 
E_RVVM8HFmode, 
E_RVVMF2BImode) != 0
              || !(
#line 6995 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 16388; /* pred_classrvvm8hf */

        case E_RVVM4HImode:
          if (pattern666 (x2, 
E_RVVM4HImode, 
E_RVVM4HFmode, 
E_RVVMF4BImode) != 0
              || !(
#line 6995 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 16389; /* pred_classrvvm4hf */

        case E_RVVM2HImode:
          if (pattern666 (x2, 
E_RVVM2HImode, 
E_RVVM2HFmode, 
E_RVVMF8BImode) != 0
              || !(
#line 6995 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 16390; /* pred_classrvvm2hf */

        case E_RVVM1HImode:
          if (pattern666 (x2, 
E_RVVM1HImode, 
E_RVVM1HFmode, 
E_RVVMF16BImode) != 0
              || !(
#line 6995 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 16391; /* pred_classrvvm1hf */

        case E_RVVMF2HImode:
          if (pattern666 (x2, 
E_RVVMF2HImode, 
E_RVVMF2HFmode, 
E_RVVMF32BImode) != 0
              || !(
#line 6995 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 16392; /* pred_classrvvmf2hf */

        case E_RVVMF4HImode:
          if (pattern666 (x2, 
E_RVVMF4HImode, 
E_RVVMF4HFmode, 
E_RVVMF64BImode) != 0
              || !(
#line 6995 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 157 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
            return -1;
          return 16393; /* pred_classrvvmf4hf */

        case E_RVVM8SImode:
          if (pattern666 (x2, 
E_RVVM8SImode, 
E_RVVM8SFmode, 
E_RVVMF4BImode) != 0
              || !(
#line 6995 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 16394; /* pred_classrvvm8sf */

        case E_RVVM4SImode:
          if (pattern666 (x2, 
E_RVVM4SImode, 
E_RVVM4SFmode, 
E_RVVMF8BImode) != 0
              || !(
#line 6995 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 16395; /* pred_classrvvm4sf */

        case E_RVVM2SImode:
          if (pattern666 (x2, 
E_RVVM2SImode, 
E_RVVM2SFmode, 
E_RVVMF16BImode) != 0
              || !(
#line 6995 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 16396; /* pred_classrvvm2sf */

        case E_RVVM1SImode:
          if (pattern666 (x2, 
E_RVVM1SImode, 
E_RVVM1SFmode, 
E_RVVMF32BImode) != 0
              || !(
#line 6995 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 16397; /* pred_classrvvm1sf */

        case E_RVVMF2SImode:
          if (pattern666 (x2, 
E_RVVMF2SImode, 
E_RVVMF2SFmode, 
E_RVVMF64BImode) != 0
              || !(
#line 6995 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
            return -1;
          return 16398; /* pred_classrvvmf2sf */

        case E_RVVM8DImode:
          if (pattern666 (x2, 
E_RVVM8DImode, 
E_RVVM8DFmode, 
E_RVVMF8BImode) != 0
              || !(
#line 6995 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 16399; /* pred_classrvvm8df */

        case E_RVVM4DImode:
          if (pattern666 (x2, 
E_RVVM4DImode, 
E_RVVM4DFmode, 
E_RVVMF16BImode) != 0
              || !(
#line 6995 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 16400; /* pred_classrvvm4df */

        case E_RVVM2DImode:
          if (pattern666 (x2, 
E_RVVM2DImode, 
E_RVVM2DFmode, 
E_RVVMF32BImode) != 0
              || !(
#line 6995 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 16401; /* pred_classrvvm2df */

        case E_RVVM1DImode:
          if (pattern666 (x2, 
E_RVVM1DImode, 
E_RVVM1DFmode, 
E_RVVMF64BImode) != 0
              || !(
#line 6995 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 16402; /* pred_classrvvm1df */

        default:
          return -1;
        }

    case 125:
      x9 = XVECEXP (x8, 0, 0);
      if (GET_CODE (x9) != FLOAT_TRUNCATE)
        return -1;
      x10 = XEXP (x9, 0);
      operands[3] = x10;
      switch (GET_MODE (operands[0]))
        {
        case E_RVVM4HFmode:
          if (pattern684 (x2, 
E_RVVM4HFmode, 
E_RVVM8SFmode, 
E_RVVMF4BImode) != 0
              || !(
#line 7735 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 990 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 18095; /* pred_rod_truncrvvm8sf */

        case E_RVVM2HFmode:
          if (pattern684 (x2, 
E_RVVM2HFmode, 
E_RVVM4SFmode, 
E_RVVMF8BImode) != 0
              || !(
#line 7735 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 991 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 18096; /* pred_rod_truncrvvm4sf */

        case E_RVVM1HFmode:
          if (pattern684 (x2, 
E_RVVM1HFmode, 
E_RVVM2SFmode, 
E_RVVMF16BImode) != 0
              || !(
#line 7735 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 992 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 18097; /* pred_rod_truncrvvm2sf */

        case E_RVVMF2HFmode:
          if (pattern684 (x2, 
E_RVVMF2HFmode, 
E_RVVM1SFmode, 
E_RVVMF32BImode) != 0
              || !(
#line 7735 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 993 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 18098; /* pred_rod_truncrvvm1sf */

        case E_RVVMF4HFmode:
          if (pattern684 (x2, 
E_RVVMF4HFmode, 
E_RVVMF2SFmode, 
E_RVVMF64BImode) != 0
              || !(
#line 7735 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 994 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
            return -1;
          return 18099; /* pred_rod_truncrvvmf2sf */

        case E_RVVM4SFmode:
          if (pattern684 (x2, 
E_RVVM4SFmode, 
E_RVVM8DFmode, 
E_RVVMF8BImode) != 0
              || !(
#line 7735 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 996 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 18100; /* pred_rod_truncrvvm8df */

        case E_RVVM2SFmode:
          if (pattern684 (x2, 
E_RVVM2SFmode, 
E_RVVM4DFmode, 
E_RVVMF16BImode) != 0
              || !(
#line 7735 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 996 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 18101; /* pred_rod_truncrvvm4df */

        case E_RVVM1SFmode:
          if (pattern684 (x2, 
E_RVVM1SFmode, 
E_RVVM2DFmode, 
E_RVVMF32BImode) != 0
              || !(
#line 7735 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 997 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 18102; /* pred_rod_truncrvvm2df */

        case E_RVVMF2SFmode:
          if (pattern684 (x2, 
E_RVVMF2SFmode, 
E_RVVM1DFmode, 
E_RVVMF64BImode) != 0
              || !(
#line 7735 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 997 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 18103; /* pred_rod_truncrvvm1df */

        case E_V1HFmode:
          if (pattern684 (x2, 
E_V1HFmode, 
E_V1SFmode, 
E_V1BImode) != 0
              || !(
#line 7735 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 999 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 18104; /* pred_rod_truncv1sf */

        case E_V2HFmode:
          if (pattern684 (x2, 
E_V2HFmode, 
E_V2SFmode, 
E_V2BImode) != 0
              || !(
#line 7735 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1000 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 18105; /* pred_rod_truncv2sf */

        case E_V4HFmode:
          if (pattern684 (x2, 
E_V4HFmode, 
E_V4SFmode, 
E_V4BImode) != 0
              || !(
#line 7735 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1001 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 18106; /* pred_rod_truncv4sf */

        case E_V8HFmode:
          if (pattern684 (x2, 
E_V8HFmode, 
E_V8SFmode, 
E_V8BImode) != 0
              || !(
#line 7735 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1002 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 18107; /* pred_rod_truncv8sf */

        case E_V16HFmode:
          if (pattern684 (x2, 
E_V16HFmode, 
E_V16SFmode, 
E_V16BImode) != 0
              || !(
#line 7735 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1003 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 18108; /* pred_rod_truncv16sf */

        case E_V32HFmode:
          if (pattern684 (x2, 
E_V32HFmode, 
E_V32SFmode, 
E_V32BImode) != 0
              || !(
#line 7735 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1004 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 18109; /* pred_rod_truncv32sf */

        case E_V64HFmode:
          if (pattern684 (x2, 
E_V64HFmode, 
E_V64SFmode, 
E_V64BImode) != 0
              || !(
#line 7735 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1005 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 18110; /* pred_rod_truncv64sf */

        case E_V128HFmode:
          if (pattern684 (x2, 
E_V128HFmode, 
E_V128SFmode, 
E_V128BImode) != 0
              || !(
#line 7735 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1006 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 18111; /* pred_rod_truncv128sf */

        case E_V256HFmode:
          if (pattern684 (x2, 
E_V256HFmode, 
E_V256SFmode, 
E_V256BImode) != 0
              || !(
#line 7735 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1007 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 18112; /* pred_rod_truncv256sf */

        case E_V512HFmode:
          if (pattern684 (x2, 
E_V512HFmode, 
E_V512SFmode, 
E_V512BImode) != 0
              || !(
#line 7735 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1008 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 18113; /* pred_rod_truncv512sf */

        case E_V1024HFmode:
          if (pattern684 (x2, 
E_V1024HFmode, 
E_V1024SFmode, 
E_V1024BImode) != 0
              || !(
#line 7735 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1009 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 18114; /* pred_rod_truncv1024sf */

        case E_V1SFmode:
          if (pattern684 (x2, 
E_V1SFmode, 
E_V1DFmode, 
E_V1BImode) != 0
              || !(
#line 7735 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1010 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 18115; /* pred_rod_truncv1df */

        case E_V2SFmode:
          if (pattern684 (x2, 
E_V2SFmode, 
E_V2DFmode, 
E_V2BImode) != 0
              || !(
#line 7735 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1011 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 18116; /* pred_rod_truncv2df */

        case E_V4SFmode:
          if (pattern684 (x2, 
E_V4SFmode, 
E_V4DFmode, 
E_V4BImode) != 0
              || !(
#line 7735 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1012 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 18117; /* pred_rod_truncv4df */

        case E_V8SFmode:
          if (pattern684 (x2, 
E_V8SFmode, 
E_V8DFmode, 
E_V8BImode) != 0
              || !(
#line 7735 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1013 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 18118; /* pred_rod_truncv8df */

        case E_V16SFmode:
          if (pattern684 (x2, 
E_V16SFmode, 
E_V16DFmode, 
E_V16BImode) != 0
              || !(
#line 7735 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1014 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 18119; /* pred_rod_truncv16df */

        case E_V32SFmode:
          if (pattern684 (x2, 
E_V32SFmode, 
E_V32DFmode, 
E_V32BImode) != 0
              || !(
#line 7735 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1015 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 18120; /* pred_rod_truncv32df */

        case E_V64SFmode:
          if (pattern684 (x2, 
E_V64SFmode, 
E_V64DFmode, 
E_V64BImode) != 0
              || !(
#line 7735 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1016 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 18121; /* pred_rod_truncv64df */

        case E_V128SFmode:
          if (pattern684 (x2, 
E_V128SFmode, 
E_V128DFmode, 
E_V128BImode) != 0
              || !(
#line 7735 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1017 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 18122; /* pred_rod_truncv128df */

        case E_V256SFmode:
          if (pattern684 (x2, 
E_V256SFmode, 
E_V256DFmode, 
E_V256BImode) != 0
              || !(
#line 7735 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1018 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 18123; /* pred_rod_truncv256df */

        case E_V512SFmode:
          if (pattern684 (x2, 
E_V512SFmode, 
E_V512DFmode, 
E_V512BImode) != 0
              || !(
#line 7735 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1019 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 18124; /* pred_rod_truncv512df */

        default:
          return -1;
        }

    case 194:
      return recog_603 (x1, insn, pnum_clobbers);

    case 195:
      return recog_602 (x1, insn, pnum_clobbers);

    case 196:
      return recog_601 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 int
recog_687 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern565 (x2, 
E_V256SImode, 
E_V256BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_662 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XEXP (x4, 1);
  operands[3] = x11;
  if (!register_operand (operands[3], E_V256SImode))
    return -1;
  x12 = XEXP (x3, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V256SImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5347 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 221 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
    return 13204; /* *pred_maddv256si */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5376 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 221 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
    return -1;
  return 13272; /* *pred_maccv256si */
}

 int
recog_694 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern565 (x2, 
E_V2SImode, 
E_V2BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_655 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XEXP (x4, 1);
  operands[3] = x11;
  if (!register_operand (operands[3], E_V2SImode))
    return -1;
  x12 = XEXP (x3, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V2SImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5347 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 214 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
    return 13197; /* *pred_maddv2si */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5376 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 214 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
    return -1;
  return 13265; /* *pred_maccv2si */
}

 int
recog_701 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern565 (x2, 
E_V64HImode, 
E_V64BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_648 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XEXP (x4, 1);
  operands[3] = x11;
  if (!register_operand (operands[3], E_V64HImode))
    return -1;
  x12 = XEXP (x3, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V64HImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5347 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 207 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
    return 13190; /* *pred_maddv64hi */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5376 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 207 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
    return -1;
  return 13258; /* *pred_maccv64hi */
}

 int
recog_708 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern565 (x2, 
E_V4096QImode, 
E_V4096BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_641 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XEXP (x4, 1);
  operands[3] = x11;
  if (!register_operand (operands[3], E_V4096QImode))
    return -1;
  x12 = XEXP (x3, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V4096QImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5347 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 200 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
    return 13183; /* *pred_maddv4096qi */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5376 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 200 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
    return -1;
  return 13251; /* *pred_maccv4096qi */
}

 int
recog_715 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern696 (x2, 
E_V512DImode, 
E_V512BImode, 
E_DImode) != 0)
    return -1;
  x3 = XEXP (x2, 2);
  if (rtx_equal_p (x3, operands[3])
      && (
#line 5425 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 233 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
    return 13352; /* *pred_maddv512di_scalar */
  if (!rtx_equal_p (x3, operands[4])
      || !(
#line 5455 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 233 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
    return -1;
  return 13420; /* *pred_maccv512di_scalar */
}

 int
recog_722 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern696 (x2, 
E_V4DImode, 
E_V4BImode, 
E_DImode) != 0)
    return -1;
  x3 = XEXP (x2, 2);
  if (rtx_equal_p (x3, operands[3])
      && (
#line 5425 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 226 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
    return 13345; /* *pred_maddv4di_scalar */
  if (!rtx_equal_p (x3, operands[4])
      || !(
#line 5455 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 226 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
    return -1;
  return 13413; /* *pred_maccv4di_scalar */
}

 int
recog_729 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern696 (x2, 
E_V64SImode, 
E_V64BImode, 
E_SImode) != 0)
    return -1;
  x3 = XEXP (x2, 2);
  if (rtx_equal_p (x3, operands[3])
      && (
#line 5425 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 219 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
    return 13338; /* *pred_maddv64si_scalar */
  if (!rtx_equal_p (x3, operands[4])
      || !(
#line 5455 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 219 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
    return -1;
  return 13406; /* *pred_maccv64si_scalar */
}

 int
recog_736 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern696 (x2, 
E_V2048HImode, 
E_V2048BImode, 
E_HImode) != 0)
    return -1;
  x3 = XEXP (x2, 2);
  if (rtx_equal_p (x3, operands[3])
      && (
#line 5425 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 212 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
    return 13331; /* *pred_maddv2048hi_scalar */
  if (!rtx_equal_p (x3, operands[4])
      || !(
#line 5455 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 212 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
    return -1;
  return 13399; /* *pred_maccv2048hi_scalar */
}

 int
recog_743 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern696 (x2, 
E_V16HImode, 
E_V16BImode, 
E_HImode) != 0)
    return -1;
  x3 = XEXP (x2, 2);
  if (rtx_equal_p (x3, operands[3])
      && (
#line 5425 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 205 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
    return 13324; /* *pred_maddv16hi_scalar */
  if (!rtx_equal_p (x3, operands[4])
      || !(
#line 5455 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 205 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
    return -1;
  return 13392; /* *pred_maccv16hi_scalar */
}

 int
recog_750 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      return recog_746 (x1, insn, pnum_clobbers);

    case VEC_DUPLICATE:
      x6 = XEXP (x2, 0);
      x7 = XVECEXP (x6, 0, 1);
      operands[5] = x7;
      x8 = XVECEXP (x6, 0, 2);
      operands[6] = x8;
      x9 = XVECEXP (x6, 0, 3);
      operands[7] = x9;
      x10 = XVECEXP (x6, 0, 4);
      operands[8] = x10;
      x11 = XEXP (x4, 1);
      operands[3] = x11;
      x12 = XEXP (x3, 1);
      operands[4] = x12;
      x13 = XEXP (x5, 0);
      switch (GET_CODE (x13))
        {
        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case REG:
        case SUBREG:
          return recog_744 (x1, insn, pnum_clobbers);

        case SIGN_EXTEND:
          if (GET_MODE (x13) != E_DImode)
            return -1;
          x14 = XEXP (x13, 0);
          operands[2] = x14;
          if (!reg_or_0_operand (operands[2], E_SImode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_RVVM8DImode:
              if (pattern715 (x2, 
E_RVVM8DImode, 
E_RVVMF8BImode) != 0)
                return -1;
              x15 = XEXP (x2, 2);
              if (rtx_equal_p (x15, operands[3])
                  && (
#line 5521 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 774 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return 13421; /* *pred_maddrvvm8di_extended_scalar */
              if (!rtx_equal_p (x15, operands[4])
                  || !(
#line 5552 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 774 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 13435; /* *pred_maccrvvm8di_extended_scalar */

            case E_RVVM4DImode:
              if (pattern715 (x2, 
E_RVVM4DImode, 
E_RVVMF16BImode) != 0)
                return -1;
              x15 = XEXP (x2, 2);
              if (rtx_equal_p (x15, operands[3])
                  && (
#line 5521 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 774 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return 13422; /* *pred_maddrvvm4di_extended_scalar */
              if (!rtx_equal_p (x15, operands[4])
                  || !(
#line 5552 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 774 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 13436; /* *pred_maccrvvm4di_extended_scalar */

            case E_RVVM2DImode:
              if (pattern715 (x2, 
E_RVVM2DImode, 
E_RVVMF32BImode) != 0)
                return -1;
              x15 = XEXP (x2, 2);
              if (rtx_equal_p (x15, operands[3])
                  && (
#line 5521 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 775 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return 13423; /* *pred_maddrvvm2di_extended_scalar */
              if (!rtx_equal_p (x15, operands[4])
                  || !(
#line 5552 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 775 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 13437; /* *pred_maccrvvm2di_extended_scalar */

            case E_RVVM1DImode:
              if (pattern715 (x2, 
E_RVVM1DImode, 
E_RVVMF64BImode) != 0)
                return -1;
              x15 = XEXP (x2, 2);
              if (rtx_equal_p (x15, operands[3])
                  && (
#line 5521 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 775 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return 13424; /* *pred_maddrvvm1di_extended_scalar */
              if (!rtx_equal_p (x15, operands[4])
                  || !(
#line 5552 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 775 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 13438; /* *pred_maccrvvm1di_extended_scalar */

            case E_V1DImode:
              if (pattern715 (x2, 
E_V1DImode, 
E_V1BImode) != 0)
                return -1;
              x15 = XEXP (x2, 2);
              if (rtx_equal_p (x15, operands[3])
                  && (
#line 5521 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 777 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
                return 13425; /* *pred_maddv1di_extended_scalar */
              if (!rtx_equal_p (x15, operands[4])
                  || !(
#line 5552 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 777 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
                return -1;
              return 13439; /* *pred_maccv1di_extended_scalar */

            case E_V2DImode:
              if (pattern715 (x2, 
E_V2DImode, 
E_V2BImode) != 0)
                return -1;
              x15 = XEXP (x2, 2);
              if (rtx_equal_p (x15, operands[3])
                  && (
#line 5521 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 778 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
                return 13426; /* *pred_maddv2di_extended_scalar */
              if (!rtx_equal_p (x15, operands[4])
                  || !(
#line 5552 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 778 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
                return -1;
              return 13440; /* *pred_maccv2di_extended_scalar */

            case E_V4DImode:
              if (pattern715 (x2, 
E_V4DImode, 
E_V4BImode) != 0)
                return -1;
              x15 = XEXP (x2, 2);
              if (rtx_equal_p (x15, operands[3])
                  && (
#line 5521 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 779 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
                return 13427; /* *pred_maddv4di_extended_scalar */
              if (!rtx_equal_p (x15, operands[4])
                  || !(
#line 5552 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 779 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
                return -1;
              return 13441; /* *pred_maccv4di_extended_scalar */

            case E_V8DImode:
              if (pattern715 (x2, 
E_V8DImode, 
E_V8BImode) != 0)
                return -1;
              x15 = XEXP (x2, 2);
              if (rtx_equal_p (x15, operands[3])
                  && (
#line 5521 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 780 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
                return 13428; /* *pred_maddv8di_extended_scalar */
              if (!rtx_equal_p (x15, operands[4])
                  || !(
#line 5552 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 780 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 13442; /* *pred_maccv8di_extended_scalar */

            case E_V16DImode:
              if (pattern715 (x2, 
E_V16DImode, 
E_V16BImode) != 0)
                return -1;
              x15 = XEXP (x2, 2);
              if (rtx_equal_p (x15, operands[3])
                  && (
#line 5521 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 781 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
                return 13429; /* *pred_maddv16di_extended_scalar */
              if (!rtx_equal_p (x15, operands[4])
                  || !(
#line 5552 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 781 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 13443; /* *pred_maccv16di_extended_scalar */

            case E_V32DImode:
              if (pattern715 (x2, 
E_V32DImode, 
E_V32BImode) != 0)
                return -1;
              x15 = XEXP (x2, 2);
              if (rtx_equal_p (x15, operands[3])
                  && (
#line 5521 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 782 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
                return 13430; /* *pred_maddv32di_extended_scalar */
              if (!rtx_equal_p (x15, operands[4])
                  || !(
#line 5552 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 782 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 13444; /* *pred_maccv32di_extended_scalar */

            case E_V64DImode:
              if (pattern715 (x2, 
E_V64DImode, 
E_V64BImode) != 0)
                return -1;
              x15 = XEXP (x2, 2);
              if (rtx_equal_p (x15, operands[3])
                  && (
#line 5521 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 783 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
                return 13431; /* *pred_maddv64di_extended_scalar */
              if (!rtx_equal_p (x15, operands[4])
                  || !(
#line 5552 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 783 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 13445; /* *pred_maccv64di_extended_scalar */

            case E_V128DImode:
              if (pattern715 (x2, 
E_V128DImode, 
E_V128BImode) != 0)
                return -1;
              x15 = XEXP (x2, 2);
              if (rtx_equal_p (x15, operands[3])
                  && (
#line 5521 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 784 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
                return 13432; /* *pred_maddv128di_extended_scalar */
              if (!rtx_equal_p (x15, operands[4])
                  || !(
#line 5552 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 784 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 13446; /* *pred_maccv128di_extended_scalar */

            case E_V256DImode:
              if (pattern715 (x2, 
E_V256DImode, 
E_V256BImode) != 0)
                return -1;
              x15 = XEXP (x2, 2);
              if (rtx_equal_p (x15, operands[3])
                  && (
#line 5521 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 785 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
                return 13433; /* *pred_maddv256di_extended_scalar */
              if (!rtx_equal_p (x15, operands[4])
                  || !(
#line 5552 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 785 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 13447; /* *pred_maccv256di_extended_scalar */

            case E_V512DImode:
              if (pattern715 (x2, 
E_V512DImode, 
E_V512BImode) != 0)
                return -1;
              x15 = XEXP (x2, 2);
              if (rtx_equal_p (x15, operands[3])
                  && (
#line 5521 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 786 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
                return 13434; /* *pred_maddv512di_extended_scalar */
              if (!rtx_equal_p (x15, operands[4])
                  || !(
#line 5552 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 786 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 13448; /* *pred_maccv512di_extended_scalar */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case SIGN_EXTEND:
      x6 = XEXP (x2, 0);
      x7 = XVECEXP (x6, 0, 1);
      operands[5] = x7;
      x8 = XVECEXP (x6, 0, 2);
      operands[6] = x8;
      x9 = XVECEXP (x6, 0, 3);
      operands[7] = x9;
      x10 = XVECEXP (x6, 0, 4);
      operands[8] = x10;
      x12 = XEXP (x3, 1);
      operands[2] = x12;
      x15 = XEXP (x2, 2);
      if (!rtx_equal_p (x15, operands[2]))
        return -1;
      x13 = XEXP (x5, 0);
      switch (GET_CODE (x13))
        {
        case REG:
        case SUBREG:
          return recog_745 (x1, insn, pnum_clobbers);

        case VEC_DUPLICATE:
          x14 = XEXP (x13, 0);
          operands[3] = x14;
          x11 = XEXP (x4, 1);
          switch (GET_CODE (x11))
            {
            case SIGN_EXTEND:
              switch (pattern700 (x2))
                {
                case 0:
                  if (!
#line 5899 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                    return -1;
                  return 13913; /* pred_widen_mul_plussrvvm8hi_scalar */

                case 1:
                  if (!
#line 5899 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                    return -1;
                  return 13915; /* pred_widen_mul_plussrvvm4hi_scalar */

                case 2:
                  if (!
#line 5899 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                    return -1;
                  return 13917; /* pred_widen_mul_plussrvvm2hi_scalar */

                case 3:
                  if (!
#line 5899 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                    return -1;
                  return 13919; /* pred_widen_mul_plussrvvm1hi_scalar */

                case 4:
                  if (!
#line 5899 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                    return -1;
                  return 13921; /* pred_widen_mul_plussrvvmf2hi_scalar */

                case 5:
                  if (!(
#line 5899 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 946 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
                    return -1;
                  return 13923; /* pred_widen_mul_plussrvvmf4hi_scalar */

                case 6:
                  if (!
#line 5899 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                    return -1;
                  return 13925; /* pred_widen_mul_plussrvvm8si_scalar */

                case 7:
                  if (!
#line 5899 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                    return -1;
                  return 13927; /* pred_widen_mul_plussrvvm4si_scalar */

                case 8:
                  if (!
#line 5899 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                    return -1;
                  return 13929; /* pred_widen_mul_plussrvvm2si_scalar */

                case 9:
                  if (!
#line 5899 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                    return -1;
                  return 13931; /* pred_widen_mul_plussrvvm1si_scalar */

                case 10:
                  if (!(
#line 5899 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 948 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
                    return -1;
                  return 13933; /* pred_widen_mul_plussrvvmf2si_scalar */

                case 11:
                  if (!(
#line 5899 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                    return -1;
                  return 13935; /* pred_widen_mul_plussrvvm8di_scalar */

                case 12:
                  if (!(
#line 5899 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                    return -1;
                  return 13937; /* pred_widen_mul_plussrvvm4di_scalar */

                case 13:
                  if (!(
#line 5899 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                    return -1;
                  return 13939; /* pred_widen_mul_plussrvvm2di_scalar */

                case 14:
                  if (!(
#line 5899 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                    return -1;
                  return 13941; /* pred_widen_mul_plussrvvm1di_scalar */

                case 15:
                  if (!(
#line 5899 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 953 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
                    return -1;
                  return 13943; /* pred_widen_mul_plussv1hi_scalar */

                case 16:
                  if (!(
#line 5899 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 954 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
                    return -1;
                  return 13945; /* pred_widen_mul_plussv2hi_scalar */

                case 17:
                  if (!(
#line 5899 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 955 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
                    return -1;
                  return 13947; /* pred_widen_mul_plussv4hi_scalar */

                case 18:
                  if (!(
#line 5899 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 956 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
                    return -1;
                  return 13949; /* pred_widen_mul_plussv8hi_scalar */

                case 19:
                  if (!(
#line 5899 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 957 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
                    return -1;
                  return 13951; /* pred_widen_mul_plussv16hi_scalar */

                case 20:
                  if (!(
#line 5899 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 958 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
                    return -1;
                  return 13953; /* pred_widen_mul_plussv32hi_scalar */

                case 21:
                  if (!(
#line 5899 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 959 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
                    return -1;
                  return 13955; /* pred_widen_mul_plussv64hi_scalar */

                case 22:
                  if (!(
#line 5899 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 960 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
                    return -1;
                  return 13957; /* pred_widen_mul_plussv128hi_scalar */

                case 23:
                  if (!(
#line 5899 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 961 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
                    return -1;
                  return 13959; /* pred_widen_mul_plussv256hi_scalar */

                case 24:
                  if (!(
#line 5899 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 962 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
                    return -1;
                  return 13961; /* pred_widen_mul_plussv512hi_scalar */

                case 25:
                  if (!(
#line 5899 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 963 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
                    return -1;
                  return 13963; /* pred_widen_mul_plussv1024hi_scalar */

                case 26:
                  if (!(
#line 5899 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 964 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
                    return -1;
                  return 13965; /* pred_widen_mul_plussv2048hi_scalar */

                case 27:
                  if (!(
#line 5899 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 965 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
                    return -1;
                  return 13967; /* pred_widen_mul_plussv1si_scalar */

                case 28:
                  if (!(
#line 5899 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 966 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
                    return -1;
                  return 13969; /* pred_widen_mul_plussv2si_scalar */

                case 29:
                  if (!(
#line 5899 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 967 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
                    return -1;
                  return 13971; /* pred_widen_mul_plussv4si_scalar */

                case 30:
                  if (!(
#line 5899 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 968 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
                    return -1;
                  return 13973; /* pred_widen_mul_plussv8si_scalar */

                case 31:
                  if (!(
#line 5899 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 969 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
                    return -1;
                  return 13975; /* pred_widen_mul_plussv16si_scalar */

                case 32:
                  if (!(
#line 5899 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 970 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
                    return -1;
                  return 13977; /* pred_widen_mul_plussv32si_scalar */

                case 33:
                  if (!(
#line 5899 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 971 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
                    return -1;
                  return 13979; /* pred_widen_mul_plussv64si_scalar */

                case 34:
                  if (!(
#line 5899 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 972 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
                    return -1;
                  return 13981; /* pred_widen_mul_plussv128si_scalar */

                case 35:
                  if (!(
#line 5899 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 973 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
                    return -1;
                  return 13983; /* pred_widen_mul_plussv256si_scalar */

                case 36:
                  if (!(
#line 5899 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 974 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
                    return -1;
                  return 13985; /* pred_widen_mul_plussv512si_scalar */

                case 37:
                  if (!(
#line 5899 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 975 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
                    return -1;
                  return 13987; /* pred_widen_mul_plussv1024si_scalar */

                case 38:
                  if (!(
#line 5899 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 976 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
                    return -1;
                  return 13989; /* pred_widen_mul_plussv1di_scalar */

                case 39:
                  if (!(
#line 5899 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 977 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
                    return -1;
                  return 13991; /* pred_widen_mul_plussv2di_scalar */

                case 40:
                  if (!(
#line 5899 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 978 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
                    return -1;
                  return 13993; /* pred_widen_mul_plussv4di_scalar */

                case 41:
                  if (!(
#line 5899 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 979 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
                    return -1;
                  return 13995; /* pred_widen_mul_plussv8di_scalar */

                case 42:
                  if (!(
#line 5899 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 980 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
                    return -1;
                  return 13997; /* pred_widen_mul_plussv16di_scalar */

                case 43:
                  if (!(
#line 5899 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 981 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
                    return -1;
                  return 13999; /* pred_widen_mul_plussv32di_scalar */

                case 44:
                  if (!(
#line 5899 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 982 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
                    return -1;
                  return 14001; /* pred_widen_mul_plussv64di_scalar */

                case 45:
                  if (!(
#line 5899 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 983 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
                    return -1;
                  return 14003; /* pred_widen_mul_plussv128di_scalar */

                case 46:
                  if (!(
#line 5899 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 984 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
                    return -1;
                  return 14005; /* pred_widen_mul_plussv256di_scalar */

                case 47:
                  if (!(
#line 5899 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 985 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
                    return -1;
                  return 14007; /* pred_widen_mul_plussv512di_scalar */

                default:
                  return -1;
                }

            case ZERO_EXTEND:
              switch (pattern700 (x2))
                {
                case 0:
                  if (!
#line 5948 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                    return -1;
                  return 14057; /* pred_widen_mul_plussurvvm8hi_scalar */

                case 1:
                  if (!
#line 5948 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                    return -1;
                  return 14058; /* pred_widen_mul_plussurvvm4hi_scalar */

                case 2:
                  if (!
#line 5948 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                    return -1;
                  return 14059; /* pred_widen_mul_plussurvvm2hi_scalar */

                case 3:
                  if (!
#line 5948 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                    return -1;
                  return 14060; /* pred_widen_mul_plussurvvm1hi_scalar */

                case 4:
                  if (!
#line 5948 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                    return -1;
                  return 14061; /* pred_widen_mul_plussurvvmf2hi_scalar */

                case 5:
                  if (!(
#line 5948 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 946 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
                    return -1;
                  return 14062; /* pred_widen_mul_plussurvvmf4hi_scalar */

                case 6:
                  if (!
#line 5948 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                    return -1;
                  return 14063; /* pred_widen_mul_plussurvvm8si_scalar */

                case 7:
                  if (!
#line 5948 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                    return -1;
                  return 14064; /* pred_widen_mul_plussurvvm4si_scalar */

                case 8:
                  if (!
#line 5948 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                    return -1;
                  return 14065; /* pred_widen_mul_plussurvvm2si_scalar */

                case 9:
                  if (!
#line 5948 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                    return -1;
                  return 14066; /* pred_widen_mul_plussurvvm1si_scalar */

                case 10:
                  if (!(
#line 5948 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 948 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
                    return -1;
                  return 14067; /* pred_widen_mul_plussurvvmf2si_scalar */

                case 11:
                  if (!(
#line 5948 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                    return -1;
                  return 14068; /* pred_widen_mul_plussurvvm8di_scalar */

                case 12:
                  if (!(
#line 5948 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                    return -1;
                  return 14069; /* pred_widen_mul_plussurvvm4di_scalar */

                case 13:
                  if (!(
#line 5948 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                    return -1;
                  return 14070; /* pred_widen_mul_plussurvvm2di_scalar */

                case 14:
                  if (!(
#line 5948 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                    return -1;
                  return 14071; /* pred_widen_mul_plussurvvm1di_scalar */

                case 15:
                  if (!(
#line 5948 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 953 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
                    return -1;
                  return 14072; /* pred_widen_mul_plussuv1hi_scalar */

                case 16:
                  if (!(
#line 5948 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 954 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
                    return -1;
                  return 14073; /* pred_widen_mul_plussuv2hi_scalar */

                case 17:
                  if (!(
#line 5948 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 955 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
                    return -1;
                  return 14074; /* pred_widen_mul_plussuv4hi_scalar */

                case 18:
                  if (!(
#line 5948 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 956 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
                    return -1;
                  return 14075; /* pred_widen_mul_plussuv8hi_scalar */

                case 19:
                  if (!(
#line 5948 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 957 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
                    return -1;
                  return 14076; /* pred_widen_mul_plussuv16hi_scalar */

                case 20:
                  if (!(
#line 5948 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 958 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
                    return -1;
                  return 14077; /* pred_widen_mul_plussuv32hi_scalar */

                case 21:
                  if (!(
#line 5948 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 959 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
                    return -1;
                  return 14078; /* pred_widen_mul_plussuv64hi_scalar */

                case 22:
                  if (!(
#line 5948 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 960 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
                    return -1;
                  return 14079; /* pred_widen_mul_plussuv128hi_scalar */

                case 23:
                  if (!(
#line 5948 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 961 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
                    return -1;
                  return 14080; /* pred_widen_mul_plussuv256hi_scalar */

                case 24:
                  if (!(
#line 5948 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 962 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
                    return -1;
                  return 14081; /* pred_widen_mul_plussuv512hi_scalar */

                case 25:
                  if (!(
#line 5948 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 963 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
                    return -1;
                  return 14082; /* pred_widen_mul_plussuv1024hi_scalar */

                case 26:
                  if (!(
#line 5948 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 964 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
                    return -1;
                  return 14083; /* pred_widen_mul_plussuv2048hi_scalar */

                case 27:
                  if (!(
#line 5948 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 965 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
                    return -1;
                  return 14084; /* pred_widen_mul_plussuv1si_scalar */

                case 28:
                  if (!(
#line 5948 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 966 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
                    return -1;
                  return 14085; /* pred_widen_mul_plussuv2si_scalar */

                case 29:
                  if (!(
#line 5948 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 967 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
                    return -1;
                  return 14086; /* pred_widen_mul_plussuv4si_scalar */

                case 30:
                  if (!(
#line 5948 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 968 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
                    return -1;
                  return 14087; /* pred_widen_mul_plussuv8si_scalar */

                case 31:
                  if (!(
#line 5948 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 969 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
                    return -1;
                  return 14088; /* pred_widen_mul_plussuv16si_scalar */

                case 32:
                  if (!(
#line 5948 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 970 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
                    return -1;
                  return 14089; /* pred_widen_mul_plussuv32si_scalar */

                case 33:
                  if (!(
#line 5948 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 971 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
                    return -1;
                  return 14090; /* pred_widen_mul_plussuv64si_scalar */

                case 34:
                  if (!(
#line 5948 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 972 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
                    return -1;
                  return 14091; /* pred_widen_mul_plussuv128si_scalar */

                case 35:
                  if (!(
#line 5948 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 973 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
                    return -1;
                  return 14092; /* pred_widen_mul_plussuv256si_scalar */

                case 36:
                  if (!(
#line 5948 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 974 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
                    return -1;
                  return 14093; /* pred_widen_mul_plussuv512si_scalar */

                case 37:
                  if (!(
#line 5948 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 975 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
                    return -1;
                  return 14094; /* pred_widen_mul_plussuv1024si_scalar */

                case 38:
                  if (!(
#line 5948 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 976 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
                    return -1;
                  return 14095; /* pred_widen_mul_plussuv1di_scalar */

                case 39:
                  if (!(
#line 5948 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 977 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
                    return -1;
                  return 14096; /* pred_widen_mul_plussuv2di_scalar */

                case 40:
                  if (!(
#line 5948 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 978 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
                    return -1;
                  return 14097; /* pred_widen_mul_plussuv4di_scalar */

                case 41:
                  if (!(
#line 5948 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 979 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
                    return -1;
                  return 14098; /* pred_widen_mul_plussuv8di_scalar */

                case 42:
                  if (!(
#line 5948 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 980 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
                    return -1;
                  return 14099; /* pred_widen_mul_plussuv16di_scalar */

                case 43:
                  if (!(
#line 5948 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 981 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
                    return -1;
                  return 14100; /* pred_widen_mul_plussuv32di_scalar */

                case 44:
                  if (!(
#line 5948 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 982 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
                    return -1;
                  return 14101; /* pred_widen_mul_plussuv64di_scalar */

                case 45:
                  if (!(
#line 5948 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 983 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
                    return -1;
                  return 14102; /* pred_widen_mul_plussuv128di_scalar */

                case 46:
                  if (!(
#line 5948 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 984 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
                    return -1;
                  return 14103; /* pred_widen_mul_plussuv256di_scalar */

                case 47:
                  if (!(
#line 5948 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 985 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
                    return -1;
                  return 14104; /* pred_widen_mul_plussuv512di_scalar */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ZERO_EXTEND:
      return recog_747 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 int
recog_765 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern569 (x2, 
E_V256SImode, 
E_V256BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[5] = x4;
  if (pattern701 (x2, 
E_V256SImode) == 0
      && (
#line 5603 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 221 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
    return 13504; /* *pred_minus_mulv256si_undef */
  operands[4] = x4;
  x5 = XEXP (x2, 0);
  x6 = XVECEXP (x5, 0, 1);
  operands[5] = x6;
  x7 = XVECEXP (x5, 0, 2);
  operands[6] = x7;
  x8 = XVECEXP (x5, 0, 3);
  operands[7] = x8;
  x9 = XVECEXP (x5, 0, 4);
  operands[8] = x9;
  x10 = XEXP (x3, 1);
  if (GET_MODE (x10) != E_V256SImode)
    return -1;
  x11 = XEXP (x10, 0);
  operands[2] = x11;
  if (!register_operand (operands[2], E_V256SImode))
    return -1;
  x12 = XEXP (x10, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V256SImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5629 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 221 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
    return 13572; /* *pred_nmsubv256si */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5658 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 221 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
    return -1;
  return 13640; /* *pred_nmsacv256si */
}

 int
recog_768 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern569 (x2, 
E_V32SImode, 
E_V32BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[5] = x4;
  if (pattern701 (x2, 
E_V32SImode) == 0
      && (
#line 5603 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 218 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
    return 13501; /* *pred_minus_mulv32si_undef */
  operands[4] = x4;
  x5 = XEXP (x2, 0);
  x6 = XVECEXP (x5, 0, 1);
  operands[5] = x6;
  x7 = XVECEXP (x5, 0, 2);
  operands[6] = x7;
  x8 = XVECEXP (x5, 0, 3);
  operands[7] = x8;
  x9 = XVECEXP (x5, 0, 4);
  operands[8] = x9;
  x10 = XEXP (x3, 1);
  if (GET_MODE (x10) != E_V32SImode)
    return -1;
  x11 = XEXP (x10, 0);
  operands[2] = x11;
  if (!register_operand (operands[2], E_V32SImode))
    return -1;
  x12 = XEXP (x10, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V32SImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5629 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 218 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
    return 13569; /* *pred_nmsubv32si */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5658 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 218 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
    return -1;
  return 13637; /* *pred_nmsacv32si */
}

 int
recog_772 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern569 (x2, 
E_V2SImode, 
E_V2BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[5] = x4;
  if (pattern701 (x2, 
E_V2SImode) == 0
      && (
#line 5603 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 214 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
    return 13497; /* *pred_minus_mulv2si_undef */
  operands[4] = x4;
  x5 = XEXP (x2, 0);
  x6 = XVECEXP (x5, 0, 1);
  operands[5] = x6;
  x7 = XVECEXP (x5, 0, 2);
  operands[6] = x7;
  x8 = XVECEXP (x5, 0, 3);
  operands[7] = x8;
  x9 = XVECEXP (x5, 0, 4);
  operands[8] = x9;
  x10 = XEXP (x3, 1);
  if (GET_MODE (x10) != E_V2SImode)
    return -1;
  x11 = XEXP (x10, 0);
  operands[2] = x11;
  if (!register_operand (operands[2], E_V2SImode))
    return -1;
  x12 = XEXP (x10, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V2SImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5629 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 214 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
    return 13565; /* *pred_nmsubv2si */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5658 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 214 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
    return -1;
  return 13633; /* *pred_nmsacv2si */
}

 int
recog_778 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern569 (x2, 
E_V128HImode, 
E_V128BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[5] = x4;
  if (pattern701 (x2, 
E_V128HImode) == 0
      && (
#line 5603 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 208 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
    return 13491; /* *pred_minus_mulv128hi_undef */
  operands[4] = x4;
  x5 = XEXP (x2, 0);
  x6 = XVECEXP (x5, 0, 1);
  operands[5] = x6;
  x7 = XVECEXP (x5, 0, 2);
  operands[6] = x7;
  x8 = XVECEXP (x5, 0, 3);
  operands[7] = x8;
  x9 = XVECEXP (x5, 0, 4);
  operands[8] = x9;
  x10 = XEXP (x3, 1);
  if (GET_MODE (x10) != E_V128HImode)
    return -1;
  x11 = XEXP (x10, 0);
  operands[2] = x11;
  if (!register_operand (operands[2], E_V128HImode))
    return -1;
  x12 = XEXP (x10, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V128HImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5629 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 208 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
    return 13559; /* *pred_nmsubv128hi */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5658 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 208 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
    return -1;
  return 13627; /* *pred_nmsacv128hi */
}

 int
recog_784 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern569 (x2, 
E_V2HImode, 
E_V2BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[5] = x4;
  if (pattern701 (x2, 
E_V2HImode) == 0
      && (
#line 5603 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 202 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
    return 13485; /* *pred_minus_mulv2hi_undef */
  operands[4] = x4;
  x5 = XEXP (x2, 0);
  x6 = XVECEXP (x5, 0, 1);
  operands[5] = x6;
  x7 = XVECEXP (x5, 0, 2);
  operands[6] = x7;
  x8 = XVECEXP (x5, 0, 3);
  operands[7] = x8;
  x9 = XVECEXP (x5, 0, 4);
  operands[8] = x9;
  x10 = XEXP (x3, 1);
  if (GET_MODE (x10) != E_V2HImode)
    return -1;
  x11 = XEXP (x10, 0);
  operands[2] = x11;
  if (!register_operand (operands[2], E_V2HImode))
    return -1;
  x12 = XEXP (x10, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V2HImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5629 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 202 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
    return 13553; /* *pred_nmsubv2hi */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5658 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 202 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
    return -1;
  return 13621; /* *pred_nmsacv2hi */
}

 int
recog_792 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern569 (x2, 
E_V64QImode, 
E_V64BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[5] = x4;
  if (pattern701 (x2, 
E_V64QImode) == 0
      && (
#line 5603 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 194 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
    return 13477; /* *pred_minus_mulv64qi_undef */
  operands[4] = x4;
  x5 = XEXP (x2, 0);
  x6 = XVECEXP (x5, 0, 1);
  operands[5] = x6;
  x7 = XVECEXP (x5, 0, 2);
  operands[6] = x7;
  x8 = XVECEXP (x5, 0, 3);
  operands[7] = x8;
  x9 = XVECEXP (x5, 0, 4);
  operands[8] = x9;
  x10 = XEXP (x3, 1);
  if (GET_MODE (x10) != E_V64QImode)
    return -1;
  x11 = XEXP (x10, 0);
  operands[2] = x11;
  if (!register_operand (operands[2], E_V64QImode))
    return -1;
  x12 = XEXP (x10, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V64QImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5629 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 194 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
    return 13545; /* *pred_nmsubv64qi */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5658 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 194 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
    return -1;
  return 13613; /* *pred_nmsacv64qi */
}

 int
recog_801 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern569 (x2, 
E_RVVMF2HImode, 
E_RVVMF32BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[5] = x4;
  if (pattern701 (x2, 
E_RVVMF2HImode) == 0
      && (
#line 5603 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
    return 13468; /* *pred_minus_mulrvvmf2hi_undef */
  operands[4] = x4;
  x5 = XEXP (x2, 0);
  x6 = XVECEXP (x5, 0, 1);
  operands[5] = x6;
  x7 = XVECEXP (x5, 0, 2);
  operands[6] = x7;
  x8 = XVECEXP (x5, 0, 3);
  operands[7] = x8;
  x9 = XVECEXP (x5, 0, 4);
  operands[8] = x9;
  x10 = XEXP (x3, 1);
  if (GET_MODE (x10) != E_RVVMF2HImode)
    return -1;
  x11 = XEXP (x10, 0);
  operands[2] = x11;
  if (!register_operand (operands[2], E_RVVMF2HImode))
    return -1;
  x12 = XEXP (x10, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_RVVMF2HImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5629 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
    return 13536; /* *pred_nmsubrvvmf2hi */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5658 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
    return -1;
  return 13604; /* *pred_nmsacrvvmf2hi */
}

 int
recog_809 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern705 (x2, 
E_V4DImode, 
E_V4BImode, 
E_DImode) != 0)
    return -1;
  x3 = XEXP (x2, 2);
  if (rtx_equal_p (x3, operands[3])
      && (
#line 5709 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 226 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
    return 13713; /* *pred_nmsubv4di_scalar */
  if (!rtx_equal_p (x3, operands[4])
      || !(
#line 5739 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 226 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
    return -1;
  return 13781; /* *pred_nmsacv4di_scalar */
}

 int
recog_815 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern705 (x2, 
E_V128SImode, 
E_V128BImode, 
E_SImode) != 0)
    return -1;
  x3 = XEXP (x2, 2);
  if (rtx_equal_p (x3, operands[3])
      && (
#line 5709 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 220 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
    return 13707; /* *pred_nmsubv128si_scalar */
  if (!rtx_equal_p (x3, operands[4])
      || !(
#line 5739 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 220 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
    return -1;
  return 13775; /* *pred_nmsacv128si_scalar */
}

 int
recog_823 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern705 (x2, 
E_V2048HImode, 
E_V2048BImode, 
E_HImode) != 0)
    return -1;
  x3 = XEXP (x2, 2);
  if (rtx_equal_p (x3, operands[3])
      && (
#line 5709 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 212 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
    return 13699; /* *pred_nmsubv2048hi_scalar */
  if (!rtx_equal_p (x3, operands[4])
      || !(
#line 5739 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 212 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
    return -1;
  return 13767; /* *pred_nmsacv2048hi_scalar */
}

 int
recog_831 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[2] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8QImode:
      if (pattern705 (x2, 
E_RVVM8QImode, 
E_RVVM1BImode, 
E_QImode) != 0)
        return -1;
      x7 = XEXP (x2, 2);
      if (rtx_equal_p (x7, operands[3])
          && 
#line 5709 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 13653; /* *pred_nmsubrvvm8qi_scalar */
      if (!rtx_equal_p (x7, operands[4])
          || !
#line 5739 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 13721; /* *pred_nmsacrvvm8qi_scalar */

    case E_RVVM4QImode:
      if (pattern705 (x2, 
E_RVVM4QImode, 
E_RVVMF2BImode, 
E_QImode) != 0)
        return -1;
      x7 = XEXP (x2, 2);
      if (rtx_equal_p (x7, operands[3])
          && 
#line 5709 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 13654; /* *pred_nmsubrvvm4qi_scalar */
      if (!rtx_equal_p (x7, operands[4])
          || !
#line 5739 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 13722; /* *pred_nmsacrvvm4qi_scalar */

    case E_RVVM2QImode:
      if (pattern705 (x2, 
E_RVVM2QImode, 
E_RVVMF4BImode, 
E_QImode) != 0)
        return -1;
      x7 = XEXP (x2, 2);
      if (rtx_equal_p (x7, operands[3])
          && 
#line 5709 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 13655; /* *pred_nmsubrvvm2qi_scalar */
      if (!rtx_equal_p (x7, operands[4])
          || !
#line 5739 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 13723; /* *pred_nmsacrvvm2qi_scalar */

    case E_RVVM1QImode:
      if (pattern705 (x2, 
E_RVVM1QImode, 
E_RVVMF8BImode, 
E_QImode) != 0)
        return -1;
      x7 = XEXP (x2, 2);
      if (rtx_equal_p (x7, operands[3])
          && 
#line 5709 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 13656; /* *pred_nmsubrvvm1qi_scalar */
      if (!rtx_equal_p (x7, operands[4])
          || !
#line 5739 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 13724; /* *pred_nmsacrvvm1qi_scalar */

    case E_RVVM8HImode:
      if (pattern705 (x2, 
E_RVVM8HImode, 
E_RVVMF2BImode, 
E_HImode) != 0)
        return -1;
      x7 = XEXP (x2, 2);
      if (rtx_equal_p (x7, operands[3])
          && 
#line 5709 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 13657; /* *pred_nmsubrvvm8hi_scalar */
      if (!rtx_equal_p (x7, operands[4])
          || !
#line 5739 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 13725; /* *pred_nmsacrvvm8hi_scalar */

    case E_RVVM4HImode:
      if (pattern705 (x2, 
E_RVVM4HImode, 
E_RVVMF4BImode, 
E_HImode) != 0)
        return -1;
      x7 = XEXP (x2, 2);
      if (rtx_equal_p (x7, operands[3])
          && 
#line 5709 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 13658; /* *pred_nmsubrvvm4hi_scalar */
      if (!rtx_equal_p (x7, operands[4])
          || !
#line 5739 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 13726; /* *pred_nmsacrvvm4hi_scalar */

    case E_RVVM2HImode:
      if (pattern705 (x2, 
E_RVVM2HImode, 
E_RVVMF8BImode, 
E_HImode) != 0)
        return -1;
      x7 = XEXP (x2, 2);
      if (rtx_equal_p (x7, operands[3])
          && 
#line 5709 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 13659; /* *pred_nmsubrvvm2hi_scalar */
      if (!rtx_equal_p (x7, operands[4])
          || !
#line 5739 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 13727; /* *pred_nmsacrvvm2hi_scalar */

    case E_RVVM1HImode:
      if (pattern705 (x2, 
E_RVVM1HImode, 
E_RVVMF16BImode, 
E_HImode) != 0)
        return -1;
      x7 = XEXP (x2, 2);
      if (rtx_equal_p (x7, operands[3])
          && 
#line 5709 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 13660; /* *pred_nmsubrvvm1hi_scalar */
      if (!rtx_equal_p (x7, operands[4])
          || !
#line 5739 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 13728; /* *pred_nmsacrvvm1hi_scalar */

    case E_RVVM8SImode:
      if (pattern705 (x2, 
E_RVVM8SImode, 
E_RVVMF4BImode, 
E_SImode) != 0)
        return -1;
      x7 = XEXP (x2, 2);
      if (rtx_equal_p (x7, operands[3])
          && 
#line 5709 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 13661; /* *pred_nmsubrvvm8si_scalar */
      if (!rtx_equal_p (x7, operands[4])
          || !
#line 5739 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 13729; /* *pred_nmsacrvvm8si_scalar */

    case E_RVVM4SImode:
      if (pattern705 (x2, 
E_RVVM4SImode, 
E_RVVMF8BImode, 
E_SImode) != 0)
        return -1;
      x7 = XEXP (x2, 2);
      if (rtx_equal_p (x7, operands[3])
          && 
#line 5709 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 13662; /* *pred_nmsubrvvm4si_scalar */
      if (!rtx_equal_p (x7, operands[4])
          || !
#line 5739 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 13730; /* *pred_nmsacrvvm4si_scalar */

    case E_RVVM2SImode:
      if (pattern705 (x2, 
E_RVVM2SImode, 
E_RVVMF16BImode, 
E_SImode) != 0)
        return -1;
      x7 = XEXP (x2, 2);
      if (rtx_equal_p (x7, operands[3])
          && 
#line 5709 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 13663; /* *pred_nmsubrvvm2si_scalar */
      if (!rtx_equal_p (x7, operands[4])
          || !
#line 5739 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 13731; /* *pred_nmsacrvvm2si_scalar */

    case E_RVVM1SImode:
      if (pattern705 (x2, 
E_RVVM1SImode, 
E_RVVMF32BImode, 
E_SImode) != 0)
        return -1;
      x7 = XEXP (x2, 2);
      if (rtx_equal_p (x7, operands[3])
          && 
#line 5709 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 13664; /* *pred_nmsubrvvm1si_scalar */
      if (!rtx_equal_p (x7, operands[4])
          || !
#line 5739 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 13732; /* *pred_nmsacrvvm1si_scalar */

    case E_RVVM8DImode:
      if (pattern705 (x2, 
E_RVVM8DImode, 
E_RVVMF8BImode, 
E_DImode) != 0)
        return -1;
      x7 = XEXP (x2, 2);
      if (rtx_equal_p (x7, operands[3])
          && (
#line 5709 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 13665; /* *pred_nmsubrvvm8di_scalar */
      if (!rtx_equal_p (x7, operands[4])
          || !(
#line 5739 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 13733; /* *pred_nmsacrvvm8di_scalar */

    case E_RVVM4DImode:
      if (pattern705 (x2, 
E_RVVM4DImode, 
E_RVVMF16BImode, 
E_DImode) != 0)
        return -1;
      x7 = XEXP (x2, 2);
      if (rtx_equal_p (x7, operands[3])
          && (
#line 5709 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 13666; /* *pred_nmsubrvvm4di_scalar */
      if (!rtx_equal_p (x7, operands[4])
          || !(
#line 5739 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 13734; /* *pred_nmsacrvvm4di_scalar */

    case E_RVVM2DImode:
      if (pattern705 (x2, 
E_RVVM2DImode, 
E_RVVMF32BImode, 
E_DImode) != 0)
        return -1;
      x7 = XEXP (x2, 2);
      if (rtx_equal_p (x7, operands[3])
          && (
#line 5709 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 13667; /* *pred_nmsubrvvm2di_scalar */
      if (!rtx_equal_p (x7, operands[4])
          || !(
#line 5739 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 13735; /* *pred_nmsacrvvm2di_scalar */

    case E_RVVM1DImode:
      if (pattern705 (x2, 
E_RVVM1DImode, 
E_RVVMF64BImode, 
E_DImode) != 0)
        return -1;
      x7 = XEXP (x2, 2);
      if (rtx_equal_p (x7, operands[3])
          && (
#line 5709 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 13668; /* *pred_nmsubrvvm1di_scalar */
      if (!rtx_equal_p (x7, operands[4])
          || !(
#line 5739 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 13736; /* *pred_nmsacrvvm1di_scalar */

    case E_RVVMF2QImode:
      if (pattern705 (x2, 
E_RVVMF2QImode, 
E_RVVMF16BImode, 
E_QImode) != 0)
        return -1;
      x7 = XEXP (x2, 2);
      if (rtx_equal_p (x7, operands[3])
          && (
#line 5709 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return 13669; /* *pred_nmsubrvvmf2qi_scalar */
      if (!rtx_equal_p (x7, operands[4])
          || !(
#line 5739 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 13737; /* *pred_nmsacrvvmf2qi_scalar */

    case E_RVVMF4QImode:
      if (pattern705 (x2, 
E_RVVMF4QImode, 
E_RVVMF32BImode, 
E_QImode) != 0)
        return -1;
      x7 = XEXP (x2, 2);
      if (rtx_equal_p (x7, operands[3])
          && (
#line 5709 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return 13670; /* *pred_nmsubrvvmf4qi_scalar */
      if (!rtx_equal_p (x7, operands[4])
          || !(
#line 5739 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 13738; /* *pred_nmsacrvvmf4qi_scalar */

    case E_RVVMF8QImode:
      if (pattern705 (x2, 
E_RVVMF8QImode, 
E_RVVMF64BImode, 
E_QImode) != 0)
        return -1;
      x7 = XEXP (x2, 2);
      if (rtx_equal_p (x7, operands[3])
          && (
#line 5709 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return 13671; /* *pred_nmsubrvvmf8qi_scalar */
      if (!rtx_equal_p (x7, operands[4])
          || !(
#line 5739 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 13739; /* *pred_nmsacrvvmf8qi_scalar */

    case E_RVVMF2HImode:
      if (pattern705 (x2, 
E_RVVMF2HImode, 
E_RVVMF32BImode, 
E_HImode) != 0)
        return -1;
      x7 = XEXP (x2, 2);
      if (rtx_equal_p (x7, operands[3])
          && (
#line 5709 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return 13672; /* *pred_nmsubrvvmf2hi_scalar */
      if (!rtx_equal_p (x7, operands[4])
          || !(
#line 5739 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 13740; /* *pred_nmsacrvvmf2hi_scalar */

    case E_RVVMF4HImode:
      if (pattern705 (x2, 
E_RVVMF4HImode, 
E_RVVMF64BImode, 
E_HImode) != 0)
        return -1;
      x7 = XEXP (x2, 2);
      if (rtx_equal_p (x7, operands[3])
          && (
#line 5709 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 132 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return 13673; /* *pred_nmsubrvvmf4hi_scalar */
      if (!rtx_equal_p (x7, operands[4])
          || !(
#line 5739 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 132 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 13741; /* *pred_nmsacrvvmf4hi_scalar */

    case E_RVVMF2SImode:
      if (pattern705 (x2, 
E_RVVMF2SImode, 
E_RVVMF64BImode, 
E_SImode) != 0)
        return -1;
      x7 = XEXP (x2, 2);
      if (rtx_equal_p (x7, operands[3])
          && (
#line 5709 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 133 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return 13674; /* *pred_nmsubrvvmf2si_scalar */
      if (!rtx_equal_p (x7, operands[4])
          || !(
#line 5739 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 133 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 13742; /* *pred_nmsacrvvmf2si_scalar */

    case E_V1QImode:
      if (pattern705 (x2, 
E_V1QImode, 
E_V1BImode, 
E_QImode) != 0)
        return -1;
      x7 = XEXP (x2, 2);
      if (rtx_equal_p (x7, operands[3])
          && (
#line 5709 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 188 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return 13675; /* *pred_nmsubv1qi_scalar */
      if (!rtx_equal_p (x7, operands[4])
          || !(
#line 5739 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 188 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 13743; /* *pred_nmsacv1qi_scalar */

    case E_V2QImode:
      if (pattern705 (x2, 
E_V2QImode, 
E_V2BImode, 
E_QImode) != 0)
        return -1;
      x7 = XEXP (x2, 2);
      if (rtx_equal_p (x7, operands[3])
          && (
#line 5709 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 189 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return 13676; /* *pred_nmsubv2qi_scalar */
      if (!rtx_equal_p (x7, operands[4])
          || !(
#line 5739 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 189 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 13744; /* *pred_nmsacv2qi_scalar */

    case E_V4QImode:
      if (pattern705 (x2, 
E_V4QImode, 
E_V4BImode, 
E_QImode) != 0)
        return -1;
      x7 = XEXP (x2, 2);
      if (rtx_equal_p (x7, operands[3])
          && (
#line 5709 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 190 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return 13677; /* *pred_nmsubv4qi_scalar */
      if (!rtx_equal_p (x7, operands[4])
          || !(
#line 5739 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 190 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 13745; /* *pred_nmsacv4qi_scalar */

    case E_V8QImode:
      if (pattern705 (x2, 
E_V8QImode, 
E_V8BImode, 
E_QImode) != 0)
        return -1;
      x7 = XEXP (x2, 2);
      if (rtx_equal_p (x7, operands[3])
          && (
#line 5709 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 191 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return 13678; /* *pred_nmsubv8qi_scalar */
      if (!rtx_equal_p (x7, operands[4])
          || !(
#line 5739 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 191 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 13746; /* *pred_nmsacv8qi_scalar */

    case E_V16QImode:
      if (pattern705 (x2, 
E_V16QImode, 
E_V16BImode, 
E_QImode) != 0)
        return -1;
      x7 = XEXP (x2, 2);
      if (rtx_equal_p (x7, operands[3])
          && (
#line 5709 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 192 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return 13679; /* *pred_nmsubv16qi_scalar */
      if (!rtx_equal_p (x7, operands[4])
          || !(
#line 5739 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 192 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 13747; /* *pred_nmsacv16qi_scalar */

    case E_V32QImode:
      if (pattern705 (x2, 
E_V32QImode, 
E_V32BImode, 
E_QImode) != 0)
        return -1;
      x7 = XEXP (x2, 2);
      if (rtx_equal_p (x7, operands[3])
          && (
#line 5709 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 193 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return 13680; /* *pred_nmsubv32qi_scalar */
      if (!rtx_equal_p (x7, operands[4])
          || !(
#line 5739 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 193 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 13748; /* *pred_nmsacv32qi_scalar */

    case E_V64QImode:
      if (pattern705 (x2, 
E_V64QImode, 
E_V64BImode, 
E_QImode) != 0)
        return -1;
      x7 = XEXP (x2, 2);
      if (rtx_equal_p (x7, operands[3])
          && (
#line 5709 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 194 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return 13681; /* *pred_nmsubv64qi_scalar */
      if (!rtx_equal_p (x7, operands[4])
          || !(
#line 5739 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 194 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 13749; /* *pred_nmsacv64qi_scalar */

    case E_V128QImode:
      if (pattern705 (x2, 
E_V128QImode, 
E_V128BImode, 
E_QImode) != 0)
        return -1;
      x7 = XEXP (x2, 2);
      if (rtx_equal_p (x7, operands[3])
          && (
#line 5709 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 195 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return 13682; /* *pred_nmsubv128qi_scalar */
      if (!rtx_equal_p (x7, operands[4])
          || !(
#line 5739 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 195 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 13750; /* *pred_nmsacv128qi_scalar */

    case E_V256QImode:
      if (pattern705 (x2, 
E_V256QImode, 
E_V256BImode, 
E_QImode) != 0)
        return -1;
      x7 = XEXP (x2, 2);
      if (rtx_equal_p (x7, operands[3])
          && (
#line 5709 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 196 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return 13683; /* *pred_nmsubv256qi_scalar */
      if (!rtx_equal_p (x7, operands[4])
          || !(
#line 5739 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 196 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 13751; /* *pred_nmsacv256qi_scalar */

    case E_V512QImode:
      if (pattern705 (x2, 
E_V512QImode, 
E_V512BImode, 
E_QImode) != 0)
        return -1;
      x7 = XEXP (x2, 2);
      if (rtx_equal_p (x7, operands[3])
          && (
#line 5709 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 197 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return 13684; /* *pred_nmsubv512qi_scalar */
      if (!rtx_equal_p (x7, operands[4])
          || !(
#line 5739 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 197 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 13752; /* *pred_nmsacv512qi_scalar */

    case E_V1024QImode:
      if (pattern705 (x2, 
E_V1024QImode, 
E_V1024BImode, 
E_QImode) != 0)
        return -1;
      x7 = XEXP (x2, 2);
      if (rtx_equal_p (x7, operands[3])
          && (
#line 5709 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 198 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return 13685; /* *pred_nmsubv1024qi_scalar */
      if (!rtx_equal_p (x7, operands[4])
          || !(
#line 5739 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 198 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 13753; /* *pred_nmsacv1024qi_scalar */

    case E_V2048QImode:
      if (pattern705 (x2, 
E_V2048QImode, 
E_V2048BImode, 
E_QImode) != 0)
        return -1;
      x7 = XEXP (x2, 2);
      if (rtx_equal_p (x7, operands[3])
          && (
#line 5709 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 199 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return 13686; /* *pred_nmsubv2048qi_scalar */
      if (!rtx_equal_p (x7, operands[4])
          || !(
#line 5739 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 199 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 13754; /* *pred_nmsacv2048qi_scalar */

    case E_V4096QImode:
      if (pattern705 (x2, 
E_V4096QImode, 
E_V4096BImode, 
E_QImode) != 0)
        return -1;
      x7 = XEXP (x2, 2);
      if (rtx_equal_p (x7, operands[3])
          && (
#line 5709 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 200 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return 13687; /* *pred_nmsubv4096qi_scalar */
      if (!rtx_equal_p (x7, operands[4])
          || !(
#line 5739 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 200 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 13755; /* *pred_nmsacv4096qi_scalar */

    case E_V1HImode:
      if (pattern705 (x2, 
E_V1HImode, 
E_V1BImode, 
E_HImode) != 0)
        return -1;
      x7 = XEXP (x2, 2);
      if (rtx_equal_p (x7, operands[3])
          && (
#line 5709 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 201 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return 13688; /* *pred_nmsubv1hi_scalar */
      if (!rtx_equal_p (x7, operands[4])
          || !(
#line 5739 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 201 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 13756; /* *pred_nmsacv1hi_scalar */

    case E_V2HImode:
      if (pattern705 (x2, 
E_V2HImode, 
E_V2BImode, 
E_HImode) != 0)
        return -1;
      x7 = XEXP (x2, 2);
      if (rtx_equal_p (x7, operands[3])
          && (
#line 5709 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 202 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return 13689; /* *pred_nmsubv2hi_scalar */
      if (!rtx_equal_p (x7, operands[4])
          || !(
#line 5739 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 202 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 13757; /* *pred_nmsacv2hi_scalar */

    case E_V4HImode:
      if (pattern705 (x2, 
E_V4HImode, 
E_V4BImode, 
E_HImode) != 0)
        return -1;
      x7 = XEXP (x2, 2);
      if (rtx_equal_p (x7, operands[3])
          && (
#line 5709 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 203 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return 13690; /* *pred_nmsubv4hi_scalar */
      if (!rtx_equal_p (x7, operands[4])
          || !(
#line 5739 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 203 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 13758; /* *pred_nmsacv4hi_scalar */

    case E_V8HImode:
      if (pattern705 (x2, 
E_V8HImode, 
E_V8BImode, 
E_HImode) != 0)
        return -1;
      x7 = XEXP (x2, 2);
      if (rtx_equal_p (x7, operands[3])
          && (
#line 5709 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 204 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return 13691; /* *pred_nmsubv8hi_scalar */
      if (!rtx_equal_p (x7, operands[4])
          || !(
#line 5739 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 204 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 13759; /* *pred_nmsacv8hi_scalar */

    case E_V16HImode:
      return recog_830 (x1, insn, pnum_clobbers);

    case E_V32HImode:
      return recog_829 (x1, insn, pnum_clobbers);

    case E_V64HImode:
      return recog_828 (x1, insn, pnum_clobbers);

    case E_V128HImode:
      return recog_827 (x1, insn, pnum_clobbers);

    case E_V256HImode:
      return recog_826 (x1, insn, pnum_clobbers);

    case E_V512HImode:
      return recog_825 (x1, insn, pnum_clobbers);

    case E_V1024HImode:
      return recog_824 (x1, insn, pnum_clobbers);

    case E_V2048HImode:
      return recog_823 (x1, insn, pnum_clobbers);

    case E_V1SImode:
      return recog_822 (x1, insn, pnum_clobbers);

    case E_V2SImode:
      return recog_821 (x1, insn, pnum_clobbers);

    case E_V4SImode:
      return recog_820 (x1, insn, pnum_clobbers);

    case E_V8SImode:
      return recog_819 (x1, insn, pnum_clobbers);

    case E_V16SImode:
      return recog_818 (x1, insn, pnum_clobbers);

    case E_V32SImode:
      return recog_817 (x1, insn, pnum_clobbers);

    case E_V64SImode:
      return recog_816 (x1, insn, pnum_clobbers);

    case E_V128SImode:
      return recog_815 (x1, insn, pnum_clobbers);

    case E_V256SImode:
      return recog_814 (x1, insn, pnum_clobbers);

    case E_V512SImode:
      return recog_813 (x1, insn, pnum_clobbers);

    case E_V1024SImode:
      return recog_812 (x1, insn, pnum_clobbers);

    case E_V1DImode:
      return recog_811 (x1, insn, pnum_clobbers);

    case E_V2DImode:
      return recog_810 (x1, insn, pnum_clobbers);

    case E_V4DImode:
      return recog_809 (x1, insn, pnum_clobbers);

    case E_V8DImode:
      return recog_808 (x1, insn, pnum_clobbers);

    case E_V16DImode:
      return recog_807 (x1, insn, pnum_clobbers);

    case E_V32DImode:
      return recog_806 (x1, insn, pnum_clobbers);

    case E_V64DImode:
      return recog_805 (x1, insn, pnum_clobbers);

    case E_V128DImode:
      return recog_804 (x1, insn, pnum_clobbers);

    case E_V256DImode:
      return recog_803 (x1, insn, pnum_clobbers);

    case E_V512DImode:
      return recog_802 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 int
recog_846 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern488 (x2, 
E_V8DImode, 
E_V8BImode) != 0)
    return -1;
  if (vector_shift_operand (operands[4], E_V8DImode)
      && (
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 227 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
    return 6539; /* pred_ashlv8di */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 2759 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 227 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
    return -1;
  return 6836; /* pred_ashlv8di_scalar */
}

 int
recog_849 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern488 (x2, 
E_V1DImode, 
E_V1BImode) != 0)
    return -1;
  if (vector_shift_operand (operands[4], E_V1DImode)
      && (
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 224 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
    return 6488; /* pred_ashlv1di */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 2759 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 224 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
    return -1;
  return 6827; /* pred_ashlv1di_scalar */
}

 int
recog_852 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern488 (x2, 
E_V256SImode, 
E_V256BImode) != 0)
    return -1;
  if (vector_shift_operand (operands[4], E_V256SImode)
      && (
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 221 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
    return 6437; /* pred_ashlv256si */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 2759 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 221 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
    return -1;
  return 6818; /* pred_ashlv256si_scalar */
}

 int
recog_855 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern488 (x2, 
E_V32SImode, 
E_V32BImode) != 0)
    return -1;
  if (vector_shift_operand (operands[4], E_V32SImode)
      && (
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 218 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
    return 6386; /* pred_ashlv32si */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 2759 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 218 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
    return -1;
  return 6809; /* pred_ashlv32si_scalar */
}

 int
recog_859 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern488 (x2, 
E_V2SImode, 
E_V2BImode) != 0)
    return -1;
  if (vector_shift_operand (operands[4], E_V2SImode)
      && (
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 214 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
    return 6318; /* pred_ashlv2si */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 2759 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 214 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
    return -1;
  return 6797; /* pred_ashlv2si_scalar */
}

 int
recog_864 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern488 (x2, 
E_V256HImode, 
E_V256BImode) != 0)
    return -1;
  if (vector_shift_operand (operands[4], E_V256HImode)
      && (
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 209 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
    return 6233; /* pred_ashlv256hi */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 2759 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 209 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
    return -1;
  return 6782; /* pred_ashlv256hi_scalar */
}

 int
recog_869 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern667 (x2, 
E_V512DImode, 
E_V512SImode, 
E_V512BImode) != 0)
    return -1;
  if (vector_shift_operand (operands[4], E_V512SImode)
      && (
#line 301 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 985 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
    return 32770; /* pred_vwsllv512di */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 322 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 985 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
    return -1;
  return 32818; /* pred_vwsllv512di_scalar */
}

 int
recog_874 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern667 (x2, 
E_V16DImode, 
E_V16SImode, 
E_V16BImode) != 0)
    return -1;
  if (vector_shift_operand (operands[4], E_V16SImode)
      && (
#line 301 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 980 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
    return 32765; /* pred_vwsllv16di */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 322 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 980 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
    return -1;
  return 32813; /* pred_vwsllv16di_scalar */
}

 int
recog_879 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  x6 = XEXP (x3, 1);
  switch (GET_CODE (x6))
    {
    case SIGN_EXTEND:
      switch (pattern529 (x2))
        {
        case 0:
          if (!
#line 4002 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9305; /* pred_dual_widen_mulsrvvm8hi */

        case 1:
          if (!
#line 4002 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9311; /* pred_dual_widen_mulsrvvm4hi */

        case 2:
          if (!
#line 4002 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9317; /* pred_dual_widen_mulsrvvm2hi */

        case 3:
          if (!
#line 4002 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9323; /* pred_dual_widen_mulsrvvm1hi */

        case 4:
          if (!
#line 4002 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9329; /* pred_dual_widen_mulsrvvmf2hi */

        case 5:
          if (!(
#line 4002 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 946 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 9335; /* pred_dual_widen_mulsrvvmf4hi */

        case 6:
          if (!
#line 4002 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9341; /* pred_dual_widen_mulsrvvm8si */

        case 7:
          if (!
#line 4002 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9347; /* pred_dual_widen_mulsrvvm4si */

        case 8:
          if (!
#line 4002 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9353; /* pred_dual_widen_mulsrvvm2si */

        case 9:
          if (!
#line 4002 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9359; /* pred_dual_widen_mulsrvvm1si */

        case 10:
          if (!(
#line 4002 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 948 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 9365; /* pred_dual_widen_mulsrvvmf2si */

        case 11:
          if (!(
#line 4002 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9371; /* pred_dual_widen_mulsrvvm8di */

        case 12:
          if (!(
#line 4002 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9377; /* pred_dual_widen_mulsrvvm4di */

        case 13:
          if (!(
#line 4002 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9383; /* pred_dual_widen_mulsrvvm2di */

        case 14:
          if (!(
#line 4002 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9389; /* pred_dual_widen_mulsrvvm1di */

        case 15:
          if (!(
#line 4002 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 953 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
            return -1;
          return 9395; /* pred_dual_widen_mulsv1hi */

        case 16:
          if (!(
#line 4002 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 954 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
            return -1;
          return 9401; /* pred_dual_widen_mulsv2hi */

        case 17:
          if (!(
#line 4002 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 955 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
            return -1;
          return 9407; /* pred_dual_widen_mulsv4hi */

        case 18:
          if (!(
#line 4002 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 956 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
            return -1;
          return 9413; /* pred_dual_widen_mulsv8hi */

        case 19:
          if (!(
#line 4002 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 957 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
            return -1;
          return 9419; /* pred_dual_widen_mulsv16hi */

        case 20:
          if (!(
#line 4002 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 958 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 9425; /* pred_dual_widen_mulsv32hi */

        case 21:
          if (!(
#line 4002 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 959 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 9431; /* pred_dual_widen_mulsv64hi */

        case 22:
          if (!(
#line 4002 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 960 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 9437; /* pred_dual_widen_mulsv128hi */

        case 23:
          if (!(
#line 4002 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 961 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 9443; /* pred_dual_widen_mulsv256hi */

        case 24:
          if (!(
#line 4002 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 962 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 9449; /* pred_dual_widen_mulsv512hi */

        case 25:
          if (!(
#line 4002 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 963 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 9455; /* pred_dual_widen_mulsv1024hi */

        case 26:
          if (!(
#line 4002 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 964 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 9461; /* pred_dual_widen_mulsv2048hi */

        case 27:
          if (!(
#line 4002 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 965 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return -1;
          return 9467; /* pred_dual_widen_mulsv1si */

        case 28:
          if (!(
#line 4002 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 966 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return -1;
          return 9473; /* pred_dual_widen_mulsv2si */

        case 29:
          if (!(
#line 4002 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 967 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
            return -1;
          return 9479; /* pred_dual_widen_mulsv4si */

        case 30:
          if (!(
#line 4002 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 968 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
            return -1;
          return 9485; /* pred_dual_widen_mulsv8si */

        case 31:
          if (!(
#line 4002 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 969 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 9491; /* pred_dual_widen_mulsv16si */

        case 32:
          if (!(
#line 4002 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 970 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 9497; /* pred_dual_widen_mulsv32si */

        case 33:
          if (!(
#line 4002 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 971 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 9503; /* pred_dual_widen_mulsv64si */

        case 34:
          if (!(
#line 4002 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 972 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 9509; /* pred_dual_widen_mulsv128si */

        case 35:
          if (!(
#line 4002 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 973 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 9515; /* pred_dual_widen_mulsv256si */

        case 36:
          if (!(
#line 4002 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 974 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 9521; /* pred_dual_widen_mulsv512si */

        case 37:
          if (!(
#line 4002 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 975 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 9527; /* pred_dual_widen_mulsv1024si */

        case 38:
          if (!(
#line 4002 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 976 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9533; /* pred_dual_widen_mulsv1di */

        case 39:
          if (!(
#line 4002 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 977 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9539; /* pred_dual_widen_mulsv2di */

        case 40:
          if (!(
#line 4002 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 978 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9545; /* pred_dual_widen_mulsv4di */

        case 41:
          if (!(
#line 4002 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 979 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 9551; /* pred_dual_widen_mulsv8di */

        case 42:
          if (!(
#line 4002 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 980 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 9557; /* pred_dual_widen_mulsv16di */

        case 43:
          if (!(
#line 4002 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 981 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 9563; /* pred_dual_widen_mulsv32di */

        case 44:
          if (!(
#line 4002 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 982 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 9569; /* pred_dual_widen_mulsv64di */

        case 45:
          if (!(
#line 4002 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 983 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 9575; /* pred_dual_widen_mulsv128di */

        case 46:
          if (!(
#line 4002 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 984 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 9581; /* pred_dual_widen_mulsv256di */

        case 47:
          if (!(
#line 4002 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 985 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 9587; /* pred_dual_widen_mulsv512di */

        case 48:
          if (!
#line 4025 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9593; /* pred_dual_widen_mulsrvvm8hi_scalar */

        case 49:
          if (!
#line 4025 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9599; /* pred_dual_widen_mulsrvvm4hi_scalar */

        case 50:
          if (!
#line 4025 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9605; /* pred_dual_widen_mulsrvvm2hi_scalar */

        case 51:
          if (!
#line 4025 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9611; /* pred_dual_widen_mulsrvvm1hi_scalar */

        case 52:
          if (!
#line 4025 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9617; /* pred_dual_widen_mulsrvvmf2hi_scalar */

        case 53:
          if (!(
#line 4025 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 946 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 9623; /* pred_dual_widen_mulsrvvmf4hi_scalar */

        case 54:
          if (!
#line 4025 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9629; /* pred_dual_widen_mulsrvvm8si_scalar */

        case 55:
          if (!
#line 4025 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9635; /* pred_dual_widen_mulsrvvm4si_scalar */

        case 56:
          if (!
#line 4025 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9641; /* pred_dual_widen_mulsrvvm2si_scalar */

        case 57:
          if (!
#line 4025 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9647; /* pred_dual_widen_mulsrvvm1si_scalar */

        case 58:
          if (!(
#line 4025 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 948 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 9653; /* pred_dual_widen_mulsrvvmf2si_scalar */

        case 59:
          if (!(
#line 4025 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9659; /* pred_dual_widen_mulsrvvm8di_scalar */

        case 60:
          if (!(
#line 4025 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9665; /* pred_dual_widen_mulsrvvm4di_scalar */

        case 61:
          if (!(
#line 4025 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9671; /* pred_dual_widen_mulsrvvm2di_scalar */

        case 62:
          if (!(
#line 4025 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9677; /* pred_dual_widen_mulsrvvm1di_scalar */

        case 63:
          if (!(
#line 4025 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 953 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
            return -1;
          return 9683; /* pred_dual_widen_mulsv1hi_scalar */

        case 64:
          if (!(
#line 4025 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 954 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
            return -1;
          return 9689; /* pred_dual_widen_mulsv2hi_scalar */

        case 65:
          if (!(
#line 4025 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 955 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
            return -1;
          return 9695; /* pred_dual_widen_mulsv4hi_scalar */

        case 66:
          if (!(
#line 4025 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 956 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
            return -1;
          return 9701; /* pred_dual_widen_mulsv8hi_scalar */

        case 67:
          if (!(
#line 4025 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 957 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
            return -1;
          return 9707; /* pred_dual_widen_mulsv16hi_scalar */

        case 68:
          if (!(
#line 4025 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 958 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 9713; /* pred_dual_widen_mulsv32hi_scalar */

        case 69:
          if (!(
#line 4025 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 959 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 9719; /* pred_dual_widen_mulsv64hi_scalar */

        case 70:
          if (!(
#line 4025 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 960 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 9725; /* pred_dual_widen_mulsv128hi_scalar */

        case 71:
          if (!(
#line 4025 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 961 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 9731; /* pred_dual_widen_mulsv256hi_scalar */

        case 72:
          if (!(
#line 4025 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 962 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 9737; /* pred_dual_widen_mulsv512hi_scalar */

        case 73:
          if (!(
#line 4025 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 963 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 9743; /* pred_dual_widen_mulsv1024hi_scalar */

        case 74:
          if (!(
#line 4025 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 964 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 9749; /* pred_dual_widen_mulsv2048hi_scalar */

        case 75:
          if (!(
#line 4025 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 965 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return -1;
          return 9755; /* pred_dual_widen_mulsv1si_scalar */

        case 76:
          if (!(
#line 4025 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 966 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return -1;
          return 9761; /* pred_dual_widen_mulsv2si_scalar */

        case 77:
          if (!(
#line 4025 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 967 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
            return -1;
          return 9767; /* pred_dual_widen_mulsv4si_scalar */

        case 78:
          if (!(
#line 4025 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 968 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
            return -1;
          return 9773; /* pred_dual_widen_mulsv8si_scalar */

        case 79:
          if (!(
#line 4025 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 969 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 9779; /* pred_dual_widen_mulsv16si_scalar */

        case 80:
          if (!(
#line 4025 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 970 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 9785; /* pred_dual_widen_mulsv32si_scalar */

        case 81:
          if (!(
#line 4025 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 971 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 9791; /* pred_dual_widen_mulsv64si_scalar */

        case 82:
          if (!(
#line 4025 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 972 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 9797; /* pred_dual_widen_mulsv128si_scalar */

        case 83:
          if (!(
#line 4025 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 973 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 9803; /* pred_dual_widen_mulsv256si_scalar */

        case 84:
          if (!(
#line 4025 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 974 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 9809; /* pred_dual_widen_mulsv512si_scalar */

        case 85:
          if (!(
#line 4025 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 975 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 9815; /* pred_dual_widen_mulsv1024si_scalar */

        case 86:
          if (!(
#line 4025 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 976 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9821; /* pred_dual_widen_mulsv1di_scalar */

        case 87:
          if (!(
#line 4025 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 977 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9827; /* pred_dual_widen_mulsv2di_scalar */

        case 88:
          if (!(
#line 4025 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 978 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9833; /* pred_dual_widen_mulsv4di_scalar */

        case 89:
          if (!(
#line 4025 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 979 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 9839; /* pred_dual_widen_mulsv8di_scalar */

        case 90:
          if (!(
#line 4025 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 980 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 9845; /* pred_dual_widen_mulsv16di_scalar */

        case 91:
          if (!(
#line 4025 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 981 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 9851; /* pred_dual_widen_mulsv32di_scalar */

        case 92:
          if (!(
#line 4025 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 982 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 9857; /* pred_dual_widen_mulsv64di_scalar */

        case 93:
          if (!(
#line 4025 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 983 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 9863; /* pred_dual_widen_mulsv128di_scalar */

        case 94:
          if (!(
#line 4025 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 984 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 9869; /* pred_dual_widen_mulsv256di_scalar */

        case 95:
          if (!(
#line 4025 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 985 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 9875; /* pred_dual_widen_mulsv512di_scalar */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      switch (pattern529 (x2))
        {
        case 0:
          if (!
#line 4157 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10453; /* pred_widen_mulsurvvm8hi */

        case 1:
          if (!
#line 4157 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10454; /* pred_widen_mulsurvvm4hi */

        case 2:
          if (!
#line 4157 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10455; /* pred_widen_mulsurvvm2hi */

        case 3:
          if (!
#line 4157 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10456; /* pred_widen_mulsurvvm1hi */

        case 4:
          if (!
#line 4157 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10457; /* pred_widen_mulsurvvmf2hi */

        case 5:
          if (!(
#line 4157 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 946 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 10458; /* pred_widen_mulsurvvmf4hi */

        case 6:
          if (!
#line 4157 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10459; /* pred_widen_mulsurvvm8si */

        case 7:
          if (!
#line 4157 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10460; /* pred_widen_mulsurvvm4si */

        case 8:
          if (!
#line 4157 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10461; /* pred_widen_mulsurvvm2si */

        case 9:
          if (!
#line 4157 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10462; /* pred_widen_mulsurvvm1si */

        case 10:
          if (!(
#line 4157 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 948 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 10463; /* pred_widen_mulsurvvmf2si */

        case 11:
          if (!(
#line 4157 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10464; /* pred_widen_mulsurvvm8di */

        case 12:
          if (!(
#line 4157 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10465; /* pred_widen_mulsurvvm4di */

        case 13:
          if (!(
#line 4157 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10466; /* pred_widen_mulsurvvm2di */

        case 14:
          if (!(
#line 4157 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10467; /* pred_widen_mulsurvvm1di */

        case 15:
          if (!(
#line 4157 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 953 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
            return -1;
          return 10468; /* pred_widen_mulsuv1hi */

        case 16:
          if (!(
#line 4157 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 954 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
            return -1;
          return 10469; /* pred_widen_mulsuv2hi */

        case 17:
          if (!(
#line 4157 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 955 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
            return -1;
          return 10470; /* pred_widen_mulsuv4hi */

        case 18:
          if (!(
#line 4157 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 956 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
            return -1;
          return 10471; /* pred_widen_mulsuv8hi */

        case 19:
          if (!(
#line 4157 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 957 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
            return -1;
          return 10472; /* pred_widen_mulsuv16hi */

        case 20:
          if (!(
#line 4157 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 958 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 10473; /* pred_widen_mulsuv32hi */

        case 21:
          if (!(
#line 4157 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 959 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 10474; /* pred_widen_mulsuv64hi */

        case 22:
          if (!(
#line 4157 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 960 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 10475; /* pred_widen_mulsuv128hi */

        case 23:
          if (!(
#line 4157 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 961 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 10476; /* pred_widen_mulsuv256hi */

        case 24:
          if (!(
#line 4157 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 962 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 10477; /* pred_widen_mulsuv512hi */

        case 25:
          if (!(
#line 4157 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 963 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 10478; /* pred_widen_mulsuv1024hi */

        case 26:
          if (!(
#line 4157 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 964 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 10479; /* pred_widen_mulsuv2048hi */

        case 27:
          if (!(
#line 4157 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 965 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return -1;
          return 10480; /* pred_widen_mulsuv1si */

        case 28:
          if (!(
#line 4157 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 966 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return -1;
          return 10481; /* pred_widen_mulsuv2si */

        case 29:
          if (!(
#line 4157 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 967 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
            return -1;
          return 10482; /* pred_widen_mulsuv4si */

        case 30:
          if (!(
#line 4157 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 968 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
            return -1;
          return 10483; /* pred_widen_mulsuv8si */

        case 31:
          if (!(
#line 4157 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 969 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 10484; /* pred_widen_mulsuv16si */

        case 32:
          if (!(
#line 4157 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 970 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 10485; /* pred_widen_mulsuv32si */

        case 33:
          if (!(
#line 4157 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 971 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 10486; /* pred_widen_mulsuv64si */

        case 34:
          if (!(
#line 4157 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 972 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 10487; /* pred_widen_mulsuv128si */

        case 35:
          if (!(
#line 4157 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 973 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 10488; /* pred_widen_mulsuv256si */

        case 36:
          if (!(
#line 4157 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 974 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 10489; /* pred_widen_mulsuv512si */

        case 37:
          if (!(
#line 4157 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 975 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 10490; /* pred_widen_mulsuv1024si */

        case 38:
          if (!(
#line 4157 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 976 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10491; /* pred_widen_mulsuv1di */

        case 39:
          if (!(
#line 4157 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 977 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10492; /* pred_widen_mulsuv2di */

        case 40:
          if (!(
#line 4157 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 978 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10493; /* pred_widen_mulsuv4di */

        case 41:
          if (!(
#line 4157 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 979 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 10494; /* pred_widen_mulsuv8di */

        case 42:
          if (!(
#line 4157 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 980 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 10495; /* pred_widen_mulsuv16di */

        case 43:
          if (!(
#line 4157 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 981 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 10496; /* pred_widen_mulsuv32di */

        case 44:
          if (!(
#line 4157 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 982 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 10497; /* pred_widen_mulsuv64di */

        case 45:
          if (!(
#line 4157 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 983 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 10498; /* pred_widen_mulsuv128di */

        case 46:
          if (!(
#line 4157 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 984 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 10499; /* pred_widen_mulsuv256di */

        case 47:
          if (!(
#line 4157 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 985 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 10500; /* pred_widen_mulsuv512di */

        case 48:
          if (!
#line 4180 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10501; /* pred_widen_mulsurvvm8hi_scalar */

        case 49:
          if (!
#line 4180 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10502; /* pred_widen_mulsurvvm4hi_scalar */

        case 50:
          if (!
#line 4180 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10503; /* pred_widen_mulsurvvm2hi_scalar */

        case 51:
          if (!
#line 4180 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10504; /* pred_widen_mulsurvvm1hi_scalar */

        case 52:
          if (!
#line 4180 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10505; /* pred_widen_mulsurvvmf2hi_scalar */

        case 53:
          if (!(
#line 4180 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 946 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 10506; /* pred_widen_mulsurvvmf4hi_scalar */

        case 54:
          if (!
#line 4180 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10507; /* pred_widen_mulsurvvm8si_scalar */

        case 55:
          if (!
#line 4180 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10508; /* pred_widen_mulsurvvm4si_scalar */

        case 56:
          if (!
#line 4180 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10509; /* pred_widen_mulsurvvm2si_scalar */

        case 57:
          if (!
#line 4180 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10510; /* pred_widen_mulsurvvm1si_scalar */

        case 58:
          if (!(
#line 4180 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 948 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 10511; /* pred_widen_mulsurvvmf2si_scalar */

        case 59:
          if (!(
#line 4180 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10512; /* pred_widen_mulsurvvm8di_scalar */

        case 60:
          if (!(
#line 4180 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10513; /* pred_widen_mulsurvvm4di_scalar */

        case 61:
          if (!(
#line 4180 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10514; /* pred_widen_mulsurvvm2di_scalar */

        case 62:
          if (!(
#line 4180 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10515; /* pred_widen_mulsurvvm1di_scalar */

        case 63:
          if (!(
#line 4180 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 953 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
            return -1;
          return 10516; /* pred_widen_mulsuv1hi_scalar */

        case 64:
          if (!(
#line 4180 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 954 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
            return -1;
          return 10517; /* pred_widen_mulsuv2hi_scalar */

        case 65:
          if (!(
#line 4180 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 955 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
            return -1;
          return 10518; /* pred_widen_mulsuv4hi_scalar */

        case 66:
          if (!(
#line 4180 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 956 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
            return -1;
          return 10519; /* pred_widen_mulsuv8hi_scalar */

        case 67:
          if (!(
#line 4180 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 957 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
            return -1;
          return 10520; /* pred_widen_mulsuv16hi_scalar */

        case 68:
          if (!(
#line 4180 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 958 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 10521; /* pred_widen_mulsuv32hi_scalar */

        case 69:
          if (!(
#line 4180 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 959 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 10522; /* pred_widen_mulsuv64hi_scalar */

        case 70:
          if (!(
#line 4180 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 960 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 10523; /* pred_widen_mulsuv128hi_scalar */

        case 71:
          if (!(
#line 4180 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 961 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 10524; /* pred_widen_mulsuv256hi_scalar */

        case 72:
          if (!(
#line 4180 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 962 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 10525; /* pred_widen_mulsuv512hi_scalar */

        case 73:
          if (!(
#line 4180 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 963 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 10526; /* pred_widen_mulsuv1024hi_scalar */

        case 74:
          if (!(
#line 4180 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 964 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 10527; /* pred_widen_mulsuv2048hi_scalar */

        case 75:
          if (!(
#line 4180 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 965 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return -1;
          return 10528; /* pred_widen_mulsuv1si_scalar */

        case 76:
          if (!(
#line 4180 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 966 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return -1;
          return 10529; /* pred_widen_mulsuv2si_scalar */

        case 77:
          if (!(
#line 4180 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 967 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
            return -1;
          return 10530; /* pred_widen_mulsuv4si_scalar */

        case 78:
          if (!(
#line 4180 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 968 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
            return -1;
          return 10531; /* pred_widen_mulsuv8si_scalar */

        case 79:
          if (!(
#line 4180 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 969 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 10532; /* pred_widen_mulsuv16si_scalar */

        case 80:
          if (!(
#line 4180 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 970 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 10533; /* pred_widen_mulsuv32si_scalar */

        case 81:
          if (!(
#line 4180 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 971 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 10534; /* pred_widen_mulsuv64si_scalar */

        case 82:
          if (!(
#line 4180 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 972 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 10535; /* pred_widen_mulsuv128si_scalar */

        case 83:
          if (!(
#line 4180 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 973 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 10536; /* pred_widen_mulsuv256si_scalar */

        case 84:
          if (!(
#line 4180 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 974 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 10537; /* pred_widen_mulsuv512si_scalar */

        case 85:
          if (!(
#line 4180 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 975 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 10538; /* pred_widen_mulsuv1024si_scalar */

        case 86:
          if (!(
#line 4180 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 976 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10539; /* pred_widen_mulsuv1di_scalar */

        case 87:
          if (!(
#line 4180 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 977 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10540; /* pred_widen_mulsuv2di_scalar */

        case 88:
          if (!(
#line 4180 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 978 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10541; /* pred_widen_mulsuv4di_scalar */

        case 89:
          if (!(
#line 4180 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 979 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 10542; /* pred_widen_mulsuv8di_scalar */

        case 90:
          if (!(
#line 4180 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 980 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 10543; /* pred_widen_mulsuv16di_scalar */

        case 91:
          if (!(
#line 4180 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 981 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 10544; /* pred_widen_mulsuv32di_scalar */

        case 92:
          if (!(
#line 4180 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 982 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 10545; /* pred_widen_mulsuv64di_scalar */

        case 93:
          if (!(
#line 4180 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 983 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 10546; /* pred_widen_mulsuv128di_scalar */

        case 94:
          if (!(
#line 4180 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 984 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 10547; /* pred_widen_mulsuv256di_scalar */

        case 95:
          if (!(
#line 4180 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 985 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 10548; /* pred_widen_mulsuv512di_scalar */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_893 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      return recog_751 (x1, insn, pnum_clobbers);

    case VEC_DUPLICATE:
      x5 = XEXP (x2, 0);
      x6 = XVECEXP (x5, 0, 1);
      operands[5] = x6;
      x7 = XVECEXP (x5, 0, 2);
      operands[6] = x7;
      x8 = XVECEXP (x5, 0, 3);
      operands[7] = x8;
      x9 = XVECEXP (x5, 0, 4);
      operands[8] = x9;
      x10 = XEXP (x3, 1);
      operands[3] = x10;
      x11 = XEXP (x2, 2);
      operands[2] = x11;
      x12 = XEXP (x4, 0);
      switch (GET_CODE (x12))
        {
        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case REG:
        case SUBREG:
          switch (pattern484 (x2))
            {
            case 0:
              if (!
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 6857; /* pred_addrvvm8qi_scalar */

            case 1:
              if (!
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 6866; /* pred_addrvvm4qi_scalar */

            case 2:
              if (!
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 6875; /* pred_addrvvm2qi_scalar */

            case 3:
              if (!
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 6884; /* pred_addrvvm1qi_scalar */

            case 4:
              if (!
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 6893; /* pred_addrvvmf2qi_scalar */

            case 5:
              if (!
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 6902; /* pred_addrvvmf4qi_scalar */

            case 6:
              if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 724 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
                return -1;
              return 6911; /* pred_addrvvmf8qi_scalar */

            case 7:
              if (!
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 6920; /* pred_addrvvm8hi_scalar */

            case 8:
              if (!
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 6929; /* pred_addrvvm4hi_scalar */

            case 9:
              if (!
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 6938; /* pred_addrvvm2hi_scalar */

            case 10:
              if (!
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 6947; /* pred_addrvvm1hi_scalar */

            case 11:
              if (!
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 6956; /* pred_addrvvmf2hi_scalar */

            case 12:
              if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 726 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
                return -1;
              return 6965; /* pred_addrvvmf4hi_scalar */

            case 13:
              if (!
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 6974; /* pred_addrvvm8si_scalar */

            case 14:
              if (!
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 6983; /* pred_addrvvm4si_scalar */

            case 15:
              if (!
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 6992; /* pred_addrvvm2si_scalar */

            case 16:
              if (!
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 7001; /* pred_addrvvm1si_scalar */

            case 17:
              if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 728 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
                return -1;
              return 7010; /* pred_addrvvmf2si_scalar */

            case 18:
              if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 730 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
                return -1;
              return 7019; /* pred_addv1qi_scalar */

            case 19:
              if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 731 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
                return -1;
              return 7028; /* pred_addv2qi_scalar */

            case 20:
              if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 732 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
                return -1;
              return 7037; /* pred_addv4qi_scalar */

            case 21:
              if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 733 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
                return -1;
              return 7046; /* pred_addv8qi_scalar */

            case 22:
              if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 734 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
                return -1;
              return 7055; /* pred_addv16qi_scalar */

            case 23:
              if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 735 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
                return -1;
              return 7064; /* pred_addv32qi_scalar */

            case 24:
              if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 736 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 7073; /* pred_addv64qi_scalar */

            case 25:
              if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 737 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 7082; /* pred_addv128qi_scalar */

            case 26:
              if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 738 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 7091; /* pred_addv256qi_scalar */

            case 27:
              if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 739 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 7100; /* pred_addv512qi_scalar */

            case 28:
              if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 740 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 7109; /* pred_addv1024qi_scalar */

            case 29:
              if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 741 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 7118; /* pred_addv2048qi_scalar */

            case 30:
              if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 742 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 7127; /* pred_addv4096qi_scalar */

            case 31:
              if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 743 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
                return -1;
              return 7136; /* pred_addv1hi_scalar */

            case 32:
              if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 744 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
                return -1;
              return 7145; /* pred_addv2hi_scalar */

            case 33:
              if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 745 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
                return -1;
              return 7154; /* pred_addv4hi_scalar */

            case 34:
              if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 746 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
                return -1;
              return 7163; /* pred_addv8hi_scalar */

            case 35:
              if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 747 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
                return -1;
              return 7172; /* pred_addv16hi_scalar */

            case 36:
              if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 748 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 7181; /* pred_addv32hi_scalar */

            case 37:
              if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 749 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 7190; /* pred_addv64hi_scalar */

            case 38:
              if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 750 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 7199; /* pred_addv128hi_scalar */

            case 39:
              if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 751 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 7208; /* pred_addv256hi_scalar */

            case 40:
              if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 752 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 7217; /* pred_addv512hi_scalar */

            case 41:
              if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 753 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 7226; /* pred_addv1024hi_scalar */

            case 42:
              if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 754 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 7235; /* pred_addv2048hi_scalar */

            case 43:
              if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 755 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
                return -1;
              return 7244; /* pred_addv1si_scalar */

            case 44:
              if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 756 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
                return -1;
              return 7253; /* pred_addv2si_scalar */

            case 45:
              if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 757 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
                return -1;
              return 7262; /* pred_addv4si_scalar */

            case 46:
              if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 758 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
                return -1;
              return 7271; /* pred_addv8si_scalar */

            case 47:
              if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 759 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 7280; /* pred_addv16si_scalar */

            case 48:
              if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 760 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 7289; /* pred_addv32si_scalar */

            case 49:
              if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 761 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 7298; /* pred_addv64si_scalar */

            case 50:
              if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 762 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 7307; /* pred_addv128si_scalar */

            case 51:
              if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 763 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 7316; /* pred_addv256si_scalar */

            case 52:
              if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 764 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 7325; /* pred_addv512si_scalar */

            case 53:
              if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 765 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 7334; /* pred_addv1024si_scalar */

            case 54:
              if (!(
#line 2879 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 774 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 7667; /* *pred_addrvvm8di_scalar */

            case 55:
              if (!(
#line 2879 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 774 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 7676; /* *pred_addrvvm4di_scalar */

            case 56:
              if (!(
#line 2879 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 775 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 7685; /* *pred_addrvvm2di_scalar */

            case 57:
              if (!(
#line 2879 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 775 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 7694; /* *pred_addrvvm1di_scalar */

            case 58:
              if (!(
#line 2879 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 777 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
                return -1;
              return 7703; /* *pred_addv1di_scalar */

            case 59:
              if (!(
#line 2879 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 778 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
                return -1;
              return 7712; /* *pred_addv2di_scalar */

            case 60:
              if (!(
#line 2879 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 779 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
                return -1;
              return 7721; /* *pred_addv4di_scalar */

            case 61:
              if (!(
#line 2879 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 780 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 7730; /* *pred_addv8di_scalar */

            case 62:
              if (!(
#line 2879 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 781 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 7739; /* *pred_addv16di_scalar */

            case 63:
              if (!(
#line 2879 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 782 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 7748; /* *pred_addv32di_scalar */

            case 64:
              if (!(
#line 2879 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 783 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 7757; /* *pred_addv64di_scalar */

            case 65:
              if (!(
#line 2879 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 784 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 7766; /* *pred_addv128di_scalar */

            case 66:
              if (!(
#line 2879 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 785 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 7775; /* *pred_addv256di_scalar */

            case 67:
              if (!(
#line 2879 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 786 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 7784; /* *pred_addv512di_scalar */

            default:
              return -1;
            }

        case SIGN_EXTEND:
          return recog_606 (x1, insn, pnum_clobbers);

        case ZERO_EXTEND:
          x13 = XEXP (x12, 0);
          operands[4] = x13;
          switch (GET_MODE (operands[0]))
            {
            case E_RVVM8HImode:
              if (pattern685 (x2, 
E_RVVM8HImode, 
E_RVVMF2BImode, 
E_QImode, 
E_HImode) != 0
                  || !
#line 4111 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 10262; /* pred_single_widen_addurvvm8hi_extended_scalar */

            case E_RVVM4HImode:
              if (pattern685 (x2, 
E_RVVM4HImode, 
E_RVVMF4BImode, 
E_QImode, 
E_HImode) != 0
                  || !
#line 4111 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 10264; /* pred_single_widen_addurvvm4hi_extended_scalar */

            case E_RVVM2HImode:
              if (pattern685 (x2, 
E_RVVM2HImode, 
E_RVVMF8BImode, 
E_QImode, 
E_HImode) != 0
                  || !
#line 4111 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 10266; /* pred_single_widen_addurvvm2hi_extended_scalar */

            case E_RVVM1HImode:
              if (pattern685 (x2, 
E_RVVM1HImode, 
E_RVVMF16BImode, 
E_QImode, 
E_HImode) != 0
                  || !
#line 4111 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 10268; /* pred_single_widen_addurvvm1hi_extended_scalar */

            case E_RVVMF2HImode:
              if (pattern685 (x2, 
E_RVVMF2HImode, 
E_RVVMF32BImode, 
E_QImode, 
E_HImode) != 0
                  || !
#line 4111 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 10270; /* pred_single_widen_addurvvmf2hi_extended_scalar */

            case E_RVVMF4HImode:
              if (pattern685 (x2, 
E_RVVMF4HImode, 
E_RVVMF64BImode, 
E_QImode, 
E_HImode) != 0
                  || !(
#line 4111 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 946 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
                return -1;
              return 10272; /* pred_single_widen_addurvvmf4hi_extended_scalar */

            case E_RVVM8SImode:
              if (pattern685 (x2, 
E_RVVM8SImode, 
E_RVVMF4BImode, 
E_HImode, 
E_SImode) != 0
                  || !
#line 4111 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 10274; /* pred_single_widen_addurvvm8si_extended_scalar */

            case E_RVVM4SImode:
              if (pattern685 (x2, 
E_RVVM4SImode, 
E_RVVMF8BImode, 
E_HImode, 
E_SImode) != 0
                  || !
#line 4111 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 10276; /* pred_single_widen_addurvvm4si_extended_scalar */

            case E_RVVM2SImode:
              if (pattern685 (x2, 
E_RVVM2SImode, 
E_RVVMF16BImode, 
E_HImode, 
E_SImode) != 0
                  || !
#line 4111 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 10278; /* pred_single_widen_addurvvm2si_extended_scalar */

            case E_RVVM1SImode:
              if (pattern685 (x2, 
E_RVVM1SImode, 
E_RVVMF32BImode, 
E_HImode, 
E_SImode) != 0
                  || !
#line 4111 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 10280; /* pred_single_widen_addurvvm1si_extended_scalar */

            case E_RVVMF2SImode:
              if (pattern685 (x2, 
E_RVVMF2SImode, 
E_RVVMF64BImode, 
E_HImode, 
E_SImode) != 0
                  || !(
#line 4111 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 948 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
                return -1;
              return 10282; /* pred_single_widen_addurvvmf2si_extended_scalar */

            case E_RVVM8DImode:
              if (pattern685 (x2, 
E_RVVM8DImode, 
E_RVVMF8BImode, 
E_SImode, 
E_DImode) != 0
                  || !(
#line 4111 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 10284; /* pred_single_widen_addurvvm8di_extended_scalar */

            case E_RVVM4DImode:
              if (pattern685 (x2, 
E_RVVM4DImode, 
E_RVVMF16BImode, 
E_SImode, 
E_DImode) != 0
                  || !(
#line 4111 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 10286; /* pred_single_widen_addurvvm4di_extended_scalar */

            case E_RVVM2DImode:
              if (pattern685 (x2, 
E_RVVM2DImode, 
E_RVVMF32BImode, 
E_SImode, 
E_DImode) != 0
                  || !(
#line 4111 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 10288; /* pred_single_widen_addurvvm2di_extended_scalar */

            case E_RVVM1DImode:
              if (pattern685 (x2, 
E_RVVM1DImode, 
E_RVVMF64BImode, 
E_SImode, 
E_DImode) != 0
                  || !(
#line 4111 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 10290; /* pred_single_widen_addurvvm1di_extended_scalar */

            case E_V1HImode:
              if (pattern685 (x2, 
E_V1HImode, 
E_V1BImode, 
E_QImode, 
E_HImode) != 0
                  || !(
#line 4111 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 953 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
                return -1;
              return 10292; /* pred_single_widen_adduv1hi_extended_scalar */

            case E_V2HImode:
              if (pattern685 (x2, 
E_V2HImode, 
E_V2BImode, 
E_QImode, 
E_HImode) != 0
                  || !(
#line 4111 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 954 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
                return -1;
              return 10294; /* pred_single_widen_adduv2hi_extended_scalar */

            case E_V4HImode:
              if (pattern685 (x2, 
E_V4HImode, 
E_V4BImode, 
E_QImode, 
E_HImode) != 0
                  || !(
#line 4111 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 955 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
                return -1;
              return 10296; /* pred_single_widen_adduv4hi_extended_scalar */

            case E_V8HImode:
              if (pattern685 (x2, 
E_V8HImode, 
E_V8BImode, 
E_QImode, 
E_HImode) != 0
                  || !(
#line 4111 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 956 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
                return -1;
              return 10298; /* pred_single_widen_adduv8hi_extended_scalar */

            case E_V16HImode:
              if (pattern685 (x2, 
E_V16HImode, 
E_V16BImode, 
E_QImode, 
E_HImode) != 0
                  || !(
#line 4111 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 957 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
                return -1;
              return 10300; /* pred_single_widen_adduv16hi_extended_scalar */

            case E_V32HImode:
              if (pattern685 (x2, 
E_V32HImode, 
E_V32BImode, 
E_QImode, 
E_HImode) != 0
                  || !(
#line 4111 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 958 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 10302; /* pred_single_widen_adduv32hi_extended_scalar */

            case E_V64HImode:
              if (pattern685 (x2, 
E_V64HImode, 
E_V64BImode, 
E_QImode, 
E_HImode) != 0
                  || !(
#line 4111 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 959 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 10304; /* pred_single_widen_adduv64hi_extended_scalar */

            case E_V128HImode:
              if (pattern685 (x2, 
E_V128HImode, 
E_V128BImode, 
E_QImode, 
E_HImode) != 0
                  || !(
#line 4111 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 960 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 10306; /* pred_single_widen_adduv128hi_extended_scalar */

            case E_V256HImode:
              if (pattern685 (x2, 
E_V256HImode, 
E_V256BImode, 
E_QImode, 
E_HImode) != 0
                  || !(
#line 4111 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 961 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 10308; /* pred_single_widen_adduv256hi_extended_scalar */

            case E_V512HImode:
              if (pattern685 (x2, 
E_V512HImode, 
E_V512BImode, 
E_QImode, 
E_HImode) != 0
                  || !(
#line 4111 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 962 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 10310; /* pred_single_widen_adduv512hi_extended_scalar */

            case E_V1024HImode:
              if (pattern685 (x2, 
E_V1024HImode, 
E_V1024BImode, 
E_QImode, 
E_HImode) != 0
                  || !(
#line 4111 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 963 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 10312; /* pred_single_widen_adduv1024hi_extended_scalar */

            case E_V2048HImode:
              if (pattern685 (x2, 
E_V2048HImode, 
E_V2048BImode, 
E_QImode, 
E_HImode) != 0
                  || !(
#line 4111 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 964 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 10314; /* pred_single_widen_adduv2048hi_extended_scalar */

            case E_V1SImode:
              if (pattern685 (x2, 
E_V1SImode, 
E_V1BImode, 
E_HImode, 
E_SImode) != 0
                  || !(
#line 4111 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 965 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
                return -1;
              return 10316; /* pred_single_widen_adduv1si_extended_scalar */

            case E_V2SImode:
              if (pattern685 (x2, 
E_V2SImode, 
E_V2BImode, 
E_HImode, 
E_SImode) != 0
                  || !(
#line 4111 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 966 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
                return -1;
              return 10318; /* pred_single_widen_adduv2si_extended_scalar */

            case E_V4SImode:
              if (pattern685 (x2, 
E_V4SImode, 
E_V4BImode, 
E_HImode, 
E_SImode) != 0
                  || !(
#line 4111 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 967 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
                return -1;
              return 10320; /* pred_single_widen_adduv4si_extended_scalar */

            case E_V8SImode:
              if (pattern685 (x2, 
E_V8SImode, 
E_V8BImode, 
E_HImode, 
E_SImode) != 0
                  || !(
#line 4111 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 968 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
                return -1;
              return 10322; /* pred_single_widen_adduv8si_extended_scalar */

            case E_V16SImode:
              if (pattern685 (x2, 
E_V16SImode, 
E_V16BImode, 
E_HImode, 
E_SImode) != 0
                  || !(
#line 4111 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 969 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 10324; /* pred_single_widen_adduv16si_extended_scalar */

            case E_V32SImode:
              if (pattern685 (x2, 
E_V32SImode, 
E_V32BImode, 
E_HImode, 
E_SImode) != 0
                  || !(
#line 4111 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 970 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 10326; /* pred_single_widen_adduv32si_extended_scalar */

            case E_V64SImode:
              if (pattern685 (x2, 
E_V64SImode, 
E_V64BImode, 
E_HImode, 
E_SImode) != 0
                  || !(
#line 4111 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 971 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 10328; /* pred_single_widen_adduv64si_extended_scalar */

            case E_V128SImode:
              if (pattern685 (x2, 
E_V128SImode, 
E_V128BImode, 
E_HImode, 
E_SImode) != 0
                  || !(
#line 4111 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 972 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 10330; /* pred_single_widen_adduv128si_extended_scalar */

            case E_V256SImode:
              if (pattern685 (x2, 
E_V256SImode, 
E_V256BImode, 
E_HImode, 
E_SImode) != 0
                  || !(
#line 4111 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 973 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 10332; /* pred_single_widen_adduv256si_extended_scalar */

            case E_V512SImode:
              if (pattern685 (x2, 
E_V512SImode, 
E_V512BImode, 
E_HImode, 
E_SImode) != 0
                  || !(
#line 4111 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 974 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 10334; /* pred_single_widen_adduv512si_extended_scalar */

            case E_V1024SImode:
              if (pattern685 (x2, 
E_V1024SImode, 
E_V1024BImode, 
E_HImode, 
E_SImode) != 0
                  || !(
#line 4111 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 975 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 10336; /* pred_single_widen_adduv1024si_extended_scalar */

            case E_V1DImode:
              if (pattern685 (x2, 
E_V1DImode, 
E_V1BImode, 
E_SImode, 
E_DImode) != 0
                  || !(
#line 4111 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 976 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
                return -1;
              return 10338; /* pred_single_widen_adduv1di_extended_scalar */

            case E_V2DImode:
              if (pattern685 (x2, 
E_V2DImode, 
E_V2BImode, 
E_SImode, 
E_DImode) != 0
                  || !(
#line 4111 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 977 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
                return -1;
              return 10340; /* pred_single_widen_adduv2di_extended_scalar */

            case E_V4DImode:
              if (pattern685 (x2, 
E_V4DImode, 
E_V4BImode, 
E_SImode, 
E_DImode) != 0
                  || !(
#line 4111 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 978 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
                return -1;
              return 10342; /* pred_single_widen_adduv4di_extended_scalar */

            case E_V8DImode:
              if (pattern685 (x2, 
E_V8DImode, 
E_V8BImode, 
E_SImode, 
E_DImode) != 0
                  || !(
#line 4111 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 979 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 10344; /* pred_single_widen_adduv8di_extended_scalar */

            case E_V16DImode:
              if (pattern685 (x2, 
E_V16DImode, 
E_V16BImode, 
E_SImode, 
E_DImode) != 0
                  || !(
#line 4111 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 980 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 10346; /* pred_single_widen_adduv16di_extended_scalar */

            case E_V32DImode:
              if (pattern685 (x2, 
E_V32DImode, 
E_V32BImode, 
E_SImode, 
E_DImode) != 0
                  || !(
#line 4111 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 981 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 10348; /* pred_single_widen_adduv32di_extended_scalar */

            case E_V64DImode:
              if (pattern685 (x2, 
E_V64DImode, 
E_V64BImode, 
E_SImode, 
E_DImode) != 0
                  || !(
#line 4111 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 982 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 10350; /* pred_single_widen_adduv64di_extended_scalar */

            case E_V128DImode:
              if (pattern685 (x2, 
E_V128DImode, 
E_V128BImode, 
E_SImode, 
E_DImode) != 0
                  || !(
#line 4111 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 983 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 10352; /* pred_single_widen_adduv128di_extended_scalar */

            case E_V256DImode:
              if (pattern685 (x2, 
E_V256DImode, 
E_V256BImode, 
E_SImode, 
E_DImode) != 0
                  || !(
#line 4111 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 984 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 10354; /* pred_single_widen_adduv256di_extended_scalar */

            case E_V512DImode:
              if (pattern685 (x2, 
E_V512DImode, 
E_V512BImode, 
E_SImode, 
E_DImode) != 0
                  || !(
#line 4111 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 985 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 10356; /* pred_single_widen_adduv512di_extended_scalar */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case SIGN_EXTEND:
      return recog_749 (x1, insn, pnum_clobbers);

    case ZERO_EXTEND:
      return recog_748 (x1, insn, pnum_clobbers);

    case MULT:
      return recog_750 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 int
recog_902 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern494 (x2))
    {
    case 0:
      if (!
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5506; /* pred_umaxrvvm8qi */

    case 1:
      if (!
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5523; /* pred_umaxrvvm4qi */

    case 2:
      if (!
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5540; /* pred_umaxrvvm2qi */

    case 3:
      if (!
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5557; /* pred_umaxrvvm1qi */

    case 4:
      if (!
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5574; /* pred_umaxrvvm8hi */

    case 5:
      if (!
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5591; /* pred_umaxrvvm4hi */

    case 6:
      if (!
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5608; /* pred_umaxrvvm2hi */

    case 7:
      if (!
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5625; /* pred_umaxrvvm1hi */

    case 8:
      if (!
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5642; /* pred_umaxrvvm8si */

    case 9:
      if (!
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5659; /* pred_umaxrvvm4si */

    case 10:
      if (!
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5676; /* pred_umaxrvvm2si */

    case 11:
      if (!
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5693; /* pred_umaxrvvm1si */

    case 12:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5710; /* pred_umaxrvvm8di */

    case 13:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5727; /* pred_umaxrvvm4di */

    case 14:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5744; /* pred_umaxrvvm2di */

    case 15:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5761; /* pred_umaxrvvm1di */

    case 16:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 5778; /* pred_umaxrvvmf2qi */

    case 17:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 5795; /* pred_umaxrvvmf4qi */

    case 18:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 5812; /* pred_umaxrvvmf8qi */

    case 19:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 5829; /* pred_umaxrvvmf2hi */

    case 20:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 132 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 5846; /* pred_umaxrvvmf4hi */

    case 21:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 133 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 5863; /* pred_umaxrvvmf2si */

    case 22:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 188 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 5880; /* pred_umaxv1qi */

    case 23:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 189 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 5897; /* pred_umaxv2qi */

    case 24:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 190 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 5914; /* pred_umaxv4qi */

    case 25:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 191 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 5931; /* pred_umaxv8qi */

    case 26:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 192 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 5948; /* pred_umaxv16qi */

    case 27:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 193 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 5965; /* pred_umaxv32qi */

    case 28:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 194 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 5982; /* pred_umaxv64qi */

    case 29:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 195 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 5999; /* pred_umaxv128qi */

    case 30:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 196 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 6016; /* pred_umaxv256qi */

    case 31:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 197 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 6033; /* pred_umaxv512qi */

    case 32:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 198 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 6050; /* pred_umaxv1024qi */

    case 33:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 199 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 6067; /* pred_umaxv2048qi */

    case 34:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 200 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 6084; /* pred_umaxv4096qi */

    case 35:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 201 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 6101; /* pred_umaxv1hi */

    case 36:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 202 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 6118; /* pred_umaxv2hi */

    case 37:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 203 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 6135; /* pred_umaxv4hi */

    case 38:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 204 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 6152; /* pred_umaxv8hi */

    case 39:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 205 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 6169; /* pred_umaxv16hi */

    case 40:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 206 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 6186; /* pred_umaxv32hi */

    case 41:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 207 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 6203; /* pred_umaxv64hi */

    case 42:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 208 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 6220; /* pred_umaxv128hi */

    case 43:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 209 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 6237; /* pred_umaxv256hi */

    case 44:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 210 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 6254; /* pred_umaxv512hi */

    case 45:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 211 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 6271; /* pred_umaxv1024hi */

    case 46:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 212 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 6288; /* pred_umaxv2048hi */

    case 47:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 213 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 6305; /* pred_umaxv1si */

    case 48:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 214 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 6322; /* pred_umaxv2si */

    case 49:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 215 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 6339; /* pred_umaxv4si */

    case 50:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 216 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 6356; /* pred_umaxv8si */

    case 51:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 217 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 6373; /* pred_umaxv16si */

    case 52:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 218 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 6390; /* pred_umaxv32si */

    case 53:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 219 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 6407; /* pred_umaxv64si */

    case 54:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 220 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 6424; /* pred_umaxv128si */

    case 55:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 221 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 6441; /* pred_umaxv256si */

    case 56:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 222 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 6458; /* pred_umaxv512si */

    case 57:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 223 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 6475; /* pred_umaxv1024si */

    case 58:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 224 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 6492; /* pred_umaxv1di */

    case 59:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 225 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 6509; /* pred_umaxv2di */

    case 60:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 226 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 6526; /* pred_umaxv4di */

    case 61:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 227 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 6543; /* pred_umaxv8di */

    case 62:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 228 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 6560; /* pred_umaxv16di */

    case 63:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 229 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 6577; /* pred_umaxv32di */

    case 64:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 230 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 6594; /* pred_umaxv64di */

    case 65:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 231 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 6611; /* pred_umaxv128di */

    case 66:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 232 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 6628; /* pred_umaxv256di */

    case 67:
      if (!(
#line 2723 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 233 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 6645; /* pred_umaxv512di */

    case 68:
      if (!
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6862; /* pred_umaxrvvm8qi_scalar */

    case 69:
      if (!
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6871; /* pred_umaxrvvm4qi_scalar */

    case 70:
      if (!
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6880; /* pred_umaxrvvm2qi_scalar */

    case 71:
      if (!
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6889; /* pred_umaxrvvm1qi_scalar */

    case 72:
      if (!
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6898; /* pred_umaxrvvmf2qi_scalar */

    case 73:
      if (!
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6907; /* pred_umaxrvvmf4qi_scalar */

    case 74:
      if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 724 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 6916; /* pred_umaxrvvmf8qi_scalar */

    case 75:
      if (!
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6925; /* pred_umaxrvvm8hi_scalar */

    case 76:
      if (!
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6934; /* pred_umaxrvvm4hi_scalar */

    case 77:
      if (!
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6943; /* pred_umaxrvvm2hi_scalar */

    case 78:
      if (!
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6952; /* pred_umaxrvvm1hi_scalar */

    case 79:
      if (!
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6961; /* pred_umaxrvvmf2hi_scalar */

    case 80:
      if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 726 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 6970; /* pred_umaxrvvmf4hi_scalar */

    case 81:
      if (!
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6979; /* pred_umaxrvvm8si_scalar */

    case 82:
      if (!
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6988; /* pred_umaxrvvm4si_scalar */

    case 83:
      if (!
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6997; /* pred_umaxrvvm2si_scalar */

    case 84:
      if (!
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 7006; /* pred_umaxrvvm1si_scalar */

    case 85:
      if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 728 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 7015; /* pred_umaxrvvmf2si_scalar */

    case 86:
      if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 730 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 7024; /* pred_umaxv1qi_scalar */

    case 87:
      if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 731 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 7033; /* pred_umaxv2qi_scalar */

    case 88:
      if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 732 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 7042; /* pred_umaxv4qi_scalar */

    case 89:
      if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 733 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 7051; /* pred_umaxv8qi_scalar */

    case 90:
      if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 734 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 7060; /* pred_umaxv16qi_scalar */

    case 91:
      if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 735 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 7069; /* pred_umaxv32qi_scalar */

    case 92:
      if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 736 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 7078; /* pred_umaxv64qi_scalar */

    case 93:
      if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 737 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 7087; /* pred_umaxv128qi_scalar */

    case 94:
      if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 738 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 7096; /* pred_umaxv256qi_scalar */

    case 95:
      if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 739 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 7105; /* pred_umaxv512qi_scalar */

    case 96:
      if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 740 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 7114; /* pred_umaxv1024qi_scalar */

    case 97:
      if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 741 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 7123; /* pred_umaxv2048qi_scalar */

    case 98:
      if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 742 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 7132; /* pred_umaxv4096qi_scalar */

    case 99:
      if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 743 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 7141; /* pred_umaxv1hi_scalar */

    case 100:
      if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 744 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 7150; /* pred_umaxv2hi_scalar */

    case 101:
      if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 745 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 7159; /* pred_umaxv4hi_scalar */

    case 102:
      if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 746 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 7168; /* pred_umaxv8hi_scalar */

    case 103:
      if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 747 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 7177; /* pred_umaxv16hi_scalar */

    case 104:
      if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 748 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 7186; /* pred_umaxv32hi_scalar */

    case 105:
      if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 749 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 7195; /* pred_umaxv64hi_scalar */

    case 106:
      if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 750 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 7204; /* pred_umaxv128hi_scalar */

    case 107:
      if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 751 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 7213; /* pred_umaxv256hi_scalar */

    case 108:
      if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 752 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 7222; /* pred_umaxv512hi_scalar */

    case 109:
      if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 753 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 7231; /* pred_umaxv1024hi_scalar */

    case 110:
      if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 754 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 7240; /* pred_umaxv2048hi_scalar */

    case 111:
      if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 755 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 7249; /* pred_umaxv1si_scalar */

    case 112:
      if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 756 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 7258; /* pred_umaxv2si_scalar */

    case 113:
      if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 757 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 7267; /* pred_umaxv4si_scalar */

    case 114:
      if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 758 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 7276; /* pred_umaxv8si_scalar */

    case 115:
      if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 759 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 7285; /* pred_umaxv16si_scalar */

    case 116:
      if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 760 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 7294; /* pred_umaxv32si_scalar */

    case 117:
      if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 761 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 7303; /* pred_umaxv64si_scalar */

    case 118:
      if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 762 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 7312; /* pred_umaxv128si_scalar */

    case 119:
      if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 763 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 7321; /* pred_umaxv256si_scalar */

    case 120:
      if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 764 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 7330; /* pred_umaxv512si_scalar */

    case 121:
      if (!(
#line 2781 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 765 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 7339; /* pred_umaxv1024si_scalar */

    case 122:
      if (!(
#line 2879 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 774 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7672; /* *pred_umaxrvvm8di_scalar */

    case 123:
      if (!(
#line 2879 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 774 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7681; /* *pred_umaxrvvm4di_scalar */

    case 124:
      if (!(
#line 2879 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 775 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7690; /* *pred_umaxrvvm2di_scalar */

    case 125:
      if (!(
#line 2879 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 775 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7699; /* *pred_umaxrvvm1di_scalar */

    case 126:
      if (!(
#line 2879 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 777 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7708; /* *pred_umaxv1di_scalar */

    case 127:
      if (!(
#line 2879 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 778 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7717; /* *pred_umaxv2di_scalar */

    case 128:
      if (!(
#line 2879 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 779 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7726; /* *pred_umaxv4di_scalar */

    case 129:
      if (!(
#line 2879 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 780 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 7735; /* *pred_umaxv8di_scalar */

    case 130:
      if (!(
#line 2879 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 781 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 7744; /* *pred_umaxv16di_scalar */

    case 131:
      if (!(
#line 2879 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 782 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 7753; /* *pred_umaxv32di_scalar */

    case 132:
      if (!(
#line 2879 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 783 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 7762; /* *pred_umaxv64di_scalar */

    case 133:
      if (!(
#line 2879 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 784 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 7771; /* *pred_umaxv128di_scalar */

    case 134:
      if (!(
#line 2879 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 785 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 7780; /* *pred_umaxv256di_scalar */

    case 135:
      if (!(
#line 2879 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 786 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 7789; /* *pred_umaxv512di_scalar */

    case 136:
      if (!(
#line 2901 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 774 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7798; /* *pred_umaxrvvm8di_extended_scalar */

    case 137:
      if (!(
#line 2901 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 774 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7807; /* *pred_umaxrvvm4di_extended_scalar */

    case 138:
      if (!(
#line 2901 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 775 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7816; /* *pred_umaxrvvm2di_extended_scalar */

    case 139:
      if (!(
#line 2901 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 775 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7825; /* *pred_umaxrvvm1di_extended_scalar */

    case 140:
      if (!(
#line 2901 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 777 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7834; /* *pred_umaxv1di_extended_scalar */

    case 141:
      if (!(
#line 2901 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 778 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7843; /* *pred_umaxv2di_extended_scalar */

    case 142:
      if (!(
#line 2901 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 779 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7852; /* *pred_umaxv4di_extended_scalar */

    case 143:
      if (!(
#line 2901 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 780 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 7861; /* *pred_umaxv8di_extended_scalar */

    case 144:
      if (!(
#line 2901 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 781 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 7870; /* *pred_umaxv16di_extended_scalar */

    case 145:
      if (!(
#line 2901 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 782 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 7879; /* *pred_umaxv32di_extended_scalar */

    case 146:
      if (!(
#line 2901 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 783 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 7888; /* *pred_umaxv64di_extended_scalar */

    case 147:
      if (!(
#line 2901 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 784 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 7897; /* *pred_umaxv128di_extended_scalar */

    case 148:
      if (!(
#line 2901 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 785 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 7906; /* *pred_umaxv256di_extended_scalar */

    case 149:
      if (!(
#line 2901 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 786 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 7915; /* *pred_umaxv512di_extended_scalar */

    default:
      return -1;
    }
}

 int
recog_914 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern500 (x2))
    {
    case 0:
      if (!
#line 3939 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 9118; /* pred_zero_extendrvvm8hi_vf2 */

    case 1:
      if (!
#line 3939 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 9120; /* pred_zero_extendrvvm4hi_vf2 */

    case 2:
      if (!
#line 3939 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 9122; /* pred_zero_extendrvvm2hi_vf2 */

    case 3:
      if (!
#line 3939 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 9124; /* pred_zero_extendrvvm1hi_vf2 */

    case 4:
      if (!
#line 3939 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 9126; /* pred_zero_extendrvvmf2hi_vf2 */

    case 5:
      if (!(
#line 3939 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 946 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 9128; /* pred_zero_extendrvvmf4hi_vf2 */

    case 6:
      if (!
#line 3939 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 9130; /* pred_zero_extendrvvm8si_vf2 */

    case 7:
      if (!
#line 3959 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 9214; /* pred_zero_extendrvvm8si_vf4 */

    case 8:
      if (!
#line 3939 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 9132; /* pred_zero_extendrvvm4si_vf2 */

    case 9:
      if (!
#line 3959 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 9216; /* pred_zero_extendrvvm4si_vf4 */

    case 10:
      if (!
#line 3939 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 9134; /* pred_zero_extendrvvm2si_vf2 */

    case 11:
      if (!
#line 3959 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 9218; /* pred_zero_extendrvvm2si_vf4 */

    case 12:
      if (!
#line 3939 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 9136; /* pred_zero_extendrvvm1si_vf2 */

    case 13:
      if (!
#line 3959 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 9220; /* pred_zero_extendrvvm1si_vf4 */

    case 14:
      if (!(
#line 3939 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 948 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 9138; /* pred_zero_extendrvvmf2si_vf2 */

    case 15:
      if (!(
#line 3959 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1106 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
        return -1;
      return 9222; /* pred_zero_extendrvvmf2si_vf4 */

    case 16:
      if (!(
#line 3939 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 9140; /* pred_zero_extendrvvm8di_vf2 */

    case 17:
      if (!(
#line 3959 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1108 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 9224; /* pred_zero_extendrvvm8di_vf4 */

    case 18:
      if (!(
#line 3979 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1151 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 9274; /* pred_zero_extendrvvm8di_vf8 */

    case 19:
      if (!(
#line 3939 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 9142; /* pred_zero_extendrvvm4di_vf2 */

    case 20:
      if (!(
#line 3959 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1108 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 9226; /* pred_zero_extendrvvm4di_vf4 */

    case 21:
      if (!(
#line 3979 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1151 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 9276; /* pred_zero_extendrvvm4di_vf8 */

    case 22:
      if (!(
#line 3939 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 9144; /* pred_zero_extendrvvm2di_vf2 */

    case 23:
      if (!(
#line 3959 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1109 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 9228; /* pred_zero_extendrvvm2di_vf4 */

    case 24:
      if (!(
#line 3979 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1152 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 9278; /* pred_zero_extendrvvm2di_vf8 */

    case 25:
      if (!(
#line 3939 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 9146; /* pred_zero_extendrvvm1di_vf2 */

    case 26:
      if (!(
#line 3959 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1109 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 9230; /* pred_zero_extendrvvm1di_vf4 */

    case 27:
      if (!(
#line 3979 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1152 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 9280; /* pred_zero_extendrvvm1di_vf8 */

    case 28:
      if (!(
#line 3939 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 953 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 9148; /* pred_zero_extendv1hi_vf2 */

    case 29:
      if (!(
#line 3939 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 954 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 9150; /* pred_zero_extendv2hi_vf2 */

    case 30:
      if (!(
#line 3939 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 955 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 9152; /* pred_zero_extendv4hi_vf2 */

    case 31:
      if (!(
#line 3939 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 956 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 9154; /* pred_zero_extendv8hi_vf2 */

    case 32:
      if (!(
#line 3939 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 957 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 9156; /* pred_zero_extendv16hi_vf2 */

    case 33:
      if (!(
#line 3939 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 958 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 9158; /* pred_zero_extendv32hi_vf2 */

    case 34:
      if (!(
#line 3939 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 959 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 9160; /* pred_zero_extendv64hi_vf2 */

    case 35:
      if (!(
#line 3939 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 960 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 9162; /* pred_zero_extendv128hi_vf2 */

    case 36:
      if (!(
#line 3939 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 961 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 9164; /* pred_zero_extendv256hi_vf2 */

    case 37:
      if (!(
#line 3939 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 962 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 9166; /* pred_zero_extendv512hi_vf2 */

    case 38:
      if (!(
#line 3939 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 963 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 9168; /* pred_zero_extendv1024hi_vf2 */

    case 39:
      if (!(
#line 3939 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 964 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 9170; /* pred_zero_extendv2048hi_vf2 */

    case 40:
      if (!(
#line 3939 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 965 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 9172; /* pred_zero_extendv1si_vf2 */

    case 41:
      if (!(
#line 3959 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1111 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 9232; /* pred_zero_extendv1si_vf4 */

    case 42:
      if (!(
#line 3939 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 966 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 9174; /* pred_zero_extendv2si_vf2 */

    case 43:
      if (!(
#line 3959 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1112 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 9234; /* pred_zero_extendv2si_vf4 */

    case 44:
      if (!(
#line 3939 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 967 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 9176; /* pred_zero_extendv4si_vf2 */

    case 45:
      if (!(
#line 3959 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1113 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 9236; /* pred_zero_extendv4si_vf4 */

    case 46:
      if (!(
#line 3939 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 968 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 9178; /* pred_zero_extendv8si_vf2 */

    case 47:
      if (!(
#line 3959 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1114 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 9238; /* pred_zero_extendv8si_vf4 */

    case 48:
      if (!(
#line 3939 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 969 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 9180; /* pred_zero_extendv16si_vf2 */

    case 49:
      if (!(
#line 3959 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1115 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 9240; /* pred_zero_extendv16si_vf4 */

    case 50:
      if (!(
#line 3939 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 970 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 9182; /* pred_zero_extendv32si_vf2 */

    case 51:
      if (!(
#line 3959 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1116 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 9242; /* pred_zero_extendv32si_vf4 */

    case 52:
      if (!(
#line 3939 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 971 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 9184; /* pred_zero_extendv64si_vf2 */

    case 53:
      if (!(
#line 3959 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1117 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 9244; /* pred_zero_extendv64si_vf4 */

    case 54:
      if (!(
#line 3939 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 972 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 9186; /* pred_zero_extendv128si_vf2 */

    case 55:
      if (!(
#line 3959 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1118 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 9246; /* pred_zero_extendv128si_vf4 */

    case 56:
      if (!(
#line 3939 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 973 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 9188; /* pred_zero_extendv256si_vf2 */

    case 57:
      if (!(
#line 3959 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1119 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 9248; /* pred_zero_extendv256si_vf4 */

    case 58:
      if (!(
#line 3939 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 974 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 9190; /* pred_zero_extendv512si_vf2 */

    case 59:
      if (!(
#line 3959 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1120 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 9250; /* pred_zero_extendv512si_vf4 */

    case 60:
      if (!(
#line 3939 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 975 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 9192; /* pred_zero_extendv1024si_vf2 */

    case 61:
      if (!(
#line 3959 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1121 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 9252; /* pred_zero_extendv1024si_vf4 */

    case 62:
      if (!(
#line 3939 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 976 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 9194; /* pred_zero_extendv1di_vf2 */

    case 63:
      if (!(
#line 3959 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1122 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 9254; /* pred_zero_extendv1di_vf4 */

    case 64:
      if (!(
#line 3979 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1154 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 9282; /* pred_zero_extendv1di_vf8 */

    case 65:
      if (!(
#line 3939 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 977 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 9196; /* pred_zero_extendv2di_vf2 */

    case 66:
      if (!(
#line 3959 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1123 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 9256; /* pred_zero_extendv2di_vf4 */

    case 67:
      if (!(
#line 3979 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1155 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 9284; /* pred_zero_extendv2di_vf8 */

    case 68:
      if (!(
#line 3939 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 978 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 9198; /* pred_zero_extendv4di_vf2 */

    case 69:
      if (!(
#line 3959 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1124 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 9258; /* pred_zero_extendv4di_vf4 */

    case 70:
      if (!(
#line 3979 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1156 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 9286; /* pred_zero_extendv4di_vf8 */

    case 71:
      if (!(
#line 3939 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 979 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 9200; /* pred_zero_extendv8di_vf2 */

    case 72:
      if (!(
#line 3959 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1125 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 9260; /* pred_zero_extendv8di_vf4 */

    case 73:
      if (!(
#line 3979 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1157 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 9288; /* pred_zero_extendv8di_vf8 */

    case 74:
      if (!(
#line 3939 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 980 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 9202; /* pred_zero_extendv16di_vf2 */

    case 75:
      if (!(
#line 3959 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1126 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 9262; /* pred_zero_extendv16di_vf4 */

    case 76:
      if (!(
#line 3979 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1158 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 9290; /* pred_zero_extendv16di_vf8 */

    case 77:
      if (!(
#line 3939 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 981 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 9204; /* pred_zero_extendv32di_vf2 */

    case 78:
      if (!(
#line 3959 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1127 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 9264; /* pred_zero_extendv32di_vf4 */

    case 79:
      if (!(
#line 3979 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1159 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 9292; /* pred_zero_extendv32di_vf8 */

    case 80:
      if (!(
#line 3939 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 982 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 9206; /* pred_zero_extendv64di_vf2 */

    case 81:
      if (!(
#line 3959 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1128 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 9266; /* pred_zero_extendv64di_vf4 */

    case 82:
      if (!(
#line 3979 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1160 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 9294; /* pred_zero_extendv64di_vf8 */

    case 83:
      if (!(
#line 3939 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 983 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 9208; /* pred_zero_extendv128di_vf2 */

    case 84:
      if (!(
#line 3959 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1129 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 9268; /* pred_zero_extendv128di_vf4 */

    case 85:
      if (!(
#line 3979 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1161 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 9296; /* pred_zero_extendv128di_vf8 */

    case 86:
      if (!(
#line 3939 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 984 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 9210; /* pred_zero_extendv256di_vf2 */

    case 87:
      if (!(
#line 3959 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1130 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 9270; /* pred_zero_extendv256di_vf4 */

    case 88:
      if (!(
#line 3979 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1162 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 9298; /* pred_zero_extendv256di_vf8 */

    case 89:
      if (!(
#line 3939 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 985 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 9212; /* pred_zero_extendv512di_vf2 */

    case 90:
      if (!(
#line 3959 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1131 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 9272; /* pred_zero_extendv512di_vf4 */

    case 91:
      if (!(
#line 3979 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1163 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 9300; /* pred_zero_extendv512di_vf8 */

    default:
      return -1;
    }
}

 int
recog_924 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern469 (x2))
    {
    case 0:
      if (!
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8QImode)
	|| register_operand (operands[3], RVVM8QImode)))))
        return -1;
      return 1252; /* *pred_mov_widthburvvm8qi */

    case 1:
      if (!
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4QImode)
	|| register_operand (operands[3], RVVM4QImode)))))
        return -1;
      return 1258; /* *pred_mov_widthburvvm4qi */

    case 2:
      if (!
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2QImode)
	|| register_operand (operands[3], RVVM2QImode)))))
        return -1;
      return 1264; /* *pred_mov_widthburvvm2qi */

    case 3:
      if (!
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1QImode)
	|| register_operand (operands[3], RVVM1QImode)))))
        return -1;
      return 1270; /* *pred_mov_widthburvvm1qi */

    case 4:
      if (!
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8HImode)
	|| register_operand (operands[3], RVVM8HImode)))))
        return -1;
      return 1276; /* *pred_mov_widthburvvm8hi */

    case 5:
      if (!
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4HImode)
	|| register_operand (operands[3], RVVM4HImode)))))
        return -1;
      return 1282; /* *pred_mov_widthburvvm4hi */

    case 6:
      if (!
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2HImode)
	|| register_operand (operands[3], RVVM2HImode)))))
        return -1;
      return 1288; /* *pred_mov_widthburvvm2hi */

    case 7:
      if (!
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1HImode)
	|| register_operand (operands[3], RVVM1HImode)))))
        return -1;
      return 1294; /* *pred_mov_widthburvvm1hi */

    case 8:
      if (!
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8SImode)
	|| register_operand (operands[3], RVVM8SImode)))))
        return -1;
      return 1300; /* *pred_mov_widthburvvm8si */

    case 9:
      if (!
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4SImode)
	|| register_operand (operands[3], RVVM4SImode)))))
        return -1;
      return 1306; /* *pred_mov_widthburvvm4si */

    case 10:
      if (!
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2SImode)
	|| register_operand (operands[3], RVVM2SImode)))))
        return -1;
      return 1312; /* *pred_mov_widthburvvm2si */

    case 11:
      if (!
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1SImode)
	|| register_operand (operands[3], RVVM1SImode)))))
        return -1;
      return 1318; /* *pred_mov_widthburvvm1si */

    case 12:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8DImode)
	|| register_operand (operands[3], RVVM8DImode)))) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1324; /* *pred_mov_widthburvvm8di */

    case 13:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4DImode)
	|| register_operand (operands[3], RVVM4DImode)))) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1330; /* *pred_mov_widthburvvm4di */

    case 14:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2DImode)
	|| register_operand (operands[3], RVVM2DImode)))) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1336; /* *pred_mov_widthburvvm2di */

    case 15:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1DImode)
	|| register_operand (operands[3], RVVM1DImode)))) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1342; /* *pred_mov_widthburvvm1di */

    case 16:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF2QImode)
	|| register_operand (operands[3], RVVMF2QImode)))) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 1348; /* *pred_mov_widthburvvmf2qi */

    case 17:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF4QImode)
	|| register_operand (operands[3], RVVMF4QImode)))) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 1354; /* *pred_mov_widthburvvmf4qi */

    case 18:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF8QImode)
	|| register_operand (operands[3], RVVMF8QImode)))) && (
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 1360; /* *pred_mov_widthburvvmf8qi */

    case 19:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF2HImode)
	|| register_operand (operands[3], RVVMF2HImode)))) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 1366; /* *pred_mov_widthburvvmf2hi */

    case 20:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF4HImode)
	|| register_operand (operands[3], RVVMF4HImode)))) && (
#line 132 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 1372; /* *pred_mov_widthburvvmf4hi */

    case 21:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF2SImode)
	|| register_operand (operands[3], RVVMF2SImode)))) && (
#line 133 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 1378; /* *pred_mov_widthburvvmf2si */

    case 22:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8BFmode)
	|| register_operand (operands[3], RVVM8BFmode)))) && 
#line 167 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 1384; /* *pred_mov_widthburvvm8bf */

    case 23:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4BFmode)
	|| register_operand (operands[3], RVVM4BFmode)))) && 
#line 168 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 1390; /* *pred_mov_widthburvvm4bf */

    case 24:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2BFmode)
	|| register_operand (operands[3], RVVM2BFmode)))) && 
#line 169 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 1396; /* *pred_mov_widthburvvm2bf */

    case 25:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1BFmode)
	|| register_operand (operands[3], RVVM1BFmode)))) && 
#line 170 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 1402; /* *pred_mov_widthburvvm1bf */

    case 26:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF2BFmode)
	|| register_operand (operands[3], RVVMF2BFmode)))) && 
#line 171 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 1408; /* *pred_mov_widthburvvmf2bf */

    case 27:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF4BFmode)
	|| register_operand (operands[3], RVVMF4BFmode)))) && 
#line 172 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 1414; /* *pred_mov_widthburvvmf4bf */

    case 28:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8HFmode)
	|| register_operand (operands[3], RVVM8HFmode)))) && 
#line 176 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1420; /* *pred_mov_widthburvvm8hf */

    case 29:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4HFmode)
	|| register_operand (operands[3], RVVM4HFmode)))) && 
#line 176 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1426; /* *pred_mov_widthburvvm4hf */

    case 30:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2HFmode)
	|| register_operand (operands[3], RVVM2HFmode)))) && 
#line 176 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1432; /* *pred_mov_widthburvvm2hf */

    case 31:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1HFmode)
	|| register_operand (operands[3], RVVM1HFmode)))) && 
#line 177 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1438; /* *pred_mov_widthburvvm1hf */

    case 32:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF2HFmode)
	|| register_operand (operands[3], RVVMF2HFmode)))) && 
#line 177 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1444; /* *pred_mov_widthburvvmf2hf */

    case 33:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF4HFmode)
	|| register_operand (operands[3], RVVMF4HFmode)))) && 
#line 178 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 1450; /* *pred_mov_widthburvvmf4hf */

    case 34:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8SFmode)
	|| register_operand (operands[3], RVVM8SFmode)))) && 
#line 180 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1456; /* *pred_mov_widthburvvm8sf */

    case 35:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4SFmode)
	|| register_operand (operands[3], RVVM4SFmode)))) && 
#line 180 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1462; /* *pred_mov_widthburvvm4sf */

    case 36:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2SFmode)
	|| register_operand (operands[3], RVVM2SFmode)))) && 
#line 180 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1468; /* *pred_mov_widthburvvm2sf */

    case 37:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1SFmode)
	|| register_operand (operands[3], RVVM1SFmode)))) && 
#line 181 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1474; /* *pred_mov_widthburvvm1sf */

    case 38:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF2SFmode)
	|| register_operand (operands[3], RVVMF2SFmode)))) && 
#line 181 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 1480; /* *pred_mov_widthburvvmf2sf */

    case 39:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8DFmode)
	|| register_operand (operands[3], RVVM8DFmode)))) && 
#line 183 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 1486; /* *pred_mov_widthburvvm8df */

    case 40:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4DFmode)
	|| register_operand (operands[3], RVVM4DFmode)))) && 
#line 183 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 1492; /* *pred_mov_widthburvvm4df */

    case 41:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2DFmode)
	|| register_operand (operands[3], RVVM2DFmode)))) && 
#line 184 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 1498; /* *pred_mov_widthburvvm2df */

    case 42:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1DFmode)
	|| register_operand (operands[3], RVVM1DFmode)))) && 
#line 184 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 1504; /* *pred_mov_widthburvvm1df */

    case 43:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1QImode)
	|| register_operand (operands[3], V1QImode)))) && 
#line 188 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 1510; /* *pred_mov_widthbuv1qi */

    case 44:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2QImode)
	|| register_operand (operands[3], V2QImode)))) && 
#line 189 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 1516; /* *pred_mov_widthbuv2qi */

    case 45:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4QImode)
	|| register_operand (operands[3], V4QImode)))) && 
#line 190 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 1522; /* *pred_mov_widthbuv4qi */

    case 46:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V8QImode)
	|| register_operand (operands[3], V8QImode)))) && 
#line 191 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 1528; /* *pred_mov_widthbuv8qi */

    case 47:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V16QImode)
	|| register_operand (operands[3], V16QImode)))) && 
#line 192 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 1534; /* *pred_mov_widthbuv16qi */

    case 48:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V32QImode)
	|| register_operand (operands[3], V32QImode)))) && 
#line 193 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 1540; /* *pred_mov_widthbuv32qi */

    case 49:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V64QImode)
	|| register_operand (operands[3], V64QImode)))) && 
#line 194 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 1546; /* *pred_mov_widthbuv64qi */

    case 50:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V128QImode)
	|| register_operand (operands[3], V128QImode)))) && 
#line 195 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 1552; /* *pred_mov_widthbuv128qi */

    case 51:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V256QImode)
	|| register_operand (operands[3], V256QImode)))) && 
#line 196 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 1558; /* *pred_mov_widthbuv256qi */

    case 52:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V512QImode)
	|| register_operand (operands[3], V512QImode)))) && 
#line 197 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 1564; /* *pred_mov_widthbuv512qi */

    case 53:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1024QImode)
	|| register_operand (operands[3], V1024QImode)))) && 
#line 198 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 1570; /* *pred_mov_widthbuv1024qi */

    case 54:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2048QImode)
	|| register_operand (operands[3], V2048QImode)))) && 
#line 199 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 1576; /* *pred_mov_widthbuv2048qi */

    case 55:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4096QImode)
	|| register_operand (operands[3], V4096QImode)))) && 
#line 200 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 1582; /* *pred_mov_widthbuv4096qi */

    case 56:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1HImode)
	|| register_operand (operands[3], V1HImode)))) && 
#line 201 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 1588; /* *pred_mov_widthbuv1hi */

    case 57:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2HImode)
	|| register_operand (operands[3], V2HImode)))) && 
#line 202 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 1594; /* *pred_mov_widthbuv2hi */

    case 58:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4HImode)
	|| register_operand (operands[3], V4HImode)))) && 
#line 203 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 1600; /* *pred_mov_widthbuv4hi */

    case 59:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V8HImode)
	|| register_operand (operands[3], V8HImode)))) && 
#line 204 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 1606; /* *pred_mov_widthbuv8hi */

    case 60:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V16HImode)
	|| register_operand (operands[3], V16HImode)))) && 
#line 205 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 1612; /* *pred_mov_widthbuv16hi */

    case 61:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V32HImode)
	|| register_operand (operands[3], V32HImode)))) && 
#line 206 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 1618; /* *pred_mov_widthbuv32hi */

    case 62:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V64HImode)
	|| register_operand (operands[3], V64HImode)))) && 
#line 207 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 1624; /* *pred_mov_widthbuv64hi */

    case 63:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V128HImode)
	|| register_operand (operands[3], V128HImode)))) && 
#line 208 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 1630; /* *pred_mov_widthbuv128hi */

    case 64:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V256HImode)
	|| register_operand (operands[3], V256HImode)))) && 
#line 209 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 1636; /* *pred_mov_widthbuv256hi */

    case 65:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V512HImode)
	|| register_operand (operands[3], V512HImode)))) && 
#line 210 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 1642; /* *pred_mov_widthbuv512hi */

    case 66:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1024HImode)
	|| register_operand (operands[3], V1024HImode)))) && 
#line 211 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 1648; /* *pred_mov_widthbuv1024hi */

    case 67:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2048HImode)
	|| register_operand (operands[3], V2048HImode)))) && 
#line 212 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 1654; /* *pred_mov_widthbuv2048hi */

    case 68:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1SImode)
	|| register_operand (operands[3], V1SImode)))) && 
#line 213 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 1660; /* *pred_mov_widthbuv1si */

    case 69:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2SImode)
	|| register_operand (operands[3], V2SImode)))) && 
#line 214 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 1666; /* *pred_mov_widthbuv2si */

    case 70:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4SImode)
	|| register_operand (operands[3], V4SImode)))) && 
#line 215 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 1672; /* *pred_mov_widthbuv4si */

    case 71:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V8SImode)
	|| register_operand (operands[3], V8SImode)))) && 
#line 216 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 1678; /* *pred_mov_widthbuv8si */

    case 72:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V16SImode)
	|| register_operand (operands[3], V16SImode)))) && 
#line 217 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 1684; /* *pred_mov_widthbuv16si */

    case 73:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V32SImode)
	|| register_operand (operands[3], V32SImode)))) && 
#line 218 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 1690; /* *pred_mov_widthbuv32si */

    case 74:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V64SImode)
	|| register_operand (operands[3], V64SImode)))) && 
#line 219 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 1696; /* *pred_mov_widthbuv64si */

    case 75:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V128SImode)
	|| register_operand (operands[3], V128SImode)))) && 
#line 220 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 1702; /* *pred_mov_widthbuv128si */

    case 76:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V256SImode)
	|| register_operand (operands[3], V256SImode)))) && 
#line 221 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 1708; /* *pred_mov_widthbuv256si */

    case 77:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V512SImode)
	|| register_operand (operands[3], V512SImode)))) && 
#line 222 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 1714; /* *pred_mov_widthbuv512si */

    case 78:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1024SImode)
	|| register_operand (operands[3], V1024SImode)))) && 
#line 223 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 1720; /* *pred_mov_widthbuv1024si */

    case 79:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1DImode)
	|| register_operand (operands[3], V1DImode)))) && 
#line 224 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1726; /* *pred_mov_widthbuv1di */

    case 80:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2DImode)
	|| register_operand (operands[3], V2DImode)))) && 
#line 225 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1732; /* *pred_mov_widthbuv2di */

    case 81:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4DImode)
	|| register_operand (operands[3], V4DImode)))) && 
#line 226 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1738; /* *pred_mov_widthbuv4di */

    case 82:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V8DImode)
	|| register_operand (operands[3], V8DImode)))) && 
#line 227 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 1744; /* *pred_mov_widthbuv8di */

    case 83:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V16DImode)
	|| register_operand (operands[3], V16DImode)))) && 
#line 228 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 1750; /* *pred_mov_widthbuv16di */

    case 84:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V32DImode)
	|| register_operand (operands[3], V32DImode)))) && 
#line 229 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 1756; /* *pred_mov_widthbuv32di */

    case 85:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V64DImode)
	|| register_operand (operands[3], V64DImode)))) && 
#line 230 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 1762; /* *pred_mov_widthbuv64di */

    case 86:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V128DImode)
	|| register_operand (operands[3], V128DImode)))) && 
#line 231 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 1768; /* *pred_mov_widthbuv128di */

    case 87:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V256DImode)
	|| register_operand (operands[3], V256DImode)))) && 
#line 232 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 1774; /* *pred_mov_widthbuv256di */

    case 88:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V512DImode)
	|| register_operand (operands[3], V512DImode)))) && 
#line 233 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 1780; /* *pred_mov_widthbuv512di */

    case 89:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1HFmode)
	|| register_operand (operands[3], V1HFmode)))) && 
#line 272 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1786; /* *pred_mov_widthbuv1hf */

    case 90:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2HFmode)
	|| register_operand (operands[3], V2HFmode)))) && 
#line 273 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1792; /* *pred_mov_widthbuv2hf */

    case 91:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4HFmode)
	|| register_operand (operands[3], V4HFmode)))) && 
#line 274 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1798; /* *pred_mov_widthbuv4hf */

    case 92:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V8HFmode)
	|| register_operand (operands[3], V8HFmode)))) && 
#line 275 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1804; /* *pred_mov_widthbuv8hf */

    case 93:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V16HFmode)
	|| register_operand (operands[3], V16HFmode)))) && 
#line 276 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1810; /* *pred_mov_widthbuv16hf */

    case 94:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V32HFmode)
	|| register_operand (operands[3], V32HFmode)))) && 
#line 277 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 1816; /* *pred_mov_widthbuv32hf */

    case 95:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V64HFmode)
	|| register_operand (operands[3], V64HFmode)))) && 
#line 278 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 1822; /* *pred_mov_widthbuv64hf */

    case 96:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V128HFmode)
	|| register_operand (operands[3], V128HFmode)))) && 
#line 279 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 1828; /* *pred_mov_widthbuv128hf */

    case 97:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V256HFmode)
	|| register_operand (operands[3], V256HFmode)))) && 
#line 280 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 1834; /* *pred_mov_widthbuv256hf */

    case 98:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V512HFmode)
	|| register_operand (operands[3], V512HFmode)))) && 
#line 281 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 1840; /* *pred_mov_widthbuv512hf */

    case 99:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1024HFmode)
	|| register_operand (operands[3], V1024HFmode)))) && 
#line 282 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 1846; /* *pred_mov_widthbuv1024hf */

    case 100:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2048HFmode)
	|| register_operand (operands[3], V2048HFmode)))) && 
#line 283 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 1852; /* *pred_mov_widthbuv2048hf */

    case 101:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1SFmode)
	|| register_operand (operands[3], V1SFmode)))) && 
#line 284 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1858; /* *pred_mov_widthbuv1sf */

    case 102:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2SFmode)
	|| register_operand (operands[3], V2SFmode)))) && 
#line 285 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1864; /* *pred_mov_widthbuv2sf */

    case 103:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4SFmode)
	|| register_operand (operands[3], V4SFmode)))) && 
#line 286 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1870; /* *pred_mov_widthbuv4sf */

    case 104:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V8SFmode)
	|| register_operand (operands[3], V8SFmode)))) && 
#line 287 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1876; /* *pred_mov_widthbuv8sf */

    case 105:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V16SFmode)
	|| register_operand (operands[3], V16SFmode)))) && 
#line 288 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 1882; /* *pred_mov_widthbuv16sf */

    case 106:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V32SFmode)
	|| register_operand (operands[3], V32SFmode)))) && 
#line 289 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 1888; /* *pred_mov_widthbuv32sf */

    case 107:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V64SFmode)
	|| register_operand (operands[3], V64SFmode)))) && 
#line 290 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 1894; /* *pred_mov_widthbuv64sf */

    case 108:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V128SFmode)
	|| register_operand (operands[3], V128SFmode)))) && 
#line 291 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 1900; /* *pred_mov_widthbuv128sf */

    case 109:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V256SFmode)
	|| register_operand (operands[3], V256SFmode)))) && 
#line 292 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 1906; /* *pred_mov_widthbuv256sf */

    case 110:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V512SFmode)
	|| register_operand (operands[3], V512SFmode)))) && 
#line 293 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 1912; /* *pred_mov_widthbuv512sf */

    case 111:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1024SFmode)
	|| register_operand (operands[3], V1024SFmode)))) && 
#line 294 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 1918; /* *pred_mov_widthbuv1024sf */

    case 112:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1DFmode)
	|| register_operand (operands[3], V1DFmode)))) && 
#line 295 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 1924; /* *pred_mov_widthbuv1df */

    case 113:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2DFmode)
	|| register_operand (operands[3], V2DFmode)))) && 
#line 296 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 1930; /* *pred_mov_widthbuv2df */

    case 114:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4DFmode)
	|| register_operand (operands[3], V4DFmode)))) && 
#line 297 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 1936; /* *pred_mov_widthbuv4df */

    case 115:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V8DFmode)
	|| register_operand (operands[3], V8DFmode)))) && 
#line 298 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 1942; /* *pred_mov_widthbuv8df */

    case 116:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V16DFmode)
	|| register_operand (operands[3], V16DFmode)))) && 
#line 299 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 1948; /* *pred_mov_widthbuv16df */

    case 117:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V32DFmode)
	|| register_operand (operands[3], V32DFmode)))) && 
#line 300 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 1954; /* *pred_mov_widthbuv32df */

    case 118:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V64DFmode)
	|| register_operand (operands[3], V64DFmode)))) && 
#line 301 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 1960; /* *pred_mov_widthbuv64df */

    case 119:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V128DFmode)
	|| register_operand (operands[3], V128DFmode)))) && 
#line 302 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 1966; /* *pred_mov_widthbuv128df */

    case 120:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V256DFmode)
	|| register_operand (operands[3], V256DFmode)))) && 
#line 303 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 1972; /* *pred_mov_widthbuv256df */

    case 121:
      if (!(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V512DFmode)
	|| register_operand (operands[3], V512DFmode)))) && 
#line 304 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 1978; /* *pred_mov_widthbuv512df */

    default:
      return -1;
    }
}

 int
recog_944 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_RVVM4SFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_RVVM4SFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_RVVM4SFmode)
      || !(
#line 6492 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 15268; /* *pred_mul_addrvvm4sf_undef */
}

 int
recog_949 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_RVVM4DFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_RVVM4DFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_RVVM4DFmode)
      || !(
#line 6492 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
    return -1;
  return 15278; /* *pred_mul_addrvvm4df_undef */
}

 int
recog_954 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_V4HFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_V4HFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_V4HFmode)
      || !(
#line 6492 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 238 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
    return -1;
  return 15288; /* *pred_mul_addv4hf_undef */
}

 int
recog_959 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_V128HFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_V128HFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_V128HFmode)
      || !(
#line 6492 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 243 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
    return -1;
  return 15298; /* *pred_mul_addv128hf_undef */
}

 int
recog_964 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_V1SFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_V1SFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_V1SFmode)
      || !(
#line 6492 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 248 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 15308; /* *pred_mul_addv1sf_undef */
}

 int
recog_969 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_V32SFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_V32SFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_V32SFmode)
      || !(
#line 6492 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 253 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
    return -1;
  return 15318; /* *pred_mul_addv32sf_undef */
}

 int
recog_974 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_V1024SFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_V1024SFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_V1024SFmode)
      || !(
#line 6492 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 258 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
    return -1;
  return 15328; /* *pred_mul_addv1024sf_undef */
}

 int
recog_979 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_V16DFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_V16DFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_V16DFmode)
      || !(
#line 6492 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 263 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
    return -1;
  return 15338; /* *pred_mul_addv16df_undef */
}

 int
recog_984 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_V512DFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_V512DFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_V512DFmode)
      || !(
#line 6492 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 268 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
    return -1;
  return 15348; /* *pred_mul_addv512df_undef */
}

 int
recog_989 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern726 (x2, 
E_RVVM8SFmode, 
E_RVVMF4BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  switch (GET_MODE (x6))
    {
    case E_RVVM4HFmode:
      if (!register_operand (operands[3], E_HFmode)
          || !register_operand (operands[4], E_RVVM4HFmode)
          || !(
#line 7195 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1023 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16763; /* pred_widen_mul_addrvvm8sf_scalar */

    case E_RVVM4BFmode:
      if (!register_operand (operands[3], E_BFmode)
          || !register_operand (operands[4], E_RVVM4BFmode)
          || !(
#line 130 "../../../gcc/config/riscv/vector-bfloat16.md"
(TARGET_ZVFBFWMA) && 
#line 21 "../../../gcc/config/riscv/vector-bfloat16.md"
(TARGET_VECTOR_ELEN_BF_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 33651; /* pred_widen_bf16_mul_rvvm8sf_scalar */

    default:
      return -1;
    }
}

 int
recog_994 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern726 (x2, 
E_RVVM8SFmode, 
E_RVVMF4BImode) != 0)
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_RVVM4HFmode:
      if (!register_operand (operands[3], E_RVVM4HFmode)
          || !register_operand (operands[4], E_RVVM4HFmode)
          || !(
#line 7166 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1023 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16703; /* pred_widen_mul_addrvvm8sf */

    case E_RVVM4BFmode:
      if (!register_operand (operands[3], E_RVVM4BFmode)
          || !register_operand (operands[4], E_RVVM4BFmode)
          || !(
#line 101 "../../../gcc/config/riscv/vector-bfloat16.md"
(TARGET_ZVFBFWMA) && 
#line 21 "../../../gcc/config/riscv/vector-bfloat16.md"
(TARGET_VECTOR_ELEN_BF_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 33646; /* pred_widen_bf16_mul_rvvm8sf */

    default:
      return -1;
    }
}

 int
recog_999 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_980 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V32DFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_V32DFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6522 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 264 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
    return 15436; /* *pred_maddv32df */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6555 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 264 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
    return -1;
  return 15532; /* *pred_maccv32df */
}

 int
recog_1004 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_975 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V1DFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_V1DFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6522 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 259 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
    return 15426; /* *pred_maddv1df */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6555 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 259 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
    return -1;
  return 15522; /* *pred_maccv1df */
}

 int
recog_1009 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_970 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V64SFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_V64SFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6522 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 254 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
    return 15416; /* *pred_maddv64sf */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6555 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 254 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
    return -1;
  return 15512; /* *pred_maccv64sf */
}

 int
recog_1014 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_965 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V2SFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_V2SFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6522 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 249 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
    return 15406; /* *pred_maddv2sf */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6555 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 249 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 15502; /* *pred_maccv2sf */
}

 int
recog_1019 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_960 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V256HFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_V256HFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6522 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 244 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
    return 15396; /* *pred_maddv256hf */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6555 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 244 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
    return -1;
  return 15492; /* *pred_maccv256hf */
}

 int
recog_1024 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_955 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V8HFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_V8HFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6522 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 239 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
    return 15386; /* *pred_maddv8hf */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6555 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 239 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
    return -1;
  return 15482; /* *pred_maccv8hf */
}

 int
recog_1030 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_949 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_RVVM4DFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_RVVM4DFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6522 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
    return 15374; /* *pred_maddrvvm4df */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6555 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
    return -1;
  return 15470; /* *pred_maccrvvm4df */
}

 int
recog_1036 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_943 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_RVVM8SFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_RVVM8SFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6522 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
    return 15362; /* *pred_maddrvvm8sf */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6555 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 15458; /* *pred_maccrvvm8sf */
}

 int
recog_1042 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_937 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_RVVM8HFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_RVVM8HFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6522 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
    return 15350; /* *pred_maddrvvm8hf */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6555 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
    return -1;
  return 15446; /* *pred_maccrvvm8hf */
}

 int
recog_1050 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_RVVM4SFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_RVVM4SFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_RVVM4SFmode)
      || !(
#line 6705 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 15748; /* *pred_mul_neg_addrvvm4sf_undef */
}

 int
recog_1058 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V1HFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_V1HFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_V1HFmode)
      || !(
#line 6705 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 236 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
    return -1;
  return 15764; /* *pred_mul_neg_addv1hf_undef */
}

 int
recog_1067 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V512HFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_V512HFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_V512HFmode)
      || !(
#line 6705 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 245 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
    return -1;
  return 15782; /* *pred_mul_neg_addv512hf_undef */
}

 int
recog_1077 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V128SFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_V128SFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_V128SFmode)
      || !(
#line 6705 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 255 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
    return -1;
  return 15802; /* *pred_mul_neg_addv128sf_undef */
}

 int
recog_1087 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V64DFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_V64DFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_V64DFmode)
      || !(
#line 6705 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 265 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
    return -1;
  return 15822; /* *pred_mul_neg_addv64df_undef */
}

 int
recog_1097 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1084 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_V8DFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_V8DFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6736 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 262 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
    return 15912; /* *pred_nmsubv8df */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6770 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 262 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
    return -1;
  return 16008; /* *pred_nmsacv8df */
}

 int
recog_1107 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1074 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_V16SFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_V16SFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6736 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 252 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
    return 15892; /* *pred_nmsubv16sf */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6770 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 252 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
    return -1;
  return 15988; /* *pred_nmsacv16sf */
}

 int
recog_1117 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1064 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_V64HFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_V64HFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6736 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 242 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
    return 15872; /* *pred_nmsubv64hf */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6770 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 242 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
    return -1;
  return 15968; /* *pred_nmsacv64hf */
}

 int
recog_1127 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1054 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_RVVM8DFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_RVVM8DFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6736 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
    return 15852; /* *pred_nmsubrvvm8df */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6770 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
    return -1;
  return 15948; /* *pred_nmsacrvvm8df */
}

 int
recog_1137 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1044 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_RVVM4HFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_RVVM4HFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6736 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
    return 15832; /* *pred_nmsubrvvm4hf */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6770 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
    return -1;
  return 15928; /* *pred_nmsacrvvm4hf */
}

 int
recog_1147 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_RVVMF4HFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_RVVMF4HFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_RVVMF4HFmode)
      || !(
#line 6492 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 157 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
    return -1;
  return 15265; /* *pred_mul_subrvvmf4hf_undef */
}

 int
recog_1154 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_RVVM4DFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_RVVM4DFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_RVVM4DFmode)
      || !(
#line 6492 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
    return -1;
  return 15279; /* *pred_mul_subrvvm4df_undef */
}

 int
recog_1161 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_V16HFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_V16HFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_V16HFmode)
      || !(
#line 6492 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 240 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
    return -1;
  return 15293; /* *pred_mul_subv16hf_undef */
}

 int
recog_1168 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_V2048HFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_V2048HFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_V2048HFmode)
      || !(
#line 6492 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 247 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
    return -1;
  return 15307; /* *pred_mul_subv2048hf_undef */
}

 int
recog_1175 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_V64SFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_V64SFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_V64SFmode)
      || !(
#line 6492 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 254 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
    return -1;
  return 15321; /* *pred_mul_subv64sf_undef */
}

 int
recog_1182 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_V4DFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_V4DFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_V4DFmode)
      || !(
#line 6492 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 261 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
    return -1;
  return 15335; /* *pred_mul_subv4df_undef */
}

 int
recog_1189 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_V512DFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_V512DFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_V512DFmode)
      || !(
#line 6492 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 268 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
    return -1;
  return 15349; /* *pred_mul_subv512df_undef */
}

 int
recog_1196 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_1183 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V8DFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_V8DFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6522 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 262 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
    return 15433; /* *pred_msubv8df */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6555 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 262 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
    return -1;
  return 15529; /* *pred_msacv8df */
}

 int
recog_1203 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_1176 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V128SFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_V128SFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6522 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 255 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
    return 15419; /* *pred_msubv128sf */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6555 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 255 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
    return -1;
  return 15515; /* *pred_msacv128sf */
}

 int
recog_1210 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_1169 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V1SFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_V1SFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6522 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 248 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
    return 15405; /* *pred_msubv1sf */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6555 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 248 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 15501; /* *pred_msacv1sf */
}

 int
recog_1217 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_1162 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V32HFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_V32HFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6522 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 241 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
    return 15391; /* *pred_msubv32hf */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6555 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 241 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
    return -1;
  return 15487; /* *pred_msacv32hf */
}

 int
recog_1224 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_1155 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_RVVM2DFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_RVVM2DFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6522 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
    return 15377; /* *pred_msubrvvm2df */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6555 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
    return -1;
  return 15473; /* *pred_msacrvvm2df */
}

 int
recog_1231 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_1148 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_RVVM8SFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_RVVM8SFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6522 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
    return 15363; /* *pred_msubrvvm8sf */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6555 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 15459; /* *pred_msacrvvm8sf */
}

 int
recog_1238 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_RVVM8HFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_RVVM8HFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_RVVM8HFmode)
      || !(
#line 6705 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
    return -1;
  return 15735; /* *pred_mul_neg_subrvvm8hf_undef */
}

 int
recog_1241 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_RVVM1HFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_RVVM1HFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_RVVM1HFmode)
      || !(
#line 6705 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
    return -1;
  return 15741; /* *pred_mul_neg_subrvvm1hf_undef */
}

 int
recog_1248 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_RVVMF2SFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_RVVMF2SFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_RVVMF2SFmode)
      || !(
#line 6705 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
    return -1;
  return 15755; /* *pred_mul_neg_subrvvmf2sf_undef */
}

 int
recog_1255 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V4HFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_V4HFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_V4HFmode)
      || !(
#line 6705 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 238 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
    return -1;
  return 15769; /* *pred_mul_neg_subv4hf_undef */
}

 int
recog_1262 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V512HFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_V512HFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_V512HFmode)
      || !(
#line 6705 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 245 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
    return -1;
  return 15783; /* *pred_mul_neg_subv512hf_undef */
}

 int
recog_1269 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V16SFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_V16SFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_V16SFmode)
      || !(
#line 6705 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 252 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
    return -1;
  return 15797; /* *pred_mul_neg_subv16sf_undef */
}

 int
recog_1276 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V1DFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_V1DFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_V1DFmode)
      || !(
#line 6705 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 259 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
    return -1;
  return 15811; /* *pred_mul_neg_subv1df_undef */
}

 int
recog_1283 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V128DFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_V128DFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_V128DFmode)
      || !(
#line 6705 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 266 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
    return -1;
  return 15825; /* *pred_mul_neg_subv128df_undef */
}

 int
recog_1290 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1281 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_V32DFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_V32DFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6736 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 264 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
    return 15917; /* *pred_nmaddv32df */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6770 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 264 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
    return -1;
  return 16013; /* *pred_nmaccv32df */
}

 int
recog_1297 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1274 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_V512SFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_V512SFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6736 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 257 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
    return 15903; /* *pred_nmaddv512sf */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6770 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 257 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
    return -1;
  return 15999; /* *pred_nmaccv512sf */
}

 int
recog_1304 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1267 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_V4SFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_V4SFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6736 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 250 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
    return 15889; /* *pred_nmaddv4sf */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6770 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 250 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 15985; /* *pred_nmaccv4sf */
}

 int
recog_1311 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1260 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_V128HFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_V128HFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6736 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 243 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
    return 15875; /* *pred_nmaddv128hf */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6770 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 243 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
    return -1;
  return 15971; /* *pred_nmaccv128hf */
}

 int
recog_1319 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1252 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_RVVM1DFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_RVVM1DFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6736 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
    return 15859; /* *pred_nmaddrvvm1df */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6770 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
    return -1;
  return 15955; /* *pred_nmaccrvvm1df */
}

 int
recog_1327 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1244 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_RVVM8SFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_RVVM8SFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6736 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
    return 15843; /* *pred_nmaddrvvm8sf */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6770 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 15939; /* *pred_nmaccrvvm8sf */
}

 int
recog_1335 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern583 (x2))
    {
    case 0:
      return recog_1333 (x1, insn, pnum_clobbers);

    case 1:
      return recog_1332 (x1, insn, pnum_clobbers);

    case 2:
      return recog_1331 (x1, insn, pnum_clobbers);

    case 3:
      return recog_1330 (x1, insn, pnum_clobbers);

    case 4:
      return recog_1329 (x1, insn, pnum_clobbers);

    case 5:
      return recog_1328 (x1, insn, pnum_clobbers);

    case 6:
      return recog_1327 (x1, insn, pnum_clobbers);

    case 7:
      return recog_1326 (x1, insn, pnum_clobbers);

    case 8:
      return recog_1325 (x1, insn, pnum_clobbers);

    case 9:
      return recog_1324 (x1, insn, pnum_clobbers);

    case 10:
      return recog_1323 (x1, insn, pnum_clobbers);

    case 11:
      return recog_1322 (x1, insn, pnum_clobbers);

    case 12:
      return recog_1321 (x1, insn, pnum_clobbers);

    case 13:
      return recog_1320 (x1, insn, pnum_clobbers);

    case 14:
      return recog_1319 (x1, insn, pnum_clobbers);

    case 15:
      return recog_1318 (x1, insn, pnum_clobbers);

    case 16:
      return recog_1317 (x1, insn, pnum_clobbers);

    case 17:
      return recog_1316 (x1, insn, pnum_clobbers);

    case 18:
      return recog_1315 (x1, insn, pnum_clobbers);

    case 19:
      return recog_1314 (x1, insn, pnum_clobbers);

    case 20:
      return recog_1313 (x1, insn, pnum_clobbers);

    case 21:
      return recog_1312 (x1, insn, pnum_clobbers);

    case 22:
      return recog_1311 (x1, insn, pnum_clobbers);

    case 23:
      return recog_1310 (x1, insn, pnum_clobbers);

    case 24:
      return recog_1309 (x1, insn, pnum_clobbers);

    case 25:
      return recog_1308 (x1, insn, pnum_clobbers);

    case 26:
      return recog_1307 (x1, insn, pnum_clobbers);

    case 27:
      return recog_1306 (x1, insn, pnum_clobbers);

    case 28:
      return recog_1305 (x1, insn, pnum_clobbers);

    case 29:
      return recog_1304 (x1, insn, pnum_clobbers);

    case 30:
      return recog_1303 (x1, insn, pnum_clobbers);

    case 31:
      return recog_1302 (x1, insn, pnum_clobbers);

    case 32:
      return recog_1301 (x1, insn, pnum_clobbers);

    case 33:
      return recog_1300 (x1, insn, pnum_clobbers);

    case 34:
      return recog_1299 (x1, insn, pnum_clobbers);

    case 35:
      return recog_1298 (x1, insn, pnum_clobbers);

    case 36:
      return recog_1297 (x1, insn, pnum_clobbers);

    case 37:
      return recog_1296 (x1, insn, pnum_clobbers);

    case 38:
      return recog_1295 (x1, insn, pnum_clobbers);

    case 39:
      return recog_1294 (x1, insn, pnum_clobbers);

    case 40:
      return recog_1293 (x1, insn, pnum_clobbers);

    case 41:
      return recog_1292 (x1, insn, pnum_clobbers);

    case 42:
      return recog_1291 (x1, insn, pnum_clobbers);

    case 43:
      return recog_1290 (x1, insn, pnum_clobbers);

    case 44:
      return recog_1289 (x1, insn, pnum_clobbers);

    case 45:
      return recog_1288 (x1, insn, pnum_clobbers);

    case 46:
      return recog_1287 (x1, insn, pnum_clobbers);

    case 47:
      return recog_1286 (x1, insn, pnum_clobbers);

    case 48:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6829 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return 16023; /* *pred_nmaddrvvm8hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6864 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 16119; /* *pred_nmaccrvvm8hf_scalar */

    case 49:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6829 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return 16025; /* *pred_nmaddrvvm4hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6864 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 16121; /* *pred_nmaccrvvm4hf_scalar */

    case 50:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6829 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return 16027; /* *pred_nmaddrvvm2hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6864 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 16123; /* *pred_nmaccrvvm2hf_scalar */

    case 51:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6829 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return 16029; /* *pred_nmaddrvvm1hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6864 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 16125; /* *pred_nmaccrvvm1hf_scalar */

    case 52:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6829 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return 16031; /* *pred_nmaddrvvmf2hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6864 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 16127; /* *pred_nmaccrvvmf2hf_scalar */

    case 53:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6829 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 157 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
        return 16033; /* *pred_nmaddrvvmf4hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6864 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 157 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
        return -1;
      return 16129; /* *pred_nmaccrvvmf4hf_scalar */

    case 54:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6829 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return 16035; /* *pred_nmaddrvvm8sf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6864 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16131; /* *pred_nmaccrvvm8sf_scalar */

    case 55:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6829 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return 16037; /* *pred_nmaddrvvm4sf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6864 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16133; /* *pred_nmaccrvvm4sf_scalar */

    case 56:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6829 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return 16039; /* *pred_nmaddrvvm2sf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6864 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16135; /* *pred_nmaccrvvm2sf_scalar */

    case 57:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6829 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return 16041; /* *pred_nmaddrvvm1sf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6864 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16137; /* *pred_nmaccrvvm1sf_scalar */

    case 58:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6829 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return 16043; /* *pred_nmaddrvvmf2sf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6864 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 16139; /* *pred_nmaccrvvmf2sf_scalar */

    case 59:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6829 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return 16045; /* *pred_nmaddrvvm8df_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6864 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16141; /* *pred_nmaccrvvm8df_scalar */

    case 60:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6829 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return 16047; /* *pred_nmaddrvvm4df_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6864 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16143; /* *pred_nmaccrvvm4df_scalar */

    case 61:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6829 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return 16049; /* *pred_nmaddrvvm2df_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6864 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16145; /* *pred_nmaccrvvm2df_scalar */

    case 62:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6829 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return 16051; /* *pred_nmaddrvvm1df_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6864 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16147; /* *pred_nmaccrvvm1df_scalar */

    case 63:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6829 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 236 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
        return 16053; /* *pred_nmaddv1hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6864 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 236 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
        return -1;
      return 16149; /* *pred_nmaccv1hf_scalar */

    case 64:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6829 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 237 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
        return 16055; /* *pred_nmaddv2hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6864 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 237 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
        return -1;
      return 16151; /* *pred_nmaccv2hf_scalar */

    case 65:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6829 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 238 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
        return 16057; /* *pred_nmaddv4hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6864 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 238 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
        return -1;
      return 16153; /* *pred_nmaccv4hf_scalar */

    case 66:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6829 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 239 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
        return 16059; /* *pred_nmaddv8hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6864 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 239 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
        return -1;
      return 16155; /* *pred_nmaccv8hf_scalar */

    case 67:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6829 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 240 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
        return 16061; /* *pred_nmaddv16hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6864 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 240 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
        return -1;
      return 16157; /* *pred_nmaccv16hf_scalar */

    case 68:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6829 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 241 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return 16063; /* *pred_nmaddv32hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6864 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 241 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 16159; /* *pred_nmaccv32hf_scalar */

    case 69:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6829 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 242 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return 16065; /* *pred_nmaddv64hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6864 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 242 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 16161; /* *pred_nmaccv64hf_scalar */

    case 70:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6829 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 243 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return 16067; /* *pred_nmaddv128hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6864 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 243 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 16163; /* *pred_nmaccv128hf_scalar */

    case 71:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6829 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 244 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return 16069; /* *pred_nmaddv256hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6864 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 244 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 16165; /* *pred_nmaccv256hf_scalar */

    case 72:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6829 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 245 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return 16071; /* *pred_nmaddv512hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6864 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 245 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 16167; /* *pred_nmaccv512hf_scalar */

    case 73:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6829 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 246 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return 16073; /* *pred_nmaddv1024hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6864 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 246 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 16169; /* *pred_nmaccv1024hf_scalar */

    case 74:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6829 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 247 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return 16075; /* *pred_nmaddv2048hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6864 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 247 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 16171; /* *pred_nmaccv2048hf_scalar */

    case 75:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6829 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 248 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return 16077; /* *pred_nmaddv1sf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6864 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 248 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16173; /* *pred_nmaccv1sf_scalar */

    case 76:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6829 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 249 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return 16079; /* *pred_nmaddv2sf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6864 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 249 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16175; /* *pred_nmaccv2sf_scalar */

    case 77:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6829 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 250 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return 16081; /* *pred_nmaddv4sf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6864 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 250 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16177; /* *pred_nmaccv4sf_scalar */

    case 78:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6829 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 251 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return 16083; /* *pred_nmaddv8sf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6864 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 251 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16179; /* *pred_nmaccv8sf_scalar */

    case 79:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6829 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 252 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return 16085; /* *pred_nmaddv16sf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6864 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 252 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 16181; /* *pred_nmaccv16sf_scalar */

    case 80:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6829 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 253 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return 16087; /* *pred_nmaddv32sf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6864 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 253 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 16183; /* *pred_nmaccv32sf_scalar */

    case 81:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6829 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 254 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return 16089; /* *pred_nmaddv64sf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6864 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 254 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 16185; /* *pred_nmaccv64sf_scalar */

    case 82:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6829 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 255 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return 16091; /* *pred_nmaddv128sf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6864 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 255 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 16187; /* *pred_nmaccv128sf_scalar */

    case 83:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6829 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 256 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return 16093; /* *pred_nmaddv256sf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6864 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 256 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 16189; /* *pred_nmaccv256sf_scalar */

    case 84:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6829 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 257 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return 16095; /* *pred_nmaddv512sf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6864 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 257 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 16191; /* *pred_nmaccv512sf_scalar */

    case 85:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6829 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 258 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return 16097; /* *pred_nmaddv1024sf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6864 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 258 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 16193; /* *pred_nmaccv1024sf_scalar */

    case 86:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6829 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 259 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return 16099; /* *pred_nmaddv1df_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6864 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 259 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16195; /* *pred_nmaccv1df_scalar */

    case 87:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6829 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 260 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return 16101; /* *pred_nmaddv2df_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6864 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 260 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16197; /* *pred_nmaccv2df_scalar */

    case 88:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6829 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 261 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return 16103; /* *pred_nmaddv4df_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6864 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 261 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16199; /* *pred_nmaccv4df_scalar */

    case 89:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6829 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 262 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return 16105; /* *pred_nmaddv8df_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6864 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 262 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 16201; /* *pred_nmaccv8df_scalar */

    case 90:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6829 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 263 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return 16107; /* *pred_nmaddv16df_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6864 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 263 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 16203; /* *pred_nmaccv16df_scalar */

    case 91:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6829 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 264 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return 16109; /* *pred_nmaddv32df_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6864 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 264 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 16205; /* *pred_nmaccv32df_scalar */

    case 92:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6829 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 265 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return 16111; /* *pred_nmaddv64df_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6864 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 265 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 16207; /* *pred_nmaccv64df_scalar */

    case 93:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6829 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 266 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return 16113; /* *pred_nmaddv128df_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6864 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 266 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 16209; /* *pred_nmaccv128df_scalar */

    case 94:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6829 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 267 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return 16115; /* *pred_nmaddv256df_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6864 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 267 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 16211; /* *pred_nmaccv256df_scalar */

    case 95:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6829 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 268 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return 16117; /* *pred_nmaddv512df_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6864 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 268 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 16213; /* *pred_nmaccv512df_scalar */

    case 96:
      if (!(
#line 7224 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1023 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16824; /* pred_widen_mul_neg_subrvvm8sf */

    case 97:
      if (!(
#line 7224 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1024 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16826; /* pred_widen_mul_neg_subrvvm4sf */

    case 98:
      if (!(
#line 7224 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1025 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16828; /* pred_widen_mul_neg_subrvvm2sf */

    case 99:
      if (!(
#line 7224 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1026 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16830; /* pred_widen_mul_neg_subrvvm1sf */

    case 100:
      if (!(
#line 7224 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1027 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 16832; /* pred_widen_mul_neg_subrvvmf2sf */

    case 101:
      if (!(
#line 7224 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1029 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16834; /* pred_widen_mul_neg_subrvvm8df */

    case 102:
      if (!(
#line 7224 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1029 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16836; /* pred_widen_mul_neg_subrvvm4df */

    case 103:
      if (!(
#line 7224 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1030 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16838; /* pred_widen_mul_neg_subrvvm2df */

    case 104:
      if (!(
#line 7224 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1030 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16840; /* pred_widen_mul_neg_subrvvm1df */

    case 105:
      if (!(
#line 7224 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1032 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16842; /* pred_widen_mul_neg_subv1sf */

    case 106:
      if (!(
#line 7224 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1033 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16844; /* pred_widen_mul_neg_subv2sf */

    case 107:
      if (!(
#line 7224 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1034 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16846; /* pred_widen_mul_neg_subv4sf */

    case 108:
      if (!(
#line 7224 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1035 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16848; /* pred_widen_mul_neg_subv8sf */

    case 109:
      if (!(
#line 7224 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1036 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 16850; /* pred_widen_mul_neg_subv16sf */

    case 110:
      if (!(
#line 7224 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1037 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 16852; /* pred_widen_mul_neg_subv32sf */

    case 111:
      if (!(
#line 7224 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1038 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 16854; /* pred_widen_mul_neg_subv64sf */

    case 112:
      if (!(
#line 7224 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1039 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 16856; /* pred_widen_mul_neg_subv128sf */

    case 113:
      if (!(
#line 7224 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1040 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 16858; /* pred_widen_mul_neg_subv256sf */

    case 114:
      if (!(
#line 7224 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1041 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 16860; /* pred_widen_mul_neg_subv512sf */

    case 115:
      if (!(
#line 7224 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1042 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 16862; /* pred_widen_mul_neg_subv1024sf */

    case 116:
      if (!(
#line 7224 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1043 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16864; /* pred_widen_mul_neg_subv1df */

    case 117:
      if (!(
#line 7224 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1044 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16866; /* pred_widen_mul_neg_subv2df */

    case 118:
      if (!(
#line 7224 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1045 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16868; /* pred_widen_mul_neg_subv4df */

    case 119:
      if (!(
#line 7224 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1046 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 16870; /* pred_widen_mul_neg_subv8df */

    case 120:
      if (!(
#line 7224 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1047 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 16872; /* pred_widen_mul_neg_subv16df */

    case 121:
      if (!(
#line 7224 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1048 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 16874; /* pred_widen_mul_neg_subv32df */

    case 122:
      if (!(
#line 7224 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1049 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 16876; /* pred_widen_mul_neg_subv64df */

    case 123:
      if (!(
#line 7224 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1050 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 16878; /* pred_widen_mul_neg_subv128df */

    case 124:
      if (!(
#line 7224 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1051 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 16880; /* pred_widen_mul_neg_subv256df */

    case 125:
      if (!(
#line 7224 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1052 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 16882; /* pred_widen_mul_neg_subv512df */

    case 126:
      if (!(
#line 7254 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1023 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16884; /* pred_widen_mul_neg_subrvvm8sf_scalar */

    case 127:
      if (!(
#line 7254 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1024 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16886; /* pred_widen_mul_neg_subrvvm4sf_scalar */

    case 128:
      if (!(
#line 7254 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1025 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16888; /* pred_widen_mul_neg_subrvvm2sf_scalar */

    case 129:
      if (!(
#line 7254 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1026 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16890; /* pred_widen_mul_neg_subrvvm1sf_scalar */

    case 130:
      if (!(
#line 7254 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1027 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 16892; /* pred_widen_mul_neg_subrvvmf2sf_scalar */

    case 131:
      if (!(
#line 7254 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1029 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16894; /* pred_widen_mul_neg_subrvvm8df_scalar */

    case 132:
      if (!(
#line 7254 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1029 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16896; /* pred_widen_mul_neg_subrvvm4df_scalar */

    case 133:
      if (!(
#line 7254 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1030 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16898; /* pred_widen_mul_neg_subrvvm2df_scalar */

    case 134:
      if (!(
#line 7254 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1030 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16900; /* pred_widen_mul_neg_subrvvm1df_scalar */

    case 135:
      if (!(
#line 7254 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1032 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16902; /* pred_widen_mul_neg_subv1sf_scalar */

    case 136:
      if (!(
#line 7254 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1033 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16904; /* pred_widen_mul_neg_subv2sf_scalar */

    case 137:
      if (!(
#line 7254 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1034 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16906; /* pred_widen_mul_neg_subv4sf_scalar */

    case 138:
      if (!(
#line 7254 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1035 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16908; /* pred_widen_mul_neg_subv8sf_scalar */

    case 139:
      if (!(
#line 7254 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1036 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 16910; /* pred_widen_mul_neg_subv16sf_scalar */

    case 140:
      if (!(
#line 7254 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1037 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 16912; /* pred_widen_mul_neg_subv32sf_scalar */

    case 141:
      if (!(
#line 7254 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1038 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 16914; /* pred_widen_mul_neg_subv64sf_scalar */

    case 142:
      if (!(
#line 7254 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1039 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 16916; /* pred_widen_mul_neg_subv128sf_scalar */

    case 143:
      if (!(
#line 7254 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1040 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 16918; /* pred_widen_mul_neg_subv256sf_scalar */

    case 144:
      if (!(
#line 7254 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1041 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 16920; /* pred_widen_mul_neg_subv512sf_scalar */

    case 145:
      if (!(
#line 7254 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1042 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 16922; /* pred_widen_mul_neg_subv1024sf_scalar */

    case 146:
      if (!(
#line 7254 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1043 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16924; /* pred_widen_mul_neg_subv1df_scalar */

    case 147:
      if (!(
#line 7254 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1044 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16926; /* pred_widen_mul_neg_subv2df_scalar */

    case 148:
      if (!(
#line 7254 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1045 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16928; /* pred_widen_mul_neg_subv4df_scalar */

    case 149:
      if (!(
#line 7254 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1046 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 16930; /* pred_widen_mul_neg_subv8df_scalar */

    case 150:
      if (!(
#line 7254 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1047 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 16932; /* pred_widen_mul_neg_subv16df_scalar */

    case 151:
      if (!(
#line 7254 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1048 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 16934; /* pred_widen_mul_neg_subv32df_scalar */

    case 152:
      if (!(
#line 7254 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1049 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 16936; /* pred_widen_mul_neg_subv64df_scalar */

    case 153:
      if (!(
#line 7254 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1050 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 16938; /* pred_widen_mul_neg_subv128df_scalar */

    case 154:
      if (!(
#line 7254 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1051 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 16940; /* pred_widen_mul_neg_subv256df_scalar */

    case 155:
      if (!(
#line 7254 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1052 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 16942; /* pred_widen_mul_neg_subv512df_scalar */

    default:
      return -1;
    }
}

 int
recog_1387 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x7, 1);
  operands[4] = x9;
  x10 = XEXP (x2, 2);
  if (!rtx_equal_p (x10, operands[1]))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_V512QImode:
      if (!register_operand (operands[3], E_V512QImode)
          || !vector_neg_arith_operand (operands[4], E_V512QImode)
          || !(
#line 4841 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 197 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 12662; /* *pred_ltgev512qi_merge_tie_mask */

    case E_V512HImode:
      if (!register_operand (operands[3], E_V512HImode)
          || !vector_neg_arith_operand (operands[4], E_V512HImode)
          || !(
#line 4841 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 210 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 12675; /* *pred_ltgev512hi_merge_tie_mask */

    case E_V512SImode:
      if (!register_operand (operands[3], E_V512SImode)
          || !vector_neg_arith_operand (operands[4], E_V512SImode)
          || !(
#line 4841 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 222 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 12687; /* *pred_ltgev512si_merge_tie_mask */

    case E_V512DImode:
      if (!register_operand (operands[3], E_V512DImode)
          || !vector_neg_arith_operand (operands[4], E_V512DImode)
          || !(
#line 4841 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 233 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 12698; /* *pred_ltgev512di_merge_tie_mask */

    default:
      return -1;
    }
}

 int
recog_1396 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern532 (x2, 
E_V8BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  operands[2] = x3;
  if (register_operand (operands[1], E_V8BImode))
    {
      res = recog_1381 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  operands[3] = x3;
  if (!vector_mask_operand (operands[1], E_V8BImode))
    return -1;
  x4 = XEXP (x2, 0);
  x5 = XVECEXP (x4, 0, 1);
  operands[6] = x5;
  x6 = XVECEXP (x4, 0, 2);
  operands[7] = x6;
  x7 = XVECEXP (x4, 0, 3);
  operands[8] = x7;
  x8 = XEXP (x3, 0);
  operands[4] = x8;
  x9 = XEXP (x3, 1);
  operands[5] = x9;
  x10 = XEXP (x2, 2);
  operands[2] = x10;
  if (!vector_merge_operand (operands[2], E_V8BImode))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_V8QImode:
      if (!register_operand (operands[4], E_V8QImode)
          || !vector_neg_arith_operand (operands[5], E_V8QImode))
        return -1;
      if ((
#line 4865 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V8QImode)) && 
#line 191 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return 12724; /* *pred_ltgev8qi */
      if (!(
#line 4886 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V8QImode)) && 
#line 191 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 12792; /* *pred_ltgev8qi_narrow */

    case E_V8HImode:
      if (!register_operand (operands[4], E_V8HImode)
          || !vector_neg_arith_operand (operands[5], E_V8HImode))
        return -1;
      if ((
#line 4865 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V8HImode)) && 
#line 204 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return 12737; /* *pred_ltgev8hi */
      if (!(
#line 4886 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V8HImode)) && 
#line 204 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 12805; /* *pred_ltgev8hi_narrow */

    case E_V8SImode:
      if (!register_operand (operands[4], E_V8SImode)
          || !vector_neg_arith_operand (operands[5], E_V8SImode))
        return -1;
      if ((
#line 4865 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V8SImode)) && 
#line 216 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return 12749; /* *pred_ltgev8si */
      if (!(
#line 4886 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V8SImode)) && 
#line 216 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 12817; /* *pred_ltgev8si_narrow */

    case E_V8DImode:
      if (!register_operand (operands[4], E_V8DImode)
          || !vector_neg_arith_operand (operands[5], E_V8DImode))
        return -1;
      if ((
#line 4865 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V8DImode)) && 
#line 227 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return 12760; /* *pred_ltgev8di */
      if (!(
#line 4886 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V8DImode)) && 
#line 227 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 12828; /* *pred_ltgev8di_narrow */

    default:
      return -1;
    }
}

 int
recog_1402 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x7, 1);
  x10 = XEXP (x9, 0);
  operands[4] = x10;
  x11 = XEXP (x2, 2);
  if (!rtx_equal_p (x11, operands[1]))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_RVVMF2QImode:
      if (!register_operand (operands[3], E_RVVMF2QImode)
          || GET_MODE (x9) != E_RVVMF2QImode
          || !register_operand (operands[4], E_QImode)
          || !
#line 4925 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 12839; /* *pred_cmprvvmf2qi_scalar_merge_tie_mask */

    case E_RVVM1HImode:
      if (!register_operand (operands[3], E_RVVM1HImode)
          || GET_MODE (x9) != E_RVVM1HImode
          || !register_operand (operands[4], E_HImode)
          || !
#line 4925 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 12845; /* *pred_cmprvvm1hi_scalar_merge_tie_mask */

    case E_RVVM2SImode:
      if (!register_operand (operands[3], E_RVVM2SImode)
          || GET_MODE (x9) != E_RVVM2SImode
          || !register_operand (operands[4], E_SImode)
          || !
#line 4925 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 12850; /* *pred_cmprvvm2si_scalar_merge_tie_mask */

    case E_RVVM4DImode:
      if (!register_operand (operands[3], E_RVVM4DImode)
          || GET_MODE (x9) != E_RVVM4DImode
          || !register_operand (operands[4], E_DImode)
          || !(
#line 5035 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 774 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12998; /* *pred_cmprvvm4di_scalar_merge_tie_mask */

    default:
      return -1;
    }
}

 int
recog_1409 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x7, 1);
  x10 = XEXP (x9, 0);
  operands[4] = x10;
  x11 = XEXP (x2, 2);
  if (!rtx_equal_p (x11, operands[1]))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_V16QImode:
      if (!register_operand (operands[3], E_V16QImode)
          || GET_MODE (x9) != E_V16QImode
          || !register_operand (operands[4], E_QImode)
          || !(
#line 4925 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 734 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 12857; /* *pred_cmpv16qi_scalar_merge_tie_mask */

    case E_V16HImode:
      if (!register_operand (operands[3], E_V16HImode)
          || GET_MODE (x9) != E_V16HImode
          || !register_operand (operands[4], E_HImode)
          || !(
#line 4925 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 747 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 12870; /* *pred_cmpv16hi_scalar_merge_tie_mask */

    case E_V16SImode:
      if (!register_operand (operands[3], E_V16SImode)
          || GET_MODE (x9) != E_V16SImode
          || !register_operand (operands[4], E_SImode)
          || !(
#line 4925 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 759 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 12882; /* *pred_cmpv16si_scalar_merge_tie_mask */

    case E_V16DImode:
      if (!register_operand (operands[3], E_V16DImode)
          || GET_MODE (x9) != E_V16DImode
          || !register_operand (operands[4], E_DImode)
          || !(
#line 5035 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 781 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 13005; /* *pred_cmpv16di_scalar_merge_tie_mask */

    default:
      return -1;
    }
}

 int
recog_1416 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x7, 1);
  x10 = XEXP (x9, 0);
  operands[4] = x10;
  x11 = XEXP (x2, 2);
  if (!rtx_equal_p (x11, operands[1]))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_V2048QImode:
      if (!register_operand (operands[3], E_V2048QImode)
          || GET_MODE (x9) != E_V2048QImode
          || !register_operand (operands[4], E_QImode)
          || !(
#line 4925 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 741 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 12864; /* *pred_cmpv2048qi_scalar_merge_tie_mask */

    case E_V2048HImode:
      if (!register_operand (operands[3], E_V2048HImode)
          || GET_MODE (x9) != E_V2048HImode
          || !register_operand (operands[4], E_HImode)
          || !(
#line 4925 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 754 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 12877; /* *pred_cmpv2048hi_scalar_merge_tie_mask */

    default:
      return -1;
    }
}

 int
recog_1420 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern566 (x2, 
E_V64BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  operands[2] = x3;
  if (register_operand (operands[1], E_V64BImode))
    {
      res = recog_1411 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  operands[3] = x3;
  if (!vector_mask_operand (operands[1], E_V64BImode))
    return -1;
  x4 = XEXP (x2, 0);
  x5 = XVECEXP (x4, 0, 1);
  operands[6] = x5;
  x6 = XVECEXP (x4, 0, 2);
  operands[7] = x6;
  x7 = XVECEXP (x4, 0, 3);
  operands[8] = x7;
  x8 = XEXP (x3, 0);
  operands[4] = x8;
  x9 = XEXP (x3, 1);
  x10 = XEXP (x9, 0);
  operands[5] = x10;
  x11 = XEXP (x2, 2);
  operands[2] = x11;
  if (!vector_merge_operand (operands[2], E_V64BImode))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_V64QImode:
      if (!register_operand (operands[4], E_V64QImode)
          || GET_MODE (x9) != E_V64QImode
          || !register_operand (operands[5], E_QImode))
        return -1;
      if ((
#line 4950 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V64QImode)) && 
#line 736 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return 12913; /* *pred_cmpv64qi_scalar */
      if (!(
#line 4972 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V64QImode)) && 
#line 736 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 12967; /* *pred_cmpv64qi_scalar_narrow */

    case E_V64HImode:
      if (!register_operand (operands[4], E_V64HImode)
          || GET_MODE (x9) != E_V64HImode
          || !register_operand (operands[5], E_HImode))
        return -1;
      if ((
#line 4950 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V64HImode)) && 
#line 749 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return 12926; /* *pred_cmpv64hi_scalar */
      if (!(
#line 4972 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V64HImode)) && 
#line 749 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 12980; /* *pred_cmpv64hi_scalar_narrow */

    case E_V64SImode:
      if (!register_operand (operands[4], E_V64SImode)
          || GET_MODE (x9) != E_V64SImode
          || !register_operand (operands[5], E_SImode))
        return -1;
      if ((
#line 4950 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V64SImode)) && 
#line 761 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return 12938; /* *pred_cmpv64si_scalar */
      if (!(
#line 4972 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V64SImode)) && 
#line 761 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 12992; /* *pred_cmpv64si_scalar_narrow */

    case E_V64DImode:
      if (!register_operand (operands[4], E_V64DImode)
          || GET_MODE (x9) != E_V64DImode
          || !register_operand (operands[5], E_DImode))
        return -1;
      if ((
#line 5060 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V64DImode)) && 
#line 783 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return 13021; /* *pred_cmpv64di_scalar */
      if (!(
#line 5082 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V64DImode)) && 
#line 783 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 13035; /* *pred_cmpv64di_scalar_narrow */

    default:
      return -1;
    }
}

 int
recog_1427 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM1BImode:
      x2 = XEXP (x1, 1);
      if (pattern566 (x2, 
E_RVVM1BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      operands[2] = x3;
      if (pattern620 (x2, 
E_RVVM8QImode, 
E_RVVM1BImode, 
E_QImode) == 0
          && 
#line 4925 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 12835; /* *pred_cmprvvm8qi_scalar_merge_tie_mask */
      operands[3] = x3;
      if (pattern621 (x2, 
E_RVVM1BImode, 
E_RVVM8QImode, 
E_QImode) != 0)
        return -1;
      if (
#line 4950 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM8QImode)))
        return 12889; /* *pred_cmprvvm8qi_scalar */
      if (!
#line 4972 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM8QImode)))
        return -1;
      return 12943; /* *pred_cmprvvm8qi_scalar_narrow */

    case E_RVVMF2BImode:
      x2 = XEXP (x1, 1);
      if (pattern566 (x2, 
E_RVVMF2BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      operands[2] = x3;
      if (register_operand (operands[1], E_RVVMF2BImode))
        {
          res = recog_1399 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[3] = x3;
      if (!vector_mask_operand (operands[1], E_RVVMF2BImode))
        return -1;
      x4 = XEXP (x2, 0);
      x5 = XVECEXP (x4, 0, 1);
      operands[6] = x5;
      x6 = XVECEXP (x4, 0, 2);
      operands[7] = x6;
      x7 = XVECEXP (x4, 0, 3);
      operands[8] = x7;
      x8 = XEXP (x3, 0);
      operands[4] = x8;
      x9 = XEXP (x3, 1);
      x10 = XEXP (x9, 0);
      operands[5] = x10;
      x11 = XEXP (x2, 2);
      operands[2] = x11;
      if (!vector_merge_operand (operands[2], E_RVVMF2BImode))
        return -1;
      switch (GET_MODE (operands[4]))
        {
        case E_RVVM4QImode:
          if (!register_operand (operands[4], E_RVVM4QImode)
              || GET_MODE (x9) != E_RVVM4QImode
              || !register_operand (operands[5], E_QImode))
            return -1;
          if (
#line 4950 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM4QImode)))
            return 12890; /* *pred_cmprvvm4qi_scalar */
          if (!
#line 4972 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM4QImode)))
            return -1;
          return 12944; /* *pred_cmprvvm4qi_scalar_narrow */

        case E_RVVM8HImode:
          if (!register_operand (operands[4], E_RVVM8HImode)
              || GET_MODE (x9) != E_RVVM8HImode
              || !register_operand (operands[5], E_HImode))
            return -1;
          if (
#line 4950 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM8HImode)))
            return 12896; /* *pred_cmprvvm8hi_scalar */
          if (!
#line 4972 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM8HImode)))
            return -1;
          return 12950; /* *pred_cmprvvm8hi_scalar_narrow */

        default:
          return -1;
        }

    case E_RVVMF4BImode:
      x2 = XEXP (x1, 1);
      if (pattern566 (x2, 
E_RVVMF4BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      operands[2] = x3;
      if (register_operand (operands[1], E_RVVMF4BImode))
        {
          res = recog_1400 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[3] = x3;
      if (!vector_mask_operand (operands[1], E_RVVMF4BImode))
        return -1;
      x4 = XEXP (x2, 0);
      x5 = XVECEXP (x4, 0, 1);
      operands[6] = x5;
      x6 = XVECEXP (x4, 0, 2);
      operands[7] = x6;
      x7 = XVECEXP (x4, 0, 3);
      operands[8] = x7;
      x8 = XEXP (x3, 0);
      operands[4] = x8;
      x9 = XEXP (x3, 1);
      x10 = XEXP (x9, 0);
      operands[5] = x10;
      x11 = XEXP (x2, 2);
      operands[2] = x11;
      if (!vector_merge_operand (operands[2], E_RVVMF4BImode))
        return -1;
      switch (GET_MODE (operands[4]))
        {
        case E_RVVM2QImode:
          if (!register_operand (operands[4], E_RVVM2QImode)
              || GET_MODE (x9) != E_RVVM2QImode
              || !register_operand (operands[5], E_QImode))
            return -1;
          if (
#line 4950 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM2QImode)))
            return 12891; /* *pred_cmprvvm2qi_scalar */
          if (!
#line 4972 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM2QImode)))
            return -1;
          return 12945; /* *pred_cmprvvm2qi_scalar_narrow */

        case E_RVVM4HImode:
          if (!register_operand (operands[4], E_RVVM4HImode)
              || GET_MODE (x9) != E_RVVM4HImode
              || !register_operand (operands[5], E_HImode))
            return -1;
          if (
#line 4950 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM4HImode)))
            return 12897; /* *pred_cmprvvm4hi_scalar */
          if (!
#line 4972 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM4HImode)))
            return -1;
          return 12951; /* *pred_cmprvvm4hi_scalar_narrow */

        case E_RVVM8SImode:
          if (!register_operand (operands[4], E_RVVM8SImode)
              || GET_MODE (x9) != E_RVVM8SImode
              || !register_operand (operands[5], E_SImode))
            return -1;
          if (
#line 4950 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM8SImode)))
            return 12902; /* *pred_cmprvvm8si_scalar */
          if (!
#line 4972 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM8SImode)))
            return -1;
          return 12956; /* *pred_cmprvvm8si_scalar_narrow */

        default:
          return -1;
        }

    case E_RVVMF8BImode:
      x2 = XEXP (x1, 1);
      if (pattern566 (x2, 
E_RVVMF8BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      operands[2] = x3;
      if (register_operand (operands[1], E_RVVMF8BImode))
        {
          res = recog_1401 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[3] = x3;
      if (!vector_mask_operand (operands[1], E_RVVMF8BImode))
        return -1;
      x4 = XEXP (x2, 0);
      x5 = XVECEXP (x4, 0, 1);
      operands[6] = x5;
      x6 = XVECEXP (x4, 0, 2);
      operands[7] = x6;
      x7 = XVECEXP (x4, 0, 3);
      operands[8] = x7;
      x8 = XEXP (x3, 0);
      operands[4] = x8;
      x9 = XEXP (x3, 1);
      x10 = XEXP (x9, 0);
      operands[5] = x10;
      x11 = XEXP (x2, 2);
      operands[2] = x11;
      if (!vector_merge_operand (operands[2], E_RVVMF8BImode))
        return -1;
      switch (GET_MODE (operands[4]))
        {
        case E_RVVM1QImode:
          if (!register_operand (operands[4], E_RVVM1QImode)
              || GET_MODE (x9) != E_RVVM1QImode
              || !register_operand (operands[5], E_QImode))
            return -1;
          if (
#line 4950 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM1QImode)))
            return 12892; /* *pred_cmprvvm1qi_scalar */
          if (!
#line 4972 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM1QImode)))
            return -1;
          return 12946; /* *pred_cmprvvm1qi_scalar_narrow */

        case E_RVVM2HImode:
          if (!register_operand (operands[4], E_RVVM2HImode)
              || GET_MODE (x9) != E_RVVM2HImode
              || !register_operand (operands[5], E_HImode))
            return -1;
          if (
#line 4950 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM2HImode)))
            return 12898; /* *pred_cmprvvm2hi_scalar */
          if (!
#line 4972 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM2HImode)))
            return -1;
          return 12952; /* *pred_cmprvvm2hi_scalar_narrow */

        case E_RVVM4SImode:
          if (!register_operand (operands[4], E_RVVM4SImode)
              || GET_MODE (x9) != E_RVVM4SImode
              || !register_operand (operands[5], E_SImode))
            return -1;
          if (
#line 4950 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM4SImode)))
            return 12903; /* *pred_cmprvvm4si_scalar */
          if (!
#line 4972 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM4SImode)))
            return -1;
          return 12957; /* *pred_cmprvvm4si_scalar_narrow */

        case E_RVVM8DImode:
          if (!register_operand (operands[4], E_RVVM8DImode)
              || GET_MODE (x9) != E_RVVM8DImode
              || !register_operand (operands[5], E_DImode))
            return -1;
          if ((
#line 5060 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM8DImode)) && 
#line 774 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return 13011; /* *pred_cmprvvm8di_scalar */
          if (!(
#line 5082 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM8DImode)) && 
#line 774 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 13025; /* *pred_cmprvvm8di_scalar_narrow */

        default:
          return -1;
        }

    case E_RVVMF16BImode:
      x2 = XEXP (x1, 1);
      if (pattern566 (x2, 
E_RVVMF16BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      operands[2] = x3;
      if (register_operand (operands[1], E_RVVMF16BImode))
        {
          res = recog_1402 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[3] = x3;
      if (!vector_mask_operand (operands[1], E_RVVMF16BImode))
        return -1;
      x4 = XEXP (x2, 0);
      x5 = XVECEXP (x4, 0, 1);
      operands[6] = x5;
      x6 = XVECEXP (x4, 0, 2);
      operands[7] = x6;
      x7 = XVECEXP (x4, 0, 3);
      operands[8] = x7;
      x8 = XEXP (x3, 0);
      operands[4] = x8;
      x9 = XEXP (x3, 1);
      x10 = XEXP (x9, 0);
      operands[5] = x10;
      x11 = XEXP (x2, 2);
      operands[2] = x11;
      if (!vector_merge_operand (operands[2], E_RVVMF16BImode))
        return -1;
      switch (GET_MODE (operands[4]))
        {
        case E_RVVMF2QImode:
          if (!register_operand (operands[4], E_RVVMF2QImode)
              || GET_MODE (x9) != E_RVVMF2QImode
              || !register_operand (operands[5], E_QImode))
            return -1;
          if (
#line 4950 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVMF2QImode)))
            return 12893; /* *pred_cmprvvmf2qi_scalar */
          if (!
#line 4972 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVMF2QImode)))
            return -1;
          return 12947; /* *pred_cmprvvmf2qi_scalar_narrow */

        case E_RVVM1HImode:
          if (!register_operand (operands[4], E_RVVM1HImode)
              || GET_MODE (x9) != E_RVVM1HImode
              || !register_operand (operands[5], E_HImode))
            return -1;
          if (
#line 4950 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM1HImode)))
            return 12899; /* *pred_cmprvvm1hi_scalar */
          if (!
#line 4972 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM1HImode)))
            return -1;
          return 12953; /* *pred_cmprvvm1hi_scalar_narrow */

        case E_RVVM2SImode:
          if (!register_operand (operands[4], E_RVVM2SImode)
              || GET_MODE (x9) != E_RVVM2SImode
              || !register_operand (operands[5], E_SImode))
            return -1;
          if (
#line 4950 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM2SImode)))
            return 12904; /* *pred_cmprvvm2si_scalar */
          if (!
#line 4972 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM2SImode)))
            return -1;
          return 12958; /* *pred_cmprvvm2si_scalar_narrow */

        case E_RVVM4DImode:
          if (!register_operand (operands[4], E_RVVM4DImode)
              || GET_MODE (x9) != E_RVVM4DImode
              || !register_operand (operands[5], E_DImode))
            return -1;
          if ((
#line 5060 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM4DImode)) && 
#line 774 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return 13012; /* *pred_cmprvvm4di_scalar */
          if (!(
#line 5082 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM4DImode)) && 
#line 774 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 13026; /* *pred_cmprvvm4di_scalar_narrow */

        default:
          return -1;
        }

    case E_RVVMF32BImode:
      x2 = XEXP (x1, 1);
      if (pattern566 (x2, 
E_RVVMF32BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      operands[2] = x3;
      if (register_operand (operands[1], E_RVVMF32BImode))
        {
          res = recog_1403 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[3] = x3;
      if (!vector_mask_operand (operands[1], E_RVVMF32BImode))
        return -1;
      x4 = XEXP (x2, 0);
      x5 = XVECEXP (x4, 0, 1);
      operands[6] = x5;
      x6 = XVECEXP (x4, 0, 2);
      operands[7] = x6;
      x7 = XVECEXP (x4, 0, 3);
      operands[8] = x7;
      x8 = XEXP (x3, 0);
      operands[4] = x8;
      x9 = XEXP (x3, 1);
      x10 = XEXP (x9, 0);
      operands[5] = x10;
      x11 = XEXP (x2, 2);
      operands[2] = x11;
      if (!vector_merge_operand (operands[2], E_RVVMF32BImode))
        return -1;
      switch (GET_MODE (operands[4]))
        {
        case E_RVVMF4QImode:
          if (!register_operand (operands[4], E_RVVMF4QImode)
              || GET_MODE (x9) != E_RVVMF4QImode
              || !register_operand (operands[5], E_QImode))
            return -1;
          if (
#line 4950 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVMF4QImode)))
            return 12894; /* *pred_cmprvvmf4qi_scalar */
          if (!
#line 4972 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVMF4QImode)))
            return -1;
          return 12948; /* *pred_cmprvvmf4qi_scalar_narrow */

        case E_RVVMF2HImode:
          if (!register_operand (operands[4], E_RVVMF2HImode)
              || GET_MODE (x9) != E_RVVMF2HImode
              || !register_operand (operands[5], E_HImode))
            return -1;
          if (
#line 4950 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVMF2HImode)))
            return 12900; /* *pred_cmprvvmf2hi_scalar */
          if (!
#line 4972 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVMF2HImode)))
            return -1;
          return 12954; /* *pred_cmprvvmf2hi_scalar_narrow */

        case E_RVVM1SImode:
          if (!register_operand (operands[4], E_RVVM1SImode)
              || GET_MODE (x9) != E_RVVM1SImode
              || !register_operand (operands[5], E_SImode))
            return -1;
          if (
#line 4950 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM1SImode)))
            return 12905; /* *pred_cmprvvm1si_scalar */
          if (!
#line 4972 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM1SImode)))
            return -1;
          return 12959; /* *pred_cmprvvm1si_scalar_narrow */

        case E_RVVM2DImode:
          if (!register_operand (operands[4], E_RVVM2DImode)
              || GET_MODE (x9) != E_RVVM2DImode
              || !register_operand (operands[5], E_DImode))
            return -1;
          if ((
#line 5060 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM2DImode)) && 
#line 775 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return 13013; /* *pred_cmprvvm2di_scalar */
          if (!(
#line 5082 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM2DImode)) && 
#line 775 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 13027; /* *pred_cmprvvm2di_scalar_narrow */

        default:
          return -1;
        }

    case E_RVVMF64BImode:
      x2 = XEXP (x1, 1);
      if (pattern566 (x2, 
E_RVVMF64BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      operands[2] = x3;
      if (register_operand (operands[1], E_RVVMF64BImode))
        {
          res = recog_1404 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[3] = x3;
      if (!vector_mask_operand (operands[1], E_RVVMF64BImode))
        return -1;
      x4 = XEXP (x2, 0);
      x5 = XVECEXP (x4, 0, 1);
      operands[6] = x5;
      x6 = XVECEXP (x4, 0, 2);
      operands[7] = x6;
      x7 = XVECEXP (x4, 0, 3);
      operands[8] = x7;
      x8 = XEXP (x3, 0);
      operands[4] = x8;
      x9 = XEXP (x3, 1);
      x10 = XEXP (x9, 0);
      operands[5] = x10;
      x11 = XEXP (x2, 2);
      operands[2] = x11;
      if (!vector_merge_operand (operands[2], E_RVVMF64BImode))
        return -1;
      switch (GET_MODE (operands[4]))
        {
        case E_RVVMF8QImode:
          if (!register_operand (operands[4], E_RVVMF8QImode)
              || GET_MODE (x9) != E_RVVMF8QImode
              || !register_operand (operands[5], E_QImode))
            return -1;
          if ((
#line 4950 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVMF8QImode)) && 
#line 724 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return 12895; /* *pred_cmprvvmf8qi_scalar */
          if (!(
#line 4972 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVMF8QImode)) && 
#line 724 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 12949; /* *pred_cmprvvmf8qi_scalar_narrow */

        case E_RVVMF4HImode:
          if (!register_operand (operands[4], E_RVVMF4HImode)
              || GET_MODE (x9) != E_RVVMF4HImode
              || !register_operand (operands[5], E_HImode))
            return -1;
          if ((
#line 4950 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVMF4HImode)) && 
#line 726 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return 12901; /* *pred_cmprvvmf4hi_scalar */
          if (!(
#line 4972 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVMF4HImode)) && 
#line 726 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 12955; /* *pred_cmprvvmf4hi_scalar_narrow */

        case E_RVVMF2SImode:
          if (!register_operand (operands[4], E_RVVMF2SImode)
              || GET_MODE (x9) != E_RVVMF2SImode
              || !register_operand (operands[5], E_SImode))
            return -1;
          if ((
#line 4950 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVMF2SImode)) && 
#line 728 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return 12906; /* *pred_cmprvvmf2si_scalar */
          if (!(
#line 4972 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVMF2SImode)) && 
#line 728 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
            return -1;
          return 12960; /* *pred_cmprvvmf2si_scalar_narrow */

        case E_RVVM1DImode:
          if (!register_operand (operands[4], E_RVVM1DImode)
              || GET_MODE (x9) != E_RVVM1DImode
              || !register_operand (operands[5], E_DImode))
            return -1;
          if ((
#line 5060 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM1DImode)) && 
#line 775 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return 13014; /* *pred_cmprvvm1di_scalar */
          if (!(
#line 5082 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM1DImode)) && 
#line 775 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 13028; /* *pred_cmprvvm1di_scalar_narrow */

        default:
          return -1;
        }

    case E_V1BImode:
      return recog_1426 (x1, insn, pnum_clobbers);

    case E_V2BImode:
      return recog_1425 (x1, insn, pnum_clobbers);

    case E_V4BImode:
      return recog_1424 (x1, insn, pnum_clobbers);

    case E_V8BImode:
      return recog_1423 (x1, insn, pnum_clobbers);

    case E_V16BImode:
      return recog_1422 (x1, insn, pnum_clobbers);

    case E_V32BImode:
      return recog_1421 (x1, insn, pnum_clobbers);

    case E_V64BImode:
      return recog_1420 (x1, insn, pnum_clobbers);

    case E_V128BImode:
      return recog_1419 (x1, insn, pnum_clobbers);

    case E_V256BImode:
      return recog_1418 (x1, insn, pnum_clobbers);

    case E_V512BImode:
      return recog_1417 (x1, insn, pnum_clobbers);

    case E_V1024BImode:
      x2 = XEXP (x1, 1);
      if (pattern566 (x2, 
E_V1024BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      operands[2] = x3;
      if (register_operand (operands[1], E_V1024BImode))
        {
          res = recog_1415 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[3] = x3;
      if (!vector_mask_operand (operands[1], E_V1024BImode))
        return -1;
      x4 = XEXP (x2, 0);
      x5 = XVECEXP (x4, 0, 1);
      operands[6] = x5;
      x6 = XVECEXP (x4, 0, 2);
      operands[7] = x6;
      x7 = XVECEXP (x4, 0, 3);
      operands[8] = x7;
      x8 = XEXP (x3, 0);
      operands[4] = x8;
      x9 = XEXP (x3, 1);
      x10 = XEXP (x9, 0);
      operands[5] = x10;
      x11 = XEXP (x2, 2);
      operands[2] = x11;
      if (!vector_merge_operand (operands[2], E_V1024BImode))
        return -1;
      switch (GET_MODE (operands[4]))
        {
        case E_V1024QImode:
          if (!register_operand (operands[4], E_V1024QImode)
              || GET_MODE (x9) != E_V1024QImode
              || !register_operand (operands[5], E_QImode))
            return -1;
          if ((
#line 4950 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V1024QImode)) && 
#line 740 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
            return 12917; /* *pred_cmpv1024qi_scalar */
          if (!(
#line 4972 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V1024QImode)) && 
#line 740 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 12971; /* *pred_cmpv1024qi_scalar_narrow */

        case E_V1024HImode:
          if (!register_operand (operands[4], E_V1024HImode)
              || GET_MODE (x9) != E_V1024HImode
              || !register_operand (operands[5], E_HImode))
            return -1;
          if ((
#line 4950 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V1024HImode)) && 
#line 753 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
            return 12930; /* *pred_cmpv1024hi_scalar */
          if (!(
#line 4972 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V1024HImode)) && 
#line 753 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 12984; /* *pred_cmpv1024hi_scalar_narrow */

        case E_V1024SImode:
          if (!register_operand (operands[4], E_V1024SImode)
              || GET_MODE (x9) != E_V1024SImode
              || !register_operand (operands[5], E_SImode))
            return -1;
          if ((
#line 4950 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V1024SImode)) && 
#line 765 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return 12942; /* *pred_cmpv1024si_scalar */
          if (!(
#line 4972 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V1024SImode)) && 
#line 765 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 12996; /* *pred_cmpv1024si_scalar_narrow */

        default:
          return -1;
        }

    case E_V2048BImode:
      x2 = XEXP (x1, 1);
      if (pattern566 (x2, 
E_V2048BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      operands[2] = x3;
      if (register_operand (operands[1], E_V2048BImode))
        {
          res = recog_1416 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[3] = x3;
      if (!vector_mask_operand (operands[1], E_V2048BImode))
        return -1;
      x4 = XEXP (x2, 0);
      x5 = XVECEXP (x4, 0, 1);
      operands[6] = x5;
      x6 = XVECEXP (x4, 0, 2);
      operands[7] = x6;
      x7 = XVECEXP (x4, 0, 3);
      operands[8] = x7;
      x8 = XEXP (x3, 0);
      operands[4] = x8;
      x9 = XEXP (x3, 1);
      x10 = XEXP (x9, 0);
      operands[5] = x10;
      x11 = XEXP (x2, 2);
      operands[2] = x11;
      if (!vector_merge_operand (operands[2], E_V2048BImode))
        return -1;
      switch (GET_MODE (operands[4]))
        {
        case E_V2048QImode:
          if (!register_operand (operands[4], E_V2048QImode)
              || GET_MODE (x9) != E_V2048QImode
              || !register_operand (operands[5], E_QImode))
            return -1;
          if ((
#line 4950 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V2048QImode)) && 
#line 741 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
            return 12918; /* *pred_cmpv2048qi_scalar */
          if (!(
#line 4972 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V2048QImode)) && 
#line 741 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 12972; /* *pred_cmpv2048qi_scalar_narrow */

        case E_V2048HImode:
          if (!register_operand (operands[4], E_V2048HImode)
              || GET_MODE (x9) != E_V2048HImode
              || !register_operand (operands[5], E_HImode))
            return -1;
          if ((
#line 4950 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V2048HImode)) && 
#line 754 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
            return 12931; /* *pred_cmpv2048hi_scalar */
          if (!(
#line 4972 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V2048HImode)) && 
#line 754 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 12985; /* *pred_cmpv2048hi_scalar_narrow */

        default:
          return -1;
        }

    case E_V4096BImode:
      x2 = XEXP (x1, 1);
      if (pattern566 (x2, 
E_V4096BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      operands[2] = x3;
      if (pattern620 (x2, 
E_V4096QImode, 
E_V4096BImode, 
E_QImode) == 0
          && (
#line 4925 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 742 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return 12865; /* *pred_cmpv4096qi_scalar_merge_tie_mask */
      operands[3] = x3;
      if (pattern621 (x2, 
E_V4096BImode, 
E_V4096QImode, 
E_QImode) != 0)
        return -1;
      if ((
#line 4950 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V4096QImode)) && 
#line 742 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return 12919; /* *pred_cmpv4096qi_scalar */
      if (!(
#line 4972 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V4096QImode)) && 
#line 742 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 12973; /* *pred_cmpv4096qi_scalar_narrow */

    default:
      return -1;
    }
}

 int
recog_1477 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case PLUS:
      if (GET_MODE (x4) != E_SImode
          || !register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode)
        return -1;
      x5 = XEXP (x4, 0);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          operands[1] = x5;
          if (register_operand (operands[1], E_SImode))
            {
              x6 = XEXP (x4, 1);
              operands[2] = x6;
              if (arith_operand (operands[2], E_SImode)
                  && 
#line 858 "../../../gcc/config/riscv/riscv.md"
(TARGET_64BIT))
                return 8; /* addsi3_extended */
            }
          if (pnum_clobbers == NULL
              || GET_CODE (x5) != SUBREG
              || maybe_ne (SUBREG_BYTE (x5), 0)
              || GET_MODE (x5) != E_SImode)
            return -1;
          x7 = XEXP (x5, 0);
          if (pattern415 (x7) != 0
              || !const_int_operand (operands[2], E_VOIDmode))
            return -1;
          x8 = XEXP (x7, 1);
          operands[3] = x8;
          if (!const_int_operand (operands[3], E_VOIDmode))
            return -1;
          x6 = XEXP (x4, 1);
          operands[4] = x6;
          if (!register_operand (operands[4], E_SImode)
              || !
#line 4553 "../../../gcc/config/riscv/riscv.md"
(TARGET_64BIT
   && (INTVAL (operands[3]) | ((1 << INTVAL (operands[2])) - 1)) == 0xffffffff))
            return -1;
          *pnum_clobbers = 1;
          return 491; /* *riscv.md:4543 */

        case ASHIFT:
          if (pnum_clobbers == NULL
              || GET_MODE (x5) != E_SImode)
            return -1;
          x7 = XEXP (x5, 0);
          operands[1] = x7;
          if (!register_operand (operands[1], E_SImode))
            return -1;
          x9 = XEXP (x5, 1);
          operands[2] = x9;
          if (!const_int_operand (operands[2], E_VOIDmode))
            return -1;
          x6 = XEXP (x4, 1);
          operands[3] = x6;
          if (!const_int_operand (operands[3], E_VOIDmode)
              || !
#line 4700 "../../../gcc/config/riscv/riscv.md"
((TARGET_64BIT && riscv_const_insns (operands[3], false) == 1)))
            return -1;
          *pnum_clobbers = 1;
          return 493; /* *riscv.md:4693 */

        case MULT:
          if (GET_MODE (x5) != E_SImode)
            return -1;
          x6 = XEXP (x4, 1);
          operands[3] = x6;
          if (!register_operand (operands[3], E_SImode))
            return -1;
          x7 = XEXP (x5, 0);
          switch (GET_CODE (x7))
            {
            case REG:
            case SUBREG:
              operands[1] = x7;
              if (!register_operand (operands[1], E_SImode))
                return -1;
              x9 = XEXP (x5, 1);
              operands[2] = x9;
              if (!register_operand (operands[2], E_SImode)
                  || !
#line 301 "../../../gcc/config/riscv/thead.md"
(TARGET_XTHEADMAC && TARGET_64BIT))
                return -1;
              return 903; /* *th_mulawsi */

            case SIGN_EXTEND:
              if (GET_MODE (x7) != E_SImode)
                return -1;
              x9 = XEXP (x5, 1);
              if (GET_CODE (x9) != SIGN_EXTEND
                  || GET_MODE (x9) != E_SImode)
                return -1;
              x10 = XEXP (x7, 0);
              operands[1] = x10;
              if (!register_operand (operands[1], E_HImode))
                return -1;
              x11 = XEXP (x9, 0);
              operands[2] = x11;
              if (!register_operand (operands[2], E_HImode)
                  || !
#line 339 "../../../gcc/config/riscv/thead.md"
(TARGET_XTHEADMAC && TARGET_64BIT))
                return -1;
              return 906; /* *th_sextw_maddhisi4 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case REG:
    case SUBREG:
    case MEM:
    case TRUNCATE:
      switch (GET_CODE (x4))
        {
        case REG:
        case SUBREG:
        case TRUNCATE:
          res = recog_14 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case MEM:
          if (GET_MODE (x4) == E_SImode)
            {
              x5 = XEXP (x4, 0);
              operands[1] = x5;
              if (absolute_symbolic_operand (operands[1], E_VOIDmode))
                {
                  switch (GET_MODE (operands[0]))
                    {
                    case E_HImode:
                      if (register_operand (operands[0], E_HImode)
                          && GET_MODE (x3) == E_HImode
                          && (
#line 36 "../../../gcc/config/riscv/pic.md"
(USE_LOAD_ADDRESS_MACRO (operands[1])) && 
#line 63 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                        return 815; /* *local_pic_load_ssi */
                      break;

                    case E_SImode:
                      if (register_operand (operands[0], E_SImode)
                          && GET_MODE (x3) == E_SImode
                          && (
#line 36 "../../../gcc/config/riscv/pic.md"
(USE_LOAD_ADDRESS_MACRO (operands[1])) && 
#line 63 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                        return 816; /* *local_pic_load_ssi */
                      break;

                    default:
                      break;
                    }
                }
            }
          break;

        default:
          break;
        }
      operands[1] = x4;
      res = recog_11 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      if (GET_CODE (x4) == MEM)
        {
          res = recog_12 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[1] = x4;
      res = recog_13 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      if (GET_CODE (x4) != SUBREG
          || pattern232 (x3) != 0)
        return -1;
      if (vector_length_operand (operands[1], E_SImode)
          && (
#line 1828 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && TARGET_64BIT) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)))
        return 3649; /* *vsetvldi_no_side_effects_si_extend */
      if (!vector_length_operand (operands[1], E_DImode)
          || !(
#line 1828 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && TARGET_64BIT) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)))
        return -1;
      return 3650; /* *vsetvldi_no_side_effects_si_extend */

    case MINUS:
      if (GET_MODE (x4) != E_SImode
          || !register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode)
        return -1;
      x6 = XEXP (x4, 1);
      switch (GET_CODE (x6))
        {
        case REG:
        case SUBREG:
          operands[2] = x6;
          if (!register_operand (operands[2], E_SImode))
            return -1;
          x5 = XEXP (x4, 0);
          operands[1] = x5;
          if (!reg_or_0_operand (operands[1], E_SImode)
              || !
#line 1039 "../../../gcc/config/riscv/riscv.md"
(TARGET_64BIT))
            return -1;
          return 17; /* subsi3_extended */

        case MULT:
          if (GET_MODE (x6) != E_SImode)
            return -1;
          x5 = XEXP (x4, 0);
          operands[3] = x5;
          if (!register_operand (operands[3], E_SImode))
            return -1;
          x12 = XEXP (x6, 0);
          switch (GET_CODE (x12))
            {
            case REG:
            case SUBREG:
              operands[1] = x12;
              if (!register_operand (operands[1], E_SImode))
                return -1;
              x13 = XEXP (x6, 1);
              operands[2] = x13;
              if (!register_operand (operands[2], E_SImode)
                  || !
#line 362 "../../../gcc/config/riscv/thead.md"
(TARGET_XTHEADMAC && TARGET_64BIT))
                return -1;
              return 909; /* *th_mulswsi */

            case SIGN_EXTEND:
              if (GET_MODE (x12) != E_SImode)
                return -1;
              x13 = XEXP (x6, 1);
              if (GET_CODE (x13) != SIGN_EXTEND
                  || GET_MODE (x13) != E_SImode)
                return -1;
              x14 = XEXP (x12, 0);
              operands[1] = x14;
              if (!register_operand (operands[1], E_HImode))
                return -1;
              x15 = XEXP (x13, 0);
              operands[2] = x15;
              if (!register_operand (operands[2], E_HImode)
                  || !
#line 397 "../../../gcc/config/riscv/thead.md"
(TARGET_XTHEADMAC && TARGET_64BIT))
                return -1;
              return 912; /* *th_sextw_msubhisi4 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case NEG:
      if (pattern132 (x3) != 0
          || !
#line 1092 "../../../gcc/config/riscv/riscv.md"
(TARGET_64BIT))
        return -1;
      return 21; /* negsi2_extended */

    case MULT:
      if (pattern133 (x3) != 0
          || !
#line 1256 "../../../gcc/config/riscv/riscv.md"
((TARGET_ZMMUL || TARGET_MUL) && TARGET_64BIT))
        return -1;
      return 28; /* mulsi3_extended */

    case DIV:
      if (pattern133 (x3) != 0
          || !
#line 1469 "../../../gcc/config/riscv/riscv.md"
(TARGET_DIV && TARGET_64BIT))
        return -1;
      return 44; /* divsi3_extended */

    case UDIV:
      if (pattern133 (x3) != 0
          || !
#line 1469 "../../../gcc/config/riscv/riscv.md"
(TARGET_DIV && TARGET_64BIT))
        return -1;
      return 45; /* udivsi3_extended */

    case MOD:
      if (pattern133 (x3) != 0
          || !
#line 1469 "../../../gcc/config/riscv/riscv.md"
(TARGET_DIV && TARGET_64BIT))
        return -1;
      return 46; /* modsi3_extended */

    case UMOD:
      if (pattern133 (x3) != 0
          || !
#line 1469 "../../../gcc/config/riscv/riscv.md"
(TARGET_DIV && TARGET_64BIT))
        return -1;
      return 47; /* umodsi3_extended */

    case FIX:
      switch (pattern134 (x3))
        {
        case 0:
          if (!(
#line 2120 "../../../gcc/config/riscv/riscv.md"
(TARGET_64BIT && (TARGET_HARD_FLOAT || TARGET_ZFINX)) && 
#line 105 "../../../gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX)))
            return -1;
          return 152; /* fix_truncsfsi2_sext */

        case 1:
          if (!(
#line 2120 "../../../gcc/config/riscv/riscv.md"
(TARGET_64BIT && (TARGET_HARD_FLOAT || TARGET_ZFINX)) && 
#line 106 "../../../gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX)))
            return -1;
          return 154; /* fix_truncdfsi2_sext */

        case 2:
          if (!(
#line 2120 "../../../gcc/config/riscv/riscv.md"
(TARGET_64BIT && (TARGET_HARD_FLOAT || TARGET_ZFINX)) && 
#line 107 "../../../gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX)))
            return -1;
          return 156; /* fix_trunchfsi2_sext */

        default:
          return -1;
        }

    case UNSIGNED_FIX:
      switch (pattern134 (x3))
        {
        case 0:
          if (!(
#line 2120 "../../../gcc/config/riscv/riscv.md"
(TARGET_64BIT && (TARGET_HARD_FLOAT || TARGET_ZFINX)) && 
#line 105 "../../../gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX)))
            return -1;
          return 153; /* fixuns_truncsfsi2_sext */

        case 1:
          if (!(
#line 2120 "../../../gcc/config/riscv/riscv.md"
(TARGET_64BIT && (TARGET_HARD_FLOAT || TARGET_ZFINX)) && 
#line 106 "../../../gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX)))
            return -1;
          return 155; /* fixuns_truncdfsi2_sext */

        case 2:
          if (!(
#line 2120 "../../../gcc/config/riscv/riscv.md"
(TARGET_64BIT && (TARGET_HARD_FLOAT || TARGET_ZFINX)) && 
#line 107 "../../../gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX)))
            return -1;
          return 157; /* fixuns_trunchfsi2_sext */

        default:
          return -1;
        }

    case UNSPEC:
      return recog_16 (x1, insn, pnum_clobbers);

    case ASHIFT:
      switch (pattern135 (x3))
        {
        case 0:
          x6 = XEXP (x4, 1);
          operands[2] = x6;
          if (arith_operand (operands[2], E_QImode)
              && 
#line 2948 "../../../gcc/config/riscv/riscv.md"
(TARGET_64BIT))
            return 314; /* ashlsi3_extend */
          if (!subreg_lowpart_operator (x6, E_VOIDmode))
            return -1;
          switch (pattern396 (x6))
            {
            case 0:
              if (!
#line 2967 "../../../gcc/config/riscv/riscv.md"
(TARGET_64BIT))
                return -1;
              return 317; /* *ashlsi3_extend_mask */

            case 1:
              if (!
#line 2967 "../../../gcc/config/riscv/riscv.md"
(TARGET_64BIT))
                return -1;
              return 320; /* *ashlsi3_extend_mask */

            default:
              return -1;
            }

        case 1:
          x6 = XEXP (x4, 1);
          if (GET_CODE (x6) != SUBREG)
            return -1;
          switch (pattern387 (x6, pnum_clobbers))
            {
            case 0:
              if ((
#line 636 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (TARGET_ZBB || TARGET_ZBKB)
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                {
                  *pnum_clobbers = 1;
                  return 589; /* *bitmanip.md:628 */
                }
              if (!(
#line 636 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (TARGET_ZBB || TARGET_ZBKB)
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return -1;
              *pnum_clobbers = 1;
              return 591; /* *bitmanip.md:628 */

            case 1:
              if (!
#line 659 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (INTVAL (operands[2]) & 0x1f) != 0x1f))
                return -1;
              return 593; /* *bitmanip.md:652 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ASHIFTRT:
      if (pattern132 (x3) != 0)
        return -1;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      if (arith_operand (operands[2], E_QImode)
          && 
#line 2948 "../../../gcc/config/riscv/riscv.md"
(TARGET_64BIT))
        return 315; /* ashrsi3_extend */
      if (!subreg_lowpart_operator (x6, E_VOIDmode))
        return -1;
      switch (pattern396 (x6))
        {
        case 0:
          if (!
#line 2967 "../../../gcc/config/riscv/riscv.md"
(TARGET_64BIT))
            return -1;
          return 318; /* *ashrsi3_extend_mask */

        case 1:
          if (!
#line 2967 "../../../gcc/config/riscv/riscv.md"
(TARGET_64BIT))
            return -1;
          return 321; /* *ashrsi3_extend_mask */

        default:
          return -1;
        }

    case LSHIFTRT:
      if (pattern132 (x3) != 0)
        return -1;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      if (arith_operand (operands[2], E_QImode)
          && 
#line 2948 "../../../gcc/config/riscv/riscv.md"
(TARGET_64BIT))
        return 316; /* lshrsi3_extend */
      if (!subreg_lowpart_operator (x6, E_VOIDmode))
        return -1;
      switch (pattern396 (x6))
        {
        case 0:
          if (!
#line 2967 "../../../gcc/config/riscv/riscv.md"
(TARGET_64BIT))
            return -1;
          return 319; /* *lshrsi3_extend_mask */

        case 1:
          if (!
#line 2967 "../../../gcc/config/riscv/riscv.md"
(TARGET_64BIT))
            return -1;
          return 322; /* *lshrsi3_extend_mask */

        default:
          return -1;
        }

    case CLZ:
      if (pattern132 (x3) != 0
          || !
#line 283 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT && TARGET_ZBB))
        return -1;
      return 528; /* *clzdisi2 */

    case CTZ:
      if (pattern132 (x3) != 0
          || !
#line 283 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT && TARGET_ZBB))
        return -1;
      return 529; /* *ctzdisi2 */

    case POPCOUNT:
      if (pattern132 (x3) != 0
          || !
#line 283 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT && TARGET_ZBB))
        return -1;
      return 530; /* *popcountdisi2 */

    case ROTATERT:
      if (pattern132 (x3) != 0)
        return -1;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      if (arith_operand (operands[2], E_QImode)
          && 
#line 378 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT && (TARGET_ZBB || TARGET_ZBKB)))
        return 550; /* rotrsi3_sext */
      if (!subreg_lowpart_operator (x6, E_VOIDmode))
        return -1;
      switch (pattern396 (x6))
        {
        case 0:
          if (!
#line 450 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT && (TARGET_ZBB || TARGET_ZBKB)))
            return -1;
          return 563; /* *rotrsi3_sext_mask */

        case 1:
          if (!(
#line 450 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT && (TARGET_ZBB || TARGET_ZBKB)) && 
#line 27 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 565; /* *rotrsi3_sext_mask */

        default:
          return -1;
        }

    case ROTATE:
      if (pattern132 (x3) != 0)
        return -1;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      if (register_operand (operands[2], E_QImode)
          && 
#line 420 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT && (TARGET_ZBB || TARGET_ZBKB)))
        return 553; /* rotlsi3_sext */
      if (!subreg_lowpart_operator (x6, E_VOIDmode))
        return -1;
      switch (pattern396 (x6))
        {
        case 0:
          if (!
#line 450 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT && (TARGET_ZBB || TARGET_ZBKB)))
            return -1;
          return 562; /* *rotlsi3_sext_mask */

        case 1:
          if (!(
#line 450 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT && (TARGET_ZBB || TARGET_ZBKB)) && 
#line 27 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 564; /* *rotlsi3_sext_mask */

        default:
          return -1;
        }

    case IOR:
      if (GET_MODE (x4) != E_SImode)
        return -1;
      x5 = XEXP (x4, 0);
      if (GET_CODE (x5) != ASHIFT
          || GET_MODE (x5) != E_SImode)
        return -1;
      x9 = XEXP (x5, 1);
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
        return -1;
      x6 = XEXP (x4, 1);
      if (GET_CODE (x6) != ZERO_EXTEND
          || GET_MODE (x6) != E_SImode
          || !register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode)
        return -1;
      x7 = XEXP (x5, 0);
      operands[1] = x7;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x12 = XEXP (x6, 0);
      operands[2] = x12;
      if (!register_operand (operands[2], E_HImode)
          || !
#line 184 "../../../gcc/config/riscv/crypto.md"
(TARGET_ZBKB && TARGET_64BIT))
        return -1;
      return 678; /* *riscv_packw_2 */

    default:
      return -1;
    }
}

 int
recog_1479 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern101 (x1))
    {
    case 0:
      if (reg_or_0_operand (operands[1], E_SImode)
          && 
#line 2138 "../../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX))
        return 164; /* floatsisf2 */
      if (!reg_or_0_operand (operands[1], E_DImode)
          || !(
#line 2138 "../../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && (
#line 105 "../../../gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && 
#line 27 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT))))
        return -1;
      return 165; /* floatdisf2 */

    case 1:
      if (reg_or_0_operand (operands[1], E_SImode)
          && (
#line 2138 "../../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && 
#line 106 "../../../gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX)))
        return 166; /* floatsidf2 */
      if (!reg_or_0_operand (operands[1], E_DImode)
          || !(
#line 2138 "../../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && (
#line 106 "../../../gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX) && 
#line 27 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT))))
        return -1;
      return 167; /* floatdidf2 */

    case 2:
      if (reg_or_0_operand (operands[1], E_SImode)
          && (
#line 2138 "../../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && 
#line 107 "../../../gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX)))
        return 168; /* floatsihf2 */
      if (!reg_or_0_operand (operands[1], E_DImode)
          || !(
#line 2138 "../../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && (
#line 107 "../../../gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX) && 
#line 27 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT))))
        return -1;
      return 169; /* floatdihf2 */

    case 3:
      if (!(
#line 937 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 26491; /* floatrvvm8hirvvm8hf2 */

    case 4:
      if (!(
#line 985 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 26647; /* floatrvvm4qirvvm8hf2 */

    case 5:
      if (!(
#line 937 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 26493; /* floatrvvm4hirvvm4hf2 */

    case 6:
      if (!(
#line 985 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 26649; /* floatrvvm2qirvvm4hf2 */

    case 7:
      if (!(
#line 1029 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1056 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 26839; /* floatrvvm8sirvvm4hf2 */

    case 8:
      if (!(
#line 937 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 26495; /* floatrvvm2hirvvm2hf2 */

    case 9:
      if (!(
#line 985 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 26651; /* floatrvvm1qirvvm2hf2 */

    case 10:
      if (!(
#line 1029 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1056 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 26841; /* floatrvvm4sirvvm2hf2 */

    case 11:
      if (!(
#line 937 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 26497; /* floatrvvm1hirvvm1hf2 */

    case 12:
      if (!(
#line 985 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 26653; /* floatrvvmf2qirvvm1hf2 */

    case 13:
      if (!(
#line 1029 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1056 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 26843; /* floatrvvm2sirvvm1hf2 */

    case 14:
      if (!(
#line 937 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 26499; /* floatrvvmf2hirvvmf2hf2 */

    case 15:
      if (!(
#line 985 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 26655; /* floatrvvmf4qirvvmf2hf2 */

    case 16:
      if (!(
#line 1029 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1056 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 26845; /* floatrvvm1sirvvmf2hf2 */

    case 17:
      if (!(
#line 937 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 157 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
        return -1;
      return 26501; /* floatrvvmf4hirvvmf4hf2 */

    case 18:
      if (!(
#line 985 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 157 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)))
        return -1;
      return 26657; /* floatrvvmf8qirvvmf4hf2 */

    case 19:
      if (!(
#line 1029 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1057 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 26847; /* floatrvvmf2sirvvmf4hf2 */

    case 20:
      if (!(
#line 937 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26503; /* floatrvvm8sirvvm8sf2 */

    case 21:
      if (!(
#line 985 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26659; /* floatrvvm4hirvvm8sf2 */

    case 22:
      if (!(
#line 937 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26505; /* floatrvvm4sirvvm4sf2 */

    case 23:
      if (!(
#line 985 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26661; /* floatrvvm2hirvvm4sf2 */

    case 24:
      if (!(
#line 1029 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1059 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26849; /* floatrvvm8dirvvm4sf2 */

    case 25:
      if (!(
#line 937 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26507; /* floatrvvm2sirvvm2sf2 */

    case 26:
      if (!(
#line 985 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26663; /* floatrvvm1hirvvm2sf2 */

    case 27:
      if (!(
#line 1029 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1060 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26851; /* floatrvvm4dirvvm2sf2 */

    case 28:
      if (!(
#line 937 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26509; /* floatrvvm1sirvvm1sf2 */

    case 29:
      if (!(
#line 985 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26665; /* floatrvvmf2hirvvm1sf2 */

    case 30:
      if (!(
#line 1029 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1061 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26853; /* floatrvvm2dirvvm1sf2 */

    case 31:
      if (!(
#line 937 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 26511; /* floatrvvmf2sirvvmf2sf2 */

    case 32:
      if (!(
#line 985 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
        return -1;
      return 26667; /* floatrvvmf4hirvvmf2sf2 */

    case 33:
      if (!(
#line 1029 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1062 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26855; /* floatrvvm1dirvvmf2sf2 */

    case 34:
      if (!(
#line 937 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 26513; /* floatrvvm8dirvvm8df2 */

    case 35:
      if (!(
#line 985 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 26669; /* floatrvvm4sirvvm8df2 */

    case 36:
      if (!(
#line 937 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 26515; /* floatrvvm4dirvvm4df2 */

    case 37:
      if (!(
#line 985 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 26671; /* floatrvvm2sirvvm4df2 */

    case 38:
      if (!(
#line 937 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 26517; /* floatrvvm2dirvvm2df2 */

    case 39:
      if (!(
#line 985 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 26673; /* floatrvvm1sirvvm2df2 */

    case 40:
      if (!(
#line 937 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 26519; /* floatrvvm1dirvvm1df2 */

    case 41:
      if (!(
#line 985 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 26675; /* floatrvvmf2sirvvm1df2 */

    case 42:
      if (!(
#line 937 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 236 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
        return -1;
      return 26521; /* floatv1hiv1hf2 */

    case 43:
      if (!(
#line 985 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 236 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
        return -1;
      return 26677; /* floatv1qiv1hf2 */

    case 44:
      if (!(
#line 1029 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1064 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode) && TARGET_ZVFH)))
        return -1;
      return 26857; /* floatv1siv1hf2 */

    case 45:
      if (!(
#line 937 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 237 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
        return -1;
      return 26523; /* floatv2hiv2hf2 */

    case 46:
      if (!(
#line 985 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 237 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
        return -1;
      return 26679; /* floatv2qiv2hf2 */

    case 47:
      if (!(
#line 1029 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1065 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode) && TARGET_ZVFH)))
        return -1;
      return 26859; /* floatv2siv2hf2 */

    case 48:
      if (!(
#line 937 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 238 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
        return -1;
      return 26525; /* floatv4hiv4hf2 */

    case 49:
      if (!(
#line 985 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 238 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
        return -1;
      return 26681; /* floatv4qiv4hf2 */

    case 50:
      if (!(
#line 1029 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1066 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode) && TARGET_ZVFH)))
        return -1;
      return 26861; /* floatv4siv4hf2 */

    case 51:
      if (!(
#line 937 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 239 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
        return -1;
      return 26527; /* floatv8hiv8hf2 */

    case 52:
      if (!(
#line 985 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 239 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
        return -1;
      return 26683; /* floatv8qiv8hf2 */

    case 53:
      if (!(
#line 1029 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1067 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode) && TARGET_ZVFH)))
        return -1;
      return 26863; /* floatv8siv8hf2 */

    case 54:
      if (!(
#line 937 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 240 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
        return -1;
      return 26529; /* floatv16hiv16hf2 */

    case 55:
      if (!(
#line 985 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 240 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
        return -1;
      return 26685; /* floatv16qiv16hf2 */

    case 56:
      if (!(
#line 1029 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1068 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 26865; /* floatv16siv16hf2 */

    case 57:
      if (!(
#line 937 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 241 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 26531; /* floatv32hiv32hf2 */

    case 58:
      if (!(
#line 985 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 241 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 26687; /* floatv32qiv32hf2 */

    case 59:
      if (!(
#line 1029 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1069 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 26867; /* floatv32siv32hf2 */

    case 60:
      if (!(
#line 937 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 242 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 26533; /* floatv64hiv64hf2 */

    case 61:
      if (!(
#line 985 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 242 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 26689; /* floatv64qiv64hf2 */

    case 62:
      if (!(
#line 1029 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1070 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 26869; /* floatv64siv64hf2 */

    case 63:
      if (!(
#line 937 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 243 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 26535; /* floatv128hiv128hf2 */

    case 64:
      if (!(
#line 985 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 243 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 26691; /* floatv128qiv128hf2 */

    case 65:
      if (!(
#line 1029 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1071 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 26871; /* floatv128siv128hf2 */

    case 66:
      if (!(
#line 937 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 244 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 26537; /* floatv256hiv256hf2 */

    case 67:
      if (!(
#line 985 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 244 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 26693; /* floatv256qiv256hf2 */

    case 68:
      if (!(
#line 1029 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1072 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 26873; /* floatv256siv256hf2 */

    case 69:
      if (!(
#line 937 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 245 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 26539; /* floatv512hiv512hf2 */

    case 70:
      if (!(
#line 985 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 245 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 26695; /* floatv512qiv512hf2 */

    case 71:
      if (!(
#line 1029 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1073 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 26875; /* floatv512siv512hf2 */

    case 72:
      if (!(
#line 937 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 246 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 26541; /* floatv1024hiv1024hf2 */

    case 73:
      if (!(
#line 985 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 246 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 26697; /* floatv1024qiv1024hf2 */

    case 74:
      if (!(
#line 1029 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1074 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 26877; /* floatv1024siv1024hf2 */

    case 75:
      if (!(
#line 937 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 247 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 26543; /* floatv2048hiv2048hf2 */

    case 76:
      if (!(
#line 985 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 247 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 26699; /* floatv2048qiv2048hf2 */

    case 77:
      if (!(
#line 937 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 248 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26545; /* floatv1siv1sf2 */

    case 78:
      if (!(
#line 985 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 248 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26701; /* floatv1hiv1sf2 */

    case 79:
      if (!(
#line 1029 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1075 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26879; /* floatv1div1sf2 */

    case 80:
      if (!(
#line 937 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 249 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26547; /* floatv2siv2sf2 */

    case 81:
      if (!(
#line 985 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 249 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26703; /* floatv2hiv2sf2 */

    case 82:
      if (!(
#line 1029 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1076 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26881; /* floatv2div2sf2 */

    case 83:
      if (!(
#line 937 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 250 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26549; /* floatv4siv4sf2 */

    case 84:
      if (!(
#line 985 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 250 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26705; /* floatv4hiv4sf2 */

    case 85:
      if (!(
#line 1029 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1077 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26883; /* floatv4div4sf2 */

    case 86:
      if (!(
#line 937 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 251 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26551; /* floatv8siv8sf2 */

    case 87:
      if (!(
#line 985 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 251 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26707; /* floatv8hiv8sf2 */

    case 88:
      if (!(
#line 1029 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1078 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 26885; /* floatv8div8sf2 */

    case 89:
      if (!(
#line 937 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 252 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 26553; /* floatv16siv16sf2 */

    case 90:
      if (!(
#line 985 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 252 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 26709; /* floatv16hiv16sf2 */

    case 91:
      if (!(
#line 1029 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1079 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 26887; /* floatv16div16sf2 */

    case 92:
      if (!(
#line 937 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 253 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 26555; /* floatv32siv32sf2 */

    case 93:
      if (!(
#line 985 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 253 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 26711; /* floatv32hiv32sf2 */

    case 94:
      if (!(
#line 1029 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1080 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 26889; /* floatv32div32sf2 */

    case 95:
      if (!(
#line 937 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 254 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 26557; /* floatv64siv64sf2 */

    case 96:
      if (!(
#line 985 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 254 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 26713; /* floatv64hiv64sf2 */

    case 97:
      if (!(
#line 1029 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1081 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 26891; /* floatv64div64sf2 */

    case 98:
      if (!(
#line 937 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 255 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 26559; /* floatv128siv128sf2 */

    case 99:
      if (!(
#line 985 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 255 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 26715; /* floatv128hiv128sf2 */

    case 100:
      if (!(
#line 1029 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1082 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 26893; /* floatv128div128sf2 */

    case 101:
      if (!(
#line 937 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 256 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 26561; /* floatv256siv256sf2 */

    case 102:
      if (!(
#line 985 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 256 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 26717; /* floatv256hiv256sf2 */

    case 103:
      if (!(
#line 1029 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1083 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 26895; /* floatv256div256sf2 */

    case 104:
      if (!(
#line 937 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 257 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 26563; /* floatv512siv512sf2 */

    case 105:
      if (!(
#line 985 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 257 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 26719; /* floatv512hiv512sf2 */

    case 106:
      if (!(
#line 1029 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1084 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 26897; /* floatv512div512sf2 */

    case 107:
      if (!(
#line 937 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 258 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 26565; /* floatv1024siv1024sf2 */

    case 108:
      if (!(
#line 985 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 258 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 26721; /* floatv1024hiv1024sf2 */

    case 109:
      if (!(
#line 937 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 259 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 26567; /* floatv1div1df2 */

    case 110:
      if (!(
#line 985 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 259 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 26723; /* floatv1siv1df2 */

    case 111:
      if (!(
#line 937 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 260 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 26569; /* floatv2div2df2 */

    case 112:
      if (!(
#line 985 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 260 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 26725; /* floatv2siv2df2 */

    case 113:
      if (!(
#line 937 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 261 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 26571; /* floatv4div4df2 */

    case 114:
      if (!(
#line 985 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 261 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 26727; /* floatv4siv4df2 */

    case 115:
      if (!(
#line 937 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 262 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 26573; /* floatv8div8df2 */

    case 116:
      if (!(
#line 985 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 262 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 26729; /* floatv8siv8df2 */

    case 117:
      if (!(
#line 937 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 263 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 26575; /* floatv16div16df2 */

    case 118:
      if (!(
#line 985 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 263 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 26731; /* floatv16siv16df2 */

    case 119:
      if (!(
#line 937 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 264 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 26577; /* floatv32div32df2 */

    case 120:
      if (!(
#line 985 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 264 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 26733; /* floatv32siv32df2 */

    case 121:
      if (!(
#line 937 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 265 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 26579; /* floatv64div64df2 */

    case 122:
      if (!(
#line 985 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 265 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 26735; /* floatv64siv64df2 */

    case 123:
      if (!(
#line 937 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 266 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 26581; /* floatv128div128df2 */

    case 124:
      if (!(
#line 985 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 266 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 26737; /* floatv128siv128df2 */

    case 125:
      if (!(
#line 937 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 267 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 26583; /* floatv256div256df2 */

    case 126:
      if (!(
#line 985 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 267 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 26739; /* floatv256siv256df2 */

    case 127:
      if (!(
#line 937 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 268 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 26585; /* floatv512div512df2 */

    case 128:
      if (!(
#line 985 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 268 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 26741; /* floatv512siv512df2 */

    default:
      return -1;
    }
}

 int
recog_1489 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      return recog_107 (x1, insn, pnum_clobbers);

    case ASHIFT:
      x5 = XEXP (x4, 0);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          operands[1] = x5;
          x6 = XEXP (x4, 1);
          operands[2] = x6;
          if (!immediate_operand (operands[2], E_VOIDmode))
            return -1;
          x7 = XEXP (x3, 1);
          switch (GET_CODE (x7))
            {
            case CONST_INT:
            case CONST_WIDE_INT:
            case CONST_POLY_INT:
            case CONST_FIXED:
            case CONST_DOUBLE:
            case CONST_VECTOR:
            case CONST:
            case LABEL_REF:
            case SYMBOL_REF:
            case HIGH:
              switch (pattern225 (x3))
                {
                case 0:
                  if (!(
#line 2992 "../../../gcc/config/riscv/riscv.md"
((!SMALL_OPERAND (INTVAL (operands[3]))
    && SMALL_OPERAND (INTVAL (operands[3]) >> INTVAL (operands[2]))
    && (!TARGET_ZBS || popcount_hwi (INTVAL (operands[3])) > 1)
    && (INTVAL (operands[3]) & ((1ULL << INTVAL (operands[2])) - 1)) == 0)) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                    return -1;
                  return 324; /* ior_shift_reversesi */

                case 1:
                  if (!(
#line 2992 "../../../gcc/config/riscv/riscv.md"
((!SMALL_OPERAND (INTVAL (operands[3]))
    && SMALL_OPERAND (INTVAL (operands[3]) >> INTVAL (operands[2]))
    && (!TARGET_ZBS || popcount_hwi (INTVAL (operands[3])) > 1)
    && (INTVAL (operands[3]) & ((1ULL << INTVAL (operands[2])) - 1)) == 0)) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                    return -1;
                  return 327; /* ior_shift_reversedi */

                default:
                  return -1;
                }

            case ZERO_EXTEND:
              x8 = XEXP (x7, 0);
              operands[3] = x8;
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (pattern408 (x3, 
E_HImode, 
E_SImode) != 0
                      || !(
#line 116 "../../../gcc/config/riscv/crypto.md"
(TARGET_ZBKB && INTVAL (operands[2]) == BITS_PER_WORD / 2) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                    return -1;
                  return 669; /* riscv_xpack_si_hi_2 */

                case E_DImode:
                  if (pattern408 (x3, 
E_SImode, 
E_DImode) != 0
                      || !(
#line 116 "../../../gcc/config/riscv/crypto.md"
(TARGET_ZBKB && INTVAL (operands[2]) == BITS_PER_WORD / 2) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                    return -1;
                  return 670; /* riscv_xpack_di_si_2 */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case CONST_INT:
          if (XWINT (x5, 0) != 1L)
            return -1;
          x6 = XEXP (x4, 1);
          operands[2] = x6;
          switch (pattern287 (x3))
            {
            case 0:
              if ((
#line 587 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBS) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                return 578; /* *bsetsi */
              break;

            case 1:
              if ((
#line 587 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBS) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return 580; /* *bsetdi */
              break;

            default:
              break;
            }
          if (GET_CODE (x6) != SUBREG)
            return -1;
          switch (pattern331 (x3))
            {
            case 0:
              if (!(
#line 600 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBS) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                return -1;
              return 582; /* *bsetsi_mask */

            case 1:
              if (!(
#line 600 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBS) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return -1;
              return 584; /* *bsetdi_mask */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case NOT:
      x7 = XEXP (x3, 1);
      switch (GET_CODE (x7))
        {
        case REG:
        case SUBREG:
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern288 (x3, 
E_SImode) != 0
                  || !(
#line 230 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBB || TARGET_ZBKB) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                return -1;
              return 516; /* ior_notsi3 */

            case E_DImode:
              if (pattern288 (x3, 
E_DImode) != 0
                  || !(
#line 230 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBB || TARGET_ZBKB) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return -1;
              return 518; /* ior_notdi3 */

            case E_RVVMF64BImode:
              if (pattern289 (x3, 
E_RVVMF64BImode) != 0
                  || !(
#line 1419 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1533 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)))
                return -1;
              return 31980; /* *iornotrvvmf64bi */

            case E_RVVMF32BImode:
              if (pattern289 (x3, 
E_RVVMF32BImode) != 0
                  || !
#line 1419 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
                return -1;
              return 31982; /* *iornotrvvmf32bi */

            case E_RVVMF16BImode:
              if (pattern289 (x3, 
E_RVVMF16BImode) != 0
                  || !
#line 1419 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
                return -1;
              return 31984; /* *iornotrvvmf16bi */

            case E_RVVMF8BImode:
              if (pattern289 (x3, 
E_RVVMF8BImode) != 0
                  || !
#line 1419 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
                return -1;
              return 31986; /* *iornotrvvmf8bi */

            case E_RVVMF4BImode:
              if (pattern289 (x3, 
E_RVVMF4BImode) != 0
                  || !
#line 1419 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
                return -1;
              return 31988; /* *iornotrvvmf4bi */

            case E_RVVMF2BImode:
              if (pattern289 (x3, 
E_RVVMF2BImode) != 0
                  || !
#line 1419 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
                return -1;
              return 31990; /* *iornotrvvmf2bi */

            case E_RVVM1BImode:
              if (pattern289 (x3, 
E_RVVM1BImode) != 0
                  || !
#line 1419 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
                return -1;
              return 31992; /* *iornotrvvm1bi */

            case E_V1BImode:
              if (pattern289 (x3, 
E_V1BImode) != 0
                  || !(
#line 1419 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1518 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode))))
                return -1;
              return 31994; /* *iornotv1bi */

            case E_V2BImode:
              if (pattern289 (x3, 
E_V2BImode) != 0
                  || !(
#line 1419 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1519 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode))))
                return -1;
              return 31996; /* *iornotv2bi */

            case E_V4BImode:
              if (pattern289 (x3, 
E_V4BImode) != 0
                  || !(
#line 1419 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1520 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode))))
                return -1;
              return 31998; /* *iornotv4bi */

            case E_V8BImode:
              if (pattern289 (x3, 
E_V8BImode) != 0
                  || !(
#line 1419 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1521 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode))))
                return -1;
              return 32000; /* *iornotv8bi */

            case E_V16BImode:
              if (pattern289 (x3, 
E_V16BImode) != 0
                  || !(
#line 1419 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1522 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode))))
                return -1;
              return 32002; /* *iornotv16bi */

            case E_V32BImode:
              if (pattern289 (x3, 
E_V32BImode) != 0
                  || !(
#line 1419 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1523 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode))))
                return -1;
              return 32004; /* *iornotv32bi */

            case E_V64BImode:
              if (pattern289 (x3, 
E_V64BImode) != 0
                  || !(
#line 1419 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1524 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 32006; /* *iornotv64bi */

            case E_V128BImode:
              if (pattern289 (x3, 
E_V128BImode) != 0
                  || !(
#line 1419 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1525 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 32008; /* *iornotv128bi */

            case E_V256BImode:
              if (pattern289 (x3, 
E_V256BImode) != 0
                  || !(
#line 1419 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1526 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 32010; /* *iornotv256bi */

            case E_V512BImode:
              if (pattern289 (x3, 
E_V512BImode) != 0
                  || !(
#line 1419 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1527 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 32012; /* *iornotv512bi */

            case E_V1024BImode:
              if (pattern289 (x3, 
E_V1024BImode) != 0
                  || !(
#line 1419 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1528 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 32014; /* *iornotv1024bi */

            case E_V2048BImode:
              if (pattern289 (x3, 
E_V2048BImode) != 0
                  || !(
#line 1419 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1529 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 32016; /* *iornotv2048bi */

            case E_V4096BImode:
              if (pattern289 (x3, 
E_V4096BImode) != 0
                  || !(
#line 1419 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1530 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 32018; /* *iornotv4096bi */

            default:
              return -1;
            }

        case CONST_INT:
          switch (pattern259 (x3, pnum_clobbers))
            {
            case 0:
              if (!(
#line 240 "../../../gcc/config/riscv/bitmanip.md"
((TARGET_ZBB || TARGET_ZBKB) && !TARGET_ZCB
   && !optimize_function_for_size_p (cfun)) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                return -1;
              *pnum_clobbers = 1;
              return 520; /* *ior_not_constsi */

            case 1:
              if (!(
#line 240 "../../../gcc/config/riscv/bitmanip.md"
((TARGET_ZBB || TARGET_ZBKB) && !TARGET_ZCB
   && !optimize_function_for_size_p (cfun)) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return -1;
              *pnum_clobbers = 1;
              return 522; /* *ior_not_constdi */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case SIGN_EXTEND:
      switch (pattern194 (x3, pnum_clobbers))
        {
        case 0:
          if ((
#line 684 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (TARGET_ZBB || TARGET_ZBKB)
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            {
              *pnum_clobbers = 1;
              return 595; /* *bitmanip.md:673 */
            }
          if (!(
#line 684 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (TARGET_ZBB || TARGET_ZBKB)
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 599; /* *bitmanip.md:673 */

        case 1:
          if ((
#line 710 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            {
              *pnum_clobbers = 1;
              return 603; /* *bitmanip.md:699 */
            }
          if (!(
#line 710 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 607; /* *bitmanip.md:699 */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      switch (pattern194 (x3, pnum_clobbers))
        {
        case 0:
          if ((
#line 684 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (TARGET_ZBB || TARGET_ZBKB)
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            {
              *pnum_clobbers = 1;
              return 597; /* *bitmanip.md:673 */
            }
          if (!(
#line 684 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (TARGET_ZBB || TARGET_ZBKB)
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 601; /* *bitmanip.md:673 */

        case 1:
          if ((
#line 710 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            {
              *pnum_clobbers = 1;
              return 605; /* *bitmanip.md:699 */
            }
          if (!(
#line 710 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 609; /* *bitmanip.md:699 */

        default:
          return -1;
        }

    case AND:
      x5 = XEXP (x4, 0);
      if (GET_CODE (x5) != ASHIFT)
        return -1;
      x9 = XEXP (x5, 1);
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
        return -1;
      x6 = XEXP (x4, 1);
      if (GET_CODE (x6) != CONST_INT
          || XWINT (x6, 0) != 65280L)
        return -1;
      x7 = XEXP (x3, 1);
      if (GET_CODE (x7) != ZERO_EXTEND)
        return -1;
      x10 = XEXP (x5, 0);
      operands[1] = x10;
      x8 = XEXP (x7, 0);
      operands[2] = x8;
      if (!register_operand (operands[2], E_QImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern428 (x3, 
E_SImode) != 0
              || !(
#line 148 "../../../gcc/config/riscv/crypto.md"
(TARGET_ZBKB) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            return -1;
          return 675; /* *riscv_packh_si_3 */

        case E_DImode:
          if (pattern428 (x3, 
E_DImode) != 0
              || !(
#line 148 "../../../gcc/config/riscv/crypto.md"
(TARGET_ZBKB) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 676; /* *riscv_packh_di_3 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_1495 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern110 (x1))
    {
    case 0:
      if (!
#line 274 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBB))
        return -1;
      return 526; /* *ctzsi2 */

    case 1:
      if (!
#line 302 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT && TARGET_ZBB))
        return -1;
      return 538; /* *ctzdi2 */

    case 2:
      if (!
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB))
        return -1;
      return 33024; /* pred_vctzrvvm8qi */

    case 3:
      if (!
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB))
        return -1;
      return 33027; /* pred_vctzrvvm4qi */

    case 4:
      if (!
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB))
        return -1;
      return 33030; /* pred_vctzrvvm2qi */

    case 5:
      if (!
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB))
        return -1;
      return 33033; /* pred_vctzrvvm1qi */

    case 6:
      if (!
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB))
        return -1;
      return 33036; /* pred_vctzrvvm8hi */

    case 7:
      if (!
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB))
        return -1;
      return 33039; /* pred_vctzrvvm4hi */

    case 8:
      if (!
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB))
        return -1;
      return 33042; /* pred_vctzrvvm2hi */

    case 9:
      if (!
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB))
        return -1;
      return 33045; /* pred_vctzrvvm1hi */

    case 10:
      if (!
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB))
        return -1;
      return 33048; /* pred_vctzrvvm8si */

    case 11:
      if (!
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB))
        return -1;
      return 33051; /* pred_vctzrvvm4si */

    case 12:
      if (!
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB))
        return -1;
      return 33054; /* pred_vctzrvvm2si */

    case 13:
      if (!
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB))
        return -1;
      return 33057; /* pred_vctzrvvm1si */

    case 14:
      if (!(
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 33060; /* pred_vctzrvvm8di */

    case 15:
      if (!(
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 33063; /* pred_vctzrvvm4di */

    case 16:
      if (!(
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 33066; /* pred_vctzrvvm2di */

    case 17:
      if (!(
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 33069; /* pred_vctzrvvm1di */

    case 18:
      if (!(
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 33072; /* pred_vctzrvvmf2qi */

    case 19:
      if (!(
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 33075; /* pred_vctzrvvmf4qi */

    case 20:
      if (!(
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && (
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 33078; /* pred_vctzrvvmf8qi */

    case 21:
      if (!(
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 33081; /* pred_vctzrvvmf2hi */

    case 22:
      if (!(
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && (
#line 132 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 33084; /* pred_vctzrvvmf4hi */

    case 23:
      if (!(
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && (
#line 133 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 33087; /* pred_vctzrvvmf2si */

    case 24:
      if (!(
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 188 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 33090; /* pred_vctzv1qi */

    case 25:
      if (!(
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 189 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 33093; /* pred_vctzv2qi */

    case 26:
      if (!(
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 190 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 33096; /* pred_vctzv4qi */

    case 27:
      if (!(
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 191 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 33099; /* pred_vctzv8qi */

    case 28:
      if (!(
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 192 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 33102; /* pred_vctzv16qi */

    case 29:
      if (!(
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 193 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 33105; /* pred_vctzv32qi */

    case 30:
      if (!(
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 194 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 33108; /* pred_vctzv64qi */

    case 31:
      if (!(
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 195 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 33111; /* pred_vctzv128qi */

    case 32:
      if (!(
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 196 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 33114; /* pred_vctzv256qi */

    case 33:
      if (!(
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 197 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 33117; /* pred_vctzv512qi */

    case 34:
      if (!(
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 198 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 33120; /* pred_vctzv1024qi */

    case 35:
      if (!(
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 199 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 33123; /* pred_vctzv2048qi */

    case 36:
      if (!(
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 200 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 33126; /* pred_vctzv4096qi */

    case 37:
      if (!(
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 201 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 33129; /* pred_vctzv1hi */

    case 38:
      if (!(
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 202 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 33132; /* pred_vctzv2hi */

    case 39:
      if (!(
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 203 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 33135; /* pred_vctzv4hi */

    case 40:
      if (!(
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 204 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 33138; /* pred_vctzv8hi */

    case 41:
      if (!(
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 205 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 33141; /* pred_vctzv16hi */

    case 42:
      if (!(
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 206 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 33144; /* pred_vctzv32hi */

    case 43:
      if (!(
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 207 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 33147; /* pred_vctzv64hi */

    case 44:
      if (!(
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 208 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 33150; /* pred_vctzv128hi */

    case 45:
      if (!(
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 209 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 33153; /* pred_vctzv256hi */

    case 46:
      if (!(
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 210 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 33156; /* pred_vctzv512hi */

    case 47:
      if (!(
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 211 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 33159; /* pred_vctzv1024hi */

    case 48:
      if (!(
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 212 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 33162; /* pred_vctzv2048hi */

    case 49:
      if (!(
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 213 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 33165; /* pred_vctzv1si */

    case 50:
      if (!(
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 214 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 33168; /* pred_vctzv2si */

    case 51:
      if (!(
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 215 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 33171; /* pred_vctzv4si */

    case 52:
      if (!(
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 216 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 33174; /* pred_vctzv8si */

    case 53:
      if (!(
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 217 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 33177; /* pred_vctzv16si */

    case 54:
      if (!(
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 218 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 33180; /* pred_vctzv32si */

    case 55:
      if (!(
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 219 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 33183; /* pred_vctzv64si */

    case 56:
      if (!(
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 220 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 33186; /* pred_vctzv128si */

    case 57:
      if (!(
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 221 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 33189; /* pred_vctzv256si */

    case 58:
      if (!(
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 222 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 33192; /* pred_vctzv512si */

    case 59:
      if (!(
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 223 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 33195; /* pred_vctzv1024si */

    case 60:
      if (!(
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 224 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 33198; /* pred_vctzv1di */

    case 61:
      if (!(
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 225 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 33201; /* pred_vctzv2di */

    case 62:
      if (!(
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 226 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 33204; /* pred_vctzv4di */

    case 63:
      if (!(
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 227 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 33207; /* pred_vctzv8di */

    case 64:
      if (!(
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 228 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 33210; /* pred_vctzv16di */

    case 65:
      if (!(
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 229 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 33213; /* pred_vctzv32di */

    case 66:
      if (!(
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 230 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 33216; /* pred_vctzv64di */

    case 67:
      if (!(
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 231 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 33219; /* pred_vctzv128di */

    case 68:
      if (!(
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 232 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 33222; /* pred_vctzv256di */

    case 69:
      if (!(
#line 359 "../../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 233 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 33225; /* pred_vctzv512di */

    default:
      return -1;
    }
}

 int
recog_1503 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      return recog_23 (x1, insn, pnum_clobbers);

    case SIGN_EXTEND:
      return recog_24 (x1, insn, pnum_clobbers);

    case ZERO_EXTEND:
      return recog_25 (x1, insn, pnum_clobbers);

    case FLOAT_EXTEND:
      switch (pattern131 (x3))
        {
        case 0:
          if (!(
#line 729 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1023 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 30820; /* *dual_widen_mulrvvm8sf */

        case 1:
          if (!(
#line 729 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1024 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 30823; /* *dual_widen_mulrvvm4sf */

        case 2:
          if (!(
#line 729 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1025 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 30826; /* *dual_widen_mulrvvm2sf */

        case 3:
          if (!(
#line 729 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1026 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 30829; /* *dual_widen_mulrvvm1sf */

        case 4:
          if (!(
#line 729 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1027 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
            return -1;
          return 30832; /* *dual_widen_mulrvvmf2sf */

        case 5:
          if (!(
#line 729 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1029 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 30835; /* *dual_widen_mulrvvm8df */

        case 6:
          if (!(
#line 729 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1029 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 30838; /* *dual_widen_mulrvvm4df */

        case 7:
          if (!(
#line 729 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1030 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 30841; /* *dual_widen_mulrvvm2df */

        case 8:
          if (!(
#line 729 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1030 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 30844; /* *dual_widen_mulrvvm1df */

        case 9:
          if (!(
#line 729 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1032 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 30847; /* *dual_widen_mulv1sf */

        case 10:
          if (!(
#line 729 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1033 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 30850; /* *dual_widen_mulv2sf */

        case 11:
          if (!(
#line 729 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1034 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 30853; /* *dual_widen_mulv4sf */

        case 12:
          if (!(
#line 729 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1035 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 30856; /* *dual_widen_mulv8sf */

        case 13:
          if (!(
#line 729 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1036 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 30859; /* *dual_widen_mulv16sf */

        case 14:
          if (!(
#line 729 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1037 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 30862; /* *dual_widen_mulv32sf */

        case 15:
          if (!(
#line 729 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1038 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 30865; /* *dual_widen_mulv64sf */

        case 16:
          if (!(
#line 729 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1039 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 30868; /* *dual_widen_mulv128sf */

        case 17:
          if (!(
#line 729 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1040 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 30871; /* *dual_widen_mulv256sf */

        case 18:
          if (!(
#line 729 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1041 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 30874; /* *dual_widen_mulv512sf */

        case 19:
          if (!(
#line 729 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1042 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 30877; /* *dual_widen_mulv1024sf */

        case 20:
          if (!(
#line 729 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1043 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 30880; /* *dual_widen_mulv1df */

        case 21:
          if (!(
#line 729 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1044 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 30883; /* *dual_widen_mulv2df */

        case 22:
          if (!(
#line 729 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1045 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 30886; /* *dual_widen_mulv4df */

        case 23:
          if (!(
#line 729 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1046 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 30889; /* *dual_widen_mulv8df */

        case 24:
          if (!(
#line 729 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1047 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 30892; /* *dual_widen_mulv16df */

        case 25:
          if (!(
#line 729 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1048 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 30895; /* *dual_widen_mulv32df */

        case 26:
          if (!(
#line 729 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1049 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 30898; /* *dual_widen_mulv64df */

        case 27:
          if (!(
#line 729 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1050 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 30901; /* *dual_widen_mulv128df */

        case 28:
          if (!(
#line 729 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1051 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 30904; /* *dual_widen_mulv256df */

        case 29:
          if (!(
#line 729 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1052 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 30907; /* *dual_widen_mulv512df */

        case 30:
          if (!(
#line 784 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1023 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 30968; /* *single_widen_mulrvvm8sf */

        case 31:
          if (!(
#line 784 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1024 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 30969; /* *single_widen_mulrvvm4sf */

        case 32:
          if (!(
#line 784 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1025 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 30970; /* *single_widen_mulrvvm2sf */

        case 33:
          if (!(
#line 784 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1026 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 30971; /* *single_widen_mulrvvm1sf */

        case 34:
          if (!(
#line 784 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1027 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
            return -1;
          return 30972; /* *single_widen_mulrvvmf2sf */

        case 35:
          if (!(
#line 784 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1029 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 30973; /* *single_widen_mulrvvm8df */

        case 36:
          if (!(
#line 784 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1029 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 30974; /* *single_widen_mulrvvm4df */

        case 37:
          if (!(
#line 784 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1030 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 30975; /* *single_widen_mulrvvm2df */

        case 38:
          if (!(
#line 784 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1030 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 30976; /* *single_widen_mulrvvm1df */

        case 39:
          if (!(
#line 784 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1032 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 30977; /* *single_widen_mulv1sf */

        case 40:
          if (!(
#line 784 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1033 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 30978; /* *single_widen_mulv2sf */

        case 41:
          if (!(
#line 784 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1034 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 30979; /* *single_widen_mulv4sf */

        case 42:
          if (!(
#line 784 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1035 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 30980; /* *single_widen_mulv8sf */

        case 43:
          if (!(
#line 784 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1036 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 30981; /* *single_widen_mulv16sf */

        case 44:
          if (!(
#line 784 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1037 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 30982; /* *single_widen_mulv32sf */

        case 45:
          if (!(
#line 784 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1038 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 30983; /* *single_widen_mulv64sf */

        case 46:
          if (!(
#line 784 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1039 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 30984; /* *single_widen_mulv128sf */

        case 47:
          if (!(
#line 784 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1040 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 30985; /* *single_widen_mulv256sf */

        case 48:
          if (!(
#line 784 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1041 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 30986; /* *single_widen_mulv512sf */

        case 49:
          if (!(
#line 784 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1042 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 30987; /* *single_widen_mulv1024sf */

        case 50:
          if (!(
#line 784 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1043 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 30988; /* *single_widen_mulv1df */

        case 51:
          if (!(
#line 784 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1044 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 30989; /* *single_widen_mulv2df */

        case 52:
          if (!(
#line 784 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1045 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 30990; /* *single_widen_mulv4df */

        case 53:
          if (!(
#line 784 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1046 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 30991; /* *single_widen_mulv8df */

        case 54:
          if (!(
#line 784 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1047 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 30992; /* *single_widen_mulv16df */

        case 55:
          if (!(
#line 784 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1048 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 30993; /* *single_widen_mulv32df */

        case 56:
          if (!(
#line 784 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1049 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 30994; /* *single_widen_mulv64df */

        case 57:
          if (!(
#line 784 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1050 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 30995; /* *single_widen_mulv128df */

        case 58:
          if (!(
#line 784 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1051 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 30996; /* *single_widen_mulv256df */

        case 59:
          if (!(
#line 784 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1052 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 30997; /* *single_widen_mulv512df */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_1522 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  switch (XVECLEN (x3, 0))
    {
    case 1:
      switch (XINT (x3, 1))
        {
        case 9:
          x4 = XEXP (x2, 0);
          if (GET_CODE (x4) != REG
              || REGNO (x4) != 10)
            return -1;
          x5 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x5) != CLOBBER)
            return -1;
          x6 = XEXP (x5, 0);
          if (GET_CODE (x6) != REG
              || REGNO (x6) != 5)
            return -1;
          x7 = XVECEXP (x3, 0, 0);
          operands[0] = x7;
          switch (GET_MODE (x4))
            {
            case E_SImode:
              if (GET_MODE (x3) != E_SImode
                  || !symbolic_operand (operands[0], E_SImode)
                  || GET_MODE (x6) != E_SImode
                  || !(
#line 2400 "../../../gcc/config/riscv/riscv.md"
(TARGET_TLSDESC) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)))
                return -1;
              return 268; /* tlsdescsi */

            case E_DImode:
              if (GET_MODE (x3) != E_DImode
                  || !symbolic_operand (operands[0], E_DImode)
                  || GET_MODE (x6) != E_DImode
                  || !(
#line 2400 "../../../gcc/config/riscv/riscv.md"
(TARGET_TLSDESC) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)))
                return -1;
              return 269; /* tlsdescdi */

            default:
              return -1;
            }

        case 13:
          x5 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x5) != SET)
            return -1;
          x8 = XEXP (x5, 1);
          if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x4 = XEXP (x2, 0);
          operands[0] = x4;
          x7 = XVECEXP (x3, 0, 0);
          operands[1] = x7;
          x6 = XEXP (x5, 0);
          operands[2] = x6;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern417 (x3, 
E_SImode) != 0)
                return -1;
              return 475; /* stack_protect_set_si */

            case E_DImode:
              if (pattern417 (x3, 
E_DImode) != 0
                  || !
#line 27 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT))
                return -1;
              return 476; /* stack_protect_set_di */

            default:
              return -1;
            }

        case 88:
          if (GET_MODE (x3) != E_BLKmode)
            return -1;
          x4 = XEXP (x2, 0);
          operands[0] = x4;
          x5 = XVECEXP (x1, 0, 1);
          operands[1] = x5;
          if (!const_int_operand (operands[1], E_SImode))
            return -1;
          x7 = XVECEXP (x3, 0, 0);
          if (!rtx_equal_p (x7, operands[0]))
            return -1;
          if (
#line 28 "../../../gcc/config/riscv/sync-rvwmo.md"
(!TARGET_ZTSO))
            return 787; /* mem_thread_fence_rvwmo */
          if (!
#line 28 "../../../gcc/config/riscv/sync-ztso.md"
(TARGET_ZTSO))
            return -1;
          return 796; /* mem_thread_fence_ztso */

        default:
          return -1;
        }

    case 2:
      if (XINT (x3, 1) != 14)
        return -1;
      x5 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x5) != CLOBBER)
        return -1;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      x7 = XVECEXP (x3, 0, 0);
      operands[1] = x7;
      x9 = XVECEXP (x3, 0, 1);
      operands[2] = x9;
      x6 = XEXP (x5, 0);
      operands[3] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern418 (x3, 
E_SImode) != 0)
            return -1;
          return 477; /* stack_protect_test_si */

        case E_DImode:
          if (pattern418 (x3, 
E_DImode) != 0
              || !
#line 27 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT))
            return -1;
          return 478; /* stack_protect_test_di */

        default:
          return -1;
        }

    case 3:
      if (XINT (x3, 1) != 89
          || GET_MODE (x3) != E_SImode)
        return -1;
      x4 = XEXP (x2, 0);
      if (GET_CODE (x4) != REG
          || REGNO (x4) != 66
          || GET_MODE (x4) != E_SImode)
        return -1;
      x5 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x5) != SET)
        return -1;
      x8 = XEXP (x5, 1);
      if (GET_CODE (x8) != UNSPEC
          || XVECLEN (x8, 0) != 4
          || XINT (x8, 1) != 89
          || GET_MODE (x8) != E_SImode)
        return -1;
      x6 = XEXP (x5, 0);
      if (GET_CODE (x6) != REG
          || REGNO (x6) != 67
          || GET_MODE (x6) != E_SImode)
        return -1;
      x7 = XVECEXP (x3, 0, 0);
      operands[0] = x7;
      x9 = XVECEXP (x3, 0, 1);
      operands[1] = x9;
      if (!const_int_operand (operands[1], E_VOIDmode))
        return -1;
      x10 = XVECEXP (x3, 0, 2);
      operands[2] = x10;
      if (!const_int_operand (operands[2], E_VOIDmode))
        return -1;
      x11 = XVECEXP (x8, 0, 2);
      operands[3] = x11;
      if (!const_int_operand (operands[3], E_VOIDmode))
        return -1;
      x12 = XVECEXP (x8, 0, 3);
      operands[4] = x12;
      if (!const_int_operand (operands[4], E_VOIDmode))
        return -1;
      x13 = XVECEXP (x8, 0, 0);
      if (!rtx_equal_p (x13, operands[1]))
        return -1;
      x14 = XVECEXP (x8, 0, 1);
      if (!rtx_equal_p (x14, operands[2]))
        return -1;
      if (vector_length_operand (operands[0], E_SImode)
          && (
#line 1765 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)))
        return 3645; /* vsetvl_discard_resultsi */
      if (!vector_length_operand (operands[0], E_DImode)
          || !(
#line 1765 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)))
        return -1;
      return 3646; /* vsetvl_discard_resultdi */

    default:
      return -1;
    }
}

 int
recog_1526 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x3) != SET)
    return -1;
  x4 = XEXP (x2, 1);
  switch (GET_CODE (x4))
    {
    case SUBREG:
    case MEM:
      operands[1] = x4;
      if (!memory_operand (operands[1], E_SImode))
        return -1;
      x5 = XEXP (x3, 1);
      if (GET_CODE (x5) != UNSPEC_VOLATILE
          || XVECLEN (x5, 0) != 2)
        return -1;
      x6 = XVECEXP (x1, 0, 5);
      if (GET_CODE (x6) != CLOBBER)
        return -1;
      x7 = XEXP (x2, 0);
      operands[0] = x7;
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x5) != E_SImode)
        return -1;
      x8 = XVECEXP (x5, 0, 1);
      operands[3] = x8;
      x9 = XVECEXP (x1, 0, 2);
      operands[4] = x9;
      x10 = XVECEXP (x1, 0, 3);
      operands[5] = x10;
      if (!register_operand (operands[5], E_SImode))
        return -1;
      x11 = XEXP (x6, 0);
      operands[7] = x11;
      if (!scratch_operand (operands[7], E_SImode))
        return -1;
      x12 = XEXP (x3, 0);
      if (!rtx_equal_p (x12, operands[1]))
        return -1;
      switch (XINT (x5, 1))
        {
        case 81:
          x13 = XVECEXP (x1, 0, 4);
          if (GET_CODE (x13) != CLOBBER)
            return -1;
          x14 = XVECEXP (x5, 0, 0);
          if (GET_MODE (x14) != E_SImode
              || !const_int_operand (operands[3], E_SImode)
              || !register_operand (operands[4], E_SImode))
            return -1;
          x15 = XEXP (x13, 0);
          operands[6] = x15;
          if (!scratch_operand (operands[6], E_SImode))
            return -1;
          switch (pattern572 (x14))
            {
            case 0:
              if (!
#line 217 "../../../gcc/config/riscv/sync.md"
(TARGET_ZALRSC && TARGET_INLINE_SUBWORD_ATOMIC))
                return -1;
              return 760; /* subword_atomic_fetch_strong_add */

            case 1:
              if (!
#line 217 "../../../gcc/config/riscv/sync.md"
(TARGET_ZALRSC && TARGET_INLINE_SUBWORD_ATOMIC))
                return -1;
              return 761; /* subword_atomic_fetch_strong_or */

            case 2:
              if (!
#line 217 "../../../gcc/config/riscv/sync.md"
(TARGET_ZALRSC && TARGET_INLINE_SUBWORD_ATOMIC))
                return -1;
              return 762; /* subword_atomic_fetch_strong_xor */

            case 3:
              if (!
#line 217 "../../../gcc/config/riscv/sync.md"
(TARGET_ZALRSC && TARGET_INLINE_SUBWORD_ATOMIC))
                return -1;
              return 763; /* subword_atomic_fetch_strong_and */

            case 4:
              if (!
#line 284 "../../../gcc/config/riscv/sync.md"
(TARGET_ZALRSC && TARGET_INLINE_SUBWORD_ATOMIC))
                return -1;
              return 764; /* subword_atomic_fetch_strong_nand */

            default:
              return -1;
            }

        case 79:
          x14 = XVECEXP (x5, 0, 0);
          operands[2] = x14;
          if (!reg_or_0_operand (operands[2], E_SImode)
              || !reg_or_0_operand (operands[3], E_SImode)
              || !const_int_operand (operands[4], E_SImode))
            return -1;
          x13 = XVECEXP (x1, 0, 4);
          operands[6] = x13;
          if (!register_operand (operands[6], E_SImode)
              || !
#line 778 "../../../gcc/config/riscv/sync.md"
(TARGET_ZALRSC && TARGET_INLINE_SUBWORD_ATOMIC))
            return -1;
          return 786; /* subword_atomic_cas_strong */

        default:
          return -1;
        }

    case PLUS:
      if (pattern269 (x1) != 0)
        return -1;
      x9 = XVECEXP (x1, 0, 2);
      x16 = XEXP (x9, 0);
      if (GET_CODE (x16) != REG)
        return -1;
      x17 = XEXP (x4, 1);
      operands[0] = x17;
      x5 = XEXP (x3, 1);
      x18 = XEXP (x5, 0);
      x19 = XEXP (x18, 1);
      switch (XWINT (x19, 0))
        {
        case -4L:
          switch (pattern534 (x1, 
E_SImode, 
-20, 
-16, 
-12, 
-8))
            {
            case 0:
              if (!(
#line 102 "../../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                return -1;
              return 33687; /* gpr_multi_pop_up_to_s3_si */

            case 1:
              if (!(
#line 398 "../../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                return -1;
              return 33707; /* gpr_multi_popret_up_to_s1_si */

            case 2:
              if (!(
#line 723 "../../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                return -1;
              return 33727; /* gpr_multi_popretz_up_to_ra_si */

            default:
              return -1;
            }

        case -8L:
          switch (pattern534 (x1, 
E_DImode, 
-40, 
-32, 
-24, 
-16))
            {
            case 0:
              if (!(
#line 102 "../../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return -1;
              return 33688; /* gpr_multi_pop_up_to_s3_di */

            case 1:
              if (!(
#line 398 "../../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return -1;
              return 33708; /* gpr_multi_popret_up_to_s1_di */

            case 2:
              if (!(
#line 723 "../../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return -1;
              return 33728; /* gpr_multi_popretz_up_to_ra_di */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case REG:
      if (pattern270 (x1, 
9, 
18, 
19) != 0
          || pattern669 (x1, 
8) != 0)
        return -1;
      x13 = XVECEXP (x1, 0, 4);
      if (pattern730 (x13, 
1) != 0)
        return -1;
      x6 = XVECEXP (x1, 0, 5);
      if (GET_CODE (x6) != SET)
        return -1;
      x20 = XEXP (x6, 1);
      if (GET_CODE (x20) != PLUS)
        return -1;
      x21 = XEXP (x20, 0);
      if (GET_CODE (x21) != REG
          || REGNO (x21) != 2)
        return -1;
      x11 = XEXP (x6, 0);
      if (GET_CODE (x11) != REG
          || REGNO (x11) != 2)
        return -1;
      x22 = XEXP (x20, 1);
      operands[0] = x22;
      if (!stack_push_up_to_s3_operand (operands[0], E_VOIDmode))
        return -1;
      switch (pattern741 (x1))
        {
        case 0:
          if (pattern744 (x1, 
E_SImode) != 0
              || !(
#line 1185 "../../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            return -1;
          return 33759; /* gpr_multi_push_up_to_s3_si */

        case 1:
          if (pattern744 (x1, 
E_DImode) != 0
              || !(
#line 1185 "../../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 33760; /* gpr_multi_push_up_to_s3_di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_1530 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x3) != SET)
    return -1;
  x4 = XEXP (x2, 1);
  switch (GET_CODE (x4))
    {
    case SUBREG:
    case MEM:
      if (pnum_clobbers == NULL)
        return -1;
      operands[1] = x4;
      if (!memory_operand (operands[1], E_SImode))
        return -1;
      x5 = XEXP (x3, 1);
      if (pattern370 (x5, 
79, 
2, 
UNSPEC_VOLATILE) != 0)
        return -1;
      x6 = XEXP (x2, 0);
      operands[0] = x6;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x7 = XVECEXP (x5, 0, 0);
      operands[2] = x7;
      if (!reg_or_0_operand (operands[2], E_SImode))
        return -1;
      x8 = XVECEXP (x5, 0, 1);
      operands[3] = x8;
      if (!reg_or_0_operand (operands[3], E_SImode))
        return -1;
      x9 = XVECEXP (x1, 0, 2);
      operands[4] = x9;
      if (!const_int_operand (operands[4], E_SImode))
        return -1;
      x10 = XVECEXP (x1, 0, 3);
      operands[5] = x10;
      if (!register_operand (operands[5], E_SImode))
        return -1;
      x11 = XVECEXP (x1, 0, 4);
      operands[6] = x11;
      if (!register_operand (operands[6], E_SImode))
        return -1;
      x12 = XEXP (x3, 0);
      if (!rtx_equal_p (x12, operands[1])
          || !
#line 778 "../../../gcc/config/riscv/sync.md"
(TARGET_ZALRSC && TARGET_INLINE_SUBWORD_ATOMIC))
        return -1;
      *pnum_clobbers = 1;
      return 786; /* subword_atomic_cas_strong */

    case PLUS:
      if (pattern269 (x1) != 0)
        return -1;
      x9 = XVECEXP (x1, 0, 2);
      if (pattern458 (x9) != 0)
        return -1;
      x13 = XEXP (x4, 1);
      operands[0] = x13;
      x5 = XEXP (x3, 1);
      x14 = XEXP (x5, 0);
      x15 = XEXP (x14, 1);
      switch (XWINT (x15, 0))
        {
        case -4L:
          x16 = XEXP (x9, 1);
          x17 = XEXP (x16, 0);
          x18 = XEXP (x17, 1);
          if (XWINT (x18, 0) != -8L)
            return -1;
          switch (pattern623 (x1, 
E_SImode, 
-16, 
-12))
            {
            case 0:
              if (!(
#line 79 "../../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                return -1;
              return 33685; /* gpr_multi_pop_up_to_s2_si */

            case 1:
              if (!(
#line 379 "../../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                return -1;
              return 33705; /* gpr_multi_popret_up_to_s0_si */

            default:
              return -1;
            }

        case -8L:
          x16 = XEXP (x9, 1);
          x17 = XEXP (x16, 0);
          x18 = XEXP (x17, 1);
          if (XWINT (x18, 0) != -16L)
            return -1;
          switch (pattern623 (x1, 
E_DImode, 
-32, 
-24))
            {
            case 0:
              if (!(
#line 79 "../../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return -1;
              return 33686; /* gpr_multi_pop_up_to_s2_di */

            case 1:
              if (!(
#line 379 "../../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return -1;
              return 33706; /* gpr_multi_popret_up_to_s0_di */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case REG:
      if (pattern270 (x1, 
8, 
9, 
18) != 0)
        return -1;
      x10 = XVECEXP (x1, 0, 3);
      if (pattern670 (x10, 
1) != 0)
        return -1;
      x11 = XVECEXP (x1, 0, 4);
      if (GET_CODE (x11) != SET)
        return -1;
      x19 = XEXP (x11, 1);
      if (GET_CODE (x19) != PLUS)
        return -1;
      x20 = XEXP (x19, 0);
      if (GET_CODE (x20) != REG
          || REGNO (x20) != 2)
        return -1;
      x21 = XEXP (x11, 0);
      if (GET_CODE (x21) != REG
          || REGNO (x21) != 2)
        return -1;
      x22 = XEXP (x19, 1);
      operands[0] = x22;
      if (!stack_push_up_to_s2_operand (operands[0], E_VOIDmode))
        return -1;
      switch (pattern731 (x1))
        {
        case 0:
          x23 = XEXP (x10, 0);
          x24 = XEXP (x23, 0);
          x25 = XEXP (x24, 1);
          if (XWINT (x25, 0) != -16L
              || pattern739 (x1, 
E_SImode) != 0
              || !(
#line 1162 "../../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            return -1;
          return 33757; /* gpr_multi_push_up_to_s2_si */

        case 1:
          x23 = XEXP (x10, 0);
          x24 = XEXP (x23, 0);
          x25 = XEXP (x24, 1);
          if (XWINT (x25, 0) != -32L
              || pattern739 (x1, 
E_DImode) != 0
              || !(
#line 1162 "../../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 33758; /* gpr_multi_push_up_to_s2_di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_1532 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32;
  int res ATTRIBUTE_UNUSED;
  if (pattern112 (x1, 
SET) != 0)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case PLUS:
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) != REG
          || REGNO (x4) != 2)
        return -1;
      x5 = XEXP (x2, 0);
      if (GET_CODE (x5) != REG
          || REGNO (x5) != 2)
        return -1;
      x6 = XVECEXP (x1, 0, 1);
      if (pattern389 (x6) != 0)
        return -1;
      x7 = XVECEXP (x1, 0, 2);
      if (pattern458 (x7) != 0)
        return -1;
      x8 = XVECEXP (x1, 0, 3);
      x9 = XEXP (x8, 0);
      if (GET_CODE (x9) != REG)
        return -1;
      x10 = XEXP (x3, 1);
      operands[0] = x10;
      x11 = XEXP (x6, 1);
      x12 = XEXP (x11, 0);
      x13 = XEXP (x12, 1);
      switch (XWINT (x13, 0))
        {
        case -4L:
          x14 = XEXP (x7, 1);
          x15 = XEXP (x14, 0);
          x16 = XEXP (x15, 1);
          if (XWINT (x16, 0) != -8L)
            return -1;
          switch (pattern671 (x1, 
E_SImode, 
-24, 
-20, 
-16, 
-12))
            {
            case 0:
              if (!(
#line 128 "../../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                return -1;
              return 33689; /* gpr_multi_pop_up_to_s4_si */

            case 1:
              if (!(
#line 420 "../../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                return -1;
              return 33709; /* gpr_multi_popret_up_to_s2_si */

            case 2:
              if (!(
#line 742 "../../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                return -1;
              return 33729; /* gpr_multi_popretz_up_to_s0_si */

            default:
              return -1;
            }

        case -8L:
          x14 = XEXP (x7, 1);
          x15 = XEXP (x14, 0);
          x16 = XEXP (x15, 1);
          if (XWINT (x16, 0) != -16L)
            return -1;
          switch (pattern671 (x1, 
E_DImode, 
-48, 
-40, 
-32, 
-24))
            {
            case 0:
              if (!(
#line 128 "../../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return -1;
              return 33690; /* gpr_multi_pop_up_to_s4_di */

            case 1:
              if (!(
#line 420 "../../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return -1;
              return 33710; /* gpr_multi_popret_up_to_s2_di */

            case 2:
              if (!(
#line 742 "../../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return -1;
              return 33730; /* gpr_multi_popretz_up_to_s0_di */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case REG:
      if (REGNO (x3) != 20)
        return -1;
      x5 = XEXP (x2, 0);
      if (GET_CODE (x5) != MEM)
        return -1;
      x17 = XEXP (x5, 0);
      if (GET_CODE (x17) != PLUS)
        return -1;
      x18 = XEXP (x17, 0);
      if (GET_CODE (x18) != REG
          || REGNO (x18) != 2)
        return -1;
      x19 = XEXP (x17, 1);
      if (GET_CODE (x19) != CONST_INT)
        return -1;
      x6 = XVECEXP (x1, 0, 1);
      x11 = XEXP (x6, 1);
      if (GET_CODE (x11) != REG
          || REGNO (x11) != 19)
        return -1;
      x20 = XEXP (x6, 0);
      if (GET_CODE (x20) != MEM)
        return -1;
      x21 = XEXP (x20, 0);
      if (GET_CODE (x21) != PLUS)
        return -1;
      x22 = XEXP (x21, 0);
      if (GET_CODE (x22) != REG
          || REGNO (x22) != 2)
        return -1;
      x23 = XEXP (x21, 1);
      if (GET_CODE (x23) != CONST_INT)
        return -1;
      x7 = XVECEXP (x1, 0, 2);
      if (pattern548 (x7, 
18) != 0
          || pattern669 (x1, 
9) != 0
          || pattern732 (x1, 
8) != 0)
        return -1;
      x24 = XVECEXP (x1, 0, 5);
      if (pattern735 (x24, 
1) != 0)
        return -1;
      x25 = XVECEXP (x1, 0, 6);
      if (GET_CODE (x25) != SET)
        return -1;
      x26 = XEXP (x25, 1);
      if (GET_CODE (x26) != PLUS)
        return -1;
      x27 = XEXP (x26, 0);
      if (GET_CODE (x27) != REG
          || REGNO (x27) != 2)
        return -1;
      x28 = XEXP (x25, 0);
      if (GET_CODE (x28) != REG
          || REGNO (x28) != 2)
        return -1;
      x29 = XEXP (x26, 1);
      operands[0] = x29;
      if (!stack_push_up_to_s4_operand (operands[0], E_VOIDmode))
        return -1;
      switch (pattern741 (x1))
        {
        case 0:
          x30 = XEXP (x24, 0);
          x31 = XEXP (x30, 0);
          x32 = XEXP (x31, 1);
          if (XWINT (x32, 0) != -24L
              || pattern753 (x1, 
E_SImode) != 0
              || !(
#line 1211 "../../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            return -1;
          return 33761; /* gpr_multi_push_up_to_s4_si */

        case 1:
          x30 = XEXP (x24, 0);
          x31 = XEXP (x30, 0);
          x32 = XEXP (x31, 1);
          if (XWINT (x32, 0) != -48L
              || pattern753 (x1, 
E_DImode) != 0
              || !(
#line 1211 "../../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 33762; /* gpr_multi_push_up_to_s4_di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_1535 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34, x35, x36, x37, x38, x39, x40, x41;
  rtx x42, x43, x44, x45, x46;
  int res ATTRIBUTE_UNUSED;
  if (pattern114 (x1) != 0)
    return -1;
  switch (pattern391 (x1, 
22, 
23))
    {
    case 0:
      x2 = XVECEXP (x1, 0, 6);
      x3 = XEXP (x2, 0);
      if (GET_CODE (x3) != REG)
        return -1;
      switch (pattern738 (x1))
        {
        case 0:
          switch (pattern743 (x1, 
-24, 
E_SImode, 
-28))
            {
            case 0:
              x4 = XVECEXP (x1, 0, 7);
              if (GET_CODE (x4) != SET)
                return -1;
              x5 = XEXP (x4, 1);
              if (GET_CODE (x5) != MEM
                  || GET_MODE (x5) != E_SImode)
                return -1;
              x6 = XEXP (x5, 0);
              if (GET_CODE (x6) != PLUS
                  || GET_MODE (x6) != E_SImode)
                return -1;
              x7 = XEXP (x6, 0);
              if (GET_CODE (x7) != REG
                  || REGNO (x7) != 2
                  || GET_MODE (x7) != E_SImode)
                return -1;
              x8 = XEXP (x6, 1);
              if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + -28])
                return -1;
              x9 = XEXP (x4, 0);
              if (GET_CODE (x9) != REG
                  || REGNO (x9) != 9
                  || GET_MODE (x9) != E_SImode
                  || pattern774 (x1, 
8) != 0)
                return -1;
              x10 = XVECEXP (x1, 0, 9);
              x11 = XEXP (x10, 0);
              if (pattern782 (x11, 
E_SImode) != 0
                  || !(
#line 224 "../../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                return -1;
              return 33695; /* gpr_multi_pop_up_to_s7_si */

            case 1:
              if (!(
#line 504 "../../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                return -1;
              return 33715; /* gpr_multi_popret_up_to_s5_si */

            case 2:
              if (!(
#line 817 "../../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                return -1;
              return 33735; /* gpr_multi_popretz_up_to_s3_si */

            default:
              return -1;
            }

        case 1:
          switch (pattern743 (x1, 
-48, 
E_DImode, 
-56))
            {
            case 0:
              x4 = XVECEXP (x1, 0, 7);
              if (GET_CODE (x4) != SET)
                return -1;
              x5 = XEXP (x4, 1);
              if (GET_CODE (x5) != MEM
                  || GET_MODE (x5) != E_DImode)
                return -1;
              x6 = XEXP (x5, 0);
              if (GET_CODE (x6) != PLUS
                  || GET_MODE (x6) != E_DImode)
                return -1;
              x7 = XEXP (x6, 0);
              if (GET_CODE (x7) != REG
                  || REGNO (x7) != 2
                  || GET_MODE (x7) != E_DImode)
                return -1;
              x8 = XEXP (x6, 1);
              if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + -56])
                return -1;
              x9 = XEXP (x4, 0);
              if (GET_CODE (x9) != REG
                  || REGNO (x9) != 9
                  || GET_MODE (x9) != E_DImode)
                return -1;
              x12 = XVECEXP (x1, 0, 8);
              if (GET_CODE (x12) != SET)
                return -1;
              x13 = XEXP (x12, 1);
              if (GET_CODE (x13) != MEM
                  || GET_MODE (x13) != E_DImode)
                return -1;
              x14 = XEXP (x13, 0);
              if (GET_CODE (x14) != PLUS
                  || GET_MODE (x14) != E_DImode)
                return -1;
              x15 = XEXP (x14, 0);
              if (GET_CODE (x15) != REG
                  || REGNO (x15) != 2
                  || GET_MODE (x15) != E_DImode)
                return -1;
              x16 = XEXP (x14, 1);
              if (x16 != const_int_rtx[MAX_SAVED_CONST_INT + -64])
                return -1;
              x17 = XEXP (x12, 0);
              if (GET_CODE (x17) != REG
                  || REGNO (x17) != 8
                  || GET_MODE (x17) != E_DImode)
                return -1;
              x10 = XVECEXP (x1, 0, 9);
              if (GET_CODE (x10) != SET)
                return -1;
              x18 = XEXP (x10, 1);
              if (GET_CODE (x18) != MEM
                  || GET_MODE (x18) != E_DImode)
                return -1;
              x19 = XEXP (x18, 0);
              if (GET_CODE (x19) != PLUS
                  || GET_MODE (x19) != E_DImode)
                return -1;
              x20 = XEXP (x19, 0);
              if (GET_CODE (x20) != REG
                  || REGNO (x20) != 2
                  || GET_MODE (x20) != E_DImode)
                return -1;
              x21 = XEXP (x19, 1);
              if (GET_CODE (x21) != CONST_INT
                  || XWINT (x21, 0) != -72L)
                return -1;
              x11 = XEXP (x10, 0);
              if (pattern782 (x11, 
E_DImode) != 0
                  || !(
#line 224 "../../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return -1;
              return 33696; /* gpr_multi_pop_up_to_s7_di */

            case 1:
              if (!(
#line 504 "../../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return -1;
              return 33716; /* gpr_multi_popret_up_to_s5_di */

            case 2:
              if (!(
#line 817 "../../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return -1;
              return 33736; /* gpr_multi_popretz_up_to_s3_di */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 1:
      x22 = XVECEXP (x1, 0, 1);
      x23 = XEXP (x22, 0);
      if (GET_CODE (x23) != MEM)
        return -1;
      x24 = XEXP (x23, 0);
      if (GET_CODE (x24) != PLUS)
        return -1;
      x25 = XEXP (x24, 0);
      if (GET_CODE (x25) != REG
          || REGNO (x25) != 2)
        return -1;
      x26 = XEXP (x24, 1);
      if (GET_CODE (x26) != CONST_INT)
        return -1;
      x27 = XVECEXP (x1, 0, 2);
      x28 = XEXP (x27, 1);
      if (GET_CODE (x28) != REG
          || REGNO (x28) != 21)
        return -1;
      x29 = XEXP (x27, 0);
      if (GET_CODE (x29) != MEM)
        return -1;
      x30 = XEXP (x29, 0);
      if (GET_CODE (x30) != PLUS)
        return -1;
      x31 = XEXP (x30, 0);
      if (GET_CODE (x31) != REG
          || REGNO (x31) != 2)
        return -1;
      x32 = XEXP (x30, 1);
      if (GET_CODE (x32) != CONST_INT)
        return -1;
      x33 = XVECEXP (x1, 0, 3);
      x34 = XEXP (x33, 1);
      if (GET_CODE (x34) != REG
          || REGNO (x34) != 20)
        return -1;
      x35 = XEXP (x33, 0);
      if (GET_CODE (x35) != MEM)
        return -1;
      x36 = XEXP (x35, 0);
      if (GET_CODE (x36) != PLUS)
        return -1;
      x37 = XEXP (x36, 0);
      if (GET_CODE (x37) != REG
          || REGNO (x37) != 2)
        return -1;
      x38 = XEXP (x36, 1);
      if (GET_CODE (x38) != CONST_INT)
        return -1;
      x39 = XVECEXP (x1, 0, 4);
      x40 = XEXP (x39, 1);
      if (GET_CODE (x40) != REG
          || REGNO (x40) != 19)
        return -1;
      x41 = XEXP (x39, 0);
      if (GET_CODE (x41) != MEM)
        return -1;
      x42 = XEXP (x41, 0);
      if (GET_CODE (x42) != PLUS)
        return -1;
      x43 = XEXP (x42, 0);
      if (GET_CODE (x43) != REG
          || REGNO (x43) != 2)
        return -1;
      x44 = XEXP (x42, 1);
      if (GET_CODE (x44) != CONST_INT)
        return -1;
      x45 = XVECEXP (x1, 0, 5);
      if (pattern735 (x45, 
18) != 0
          || pattern742 (x1, 
9) != 0
          || pattern748 (x1, 
8) != 0)
        return -1;
      x12 = XVECEXP (x1, 0, 8);
      if (pattern756 (x12, 
1) != 0)
        return -1;
      x10 = XVECEXP (x1, 0, 9);
      if (GET_CODE (x10) != SET)
        return -1;
      x18 = XEXP (x10, 1);
      if (GET_CODE (x18) != PLUS)
        return -1;
      x19 = XEXP (x18, 0);
      if (GET_CODE (x19) != REG
          || REGNO (x19) != 2)
        return -1;
      x11 = XEXP (x10, 0);
      if (GET_CODE (x11) != REG
          || REGNO (x11) != 2)
        return -1;
      x46 = XEXP (x18, 1);
      operands[0] = x46;
      if (!stack_push_up_to_s7_operand (operands[0], E_VOIDmode))
        return -1;
      switch (pattern765 (x1))
        {
        case 0:
          if (pattern769 (x1, 
E_SImode) != 0
              || !(
#line 1307 "../../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            return -1;
          return 33767; /* gpr_multi_push_up_to_s7_si */

        case 1:
          if (pattern769 (x1, 
E_DImode) != 0
              || !(
#line 1307 "../../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 33768; /* gpr_multi_push_up_to_s7_di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_1541 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != SET
      || pattern120 (x1, 
20, 
21, 
22, 
23, 
24) != 0
      || pattern740 (x1, 
1, 
8, 
9, 
18, 
19) != 0)
    return -1;
  x3 = XVECEXP (x1, 0, 11);
  if (GET_CODE (x3) != SET)
    return -1;
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x3, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 10)
    return -1;
  x6 = XVECEXP (x1, 0, 12);
  if (GET_CODE (x6) != USE)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != 10)
    return -1;
  x8 = XVECEXP (x1, 0, 13);
  if (GET_CODE (x8) != RETURN)
    return -1;
  x9 = XVECEXP (x1, 0, 14);
  if (GET_CODE (x9) != USE)
    return -1;
  x10 = XEXP (x9, 0);
  if (GET_CODE (x10) != REG
      || REGNO (x10) != 1
      || GET_MODE (x10) != E_SImode)
    return -1;
  x11 = XEXP (x2, 1);
  x12 = XEXP (x11, 1);
  operands[0] = x12;
  if (!stack_pop_up_to_s8_operand (operands[0], E_VOIDmode))
    return -1;
  switch (pattern761 (x1))
    {
    case 0:
      x13 = XVECEXP (x1, 0, 10);
      x14 = XEXP (x13, 1);
      x15 = XEXP (x14, 0);
      x16 = XEXP (x15, 1);
      if (XWINT (x16, 0) != -40L
          || pattern781 (x1, 
E_SImode) != 0
          || !(
#line 1002 "../../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
        return -1;
      return 33745; /* gpr_multi_popretz_up_to_s8_si */

    case 1:
      x13 = XVECEXP (x1, 0, 10);
      x14 = XEXP (x13, 1);
      x15 = XEXP (x14, 0);
      x16 = XEXP (x15, 1);
      if (XWINT (x16, 0) != -80L
          || pattern781 (x1, 
E_DImode) != 0
          || !(
#line 1002 "../../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
        return -1;
      return 33746; /* gpr_multi_popretz_up_to_s8_di */

    default:
      return -1;
    }
}

 int
recog (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  recog_data.insn = NULL;
  switch (GET_CODE (x1))
    {
    case SET:
      return recog_1542 (x1, insn, pnum_clobbers);

    case PARALLEL:
      switch (XVECLEN (x1, 0))
        {
        case 2:
          res = recog_1524 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 3:
          res = recog_1525 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 6:
          res = recog_1526 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 4:
          res = recog_1529 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 5:
          res = recog_1530 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 17:
          x2 = XVECEXP (x1, 0, 0);
          if (GET_CODE (x2) == UNSPEC_VOLATILE
              && pattern119 (x1, 
USE, 
29) == 0
              && 
#line 253 "../../../gcc/config/riscv/thead.md"
(TARGET_XTHEADINT && !TARGET_64BIT))
            return 899; /* th_int_push */
          break;

        case 18:
          res = recog_1531 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 7:
          res = recog_1532 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 8:
          res = recog_1533 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 9:
          res = recog_1534 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 10:
          res = recog_1535 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 11:
          res = recog_1536 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 12:
          res = recog_1537 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 14:
          res = recog_1538 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 13:
          res = recog_1539 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 16:
          res = recog_1540 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 15:
          res = recog_1541 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        default:
          break;
        }
      if (XVECLEN (x1, 0) < 1)
        return -1;
      operands[1] = x1;
      if (!gpr_save_operation (operands[1], E_VOIDmode))
        return -1;
      x2 = XVECEXP (x1, 0, 0);
      if (GET_CODE (x2) != UNSPEC_VOLATILE
          || XVECLEN (x2, 0) != 1
          || XINT (x2, 1) != 0)
        return -1;
      x3 = XVECEXP (x2, 0, 0);
      operands[0] = x3;
      if (!const_int_operand (operands[0], E_VOIDmode))
        return -1;
      return 460; /* gpr_save */

    case UNSPEC_VOLATILE:
      switch (XVECLEN (x1, 0))
        {
        case 1:
          switch (XINT (x1, 1))
            {
            case 11:
              x2 = XVECEXP (x1, 0, 0);
              if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              return 293; /* fence */

            case 12:
              x2 = XVECEXP (x1, 0, 0);
              if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
                  || !
#line 2853 "../../../gcc/config/riscv/riscv.md"
(TARGET_ZIFENCEI))
                return -1;
              return 294; /* fence_i */

            case 20:
              x2 = XVECEXP (x1, 0, 0);
              if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              return 295; /* riscv_pause */

            case 10:
              x2 = XVECEXP (x1, 0, 0);
              if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              return 448; /* blockage */

            case 1:
              x2 = XVECEXP (x1, 0, 0);
              operands[0] = x2;
              if (!const_int_operand (operands[0], E_VOIDmode))
                return -1;
              return 461; /* gpr_restore */

            case 3:
              x2 = XVECEXP (x1, 0, 0);
              operands[0] = x2;
              if (!register_operand (operands[0], E_SImode)
                  || !
#line 4098 "../../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX))
                return -1;
              return 464; /* riscv_fscsr */

            case 5:
              x2 = XVECEXP (x1, 0, 0);
              operands[0] = x2;
              if (!csr_operand (operands[0], E_SImode)
                  || !
#line 4111 "../../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX))
                return -1;
              return 466; /* riscv_fsflags */

            case 15:
              x2 = XVECEXP (x1, 0, 0);
              operands[0] = x2;
              switch (GET_MODE (x1))
                {
                case E_SImode:
                  if (!register_operand (operands[0], E_SImode)
                      || !(
#line 4344 "../../../gcc/config/riscv/riscv.md"
(TARGET_ZICBOM) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                    return -1;
                  return 479; /* riscv_clean_si */

                case E_DImode:
                  if (!register_operand (operands[0], E_DImode)
                      || !(
#line 4344 "../../../gcc/config/riscv/riscv.md"
(TARGET_ZICBOM) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                    return -1;
                  return 480; /* riscv_clean_di */

                default:
                  return -1;
                }

            case 16:
              x2 = XVECEXP (x1, 0, 0);
              operands[0] = x2;
              switch (GET_MODE (x1))
                {
                case E_SImode:
                  if (!register_operand (operands[0], E_SImode)
                      || !(
#line 4352 "../../../gcc/config/riscv/riscv.md"
(TARGET_ZICBOM) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                    return -1;
                  return 481; /* riscv_flush_si */

                case E_DImode:
                  if (!register_operand (operands[0], E_DImode)
                      || !(
#line 4352 "../../../gcc/config/riscv/riscv.md"
(TARGET_ZICBOM) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                    return -1;
                  return 482; /* riscv_flush_di */

                default:
                  return -1;
                }

            case 17:
              x2 = XVECEXP (x1, 0, 0);
              operands[0] = x2;
              switch (GET_MODE (x1))
                {
                case E_SImode:
                  if (!register_operand (operands[0], E_SImode)
                      || !(
#line 4360 "../../../gcc/config/riscv/riscv.md"
(TARGET_ZICBOM) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                    return -1;
                  return 483; /* riscv_inval_si */

                case E_DImode:
                  if (!register_operand (operands[0], E_DImode)
                      || !(
#line 4360 "../../../gcc/config/riscv/riscv.md"
(TARGET_ZICBOM) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                    return -1;
                  return 484; /* riscv_inval_di */

                default:
                  return -1;
                }

            case 18:
              x2 = XVECEXP (x1, 0, 0);
              operands[0] = x2;
              switch (GET_MODE (x1))
                {
                case E_SImode:
                  if (!register_operand (operands[0], E_SImode)
                      || !(
#line 4368 "../../../gcc/config/riscv/riscv.md"
(TARGET_ZICBOZ) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                    return -1;
                  return 485; /* riscv_zero_si */

                case E_DImode:
                  if (!register_operand (operands[0], E_DImode)
                      || !(
#line 4368 "../../../gcc/config/riscv/riscv.md"
(TARGET_ZICBOZ) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                    return -1;
                  return 486; /* riscv_zero_di */

                default:
                  return -1;
                }

            case 21:
              x2 = XVECEXP (x1, 0, 0);
              operands[0] = x2;
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (!x1x5_operand (operands[0], E_SImode)
                      || !(
#line 4717 "../../../gcc/config/riscv/riscv.md"
(TARGET_ZICFISS) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)))
                    return -1;
                  return 494; /* sspushsi */

                case E_DImode:
                  if (!x1x5_operand (operands[0], E_DImode)
                      || !(
#line 4717 "../../../gcc/config/riscv/riscv.md"
(TARGET_ZICFISS) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)))
                    return -1;
                  return 495; /* sspushdi */

                default:
                  return -1;
                }

            case 22:
              x2 = XVECEXP (x1, 0, 0);
              operands[0] = x2;
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (!x1x5_operand (operands[0], E_SImode)
                      || !(
#line 4724 "../../../gcc/config/riscv/riscv.md"
(TARGET_ZICFISS) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)))
                    return -1;
                  return 496; /* sspopchksi */

                case E_DImode:
                  if (!x1x5_operand (operands[0], E_DImode)
                      || !(
#line 4724 "../../../gcc/config/riscv/riscv.md"
(TARGET_ZICFISS) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)))
                    return -1;
                  return 497; /* sspopchkdi */

                default:
                  return -1;
                }

            case 24:
              x2 = XVECEXP (x1, 0, 0);
              operands[0] = x2;
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (!register_operand (operands[0], E_SImode)
                      || !(
#line 4739 "../../../gcc/config/riscv/riscv.md"
(TARGET_ZICFISS) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)))
                    return -1;
                  return 500; /* write_sspsi */

                case E_DImode:
                  if (!register_operand (operands[0], E_DImode)
                      || !(
#line 4739 "../../../gcc/config/riscv/riscv.md"
(TARGET_ZICFISS) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)))
                    return -1;
                  return 501; /* write_sspdi */

                default:
                  return -1;
                }

            case 25:
              x2 = XVECEXP (x1, 0, 0);
              operands[0] = x2;
              if (!immediate_operand (operands[0], E_VOIDmode)
                  || !
#line 4748 "../../../gcc/config/riscv/riscv.md"
(TARGET_ZICFILP))
                return -1;
              return 502; /* lpad */

            case 27:
              x2 = XVECEXP (x1, 0, 0);
              if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
                  || !
#line 4762 "../../../gcc/config/riscv/riscv.md"
(TARGET_ZICFILP))
                return -1;
              return 505; /* lpad_align */

            default:
              return -1;
            }

        case 2:
          x2 = XVECEXP (x1, 0, 0);
          operands[0] = x2;
          x4 = XVECEXP (x1, 0, 1);
          operands[1] = x4;
          switch (XINT (x1, 1))
            {
            case 6:
              switch (GET_MODE (operands[0]))
                {
                case E_SFmode:
                  if (!register_operand (operands[0], E_SFmode)
                      || !register_operand (operands[1], E_SFmode)
                      || !
#line 4119 "../../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX))
                    return -1;
                  return 467; /* *riscv_fsnvsnansf2 */

                case E_DFmode:
                  if (!register_operand (operands[0], E_DFmode)
                      || !register_operand (operands[1], E_DFmode)
                      || !(
#line 4119 "../../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && 
#line 106 "../../../gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX)))
                    return -1;
                  return 468; /* *riscv_fsnvsnandf2 */

                case E_HFmode:
                  if (!register_operand (operands[0], E_HFmode)
                      || !register_operand (operands[1], E_HFmode)
                      || !(
#line 4119 "../../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && 
#line 107 "../../../gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX)))
                    return -1;
                  return 469; /* *riscv_fsnvsnanhf2 */

                default:
                  return -1;
                }

            case 19:
              switch (GET_MODE (x1))
                {
                case E_SImode:
                  if (!address_operand (operands[0], E_SImode)
                      || !imm5_operand (operands[1], E_SImode)
                      || !(
#line 4397 "../../../gcc/config/riscv/riscv.md"
(TARGET_ZICBOP) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                    return -1;
                  return 488; /* riscv_prefetchi_si */

                case E_DImode:
                  if (!address_operand (operands[0], E_DImode)
                      || !imm5_operand (operands[1], E_DImode)
                      || !(
#line 4397 "../../../gcc/config/riscv/riscv.md"
(TARGET_ZICBOP) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                    return -1;
                  return 489; /* riscv_prefetchi_di */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case SIMPLE_RETURN:
      return 449; /* simple_return */

    case UNSPEC:
      if (pnum_clobbers == NULL
          || XVECLEN (x1, 0) != 1
          || XINT (x1, 1) != 0)
        return -1;
      x2 = XVECEXP (x1, 0, 0);
      operands[0] = x2;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || !
#line 3876 "../../../gcc/config/riscv/riscv.md"
(! TARGET_64BIT))
            return -1;
          *pnum_clobbers = 1;
          return 451; /* eh_set_lr_si */

        case E_DImode:
          if (!register_operand (operands[0], E_DImode)
              || !
#line 3883 "../../../gcc/config/riscv/riscv.md"
(TARGET_64BIT))
            return -1;
          *pnum_clobbers = 1;
          return 452; /* eh_set_lr_di */

        default:
          return -1;
        }

    case EH_RETURN:
      return 453; /* eh_return_internal */

    case CONST_INT:
      if (XWINT (x1, 0) != 0L)
        return -1;
      return 458; /* nop */

    case TRAP_IF:
      x5 = XEXP (x1, 0);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x6 = XEXP (x1, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      return 459; /* trap */

    case PREFETCH:
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      if (!address_operand (operands[0], E_VOIDmode))
        return -1;
      x6 = XEXP (x1, 1);
      operands[1] = x6;
      if (!imm5_operand (operands[1], E_VOIDmode))
        return -1;
      x7 = XEXP (x1, 2);
      operands[2] = x7;
      if (!const_int_operand (operands[2], E_VOIDmode)
          || !
#line 4377 "../../../gcc/config/riscv/riscv.md"
(TARGET_ZICBOP))
        return -1;
      return 487; /* prefetch */

    default:
      return -1;
    }
}

 rtx_insn *
split_6 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case ZERO_EXTEND:
      switch (pattern147 (x2))
        {
        case 0:
          if (!(
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 612 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8133 (insn, operands);

        case 1:
          if (!(
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 612 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8139 (insn, operands);

        case 2:
          if (!(
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 612 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8145 (insn, operands);

        case 3:
          if (!(
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 612 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8151 (insn, operands);

        case 4:
          if (!(
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 612 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8157 (insn, operands);

        case 5:
          if (!((
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 612 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8163 (insn, operands);

        case 6:
          if (!(
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 612 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8169 (insn, operands);

        case 7:
          if (!(
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 612 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8175 (insn, operands);

        case 8:
          if (!(
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 612 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8181 (insn, operands);

        case 9:
          if (!(
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 612 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8187 (insn, operands);

        case 10:
          if (!((
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 612 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8193 (insn, operands);

        case 11:
          if (!((
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 612 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8199 (insn, operands);

        case 12:
          if (!((
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 612 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8205 (insn, operands);

        case 13:
          if (!((
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 612 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8211 (insn, operands);

        case 14:
          if (!((
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 612 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8217 (insn, operands);

        case 15:
          if (!((
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 612 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8223 (insn, operands);

        case 16:
          if (!((
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 612 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8229 (insn, operands);

        case 17:
          if (!((
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 612 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8235 (insn, operands);

        case 18:
          if (!((
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 612 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8241 (insn, operands);

        case 19:
          if (!((
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 612 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8247 (insn, operands);

        case 20:
          if (!((
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 612 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8253 (insn, operands);

        case 21:
          if (!((
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 612 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8259 (insn, operands);

        case 22:
          if (!((
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 612 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8265 (insn, operands);

        case 23:
          if (!((
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 612 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8271 (insn, operands);

        case 24:
          if (!((
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 612 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8277 (insn, operands);

        case 25:
          if (!((
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 612 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8283 (insn, operands);

        case 26:
          if (!((
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 612 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8289 (insn, operands);

        case 27:
          if (!((
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 612 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8295 (insn, operands);

        case 28:
          if (!((
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 612 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8301 (insn, operands);

        case 29:
          if (!((
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 612 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8307 (insn, operands);

        case 30:
          if (!((
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 612 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8313 (insn, operands);

        case 31:
          if (!((
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 612 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8319 (insn, operands);

        case 32:
          if (!((
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 612 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8325 (insn, operands);

        case 33:
          if (!((
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 612 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8331 (insn, operands);

        case 34:
          if (!((
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 972 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 612 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8337 (insn, operands);

        case 35:
          if (!((
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 973 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 612 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8343 (insn, operands);

        case 36:
          if (!((
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 974 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 612 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8349 (insn, operands);

        case 37:
          if (!((
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 975 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 612 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8355 (insn, operands);

        case 38:
          if (!((
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 976 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 612 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8361 (insn, operands);

        case 39:
          if (!((
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 977 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 612 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8367 (insn, operands);

        case 40:
          if (!((
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 978 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 612 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8373 (insn, operands);

        case 41:
          if (!((
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 979 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 612 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8379 (insn, operands);

        case 42:
          if (!((
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 980 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 612 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8385 (insn, operands);

        case 43:
          if (!((
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 981 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 612 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8391 (insn, operands);

        case 44:
          if (!((
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 982 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 612 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8397 (insn, operands);

        case 45:
          if (!((
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 983 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 612 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8403 (insn, operands);

        case 46:
          if (!((
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 984 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 612 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8409 (insn, operands);

        case 47:
          if (!((
#line 610 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 985 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 612 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8415 (insn, operands);

        default:
          return NULL;
        }

    case REG:
    case SUBREG:
      switch (pattern148 (x2))
        {
        case 0:
          if (!(
#line 647 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 649 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8517 (insn, operands);

        case 1:
          if (!(
#line 647 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 649 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8519 (insn, operands);

        case 2:
          if (!(
#line 647 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 649 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8521 (insn, operands);

        case 3:
          if (!(
#line 647 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 649 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8523 (insn, operands);

        case 4:
          if (!(
#line 647 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 649 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8525 (insn, operands);

        case 5:
          if (!((
#line 647 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 649 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8527 (insn, operands);

        case 6:
          if (!(
#line 647 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 649 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8529 (insn, operands);

        case 7:
          if (!(
#line 647 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 649 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8531 (insn, operands);

        case 8:
          if (!(
#line 647 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 649 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8533 (insn, operands);

        case 9:
          if (!(
#line 647 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 649 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8535 (insn, operands);

        case 10:
          if (!((
#line 647 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 649 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8537 (insn, operands);

        case 11:
          if (!((
#line 647 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 649 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8539 (insn, operands);

        case 12:
          if (!((
#line 647 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 649 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8541 (insn, operands);

        case 13:
          if (!((
#line 647 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 649 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8543 (insn, operands);

        case 14:
          if (!((
#line 647 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 649 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8545 (insn, operands);

        case 15:
          if (!((
#line 647 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 649 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8547 (insn, operands);

        case 16:
          if (!((
#line 647 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 649 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8549 (insn, operands);

        case 17:
          if (!((
#line 647 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 649 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8551 (insn, operands);

        case 18:
          if (!((
#line 647 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 649 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8553 (insn, operands);

        case 19:
          if (!((
#line 647 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 649 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8555 (insn, operands);

        case 20:
          if (!((
#line 647 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 649 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8557 (insn, operands);

        case 21:
          if (!((
#line 647 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 649 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8559 (insn, operands);

        case 22:
          if (!((
#line 647 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 649 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8561 (insn, operands);

        case 23:
          if (!((
#line 647 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 649 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8563 (insn, operands);

        case 24:
          if (!((
#line 647 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 649 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8565 (insn, operands);

        case 25:
          if (!((
#line 647 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 649 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8567 (insn, operands);

        case 26:
          if (!((
#line 647 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 649 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8569 (insn, operands);

        case 27:
          if (!((
#line 647 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 649 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8571 (insn, operands);

        case 28:
          if (!((
#line 647 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 649 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8573 (insn, operands);

        case 29:
          if (!((
#line 647 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 649 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8575 (insn, operands);

        case 30:
          if (!((
#line 647 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 649 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8577 (insn, operands);

        case 31:
          if (!((
#line 647 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 649 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8579 (insn, operands);

        case 32:
          if (!((
#line 647 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 649 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8581 (insn, operands);

        case 33:
          if (!((
#line 647 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 649 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8583 (insn, operands);

        case 34:
          if (!((
#line 647 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 972 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 649 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8585 (insn, operands);

        case 35:
          if (!((
#line 647 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 973 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 649 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8587 (insn, operands);

        case 36:
          if (!((
#line 647 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 974 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 649 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8589 (insn, operands);

        case 37:
          if (!((
#line 647 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 975 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 649 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8591 (insn, operands);

        case 38:
          if (!((
#line 647 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 976 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 649 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8593 (insn, operands);

        case 39:
          if (!((
#line 647 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 977 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 649 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8595 (insn, operands);

        case 40:
          if (!((
#line 647 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 978 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 649 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8597 (insn, operands);

        case 41:
          if (!((
#line 647 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 979 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 649 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8599 (insn, operands);

        case 42:
          if (!((
#line 647 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 980 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 649 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8601 (insn, operands);

        case 43:
          if (!((
#line 647 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 981 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 649 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8603 (insn, operands);

        case 44:
          if (!((
#line 647 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 982 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 649 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8605 (insn, operands);

        case 45:
          if (!((
#line 647 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 983 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 649 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8607 (insn, operands);

        case 46:
          if (!((
#line 647 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 984 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 649 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8609 (insn, operands);

        case 47:
          if (!((
#line 647 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 985 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 649 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8611 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_14 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V1DFmode)
      && reg_or_mem_operand (operands[1], E_V1DFmode))
    {
      if ((
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 295 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return gen_split_313 (insn, operands);
      if (((
#line 1434 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V1DFmode)
       || register_operand (operands[1], V1DFmode))) && 
#line 4334 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1441 "../../../gcc/config/riscv/vector.md"
( reload_completed
   && (!register_operand (operands[0], V1DFmode)
       || !register_operand (operands[1], V1DFmode)))))
        return gen_split_1977 (insn, operands);
    }
  if (!register_operand (operands[0], E_V1DFmode)
      || !register_operand (operands[1], E_V1DFmode)
      || !((
#line 1509 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 295 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1511 "../../../gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2160 (insn, operands);
}

 rtx_insn *
split_18 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V2SFmode)
      && reg_or_mem_operand (operands[1], E_V2SFmode))
    {
      if ((
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 285 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return gen_split_303 (insn, operands);
      if (((
#line 1434 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V2SFmode)
       || register_operand (operands[1], V2SFmode))) && 
#line 4330 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1441 "../../../gcc/config/riscv/vector.md"
( reload_completed
   && (!register_operand (operands[0], V2SFmode)
       || !register_operand (operands[1], V2SFmode)))))
        return gen_split_1973 (insn, operands);
    }
  if (!register_operand (operands[0], E_V2SFmode)
      || !register_operand (operands[1], E_V2SFmode)
      || !((
#line 1509 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 285 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1511 "../../../gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2150 (insn, operands);
}

 rtx_insn *
split_22 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V4HFmode)
      && reg_or_mem_operand (operands[1], E_V4HFmode))
    {
      if ((
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 274 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return gen_split_292 (insn, operands);
      if (((
#line 1434 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V4HFmode)
       || register_operand (operands[1], V4HFmode))) && 
#line 4326 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_VECTOR_ELEN_FP_16)) && 
#line 1441 "../../../gcc/config/riscv/vector.md"
( reload_completed
   && (!register_operand (operands[0], V4HFmode)
       || !register_operand (operands[1], V4HFmode)))))
        return gen_split_1969 (insn, operands);
    }
  if (!register_operand (operands[0], E_V4HFmode)
      || !register_operand (operands[1], E_V4HFmode)
      || !((
#line 1509 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 274 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_VECTOR_ELEN_FP_16)) && 
#line 1511 "../../../gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2139 (insn, operands);
}

 rtx_insn *
split_27 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V4DImode)
      && reg_or_mem_operand (operands[1], E_V4DImode))
    {
      if ((
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 226 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return gen_split_282 (insn, operands);
      if (((
#line 1434 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V4DImode)
       || register_operand (operands[1], V4DImode))) && 
#line 4321 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 1441 "../../../gcc/config/riscv/vector.md"
( reload_completed
   && (!register_operand (operands[0], V4DImode)
       || !register_operand (operands[1], V4DImode)))))
        return gen_split_1964 (insn, operands);
    }
  if (!register_operand (operands[0], E_V4DImode)
      || !register_operand (operands[1], E_V4DImode)
      || !((
#line 1509 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 226 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 1511 "../../../gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2129 (insn, operands);
}

 rtx_insn *
split_31 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V8SImode)
      && reg_or_mem_operand (operands[1], E_V8SImode))
    {
      if ((
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 216 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return gen_split_272 (insn, operands);
      if (((
#line 1434 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V8SImode)
       || register_operand (operands[1], V8SImode))) && 
#line 4317 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 1441 "../../../gcc/config/riscv/vector.md"
( reload_completed
   && (!register_operand (operands[0], V8SImode)
       || !register_operand (operands[1], V8SImode)))))
        return gen_split_1960 (insn, operands);
    }
  if (!register_operand (operands[0], E_V8SImode)
      || !register_operand (operands[1], E_V8SImode)
      || !((
#line 1509 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 216 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 1511 "../../../gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2119 (insn, operands);
}

 rtx_insn *
split_36 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V8HImode)
      && reg_or_mem_operand (operands[1], E_V8HImode))
    {
      if ((
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 204 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return gen_split_260 (insn, operands);
      if (((
#line 1434 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V8HImode)
       || register_operand (operands[1], V8HImode))) && 
#line 4312 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 1441 "../../../gcc/config/riscv/vector.md"
( reload_completed
   && (!register_operand (operands[0], V8HImode)
       || !register_operand (operands[1], V8HImode)))))
        return gen_split_1955 (insn, operands);
    }
  if (!register_operand (operands[0], E_V8HImode)
      || !register_operand (operands[1], E_V8HImode)
      || !((
#line 1509 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 204 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 1511 "../../../gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2107 (insn, operands);
}

 rtx_insn *
split_42 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V4QImode)
      && reg_or_mem_operand (operands[1], E_V4QImode))
    {
      if ((
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 190 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return gen_split_246 (insn, operands);
      if (((
#line 1434 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V4QImode)
       || register_operand (operands[1], V4QImode))) && 
#line 4306 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))) && 
#line 1441 "../../../gcc/config/riscv/vector.md"
( reload_completed
   && (!register_operand (operands[0], V4QImode)
       || !register_operand (operands[1], V4QImode)))))
        return gen_split_1949 (insn, operands);
    }
  if (!register_operand (operands[0], E_V4QImode)
      || !register_operand (operands[1], E_V4QImode)
      || !((
#line 1509 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 190 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))) && 
#line 1511 "../../../gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2093 (insn, operands);
}

 rtx_insn *
split_49 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V1BImode)
      && reg_or_mem_operand (operands[1], E_V1BImode)
      && ((
#line 1434 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V1BImode)
       || register_operand (operands[1], V1BImode))) && 
#line 4340 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode))) && 
#line 1441 "../../../gcc/config/riscv/vector.md"
( reload_completed
   && (!register_operand (operands[0], V1BImode)
       || !register_operand (operands[1], V1BImode)))))
    return gen_split_1982 (insn, operands);
  if (!register_operand (operands[0], E_V1BImode)
      || !register_operand (operands[1], E_V1BImode)
      || !((
#line 1530 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1518 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode))) && 
#line 1532 "../../../gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2170 (insn, operands);
}

 rtx_insn *
split_57 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V256SFmode)
      && reg_or_mem_operand (operands[1], E_V256SFmode)
      && (
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 292 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
    return gen_split_310 (insn, operands);
  if (!register_operand (operands[0], E_V256SFmode)
      || !register_operand (operands[1], E_V256SFmode)
      || !((
#line 1509 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 292 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 1511 "../../../gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2157 (insn, operands);
}

 rtx_insn *
split_63 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V512HFmode)
      && reg_or_mem_operand (operands[1], E_V512HFmode)
      && (
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 281 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 1024)))
    return gen_split_299 (insn, operands);
  if (!register_operand (operands[0], E_V512HFmode)
      || !register_operand (operands[1], E_V512HFmode)
      || !((
#line 1509 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 281 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 1024)) && 
#line 1511 "../../../gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2146 (insn, operands);
}

 rtx_insn *
split_69 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V256DImode)
      && reg_or_mem_operand (operands[1], E_V256DImode)
      && (
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 232 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
    return gen_split_288 (insn, operands);
  if (!register_operand (operands[0], E_V256DImode)
      || !register_operand (operands[1], E_V256DImode)
      || !((
#line 1509 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 232 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 1511 "../../../gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2135 (insn, operands);
}

 rtx_insn *
split_75 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V256SImode)
      && reg_or_mem_operand (operands[1], E_V256SImode)
      && (
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 221 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
    return gen_split_277 (insn, operands);
  if (!register_operand (operands[0], E_V256SImode)
      || !register_operand (operands[1], E_V256SImode)
      || !((
#line 1509 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 221 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 1511 "../../../gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2124 (insn, operands);
}

 rtx_insn *
split_82 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V256HImode)
      && reg_or_mem_operand (operands[1], E_V256HImode)
      && (
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 209 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
    return gen_split_265 (insn, operands);
  if (!register_operand (operands[0], E_V256HImode)
      || !register_operand (operands[1], E_V256HImode)
      || !((
#line 1509 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 209 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1511 "../../../gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2112 (insn, operands);
}

 rtx_insn *
split_89 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V512QImode)
      && reg_or_mem_operand (operands[1], E_V512QImode)
      && (
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 197 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
    return gen_split_253 (insn, operands);
  if (!register_operand (operands[0], E_V512QImode)
      || !register_operand (operands[1], E_V512QImode)
      || !((
#line 1509 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 197 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1511 "../../../gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2100 (insn, operands);
}

 rtx_insn *
split_96 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_RVVMF4BImode)
      && reg_or_mem_operand (operands[1], E_RVVMF4BImode)
      && 
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
    return gen_split_241 (insn, operands);
  if (!register_operand (operands[0], E_RVVMF4BImode)
      || !register_operand (operands[1], E_RVVMF4BImode)
      || !(
#line 1294 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 1296 "../../../gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_1578 (insn, operands);
}

 rtx_insn *
split_101 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_RVVMF2SFmode)
      && reg_or_mem_operand (operands[1], E_RVVMF2SFmode)
      && (
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 181 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
    return gen_split_232 (insn, operands);
  if (!register_operand (operands[0], E_RVVMF2SFmode)
      || !register_operand (operands[1], E_RVVMF2SFmode)
      || !((
#line 1257 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 942 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)) && 
#line 1259 "../../../gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_1573 (insn, operands);
}

 rtx_insn *
split_108 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_RVVMF8QImode)
      && reg_or_mem_operand (operands[1], E_RVVMF8QImode)
      && (
#line 99 "../../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
    return gen_split_213 (insn, operands);
  if (!register_operand (operands[0], E_RVVMF8QImode)
      || !register_operand (operands[1], E_RVVMF8QImode)
      || !((
#line 1257 "../../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 932 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 1259 "../../../gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_1565 (insn, operands);
}

 rtx_insn *
split_115 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  switch (GET_CODE (operands[2]))
    {
    case CONST_INT:
      switch (pattern107 (x2))
        {
        case 0:
          if (const_nottwobits_not_arith_operand (operands[2], E_SImode)
              && ((
#line 847 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBS && !paradoxical_subreg_p (operands[1])) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 849 "../../../gcc/config/riscv/bitmanip.md"
( reload_completed)))
            return gen_split_165 (insn, operands);
          if (!not_uimm_extra_bit_or_nottwobits (operands[2], E_SImode)
              || !((
#line 1039 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBS) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 1041 "../../../gcc/config/riscv/bitmanip.md"
( reload_completed)))
            return NULL;
          return gen_split_180 (insn, operands);

        case 1:
          if (const_nottwobits_not_arith_operand (operands[2], E_DImode))
            {
              if (((
#line 847 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBS && !paradoxical_subreg_p (operands[1])) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 849 "../../../gcc/config/riscv/bitmanip.md"
( reload_completed)))
                return gen_split_166 (insn, operands);
              if ((
#line 867 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT && TARGET_ZBS
   && clz_hwi (~UINTVAL (operands[2])) > 33) && 
#line 870 "../../../gcc/config/riscv/bitmanip.md"
( reload_completed)))
                return gen_split_167 (insn, operands);
            }
          if (not_uimm_extra_bit_or_nottwobits (operands[2], E_DImode)
              && ((
#line 1039 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBS) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 1041 "../../../gcc/config/riscv/bitmanip.md"
( reload_completed)))
            return gen_split_181 (insn, operands);
          if (!const_int_operand (operands[2], E_VOIDmode)
              || !(
#line 1065 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBA
   && !paradoxical_subreg_p (operands[1])
   /* Only profitable if synthesis takes more than one insn.  */
   && riscv_const_insns (operands[2], false) != 1
   /* We need the upper half to be zero.  */
   && (INTVAL (operands[2]) & HOST_WIDE_INT_C (0xffffffff00000000)) == 0
   /* And the the adjusted constant must either be something we can
      implement with andi or bclri.  */
   && ((SMALL_OPERAND (sext_hwi (INTVAL (operands[2]), 32))
        || (TARGET_ZBS && popcount_hwi (INTVAL (operands[2])) == 31))
       && INTVAL (operands[2]) != 0x7fffffff)) && 
#line 1078 "../../../gcc/config/riscv/bitmanip.md"
( 1)))
            return NULL;
          return gen_split_182 (insn, operands);

        default:
          return NULL;
        }

    case CONST_VECTOR:
    case REG:
    case SUBREG:
      switch (GET_MODE (operands[0]))
        {
        case E_RVVM8QImode:
          if (pattern228 (x2, 
E_RVVM8QImode) != 0
              || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2589 (insn, operands);

        case E_RVVM4QImode:
          if (pattern228 (x2, 
E_RVVM4QImode) != 0
              || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2603 (insn, operands);

        case E_RVVM2QImode:
          if (pattern228 (x2, 
E_RVVM2QImode) != 0
              || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2617 (insn, operands);

        case E_RVVM1QImode:
          if (pattern228 (x2, 
E_RVVM1QImode) != 0
              || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2631 (insn, operands);

        case E_RVVM8HImode:
          if (pattern228 (x2, 
E_RVVM8HImode) != 0
              || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2645 (insn, operands);

        case E_RVVM4HImode:
          if (pattern228 (x2, 
E_RVVM4HImode) != 0
              || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2659 (insn, operands);

        case E_RVVM2HImode:
          if (pattern228 (x2, 
E_RVVM2HImode) != 0
              || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2673 (insn, operands);

        case E_RVVM1HImode:
          if (pattern228 (x2, 
E_RVVM1HImode) != 0
              || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2687 (insn, operands);

        case E_RVVM8SImode:
          if (pattern228 (x2, 
E_RVVM8SImode) != 0
              || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2701 (insn, operands);

        case E_RVVM4SImode:
          if (pattern228 (x2, 
E_RVVM4SImode) != 0
              || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2715 (insn, operands);

        case E_RVVM2SImode:
          if (pattern228 (x2, 
E_RVVM2SImode) != 0
              || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2729 (insn, operands);

        case E_RVVM1SImode:
          if (pattern228 (x2, 
E_RVVM1SImode) != 0
              || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2743 (insn, operands);

        case E_RVVM8DImode:
          if (pattern228 (x2, 
E_RVVM8DImode) != 0
              || !((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2757 (insn, operands);

        case E_RVVM4DImode:
          if (pattern228 (x2, 
E_RVVM4DImode) != 0
              || !((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2771 (insn, operands);

        case E_RVVM2DImode:
          if (pattern228 (x2, 
E_RVVM2DImode) != 0
              || !((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2785 (insn, operands);

        case E_RVVM1DImode:
          if (pattern228 (x2, 
E_RVVM1DImode) != 0
              || !((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2799 (insn, operands);

        case E_RVVMF2QImode:
          if (pattern228 (x2, 
E_RVVMF2QImode) != 0
              || !((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2813 (insn, operands);

        case E_RVVMF4QImode:
          if (pattern228 (x2, 
E_RVVMF4QImode) != 0
              || !((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2827 (insn, operands);

        case E_RVVMF8QImode:
          if (pattern228 (x2, 
E_RVVMF8QImode) != 0
              || !((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2841 (insn, operands);

        case E_RVVMF2HImode:
          if (pattern228 (x2, 
E_RVVMF2HImode) != 0
              || !((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2855 (insn, operands);

        case E_RVVMF4HImode:
          if (pattern228 (x2, 
E_RVVMF4HImode) != 0
              || !((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 132 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2869 (insn, operands);

        case E_RVVMF2SImode:
          if (pattern228 (x2, 
E_RVVMF2SImode) != 0
              || !((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 133 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2883 (insn, operands);

        case E_V1QImode:
          if (pattern228 (x2, 
E_V1QImode) != 0
              || !((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 188 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2897 (insn, operands);

        case E_V2QImode:
          if (pattern228 (x2, 
E_V2QImode) != 0
              || !((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 189 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2911 (insn, operands);

        case E_V4QImode:
          if (pattern228 (x2, 
E_V4QImode) != 0
              || !((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 190 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2925 (insn, operands);

        case E_V8QImode:
          if (pattern228 (x2, 
E_V8QImode) != 0
              || !((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 191 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2939 (insn, operands);

        case E_V16QImode:
          if (pattern228 (x2, 
E_V16QImode) != 0
              || !((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 192 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2953 (insn, operands);

        case E_V32QImode:
          if (pattern228 (x2, 
E_V32QImode) != 0
              || !((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 193 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2967 (insn, operands);

        case E_V64QImode:
          if (pattern228 (x2, 
E_V64QImode) != 0
              || !((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 194 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2981 (insn, operands);

        case E_V128QImode:
          if (pattern228 (x2, 
E_V128QImode) != 0
              || !((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 195 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2995 (insn, operands);

        case E_V256QImode:
          if (pattern228 (x2, 
E_V256QImode) != 0
              || !((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 196 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3009 (insn, operands);

        case E_V512QImode:
          if (pattern228 (x2, 
E_V512QImode) != 0
              || !((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 197 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3023 (insn, operands);

        case E_V1024QImode:
          if (pattern228 (x2, 
E_V1024QImode) != 0
              || !((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 198 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3037 (insn, operands);

        case E_V2048QImode:
          if (pattern228 (x2, 
E_V2048QImode) != 0
              || !((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 199 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3051 (insn, operands);

        case E_V4096QImode:
          if (pattern228 (x2, 
E_V4096QImode) != 0
              || !((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 200 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3065 (insn, operands);

        case E_V1HImode:
          if (pattern228 (x2, 
E_V1HImode) != 0
              || !((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 201 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3079 (insn, operands);

        case E_V2HImode:
          if (pattern228 (x2, 
E_V2HImode) != 0
              || !((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 202 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3093 (insn, operands);

        case E_V4HImode:
          if (pattern228 (x2, 
E_V4HImode) != 0
              || !((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 203 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3107 (insn, operands);

        case E_V8HImode:
          if (pattern228 (x2, 
E_V8HImode) != 0
              || !((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 204 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3121 (insn, operands);

        case E_V16HImode:
          if (pattern228 (x2, 
E_V16HImode) != 0
              || !((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 205 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3135 (insn, operands);

        case E_V32HImode:
          if (pattern228 (x2, 
E_V32HImode) != 0
              || !((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 206 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3149 (insn, operands);

        case E_V64HImode:
          if (pattern228 (x2, 
E_V64HImode) != 0
              || !((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 207 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3163 (insn, operands);

        case E_V128HImode:
          if (pattern228 (x2, 
E_V128HImode) != 0
              || !((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 208 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3177 (insn, operands);

        case E_V256HImode:
          if (pattern228 (x2, 
E_V256HImode) != 0
              || !((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 209 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3191 (insn, operands);

        case E_V512HImode:
          if (pattern228 (x2, 
E_V512HImode) != 0
              || !((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 210 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3205 (insn, operands);

        case E_V1024HImode:
          if (pattern228 (x2, 
E_V1024HImode) != 0
              || !((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 211 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3219 (insn, operands);

        case E_V2048HImode:
          if (pattern228 (x2, 
E_V2048HImode) != 0
              || !((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 212 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3233 (insn, operands);

        case E_V1SImode:
          if (pattern228 (x2, 
E_V1SImode) != 0
              || !((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 213 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3247 (insn, operands);

        case E_V2SImode:
          if (pattern228 (x2, 
E_V2SImode) != 0
              || !((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 214 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3261 (insn, operands);

        case E_V4SImode:
          if (pattern228 (x2, 
E_V4SImode) != 0
              || !((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 215 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3275 (insn, operands);

        case E_V8SImode:
          if (pattern228 (x2, 
E_V8SImode) != 0
              || !((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 216 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3289 (insn, operands);

        case E_V16SImode:
          if (pattern228 (x2, 
E_V16SImode) != 0
              || !((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 217 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3303 (insn, operands);

        case E_V32SImode:
          if (pattern228 (x2, 
E_V32SImode) != 0
              || !((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 218 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3317 (insn, operands);

        case E_V64SImode:
          if (pattern228 (x2, 
E_V64SImode) != 0
              || !((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 219 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3331 (insn, operands);

        case E_V128SImode:
          if (pattern228 (x2, 
E_V128SImode) != 0
              || !((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 220 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3345 (insn, operands);

        case E_V256SImode:
          if (pattern228 (x2, 
E_V256SImode) != 0
              || !((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 221 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3359 (insn, operands);

        case E_V512SImode:
          if (pattern228 (x2, 
E_V512SImode) != 0
              || !((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 222 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3373 (insn, operands);

        case E_V1024SImode:
          if (pattern228 (x2, 
E_V1024SImode) != 0
              || !((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 223 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3387 (insn, operands);

        case E_V1DImode:
          if (pattern228 (x2, 
E_V1DImode) != 0
              || !((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 224 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3401 (insn, operands);

        case E_V2DImode:
          if (pattern228 (x2, 
E_V2DImode) != 0
              || !((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 225 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3415 (insn, operands);

        case E_V4DImode:
          if (pattern228 (x2, 
E_V4DImode) != 0
              || !((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 226 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3429 (insn, operands);

        case E_V8DImode:
          if (pattern228 (x2, 
E_V8DImode) != 0
              || !((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 227 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3443 (insn, operands);

        case E_V16DImode:
          if (pattern228 (x2, 
E_V16DImode) != 0
              || !((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 228 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3457 (insn, operands);

        case E_V32DImode:
          if (pattern228 (x2, 
E_V32DImode) != 0
              || !((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 229 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3471 (insn, operands);

        case E_V64DImode:
          if (pattern228 (x2, 
E_V64DImode) != 0
              || !((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 230 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3485 (insn, operands);

        case E_V128DImode:
          if (pattern228 (x2, 
E_V128DImode) != 0
              || !((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 231 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3499 (insn, operands);

        case E_V256DImode:
          if (pattern228 (x2, 
E_V256DImode) != 0
              || !((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 232 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3513 (insn, operands);

        case E_V512DImode:
          if (pattern228 (x2, 
E_V512DImode) != 0
              || !((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 233 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3527 (insn, operands);

        case E_RVVMF64BImode:
          if (pattern0 (x2, 
E_RVVMF64BImode) != 0
              || !((
#line 538 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1533 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 540 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3947 (insn, operands);

        case E_RVVMF32BImode:
          if (pattern0 (x2, 
E_RVVMF32BImode) != 0
              || !(
#line 538 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 540 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3950 (insn, operands);

        case E_RVVMF16BImode:
          if (pattern0 (x2, 
E_RVVMF16BImode) != 0
              || !(
#line 538 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 540 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3953 (insn, operands);

        case E_RVVMF8BImode:
          if (pattern0 (x2, 
E_RVVMF8BImode) != 0
              || !(
#line 538 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 540 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3956 (insn, operands);

        case E_RVVMF4BImode:
          if (pattern0 (x2, 
E_RVVMF4BImode) != 0
              || !(
#line 538 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 540 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3959 (insn, operands);

        case E_RVVMF2BImode:
          if (pattern0 (x2, 
E_RVVMF2BImode) != 0
              || !(
#line 538 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 540 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3962 (insn, operands);

        case E_RVVM1BImode:
          if (pattern0 (x2, 
E_RVVM1BImode) != 0
              || !(
#line 538 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 540 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3965 (insn, operands);

        case E_V1BImode:
          if (pattern0 (x2, 
E_V1BImode) != 0
              || !((
#line 538 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1518 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode))) && 
#line 540 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3968 (insn, operands);

        case E_V2BImode:
          if (pattern0 (x2, 
E_V2BImode) != 0
              || !((
#line 538 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1519 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode))) && 
#line 540 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3971 (insn, operands);

        case E_V4BImode:
          if (pattern0 (x2, 
E_V4BImode) != 0
              || !((
#line 538 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1520 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode))) && 
#line 540 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3974 (insn, operands);

        case E_V8BImode:
          if (pattern0 (x2, 
E_V8BImode) != 0
              || !((
#line 538 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1521 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode))) && 
#line 540 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3977 (insn, operands);

        case E_V16BImode:
          if (pattern0 (x2, 
E_V16BImode) != 0
              || !((
#line 538 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1522 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode))) && 
#line 540 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3980 (insn, operands);

        case E_V32BImode:
          if (pattern0 (x2, 
E_V32BImode) != 0
              || !((
#line 538 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1523 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode))) && 
#line 540 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3983 (insn, operands);

        case E_V64BImode:
          if (pattern0 (x2, 
E_V64BImode) != 0
              || !((
#line 538 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1524 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64)) && 
#line 540 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3986 (insn, operands);

        case E_V128BImode:
          if (pattern0 (x2, 
E_V128BImode) != 0
              || !((
#line 538 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1525 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128)) && 
#line 540 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3989 (insn, operands);

        case E_V256BImode:
          if (pattern0 (x2, 
E_V256BImode) != 0
              || !((
#line 538 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1526 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256)) && 
#line 540 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3992 (insn, operands);

        case E_V512BImode:
          if (pattern0 (x2, 
E_V512BImode) != 0
              || !((
#line 538 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1527 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512)) && 
#line 540 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3995 (insn, operands);

        case E_V1024BImode:
          if (pattern0 (x2, 
E_V1024BImode) != 0
              || !((
#line 538 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1528 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 540 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3998 (insn, operands);

        case E_V2048BImode:
          if (pattern0 (x2, 
E_V2048BImode) != 0
              || !((
#line 538 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1529 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 540 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4001 (insn, operands);

        case E_V4096BImode:
          if (pattern0 (x2, 
E_V4096BImode) != 0
              || !((
#line 538 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1530 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 540 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4004 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_119 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern239 (x2))
    {
    case 0:
      if (!((
#line 2387 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 2389 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6237 (insn, operands);

    case 1:
      if (!((
#line 2387 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 2389 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6238 (insn, operands);

    case 2:
      if (!((
#line 2387 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 2389 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6239 (insn, operands);

    case 3:
      if (!((
#line 2387 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 2389 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6240 (insn, operands);

    case 4:
      if (!((
#line 2387 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 2389 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6241 (insn, operands);

    case 5:
      if (!((
#line 2387 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 157 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)) && 
#line 2389 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6242 (insn, operands);

    case 6:
      if (!((
#line 2387 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 236 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)) && 
#line 2389 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6252 (insn, operands);

    case 7:
      if (!((
#line 2387 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 237 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)) && 
#line 2389 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6253 (insn, operands);

    case 8:
      if (!((
#line 2387 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 238 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)) && 
#line 2389 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6254 (insn, operands);

    case 9:
      if (!((
#line 2387 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 239 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)) && 
#line 2389 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6255 (insn, operands);

    case 10:
      if (!((
#line 2387 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 240 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)) && 
#line 2389 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6256 (insn, operands);

    case 11:
      if (!((
#line 2387 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 241 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)) && 
#line 2389 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6257 (insn, operands);

    case 12:
      if (!((
#line 2387 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 242 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)) && 
#line 2389 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6258 (insn, operands);

    case 13:
      if (!((
#line 2387 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 243 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)) && 
#line 2389 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6259 (insn, operands);

    case 14:
      if (!((
#line 2387 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 244 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)) && 
#line 2389 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6260 (insn, operands);

    case 15:
      if (!((
#line 2387 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 245 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)) && 
#line 2389 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6261 (insn, operands);

    case 16:
      if (!((
#line 2387 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 246 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)) && 
#line 2389 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6262 (insn, operands);

    case 17:
      if (!((
#line 2387 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 247 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)) && 
#line 2389 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6263 (insn, operands);

    case 18:
      if (!((
#line 2387 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 2389 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6243 (insn, operands);

    case 19:
      if (!((
#line 2387 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 2389 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6244 (insn, operands);

    case 20:
      if (!((
#line 2387 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 2389 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6245 (insn, operands);

    case 21:
      if (!((
#line 2387 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 2389 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6246 (insn, operands);

    case 22:
      if (!((
#line 2387 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)) && 
#line 2389 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6247 (insn, operands);

    case 23:
      if (!((
#line 2387 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 248 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 2389 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6264 (insn, operands);

    case 24:
      if (!((
#line 2387 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 249 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 2389 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6265 (insn, operands);

    case 25:
      if (!((
#line 2387 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 250 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 2389 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6266 (insn, operands);

    case 26:
      if (!((
#line 2387 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 251 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 2389 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6267 (insn, operands);

    case 27:
      if (!((
#line 2387 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 252 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 2389 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6268 (insn, operands);

    case 28:
      if (!((
#line 2387 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 253 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)) && 
#line 2389 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6269 (insn, operands);

    case 29:
      if (!((
#line 2387 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 254 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)) && 
#line 2389 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6270 (insn, operands);

    case 30:
      if (!((
#line 2387 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 255 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 2389 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6271 (insn, operands);

    case 31:
      if (!((
#line 2387 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 256 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 2389 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6272 (insn, operands);

    case 32:
      if (!((
#line 2387 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 257 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)) && 
#line 2389 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6273 (insn, operands);

    case 33:
      if (!((
#line 2387 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 258 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)) && 
#line 2389 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6274 (insn, operands);

    case 34:
      if (!((
#line 2387 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 2389 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6248 (insn, operands);

    case 35:
      if (!((
#line 2387 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 2389 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6249 (insn, operands);

    case 36:
      if (!((
#line 2387 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 2389 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6250 (insn, operands);

    case 37:
      if (!((
#line 2387 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 2389 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6251 (insn, operands);

    case 38:
      if (!((
#line 2387 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 259 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 2389 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6275 (insn, operands);

    case 39:
      if (!((
#line 2387 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 260 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 2389 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6276 (insn, operands);

    case 40:
      if (!((
#line 2387 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 261 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 2389 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6277 (insn, operands);

    case 41:
      if (!((
#line 2387 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 262 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)) && 
#line 2389 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6278 (insn, operands);

    case 42:
      if (!((
#line 2387 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 263 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)) && 
#line 2389 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6279 (insn, operands);

    case 43:
      if (!((
#line 2387 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 264 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)) && 
#line 2389 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6280 (insn, operands);

    case 44:
      if (!((
#line 2387 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 265 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)) && 
#line 2389 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6281 (insn, operands);

    case 45:
      if (!((
#line 2387 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 266 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 2389 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6282 (insn, operands);

    case 46:
      if (!((
#line 2387 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 267 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 2389 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6283 (insn, operands);

    case 47:
      if (!((
#line 2387 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 268 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 2389 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6284 (insn, operands);

    case 48:
      if (!((
#line 850 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 685 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 852 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9110 (insn, operands);

    case 49:
      if (!((
#line 850 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 686 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 852 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9111 (insn, operands);

    case 50:
      if (!((
#line 850 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 687 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 852 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9112 (insn, operands);

    case 51:
      if (!((
#line 850 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 688 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 852 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9113 (insn, operands);

    case 52:
      if (!((
#line 850 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 689 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)) && 
#line 852 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9114 (insn, operands);

    case 53:
      if (!((
#line 850 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 695 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)) && 
#line 852 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9119 (insn, operands);

    case 54:
      if (!((
#line 850 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 696 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)) && 
#line 852 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9120 (insn, operands);

    case 55:
      if (!((
#line 850 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 697 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)) && 
#line 852 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9121 (insn, operands);

    case 56:
      if (!((
#line 850 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 698 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)) && 
#line 852 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9122 (insn, operands);

    case 57:
      if (!((
#line 850 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 699 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)) && 
#line 852 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9123 (insn, operands);

    case 58:
      if (!((
#line 850 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 700 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)) && 
#line 852 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9124 (insn, operands);

    case 59:
      if (!((
#line 850 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 701 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)) && 
#line 852 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9125 (insn, operands);

    case 60:
      if (!((
#line 850 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 702 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)) && 
#line 852 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9126 (insn, operands);

    case 61:
      if (!((
#line 850 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 703 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)) && 
#line 852 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9127 (insn, operands);

    case 62:
      if (!((
#line 850 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 704 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)) && 
#line 852 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9128 (insn, operands);

    case 63:
      if (!((
#line 850 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 705 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)) && 
#line 852 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9129 (insn, operands);

    case 64:
      if (!((
#line 850 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 690 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 852 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9115 (insn, operands);

    case 65:
      if (!((
#line 850 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 691 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 852 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9116 (insn, operands);

    case 66:
      if (!((
#line 850 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 692 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 852 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9117 (insn, operands);

    case 67:
      if (!((
#line 850 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 693 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)) && 
#line 852 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9118 (insn, operands);

    case 68:
      if (!((
#line 850 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 706 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 852 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9130 (insn, operands);

    case 69:
      if (!((
#line 850 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 707 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 852 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9131 (insn, operands);

    case 70:
      if (!((
#line 850 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 708 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 852 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9132 (insn, operands);

    case 71:
      if (!((
#line 850 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 709 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 852 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9133 (insn, operands);

    case 72:
      if (!((
#line 850 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 710 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 852 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9134 (insn, operands);

    case 73:
      if (!((
#line 850 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 711 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)) && 
#line 852 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9135 (insn, operands);

    case 74:
      if (!((
#line 850 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 712 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)) && 
#line 852 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9136 (insn, operands);

    case 75:
      if (!((
#line 850 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 713 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 852 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9137 (insn, operands);

    case 76:
      if (!((
#line 850 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 714 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 852 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9138 (insn, operands);

    case 77:
      if (!((
#line 850 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 715 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)) && 
#line 852 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9139 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_126 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  rtx_insn *res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8QImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVM8QImode, 
E_RVVM1BImode) != 0
          || !(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8QImode)
	|| register_operand (operands[3], RVVM8QImode)))) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM8QImode, 7))))
        return NULL;
      return gen_split_800 (insn, operands);

    case E_RVVM4QImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVM4QImode, 
E_RVVMF2BImode) != 0
          || !(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4QImode)
	|| register_operand (operands[3], RVVM4QImode)))) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM4QImode, 7))))
        return NULL;
      return gen_split_806 (insn, operands);

    case E_RVVM2QImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVM2QImode, 
E_RVVMF4BImode) != 0
          || !(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2QImode)
	|| register_operand (operands[3], RVVM2QImode)))) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM2QImode, 7))))
        return NULL;
      return gen_split_812 (insn, operands);

    case E_RVVM1QImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVM1QImode, 
E_RVVMF8BImode) != 0
          || !(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1QImode)
	|| register_operand (operands[3], RVVM1QImode)))) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM1QImode, 7))))
        return NULL;
      return gen_split_818 (insn, operands);

    case E_RVVM8HImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVM8HImode, 
E_RVVMF2BImode) != 0
          || !(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8HImode)
	|| register_operand (operands[3], RVVM8HImode)))) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM8HImode, 7))))
        return NULL;
      return gen_split_824 (insn, operands);

    case E_RVVM4HImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVM4HImode, 
E_RVVMF4BImode) != 0
          || !(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4HImode)
	|| register_operand (operands[3], RVVM4HImode)))) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM4HImode, 7))))
        return NULL;
      return gen_split_830 (insn, operands);

    case E_RVVM2HImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVM2HImode, 
E_RVVMF8BImode) != 0
          || !(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2HImode)
	|| register_operand (operands[3], RVVM2HImode)))) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM2HImode, 7))))
        return NULL;
      return gen_split_836 (insn, operands);

    case E_RVVM1HImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVM1HImode, 
E_RVVMF16BImode) != 0
          || !(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1HImode)
	|| register_operand (operands[3], RVVM1HImode)))) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM1HImode, 7))))
        return NULL;
      return gen_split_842 (insn, operands);

    case E_RVVM8SImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVM8SImode, 
E_RVVMF4BImode) != 0
          || !(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8SImode)
	|| register_operand (operands[3], RVVM8SImode)))) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM8SImode, 7))))
        return NULL;
      return gen_split_848 (insn, operands);

    case E_RVVM4SImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVM4SImode, 
E_RVVMF8BImode) != 0
          || !(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4SImode)
	|| register_operand (operands[3], RVVM4SImode)))) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM4SImode, 7))))
        return NULL;
      return gen_split_854 (insn, operands);

    case E_RVVM2SImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVM2SImode, 
E_RVVMF16BImode) != 0
          || !(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2SImode)
	|| register_operand (operands[3], RVVM2SImode)))) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM2SImode, 7))))
        return NULL;
      return gen_split_860 (insn, operands);

    case E_RVVM1SImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVM1SImode, 
E_RVVMF32BImode) != 0
          || !(
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1SImode)
	|| register_operand (operands[3], RVVM1SImode)))) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM1SImode, 7))))
        return NULL;
      return gen_split_866 (insn, operands);

    case E_RVVM8DImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVM8DImode, 
E_RVVMF8BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8DImode)
	|| register_operand (operands[3], RVVM8DImode)))) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM8DImode, 7))))
        return NULL;
      return gen_split_872 (insn, operands);

    case E_RVVM4DImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVM4DImode, 
E_RVVMF16BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4DImode)
	|| register_operand (operands[3], RVVM4DImode)))) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM4DImode, 7))))
        return NULL;
      return gen_split_878 (insn, operands);

    case E_RVVM2DImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVM2DImode, 
E_RVVMF32BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2DImode)
	|| register_operand (operands[3], RVVM2DImode)))) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM2DImode, 7))))
        return NULL;
      return gen_split_884 (insn, operands);

    case E_RVVM1DImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVM1DImode, 
E_RVVMF64BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1DImode)
	|| register_operand (operands[3], RVVM1DImode)))) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM1DImode, 7))))
        return NULL;
      return gen_split_890 (insn, operands);

    case E_RVVMF2QImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVMF2QImode, 
E_RVVMF16BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF2QImode)
	|| register_operand (operands[3], RVVMF2QImode)))) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF2QImode, 7))))
        return NULL;
      return gen_split_896 (insn, operands);

    case E_RVVMF4QImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVMF4QImode, 
E_RVVMF32BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF4QImode)
	|| register_operand (operands[3], RVVMF4QImode)))) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF4QImode, 7))))
        return NULL;
      return gen_split_902 (insn, operands);

    case E_RVVMF8QImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVMF8QImode, 
E_RVVMF64BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF8QImode)
	|| register_operand (operands[3], RVVMF8QImode)))) && (
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF8QImode, 7))))
        return NULL;
      return gen_split_908 (insn, operands);

    case E_RVVMF2HImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVMF2HImode, 
E_RVVMF32BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF2HImode)
	|| register_operand (operands[3], RVVMF2HImode)))) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF2HImode, 7))))
        return NULL;
      return gen_split_914 (insn, operands);

    case E_RVVMF4HImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVMF4HImode, 
E_RVVMF64BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF4HImode)
	|| register_operand (operands[3], RVVMF4HImode)))) && (
#line 132 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF4HImode, 7))))
        return NULL;
      return gen_split_920 (insn, operands);

    case E_RVVMF2SImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVMF2SImode, 
E_RVVMF64BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF2SImode)
	|| register_operand (operands[3], RVVMF2SImode)))) && (
#line 133 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF2SImode, 7))))
        return NULL;
      return gen_split_926 (insn, operands);

    case E_RVVM8BFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVM8BFmode, 
E_RVVMF2BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8BFmode)
	|| register_operand (operands[3], RVVM8BFmode)))) && 
#line 167 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM8BFmode, 7))))
        return NULL;
      return gen_split_932 (insn, operands);

    case E_RVVM4BFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVM4BFmode, 
E_RVVMF4BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4BFmode)
	|| register_operand (operands[3], RVVM4BFmode)))) && 
#line 168 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM4BFmode, 7))))
        return NULL;
      return gen_split_938 (insn, operands);

    case E_RVVM2BFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVM2BFmode, 
E_RVVMF8BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2BFmode)
	|| register_operand (operands[3], RVVM2BFmode)))) && 
#line 169 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM2BFmode, 7))))
        return NULL;
      return gen_split_944 (insn, operands);

    case E_RVVM1BFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVM1BFmode, 
E_RVVMF16BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1BFmode)
	|| register_operand (operands[3], RVVM1BFmode)))) && 
#line 170 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM1BFmode, 7))))
        return NULL;
      return gen_split_950 (insn, operands);

    case E_RVVMF2BFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVMF2BFmode, 
E_RVVMF32BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF2BFmode)
	|| register_operand (operands[3], RVVMF2BFmode)))) && 
#line 171 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF2BFmode, 7))))
        return NULL;
      return gen_split_956 (insn, operands);

    case E_RVVMF4BFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVMF4BFmode, 
E_RVVMF64BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF4BFmode)
	|| register_operand (operands[3], RVVMF4BFmode)))) && 
#line 172 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16 && TARGET_MIN_VLEN > 32)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF4BFmode, 7))))
        return NULL;
      return gen_split_962 (insn, operands);

    case E_RVVM8HFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVM8HFmode, 
E_RVVMF2BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8HFmode)
	|| register_operand (operands[3], RVVM8HFmode)))) && 
#line 176 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM8HFmode, 7))))
        return NULL;
      return gen_split_968 (insn, operands);

    case E_RVVM4HFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVM4HFmode, 
E_RVVMF4BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4HFmode)
	|| register_operand (operands[3], RVVM4HFmode)))) && 
#line 176 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM4HFmode, 7))))
        return NULL;
      return gen_split_974 (insn, operands);

    case E_RVVM2HFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVM2HFmode, 
E_RVVMF8BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2HFmode)
	|| register_operand (operands[3], RVVM2HFmode)))) && 
#line 176 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM2HFmode, 7))))
        return NULL;
      return gen_split_980 (insn, operands);

    case E_RVVM1HFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVM1HFmode, 
E_RVVMF16BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1HFmode)
	|| register_operand (operands[3], RVVM1HFmode)))) && 
#line 177 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM1HFmode, 7))))
        return NULL;
      return gen_split_986 (insn, operands);

    case E_RVVMF2HFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVMF2HFmode, 
E_RVVMF32BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF2HFmode)
	|| register_operand (operands[3], RVVMF2HFmode)))) && 
#line 177 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF2HFmode, 7))))
        return NULL;
      return gen_split_992 (insn, operands);

    case E_RVVMF4HFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVMF4HFmode, 
E_RVVMF64BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF4HFmode)
	|| register_operand (operands[3], RVVMF4HFmode)))) && 
#line 178 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN > 32)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF4HFmode, 7))))
        return NULL;
      return gen_split_998 (insn, operands);

    case E_RVVM8SFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVM8SFmode, 
E_RVVMF4BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8SFmode)
	|| register_operand (operands[3], RVVM8SFmode)))) && 
#line 180 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM8SFmode, 7))))
        return NULL;
      return gen_split_1004 (insn, operands);

    case E_RVVM4SFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVM4SFmode, 
E_RVVMF8BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4SFmode)
	|| register_operand (operands[3], RVVM4SFmode)))) && 
#line 180 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM4SFmode, 7))))
        return NULL;
      return gen_split_1010 (insn, operands);

    case E_RVVM2SFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVM2SFmode, 
E_RVVMF16BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2SFmode)
	|| register_operand (operands[3], RVVM2SFmode)))) && 
#line 180 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM2SFmode, 7))))
        return NULL;
      return gen_split_1016 (insn, operands);

    case E_RVVM1SFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVM1SFmode, 
E_RVVMF32BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1SFmode)
	|| register_operand (operands[3], RVVM1SFmode)))) && 
#line 181 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM1SFmode, 7))))
        return NULL;
      return gen_split_1022 (insn, operands);

    case E_RVVMF2SFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVMF2SFmode, 
E_RVVMF64BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF2SFmode)
	|| register_operand (operands[3], RVVMF2SFmode)))) && 
#line 181 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF2SFmode, 7))))
        return NULL;
      return gen_split_1028 (insn, operands);

    case E_RVVM8DFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVM8DFmode, 
E_RVVMF8BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8DFmode)
	|| register_operand (operands[3], RVVM8DFmode)))) && 
#line 183 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM8DFmode, 7))))
        return NULL;
      return gen_split_1034 (insn, operands);

    case E_RVVM4DFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVM4DFmode, 
E_RVVMF16BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4DFmode)
	|| register_operand (operands[3], RVVM4DFmode)))) && 
#line 183 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM4DFmode, 7))))
        return NULL;
      return gen_split_1040 (insn, operands);

    case E_RVVM2DFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVM2DFmode, 
E_RVVMF32BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2DFmode)
	|| register_operand (operands[3], RVVM2DFmode)))) && 
#line 184 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM2DFmode, 7))))
        return NULL;
      return gen_split_1046 (insn, operands);

    case E_RVVM1DFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_RVVM1DFmode, 
E_RVVMF64BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1DFmode)
	|| register_operand (operands[3], RVVM1DFmode)))) && 
#line 184 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM1DFmode, 7))))
        return NULL;
      return gen_split_1052 (insn, operands);

    case E_V1QImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V1QImode, 
E_V1BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1QImode)
	|| register_operand (operands[3], V1QImode)))) && 
#line 188 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1QImode, 7))))
        return NULL;
      return gen_split_1058 (insn, operands);

    case E_V2QImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V2QImode, 
E_V2BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2QImode)
	|| register_operand (operands[3], V2QImode)))) && 
#line 189 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V2QImode, 7))))
        return NULL;
      return gen_split_1064 (insn, operands);

    case E_V4QImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V4QImode, 
E_V4BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4QImode)
	|| register_operand (operands[3], V4QImode)))) && 
#line 190 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V4QImode, 7))))
        return NULL;
      return gen_split_1070 (insn, operands);

    case E_V8QImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V8QImode, 
E_V8BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V8QImode)
	|| register_operand (operands[3], V8QImode)))) && 
#line 191 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V8QImode, 7))))
        return NULL;
      return gen_split_1076 (insn, operands);

    case E_V16QImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V16QImode, 
E_V16BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V16QImode)
	|| register_operand (operands[3], V16QImode)))) && 
#line 192 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V16QImode, 7))))
        return NULL;
      return gen_split_1082 (insn, operands);

    case E_V32QImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V32QImode, 
E_V32BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V32QImode)
	|| register_operand (operands[3], V32QImode)))) && 
#line 193 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V32QImode, 7))))
        return NULL;
      return gen_split_1088 (insn, operands);

    case E_V64QImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V64QImode, 
E_V64BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V64QImode)
	|| register_operand (operands[3], V64QImode)))) && 
#line 194 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V64QImode, 7))))
        return NULL;
      return gen_split_1094 (insn, operands);

    case E_V128QImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V128QImode, 
E_V128BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V128QImode)
	|| register_operand (operands[3], V128QImode)))) && 
#line 195 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V128QImode, 7))))
        return NULL;
      return gen_split_1100 (insn, operands);

    case E_V256QImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V256QImode, 
E_V256BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V256QImode)
	|| register_operand (operands[3], V256QImode)))) && 
#line 196 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V256QImode, 7))))
        return NULL;
      return gen_split_1106 (insn, operands);

    case E_V512QImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V512QImode, 
E_V512BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V512QImode)
	|| register_operand (operands[3], V512QImode)))) && 
#line 197 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V512QImode, 7))))
        return NULL;
      return gen_split_1112 (insn, operands);

    case E_V1024QImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V1024QImode, 
E_V1024BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1024QImode)
	|| register_operand (operands[3], V1024QImode)))) && 
#line 198 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1024QImode, 7))))
        return NULL;
      return gen_split_1118 (insn, operands);

    case E_V2048QImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V2048QImode, 
E_V2048BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2048QImode)
	|| register_operand (operands[3], V2048QImode)))) && 
#line 199 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V2048QImode, 7))))
        return NULL;
      return gen_split_1124 (insn, operands);

    case E_V4096QImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V4096QImode, 
E_V4096BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4096QImode)
	|| register_operand (operands[3], V4096QImode)))) && 
#line 200 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V4096QImode, 7))))
        return NULL;
      return gen_split_1130 (insn, operands);

    case E_V1HImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V1HImode, 
E_V1BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1HImode)
	|| register_operand (operands[3], V1HImode)))) && 
#line 201 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1HImode, 7))))
        return NULL;
      return gen_split_1136 (insn, operands);

    case E_V2HImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V2HImode, 
E_V2BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2HImode)
	|| register_operand (operands[3], V2HImode)))) && 
#line 202 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V2HImode, 7))))
        return NULL;
      return gen_split_1142 (insn, operands);

    case E_V4HImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V4HImode, 
E_V4BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4HImode)
	|| register_operand (operands[3], V4HImode)))) && 
#line 203 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V4HImode, 7))))
        return NULL;
      return gen_split_1148 (insn, operands);

    case E_V8HImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V8HImode, 
E_V8BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V8HImode)
	|| register_operand (operands[3], V8HImode)))) && 
#line 204 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V8HImode, 7))))
        return NULL;
      return gen_split_1154 (insn, operands);

    case E_V16HImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V16HImode, 
E_V16BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V16HImode)
	|| register_operand (operands[3], V16HImode)))) && 
#line 205 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V16HImode, 7))))
        return NULL;
      return gen_split_1160 (insn, operands);

    case E_V32HImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V32HImode, 
E_V32BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V32HImode)
	|| register_operand (operands[3], V32HImode)))) && 
#line 206 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V32HImode, 7))))
        return NULL;
      return gen_split_1166 (insn, operands);

    case E_V64HImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V64HImode, 
E_V64BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V64HImode)
	|| register_operand (operands[3], V64HImode)))) && 
#line 207 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V64HImode, 7))))
        return NULL;
      return gen_split_1172 (insn, operands);

    case E_V128HImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V128HImode, 
E_V128BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V128HImode)
	|| register_operand (operands[3], V128HImode)))) && 
#line 208 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V128HImode, 7))))
        return NULL;
      return gen_split_1178 (insn, operands);

    case E_V256HImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V256HImode, 
E_V256BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V256HImode)
	|| register_operand (operands[3], V256HImode)))) && 
#line 209 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V256HImode, 7))))
        return NULL;
      return gen_split_1184 (insn, operands);

    case E_V512HImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V512HImode, 
E_V512BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V512HImode)
	|| register_operand (operands[3], V512HImode)))) && 
#line 210 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V512HImode, 7))))
        return NULL;
      return gen_split_1190 (insn, operands);

    case E_V1024HImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V1024HImode, 
E_V1024BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1024HImode)
	|| register_operand (operands[3], V1024HImode)))) && 
#line 211 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1024HImode, 7))))
        return NULL;
      return gen_split_1196 (insn, operands);

    case E_V2048HImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V2048HImode, 
E_V2048BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2048HImode)
	|| register_operand (operands[3], V2048HImode)))) && 
#line 212 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V2048HImode, 7))))
        return NULL;
      return gen_split_1202 (insn, operands);

    case E_V1SImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V1SImode, 
E_V1BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1SImode)
	|| register_operand (operands[3], V1SImode)))) && 
#line 213 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1SImode, 7))))
        return NULL;
      return gen_split_1208 (insn, operands);

    case E_V2SImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V2SImode, 
E_V2BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2SImode)
	|| register_operand (operands[3], V2SImode)))) && 
#line 214 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V2SImode, 7))))
        return NULL;
      return gen_split_1214 (insn, operands);

    case E_V4SImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V4SImode, 
E_V4BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4SImode)
	|| register_operand (operands[3], V4SImode)))) && 
#line 215 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V4SImode, 7))))
        return NULL;
      return gen_split_1220 (insn, operands);

    case E_V8SImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V8SImode, 
E_V8BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V8SImode)
	|| register_operand (operands[3], V8SImode)))) && 
#line 216 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V8SImode, 7))))
        return NULL;
      return gen_split_1226 (insn, operands);

    case E_V16SImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V16SImode, 
E_V16BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V16SImode)
	|| register_operand (operands[3], V16SImode)))) && 
#line 217 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V16SImode, 7))))
        return NULL;
      return gen_split_1232 (insn, operands);

    case E_V32SImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V32SImode, 
E_V32BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V32SImode)
	|| register_operand (operands[3], V32SImode)))) && 
#line 218 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V32SImode, 7))))
        return NULL;
      return gen_split_1238 (insn, operands);

    case E_V64SImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V64SImode, 
E_V64BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V64SImode)
	|| register_operand (operands[3], V64SImode)))) && 
#line 219 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V64SImode, 7))))
        return NULL;
      return gen_split_1244 (insn, operands);

    case E_V128SImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V128SImode, 
E_V128BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V128SImode)
	|| register_operand (operands[3], V128SImode)))) && 
#line 220 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V128SImode, 7))))
        return NULL;
      return gen_split_1250 (insn, operands);

    case E_V256SImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V256SImode, 
E_V256BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V256SImode)
	|| register_operand (operands[3], V256SImode)))) && 
#line 221 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V256SImode, 7))))
        return NULL;
      return gen_split_1256 (insn, operands);

    case E_V512SImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V512SImode, 
E_V512BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V512SImode)
	|| register_operand (operands[3], V512SImode)))) && 
#line 222 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V512SImode, 7))))
        return NULL;
      return gen_split_1262 (insn, operands);

    case E_V1024SImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V1024SImode, 
E_V1024BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1024SImode)
	|| register_operand (operands[3], V1024SImode)))) && 
#line 223 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1024SImode, 7))))
        return NULL;
      return gen_split_1268 (insn, operands);

    case E_V1DImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V1DImode, 
E_V1BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1DImode)
	|| register_operand (operands[3], V1DImode)))) && 
#line 224 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1DImode, 7))))
        return NULL;
      return gen_split_1274 (insn, operands);

    case E_V2DImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V2DImode, 
E_V2BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2DImode)
	|| register_operand (operands[3], V2DImode)))) && 
#line 225 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V2DImode, 7))))
        return NULL;
      return gen_split_1280 (insn, operands);

    case E_V4DImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V4DImode, 
E_V4BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4DImode)
	|| register_operand (operands[3], V4DImode)))) && 
#line 226 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V4DImode, 7))))
        return NULL;
      return gen_split_1286 (insn, operands);

    case E_V8DImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V8DImode, 
E_V8BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V8DImode)
	|| register_operand (operands[3], V8DImode)))) && 
#line 227 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V8DImode, 7))))
        return NULL;
      return gen_split_1292 (insn, operands);

    case E_V16DImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V16DImode, 
E_V16BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V16DImode)
	|| register_operand (operands[3], V16DImode)))) && 
#line 228 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V16DImode, 7))))
        return NULL;
      return gen_split_1298 (insn, operands);

    case E_V32DImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V32DImode, 
E_V32BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V32DImode)
	|| register_operand (operands[3], V32DImode)))) && 
#line 229 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V32DImode, 7))))
        return NULL;
      return gen_split_1304 (insn, operands);

    case E_V64DImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V64DImode, 
E_V64BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V64DImode)
	|| register_operand (operands[3], V64DImode)))) && 
#line 230 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V64DImode, 7))))
        return NULL;
      return gen_split_1310 (insn, operands);

    case E_V128DImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V128DImode, 
E_V128BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V128DImode)
	|| register_operand (operands[3], V128DImode)))) && 
#line 231 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V128DImode, 7))))
        return NULL;
      return gen_split_1316 (insn, operands);

    case E_V256DImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V256DImode, 
E_V256BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V256DImode)
	|| register_operand (operands[3], V256DImode)))) && 
#line 232 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V256DImode, 7))))
        return NULL;
      return gen_split_1322 (insn, operands);

    case E_V512DImode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V512DImode, 
E_V512BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V512DImode)
	|| register_operand (operands[3], V512DImode)))) && 
#line 233 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V512DImode, 7))))
        return NULL;
      return gen_split_1328 (insn, operands);

    case E_V1HFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V1HFmode, 
E_V1BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1HFmode)
	|| register_operand (operands[3], V1HFmode)))) && 
#line 272 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_VECTOR_ELEN_FP_16)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1HFmode, 7))))
        return NULL;
      return gen_split_1334 (insn, operands);

    case E_V2HFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V2HFmode, 
E_V2BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2HFmode)
	|| register_operand (operands[3], V2HFmode)))) && 
#line 273 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_VECTOR_ELEN_FP_16)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V2HFmode, 7))))
        return NULL;
      return gen_split_1340 (insn, operands);

    case E_V4HFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V4HFmode, 
E_V4BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4HFmode)
	|| register_operand (operands[3], V4HFmode)))) && 
#line 274 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_VECTOR_ELEN_FP_16)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V4HFmode, 7))))
        return NULL;
      return gen_split_1346 (insn, operands);

    case E_V8HFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V8HFmode, 
E_V8BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V8HFmode)
	|| register_operand (operands[3], V8HFmode)))) && 
#line 275 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_VECTOR_ELEN_FP_16)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V8HFmode, 7))))
        return NULL;
      return gen_split_1352 (insn, operands);

    case E_V16HFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V16HFmode, 
E_V16BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V16HFmode)
	|| register_operand (operands[3], V16HFmode)))) && 
#line 276 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_VECTOR_ELEN_FP_16)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V16HFmode, 7))))
        return NULL;
      return gen_split_1358 (insn, operands);

    case E_V32HFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V32HFmode, 
E_V32BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V32HFmode)
	|| register_operand (operands[3], V32HFmode)))) && 
#line 277 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 64)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V32HFmode, 7))))
        return NULL;
      return gen_split_1364 (insn, operands);

    case E_V64HFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V64HFmode, 
E_V64BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V64HFmode)
	|| register_operand (operands[3], V64HFmode)))) && 
#line 278 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 128)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V64HFmode, 7))))
        return NULL;
      return gen_split_1370 (insn, operands);

    case E_V128HFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V128HFmode, 
E_V128BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V128HFmode)
	|| register_operand (operands[3], V128HFmode)))) && 
#line 279 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 256)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V128HFmode, 7))))
        return NULL;
      return gen_split_1376 (insn, operands);

    case E_V256HFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V256HFmode, 
E_V256BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V256HFmode)
	|| register_operand (operands[3], V256HFmode)))) && 
#line 280 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 512)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V256HFmode, 7))))
        return NULL;
      return gen_split_1382 (insn, operands);

    case E_V512HFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V512HFmode, 
E_V512BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V512HFmode)
	|| register_operand (operands[3], V512HFmode)))) && 
#line 281 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 1024)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V512HFmode, 7))))
        return NULL;
      return gen_split_1388 (insn, operands);

    case E_V1024HFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V1024HFmode, 
E_V1024BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1024HFmode)
	|| register_operand (operands[3], V1024HFmode)))) && 
#line 282 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 2048)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1024HFmode, 7))))
        return NULL;
      return gen_split_1394 (insn, operands);

    case E_V2048HFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V2048HFmode, 
E_V2048BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2048HFmode)
	|| register_operand (operands[3], V2048HFmode)))) && 
#line 283 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 4096)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V2048HFmode, 7))))
        return NULL;
      return gen_split_1400 (insn, operands);

    case E_V1SFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V1SFmode, 
E_V1BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1SFmode)
	|| register_operand (operands[3], V1SFmode)))) && 
#line 284 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1SFmode, 7))))
        return NULL;
      return gen_split_1406 (insn, operands);

    case E_V2SFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V2SFmode, 
E_V2BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2SFmode)
	|| register_operand (operands[3], V2SFmode)))) && 
#line 285 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V2SFmode, 7))))
        return NULL;
      return gen_split_1412 (insn, operands);

    case E_V4SFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V4SFmode, 
E_V4BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4SFmode)
	|| register_operand (operands[3], V4SFmode)))) && 
#line 286 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V4SFmode, 7))))
        return NULL;
      return gen_split_1418 (insn, operands);

    case E_V8SFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V8SFmode, 
E_V8BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V8SFmode)
	|| register_operand (operands[3], V8SFmode)))) && 
#line 287 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V8SFmode, 7))))
        return NULL;
      return gen_split_1424 (insn, operands);

    case E_V16SFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V16SFmode, 
E_V16BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V16SFmode)
	|| register_operand (operands[3], V16SFmode)))) && 
#line 288 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V16SFmode, 7))))
        return NULL;
      return gen_split_1430 (insn, operands);

    case E_V32SFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V32SFmode, 
E_V32BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V32SFmode)
	|| register_operand (operands[3], V32SFmode)))) && 
#line 289 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V32SFmode, 7))))
        return NULL;
      return gen_split_1436 (insn, operands);

    case E_V64SFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V64SFmode, 
E_V64BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V64SFmode)
	|| register_operand (operands[3], V64SFmode)))) && 
#line 290 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V64SFmode, 7))))
        return NULL;
      return gen_split_1442 (insn, operands);

    case E_V128SFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V128SFmode, 
E_V128BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V128SFmode)
	|| register_operand (operands[3], V128SFmode)))) && 
#line 291 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V128SFmode, 7))))
        return NULL;
      return gen_split_1448 (insn, operands);

    case E_V256SFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V256SFmode, 
E_V256BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V256SFmode)
	|| register_operand (operands[3], V256SFmode)))) && 
#line 292 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V256SFmode, 7))))
        return NULL;
      return gen_split_1454 (insn, operands);

    case E_V512SFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V512SFmode, 
E_V512BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V512SFmode)
	|| register_operand (operands[3], V512SFmode)))) && 
#line 293 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V512SFmode, 7))))
        return NULL;
      return gen_split_1460 (insn, operands);

    case E_V1024SFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V1024SFmode, 
E_V1024BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1024SFmode)
	|| register_operand (operands[3], V1024SFmode)))) && 
#line 294 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1024SFmode, 7))))
        return NULL;
      return gen_split_1466 (insn, operands);

    case E_V1DFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V1DFmode, 
E_V1BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1DFmode)
	|| register_operand (operands[3], V1DFmode)))) && 
#line 295 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1DFmode, 7))))
        return NULL;
      return gen_split_1472 (insn, operands);

    case E_V2DFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V2DFmode, 
E_V2BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2DFmode)
	|| register_operand (operands[3], V2DFmode)))) && 
#line 296 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V2DFmode, 7))))
        return NULL;
      return gen_split_1478 (insn, operands);

    case E_V4DFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V4DFmode, 
E_V4BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4DFmode)
	|| register_operand (operands[3], V4DFmode)))) && 
#line 297 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V4DFmode, 7))))
        return NULL;
      return gen_split_1484 (insn, operands);

    case E_V8DFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V8DFmode, 
E_V8BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V8DFmode)
	|| register_operand (operands[3], V8DFmode)))) && 
#line 298 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V8DFmode, 7))))
        return NULL;
      return gen_split_1490 (insn, operands);

    case E_V16DFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V16DFmode, 
E_V16BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V16DFmode)
	|| register_operand (operands[3], V16DFmode)))) && 
#line 299 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V16DFmode, 7))))
        return NULL;
      return gen_split_1496 (insn, operands);

    case E_V32DFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V32DFmode, 
E_V32BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V32DFmode)
	|| register_operand (operands[3], V32DFmode)))) && 
#line 300 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V32DFmode, 7))))
        return NULL;
      return gen_split_1502 (insn, operands);

    case E_V64DFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V64DFmode, 
E_V64BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V64DFmode)
	|| register_operand (operands[3], V64DFmode)))) && 
#line 301 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V64DFmode, 7))))
        return NULL;
      return gen_split_1508 (insn, operands);

    case E_V128DFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V128DFmode, 
E_V128BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V128DFmode)
	|| register_operand (operands[3], V128DFmode)))) && 
#line 302 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V128DFmode, 7))))
        return NULL;
      return gen_split_1514 (insn, operands);

    case E_V256DFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V256DFmode, 
E_V256BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V256DFmode)
	|| register_operand (operands[3], V256DFmode)))) && 
#line 303 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V256DFmode, 7))))
        return NULL;
      return gen_split_1520 (insn, operands);

    case E_V512DFmode:
      x2 = XEXP (x1, 1);
      if (pattern468 (x2, 
E_V512DFmode, 
E_V512BImode) != 0
          || !((
#line 221 "../../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V512DFmode)
	|| register_operand (operands[3], V512DFmode)))) && 
#line 304 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 231 "../../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V512DFmode, 7))))
        return NULL;
      return gen_split_1526 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_134 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  rtx_insn *res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8QImode:
      x2 = XEXP (x1, 1);
      if (pattern354 (x2, 
E_RVVM8QImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2588 (insn, operands);

    case E_RVVM4QImode:
      x2 = XEXP (x1, 1);
      if (pattern354 (x2, 
E_RVVM4QImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2602 (insn, operands);

    case E_RVVM2QImode:
      x2 = XEXP (x1, 1);
      if (pattern354 (x2, 
E_RVVM2QImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2616 (insn, operands);

    case E_RVVM1QImode:
      x2 = XEXP (x1, 1);
      if (pattern354 (x2, 
E_RVVM1QImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2630 (insn, operands);

    case E_RVVM8HImode:
      x2 = XEXP (x1, 1);
      if (pattern354 (x2, 
E_RVVM8HImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2644 (insn, operands);

    case E_RVVM4HImode:
      x2 = XEXP (x1, 1);
      if (pattern354 (x2, 
E_RVVM4HImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2658 (insn, operands);

    case E_RVVM2HImode:
      x2 = XEXP (x1, 1);
      if (pattern354 (x2, 
E_RVVM2HImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2672 (insn, operands);

    case E_RVVM1HImode:
      x2 = XEXP (x1, 1);
      if (pattern354 (x2, 
E_RVVM1HImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2686 (insn, operands);

    case E_RVVM8SImode:
      x2 = XEXP (x1, 1);
      if (pattern354 (x2, 
E_RVVM8SImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2700 (insn, operands);

    case E_RVVM4SImode:
      x2 = XEXP (x1, 1);
      if (pattern354 (x2, 
E_RVVM4SImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2714 (insn, operands);

    case E_RVVM2SImode:
      x2 = XEXP (x1, 1);
      if (pattern354 (x2, 
E_RVVM2SImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2728 (insn, operands);

    case E_RVVM1SImode:
      x2 = XEXP (x1, 1);
      if (pattern354 (x2, 
E_RVVM1SImode) != 0
          || !(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2742 (insn, operands);

    case E_RVVM8DImode:
      x2 = XEXP (x1, 1);
      if (pattern354 (x2, 
E_RVVM8DImode) != 0
          || !((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2756 (insn, operands);

    case E_RVVM4DImode:
      x2 = XEXP (x1, 1);
      if (pattern354 (x2, 
E_RVVM4DImode) != 0
          || !((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2770 (insn, operands);

    case E_RVVM2DImode:
      x2 = XEXP (x1, 1);
      if (pattern354 (x2, 
E_RVVM2DImode) != 0
          || !((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2784 (insn, operands);

    case E_RVVM1DImode:
      x2 = XEXP (x1, 1);
      if (pattern354 (x2, 
E_RVVM1DImode) != 0
          || !((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2798 (insn, operands);

    case E_RVVMF2QImode:
      x2 = XEXP (x1, 1);
      if (pattern354 (x2, 
E_RVVMF2QImode) != 0
          || !((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2812 (insn, operands);

    case E_RVVMF4QImode:
      x2 = XEXP (x1, 1);
      if (pattern354 (x2, 
E_RVVMF4QImode) != 0
          || !((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2826 (insn, operands);

    case E_RVVMF8QImode:
      x2 = XEXP (x1, 1);
      if (pattern354 (x2, 
E_RVVMF8QImode) != 0
          || !((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2840 (insn, operands);

    case E_RVVMF2HImode:
      x2 = XEXP (x1, 1);
      if (pattern354 (x2, 
E_RVVMF2HImode) != 0
          || !((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2854 (insn, operands);

    case E_RVVMF4HImode:
      x2 = XEXP (x1, 1);
      if (pattern354 (x2, 
E_RVVMF4HImode) != 0
          || !((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 132 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2868 (insn, operands);

    case E_RVVMF2SImode:
      x2 = XEXP (x1, 1);
      if (pattern354 (x2, 
E_RVVMF2SImode) != 0
          || !((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 133 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2882 (insn, operands);

    case E_V1QImode:
      x2 = XEXP (x1, 1);
      if (pattern354 (x2, 
E_V1QImode) != 0
          || !((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 188 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2896 (insn, operands);

    case E_V2QImode:
      x2 = XEXP (x1, 1);
      if (pattern354 (x2, 
E_V2QImode) != 0
          || !((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 189 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2910 (insn, operands);

    case E_V4QImode:
      x2 = XEXP (x1, 1);
      if (pattern354 (x2, 
E_V4QImode) != 0
          || !((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 190 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2924 (insn, operands);

    case E_V8QImode:
      x2 = XEXP (x1, 1);
      if (pattern354 (x2, 
E_V8QImode) != 0
          || !((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 191 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2938 (insn, operands);

    case E_V16QImode:
      x2 = XEXP (x1, 1);
      if (pattern354 (x2, 
E_V16QImode) != 0
          || !((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 192 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2952 (insn, operands);

    case E_V32QImode:
      x2 = XEXP (x1, 1);
      if (pattern354 (x2, 
E_V32QImode) != 0
          || !((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 193 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2966 (insn, operands);

    case E_V64QImode:
      x2 = XEXP (x1, 1);
      if (pattern354 (x2, 
E_V64QImode) != 0
          || !((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 194 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2980 (insn, operands);

    case E_V128QImode:
      x2 = XEXP (x1, 1);
      if (pattern354 (x2, 
E_V128QImode) != 0
          || !((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 195 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2994 (insn, operands);

    case E_V256QImode:
      x2 = XEXP (x1, 1);
      if (pattern354 (x2, 
E_V256QImode) != 0
          || !((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 196 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3008 (insn, operands);

    case E_V512QImode:
      x2 = XEXP (x1, 1);
      if (pattern354 (x2, 
E_V512QImode) != 0
          || !((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 197 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3022 (insn, operands);

    case E_V1024QImode:
      x2 = XEXP (x1, 1);
      if (pattern354 (x2, 
E_V1024QImode) != 0
          || !((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 198 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3036 (insn, operands);

    case E_V2048QImode:
      x2 = XEXP (x1, 1);
      if (pattern354 (x2, 
E_V2048QImode) != 0
          || !((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 199 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3050 (insn, operands);

    case E_V4096QImode:
      x2 = XEXP (x1, 1);
      if (pattern354 (x2, 
E_V4096QImode) != 0
          || !((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 200 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3064 (insn, operands);

    case E_V1HImode:
      x2 = XEXP (x1, 1);
      if (pattern354 (x2, 
E_V1HImode) != 0
          || !((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 201 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3078 (insn, operands);

    case E_V2HImode:
      x2 = XEXP (x1, 1);
      if (pattern354 (x2, 
E_V2HImode) != 0
          || !((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 202 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3092 (insn, operands);

    case E_V4HImode:
      x2 = XEXP (x1, 1);
      if (pattern354 (x2, 
E_V4HImode) != 0
          || !((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 203 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3106 (insn, operands);

    case E_V8HImode:
      x2 = XEXP (x1, 1);
      if (pattern354 (x2, 
E_V8HImode) != 0
          || !((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 204 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3120 (insn, operands);

    case E_V16HImode:
      x2 = XEXP (x1, 1);
      if (pattern354 (x2, 
E_V16HImode) != 0
          || !((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 205 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3134 (insn, operands);

    case E_V32HImode:
      x2 = XEXP (x1, 1);
      if (pattern354 (x2, 
E_V32HImode) != 0
          || !((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 206 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3148 (insn, operands);

    case E_V64HImode:
      x2 = XEXP (x1, 1);
      if (pattern354 (x2, 
E_V64HImode) != 0
          || !((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 207 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3162 (insn, operands);

    case E_V128HImode:
      x2 = XEXP (x1, 1);
      if (pattern354 (x2, 
E_V128HImode) != 0
          || !((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 208 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3176 (insn, operands);

    case E_V256HImode:
      x2 = XEXP (x1, 1);
      if (pattern354 (x2, 
E_V256HImode) != 0
          || !((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 209 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3190 (insn, operands);

    case E_V512HImode:
      x2 = XEXP (x1, 1);
      if (pattern354 (x2, 
E_V512HImode) != 0
          || !((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 210 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3204 (insn, operands);

    case E_V1024HImode:
      x2 = XEXP (x1, 1);
      if (pattern354 (x2, 
E_V1024HImode) != 0
          || !((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 211 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3218 (insn, operands);

    case E_V2048HImode:
      x2 = XEXP (x1, 1);
      if (pattern354 (x2, 
E_V2048HImode) != 0
          || !((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 212 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3232 (insn, operands);

    case E_V1SImode:
      x2 = XEXP (x1, 1);
      if (pattern354 (x2, 
E_V1SImode) != 0
          || !((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 213 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3246 (insn, operands);

    case E_V2SImode:
      x2 = XEXP (x1, 1);
      if (pattern354 (x2, 
E_V2SImode) != 0
          || !((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 214 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3260 (insn, operands);

    case E_V4SImode:
      x2 = XEXP (x1, 1);
      if (pattern354 (x2, 
E_V4SImode) != 0
          || !((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 215 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3274 (insn, operands);

    case E_V8SImode:
      x2 = XEXP (x1, 1);
      if (pattern354 (x2, 
E_V8SImode) != 0
          || !((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 216 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3288 (insn, operands);

    case E_V16SImode:
      x2 = XEXP (x1, 1);
      if (pattern354 (x2, 
E_V16SImode) != 0
          || !((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 217 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3302 (insn, operands);

    case E_V32SImode:
      x2 = XEXP (x1, 1);
      if (pattern354 (x2, 
E_V32SImode) != 0
          || !((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 218 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3316 (insn, operands);

    case E_V64SImode:
      x2 = XEXP (x1, 1);
      if (pattern354 (x2, 
E_V64SImode) != 0
          || !((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 219 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3330 (insn, operands);

    case E_V128SImode:
      x2 = XEXP (x1, 1);
      if (pattern354 (x2, 
E_V128SImode) != 0
          || !((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 220 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3344 (insn, operands);

    case E_V256SImode:
      x2 = XEXP (x1, 1);
      if (pattern354 (x2, 
E_V256SImode) != 0
          || !((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 221 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3358 (insn, operands);

    case E_V512SImode:
      x2 = XEXP (x1, 1);
      if (pattern354 (x2, 
E_V512SImode) != 0
          || !((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 222 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3372 (insn, operands);

    case E_V1024SImode:
      x2 = XEXP (x1, 1);
      if (pattern354 (x2, 
E_V1024SImode) != 0
          || !((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 223 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3386 (insn, operands);

    case E_V1DImode:
      x2 = XEXP (x1, 1);
      if (pattern354 (x2, 
E_V1DImode) != 0
          || !((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 224 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3400 (insn, operands);

    case E_V2DImode:
      x2 = XEXP (x1, 1);
      if (pattern354 (x2, 
E_V2DImode) != 0
          || !((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 225 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3414 (insn, operands);

    case E_V4DImode:
      x2 = XEXP (x1, 1);
      if (pattern354 (x2, 
E_V4DImode) != 0
          || !((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 226 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3428 (insn, operands);

    case E_V8DImode:
      x2 = XEXP (x1, 1);
      if (pattern354 (x2, 
E_V8DImode) != 0
          || !((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 227 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3442 (insn, operands);

    case E_V16DImode:
      x2 = XEXP (x1, 1);
      if (pattern354 (x2, 
E_V16DImode) != 0
          || !((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 228 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3456 (insn, operands);

    case E_V32DImode:
      x2 = XEXP (x1, 1);
      if (pattern354 (x2, 
E_V32DImode) != 0
          || !((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 229 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3470 (insn, operands);

    case E_V64DImode:
      x2 = XEXP (x1, 1);
      if (pattern354 (x2, 
E_V64DImode) != 0
          || !((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 230 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3484 (insn, operands);

    case E_V128DImode:
      x2 = XEXP (x1, 1);
      if (pattern354 (x2, 
E_V128DImode) != 0
          || !((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 231 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3498 (insn, operands);

    case E_V256DImode:
      x2 = XEXP (x1, 1);
      if (pattern354 (x2, 
E_V256DImode) != 0
          || !((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 232 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3512 (insn, operands);

    case E_V512DImode:
      x2 = XEXP (x1, 1);
      if (pattern354 (x2, 
E_V512DImode) != 0
          || !((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 233 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3526 (insn, operands);

    case E_RVVM8HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM8HFmode) != 0
          || !((
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1542 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5555 (insn, operands);

    case E_RVVM4HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM4HFmode) != 0
          || !((
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1542 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5559 (insn, operands);

    case E_RVVM2HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM2HFmode) != 0
          || !((
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1542 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5563 (insn, operands);

    case E_RVVM1HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM1HFmode) != 0
          || !((
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1542 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5567 (insn, operands);

    case E_RVVMF2HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVMF2HFmode) != 0
          || !((
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1542 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5571 (insn, operands);

    case E_RVVMF4HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVMF4HFmode) != 0
          || !((
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 157 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)) && 
#line 1542 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5575 (insn, operands);

    case E_RVVM8SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM8SFmode) != 0
          || !((
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1542 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5579 (insn, operands);

    case E_RVVM4SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM4SFmode) != 0
          || !((
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1542 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5583 (insn, operands);

    case E_RVVM2SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM2SFmode) != 0
          || !((
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1542 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5587 (insn, operands);

    case E_RVVM1SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM1SFmode) != 0
          || !((
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1542 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5591 (insn, operands);

    case E_RVVMF2SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVMF2SFmode) != 0
          || !((
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)) && 
#line 1542 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5595 (insn, operands);

    case E_RVVM8DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM8DFmode) != 0
          || !((
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1542 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5599 (insn, operands);

    case E_RVVM4DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM4DFmode) != 0
          || !((
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1542 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5603 (insn, operands);

    case E_RVVM2DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM2DFmode) != 0
          || !((
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1542 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5607 (insn, operands);

    case E_RVVM1DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM1DFmode) != 0
          || !((
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1542 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5611 (insn, operands);

    case E_V1HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V1HFmode) != 0
          || !((
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 236 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)) && 
#line 1542 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5615 (insn, operands);

    case E_V2HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V2HFmode) != 0
          || !((
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 237 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)) && 
#line 1542 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5619 (insn, operands);

    case E_V4HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V4HFmode) != 0
          || !((
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 238 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)) && 
#line 1542 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5623 (insn, operands);

    case E_V8HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V8HFmode) != 0
          || !((
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 239 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)) && 
#line 1542 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5627 (insn, operands);

    case E_V16HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V16HFmode) != 0
          || !((
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 240 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)) && 
#line 1542 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5631 (insn, operands);

    case E_V32HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V32HFmode) != 0
          || !((
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 241 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)) && 
#line 1542 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5635 (insn, operands);

    case E_V64HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V64HFmode) != 0
          || !((
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 242 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)) && 
#line 1542 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5639 (insn, operands);

    case E_V128HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V128HFmode) != 0
          || !((
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 243 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)) && 
#line 1542 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5643 (insn, operands);

    case E_V256HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V256HFmode) != 0
          || !((
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 244 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)) && 
#line 1542 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5647 (insn, operands);

    case E_V512HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V512HFmode) != 0
          || !((
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 245 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)) && 
#line 1542 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5651 (insn, operands);

    case E_V1024HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V1024HFmode) != 0
          || !((
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 246 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)) && 
#line 1542 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5655 (insn, operands);

    case E_V2048HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V2048HFmode) != 0
          || !((
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 247 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)) && 
#line 1542 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5659 (insn, operands);

    case E_V1SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V1SFmode) != 0
          || !((
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 248 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1542 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5663 (insn, operands);

    case E_V2SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V2SFmode) != 0
          || !((
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 249 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1542 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5667 (insn, operands);

    case E_V4SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V4SFmode) != 0
          || !((
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 250 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1542 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5671 (insn, operands);

    case E_V8SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V8SFmode) != 0
          || !((
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 251 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1542 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5675 (insn, operands);

    case E_V16SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V16SFmode) != 0
          || !((
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 252 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 1542 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5679 (insn, operands);

    case E_V32SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V32SFmode) != 0
          || !((
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 253 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)) && 
#line 1542 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5683 (insn, operands);

    case E_V64SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V64SFmode) != 0
          || !((
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 254 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)) && 
#line 1542 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5687 (insn, operands);

    case E_V128SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V128SFmode) != 0
          || !((
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 255 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 1542 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5691 (insn, operands);

    case E_V256SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V256SFmode) != 0
          || !((
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 256 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 1542 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5695 (insn, operands);

    case E_V512SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V512SFmode) != 0
          || !((
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 257 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)) && 
#line 1542 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5699 (insn, operands);

    case E_V1024SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V1024SFmode) != 0
          || !((
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 258 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)) && 
#line 1542 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5703 (insn, operands);

    case E_V1DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V1DFmode) != 0
          || !((
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 259 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1542 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5707 (insn, operands);

    case E_V2DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V2DFmode) != 0
          || !((
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 260 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1542 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5711 (insn, operands);

    case E_V4DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V4DFmode) != 0
          || !((
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 261 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1542 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5715 (insn, operands);

    case E_V8DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V8DFmode) != 0
          || !((
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 262 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)) && 
#line 1542 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5719 (insn, operands);

    case E_V16DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V16DFmode) != 0
          || !((
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 263 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)) && 
#line 1542 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5723 (insn, operands);

    case E_V32DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V32DFmode) != 0
          || !((
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 264 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)) && 
#line 1542 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5727 (insn, operands);

    case E_V64DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V64DFmode) != 0
          || !((
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 265 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)) && 
#line 1542 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5731 (insn, operands);

    case E_V128DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V128DFmode) != 0
          || !((
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 266 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 1542 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5735 (insn, operands);

    case E_V256DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V256DFmode) != 0
          || !((
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 267 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 1542 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5739 (insn, operands);

    case E_V512DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V512DFmode) != 0
          || !((
#line 1540 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 268 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 1542 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5743 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_142 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern155 (x2))
    {
    case 0:
      if (!(
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 571 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7845 (insn, operands);

    case 1:
      if (!(
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 571 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7849 (insn, operands);

    case 2:
      if (!(
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 571 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7853 (insn, operands);

    case 3:
      if (!(
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 571 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7857 (insn, operands);

    case 4:
      if (!(
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 571 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7861 (insn, operands);

    case 5:
      if (!((
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 571 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7865 (insn, operands);

    case 6:
      if (!(
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 571 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7869 (insn, operands);

    case 7:
      if (!(
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 571 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7873 (insn, operands);

    case 8:
      if (!(
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 571 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7877 (insn, operands);

    case 9:
      if (!(
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 571 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7881 (insn, operands);

    case 10:
      if (!((
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 571 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7885 (insn, operands);

    case 11:
      if (!((
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 571 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7889 (insn, operands);

    case 12:
      if (!((
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 571 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7893 (insn, operands);

    case 13:
      if (!((
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 571 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7897 (insn, operands);

    case 14:
      if (!((
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 571 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7901 (insn, operands);

    case 15:
      if (!((
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 571 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7905 (insn, operands);

    case 16:
      if (!((
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 571 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7909 (insn, operands);

    case 17:
      if (!((
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 571 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7913 (insn, operands);

    case 18:
      if (!((
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 571 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7917 (insn, operands);

    case 19:
      if (!((
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 571 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7921 (insn, operands);

    case 20:
      if (!((
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 571 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7925 (insn, operands);

    case 21:
      if (!((
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 571 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7929 (insn, operands);

    case 22:
      if (!((
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 571 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7933 (insn, operands);

    case 23:
      if (!((
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 571 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7937 (insn, operands);

    case 24:
      if (!((
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 571 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7941 (insn, operands);

    case 25:
      if (!((
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 571 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7945 (insn, operands);

    case 26:
      if (!((
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 571 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7949 (insn, operands);

    case 27:
      if (!((
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 571 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7953 (insn, operands);

    case 28:
      if (!((
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 571 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7957 (insn, operands);

    case 29:
      if (!((
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 571 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7961 (insn, operands);

    case 30:
      if (!((
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 571 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7965 (insn, operands);

    case 31:
      if (!((
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 571 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7969 (insn, operands);

    case 32:
      if (!((
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 571 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7973 (insn, operands);

    case 33:
      if (!((
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 571 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7977 (insn, operands);

    case 34:
      if (!((
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 972 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 571 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7981 (insn, operands);

    case 35:
      if (!((
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 973 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 571 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7985 (insn, operands);

    case 36:
      if (!((
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 974 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 571 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7989 (insn, operands);

    case 37:
      if (!((
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 975 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 571 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7993 (insn, operands);

    case 38:
      if (!((
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 976 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 571 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7997 (insn, operands);

    case 39:
      if (!((
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 977 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 571 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8001 (insn, operands);

    case 40:
      if (!((
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 978 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 571 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8005 (insn, operands);

    case 41:
      if (!((
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 979 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 571 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8009 (insn, operands);

    case 42:
      if (!((
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 980 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 571 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8013 (insn, operands);

    case 43:
      if (!((
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 981 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 571 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8017 (insn, operands);

    case 44:
      if (!((
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 982 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 571 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8021 (insn, operands);

    case 45:
      if (!((
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 983 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 571 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8025 (insn, operands);

    case 46:
      if (!((
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 984 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 571 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8029 (insn, operands);

    case 47:
      if (!((
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 985 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 571 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8033 (insn, operands);

    case 48:
      if (!(
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 571 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7847 (insn, operands);

    case 49:
      if (!(
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 571 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7851 (insn, operands);

    case 50:
      if (!(
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 571 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7855 (insn, operands);

    case 51:
      if (!(
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 571 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7859 (insn, operands);

    case 52:
      if (!(
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 571 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7863 (insn, operands);

    case 53:
      if (!((
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 571 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7867 (insn, operands);

    case 54:
      if (!(
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 571 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7871 (insn, operands);

    case 55:
      if (!(
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 571 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7875 (insn, operands);

    case 56:
      if (!(
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 571 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7879 (insn, operands);

    case 57:
      if (!(
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 571 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7883 (insn, operands);

    case 58:
      if (!((
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 571 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7887 (insn, operands);

    case 59:
      if (!((
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 571 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7891 (insn, operands);

    case 60:
      if (!((
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 571 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7895 (insn, operands);

    case 61:
      if (!((
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 571 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7899 (insn, operands);

    case 62:
      if (!((
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 571 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7903 (insn, operands);

    case 63:
      if (!((
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 571 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7907 (insn, operands);

    case 64:
      if (!((
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 571 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7911 (insn, operands);

    case 65:
      if (!((
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 571 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7915 (insn, operands);

    case 66:
      if (!((
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 571 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7919 (insn, operands);

    case 67:
      if (!((
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 571 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7923 (insn, operands);

    case 68:
      if (!((
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 571 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7927 (insn, operands);

    case 69:
      if (!((
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 571 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7931 (insn, operands);

    case 70:
      if (!((
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 571 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7935 (insn, operands);

    case 71:
      if (!((
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 571 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7939 (insn, operands);

    case 72:
      if (!((
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 571 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7943 (insn, operands);

    case 73:
      if (!((
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 571 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7947 (insn, operands);

    case 74:
      if (!((
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 571 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7951 (insn, operands);

    case 75:
      if (!((
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 571 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7955 (insn, operands);

    case 76:
      if (!((
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 571 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7959 (insn, operands);

    case 77:
      if (!((
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 571 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7963 (insn, operands);

    case 78:
      if (!((
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 571 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7967 (insn, operands);

    case 79:
      if (!((
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 571 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7971 (insn, operands);

    case 80:
      if (!((
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 571 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7975 (insn, operands);

    case 81:
      if (!((
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 571 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7979 (insn, operands);

    case 82:
      if (!((
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 972 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 571 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7983 (insn, operands);

    case 83:
      if (!((
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 973 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 571 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7987 (insn, operands);

    case 84:
      if (!((
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 974 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 571 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7991 (insn, operands);

    case 85:
      if (!((
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 975 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 571 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7995 (insn, operands);

    case 86:
      if (!((
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 976 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 571 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_7999 (insn, operands);

    case 87:
      if (!((
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 977 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 571 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8003 (insn, operands);

    case 88:
      if (!((
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 978 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 571 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8007 (insn, operands);

    case 89:
      if (!((
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 979 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 571 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8011 (insn, operands);

    case 90:
      if (!((
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 980 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 571 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8015 (insn, operands);

    case 91:
      if (!((
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 981 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 571 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8019 (insn, operands);

    case 92:
      if (!((
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 982 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 571 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8023 (insn, operands);

    case 93:
      if (!((
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 983 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 571 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8027 (insn, operands);

    case 94:
      if (!((
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 984 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 571 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8031 (insn, operands);

    case 95:
      if (!((
#line 569 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 985 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 571 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8035 (insn, operands);

    case 96:
      if (!(
#line 587 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 589 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8037 (insn, operands);

    case 97:
      if (!(
#line 587 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 589 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8039 (insn, operands);

    case 98:
      if (!(
#line 587 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 589 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8041 (insn, operands);

    case 99:
      if (!(
#line 587 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 589 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8043 (insn, operands);

    case 100:
      if (!(
#line 587 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 589 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8045 (insn, operands);

    case 101:
      if (!((
#line 587 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 589 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8047 (insn, operands);

    case 102:
      if (!(
#line 587 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 589 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8049 (insn, operands);

    case 103:
      if (!(
#line 587 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 589 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8051 (insn, operands);

    case 104:
      if (!(
#line 587 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 589 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8053 (insn, operands);

    case 105:
      if (!(
#line 587 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 589 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8055 (insn, operands);

    case 106:
      if (!((
#line 587 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 589 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8057 (insn, operands);

    case 107:
      if (!((
#line 587 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 589 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8059 (insn, operands);

    case 108:
      if (!((
#line 587 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 589 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8061 (insn, operands);

    case 109:
      if (!((
#line 587 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 589 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8063 (insn, operands);

    case 110:
      if (!((
#line 587 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 589 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8065 (insn, operands);

    case 111:
      if (!((
#line 587 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 589 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8067 (insn, operands);

    case 112:
      if (!((
#line 587 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 589 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8069 (insn, operands);

    case 113:
      if (!((
#line 587 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 589 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8071 (insn, operands);

    case 114:
      if (!((
#line 587 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 589 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8073 (insn, operands);

    case 115:
      if (!((
#line 587 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 589 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8075 (insn, operands);

    case 116:
      if (!((
#line 587 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 589 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8077 (insn, operands);

    case 117:
      if (!((
#line 587 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 589 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8079 (insn, operands);

    case 118:
      if (!((
#line 587 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 589 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8081 (insn, operands);

    case 119:
      if (!((
#line 587 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 589 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8083 (insn, operands);

    case 120:
      if (!((
#line 587 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 589 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8085 (insn, operands);

    case 121:
      if (!((
#line 587 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 589 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8087 (insn, operands);

    case 122:
      if (!((
#line 587 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 589 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8089 (insn, operands);

    case 123:
      if (!((
#line 587 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 589 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8091 (insn, operands);

    case 124:
      if (!((
#line 587 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 589 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8093 (insn, operands);

    case 125:
      if (!((
#line 587 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 589 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8095 (insn, operands);

    case 126:
      if (!((
#line 587 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 589 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8097 (insn, operands);

    case 127:
      if (!((
#line 587 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 589 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8099 (insn, operands);

    case 128:
      if (!((
#line 587 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 589 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8101 (insn, operands);

    case 129:
      if (!((
#line 587 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 589 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8103 (insn, operands);

    case 130:
      if (!((
#line 587 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 972 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 589 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8105 (insn, operands);

    case 131:
      if (!((
#line 587 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 973 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 589 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8107 (insn, operands);

    case 132:
      if (!((
#line 587 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 974 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 589 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8109 (insn, operands);

    case 133:
      if (!((
#line 587 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 975 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 589 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8111 (insn, operands);

    case 134:
      if (!((
#line 587 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 976 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 589 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8113 (insn, operands);

    case 135:
      if (!((
#line 587 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 977 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 589 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8115 (insn, operands);

    case 136:
      if (!((
#line 587 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 978 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 589 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8117 (insn, operands);

    case 137:
      if (!((
#line 587 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 979 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 589 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8119 (insn, operands);

    case 138:
      if (!((
#line 587 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 980 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 589 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8121 (insn, operands);

    case 139:
      if (!((
#line 587 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 981 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 589 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8123 (insn, operands);

    case 140:
      if (!((
#line 587 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 982 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 589 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8125 (insn, operands);

    case 141:
      if (!((
#line 587 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 983 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 589 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8127 (insn, operands);

    case 142:
      if (!((
#line 587 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 984 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 589 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8129 (insn, operands);

    case 143:
      if (!((
#line 587 "../../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 985 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 589 "../../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8131 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_151 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern125 (x2))
    {
    case 0:
      if (!((
#line 914 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 916 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4442 (insn, operands);

    case 1:
      if (!((
#line 914 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 916 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4444 (insn, operands);

    case 2:
      if (!((
#line 1007 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1009 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4802 (insn, operands);

    case 3:
      if (!((
#line 914 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 916 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4446 (insn, operands);

    case 4:
      if (!((
#line 1007 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1009 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4804 (insn, operands);

    case 5:
      if (!((
#line 914 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 916 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4448 (insn, operands);

    case 6:
      if (!((
#line 1007 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1009 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4806 (insn, operands);

    case 7:
      if (!((
#line 914 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 916 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4450 (insn, operands);

    case 8:
      if (!((
#line 1007 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1009 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4808 (insn, operands);

    case 9:
      if (!((
#line 914 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 157 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)) && 
#line 916 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4452 (insn, operands);

    case 10:
      if (!((
#line 1007 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)) && 
#line 1009 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4810 (insn, operands);

    case 11:
      if (!((
#line 914 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 916 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4454 (insn, operands);

    case 12:
      if (!((
#line 963 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1056 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 965 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4634 (insn, operands);

    case 13:
      if (!((
#line 914 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 916 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4456 (insn, operands);

    case 14:
      if (!((
#line 963 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1056 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 965 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4636 (insn, operands);

    case 15:
      if (!((
#line 1007 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1009 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4812 (insn, operands);

    case 16:
      if (!((
#line 914 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 916 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4458 (insn, operands);

    case 17:
      if (!((
#line 963 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1056 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 965 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4638 (insn, operands);

    case 18:
      if (!((
#line 1007 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1009 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4814 (insn, operands);

    case 19:
      if (!((
#line 914 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 916 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4460 (insn, operands);

    case 20:
      if (!((
#line 963 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1056 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 965 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4640 (insn, operands);

    case 21:
      if (!((
#line 1007 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1009 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4816 (insn, operands);

    case 22:
      if (!((
#line 914 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)) && 
#line 916 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4462 (insn, operands);

    case 23:
      if (!((
#line 963 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1057 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 965 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4642 (insn, operands);

    case 24:
      if (!((
#line 1007 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1009 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4818 (insn, operands);

    case 25:
      if (!((
#line 914 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 916 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4464 (insn, operands);

    case 26:
      if (!((
#line 963 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1059 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 965 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4644 (insn, operands);

    case 27:
      if (!((
#line 914 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 916 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4466 (insn, operands);

    case 28:
      if (!((
#line 963 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1060 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 965 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4646 (insn, operands);

    case 29:
      if (!((
#line 914 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 916 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4468 (insn, operands);

    case 30:
      if (!((
#line 963 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1061 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 965 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4648 (insn, operands);

    case 31:
      if (!((
#line 914 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 916 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4470 (insn, operands);

    case 32:
      if (!((
#line 963 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1062 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 965 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4650 (insn, operands);

    case 33:
      if (!((
#line 914 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 236 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)) && 
#line 916 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4472 (insn, operands);

    case 34:
      if (!((
#line 1007 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 248 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1009 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4844 (insn, operands);

    case 35:
      if (!((
#line 914 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 237 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)) && 
#line 916 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4474 (insn, operands);

    case 36:
      if (!((
#line 1007 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 249 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1009 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4846 (insn, operands);

    case 37:
      if (!((
#line 914 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 238 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)) && 
#line 916 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4476 (insn, operands);

    case 38:
      if (!((
#line 1007 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 250 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1009 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4848 (insn, operands);

    case 39:
      if (!((
#line 914 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 239 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)) && 
#line 916 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4478 (insn, operands);

    case 40:
      if (!((
#line 1007 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 251 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1009 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4850 (insn, operands);

    case 41:
      if (!((
#line 914 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 240 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)) && 
#line 916 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4480 (insn, operands);

    case 42:
      if (!((
#line 1007 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 252 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 1009 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4852 (insn, operands);

    case 43:
      if (!((
#line 914 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 241 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)) && 
#line 916 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4482 (insn, operands);

    case 44:
      if (!((
#line 1007 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 253 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)) && 
#line 1009 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4854 (insn, operands);

    case 45:
      if (!((
#line 914 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 242 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)) && 
#line 916 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4484 (insn, operands);

    case 46:
      if (!((
#line 1007 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 254 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)) && 
#line 1009 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4856 (insn, operands);

    case 47:
      if (!((
#line 914 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 243 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)) && 
#line 916 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4486 (insn, operands);

    case 48:
      if (!((
#line 1007 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 255 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 1009 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4858 (insn, operands);

    case 49:
      if (!((
#line 914 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 244 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)) && 
#line 916 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4488 (insn, operands);

    case 50:
      if (!((
#line 1007 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 256 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 1009 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4860 (insn, operands);

    case 51:
      if (!((
#line 914 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 245 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)) && 
#line 916 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4490 (insn, operands);

    case 52:
      if (!((
#line 1007 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 257 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)) && 
#line 1009 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4862 (insn, operands);

    case 53:
      if (!((
#line 914 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 246 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)) && 
#line 916 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4492 (insn, operands);

    case 54:
      if (!((
#line 1007 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 258 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)) && 
#line 1009 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4864 (insn, operands);

    case 55:
      if (!((
#line 914 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 247 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)) && 
#line 916 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4494 (insn, operands);

    case 56:
      if (!((
#line 914 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 248 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 916 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4496 (insn, operands);

    case 57:
      if (!((
#line 963 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1064 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode) && TARGET_ZVFH)) && 
#line 965 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4652 (insn, operands);

    case 58:
      if (!((
#line 1007 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 259 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1009 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4866 (insn, operands);

    case 59:
      if (!((
#line 914 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 249 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 916 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4498 (insn, operands);

    case 60:
      if (!((
#line 963 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1065 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode) && TARGET_ZVFH)) && 
#line 965 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4654 (insn, operands);

    case 61:
      if (!((
#line 1007 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 260 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1009 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4868 (insn, operands);

    case 62:
      if (!((
#line 914 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 250 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 916 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4500 (insn, operands);

    case 63:
      if (!((
#line 963 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1066 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode) && TARGET_ZVFH)) && 
#line 965 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4656 (insn, operands);

    case 64:
      if (!((
#line 1007 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 261 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1009 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4870 (insn, operands);

    case 65:
      if (!((
#line 914 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 251 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 916 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4502 (insn, operands);

    case 66:
      if (!((
#line 963 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1067 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode) && TARGET_ZVFH)) && 
#line 965 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4658 (insn, operands);

    case 67:
      if (!((
#line 1007 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 262 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)) && 
#line 1009 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4872 (insn, operands);

    case 68:
      if (!((
#line 914 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 252 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 916 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4504 (insn, operands);

    case 69:
      if (!((
#line 963 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1068 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)) && 
#line 965 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4660 (insn, operands);

    case 70:
      if (!((
#line 1007 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 263 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)) && 
#line 1009 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4874 (insn, operands);

    case 71:
      if (!((
#line 914 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 253 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)) && 
#line 916 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4506 (insn, operands);

    case 72:
      if (!((
#line 963 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1069 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)) && 
#line 965 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4662 (insn, operands);

    case 73:
      if (!((
#line 1007 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 264 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)) && 
#line 1009 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4876 (insn, operands);

    case 74:
      if (!((
#line 914 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 254 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)) && 
#line 916 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4508 (insn, operands);

    case 75:
      if (!((
#line 963 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1070 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)) && 
#line 965 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4664 (insn, operands);

    case 76:
      if (!((
#line 1007 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 265 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)) && 
#line 1009 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4878 (insn, operands);

    case 77:
      if (!((
#line 914 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 255 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 916 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4510 (insn, operands);

    case 78:
      if (!((
#line 963 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1071 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)) && 
#line 965 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4666 (insn, operands);

    case 79:
      if (!((
#line 1007 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 266 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 1009 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4880 (insn, operands);

    case 80:
      if (!((
#line 914 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 256 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 916 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4512 (insn, operands);

    case 81:
      if (!((
#line 963 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1072 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)) && 
#line 965 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4668 (insn, operands);

    case 82:
      if (!((
#line 1007 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 267 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 1009 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4882 (insn, operands);

    case 83:
      if (!((
#line 914 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 257 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)) && 
#line 916 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4514 (insn, operands);

    case 84:
      if (!((
#line 963 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1073 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)) && 
#line 965 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4670 (insn, operands);

    case 85:
      if (!((
#line 1007 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 268 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 1009 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4884 (insn, operands);

    case 86:
      if (!((
#line 914 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 258 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)) && 
#line 916 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4516 (insn, operands);

    case 87:
      if (!((
#line 963 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1074 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)) && 
#line 965 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4672 (insn, operands);

    case 88:
      if (!((
#line 914 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 259 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 916 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4518 (insn, operands);

    case 89:
      if (!((
#line 963 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1075 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 965 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4674 (insn, operands);

    case 90:
      if (!((
#line 914 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 260 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 916 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4520 (insn, operands);

    case 91:
      if (!((
#line 963 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1076 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 965 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4676 (insn, operands);

    case 92:
      if (!((
#line 914 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 261 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 916 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4522 (insn, operands);

    case 93:
      if (!((
#line 963 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1077 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 965 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4678 (insn, operands);

    case 94:
      if (!((
#line 914 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 262 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)) && 
#line 916 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4524 (insn, operands);

    case 95:
      if (!((
#line 963 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1078 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 965 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4680 (insn, operands);

    case 96:
      if (!((
#line 914 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 263 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)) && 
#line 916 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4526 (insn, operands);

    case 97:
      if (!((
#line 963 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1079 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)) && 
#line 965 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4682 (insn, operands);

    case 98:
      if (!((
#line 914 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 264 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)) && 
#line 916 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4528 (insn, operands);

    case 99:
      if (!((
#line 963 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1080 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)) && 
#line 965 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4684 (insn, operands);

    case 100:
      if (!((
#line 914 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 265 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)) && 
#line 916 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4530 (insn, operands);

    case 101:
      if (!((
#line 963 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1081 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 965 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4686 (insn, operands);

    case 102:
      if (!((
#line 914 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 266 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 916 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4532 (insn, operands);

    case 103:
      if (!((
#line 963 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1082 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 965 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4688 (insn, operands);

    case 104:
      if (!((
#line 914 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 267 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 916 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4534 (insn, operands);

    case 105:
      if (!((
#line 963 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1083 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)) && 
#line 965 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4690 (insn, operands);

    case 106:
      if (!((
#line 914 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 268 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 916 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4536 (insn, operands);

    case 107:
      if (!((
#line 963 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1084 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)) && 
#line 965 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4692 (insn, operands);

    case 108:
      if (!((
#line 1007 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1009 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4790 (insn, operands);

    case 109:
      if (!((
#line 1007 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1009 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4792 (insn, operands);

    case 110:
      if (!((
#line 1007 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1009 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4794 (insn, operands);

    case 111:
      if (!((
#line 1007 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1009 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4796 (insn, operands);

    case 112:
      if (!((
#line 1007 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1009 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4798 (insn, operands);

    case 113:
      if (!((
#line 1007 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 157 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)) && 
#line 1009 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4800 (insn, operands);

    case 114:
      if (!((
#line 1007 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 236 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)) && 
#line 1009 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4820 (insn, operands);

    case 115:
      if (!((
#line 1007 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 237 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)) && 
#line 1009 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4822 (insn, operands);

    case 116:
      if (!((
#line 1007 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 238 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)) && 
#line 1009 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4824 (insn, operands);

    case 117:
      if (!((
#line 1007 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 239 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)) && 
#line 1009 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4826 (insn, operands);

    case 118:
      if (!((
#line 1007 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 240 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)) && 
#line 1009 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4828 (insn, operands);

    case 119:
      if (!((
#line 1007 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 241 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)) && 
#line 1009 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4830 (insn, operands);

    case 120:
      if (!((
#line 1007 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 242 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)) && 
#line 1009 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4832 (insn, operands);

    case 121:
      if (!((
#line 1007 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 243 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)) && 
#line 1009 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4834 (insn, operands);

    case 122:
      if (!((
#line 1007 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 244 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)) && 
#line 1009 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4836 (insn, operands);

    case 123:
      if (!((
#line 1007 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 245 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)) && 
#line 1009 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4838 (insn, operands);

    case 124:
      if (!((
#line 1007 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 246 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)) && 
#line 1009 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4840 (insn, operands);

    case 125:
      if (!((
#line 1007 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 247 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)) && 
#line 1009 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4842 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_160 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case ASHIFT:
      switch (pattern226 (x2))
        {
        case 0:
          if (!((
#line 2992 "../../../gcc/config/riscv/riscv.md"
((!SMALL_OPERAND (INTVAL (operands[3]))
    && SMALL_OPERAND (INTVAL (operands[3]) >> INTVAL (operands[2]))
    && (!TARGET_ZBS || popcount_hwi (INTVAL (operands[3])) > 1)
    && (INTVAL (operands[3]) & ((1ULL << INTVAL (operands[2])) - 1)) == 0)) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 2997 "../../../gcc/config/riscv/riscv.md"
( 1)))
            return NULL;
          return gen_split_42 (insn, operands);

        case 1:
          if (!((
#line 2992 "../../../gcc/config/riscv/riscv.md"
((!SMALL_OPERAND (INTVAL (operands[3]))
    && SMALL_OPERAND (INTVAL (operands[3]) >> INTVAL (operands[2]))
    && (!TARGET_ZBS || popcount_hwi (INTVAL (operands[3])) > 1)
    && (INTVAL (operands[3]) & ((1ULL << INTVAL (operands[2])) - 1)) == 0)) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 2997 "../../../gcc/config/riscv/riscv.md"
( 1)))
            return NULL;
          return gen_split_45 (insn, operands);

        default:
          return NULL;
        }

    case REG:
    case SUBREG:
      switch (pattern229 (x2))
        {
        case 0:
          if (!((
#line 1020 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBS) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 1022 "../../../gcc/config/riscv/bitmanip.md"
( reload_completed)))
            return NULL;
          return gen_split_177 (insn, operands);

        case 1:
          if (!((
#line 1020 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBS) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 1022 "../../../gcc/config/riscv/bitmanip.md"
( reload_completed)))
            return NULL;
          return gen_split_179 (insn, operands);

        case 2:
          if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2591 (insn, operands);

        case 3:
          if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2605 (insn, operands);

        case 4:
          if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2619 (insn, operands);

        case 5:
          if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2633 (insn, operands);

        case 6:
          if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2647 (insn, operands);

        case 7:
          if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2661 (insn, operands);

        case 8:
          if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2675 (insn, operands);

        case 9:
          if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2689 (insn, operands);

        case 10:
          if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2703 (insn, operands);

        case 11:
          if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2717 (insn, operands);

        case 12:
          if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2731 (insn, operands);

        case 13:
          if (!(
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2745 (insn, operands);

        case 14:
          if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2759 (insn, operands);

        case 15:
          if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2773 (insn, operands);

        case 16:
          if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2787 (insn, operands);

        case 17:
          if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2801 (insn, operands);

        case 18:
          if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2815 (insn, operands);

        case 19:
          if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2829 (insn, operands);

        case 20:
          if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 131 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2843 (insn, operands);

        case 21:
          if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2857 (insn, operands);

        case 22:
          if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 132 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2871 (insn, operands);

        case 23:
          if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 133 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32) && 
#line 145 "../../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2885 (insn, operands);

        case 24:
          if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 188 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2899 (insn, operands);

        case 25:
          if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 189 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2913 (insn, operands);

        case 26:
          if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 190 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2927 (insn, operands);

        case 27:
          if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 191 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2941 (insn, operands);

        case 28:
          if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 192 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2955 (insn, operands);

        case 29:
          if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 193 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2969 (insn, operands);

        case 30:
          if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 194 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2983 (insn, operands);

        case 31:
          if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 195 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2997 (insn, operands);

        case 32:
          if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 196 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3011 (insn, operands);

        case 33:
          if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 197 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3025 (insn, operands);

        case 34:
          if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 198 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3039 (insn, operands);

        case 35:
          if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 199 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3053 (insn, operands);

        case 36:
          if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 200 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3067 (insn, operands);

        case 37:
          if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 201 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3081 (insn, operands);

        case 38:
          if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 202 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3095 (insn, operands);

        case 39:
          if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 203 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3109 (insn, operands);

        case 40:
          if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 204 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3123 (insn, operands);

        case 41:
          if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 205 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3137 (insn, operands);

        case 42:
          if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 206 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3151 (insn, operands);

        case 43:
          if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 207 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3165 (insn, operands);

        case 44:
          if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 208 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3179 (insn, operands);

        case 45:
          if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 209 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3193 (insn, operands);

        case 46:
          if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 210 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3207 (insn, operands);

        case 47:
          if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 211 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3221 (insn, operands);

        case 48:
          if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 212 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3235 (insn, operands);

        case 49:
          if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 213 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3249 (insn, operands);

        case 50:
          if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 214 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3263 (insn, operands);

        case 51:
          if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 215 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3277 (insn, operands);

        case 52:
          if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 216 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3291 (insn, operands);

        case 53:
          if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 217 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3305 (insn, operands);

        case 54:
          if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 218 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3319 (insn, operands);

        case 55:
          if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 219 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3333 (insn, operands);

        case 56:
          if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 220 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3347 (insn, operands);

        case 57:
          if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 221 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3361 (insn, operands);

        case 58:
          if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 222 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3375 (insn, operands);

        case 59:
          if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 223 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3389 (insn, operands);

        case 60:
          if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 224 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3403 (insn, operands);

        case 61:
          if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 225 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3417 (insn, operands);

        case 62:
          if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 226 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3431 (insn, operands);

        case 63:
          if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 227 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3445 (insn, operands);

        case 64:
          if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 228 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3459 (insn, operands);

        case 65:
          if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 229 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3473 (insn, operands);

        case 66:
          if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 230 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3487 (insn, operands);

        case 67:
          if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 231 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3501 (insn, operands);

        case 68:
          if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 232 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3515 (insn, operands);

        case 69:
          if (!((
#line 464 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 233 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 466 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3529 (insn, operands);

        case 70:
          if (!((
#line 538 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1533 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_MIN_VLEN > 32)) && 
#line 540 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3949 (insn, operands);

        case 71:
          if (!(
#line 538 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 540 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3952 (insn, operands);

        case 72:
          if (!(
#line 538 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 540 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3955 (insn, operands);

        case 73:
          if (!(
#line 538 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 540 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3958 (insn, operands);

        case 74:
          if (!(
#line 538 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 540 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3961 (insn, operands);

        case 75:
          if (!(
#line 538 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 540 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3964 (insn, operands);

        case 76:
          if (!(
#line 538 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 540 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3967 (insn, operands);

        case 77:
          if (!((
#line 538 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1518 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode))) && 
#line 540 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3970 (insn, operands);

        case 78:
          if (!((
#line 538 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1519 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode))) && 
#line 540 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3973 (insn, operands);

        case 79:
          if (!((
#line 538 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1520 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode))) && 
#line 540 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3976 (insn, operands);

        case 80:
          if (!((
#line 538 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1521 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode))) && 
#line 540 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3979 (insn, operands);

        case 81:
          if (!((
#line 538 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1522 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode))) && 
#line 540 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3982 (insn, operands);

        case 82:
          if (!((
#line 538 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1523 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode))) && 
#line 540 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3985 (insn, operands);

        case 83:
          if (!((
#line 538 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1524 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64)) && 
#line 540 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3988 (insn, operands);

        case 84:
          if (!((
#line 538 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1525 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128)) && 
#line 540 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3991 (insn, operands);

        case 85:
          if (!((
#line 538 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1526 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256)) && 
#line 540 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3994 (insn, operands);

        case 86:
          if (!((
#line 538 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1527 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512)) && 
#line 540 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3997 (insn, operands);

        case 87:
          if (!((
#line 538 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1528 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 540 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4000 (insn, operands);

        case 88:
          if (!((
#line 538 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1529 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 540 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4003 (insn, operands);

        case 89:
          if (!((
#line 538 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1530 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 540 "../../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4006 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_171 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern127 (x2))
    {
    case 0:
      if (!((
#line 1130 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1132 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5177 (insn, operands);

    case 1:
      if (!((
#line 1130 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1132 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5178 (insn, operands);

    case 2:
      if (!((
#line 1130 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1132 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5179 (insn, operands);

    case 3:
      if (!((
#line 1130 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1132 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5180 (insn, operands);

    case 4:
      if (!((
#line 1130 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1132 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5181 (insn, operands);

    case 5:
      if (!((
#line 1130 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 157 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_MIN_VLEN > 32)) && 
#line 1132 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5182 (insn, operands);

    case 6:
      if (!((
#line 1130 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1132 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5183 (insn, operands);

    case 7:
      if (!((
#line 1130 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1132 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5184 (insn, operands);

    case 8:
      if (!((
#line 1130 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1132 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5185 (insn, operands);

    case 9:
      if (!((
#line 1130 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1132 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5186 (insn, operands);

    case 10:
      if (!((
#line 1130 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)) && 
#line 1132 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5187 (insn, operands);

    case 11:
      if (!((
#line 1130 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1132 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5188 (insn, operands);

    case 12:
      if (!((
#line 1130 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1132 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5189 (insn, operands);

    case 13:
      if (!((
#line 1130 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1132 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5190 (insn, operands);

    case 14:
      if (!((
#line 1130 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1132 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5191 (insn, operands);

    case 15:
      if (!((
#line 1130 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 236 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)) && 
#line 1132 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5192 (insn, operands);

    case 16:
      if (!((
#line 1130 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 237 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)) && 
#line 1132 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5193 (insn, operands);

    case 17:
      if (!((
#line 1130 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 238 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)) && 
#line 1132 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5194 (insn, operands);

    case 18:
      if (!((
#line 1130 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 239 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)) && 
#line 1132 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5195 (insn, operands);

    case 19:
      if (!((
#line 1130 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 240 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)) && 
#line 1132 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5196 (insn, operands);

    case 20:
      if (!((
#line 1130 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 241 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)) && 
#line 1132 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5197 (insn, operands);

    case 21:
      if (!((
#line 1130 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 242 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)) && 
#line 1132 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5198 (insn, operands);

    case 22:
      if (!((
#line 1130 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 243 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)) && 
#line 1132 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5199 (insn, operands);

    case 23:
      if (!((
#line 1130 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 244 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)) && 
#line 1132 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5200 (insn, operands);

    case 24:
      if (!((
#line 1130 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 245 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)) && 
#line 1132 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5201 (insn, operands);

    case 25:
      if (!((
#line 1130 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 246 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)) && 
#line 1132 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5202 (insn, operands);

    case 26:
      if (!((
#line 1130 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 247 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)) && 
#line 1132 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5203 (insn, operands);

    case 27:
      if (!((
#line 1130 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 248 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1132 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5204 (insn, operands);

    case 28:
      if (!((
#line 1130 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 249 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1132 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5205 (insn, operands);

    case 29:
      if (!((
#line 1130 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 250 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1132 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5206 (insn, operands);

    case 30:
      if (!((
#line 1130 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 251 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1132 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5207 (insn, operands);

    case 31:
      if (!((
#line 1130 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 252 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 1132 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5208 (insn, operands);

    case 32:
      if (!((
#line 1130 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 253 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)) && 
#line 1132 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5209 (insn, operands);

    case 33:
      if (!((
#line 1130 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 254 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)) && 
#line 1132 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5210 (insn, operands);

    case 34:
      if (!((
#line 1130 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 255 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 1132 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5211 (insn, operands);

    case 35:
      if (!((
#line 1130 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 256 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 1132 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5212 (insn, operands);

    case 36:
      if (!((
#line 1130 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 257 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)) && 
#line 1132 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5213 (insn, operands);

    case 37:
      if (!((
#line 1130 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 258 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)) && 
#line 1132 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5214 (insn, operands);

    case 38:
      if (!((
#line 1130 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 259 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1132 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5215 (insn, operands);

    case 39:
      if (!((
#line 1130 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 260 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1132 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5216 (insn, operands);

    case 40:
      if (!((
#line 1130 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 261 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1132 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5217 (insn, operands);

    case 41:
      if (!((
#line 1130 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 262 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)) && 
#line 1132 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5218 (insn, operands);

    case 42:
      if (!((
#line 1130 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 263 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)) && 
#line 1132 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5219 (insn, operands);

    case 43:
      if (!((
#line 1130 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 264 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)) && 
#line 1132 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5220 (insn, operands);

    case 44:
      if (!((
#line 1130 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 265 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)) && 
#line 1132 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5221 (insn, operands);

    case 45:
      if (!((
#line 1130 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 266 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 1132 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5222 (insn, operands);

    case 46:
      if (!((
#line 1130 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 267 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 1132 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5223 (insn, operands);

    case 47:
      if (!((
#line 1130 "../../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 268 "../../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 1132 "../../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5224 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_178 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23;
  rtx_insn *res ATTRIBUTE_UNUSED;
  switch (XVECLEN (x1, 0))
    {
    case 2:
      x2 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x2) != CLOBBER)
        return NULL;
      x3 = XVECEXP (x1, 0, 0);
      switch (GET_CODE (x3))
        {
        case SET:
          x4 = XEXP (x3, 1);
          switch (GET_CODE (x4))
            {
            case PLUS:
              x5 = XEXP (x4, 0);
              if (GET_CODE (x5) == AND)
                {
                  x6 = XEXP (x3, 0);
                  operands[0] = x6;
                  switch (pattern340 (x1))
                    {
                    case 0:
                      if (((
#line 883 "../../../gcc/config/riscv/riscv.md"
((LUI_OPERAND (~INTVAL (operands[2]))
    && ((INTVAL (operands[2]) & (-INTVAL (operands[3])))
	== (-INTVAL (operands[3])))
    && riscv_const_insns (operands[3], false)
    && (riscv_const_insns (GEN_INT (~INTVAL (operands[2])
				    | -INTVAL (operands[3])), false)
	<= riscv_const_insns (operands[3], false)))) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 891 "../../../gcc/config/riscv/riscv.md"
( reload_completed)))
                        return gen_split_3 (insn, operands);
                      break;

                    case 1:
                      if (((
#line 883 "../../../gcc/config/riscv/riscv.md"
((LUI_OPERAND (~INTVAL (operands[2]))
    && ((INTVAL (operands[2]) & (-INTVAL (operands[3])))
	== (-INTVAL (operands[3])))
    && riscv_const_insns (operands[3], false)
    && (riscv_const_insns (GEN_INT (~INTVAL (operands[2])
				    | -INTVAL (operands[3])), false)
	<= riscv_const_insns (operands[3], false)))) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 891 "../../../gcc/config/riscv/riscv.md"
( reload_completed)))
                        return gen_split_4 (insn, operands);
                      break;

                    default:
                      break;
                    }
                }
              break;

            case CONST_INT:
              operands[1] = x4;
              x6 = XEXP (x3, 0);
              operands[0] = x6;
              x7 = XEXP (x2, 0);
              operands[2] = x7;
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (register_operand (operands[0], E_SImode)
                      && splittable_const_int_operand (operands[1], E_SImode)
                      && register_operand (operands[2], E_SImode))
                    return gen_split_14 (insn, operands);
                  break;

                case E_DImode:
                  if (register_operand (operands[0], E_DImode)
                      && splittable_const_int_operand (operands[1], E_DImode)
                      && register_operand (operands[2], E_DImode)
                      && 
#line 27 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT))
                    return gen_split_15 (insn, operands);
                  break;

                default:
                  break;
                }
              break;

            case IF_THEN_ELSE:
              res = split_173 (x1, insn);
              if (res != NULL_RTX)
                return res;
              break;

            case SIGN_EXTEND:
              if (pattern273 (x1) == 0
                  && ((
#line 636 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (TARGET_ZBB || TARGET_ZBKB)
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 641 "../../../gcc/config/riscv/bitmanip.md"
( reload_completed)))
                return gen_split_133 (insn, operands);
              break;

            case ZERO_EXTEND:
              if (pattern273 (x1) == 0
                  && ((
#line 636 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (TARGET_ZBB || TARGET_ZBKB)
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 641 "../../../gcc/config/riscv/bitmanip.md"
( reload_completed)))
                return gen_split_134 (insn, operands);
              break;

            case IOR:
              switch (pattern276 (x1))
                {
                case 0:
                  if (((
#line 684 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (TARGET_ZBB || TARGET_ZBKB)
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 689 "../../../gcc/config/riscv/bitmanip.md"
( reload_completed)))
                    return gen_split_139 (insn, operands);
                  break;

                case 1:
                  if (((
#line 710 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 714 "../../../gcc/config/riscv/bitmanip.md"
( reload_completed)))
                    return gen_split_147 (insn, operands);
                  break;

                case 2:
                  if (((
#line 684 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (TARGET_ZBB || TARGET_ZBKB)
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 689 "../../../gcc/config/riscv/bitmanip.md"
( reload_completed)))
                    return gen_split_141 (insn, operands);
                  break;

                case 3:
                  if (((
#line 710 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 714 "../../../gcc/config/riscv/bitmanip.md"
( reload_completed)))
                    return gen_split_149 (insn, operands);
                  break;

                default:
                  break;
                }
              break;

            case XOR:
              switch (pattern276 (x1))
                {
                case 0:
                  if (((
#line 684 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (TARGET_ZBB || TARGET_ZBKB)
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 689 "../../../gcc/config/riscv/bitmanip.md"
( reload_completed)))
                    return gen_split_140 (insn, operands);
                  break;

                case 1:
                  if (((
#line 710 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 714 "../../../gcc/config/riscv/bitmanip.md"
( reload_completed)))
                    return gen_split_148 (insn, operands);
                  break;

                case 2:
                  if (((
#line 684 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (TARGET_ZBB || TARGET_ZBKB)
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 689 "../../../gcc/config/riscv/bitmanip.md"
( reload_completed)))
                    return gen_split_142 (insn, operands);
                  break;

                case 3:
                  if (((
#line 710 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 714 "../../../gcc/config/riscv/bitmanip.md"
( reload_completed)))
                    return gen_split_150 (insn, operands);
                  break;

                default:
                  break;
                }
              break;

            case AND:
              res = split_174 (x1, insn);
              if (res != NULL_RTX)
                return res;
              break;

            case REG:
            case SUBREG:
            case MEM:
              res = split_176 (x1, insn);
              if (res != NULL_RTX)
                return res;
              break;

            default:
              break;
            }
          x6 = XEXP (x3, 0);
          operands[0] = x6;
          operands[1] = x4;
          x7 = XEXP (x2, 0);
          operands[2] = x7;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (register_operand (operands[0], E_SImode)
                  && register_operand (operands[2], E_SImode)
                  && (
#line 2455 "../../../gcc/config/riscv/riscv.md"
(riscv_split_symbol (operands[2], operands[1], MAX_MACHINE_MODE, NULL)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == SImode)))
                return gen_split_16 (insn, operands);
              break;

            case E_DImode:
              if (register_operand (operands[0], E_DImode)
                  && register_operand (operands[2], E_DImode)
                  && (
#line 2455 "../../../gcc/config/riscv/riscv.md"
(riscv_split_symbol (operands[2], operands[1], MAX_MACHINE_MODE, NULL)) && 
#line 35 "../../../gcc/config/riscv/iterators.md"
(Pmode == DImode)))
                return gen_split_17 (insn, operands);
              break;

            default:
              break;
            }
          switch (GET_CODE (x4))
            {
            case SIGN_EXTRACT:
              switch (pattern218 (x1))
                {
                case 0:
                  if (!(
#line 3064 "../../../gcc/config/riscv/riscv.md"
(!((TARGET_ZBS || TARGET_XTHEADBS || TARGET_ZICOND
      || TARGET_XVENTANACONDOPS || TARGET_SFB_ALU)
     && (INTVAL (operands[2]) == 1))
   && !TARGET_XTHEADBB
   && !(TARGET_64BIT
        && (INTVAL (operands[3]) > 0)
        && (INTVAL (operands[2]) + INTVAL (operands[3]) == 32))) && 
#line 3072 "../../../gcc/config/riscv/riscv.md"
( reload_completed)))
                    return NULL;
                  return gen_split_46 (insn, operands);

                case 1:
                  if (!((
#line 3064 "../../../gcc/config/riscv/riscv.md"
(!((TARGET_ZBS || TARGET_XTHEADBS || TARGET_ZICOND
      || TARGET_XVENTANACONDOPS || TARGET_SFB_ALU)
     && (INTVAL (operands[2]) == 1))
   && !TARGET_XTHEADBB
   && !(TARGET_64BIT
        && (INTVAL (operands[3]) > 0)
        && (INTVAL (operands[2]) + INTVAL (operands[3]) == 32))) && 
#line 27 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 3072 "../../../gcc/config/riscv/riscv.md"
( reload_completed)))
                    return NULL;
                  return gen_split_48 (insn, operands);

                default:
                  return NULL;
                }

            case ZERO_EXTRACT:
              switch (pattern218 (x1))
                {
                case 0:
                  if (!(
#line 3064 "../../../gcc/config/riscv/riscv.md"
(!((TARGET_ZBS || TARGET_XTHEADBS || TARGET_ZICOND
      || TARGET_XVENTANACONDOPS || TARGET_SFB_ALU)
     && (INTVAL (operands[2]) == 1))
   && !TARGET_XTHEADBB
   && !(TARGET_64BIT
        && (INTVAL (operands[3]) > 0)
        && (INTVAL (operands[2]) + INTVAL (operands[3]) == 32))) && 
#line 3072 "../../../gcc/config/riscv/riscv.md"
( reload_completed)))
                    return NULL;
                  return gen_split_47 (insn, operands);

                case 1:
                  if (!((
#line 3064 "../../../gcc/config/riscv/riscv.md"
(!((TARGET_ZBS || TARGET_XTHEADBS || TARGET_ZICOND
      || TARGET_XVENTANACONDOPS || TARGET_SFB_ALU)
     && (INTVAL (operands[2]) == 1))
   && !TARGET_XTHEADBB
   && !(TARGET_64BIT
        && (INTVAL (operands[3]) > 0)
        && (INTVAL (operands[2]) + INTVAL (operands[3]) == 32))) && 
#line 27 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 3072 "../../../gcc/config/riscv/riscv.md"
( reload_completed)))
                    return NULL;
                  return gen_split_49 (insn, operands);

                default:
                  return NULL;
                }

            case AND:
              return split_175 (x1, insn);

            case SIGN_EXTEND:
              if (GET_MODE (x4) != E_DImode
                  || !register_operand (operands[0], E_DImode))
                return NULL;
              x5 = XEXP (x4, 0);
              if (GET_MODE (x5) != E_SImode)
                return NULL;
              switch (GET_CODE (x5))
                {
                case PLUS:
                  switch (pattern404 (x1))
                    {
                    case 0:
                      if (!(
#line 4553 "../../../gcc/config/riscv/riscv.md"
(TARGET_64BIT
   && (INTVAL (operands[3]) | ((1 << INTVAL (operands[2])) - 1)) == 0xffffffff) && 
#line 4556 "../../../gcc/config/riscv/riscv.md"
( reload_completed)))
                        return NULL;
                      return gen_split_103 (insn, operands);

                    case 1:
                      if (!(
#line 4700 "../../../gcc/config/riscv/riscv.md"
((TARGET_64BIT && riscv_const_insns (operands[3], false) == 1)) && 
#line 4702 "../../../gcc/config/riscv/riscv.md"
( reload_completed)))
                        return NULL;
                      return gen_split_105 (insn, operands);

                    default:
                      return NULL;
                    }

                case DIV:
                  x8 = XEXP (x5, 0);
                  if (GET_CODE (x8) != PLUS
                      || GET_MODE (x8) != E_SImode)
                    return NULL;
                  x9 = XEXP (x8, 0);
                  if (GET_CODE (x9) != ASHIFT
                      || GET_MODE (x9) != E_SImode)
                    return NULL;
                  x10 = XEXP (x9, 0);
                  if (GET_CODE (x10) != SUBREG
                      || maybe_ne (SUBREG_BYTE (x10), 0)
                      || GET_MODE (x10) != E_SImode)
                    return NULL;
                  x11 = XEXP (x8, 1);
                  if (GET_CODE (x11) != SUBREG
                      || maybe_ne (SUBREG_BYTE (x11), 0)
                      || GET_MODE (x11) != E_SImode)
                    return NULL;
                  x12 = XEXP (x10, 0);
                  operands[1] = x12;
                  if (!register_operand (operands[1], E_DImode))
                    return NULL;
                  x13 = XEXP (x9, 1);
                  operands[2] = x13;
                  if (!imm123_operand (operands[2], E_QImode))
                    return NULL;
                  x14 = XEXP (x11, 0);
                  operands[3] = x14;
                  if (!register_operand (operands[3], E_DImode))
                    return NULL;
                  x15 = XEXP (x5, 1);
                  operands[4] = x15;
                  if (!register_operand (operands[4], E_SImode))
                    return NULL;
                  operands[5] = x7;
                  if (!register_operand (operands[5], E_DImode)
                      || !
#line 55 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT && TARGET_ZBA))
                    return NULL;
                  return gen_split_106 (insn, operands);

                case ASHIFT:
                  if (pattern392 (x5) != 0)
                    return NULL;
                  x15 = XEXP (x5, 1);
                  x16 = XEXP (x15, 0);
                  x17 = XEXP (x16, 0);
                  x18 = XEXP (x17, 0);
                  operands[1] = x18;
                  if (!register_operand (operands[1], E_DImode))
                    return NULL;
                  x19 = XEXP (x16, 1);
                  operands[2] = x19;
                  if (!const_int_operand (operands[2], E_VOIDmode))
                    return NULL;
                  operands[3] = x7;
                  if (!scratch_operand (operands[3], E_DImode)
                      || !((
#line 636 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (TARGET_ZBB || TARGET_ZBKB)
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 641 "../../../gcc/config/riscv/bitmanip.md"
( reload_completed)))
                    return NULL;
                  return gen_split_135 (insn, operands);

                default:
                  return NULL;
                }

            case PLUS:
              if (GET_MODE (x4) != E_DImode
                  || !register_operand (operands[0], E_DImode))
                return NULL;
              x5 = XEXP (x4, 0);
              if (GET_MODE (x5) != E_DImode)
                return NULL;
              switch (GET_CODE (x5))
                {
                case ASHIFT:
                  if (pattern403 (x1) != 0
                      || !(
#line 4684 "../../../gcc/config/riscv/riscv.md"
((TARGET_64BIT && riscv_const_insns (operands[3], false) == 1)) && 
#line 4686 "../../../gcc/config/riscv/riscv.md"
( reload_completed)))
                    return NULL;
                  return gen_split_104 (insn, operands);

                case AND:
                  x8 = XEXP (x5, 0);
                  if (GET_CODE (x8) != ASHIFT
                      || GET_MODE (x8) != E_DImode)
                    return NULL;
                  x9 = XEXP (x8, 0);
                  operands[1] = x9;
                  if (!register_operand (operands[1], E_DImode))
                    return NULL;
                  x11 = XEXP (x8, 1);
                  operands[2] = x11;
                  x15 = XEXP (x5, 1);
                  operands[3] = x15;
                  if (!consecutive_bits_operand (operands[3], E_DImode))
                    return NULL;
                  x20 = XEXP (x4, 1);
                  operands[4] = x20;
                  if (!register_operand (operands[4], E_DImode))
                    return NULL;
                  operands[5] = x7;
                  if (scratch_operand (operands[5], E_DImode)
                      && imm123_operand (operands[2], E_QImode)
                      && (
#line 96 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT && TARGET_ZBA
   && riscv_shamt_matches_mask_p (INTVAL (operands[2]), INTVAL (operands[3]))
   && SMALL_OPERAND (INTVAL (operands[3]) >> INTVAL (operands[2]))) && 
#line 100 "../../../gcc/config/riscv/bitmanip.md"
( reload_completed)))
                    return gen_split_109 (insn, operands);
                  if (!register_operand (operands[5], E_DImode)
                      || !immediate_operand (operands[2], E_QImode)
                      || !
#line 136 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT && TARGET_ZBA))
                    return NULL;
                  return gen_split_110 (insn, operands);

                default:
                  return NULL;
                }

            case IOR:
              x5 = XEXP (x4, 0);
              switch (GET_CODE (x5))
                {
                case NOT:
                  x8 = XEXP (x5, 0);
                  operands[1] = x8;
                  switch (pattern368 (x1))
                    {
                    case 0:
                      if (!((
#line 240 "../../../gcc/config/riscv/bitmanip.md"
((TARGET_ZBB || TARGET_ZBKB) && !TARGET_ZCB
   && !optimize_function_for_size_p (cfun)) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 243 "../../../gcc/config/riscv/bitmanip.md"
( reload_completed)))
                        return NULL;
                      return gen_split_113 (insn, operands);

                    case 1:
                      if (!((
#line 240 "../../../gcc/config/riscv/bitmanip.md"
((TARGET_ZBB || TARGET_ZBKB) && !TARGET_ZCB
   && !optimize_function_for_size_p (cfun)) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 243 "../../../gcc/config/riscv/bitmanip.md"
( reload_completed)))
                        return NULL;
                      return gen_split_115 (insn, operands);

                    default:
                      return NULL;
                    }

                case SIGN_EXTEND:
                  if (pattern352 (x5) != 0)
                    return NULL;
                  x8 = XEXP (x5, 0);
                  x11 = XEXP (x8, 1);
                  if (GET_CODE (x11) != SUBREG
                      || maybe_ne (SUBREG_BYTE (x11), 0)
                      || GET_MODE (x11) != E_QImode)
                    return NULL;
                  x14 = XEXP (x11, 0);
                  if (GET_CODE (x14) != AND
                      || GET_MODE (x14) != E_DImode
                      || !register_operand (operands[0], E_DImode)
                      || GET_MODE (x4) != E_DImode)
                    return NULL;
                  switch (pattern444 (x1))
                    {
                    case 0:
                      if (!((
#line 684 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (TARGET_ZBB || TARGET_ZBKB)
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 689 "../../../gcc/config/riscv/bitmanip.md"
( reload_completed)))
                        return NULL;
                      return gen_split_143 (insn, operands);

                    case 1:
                      if (!((
#line 710 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 714 "../../../gcc/config/riscv/bitmanip.md"
( reload_completed)))
                        return NULL;
                      return gen_split_151 (insn, operands);

                    default:
                      return NULL;
                    }

                case ZERO_EXTEND:
                  if (pattern352 (x5) != 0
                      || !register_operand (operands[0], E_DImode)
                      || GET_MODE (x4) != E_DImode)
                    return NULL;
                  x8 = XEXP (x5, 0);
                  x11 = XEXP (x8, 1);
                  if (GET_CODE (x11) == SUBREG)
                    {
                      switch (pattern445 (x1))
                        {
                        case 0:
                          if (((
#line 684 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (TARGET_ZBB || TARGET_ZBKB)
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 689 "../../../gcc/config/riscv/bitmanip.md"
( reload_completed)))
                            return gen_split_145 (insn, operands);
                          break;

                        case 1:
                          if (((
#line 710 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 714 "../../../gcc/config/riscv/bitmanip.md"
( reload_completed)))
                            return gen_split_153 (insn, operands);
                          break;

                        default:
                          break;
                        }
                    }
                  operands[1] = x11;
                  if (!register_operand (operands[1], E_QImode))
                    return NULL;
                  x20 = XEXP (x4, 1);
                  operands[2] = x20;
                  if (!single_bit_mask_operand (operands[2], E_DImode))
                    return NULL;
                  operands[3] = x7;
                  if (!register_operand (operands[3], E_DImode)
                      || !
#line 801 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT && TARGET_ZBS))
                    return NULL;
                  return gen_split_163 (insn, operands);

                default:
                  return NULL;
                }

            case ZERO_EXTEND:
              if (GET_MODE (x4) != E_DImode)
                return NULL;
              x5 = XEXP (x4, 0);
              if (GET_CODE (x5) != ASHIFT
                  || GET_MODE (x5) != E_SImode
                  || pattern392 (x5) != 0
                  || pattern272 (x1, 
E_DImode) != 0
                  || !((
#line 636 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (TARGET_ZBB || TARGET_ZBKB)
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 641 "../../../gcc/config/riscv/bitmanip.md"
( reload_completed)))
                return NULL;
              return gen_split_136 (insn, operands);

            case XOR:
              if (GET_MODE (x4) != E_DImode
                  || !register_operand (operands[0], E_DImode))
                return NULL;
              x5 = XEXP (x4, 0);
              if (GET_MODE (x5) != E_DImode)
                return NULL;
              switch (GET_CODE (x5))
                {
                case SIGN_EXTEND:
                  x8 = XEXP (x5, 0);
                  if (GET_CODE (x8) != ASHIFT
                      || GET_MODE (x8) != E_SImode)
                    return NULL;
                  x9 = XEXP (x8, 0);
                  if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
                    return NULL;
                  x11 = XEXP (x8, 1);
                  if (GET_CODE (x11) != SUBREG)
                    return NULL;
                  switch (pattern445 (x1))
                    {
                    case 0:
                      if (!((
#line 684 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (TARGET_ZBB || TARGET_ZBKB)
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 689 "../../../gcc/config/riscv/bitmanip.md"
( reload_completed)))
                        return NULL;
                      return gen_split_144 (insn, operands);

                    case 1:
                      if (!((
#line 710 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 714 "../../../gcc/config/riscv/bitmanip.md"
( reload_completed)))
                        return NULL;
                      return gen_split_152 (insn, operands);

                    default:
                      return NULL;
                    }

                case ZERO_EXTEND:
                  x8 = XEXP (x5, 0);
                  if (GET_CODE (x8) != ASHIFT
                      || GET_MODE (x8) != E_SImode)
                    return NULL;
                  x9 = XEXP (x8, 0);
                  if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
                    return NULL;
                  x11 = XEXP (x8, 1);
                  if (GET_CODE (x11) == SUBREG)
                    {
                      switch (pattern445 (x1))
                        {
                        case 0:
                          if (((
#line 684 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (TARGET_ZBB || TARGET_ZBKB)
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 689 "../../../gcc/config/riscv/bitmanip.md"
( reload_completed)))
                            return gen_split_146 (insn, operands);
                          break;

                        case 1:
                          if (((
#line 710 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 714 "../../../gcc/config/riscv/bitmanip.md"
( reload_completed)))
                            return gen_split_154 (insn, operands);
                          break;

                        default:
                          break;
                        }
                    }
                  operands[1] = x11;
                  if (!register_operand (operands[1], E_QImode))
                    return NULL;
                  x20 = XEXP (x4, 1);
                  operands[2] = x20;
                  if (!single_bit_mask_operand (operands[2], E_DImode))
                    return NULL;
                  operands[3] = x7;
                  if (!register_operand (operands[3], E_DImode)
                      || !
#line 801 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT && TARGET_ZBS))
                    return NULL;
                  return gen_split_164 (insn, operands);

                default:
                  return NULL;
                }

            default:
              return NULL;
            }

        case UNSPEC:
          if (XVECLEN (x3, 0) != 1
              || XINT (x3, 1) != 0)
            return NULL;
          x21 = XVECEXP (x3, 0, 0);
          operands[0] = x21;
          if (!register_operand (operands[0], E_VOIDmode))
            return NULL;
          x7 = XEXP (x2, 0);
          operands[1] = x7;
          if (!scratch_operand (operands[1], E_VOIDmode)
              || !
#line 3890 "../../../gcc/config/riscv/riscv.md"
(reload_completed))
            return NULL;
          return gen_split_101 (insn, operands);

        default:
          return NULL;
        }

    case 3:
      x3 = XVECEXP (x1, 0, 0);
      if (GET_CODE (x3) != SET)
        return NULL;
      x2 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x2) != CLOBBER)
        return NULL;
      x22 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x22) != CLOBBER)
        return NULL;
      x4 = XEXP (x3, 1);
      switch (GET_CODE (x4))
        {
        case IF_THEN_ELSE:
          if (pattern220 (x3) != 0)
            return NULL;
          x5 = XEXP (x4, 0);
          x8 = XEXP (x5, 0);
          x9 = XEXP (x8, 0);
          operands[1] = x9;
          switch (pattern424 (x1))
            {
            case 0:
              if (((
#line 3194 "../../../gcc/config/riscv/riscv.md"
(!SMALL_OPERAND (INTVAL (operands[2]))
    && !SMALL_OPERAND (INTVAL (operands[3]))
    && SMALL_AFTER_COMMON_TRAILING_SHIFT (INTVAL (operands[2]),
					     INTVAL (operands[3]))) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 3199 "../../../gcc/config/riscv/riscv.md"
( reload_completed)))
                return gen_split_61 (insn, operands);
              break;

            case 1:
              if (((
#line 3194 "../../../gcc/config/riscv/riscv.md"
(!SMALL_OPERAND (INTVAL (operands[2]))
    && !SMALL_OPERAND (INTVAL (operands[3]))
    && SMALL_AFTER_COMMON_TRAILING_SHIFT (INTVAL (operands[2]),
					     INTVAL (operands[3]))) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 3199 "../../../gcc/config/riscv/riscv.md"
( reload_completed)))
                return gen_split_69 (insn, operands);
              break;

            case 2:
              if (((
#line 3194 "../../../gcc/config/riscv/riscv.md"
(!SMALL_OPERAND (INTVAL (operands[2]))
    && !SMALL_OPERAND (INTVAL (operands[3]))
    && SMALL_AFTER_COMMON_TRAILING_SHIFT (INTVAL (operands[2]),
					     INTVAL (operands[3]))) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 3199 "../../../gcc/config/riscv/riscv.md"
( reload_completed)))
                return gen_split_63 (insn, operands);
              break;

            case 3:
              if (((
#line 3194 "../../../gcc/config/riscv/riscv.md"
(!SMALL_OPERAND (INTVAL (operands[2]))
    && !SMALL_OPERAND (INTVAL (operands[3]))
    && SMALL_AFTER_COMMON_TRAILING_SHIFT (INTVAL (operands[2]),
					     INTVAL (operands[3]))) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 3199 "../../../gcc/config/riscv/riscv.md"
( reload_completed)))
                return gen_split_71 (insn, operands);
              break;

            case 4:
              if (((
#line 3194 "../../../gcc/config/riscv/riscv.md"
(!SMALL_OPERAND (INTVAL (operands[2]))
    && !SMALL_OPERAND (INTVAL (operands[3]))
    && SMALL_AFTER_COMMON_TRAILING_SHIFT (INTVAL (operands[2]),
					     INTVAL (operands[3]))) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 3199 "../../../gcc/config/riscv/riscv.md"
( reload_completed)))
                return gen_split_65 (insn, operands);
              break;

            case 5:
              if (((
#line 3194 "../../../gcc/config/riscv/riscv.md"
(!SMALL_OPERAND (INTVAL (operands[2]))
    && !SMALL_OPERAND (INTVAL (operands[3]))
    && SMALL_AFTER_COMMON_TRAILING_SHIFT (INTVAL (operands[2]),
					     INTVAL (operands[3]))) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 3199 "../../../gcc/config/riscv/riscv.md"
( reload_completed)))
                return gen_split_73 (insn, operands);
              break;

            case 6:
              if (((
#line 3194 "../../../gcc/config/riscv/riscv.md"
(!SMALL_OPERAND (INTVAL (operands[2]))
    && !SMALL_OPERAND (INTVAL (operands[3]))
    && SMALL_AFTER_COMMON_TRAILING_SHIFT (INTVAL (operands[2]),
					     INTVAL (operands[3]))) && ((((
#line 69 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT))) && 
#line 3199 "../../../gcc/config/riscv/riscv.md"
( reload_completed)))
                return gen_split_67 (insn, operands);
              break;

            case 7:
              if (((
#line 3194 "../../../gcc/config/riscv/riscv.md"
(!SMALL_OPERAND (INTVAL (operands[2]))
    && !SMALL_OPERAND (INTVAL (operands[3]))
    && SMALL_AFTER_COMMON_TRAILING_SHIFT (INTVAL (operands[2]),
					     INTVAL (operands[3]))) && 
#line 69 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 3199 "../../../gcc/config/riscv/riscv.md"
( reload_completed)))
                return gen_split_75 (insn, operands);
              break;

            case 8:
              if (((
#line 3194 "../../../gcc/config/riscv/riscv.md"
(!SMALL_OPERAND (INTVAL (operands[2]))
    && !SMALL_OPERAND (INTVAL (operands[3]))
    && SMALL_AFTER_COMMON_TRAILING_SHIFT (INTVAL (operands[2]),
					     INTVAL (operands[3]))) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 3199 "../../../gcc/config/riscv/riscv.md"
( reload_completed)))
                return gen_split_62 (insn, operands);
              break;

            case 9:
              if (((
#line 3194 "../../../gcc/config/riscv/riscv.md"
(!SMALL_OPERAND (INTVAL (operands[2]))
    && !SMALL_OPERAND (INTVAL (operands[3]))
    && SMALL_AFTER_COMMON_TRAILING_SHIFT (INTVAL (operands[2]),
					     INTVAL (operands[3]))) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 3199 "../../../gcc/config/riscv/riscv.md"
( reload_completed)))
                return gen_split_70 (insn, operands);
              break;

            case 10:
              if (((
#line 3194 "../../../gcc/config/riscv/riscv.md"
(!SMALL_OPERAND (INTVAL (operands[2]))
    && !SMALL_OPERAND (INTVAL (operands[3]))
    && SMALL_AFTER_COMMON_TRAILING_SHIFT (INTVAL (operands[2]),
					     INTVAL (operands[3]))) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 3199 "../../../gcc/config/riscv/riscv.md"
( reload_completed)))
                return gen_split_64 (insn, operands);
              break;

            case 11:
              if (((
#line 3194 "../../../gcc/config/riscv/riscv.md"
(!SMALL_OPERAND (INTVAL (operands[2]))
    && !SMALL_OPERAND (INTVAL (operands[3]))
    && SMALL_AFTER_COMMON_TRAILING_SHIFT (INTVAL (operands[2]),
					     INTVAL (operands[3]))) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 3199 "../../../gcc/config/riscv/riscv.md"
( reload_completed)))
                return gen_split_72 (insn, operands);
              break;

            case 12:
              if (((
#line 3194 "../../../gcc/config/riscv/riscv.md"
(!SMALL_OPERAND (INTVAL (operands[2]))
    && !SMALL_OPERAND (INTVAL (operands[3]))
    && SMALL_AFTER_COMMON_TRAILING_SHIFT (INTVAL (operands[2]),
					     INTVAL (operands[3]))) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 3199 "../../../gcc/config/riscv/riscv.md"
( reload_completed)))
                return gen_split_66 (insn, operands);
              break;

            case 13:
              if (((
#line 3194 "../../../gcc/config/riscv/riscv.md"
(!SMALL_OPERAND (INTVAL (operands[2]))
    && !SMALL_OPERAND (INTVAL (operands[3]))
    && SMALL_AFTER_COMMON_TRAILING_SHIFT (INTVAL (operands[2]),
					     INTVAL (operands[3]))) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 3199 "../../../gcc/config/riscv/riscv.md"
( reload_completed)))
                return gen_split_74 (insn, operands);
              break;

            case 14:
              if (((
#line 3194 "../../../gcc/config/riscv/riscv.md"
(!SMALL_OPERAND (INTVAL (operands[2]))
    && !SMALL_OPERAND (INTVAL (operands[3]))
    && SMALL_AFTER_COMMON_TRAILING_SHIFT (INTVAL (operands[2]),
					     INTVAL (operands[3]))) && ((((
#line 69 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT))) && 
#line 3199 "../../../gcc/config/riscv/riscv.md"
( reload_completed)))
                return gen_split_68 (insn, operands);
              break;

            case 15:
              if (((
#line 3194 "../../../gcc/config/riscv/riscv.md"
(!SMALL_OPERAND (INTVAL (operands[2]))
    && !SMALL_OPERAND (INTVAL (operands[3]))
    && SMALL_AFTER_COMMON_TRAILING_SHIFT (INTVAL (operands[2]),
					     INTVAL (operands[3]))) && 
#line 69 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 3199 "../../../gcc/config/riscv/riscv.md"
( reload_completed)))
                return gen_split_76 (insn, operands);
              break;

            default:
              break;
            }
          operands[1] = x5;
          switch (pattern426 (x1))
            {
            case 0:
              if (!((
#line 1099 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBS && TARGET_ZBB) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 1101 "../../../gcc/config/riscv/bitmanip.md"
( reload_completed)))
                return NULL;
              return gen_split_183 (insn, operands);

            case 1:
              if (!((
#line 1099 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBS && TARGET_ZBB) && 
#line 38 "../../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 1101 "../../../gcc/config/riscv/bitmanip.md"
( reload_completed)))
                return NULL;
              return gen_split_184 (insn, operands);

            default:
              return NULL;
            }

        case SIGN_EXTEND:
          if (GET_MODE (x4) != E_DImode)
            return NULL;
          x5 = XEXP (x4, 0);
          if (GET_CODE (x5) != SUBREG
              || maybe_ne (SUBREG_BYTE (x5), 0)
              || GET_MODE (x5) != E_SImode)
            return NULL;
          x6 = XEXP (x3, 0);
          operands[0] = x6;
          if (!register_operand (operands[0], E_DImode))
            return NULL;
          x8 = XEXP (x5, 0);
          if (GET_MODE (x8) != E_DImode)
            return NULL;
          x7 = XEXP (x2, 0);
          operands[3] = x7;
          if (!register_operand (operands[3], E_DImode))
            return NULL;
          x23 = XEXP (x22, 0);
          operands[4] = x23;
          if (!register_operand (operands[4], E_DImode))
            return NULL;
          switch (GET_CODE (x8))
            {
            case SMIN:
              if (pattern504 (x8) != 0
                  || !
#line 561 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT && TARGET_ZBB && sext_hwi (INTVAL (operands[2]), 32) >= 0))
                return NULL;
              return gen_split_129 (insn, operands);

            case UMIN:
              if (pattern504 (x8) != 0
                  || !
#line 561 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT && TARGET_ZBB && sext_hwi (INTVAL (operands[2]), 32) >= 0))
                return NULL;
              return gen_split_130 (insn, operands);

            case SMAX:
              if (pattern504 (x8) != 0
                  || !
#line 561 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT && TARGET_ZBB && sext_hwi (INTVAL (operands[2]), 32) >= 0))
                return NULL;
              return gen_split_131 (insn, operands);

            case UMAX:
              if (pattern504 (x8) != 0
                  || !
#line 561 "../../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT && TARGET_ZBB && sext_hwi (INTVAL (operands[2]), 32) >= 0))
                return NULL;
              return gen_split_132 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case 4:
      if (pattern112 (x1, 
CLOBBER) != 0)
        return NULL;
      x3 = XVECEXP (x1, 0, 0);
      x6 = XEXP (x3, 0);
      operands[0] = x6;
      x4 = XEXP (x3, 1);
      operands[1] = x4;
      return split_177 (x1, insn);

    default:
      return NULL;
    }
}
